const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-11-09";
pub const sdk_id: []const u8 = "Alexa For Business";
pub const arn_namespace: ?[]const u8 = "a4b";
pub const endpoint_prefix: []const u8 = "a4b";
pub const sigv4_name: []const u8 = "a4b";
pub const name: []const u8 = "AlexaForBusiness";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-11-09",
    sdk_id: []const u8 = "Alexa For Business",
    arn_namespace: ?[]const u8 = "a4b",
    endpoint_prefix: []const u8 = "a4b",
    sigv4_name: []const u8 = "a4b",
    name: []const u8 = "AlexaForBusiness",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const approve_skill: struct {
    action_name: []const u8 = "ApproveSkill",
    Request: type = struct {
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(approve_skill) } {
            return .{ .service_metadata = service_metadata, .action = approve_skill };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        LimitExceeded,
        NotFound,
    },
} = .{};
pub const associate_contact_with_address_book: struct {
    action_name: []const u8 = "AssociateContactWithAddressBook",
    Request: type = struct {
        contact_arn: []const u8,
        address_book_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
                .address_book_arn = "AddressBookArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_contact_with_address_book) } {
            return .{ .service_metadata = service_metadata, .action = associate_contact_with_address_book };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
    },
} = .{};
pub const associate_device_with_network_profile: struct {
    action_name: []const u8 = "AssociateDeviceWithNetworkProfile",
    Request: type = struct {
        device_arn: []const u8,
        network_profile_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
                .network_profile_arn = "NetworkProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_device_with_network_profile) } {
            return .{ .service_metadata = service_metadata, .action = associate_device_with_network_profile };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        DeviceNotRegistered,
        NotFound,
    },
} = .{};
pub const associate_device_with_room: struct {
    action_name: []const u8 = "AssociateDeviceWithRoom",
    Request: type = struct {
        device_arn: ?[]const u8 = null,
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_device_with_room) } {
            return .{ .service_metadata = service_metadata, .action = associate_device_with_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        DeviceNotRegistered,
        LimitExceeded,
    },
} = .{};
pub const associate_skill_group_with_room: struct {
    action_name: []const u8 = "AssociateSkillGroupWithRoom",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_skill_group_with_room) } {
            return .{ .service_metadata = service_metadata, .action = associate_skill_group_with_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
    },
} = .{};
pub const associate_skill_with_skill_group: struct {
    action_name: []const u8 = "AssociateSkillWithSkillGroup",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_skill_with_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = associate_skill_with_skill_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
        SkillNotLinked,
    },
} = .{};
pub const associate_skill_with_users: struct {
    action_name: []const u8 = "AssociateSkillWithUsers",
    Request: type = struct {
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_skill_with_users) } {
            return .{ .service_metadata = service_metadata, .action = associate_skill_with_users };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const create_address_book: struct {
    action_name: []const u8 = "CreateAddressBook",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .description = "Description",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_address_book) } {
            return .{ .service_metadata = service_metadata, .action = create_address_book };
        }
    },
    Response: type = struct {
        address_book_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_book_arn = "AddressBookArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
    },
} = .{};
pub const create_business_report_schedule: struct {
    action_name: []const u8 = "CreateBusinessReportSchedule",
    Request: type = struct {
        schedule_name: ?[]const u8 = null,
        s3_bucket_name: ?[]const u8 = null,
        s3_key_prefix: ?[]const u8 = null,
        format: []const u8,
        content_range: BusinessReportContentRange,
        recurrence: ?BusinessReportRecurrence = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .schedule_name = "ScheduleName",
                .s3_bucket_name = "S3BucketName",
                .s3_key_prefix = "S3KeyPrefix",
                .format = "Format",
                .content_range = "ContentRange",
                .recurrence = "Recurrence",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_business_report_schedule) } {
            return .{ .service_metadata = service_metadata, .action = create_business_report_schedule };
        }
    },
    Response: type = struct {
        schedule_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .schedule_arn = "ScheduleArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
    },
} = .{};
pub const create_conference_provider: struct {
    action_name: []const u8 = "CreateConferenceProvider",
    Request: type = struct {
        conference_provider_name: []const u8,
        conference_provider_type: []const u8,
        ip_dial_in: ?IPDialIn = null,
        pstn_dial_in: ?PSTNDialIn = null,
        meeting_setting: MeetingSetting,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider_name = "ConferenceProviderName",
                .conference_provider_type = "ConferenceProviderType",
                .ip_dial_in = "IPDialIn",
                .pstn_dial_in = "PSTNDialIn",
                .meeting_setting = "MeetingSetting",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_conference_provider) } {
            return .{ .service_metadata = service_metadata, .action = create_conference_provider };
        }
    },
    Response: type = struct {
        conference_provider_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider_arn = "ConferenceProviderArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
    },
} = .{};
pub const create_contact: struct {
    action_name: []const u8 = "CreateContact",
    Request: type = struct {
        display_name: ?[]const u8 = null,
        first_name: []const u8,
        last_name: ?[]const u8 = null,
        phone_number: ?[]const u8 = null,
        phone_numbers: ?[]PhoneNumber = null,
        sip_addresses: ?[]SipAddress = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .display_name = "DisplayName",
                .first_name = "FirstName",
                .last_name = "LastName",
                .phone_number = "PhoneNumber",
                .phone_numbers = "PhoneNumbers",
                .sip_addresses = "SipAddresses",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_contact) } {
            return .{ .service_metadata = service_metadata, .action = create_contact };
        }
    },
    Response: type = struct {
        contact_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
    },
} = .{};
pub const create_gateway_group: struct {
    action_name: []const u8 = "CreateGatewayGroup",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        client_request_token: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .description = "Description",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_gateway_group) } {
            return .{ .service_metadata = service_metadata, .action = create_gateway_group };
        }
    },
    Response: type = struct {
        gateway_group_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group_arn = "GatewayGroupArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
    },
} = .{};
pub const create_network_profile: struct {
    action_name: []const u8 = "CreateNetworkProfile",
    Request: type = struct {
        network_profile_name: []const u8,
        description: ?[]const u8 = null,
        ssid: []const u8,
        security_type: []const u8,
        eap_method: ?[]const u8 = null,
        current_password: ?[]const u8 = null,
        next_password: ?[]const u8 = null,
        certificate_authority_arn: ?[]const u8 = null,
        trust_anchors: ?[][]const u8 = null,
        client_request_token: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile_name = "NetworkProfileName",
                .description = "Description",
                .ssid = "Ssid",
                .security_type = "SecurityType",
                .eap_method = "EapMethod",
                .current_password = "CurrentPassword",
                .next_password = "NextPassword",
                .certificate_authority_arn = "CertificateAuthorityArn",
                .trust_anchors = "TrustAnchors",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_network_profile) } {
            return .{ .service_metadata = service_metadata, .action = create_network_profile };
        }
    },
    Response: type = struct {
        network_profile_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile_arn = "NetworkProfileArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        ConcurrentModification,
        InvalidCertificateAuthority,
        InvalidServiceLinkedRoleState,
        LimitExceeded,
    },
} = .{};
pub const create_profile: struct {
    action_name: []const u8 = "CreateProfile",
    Request: type = struct {
        profile_name: []const u8,
        timezone: []const u8,
        address: []const u8,
        distance_unit: []const u8,
        temperature_unit: []const u8,
        wake_word: []const u8,
        locale: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        setup_mode_disabled: ?bool = null,
        max_volume_limit: ?i64 = null,
        pstn_enabled: ?bool = null,
        data_retention_opt_in: ?bool = null,
        meeting_room_configuration: ?struct {
            room_utilization_metrics_enabled: ?bool = null,
            end_of_meeting_reminder: ?struct {
                reminder_at_minutes: []i64,
                reminder_type: []const u8,
                enabled: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .reminder_at_minutes = "ReminderAtMinutes",
                        .reminder_type = "ReminderType",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            instant_booking: ?struct {
                duration_in_minutes: i64,
                enabled: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .duration_in_minutes = "DurationInMinutes",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            require_check_in: ?struct {
                release_after_minutes: i64,
                enabled: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .release_after_minutes = "ReleaseAfterMinutes",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            proactive_join: ?struct {
                enabled_by_motion: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .enabled_by_motion = "EnabledByMotion",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .room_utilization_metrics_enabled = "RoomUtilizationMetricsEnabled",
                    .end_of_meeting_reminder = "EndOfMeetingReminder",
                    .instant_booking = "InstantBooking",
                    .require_check_in = "RequireCheckIn",
                    .proactive_join = "ProactiveJoin",
                };
                return @field(mappings, field_name);
            }
        } = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile_name = "ProfileName",
                .timezone = "Timezone",
                .address = "Address",
                .distance_unit = "DistanceUnit",
                .temperature_unit = "TemperatureUnit",
                .wake_word = "WakeWord",
                .locale = "Locale",
                .client_request_token = "ClientRequestToken",
                .setup_mode_disabled = "SetupModeDisabled",
                .max_volume_limit = "MaxVolumeLimit",
                .pstn_enabled = "PSTNEnabled",
                .data_retention_opt_in = "DataRetentionOptIn",
                .meeting_room_configuration = "MeetingRoomConfiguration",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_profile) } {
            return .{ .service_metadata = service_metadata, .action = create_profile };
        }
    },
    Response: type = struct {
        profile_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile_arn = "ProfileArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        ConcurrentModification,
        LimitExceeded,
    },
} = .{};
pub const create_room: struct {
    action_name: []const u8 = "CreateRoom",
    Request: type = struct {
        room_name: []const u8,
        description: ?[]const u8 = null,
        profile_arn: ?[]const u8 = null,
        provider_calendar_id: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_name = "RoomName",
                .description = "Description",
                .profile_arn = "ProfileArn",
                .provider_calendar_id = "ProviderCalendarId",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_room) } {
            return .{ .service_metadata = service_metadata, .action = create_room };
        }
    },
    Response: type = struct {
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
    },
} = .{};
pub const create_skill_group: struct {
    action_name: []const u8 = "CreateSkillGroup",
    Request: type = struct {
        skill_group_name: []const u8,
        description: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_name = "SkillGroupName",
                .description = "Description",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = create_skill_group };
        }
    },
    Response: type = struct {
        skill_group_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        ConcurrentModification,
        LimitExceeded,
    },
} = .{};
pub const create_user: struct {
    action_name: []const u8 = "CreateUser",
    Request: type = struct {
        user_id: []const u8,
        first_name: ?[]const u8 = null,
        last_name: ?[]const u8 = null,
        email: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_id = "UserId",
                .first_name = "FirstName",
                .last_name = "LastName",
                .email = "Email",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_user) } {
            return .{ .service_metadata = service_metadata, .action = create_user };
        }
    },
    Response: type = struct {
        user_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_arn = "UserArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        LimitExceeded,
        ResourceInUse,
    },
} = .{};
pub const delete_address_book: struct {
    action_name: []const u8 = "DeleteAddressBook",
    Request: type = struct {
        address_book_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_book_arn = "AddressBookArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_address_book) } {
            return .{ .service_metadata = service_metadata, .action = delete_address_book };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_business_report_schedule: struct {
    action_name: []const u8 = "DeleteBusinessReportSchedule",
    Request: type = struct {
        schedule_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .schedule_arn = "ScheduleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_business_report_schedule) } {
            return .{ .service_metadata = service_metadata, .action = delete_business_report_schedule };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_conference_provider: struct {
    action_name: []const u8 = "DeleteConferenceProvider",
    Request: type = struct {
        conference_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider_arn = "ConferenceProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_conference_provider) } {
            return .{ .service_metadata = service_metadata, .action = delete_conference_provider };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const delete_contact: struct {
    action_name: []const u8 = "DeleteContact",
    Request: type = struct {
        contact_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_contact) } {
            return .{ .service_metadata = service_metadata, .action = delete_contact };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_device: struct {
    action_name: []const u8 = "DeleteDevice",
    Request: type = struct {
        device_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_device) } {
            return .{ .service_metadata = service_metadata, .action = delete_device };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidCertificateAuthority,
        NotFound,
    },
} = .{};
pub const delete_device_usage_data: struct {
    action_name: []const u8 = "DeleteDeviceUsageData",
    Request: type = struct {
        device_arn: []const u8,
        device_usage_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
                .device_usage_type = "DeviceUsageType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_device_usage_data) } {
            return .{ .service_metadata = service_metadata, .action = delete_device_usage_data };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeviceNotRegistered,
        LimitExceeded,
        NotFound,
    },
} = .{};
pub const delete_gateway_group: struct {
    action_name: []const u8 = "DeleteGatewayGroup",
    Request: type = struct {
        gateway_group_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group_arn = "GatewayGroupArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_gateway_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_gateway_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceAssociated,
    },
} = .{};
pub const delete_network_profile: struct {
    action_name: []const u8 = "DeleteNetworkProfile",
    Request: type = struct {
        network_profile_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile_arn = "NetworkProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_network_profile) } {
            return .{ .service_metadata = service_metadata, .action = delete_network_profile };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
        ResourceInUse,
    },
} = .{};
pub const delete_profile: struct {
    action_name: []const u8 = "DeleteProfile",
    Request: type = struct {
        profile_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile_arn = "ProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_profile) } {
            return .{ .service_metadata = service_metadata, .action = delete_profile };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_room: struct {
    action_name: []const u8 = "DeleteRoom",
    Request: type = struct {
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_room) } {
            return .{ .service_metadata = service_metadata, .action = delete_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_room_skill_parameter: struct {
    action_name: []const u8 = "DeleteRoomSkillParameter",
    Request: type = struct {
        room_arn: ?[]const u8 = null,
        skill_id: []const u8,
        parameter_key: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .skill_id = "SkillId",
                .parameter_key = "ParameterKey",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_room_skill_parameter) } {
            return .{ .service_metadata = service_metadata, .action = delete_room_skill_parameter };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
    },
} = .{};
pub const delete_skill_authorization: struct {
    action_name: []const u8 = "DeleteSkillAuthorization",
    Request: type = struct {
        skill_id: []const u8,
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_id = "SkillId",
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_skill_authorization) } {
            return .{ .service_metadata = service_metadata, .action = delete_skill_authorization };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_skill_group: struct {
    action_name: []const u8 = "DeleteSkillGroup",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_skill_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const delete_user: struct {
    action_name: []const u8 = "DeleteUser",
    Request: type = struct {
        user_arn: ?[]const u8 = null,
        enrollment_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_arn = "UserArn",
                .enrollment_id = "EnrollmentId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_user) } {
            return .{ .service_metadata = service_metadata, .action = delete_user };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const disassociate_contact_from_address_book: struct {
    action_name: []const u8 = "DisassociateContactFromAddressBook",
    Request: type = struct {
        contact_arn: []const u8,
        address_book_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
                .address_book_arn = "AddressBookArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_contact_from_address_book) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_contact_from_address_book };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const disassociate_device_from_room: struct {
    action_name: []const u8 = "DisassociateDeviceFromRoom",
    Request: type = struct {
        device_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_device_from_room) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_device_from_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        DeviceNotRegistered,
    },
} = .{};
pub const disassociate_skill_from_skill_group: struct {
    action_name: []const u8 = "DisassociateSkillFromSkillGroup",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_skill_from_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_skill_from_skill_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const disassociate_skill_from_users: struct {
    action_name: []const u8 = "DisassociateSkillFromUsers",
    Request: type = struct {
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_skill_from_users) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_skill_from_users };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const disassociate_skill_group_from_room: struct {
    action_name: []const u8 = "DisassociateSkillGroupFromRoom",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_skill_group_from_room) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_skill_group_from_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
    },
} = .{};
pub const forget_smart_home_appliances: struct {
    action_name: []const u8 = "ForgetSmartHomeAppliances",
    Request: type = struct {
        room_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(forget_smart_home_appliances) } {
            return .{ .service_metadata = service_metadata, .action = forget_smart_home_appliances };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_address_book: struct {
    action_name: []const u8 = "GetAddressBook",
    Request: type = struct {
        address_book_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_book_arn = "AddressBookArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_address_book) } {
            return .{ .service_metadata = service_metadata, .action = get_address_book };
        }
    },
    Response: type = struct {
        address_book: ?struct {
            address_book_arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .address_book_arn = "AddressBookArn",
                    .name = "Name",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_book = "AddressBook",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_conference_preference: struct {
    action_name: []const u8 = "GetConferencePreference",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_conference_preference) } {
            return .{ .service_metadata = service_metadata, .action = get_conference_preference };
        }
    },
    Response: type = struct {
        preference: ?ConferencePreference = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .preference = "Preference",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_conference_provider: struct {
    action_name: []const u8 = "GetConferenceProvider",
    Request: type = struct {
        conference_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider_arn = "ConferenceProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_conference_provider) } {
            return .{ .service_metadata = service_metadata, .action = get_conference_provider };
        }
    },
    Response: type = struct {
        conference_provider: ?ConferenceProvider = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider = "ConferenceProvider",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_contact: struct {
    action_name: []const u8 = "GetContact",
    Request: type = struct {
        contact_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_contact) } {
            return .{ .service_metadata = service_metadata, .action = get_contact };
        }
    },
    Response: type = struct {
        contact: ?struct {
            contact_arn: ?[]const u8 = null,
            display_name: ?[]const u8 = null,
            first_name: ?[]const u8 = null,
            last_name: ?[]const u8 = null,
            phone_number: ?[]const u8 = null,
            phone_numbers: ?[]PhoneNumber = null,
            sip_addresses: ?[]SipAddress = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .contact_arn = "ContactArn",
                    .display_name = "DisplayName",
                    .first_name = "FirstName",
                    .last_name = "LastName",
                    .phone_number = "PhoneNumber",
                    .phone_numbers = "PhoneNumbers",
                    .sip_addresses = "SipAddresses",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact = "Contact",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_device: struct {
    action_name: []const u8 = "GetDevice",
    Request: type = struct {
        device_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_device) } {
            return .{ .service_metadata = service_metadata, .action = get_device };
        }
    },
    Response: type = struct {
        device: ?struct {
            device_arn: ?[]const u8 = null,
            device_serial_number: ?[]const u8 = null,
            device_type: ?[]const u8 = null,
            device_name: ?[]const u8 = null,
            software_version: ?[]const u8 = null,
            mac_address: ?[]const u8 = null,
            room_arn: ?[]const u8 = null,
            device_status: ?[]const u8 = null,
            device_status_info: ?DeviceStatusInfo = null,
            network_profile_info: ?struct {
                network_profile_arn: ?[]const u8 = null,
                certificate_arn: ?[]const u8 = null,
                certificate_expiration_time: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .network_profile_arn = "NetworkProfileArn",
                        .certificate_arn = "CertificateArn",
                        .certificate_expiration_time = "CertificateExpirationTime",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .device_arn = "DeviceArn",
                    .device_serial_number = "DeviceSerialNumber",
                    .device_type = "DeviceType",
                    .device_name = "DeviceName",
                    .software_version = "SoftwareVersion",
                    .mac_address = "MacAddress",
                    .room_arn = "RoomArn",
                    .device_status = "DeviceStatus",
                    .device_status_info = "DeviceStatusInfo",
                    .network_profile_info = "NetworkProfileInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device = "Device",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_gateway: struct {
    action_name: []const u8 = "GetGateway",
    Request: type = struct {
        gateway_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_arn = "GatewayArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_gateway) } {
            return .{ .service_metadata = service_metadata, .action = get_gateway };
        }
    },
    Response: type = struct {
        gateway: ?struct {
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            gateway_group_arn: ?[]const u8 = null,
            software_version: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .name = "Name",
                    .description = "Description",
                    .gateway_group_arn = "GatewayGroupArn",
                    .software_version = "SoftwareVersion",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway = "Gateway",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_gateway_group: struct {
    action_name: []const u8 = "GetGatewayGroup",
    Request: type = struct {
        gateway_group_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group_arn = "GatewayGroupArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_gateway_group) } {
            return .{ .service_metadata = service_metadata, .action = get_gateway_group };
        }
    },
    Response: type = struct {
        gateway_group: ?struct {
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .name = "Name",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group = "GatewayGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_invitation_configuration: struct {
    action_name: []const u8 = "GetInvitationConfiguration",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_invitation_configuration) } {
            return .{ .service_metadata = service_metadata, .action = get_invitation_configuration };
        }
    },
    Response: type = struct {
        organization_name: ?[]const u8 = null,
        contact_email: ?[]const u8 = null,
        private_skill_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .organization_name = "OrganizationName",
                .contact_email = "ContactEmail",
                .private_skill_ids = "PrivateSkillIds",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_network_profile: struct {
    action_name: []const u8 = "GetNetworkProfile",
    Request: type = struct {
        network_profile_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile_arn = "NetworkProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_network_profile) } {
            return .{ .service_metadata = service_metadata, .action = get_network_profile };
        }
    },
    Response: type = struct {
        network_profile: ?struct {
            network_profile_arn: ?[]const u8 = null,
            network_profile_name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            ssid: ?[]const u8 = null,
            security_type: ?[]const u8 = null,
            eap_method: ?[]const u8 = null,
            current_password: ?[]const u8 = null,
            next_password: ?[]const u8 = null,
            certificate_authority_arn: ?[]const u8 = null,
            trust_anchors: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .network_profile_arn = "NetworkProfileArn",
                    .network_profile_name = "NetworkProfileName",
                    .description = "Description",
                    .ssid = "Ssid",
                    .security_type = "SecurityType",
                    .eap_method = "EapMethod",
                    .current_password = "CurrentPassword",
                    .next_password = "NextPassword",
                    .certificate_authority_arn = "CertificateAuthorityArn",
                    .trust_anchors = "TrustAnchors",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile = "NetworkProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidSecretsManagerResource,
        NotFound,
    },
} = .{};
pub const get_profile: struct {
    action_name: []const u8 = "GetProfile",
    Request: type = struct {
        profile_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile_arn = "ProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_profile) } {
            return .{ .service_metadata = service_metadata, .action = get_profile };
        }
    },
    Response: type = struct {
        profile: ?struct {
            profile_arn: ?[]const u8 = null,
            profile_name: ?[]const u8 = null,
            is_default: ?bool = null,
            address: ?[]const u8 = null,
            timezone: ?[]const u8 = null,
            distance_unit: ?[]const u8 = null,
            temperature_unit: ?[]const u8 = null,
            wake_word: ?[]const u8 = null,
            locale: ?[]const u8 = null,
            setup_mode_disabled: ?bool = null,
            max_volume_limit: ?i64 = null,
            pstn_enabled: ?bool = null,
            data_retention_opt_in: ?bool = null,
            address_book_arn: ?[]const u8 = null,
            meeting_room_configuration: ?struct {
                room_utilization_metrics_enabled: ?bool = null,
                end_of_meeting_reminder: ?struct {
                    reminder_at_minutes: ?[]i64 = null,
                    reminder_type: ?[]const u8 = null,
                    enabled: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .reminder_at_minutes = "ReminderAtMinutes",
                            .reminder_type = "ReminderType",
                            .enabled = "Enabled",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                instant_booking: ?struct {
                    duration_in_minutes: ?i64 = null,
                    enabled: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .duration_in_minutes = "DurationInMinutes",
                            .enabled = "Enabled",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                require_check_in: ?struct {
                    release_after_minutes: ?i64 = null,
                    enabled: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .release_after_minutes = "ReleaseAfterMinutes",
                            .enabled = "Enabled",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                proactive_join: ?struct {
                    enabled_by_motion: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .enabled_by_motion = "EnabledByMotion",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .room_utilization_metrics_enabled = "RoomUtilizationMetricsEnabled",
                        .end_of_meeting_reminder = "EndOfMeetingReminder",
                        .instant_booking = "InstantBooking",
                        .require_check_in = "RequireCheckIn",
                        .proactive_join = "ProactiveJoin",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .profile_arn = "ProfileArn",
                    .profile_name = "ProfileName",
                    .is_default = "IsDefault",
                    .address = "Address",
                    .timezone = "Timezone",
                    .distance_unit = "DistanceUnit",
                    .temperature_unit = "TemperatureUnit",
                    .wake_word = "WakeWord",
                    .locale = "Locale",
                    .setup_mode_disabled = "SetupModeDisabled",
                    .max_volume_limit = "MaxVolumeLimit",
                    .pstn_enabled = "PSTNEnabled",
                    .data_retention_opt_in = "DataRetentionOptIn",
                    .address_book_arn = "AddressBookArn",
                    .meeting_room_configuration = "MeetingRoomConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile = "Profile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_room: struct {
    action_name: []const u8 = "GetRoom",
    Request: type = struct {
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_room) } {
            return .{ .service_metadata = service_metadata, .action = get_room };
        }
    },
    Response: type = struct {
        room: ?struct {
            room_arn: ?[]const u8 = null,
            room_name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            provider_calendar_id: ?[]const u8 = null,
            profile_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .room_arn = "RoomArn",
                    .room_name = "RoomName",
                    .description = "Description",
                    .provider_calendar_id = "ProviderCalendarId",
                    .profile_arn = "ProfileArn",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room = "Room",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_room_skill_parameter: struct {
    action_name: []const u8 = "GetRoomSkillParameter",
    Request: type = struct {
        room_arn: ?[]const u8 = null,
        skill_id: []const u8,
        parameter_key: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .skill_id = "SkillId",
                .parameter_key = "ParameterKey",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_room_skill_parameter) } {
            return .{ .service_metadata = service_metadata, .action = get_room_skill_parameter };
        }
    },
    Response: type = struct {
        room_skill_parameter: ?RoomSkillParameter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_skill_parameter = "RoomSkillParameter",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const get_skill_group: struct {
    action_name: []const u8 = "GetSkillGroup",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = get_skill_group };
        }
    },
    Response: type = struct {
        skill_group: ?struct {
            skill_group_arn: ?[]const u8 = null,
            skill_group_name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .skill_group_arn = "SkillGroupArn",
                    .skill_group_name = "SkillGroupName",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group = "SkillGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const list_business_report_schedules: struct {
    action_name: []const u8 = "ListBusinessReportSchedules",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_business_report_schedules) } {
            return .{ .service_metadata = service_metadata, .action = list_business_report_schedules };
        }
    },
    Response: type = struct {
        business_report_schedules: ?[]struct {
            schedule_arn: ?[]const u8 = null,
            schedule_name: ?[]const u8 = null,
            s3_bucket_name: ?[]const u8 = null,
            s3_key_prefix: ?[]const u8 = null,
            format: ?[]const u8 = null,
            content_range: ?BusinessReportContentRange = null,
            recurrence: ?BusinessReportRecurrence = null,
            last_business_report: ?struct {
                status: ?[]const u8 = null,
                failure_code: ?[]const u8 = null,
                s3_location: ?struct {
                    path: ?[]const u8 = null,
                    bucket_name: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .path = "Path",
                            .bucket_name = "BucketName",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                delivery_time: ?i64 = null,
                download_url: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .status = "Status",
                        .failure_code = "FailureCode",
                        .s3_location = "S3Location",
                        .delivery_time = "DeliveryTime",
                        .download_url = "DownloadUrl",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .schedule_arn = "ScheduleArn",
                    .schedule_name = "ScheduleName",
                    .s3_bucket_name = "S3BucketName",
                    .s3_key_prefix = "S3KeyPrefix",
                    .format = "Format",
                    .content_range = "ContentRange",
                    .recurrence = "Recurrence",
                    .last_business_report = "LastBusinessReport",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .business_report_schedules = "BusinessReportSchedules",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_conference_providers: struct {
    action_name: []const u8 = "ListConferenceProviders",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_conference_providers) } {
            return .{ .service_metadata = service_metadata, .action = list_conference_providers };
        }
    },
    Response: type = struct {
        conference_providers: ?[]ConferenceProvider = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_providers = "ConferenceProviders",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_device_events: struct {
    action_name: []const u8 = "ListDeviceEvents",
    Request: type = struct {
        device_arn: []const u8,
        event_type: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
                .event_type = "EventType",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_device_events) } {
            return .{ .service_metadata = service_metadata, .action = list_device_events };
        }
    },
    Response: type = struct {
        device_events: ?[]struct {
            type: ?[]const u8 = null,
            value: ?[]const u8 = null,
            timestamp: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .type = "Type",
                    .value = "Value",
                    .timestamp = "Timestamp",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_events = "DeviceEvents",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const list_gateway_groups: struct {
    action_name: []const u8 = "ListGatewayGroups",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_gateway_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_gateway_groups };
        }
    },
    Response: type = struct {
        gateway_groups: ?[]struct {
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .name = "Name",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_groups = "GatewayGroups",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_gateways: struct {
    action_name: []const u8 = "ListGateways",
    Request: type = struct {
        gateway_group_arn: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group_arn = "GatewayGroupArn",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_gateways) } {
            return .{ .service_metadata = service_metadata, .action = list_gateways };
        }
    },
    Response: type = struct {
        gateways: ?[]struct {
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            gateway_group_arn: ?[]const u8 = null,
            software_version: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .name = "Name",
                    .description = "Description",
                    .gateway_group_arn = "GatewayGroupArn",
                    .software_version = "SoftwareVersion",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateways = "Gateways",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_skills: struct {
    action_name: []const u8 = "ListSkills",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        enablement_type: ?[]const u8 = null,
        skill_type: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .enablement_type = "EnablementType",
                .skill_type = "SkillType",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_skills) } {
            return .{ .service_metadata = service_metadata, .action = list_skills };
        }
    },
    Response: type = struct {
        skill_summaries: ?[]struct {
            skill_id: ?[]const u8 = null,
            skill_name: ?[]const u8 = null,
            supports_linking: ?bool = null,
            enablement_type: ?[]const u8 = null,
            skill_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .skill_id = "SkillId",
                    .skill_name = "SkillName",
                    .supports_linking = "SupportsLinking",
                    .enablement_type = "EnablementType",
                    .skill_type = "SkillType",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_summaries = "SkillSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_skills_store_categories: struct {
    action_name: []const u8 = "ListSkillsStoreCategories",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_skills_store_categories) } {
            return .{ .service_metadata = service_metadata, .action = list_skills_store_categories };
        }
    },
    Response: type = struct {
        category_list: ?[]struct {
            category_id: ?i64 = null,
            category_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .category_id = "CategoryId",
                    .category_name = "CategoryName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .category_list = "CategoryList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_skills_store_skills_by_category: struct {
    action_name: []const u8 = "ListSkillsStoreSkillsByCategory",
    Request: type = struct {
        category_id: i64,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .category_id = "CategoryId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_skills_store_skills_by_category) } {
            return .{ .service_metadata = service_metadata, .action = list_skills_store_skills_by_category };
        }
    },
    Response: type = struct {
        skills_store_skills: ?[]struct {
            skill_id: ?[]const u8 = null,
            skill_name: ?[]const u8 = null,
            short_description: ?[]const u8 = null,
            icon_url: ?[]const u8 = null,
            sample_utterances: ?[][]const u8 = null,
            skill_details: ?struct {
                product_description: ?[]const u8 = null,
                invocation_phrase: ?[]const u8 = null,
                release_date: ?[]const u8 = null,
                end_user_license_agreement: ?[]const u8 = null,
                generic_keywords: ?[][]const u8 = null,
                bullet_points: ?[][]const u8 = null,
                new_in_this_version_bullet_points: ?[][]const u8 = null,
                skill_types: ?[][]const u8 = null,
                reviews: ?[]struct {
                    key: ?[]const u8 = null,
                    value: ?[]const u8 = null,
                } = null,
                developer_info: ?struct {
                    developer_name: ?[]const u8 = null,
                    privacy_policy: ?[]const u8 = null,
                    email: ?[]const u8 = null,
                    url: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .developer_name = "DeveloperName",
                            .privacy_policy = "PrivacyPolicy",
                            .email = "Email",
                            .url = "Url",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .product_description = "ProductDescription",
                        .invocation_phrase = "InvocationPhrase",
                        .release_date = "ReleaseDate",
                        .end_user_license_agreement = "EndUserLicenseAgreement",
                        .generic_keywords = "GenericKeywords",
                        .bullet_points = "BulletPoints",
                        .new_in_this_version_bullet_points = "NewInThisVersionBulletPoints",
                        .skill_types = "SkillTypes",
                        .reviews = "Reviews",
                        .developer_info = "DeveloperInfo",
                    };
                    return @field(mappings, field_name);
                }

                pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                    if (std.mem.eql(u8, "reviews", field_name))
                        return try serializeMap(self.reviews, self.fieldNameFor("reviews"), options, out_stream);
                    return false;
                }
            } = null,
            supports_linking: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .skill_id = "SkillId",
                    .skill_name = "SkillName",
                    .short_description = "ShortDescription",
                    .icon_url = "IconUrl",
                    .sample_utterances = "SampleUtterances",
                    .skill_details = "SkillDetails",
                    .supports_linking = "SupportsLinking",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skills_store_skills = "SkillsStoreSkills",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_smart_home_appliances: struct {
    action_name: []const u8 = "ListSmartHomeAppliances",
    Request: type = struct {
        room_arn: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_smart_home_appliances) } {
            return .{ .service_metadata = service_metadata, .action = list_smart_home_appliances };
        }
    },
    Response: type = struct {
        smart_home_appliances: ?[]struct {
            friendly_name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            manufacturer_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .friendly_name = "FriendlyName",
                    .description = "Description",
                    .manufacturer_name = "ManufacturerName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .smart_home_appliances = "SmartHomeAppliances",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const list_tags: struct {
    action_name: []const u8 = "ListTags",
    Request: type = struct {
        arn: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_tags };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const put_conference_preference: struct {
    action_name: []const u8 = "PutConferencePreference",
    Request: type = struct {
        conference_preference: ConferencePreference,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_preference = "ConferencePreference",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_conference_preference) } {
            return .{ .service_metadata = service_metadata, .action = put_conference_preference };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const put_invitation_configuration: struct {
    action_name: []const u8 = "PutInvitationConfiguration",
    Request: type = struct {
        organization_name: []const u8,
        contact_email: ?[]const u8 = null,
        private_skill_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .organization_name = "OrganizationName",
                .contact_email = "ContactEmail",
                .private_skill_ids = "PrivateSkillIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_invitation_configuration) } {
            return .{ .service_metadata = service_metadata, .action = put_invitation_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const put_room_skill_parameter: struct {
    action_name: []const u8 = "PutRoomSkillParameter",
    Request: type = struct {
        room_arn: ?[]const u8 = null,
        skill_id: []const u8,
        room_skill_parameter: RoomSkillParameter,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .skill_id = "SkillId",
                .room_skill_parameter = "RoomSkillParameter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_room_skill_parameter) } {
            return .{ .service_metadata = service_metadata, .action = put_room_skill_parameter };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
    },
} = .{};
pub const put_skill_authorization: struct {
    action_name: []const u8 = "PutSkillAuthorization",
    Request: type = struct {
        authorization_result: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },
        skill_id: []const u8,
        room_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .authorization_result = "AuthorizationResult",
                .skill_id = "SkillId",
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "authorization_result", field_name))
                return try serializeMap(self.authorization_result, self.fieldNameFor("authorization_result"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_skill_authorization) } {
            return .{ .service_metadata = service_metadata, .action = put_skill_authorization };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        Unauthorized,
    },
} = .{};
pub const register_avs_device: struct {
    action_name: []const u8 = "RegisterAVSDevice",
    Request: type = struct {
        client_id: []const u8,
        user_code: []const u8,
        product_id: []const u8,
        device_serial_number: ?[]const u8 = null,
        amazon_id: []const u8,
        room_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .client_id = "ClientId",
                .user_code = "UserCode",
                .product_id = "ProductId",
                .device_serial_number = "DeviceSerialNumber",
                .amazon_id = "AmazonId",
                .room_arn = "RoomArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_avs_device) } {
            return .{ .service_metadata = service_metadata, .action = register_avs_device };
        }
    },
    Response: type = struct {
        device_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidDevice,
        LimitExceeded,
        NotFound,
    },
} = .{};
pub const reject_skill: struct {
    action_name: []const u8 = "RejectSkill",
    Request: type = struct {
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reject_skill) } {
            return .{ .service_metadata = service_metadata, .action = reject_skill };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const resolve_room: struct {
    action_name: []const u8 = "ResolveRoom",
    Request: type = struct {
        user_id: []const u8,
        skill_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_id = "UserId",
                .skill_id = "SkillId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(resolve_room) } {
            return .{ .service_metadata = service_metadata, .action = resolve_room };
        }
    },
    Response: type = struct {
        room_arn: ?[]const u8 = null,
        room_name: ?[]const u8 = null,
        room_skill_parameters: ?[]RoomSkillParameter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .room_name = "RoomName",
                .room_skill_parameters = "RoomSkillParameters",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const revoke_invitation: struct {
    action_name: []const u8 = "RevokeInvitation",
    Request: type = struct {
        user_arn: ?[]const u8 = null,
        enrollment_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_arn = "UserArn",
                .enrollment_id = "EnrollmentId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(revoke_invitation) } {
            return .{ .service_metadata = service_metadata, .action = revoke_invitation };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const search_address_books: struct {
    action_name: []const u8 = "SearchAddressBooks",
    Request: type = struct {
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_address_books) } {
            return .{ .service_metadata = service_metadata, .action = search_address_books };
        }
    },
    Response: type = struct {
        address_books: ?[]struct {
            address_book_arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .address_book_arn = "AddressBookArn",
                    .name = "Name",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_books = "AddressBooks",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_contacts: struct {
    action_name: []const u8 = "SearchContacts",
    Request: type = struct {
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_contacts) } {
            return .{ .service_metadata = service_metadata, .action = search_contacts };
        }
    },
    Response: type = struct {
        contacts: ?[]struct {
            contact_arn: ?[]const u8 = null,
            display_name: ?[]const u8 = null,
            first_name: ?[]const u8 = null,
            last_name: ?[]const u8 = null,
            phone_number: ?[]const u8 = null,
            phone_numbers: ?[]PhoneNumber = null,
            sip_addresses: ?[]SipAddress = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .contact_arn = "ContactArn",
                    .display_name = "DisplayName",
                    .first_name = "FirstName",
                    .last_name = "LastName",
                    .phone_number = "PhoneNumber",
                    .phone_numbers = "PhoneNumbers",
                    .sip_addresses = "SipAddresses",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contacts = "Contacts",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_devices: struct {
    action_name: []const u8 = "SearchDevices",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_devices) } {
            return .{ .service_metadata = service_metadata, .action = search_devices };
        }
    },
    Response: type = struct {
        devices: ?[]struct {
            device_arn: ?[]const u8 = null,
            device_serial_number: ?[]const u8 = null,
            device_type: ?[]const u8 = null,
            device_name: ?[]const u8 = null,
            software_version: ?[]const u8 = null,
            mac_address: ?[]const u8 = null,
            device_status: ?[]const u8 = null,
            network_profile_arn: ?[]const u8 = null,
            network_profile_name: ?[]const u8 = null,
            room_arn: ?[]const u8 = null,
            room_name: ?[]const u8 = null,
            device_status_info: ?DeviceStatusInfo = null,
            created_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .device_arn = "DeviceArn",
                    .device_serial_number = "DeviceSerialNumber",
                    .device_type = "DeviceType",
                    .device_name = "DeviceName",
                    .software_version = "SoftwareVersion",
                    .mac_address = "MacAddress",
                    .device_status = "DeviceStatus",
                    .network_profile_arn = "NetworkProfileArn",
                    .network_profile_name = "NetworkProfileName",
                    .room_arn = "RoomArn",
                    .room_name = "RoomName",
                    .device_status_info = "DeviceStatusInfo",
                    .created_time = "CreatedTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .devices = "Devices",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_network_profiles: struct {
    action_name: []const u8 = "SearchNetworkProfiles",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_network_profiles) } {
            return .{ .service_metadata = service_metadata, .action = search_network_profiles };
        }
    },
    Response: type = struct {
        network_profiles: ?[]struct {
            network_profile_arn: ?[]const u8 = null,
            network_profile_name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            ssid: ?[]const u8 = null,
            security_type: ?[]const u8 = null,
            eap_method: ?[]const u8 = null,
            certificate_authority_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .network_profile_arn = "NetworkProfileArn",
                    .network_profile_name = "NetworkProfileName",
                    .description = "Description",
                    .ssid = "Ssid",
                    .security_type = "SecurityType",
                    .eap_method = "EapMethod",
                    .certificate_authority_arn = "CertificateAuthorityArn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profiles = "NetworkProfiles",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_profiles: struct {
    action_name: []const u8 = "SearchProfiles",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_profiles) } {
            return .{ .service_metadata = service_metadata, .action = search_profiles };
        }
    },
    Response: type = struct {
        profiles: ?[]struct {
            profile_arn: ?[]const u8 = null,
            profile_name: ?[]const u8 = null,
            is_default: ?bool = null,
            address: ?[]const u8 = null,
            timezone: ?[]const u8 = null,
            distance_unit: ?[]const u8 = null,
            temperature_unit: ?[]const u8 = null,
            wake_word: ?[]const u8 = null,
            locale: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .profile_arn = "ProfileArn",
                    .profile_name = "ProfileName",
                    .is_default = "IsDefault",
                    .address = "Address",
                    .timezone = "Timezone",
                    .distance_unit = "DistanceUnit",
                    .temperature_unit = "TemperatureUnit",
                    .wake_word = "WakeWord",
                    .locale = "Locale",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profiles = "Profiles",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_rooms: struct {
    action_name: []const u8 = "SearchRooms",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_rooms) } {
            return .{ .service_metadata = service_metadata, .action = search_rooms };
        }
    },
    Response: type = struct {
        rooms: ?[]struct {
            room_arn: ?[]const u8 = null,
            room_name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            provider_calendar_id: ?[]const u8 = null,
            profile_arn: ?[]const u8 = null,
            profile_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .room_arn = "RoomArn",
                    .room_name = "RoomName",
                    .description = "Description",
                    .provider_calendar_id = "ProviderCalendarId",
                    .profile_arn = "ProfileArn",
                    .profile_name = "ProfileName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rooms = "Rooms",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_skill_groups: struct {
    action_name: []const u8 = "SearchSkillGroups",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_skill_groups) } {
            return .{ .service_metadata = service_metadata, .action = search_skill_groups };
        }
    },
    Response: type = struct {
        skill_groups: ?[]struct {
            skill_group_arn: ?[]const u8 = null,
            skill_group_name: ?[]const u8 = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .skill_group_arn = "SkillGroupArn",
                    .skill_group_name = "SkillGroupName",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_groups = "SkillGroups",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const search_users: struct {
    action_name: []const u8 = "SearchUsers",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]Filter = null,
        sort_criteria: ?[]Sort = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .sort_criteria = "SortCriteria",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(search_users) } {
            return .{ .service_metadata = service_metadata, .action = search_users };
        }
    },
    Response: type = struct {
        users: ?[]struct {
            user_arn: ?[]const u8 = null,
            first_name: ?[]const u8 = null,
            last_name: ?[]const u8 = null,
            email: ?[]const u8 = null,
            enrollment_status: ?[]const u8 = null,
            enrollment_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_arn = "UserArn",
                    .first_name = "FirstName",
                    .last_name = "LastName",
                    .email = "Email",
                    .enrollment_status = "EnrollmentStatus",
                    .enrollment_id = "EnrollmentId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .users = "Users",
                .next_token = "NextToken",
                .total_count = "TotalCount",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const send_announcement: struct {
    action_name: []const u8 = "SendAnnouncement",
    Request: type = struct {
        room_filters: []Filter,
        content: struct {
            text_list: ?[]struct {
                locale: []const u8,
                value: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .locale = "Locale",
                        .value = "Value",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            ssml_list: ?[]struct {
                locale: []const u8,
                value: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .locale = "Locale",
                        .value = "Value",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            audio_list: ?[]struct {
                locale: []const u8,
                location: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .locale = "Locale",
                        .location = "Location",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .text_list = "TextList",
                    .ssml_list = "SsmlList",
                    .audio_list = "AudioList",
                };
                return @field(mappings, field_name);
            }
        },
        time_to_live_in_seconds: ?i64 = null,
        client_request_token: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_filters = "RoomFilters",
                .content = "Content",
                .time_to_live_in_seconds = "TimeToLiveInSeconds",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_announcement) } {
            return .{ .service_metadata = service_metadata, .action = send_announcement };
        }
    },
    Response: type = struct {
        announcement_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .announcement_arn = "AnnouncementArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
    },
} = .{};
pub const send_invitation: struct {
    action_name: []const u8 = "SendInvitation",
    Request: type = struct {
        user_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_arn = "UserArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_invitation) } {
            return .{ .service_metadata = service_metadata, .action = send_invitation };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidUserStatus,
        NotFound,
    },
} = .{};
pub const start_device_sync: struct {
    action_name: []const u8 = "StartDeviceSync",
    Request: type = struct {
        room_arn: ?[]const u8 = null,
        device_arn: ?[]const u8 = null,
        features: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .device_arn = "DeviceArn",
                .features = "Features",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_device_sync) } {
            return .{ .service_metadata = service_metadata, .action = start_device_sync };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeviceNotRegistered,
    },
} = .{};
pub const start_smart_home_appliance_discovery: struct {
    action_name: []const u8 = "StartSmartHomeApplianceDiscovery",
    Request: type = struct {
        room_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_smart_home_appliance_discovery) } {
            return .{ .service_metadata = service_metadata, .action = start_smart_home_appliance_discovery };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const update_address_book: struct {
    action_name: []const u8 = "UpdateAddressBook",
    Request: type = struct {
        address_book_arn: []const u8,
        name: ?[]const u8 = null,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .address_book_arn = "AddressBookArn",
                .name = "Name",
                .description = "Description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_address_book) } {
            return .{ .service_metadata = service_metadata, .action = update_address_book };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_business_report_schedule: struct {
    action_name: []const u8 = "UpdateBusinessReportSchedule",
    Request: type = struct {
        schedule_arn: []const u8,
        s3_bucket_name: ?[]const u8 = null,
        s3_key_prefix: ?[]const u8 = null,
        format: ?[]const u8 = null,
        schedule_name: ?[]const u8 = null,
        recurrence: ?BusinessReportRecurrence = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .schedule_arn = "ScheduleArn",
                .s3_bucket_name = "S3BucketName",
                .s3_key_prefix = "S3KeyPrefix",
                .format = "Format",
                .schedule_name = "ScheduleName",
                .recurrence = "Recurrence",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_business_report_schedule) } {
            return .{ .service_metadata = service_metadata, .action = update_business_report_schedule };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const update_conference_provider: struct {
    action_name: []const u8 = "UpdateConferenceProvider",
    Request: type = struct {
        conference_provider_arn: []const u8,
        conference_provider_type: []const u8,
        ip_dial_in: ?IPDialIn = null,
        pstn_dial_in: ?PSTNDialIn = null,
        meeting_setting: MeetingSetting,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .conference_provider_arn = "ConferenceProviderArn",
                .conference_provider_type = "ConferenceProviderType",
                .ip_dial_in = "IPDialIn",
                .pstn_dial_in = "PSTNDialIn",
                .meeting_setting = "MeetingSetting",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_conference_provider) } {
            return .{ .service_metadata = service_metadata, .action = update_conference_provider };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NotFound,
    },
} = .{};
pub const update_contact: struct {
    action_name: []const u8 = "UpdateContact",
    Request: type = struct {
        contact_arn: []const u8,
        display_name: ?[]const u8 = null,
        first_name: ?[]const u8 = null,
        last_name: ?[]const u8 = null,
        phone_number: ?[]const u8 = null,
        phone_numbers: ?[]PhoneNumber = null,
        sip_addresses: ?[]SipAddress = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_arn = "ContactArn",
                .display_name = "DisplayName",
                .first_name = "FirstName",
                .last_name = "LastName",
                .phone_number = "PhoneNumber",
                .phone_numbers = "PhoneNumbers",
                .sip_addresses = "SipAddresses",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_contact) } {
            return .{ .service_metadata = service_metadata, .action = update_contact };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NotFound,
    },
} = .{};
pub const update_device: struct {
    action_name: []const u8 = "UpdateDevice",
    Request: type = struct {
        device_arn: ?[]const u8 = null,
        device_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .device_arn = "DeviceArn",
                .device_name = "DeviceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_device) } {
            return .{ .service_metadata = service_metadata, .action = update_device };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        DeviceNotRegistered,
        NotFound,
    },
} = .{};
pub const update_gateway: struct {
    action_name: []const u8 = "UpdateGateway",
    Request: type = struct {
        gateway_arn: []const u8,
        name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        software_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_arn = "GatewayArn",
                .name = "Name",
                .description = "Description",
                .software_version = "SoftwareVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_gateway) } {
            return .{ .service_metadata = service_metadata, .action = update_gateway };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_gateway_group: struct {
    action_name: []const u8 = "UpdateGatewayGroup",
    Request: type = struct {
        gateway_group_arn: []const u8,
        name: ?[]const u8 = null,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .gateway_group_arn = "GatewayGroupArn",
                .name = "Name",
                .description = "Description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_gateway_group) } {
            return .{ .service_metadata = service_metadata, .action = update_gateway_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_network_profile: struct {
    action_name: []const u8 = "UpdateNetworkProfile",
    Request: type = struct {
        network_profile_arn: []const u8,
        network_profile_name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        current_password: ?[]const u8 = null,
        next_password: ?[]const u8 = null,
        certificate_authority_arn: ?[]const u8 = null,
        trust_anchors: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .network_profile_arn = "NetworkProfileArn",
                .network_profile_name = "NetworkProfileName",
                .description = "Description",
                .current_password = "CurrentPassword",
                .next_password = "NextPassword",
                .certificate_authority_arn = "CertificateAuthorityArn",
                .trust_anchors = "TrustAnchors",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_network_profile) } {
            return .{ .service_metadata = service_metadata, .action = update_network_profile };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidCertificateAuthority,
        InvalidSecretsManagerResource,
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_profile: struct {
    action_name: []const u8 = "UpdateProfile",
    Request: type = struct {
        profile_arn: ?[]const u8 = null,
        profile_name: ?[]const u8 = null,
        is_default: ?bool = null,
        timezone: ?[]const u8 = null,
        address: ?[]const u8 = null,
        distance_unit: ?[]const u8 = null,
        temperature_unit: ?[]const u8 = null,
        wake_word: ?[]const u8 = null,
        locale: ?[]const u8 = null,
        setup_mode_disabled: ?bool = null,
        max_volume_limit: ?i64 = null,
        pstn_enabled: ?bool = null,
        data_retention_opt_in: ?bool = null,
        meeting_room_configuration: ?struct {
            room_utilization_metrics_enabled: ?bool = null,
            end_of_meeting_reminder: ?struct {
                reminder_at_minutes: ?[]i64 = null,
                reminder_type: ?[]const u8 = null,
                enabled: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .reminder_at_minutes = "ReminderAtMinutes",
                        .reminder_type = "ReminderType",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            instant_booking: ?struct {
                duration_in_minutes: ?i64 = null,
                enabled: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .duration_in_minutes = "DurationInMinutes",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            require_check_in: ?struct {
                release_after_minutes: ?i64 = null,
                enabled: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .release_after_minutes = "ReleaseAfterMinutes",
                        .enabled = "Enabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            proactive_join: ?struct {
                enabled_by_motion: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .enabled_by_motion = "EnabledByMotion",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .room_utilization_metrics_enabled = "RoomUtilizationMetricsEnabled",
                    .end_of_meeting_reminder = "EndOfMeetingReminder",
                    .instant_booking = "InstantBooking",
                    .require_check_in = "RequireCheckIn",
                    .proactive_join = "ProactiveJoin",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .profile_arn = "ProfileArn",
                .profile_name = "ProfileName",
                .is_default = "IsDefault",
                .timezone = "Timezone",
                .address = "Address",
                .distance_unit = "DistanceUnit",
                .temperature_unit = "TemperatureUnit",
                .wake_word = "WakeWord",
                .locale = "Locale",
                .setup_mode_disabled = "SetupModeDisabled",
                .max_volume_limit = "MaxVolumeLimit",
                .pstn_enabled = "PSTNEnabled",
                .data_retention_opt_in = "DataRetentionOptIn",
                .meeting_room_configuration = "MeetingRoomConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_profile) } {
            return .{ .service_metadata = service_metadata, .action = update_profile };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_room: struct {
    action_name: []const u8 = "UpdateRoom",
    Request: type = struct {
        room_arn: ?[]const u8 = null,
        room_name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        provider_calendar_id: ?[]const u8 = null,
        profile_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .room_arn = "RoomArn",
                .room_name = "RoomName",
                .description = "Description",
                .provider_calendar_id = "ProviderCalendarId",
                .profile_arn = "ProfileArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_room) } {
            return .{ .service_metadata = service_metadata, .action = update_room };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NameInUse,
        NotFound,
    },
} = .{};
pub const update_skill_group: struct {
    action_name: []const u8 = "UpdateSkillGroup",
    Request: type = struct {
        skill_group_arn: ?[]const u8 = null,
        skill_group_name: ?[]const u8 = null,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .skill_group_arn = "SkillGroupArn",
                .skill_group_name = "SkillGroupName",
                .description = "Description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_skill_group) } {
            return .{ .service_metadata = service_metadata, .action = update_skill_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        NameInUse,
        NotFound,
    },
} = .{};

pub const SipAddress = struct {
    uri: []const u8,
    type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .uri = "Uri",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const PhoneNumber = struct {
    number: []const u8,
    type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .number = "Number",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const MeetingSetting = struct {
    require_pin: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .require_pin = "RequirePin",
        };
        return @field(mappings, field_name);
    }
};

pub const PSTNDialIn = struct {
    country_code: []const u8,
    phone_number: []const u8,
    one_click_id_delay: []const u8,
    one_click_pin_delay: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .country_code = "CountryCode",
            .phone_number = "PhoneNumber",
            .one_click_id_delay = "OneClickIdDelay",
            .one_click_pin_delay = "OneClickPinDelay",
        };
        return @field(mappings, field_name);
    }
};

pub const IPDialIn = struct {
    endpoint: []const u8,
    comms_protocol: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .endpoint = "Endpoint",
            .comms_protocol = "CommsProtocol",
        };
        return @field(mappings, field_name);
    }
};

pub const BusinessReportRecurrence = struct {
    start_date: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .start_date = "StartDate",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const Filter = struct {
    key: []const u8,
    values: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .values = "Values",
        };
        return @field(mappings, field_name);
    }
};

pub const Sort = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const DeviceStatusInfo = struct {
    device_status_details: ?[]DeviceStatusDetail = null,
    connection_status: ?[]const u8 = null,
    connection_status_updated_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .device_status_details = "DeviceStatusDetails",
            .connection_status = "ConnectionStatus",
            .connection_status_updated_time = "ConnectionStatusUpdatedTime",
        };
        return @field(mappings, field_name);
    }
};

pub const DeviceStatusDetail = struct {
    feature: ?[]const u8 = null,
    code: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .feature = "Feature",
            .code = "Code",
        };
        return @field(mappings, field_name);
    }
};

pub const RoomSkillParameter = struct {
    parameter_key: []const u8,
    parameter_value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .parameter_key = "ParameterKey",
            .parameter_value = "ParameterValue",
        };
        return @field(mappings, field_name);
    }
};

pub const ConferencePreference = struct {
    default_conference_provider_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_conference_provider_arn = "DefaultConferenceProviderArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ConferenceProvider = struct {
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    type: ?[]const u8 = null,
    ip_dial_in: ?IPDialIn = null,
    pstn_dial_in: ?PSTNDialIn = null,
    meeting_setting: ?MeetingSetting = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "Arn",
            .name = "Name",
            .type = "Type",
            .ip_dial_in = "IPDialIn",
            .pstn_dial_in = "PSTNDialIn",
            .meeting_setting = "MeetingSetting",
        };
        return @field(mappings, field_name);
    }
};

pub const BusinessReportContentRange = struct {
    interval: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .interval = "Interval",
        };
        return @field(mappings, field_name);
    }
};
