const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2021-11-11";
pub const sdk_id: []const u8 = "AppConfigData";
pub const arn_namespace: ?[]const u8 = "appconfigdata";
pub const endpoint_prefix: []const u8 = "appconfigdata";
pub const sigv4_name: []const u8 = "appconfig";
pub const name: []const u8 = "AppConfigData";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2021-11-11",
    sdk_id: []const u8 = "AppConfigData",
    arn_namespace: ?[]const u8 = "appconfigdata",
    endpoint_prefix: []const u8 = "appconfigdata",
    sigv4_name: []const u8 = "appconfig",
    name: []const u8 = "AppConfigData",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const get_latest_configuration: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLatestConfiguration",
    Request: type = struct {
        configuration_token: []const u8,

        pub const http_query = .{
            .configuration_token = "configuration_token",
        };

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_token = "ConfigurationToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_latest_configuration) } {
            return .{ .service_metadata = service_metadata, .action = get_latest_configuration };
        }
    },
    Response: type = struct {
        next_poll_configuration_token: ?[]const u8 = null,
        next_poll_interval_in_seconds: ?i64 = null,
        content_type: ?[]const u8 = null,
        configuration: ?[]const u8 = null,
        version_label: ?[]const u8 = null,
        pub const http_header = .{
            .next_poll_configuration_token = "Next-Poll-Configuration-Token",
            .next_poll_interval_in_seconds = "Next-Poll-Interval-In-Seconds",
            .content_type = "Content-Type",
            .version_label = "Version-Label",
        };

        pub const http_payload: []const u8 = "configuration";
        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_poll_configuration_token = "NextPollConfigurationToken",
                .next_poll_interval_in_seconds = "NextPollIntervalInSeconds",
                .content_type = "ContentType",
                .configuration = "Configuration",
                .version_label = "VersionLabel",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BadRequest,
        InternalServer,
        ResourceNotFound,
        Throttling,
    },
} = .{};
