const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2015-11-01";
pub const sdk_id: []const u8 = "Application Discovery Service";
pub const arn_namespace: ?[]const u8 = "discovery";
pub const endpoint_prefix: []const u8 = "discovery";
pub const sigv4_name: []const u8 = "discovery";
pub const name: []const u8 = "AWSPoseidonService_V2015_11_01";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2015-11-01",
    sdk_id: []const u8 = "Application Discovery Service",
    arn_namespace: ?[]const u8 = "discovery",
    endpoint_prefix: []const u8 = "discovery",
    sigv4_name: []const u8 = "discovery",
    name: []const u8 = "AWSPoseidonService_V2015_11_01",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_configuration_items_to_application: struct {
    action_name: []const u8 = "AssociateConfigurationItemsToApplication",
    Request: type = struct {
        application_configuration_id: []const u8,
        configuration_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_configuration_id = "applicationConfigurationId",
                .configuration_ids = "configurationIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_configuration_items_to_application) } {
            return .{ .service_metadata = service_metadata, .action = associate_configuration_items_to_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const batch_delete_agents: struct {
    action_name: []const u8 = "BatchDeleteAgents",
    Request: type = struct {
        delete_agents: []struct {
            agent_id: []const u8,
            force: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .agent_id = "agentId",
                    .force = "force",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delete_agents = "deleteAgents",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_delete_agents) } {
            return .{ .service_metadata = service_metadata, .action = batch_delete_agents };
        }
    },
    Response: type = struct {
        errors: ?[]struct {
            agent_id: []const u8,
            error_message: []const u8,
            error_code: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .agent_id = "agentId",
                    .error_message = "errorMessage",
                    .error_code = "errorCode",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .errors = "errors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const batch_delete_import_data: struct {
    action_name: []const u8 = "BatchDeleteImportData",
    Request: type = struct {
        import_task_ids: [][]const u8,
        delete_history: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .import_task_ids = "importTaskIds",
                .delete_history = "deleteHistory",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_delete_import_data) } {
            return .{ .service_metadata = service_metadata, .action = batch_delete_import_data };
        }
    },
    Response: type = struct {
        errors: ?[]struct {
            import_task_id: ?[]const u8 = null,
            error_code: ?[]const u8 = null,
            error_description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .import_task_id = "importTaskId",
                    .error_code = "errorCode",
                    .error_description = "errorDescription",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .errors = "errors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const create_application: struct {
    action_name: []const u8 = "CreateApplication",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application) } {
            return .{ .service_metadata = service_metadata, .action = create_application };
        }
    },
    Response: type = struct {
        configuration_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_id = "configurationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const create_tags: struct {
    action_name: []const u8 = "CreateTags",
    Request: type = struct {
        configuration_ids: [][]const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_ids = "configurationIds",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_tags) } {
            return .{ .service_metadata = service_metadata, .action = create_tags };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const delete_applications: struct {
    action_name: []const u8 = "DeleteApplications",
    Request: type = struct {
        configuration_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_ids = "configurationIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_applications) } {
            return .{ .service_metadata = service_metadata, .action = delete_applications };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const delete_tags: struct {
    action_name: []const u8 = "DeleteTags",
    Request: type = struct {
        configuration_ids: [][]const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_ids = "configurationIds",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_tags) } {
            return .{ .service_metadata = service_metadata, .action = delete_tags };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const describe_agents: struct {
    action_name: []const u8 = "DescribeAgents",
    Request: type = struct {
        agent_ids: ?[][]const u8 = null,
        filters: ?[]Filter = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agent_ids = "agentIds",
                .filters = "filters",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_agents) } {
            return .{ .service_metadata = service_metadata, .action = describe_agents };
        }
    },
    Response: type = struct {
        agents_info: ?[]struct {
            agent_id: ?[]const u8 = null,
            host_name: ?[]const u8 = null,
            agent_network_info_list: ?[]struct {
                ip_address: ?[]const u8 = null,
                mac_address: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .ip_address = "ipAddress",
                        .mac_address = "macAddress",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            connector_id: ?[]const u8 = null,
            version: ?[]const u8 = null,
            health: ?[]const u8 = null,
            last_health_ping_time: ?[]const u8 = null,
            collection_status: ?[]const u8 = null,
            agent_type: ?[]const u8 = null,
            registered_time: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .agent_id = "agentId",
                    .host_name = "hostName",
                    .agent_network_info_list = "agentNetworkInfoList",
                    .connector_id = "connectorId",
                    .version = "version",
                    .health = "health",
                    .last_health_ping_time = "lastHealthPingTime",
                    .collection_status = "collectionStatus",
                    .agent_type = "agentType",
                    .registered_time = "registeredTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agents_info = "agentsInfo",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const describe_batch_delete_configuration_task: struct {
    action_name: []const u8 = "DescribeBatchDeleteConfigurationTask",
    Request: type = struct {
        task_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_id = "taskId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_batch_delete_configuration_task) } {
            return .{ .service_metadata = service_metadata, .action = describe_batch_delete_configuration_task };
        }
    },
    Response: type = struct {
        task: ?struct {
            task_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            configuration_type: ?[]const u8 = null,
            requested_configurations: ?[][]const u8 = null,
            deleted_configurations: ?[][]const u8 = null,
            failed_configurations: ?[]struct {
                configuration_id: ?[]const u8 = null,
                error_status_code: ?i64 = null,
                error_message: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .configuration_id = "configurationId",
                        .error_status_code = "errorStatusCode",
                        .error_message = "errorMessage",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            deletion_warnings: ?[]struct {
                configuration_id: ?[]const u8 = null,
                warning_code: ?i64 = null,
                warning_text: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .configuration_id = "configurationId",
                        .warning_code = "warningCode",
                        .warning_text = "warningText",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .task_id = "taskId",
                    .status = "status",
                    .start_time = "startTime",
                    .end_time = "endTime",
                    .configuration_type = "configurationType",
                    .requested_configurations = "requestedConfigurations",
                    .deleted_configurations = "deletedConfigurations",
                    .failed_configurations = "failedConfigurations",
                    .deletion_warnings = "deletionWarnings",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task = "task",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const describe_configurations: struct {
    action_name: []const u8 = "DescribeConfigurations",
    Request: type = struct {
        configuration_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_ids = "configurationIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_configurations };
        }
    },
    Response: type = struct {
        configurations: ?[][]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configurations = "configurations",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "configurations", field_name))
                return try serializeMap(self.configurations, self.fieldNameFor("configurations"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const describe_continuous_exports: struct {
    action_name: []const u8 = "DescribeContinuousExports",
    Request: type = struct {
        export_ids: ?[][]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_ids = "exportIds",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_continuous_exports) } {
            return .{ .service_metadata = service_metadata, .action = describe_continuous_exports };
        }
    },
    Response: type = struct {
        descriptions: ?[]struct {
            export_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_detail: ?[]const u8 = null,
            s3_bucket: ?[]const u8 = null,
            start_time: ?i64 = null,
            stop_time: ?i64 = null,
            data_source: ?[]const u8 = null,
            schema_storage_config: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .export_id = "exportId",
                    .status = "status",
                    .status_detail = "statusDetail",
                    .s3_bucket = "s3Bucket",
                    .start_time = "startTime",
                    .stop_time = "stopTime",
                    .data_source = "dataSource",
                    .schema_storage_config = "schemaStorageConfig",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "schema_storage_config", field_name))
                    return try serializeMap(self.schema_storage_config, self.fieldNameFor("schema_storage_config"), options, out_stream);
                return false;
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .descriptions = "descriptions",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        OperationNotPermitted,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const describe_export_configurations: struct {
    action_name: []const u8 = "DescribeExportConfigurations",
    Request: type = struct {
        export_ids: ?[][]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_ids = "exportIds",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_export_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_export_configurations };
        }
    },
    Response: type = struct {
        exports_info: ?[]ExportInfo = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .exports_info = "exportsInfo",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const describe_export_tasks: struct {
    action_name: []const u8 = "DescribeExportTasks",
    Request: type = struct {
        export_ids: ?[][]const u8 = null,
        filters: ?[]ExportFilter = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_ids = "exportIds",
                .filters = "filters",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_export_tasks) } {
            return .{ .service_metadata = service_metadata, .action = describe_export_tasks };
        }
    },
    Response: type = struct {
        exports_info: ?[]ExportInfo = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .exports_info = "exportsInfo",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const describe_import_tasks: struct {
    action_name: []const u8 = "DescribeImportTasks",
    Request: type = struct {
        filters: ?[]struct {
            name: ?[]const u8 = null,
            values: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .values = "values",
                };
                return @field(mappings, field_name);
            }
        } = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filters = "filters",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_import_tasks) } {
            return .{ .service_metadata = service_metadata, .action = describe_import_tasks };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        tasks: ?[]ImportTask = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .tasks = "tasks",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const describe_tags: struct {
    action_name: []const u8 = "DescribeTags",
    Request: type = struct {
        filters: ?[]struct {
            name: []const u8,
            values: [][]const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .values = "values",
                };
                return @field(mappings, field_name);
            }
        } = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filters = "filters",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_tags) } {
            return .{ .service_metadata = service_metadata, .action = describe_tags };
        }
    },
    Response: type = struct {
        tags: ?[]struct {
            configuration_type: ?[]const u8 = null,
            configuration_id: ?[]const u8 = null,
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
            time_of_creation: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .configuration_type = "configurationType",
                    .configuration_id = "configurationId",
                    .key = "key",
                    .value = "value",
                    .time_of_creation = "timeOfCreation",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const disassociate_configuration_items_from_application: struct {
    action_name: []const u8 = "DisassociateConfigurationItemsFromApplication",
    Request: type = struct {
        application_configuration_id: []const u8,
        configuration_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_configuration_id = "applicationConfigurationId",
                .configuration_ids = "configurationIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_configuration_items_from_application) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_configuration_items_from_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const export_configurations: struct {
    action_name: []const u8 = "ExportConfigurations",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(export_configurations) } {
            return .{ .service_metadata = service_metadata, .action = export_configurations };
        }
    },
    Response: type = struct {
        export_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_id = "exportId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        OperationNotPermitted,
        ServerInternalError,
    },
} = .{};
pub const get_discovery_summary: struct {
    action_name: []const u8 = "GetDiscoverySummary",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_discovery_summary) } {
            return .{ .service_metadata = service_metadata, .action = get_discovery_summary };
        }
    },
    Response: type = struct {
        servers: ?i64 = null,
        applications: ?i64 = null,
        servers_mapped_to_applications: ?i64 = null,
        servers_mappedto_tags: ?i64 = null,
        agent_summary: ?struct {
            active_agents: i64,
            healthy_agents: i64,
            black_listed_agents: i64,
            shutdown_agents: i64,
            unhealthy_agents: i64,
            total_agents: i64,
            unknown_agents: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .active_agents = "activeAgents",
                    .healthy_agents = "healthyAgents",
                    .black_listed_agents = "blackListedAgents",
                    .shutdown_agents = "shutdownAgents",
                    .unhealthy_agents = "unhealthyAgents",
                    .total_agents = "totalAgents",
                    .unknown_agents = "unknownAgents",
                };
                return @field(mappings, field_name);
            }
        } = null,
        connector_summary: ?struct {
            active_connectors: i64,
            healthy_connectors: i64,
            black_listed_connectors: i64,
            shutdown_connectors: i64,
            unhealthy_connectors: i64,
            total_connectors: i64,
            unknown_connectors: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .active_connectors = "activeConnectors",
                    .healthy_connectors = "healthyConnectors",
                    .black_listed_connectors = "blackListedConnectors",
                    .shutdown_connectors = "shutdownConnectors",
                    .unhealthy_connectors = "unhealthyConnectors",
                    .total_connectors = "totalConnectors",
                    .unknown_connectors = "unknownConnectors",
                };
                return @field(mappings, field_name);
            }
        } = null,
        me_collector_summary: ?struct {
            active_me_collectors: i64,
            healthy_me_collectors: i64,
            deny_listed_me_collectors: i64,
            shutdown_me_collectors: i64,
            unhealthy_me_collectors: i64,
            total_me_collectors: i64,
            unknown_me_collectors: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .active_me_collectors = "activeMeCollectors",
                    .healthy_me_collectors = "healthyMeCollectors",
                    .deny_listed_me_collectors = "denyListedMeCollectors",
                    .shutdown_me_collectors = "shutdownMeCollectors",
                    .unhealthy_me_collectors = "unhealthyMeCollectors",
                    .total_me_collectors = "totalMeCollectors",
                    .unknown_me_collectors = "unknownMeCollectors",
                };
                return @field(mappings, field_name);
            }
        } = null,
        agentless_collector_summary: ?struct {
            active_agentless_collectors: i64,
            healthy_agentless_collectors: i64,
            deny_listed_agentless_collectors: i64,
            shutdown_agentless_collectors: i64,
            unhealthy_agentless_collectors: i64,
            total_agentless_collectors: i64,
            unknown_agentless_collectors: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .active_agentless_collectors = "activeAgentlessCollectors",
                    .healthy_agentless_collectors = "healthyAgentlessCollectors",
                    .deny_listed_agentless_collectors = "denyListedAgentlessCollectors",
                    .shutdown_agentless_collectors = "shutdownAgentlessCollectors",
                    .unhealthy_agentless_collectors = "unhealthyAgentlessCollectors",
                    .total_agentless_collectors = "totalAgentlessCollectors",
                    .unknown_agentless_collectors = "unknownAgentlessCollectors",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .servers = "servers",
                .applications = "applications",
                .servers_mapped_to_applications = "serversMappedToApplications",
                .servers_mappedto_tags = "serversMappedtoTags",
                .agent_summary = "agentSummary",
                .connector_summary = "connectorSummary",
                .me_collector_summary = "meCollectorSummary",
                .agentless_collector_summary = "agentlessCollectorSummary",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const list_configurations: struct {
    action_name: []const u8 = "ListConfigurations",
    Request: type = struct {
        configuration_type: []const u8,
        filters: ?[]Filter = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        order_by: ?[]struct {
            field_name: []const u8,
            sort_order: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .field_name = "fieldName",
                    .sort_order = "sortOrder",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_type = "configurationType",
                .filters = "filters",
                .max_results = "maxResults",
                .next_token = "nextToken",
                .order_by = "orderBy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_configurations) } {
            return .{ .service_metadata = service_metadata, .action = list_configurations };
        }
    },
    Response: type = struct {
        configurations: ?[][]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configurations = "configurations",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "configurations", field_name))
                return try serializeMap(self.configurations, self.fieldNameFor("configurations"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const list_server_neighbors: struct {
    action_name: []const u8 = "ListServerNeighbors",
    Request: type = struct {
        configuration_id: []const u8,
        port_information_needed: ?bool = null,
        neighbor_configuration_ids: ?[][]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_id = "configurationId",
                .port_information_needed = "portInformationNeeded",
                .neighbor_configuration_ids = "neighborConfigurationIds",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_server_neighbors) } {
            return .{ .service_metadata = service_metadata, .action = list_server_neighbors };
        }
    },
    Response: type = struct {
        neighbors: []struct {
            source_server_id: []const u8,
            destination_server_id: []const u8,
            destination_port: ?i64 = null,
            transport_protocol: ?[]const u8 = null,
            connections_count: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .source_server_id = "sourceServerId",
                    .destination_server_id = "destinationServerId",
                    .destination_port = "destinationPort",
                    .transport_protocol = "transportProtocol",
                    .connections_count = "connectionsCount",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,
        known_dependency_count: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .neighbors = "neighbors",
                .next_token = "nextToken",
                .known_dependency_count = "knownDependencyCount",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const start_batch_delete_configuration_task: struct {
    action_name: []const u8 = "StartBatchDeleteConfigurationTask",
    Request: type = struct {
        configuration_type: []const u8,
        configuration_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_type = "configurationType",
                .configuration_ids = "configurationIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_batch_delete_configuration_task) } {
            return .{ .service_metadata = service_metadata, .action = start_batch_delete_configuration_task };
        }
    },
    Response: type = struct {
        task_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_id = "taskId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameterValue,
        LimitExceeded,
        OperationNotPermitted,
        ServerInternalError,
    },
} = .{};
pub const start_continuous_export: struct {
    action_name: []const u8 = "StartContinuousExport",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_continuous_export) } {
            return .{ .service_metadata = service_metadata, .action = start_continuous_export };
        }
    },
    Response: type = struct {
        export_id: ?[]const u8 = null,
        s3_bucket: ?[]const u8 = null,
        start_time: ?i64 = null,
        data_source: ?[]const u8 = null,
        schema_storage_config: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_id = "exportId",
                .s3_bucket = "s3Bucket",
                .start_time = "startTime",
                .data_source = "dataSource",
                .schema_storage_config = "schemaStorageConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "schema_storage_config", field_name))
                return try serializeMap(self.schema_storage_config, self.fieldNameFor("schema_storage_config"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        ConflictError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        OperationNotPermitted,
        ResourceInUse,
        ServerInternalError,
    },
} = .{};
pub const start_data_collection_by_agent_ids: struct {
    action_name: []const u8 = "StartDataCollectionByAgentIds",
    Request: type = struct {
        agent_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agent_ids = "agentIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_data_collection_by_agent_ids) } {
            return .{ .service_metadata = service_metadata, .action = start_data_collection_by_agent_ids };
        }
    },
    Response: type = struct {
        agents_configuration_status: ?[]AgentConfigurationStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agents_configuration_status = "agentsConfigurationStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const start_export_task: struct {
    action_name: []const u8 = "StartExportTask",
    Request: type = struct {
        export_data_format: ?[][]const u8 = null,
        filters: ?[]ExportFilter = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        preferences: ?union {
            ec2_recommendations_preferences: ?struct {
                enabled: ?bool = null,
                cpu_performance_metric_basis: ?UsageMetricBasis = null,
                ram_performance_metric_basis: ?UsageMetricBasis = null,
                tenancy: ?[]const u8 = null,
                excluded_instance_types: ?[][]const u8 = null,
                preferred_region: ?[]const u8 = null,
                reserved_instance_options: ?struct {
                    purchasing_option: []const u8,
                    offering_class: []const u8,
                    term_length: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .purchasing_option = "purchasingOption",
                            .offering_class = "offeringClass",
                            .term_length = "termLength",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .enabled = "enabled",
                        .cpu_performance_metric_basis = "cpuPerformanceMetricBasis",
                        .ram_performance_metric_basis = "ramPerformanceMetricBasis",
                        .tenancy = "tenancy",
                        .excluded_instance_types = "excludedInstanceTypes",
                        .preferred_region = "preferredRegion",
                        .reserved_instance_options = "reservedInstanceOptions",
                    };
                    return @field(mappings, field_name);
                }
            },

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .ec2_recommendations_preferences = "ec2RecommendationsPreferences",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_data_format = "exportDataFormat",
                .filters = "filters",
                .start_time = "startTime",
                .end_time = "endTime",
                .preferences = "preferences",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_export_task) } {
            return .{ .service_metadata = service_metadata, .action = start_export_task };
        }
    },
    Response: type = struct {
        export_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_id = "exportId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        OperationNotPermitted,
        ServerInternalError,
    },
} = .{};
pub const start_import_task: struct {
    action_name: []const u8 = "StartImportTask",
    Request: type = struct {
        client_request_token: ?[]const u8 = null,
        name: []const u8,
        import_url: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .client_request_token = "clientRequestToken",
                .name = "name",
                .import_url = "importUrl",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_import_task) } {
            return .{ .service_metadata = service_metadata, .action = start_import_task };
        }
    },
    Response: type = struct {
        task: ?ImportTask = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task = "task",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ResourceInUse,
        ServerInternalError,
    },
} = .{};
pub const stop_continuous_export: struct {
    action_name: []const u8 = "StopContinuousExport",
    Request: type = struct {
        export_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_id = "exportId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_continuous_export) } {
            return .{ .service_metadata = service_metadata, .action = stop_continuous_export };
        }
    },
    Response: type = struct {
        start_time: ?i64 = null,
        stop_time: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .start_time = "startTime",
                .stop_time = "stopTime",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        OperationNotPermitted,
        ResourceInUse,
        ResourceNotFound,
        ServerInternalError,
    },
} = .{};
pub const stop_data_collection_by_agent_ids: struct {
    action_name: []const u8 = "StopDataCollectionByAgentIds",
    Request: type = struct {
        agent_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agent_ids = "agentIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_data_collection_by_agent_ids) } {
            return .{ .service_metadata = service_metadata, .action = stop_data_collection_by_agent_ids };
        }
    },
    Response: type = struct {
        agents_configuration_status: ?[]AgentConfigurationStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agents_configuration_status = "agentsConfigurationStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};
pub const update_application: struct {
    action_name: []const u8 = "UpdateApplication",
    Request: type = struct {
        configuration_id: []const u8,
        name: ?[]const u8 = null,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_id = "configurationId",
                .name = "name",
                .description = "description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application) } {
            return .{ .service_metadata = service_metadata, .action = update_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AuthorizationError,
        HomeRegionNotSet,
        InvalidParameter,
        InvalidParameterValue,
        ServerInternalError,
    },
} = .{};

pub const AgentConfigurationStatus = struct {
    agent_id: ?[]const u8 = null,
    operation_succeeded: ?bool = null,
    description: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .agent_id = "agentId",
            .operation_succeeded = "operationSucceeded",
            .description = "description",
        };
        return @field(mappings, field_name);
    }
};

pub const ImportTask = struct {
    import_task_id: ?[]const u8 = null,
    client_request_token: ?[]const u8 = null,
    name: ?[]const u8 = null,
    import_url: ?[]const u8 = null,
    status: ?[]const u8 = null,
    import_request_time: ?i64 = null,
    import_completion_time: ?i64 = null,
    import_deleted_time: ?i64 = null,
    server_import_success: ?i64 = null,
    server_import_failure: ?i64 = null,
    application_import_success: ?i64 = null,
    application_import_failure: ?i64 = null,
    errors_and_failed_entries_zip: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .import_task_id = "importTaskId",
            .client_request_token = "clientRequestToken",
            .name = "name",
            .import_url = "importUrl",
            .status = "status",
            .import_request_time = "importRequestTime",
            .import_completion_time = "importCompletionTime",
            .import_deleted_time = "importDeletedTime",
            .server_import_success = "serverImportSuccess",
            .server_import_failure = "serverImportFailure",
            .application_import_success = "applicationImportSuccess",
            .application_import_failure = "applicationImportFailure",
            .errors_and_failed_entries_zip = "errorsAndFailedEntriesZip",
        };
        return @field(mappings, field_name);
    }
};

pub const UsageMetricBasis = struct {
    name: ?[]const u8 = null,
    percentage_adjust: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .percentage_adjust = "percentageAdjust",
        };
        return @field(mappings, field_name);
    }
};

pub const ExportFilter = struct {
    name: []const u8,
    values: [][]const u8,
    condition: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .values = "values",
            .condition = "condition",
        };
        return @field(mappings, field_name);
    }
};

pub const Filter = struct {
    name: []const u8,
    values: [][]const u8,
    condition: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .values = "values",
            .condition = "condition",
        };
        return @field(mappings, field_name);
    }
};

pub const ExportInfo = struct {
    export_id: []const u8,
    export_status: []const u8,
    status_message: []const u8,
    configurations_download_url: ?[]const u8 = null,
    export_request_time: i64,
    is_truncated: ?bool = null,
    requested_start_time: ?i64 = null,
    requested_end_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .export_id = "exportId",
            .export_status = "exportStatus",
            .status_message = "statusMessage",
            .configurations_download_url = "configurationsDownloadUrl",
            .export_request_time = "exportRequestTime",
            .is_truncated = "isTruncated",
            .requested_start_time = "requestedStartTime",
            .requested_end_time = "requestedEndTime",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "key",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};
