const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2011-01-01";
pub const sdk_id: []const u8 = "Auto Scaling";
pub const arn_namespace: ?[]const u8 = "autoscaling";
pub const endpoint_prefix: []const u8 = "autoscaling";
pub const sigv4_name: []const u8 = "autoscaling";
pub const name: []const u8 = "AutoScaling_2011_01_01";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query;

pub const service_metadata: struct {
    version: []const u8 = "2011-01-01",
    sdk_id: []const u8 = "Auto Scaling",
    arn_namespace: ?[]const u8 = "autoscaling",
    endpoint_prefix: []const u8 = "autoscaling",
    sigv4_name: []const u8 = "autoscaling",
    name: []const u8 = "AutoScaling_2011_01_01",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query,
} = .{};
pub const attach_instances: struct {
    action_name: []const u8 = "AttachInstances",
    Request: type = struct {
        instance_ids: ?[][]const u8 = null,
        auto_scaling_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_instances) } {
            return .{ .service_metadata = service_metadata, .action = attach_instances };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const attach_load_balancers: struct {
    action_name: []const u8 = "AttachLoadBalancers",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        load_balancer_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .load_balancer_names = "LoadBalancerNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_load_balancers) } {
            return .{ .service_metadata = service_metadata, .action = attach_load_balancers };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const attach_load_balancer_target_groups: struct {
    action_name: []const u8 = "AttachLoadBalancerTargetGroups",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        target_group_ar_ns: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .target_group_ar_ns = "TargetGroupARNs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_load_balancer_target_groups) } {
            return .{ .service_metadata = service_metadata, .action = attach_load_balancer_target_groups };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const attach_traffic_sources: struct {
    action_name: []const u8 = "AttachTrafficSources",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        traffic_sources: []TrafficSourceIdentifier,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .traffic_sources = "TrafficSources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_traffic_sources) } {
            return .{ .service_metadata = service_metadata, .action = attach_traffic_sources };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const batch_delete_scheduled_action: struct {
    action_name: []const u8 = "BatchDeleteScheduledAction",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scheduled_action_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scheduled_action_names = "ScheduledActionNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_delete_scheduled_action) } {
            return .{ .service_metadata = service_metadata, .action = batch_delete_scheduled_action };
        }
    },
    Response: type = struct {
        failed_scheduled_actions: ?[]FailedScheduledUpdateGroupActionRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failed_scheduled_actions = "FailedScheduledActions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const batch_put_scheduled_update_group_action: struct {
    action_name: []const u8 = "BatchPutScheduledUpdateGroupAction",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scheduled_update_group_actions: []struct {
            scheduled_action_name: []const u8,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            recurrence: ?[]const u8 = null,
            min_size: ?i64 = null,
            max_size: ?i64 = null,
            desired_capacity: ?i64 = null,
            time_zone: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .scheduled_action_name = "ScheduledActionName",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .recurrence = "Recurrence",
                    .min_size = "MinSize",
                    .max_size = "MaxSize",
                    .desired_capacity = "DesiredCapacity",
                    .time_zone = "TimeZone",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scheduled_update_group_actions = "ScheduledUpdateGroupActions",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_put_scheduled_update_group_action) } {
            return .{ .service_metadata = service_metadata, .action = batch_put_scheduled_update_group_action };
        }
    },
    Response: type = struct {
        failed_scheduled_update_group_actions: ?[]FailedScheduledUpdateGroupActionRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failed_scheduled_update_group_actions = "FailedScheduledUpdateGroupActions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const cancel_instance_refresh: struct {
    action_name: []const u8 = "CancelInstanceRefresh",
    Request: type = struct {
        auto_scaling_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_instance_refresh) } {
            return .{ .service_metadata = service_metadata, .action = cancel_instance_refresh };
        }
    },
    Response: type = struct {
        instance_refresh_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_refresh_id = "InstanceRefreshId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ActiveInstanceRefreshNotFound,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const complete_lifecycle_action: struct {
    action_name: []const u8 = "CompleteLifecycleAction",
    Request: type = struct {
        lifecycle_hook_name: []const u8,
        auto_scaling_group_name: []const u8,
        lifecycle_action_token: ?[]const u8 = null,
        lifecycle_action_result: []const u8,
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hook_name = "LifecycleHookName",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .lifecycle_action_token = "LifecycleActionToken",
                .lifecycle_action_result = "LifecycleActionResult",
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(complete_lifecycle_action) } {
            return .{ .service_metadata = service_metadata, .action = complete_lifecycle_action };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const create_auto_scaling_group: struct {
    action_name: []const u8 = "CreateAutoScalingGroup",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        launch_configuration_name: ?[]const u8 = null,
        launch_template: ?LaunchTemplateSpecification = null,
        mixed_instances_policy: ?MixedInstancesPolicy = null,
        instance_id: ?[]const u8 = null,
        min_size: i64,
        max_size: i64,
        desired_capacity: ?i64 = null,
        default_cooldown: ?i64 = null,
        availability_zones: ?[][]const u8 = null,
        load_balancer_names: ?[][]const u8 = null,
        target_group_ar_ns: ?[][]const u8 = null,
        health_check_type: ?[]const u8 = null,
        health_check_grace_period: ?i64 = null,
        placement_group: ?[]const u8 = null,
        vpc_zone_identifier: ?[]const u8 = null,
        termination_policies: ?[][]const u8 = null,
        new_instances_protected_from_scale_in: ?bool = null,
        capacity_rebalance: ?bool = null,
        lifecycle_hook_specification_list: ?[]struct {
            lifecycle_hook_name: []const u8,
            lifecycle_transition: []const u8,
            notification_metadata: ?[]const u8 = null,
            heartbeat_timeout: ?i64 = null,
            default_result: ?[]const u8 = null,
            notification_target_arn: ?[]const u8 = null,
            role_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .lifecycle_hook_name = "LifecycleHookName",
                    .lifecycle_transition = "LifecycleTransition",
                    .notification_metadata = "NotificationMetadata",
                    .heartbeat_timeout = "HeartbeatTimeout",
                    .default_result = "DefaultResult",
                    .notification_target_arn = "NotificationTargetARN",
                    .role_arn = "RoleARN",
                };
                return @field(mappings, field_name);
            }
        } = null,
        tags: ?[]Tag = null,
        service_linked_role_arn: ?[]const u8 = null,
        max_instance_lifetime: ?i64 = null,
        context: ?[]const u8 = null,
        desired_capacity_type: ?[]const u8 = null,
        default_instance_warmup: ?i64 = null,
        traffic_sources: ?[]TrafficSourceIdentifier = null,
        instance_maintenance_policy: ?InstanceMaintenancePolicy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .launch_configuration_name = "LaunchConfigurationName",
                .launch_template = "LaunchTemplate",
                .mixed_instances_policy = "MixedInstancesPolicy",
                .instance_id = "InstanceId",
                .min_size = "MinSize",
                .max_size = "MaxSize",
                .desired_capacity = "DesiredCapacity",
                .default_cooldown = "DefaultCooldown",
                .availability_zones = "AvailabilityZones",
                .load_balancer_names = "LoadBalancerNames",
                .target_group_ar_ns = "TargetGroupARNs",
                .health_check_type = "HealthCheckType",
                .health_check_grace_period = "HealthCheckGracePeriod",
                .placement_group = "PlacementGroup",
                .vpc_zone_identifier = "VPCZoneIdentifier",
                .termination_policies = "TerminationPolicies",
                .new_instances_protected_from_scale_in = "NewInstancesProtectedFromScaleIn",
                .capacity_rebalance = "CapacityRebalance",
                .lifecycle_hook_specification_list = "LifecycleHookSpecificationList",
                .tags = "Tags",
                .service_linked_role_arn = "ServiceLinkedRoleARN",
                .max_instance_lifetime = "MaxInstanceLifetime",
                .context = "Context",
                .desired_capacity_type = "DesiredCapacityType",
                .default_instance_warmup = "DefaultInstanceWarmup",
                .traffic_sources = "TrafficSources",
                .instance_maintenance_policy = "InstanceMaintenancePolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_auto_scaling_group) } {
            return .{ .service_metadata = service_metadata, .action = create_auto_scaling_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const create_launch_configuration: struct {
    action_name: []const u8 = "CreateLaunchConfiguration",
    Request: type = struct {
        launch_configuration_name: []const u8,
        image_id: ?[]const u8 = null,
        key_name: ?[]const u8 = null,
        security_groups: ?[][]const u8 = null,
        classic_link_vpc_id: ?[]const u8 = null,
        classic_link_vpc_security_groups: ?[][]const u8 = null,
        user_data: ?[]const u8 = null,
        instance_id: ?[]const u8 = null,
        instance_type: ?[]const u8 = null,
        kernel_id: ?[]const u8 = null,
        ramdisk_id: ?[]const u8 = null,
        block_device_mappings: ?[]BlockDeviceMapping = null,
        instance_monitoring: ?InstanceMonitoring = null,
        spot_price: ?[]const u8 = null,
        iam_instance_profile: ?[]const u8 = null,
        ebs_optimized: ?bool = null,
        associate_public_ip_address: ?bool = null,
        placement_tenancy: ?[]const u8 = null,
        metadata_options: ?InstanceMetadataOptions = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .launch_configuration_name = "LaunchConfigurationName",
                .image_id = "ImageId",
                .key_name = "KeyName",
                .security_groups = "SecurityGroups",
                .classic_link_vpc_id = "ClassicLinkVPCId",
                .classic_link_vpc_security_groups = "ClassicLinkVPCSecurityGroups",
                .user_data = "UserData",
                .instance_id = "InstanceId",
                .instance_type = "InstanceType",
                .kernel_id = "KernelId",
                .ramdisk_id = "RamdiskId",
                .block_device_mappings = "BlockDeviceMappings",
                .instance_monitoring = "InstanceMonitoring",
                .spot_price = "SpotPrice",
                .iam_instance_profile = "IamInstanceProfile",
                .ebs_optimized = "EbsOptimized",
                .associate_public_ip_address = "AssociatePublicIpAddress",
                .placement_tenancy = "PlacementTenancy",
                .metadata_options = "MetadataOptions",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_launch_configuration) } {
            return .{ .service_metadata = service_metadata, .action = create_launch_configuration };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const create_or_update_tags: struct {
    action_name: []const u8 = "CreateOrUpdateTags",
    Request: type = struct {
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_or_update_tags) } {
            return .{ .service_metadata = service_metadata, .action = create_or_update_tags };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
        ResourceContention,
        ResourceInUse,
    },
} = .{};
pub const delete_auto_scaling_group: struct {
    action_name: []const u8 = "DeleteAutoScalingGroup",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        force_delete: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .force_delete = "ForceDelete",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_auto_scaling_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_auto_scaling_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ResourceInUse,
        ScalingActivityInProgress,
    },
} = .{};
pub const delete_launch_configuration: struct {
    action_name: []const u8 = "DeleteLaunchConfiguration",
    Request: type = struct {
        launch_configuration_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .launch_configuration_name = "LaunchConfigurationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_launch_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_launch_configuration };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ResourceInUse,
    },
} = .{};
pub const delete_lifecycle_hook: struct {
    action_name: []const u8 = "DeleteLifecycleHook",
    Request: type = struct {
        lifecycle_hook_name: []const u8,
        auto_scaling_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hook_name = "LifecycleHookName",
                .auto_scaling_group_name = "AutoScalingGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_lifecycle_hook) } {
            return .{ .service_metadata = service_metadata, .action = delete_lifecycle_hook };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const delete_notification_configuration: struct {
    action_name: []const u8 = "DeleteNotificationConfiguration",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        topic_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .topic_arn = "TopicARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_notification_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_notification_configuration };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const delete_policy: struct {
    action_name: []const u8 = "DeletePolicy",
    Request: type = struct {
        auto_scaling_group_name: ?[]const u8 = null,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const delete_scheduled_action: struct {
    action_name: []const u8 = "DeleteScheduledAction",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scheduled_action_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scheduled_action_name = "ScheduledActionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_scheduled_action) } {
            return .{ .service_metadata = service_metadata, .action = delete_scheduled_action };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const delete_tags: struct {
    action_name: []const u8 = "DeleteTags",
    Request: type = struct {
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_tags) } {
            return .{ .service_metadata = service_metadata, .action = delete_tags };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ResourceInUse,
    },
} = .{};
pub const delete_warm_pool: struct {
    action_name: []const u8 = "DeleteWarmPool",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        force_delete: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .force_delete = "ForceDelete",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_warm_pool) } {
            return .{ .service_metadata = service_metadata, .action = delete_warm_pool };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
        ResourceInUse,
        ScalingActivityInProgress,
    },
} = .{};
pub const describe_account_limits: struct {
    action_name: []const u8 = "DescribeAccountLimits",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_account_limits) } {
            return .{ .service_metadata = service_metadata, .action = describe_account_limits };
        }
    },
    Response: type = struct {
        max_number_of_auto_scaling_groups: ?i64 = null,
        max_number_of_launch_configurations: ?i64 = null,
        number_of_auto_scaling_groups: ?i64 = null,
        number_of_launch_configurations: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_number_of_auto_scaling_groups = "MaxNumberOfAutoScalingGroups",
                .max_number_of_launch_configurations = "MaxNumberOfLaunchConfigurations",
                .number_of_auto_scaling_groups = "NumberOfAutoScalingGroups",
                .number_of_launch_configurations = "NumberOfLaunchConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_adjustment_types: struct {
    action_name: []const u8 = "DescribeAdjustmentTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_adjustment_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_adjustment_types };
        }
    },
    Response: type = struct {
        adjustment_types: ?[]struct {
            adjustment_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .adjustment_type = "AdjustmentType",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .adjustment_types = "AdjustmentTypes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_auto_scaling_groups: struct {
    action_name: []const u8 = "DescribeAutoScalingGroups",
    Request: type = struct {
        auto_scaling_group_names: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,
        filters: ?[]Filter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_names = "AutoScalingGroupNames",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_auto_scaling_groups) } {
            return .{ .service_metadata = service_metadata, .action = describe_auto_scaling_groups };
        }
    },
    Response: type = struct {
        auto_scaling_groups: []struct {
            auto_scaling_group_name: []const u8,
            auto_scaling_group_arn: ?[]const u8 = null,
            launch_configuration_name: ?[]const u8 = null,
            launch_template: ?LaunchTemplateSpecification = null,
            mixed_instances_policy: ?MixedInstancesPolicy = null,
            min_size: i64,
            max_size: i64,
            desired_capacity: i64,
            predicted_capacity: ?i64 = null,
            default_cooldown: i64,
            availability_zones: [][]const u8,
            load_balancer_names: ?[][]const u8 = null,
            target_group_ar_ns: ?[][]const u8 = null,
            health_check_type: []const u8,
            health_check_grace_period: ?i64 = null,
            instances: ?[]Instance = null,
            created_time: i64,
            suspended_processes: ?[]struct {
                process_name: ?[]const u8 = null,
                suspension_reason: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .process_name = "ProcessName",
                        .suspension_reason = "SuspensionReason",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            placement_group: ?[]const u8 = null,
            vpc_zone_identifier: ?[]const u8 = null,
            enabled_metrics: ?[]struct {
                metric: ?[]const u8 = null,
                granularity: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .metric = "Metric",
                        .granularity = "Granularity",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            status: ?[]const u8 = null,
            tags: ?[]TagDescription = null,
            termination_policies: ?[][]const u8 = null,
            new_instances_protected_from_scale_in: ?bool = null,
            service_linked_role_arn: ?[]const u8 = null,
            max_instance_lifetime: ?i64 = null,
            capacity_rebalance: ?bool = null,
            warm_pool_configuration: ?WarmPoolConfiguration = null,
            warm_pool_size: ?i64 = null,
            context: ?[]const u8 = null,
            desired_capacity_type: ?[]const u8 = null,
            default_instance_warmup: ?i64 = null,
            traffic_sources: ?[]TrafficSourceIdentifier = null,
            instance_maintenance_policy: ?InstanceMaintenancePolicy = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .auto_scaling_group_arn = "AutoScalingGroupARN",
                    .launch_configuration_name = "LaunchConfigurationName",
                    .launch_template = "LaunchTemplate",
                    .mixed_instances_policy = "MixedInstancesPolicy",
                    .min_size = "MinSize",
                    .max_size = "MaxSize",
                    .desired_capacity = "DesiredCapacity",
                    .predicted_capacity = "PredictedCapacity",
                    .default_cooldown = "DefaultCooldown",
                    .availability_zones = "AvailabilityZones",
                    .load_balancer_names = "LoadBalancerNames",
                    .target_group_ar_ns = "TargetGroupARNs",
                    .health_check_type = "HealthCheckType",
                    .health_check_grace_period = "HealthCheckGracePeriod",
                    .instances = "Instances",
                    .created_time = "CreatedTime",
                    .suspended_processes = "SuspendedProcesses",
                    .placement_group = "PlacementGroup",
                    .vpc_zone_identifier = "VPCZoneIdentifier",
                    .enabled_metrics = "EnabledMetrics",
                    .status = "Status",
                    .tags = "Tags",
                    .termination_policies = "TerminationPolicies",
                    .new_instances_protected_from_scale_in = "NewInstancesProtectedFromScaleIn",
                    .service_linked_role_arn = "ServiceLinkedRoleARN",
                    .max_instance_lifetime = "MaxInstanceLifetime",
                    .capacity_rebalance = "CapacityRebalance",
                    .warm_pool_configuration = "WarmPoolConfiguration",
                    .warm_pool_size = "WarmPoolSize",
                    .context = "Context",
                    .desired_capacity_type = "DesiredCapacityType",
                    .default_instance_warmup = "DefaultInstanceWarmup",
                    .traffic_sources = "TrafficSources",
                    .instance_maintenance_policy = "InstanceMaintenancePolicy",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_groups = "AutoScalingGroups",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_auto_scaling_instances: struct {
    action_name: []const u8 = "DescribeAutoScalingInstances",
    Request: type = struct {
        instance_ids: ?[][]const u8 = null,
        max_records: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .max_records = "MaxRecords",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_auto_scaling_instances) } {
            return .{ .service_metadata = service_metadata, .action = describe_auto_scaling_instances };
        }
    },
    Response: type = struct {
        auto_scaling_instances: ?[]struct {
            instance_id: []const u8,
            instance_type: ?[]const u8 = null,
            auto_scaling_group_name: []const u8,
            availability_zone: []const u8,
            lifecycle_state: []const u8,
            health_status: []const u8,
            launch_configuration_name: ?[]const u8 = null,
            launch_template: ?LaunchTemplateSpecification = null,
            protected_from_scale_in: bool,
            weighted_capacity: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .instance_id = "InstanceId",
                    .instance_type = "InstanceType",
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .availability_zone = "AvailabilityZone",
                    .lifecycle_state = "LifecycleState",
                    .health_status = "HealthStatus",
                    .launch_configuration_name = "LaunchConfigurationName",
                    .launch_template = "LaunchTemplate",
                    .protected_from_scale_in = "ProtectedFromScaleIn",
                    .weighted_capacity = "WeightedCapacity",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_instances = "AutoScalingInstances",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_auto_scaling_notification_types: struct {
    action_name: []const u8 = "DescribeAutoScalingNotificationTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_auto_scaling_notification_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_auto_scaling_notification_types };
        }
    },
    Response: type = struct {
        auto_scaling_notification_types: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_notification_types = "AutoScalingNotificationTypes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_instance_refreshes: struct {
    action_name: []const u8 = "DescribeInstanceRefreshes",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        instance_refresh_ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .instance_refresh_ids = "InstanceRefreshIds",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_instance_refreshes) } {
            return .{ .service_metadata = service_metadata, .action = describe_instance_refreshes };
        }
    },
    Response: type = struct {
        instance_refreshes: ?[]struct {
            instance_refresh_id: ?[]const u8 = null,
            auto_scaling_group_name: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            percentage_complete: ?i64 = null,
            instances_to_update: ?i64 = null,
            progress_details: ?InstanceRefreshProgressDetails = null,
            preferences: ?RefreshPreferences = null,
            desired_configuration: ?DesiredConfiguration = null,
            rollback_details: ?struct {
                rollback_reason: ?[]const u8 = null,
                rollback_start_time: ?i64 = null,
                percentage_complete_on_rollback: ?i64 = null,
                instances_to_update_on_rollback: ?i64 = null,
                progress_details_on_rollback: ?InstanceRefreshProgressDetails = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .rollback_reason = "RollbackReason",
                        .rollback_start_time = "RollbackStartTime",
                        .percentage_complete_on_rollback = "PercentageCompleteOnRollback",
                        .instances_to_update_on_rollback = "InstancesToUpdateOnRollback",
                        .progress_details_on_rollback = "ProgressDetailsOnRollback",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .instance_refresh_id = "InstanceRefreshId",
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .percentage_complete = "PercentageComplete",
                    .instances_to_update = "InstancesToUpdate",
                    .progress_details = "ProgressDetails",
                    .preferences = "Preferences",
                    .desired_configuration = "DesiredConfiguration",
                    .rollback_details = "RollbackDetails",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_refreshes = "InstanceRefreshes",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_launch_configurations: struct {
    action_name: []const u8 = "DescribeLaunchConfigurations",
    Request: type = struct {
        launch_configuration_names: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .launch_configuration_names = "LaunchConfigurationNames",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_launch_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_launch_configurations };
        }
    },
    Response: type = struct {
        launch_configurations: []struct {
            launch_configuration_name: []const u8,
            launch_configuration_arn: ?[]const u8 = null,
            image_id: []const u8,
            key_name: ?[]const u8 = null,
            security_groups: ?[][]const u8 = null,
            classic_link_vpc_id: ?[]const u8 = null,
            classic_link_vpc_security_groups: ?[][]const u8 = null,
            user_data: ?[]const u8 = null,
            instance_type: []const u8,
            kernel_id: ?[]const u8 = null,
            ramdisk_id: ?[]const u8 = null,
            block_device_mappings: ?[]BlockDeviceMapping = null,
            instance_monitoring: ?InstanceMonitoring = null,
            spot_price: ?[]const u8 = null,
            iam_instance_profile: ?[]const u8 = null,
            created_time: i64,
            ebs_optimized: ?bool = null,
            associate_public_ip_address: ?bool = null,
            placement_tenancy: ?[]const u8 = null,
            metadata_options: ?InstanceMetadataOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .launch_configuration_name = "LaunchConfigurationName",
                    .launch_configuration_arn = "LaunchConfigurationARN",
                    .image_id = "ImageId",
                    .key_name = "KeyName",
                    .security_groups = "SecurityGroups",
                    .classic_link_vpc_id = "ClassicLinkVPCId",
                    .classic_link_vpc_security_groups = "ClassicLinkVPCSecurityGroups",
                    .user_data = "UserData",
                    .instance_type = "InstanceType",
                    .kernel_id = "KernelId",
                    .ramdisk_id = "RamdiskId",
                    .block_device_mappings = "BlockDeviceMappings",
                    .instance_monitoring = "InstanceMonitoring",
                    .spot_price = "SpotPrice",
                    .iam_instance_profile = "IamInstanceProfile",
                    .created_time = "CreatedTime",
                    .ebs_optimized = "EbsOptimized",
                    .associate_public_ip_address = "AssociatePublicIpAddress",
                    .placement_tenancy = "PlacementTenancy",
                    .metadata_options = "MetadataOptions",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .launch_configurations = "LaunchConfigurations",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_lifecycle_hooks: struct {
    action_name: []const u8 = "DescribeLifecycleHooks",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        lifecycle_hook_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .lifecycle_hook_names = "LifecycleHookNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_lifecycle_hooks) } {
            return .{ .service_metadata = service_metadata, .action = describe_lifecycle_hooks };
        }
    },
    Response: type = struct {
        lifecycle_hooks: ?[]struct {
            lifecycle_hook_name: ?[]const u8 = null,
            auto_scaling_group_name: ?[]const u8 = null,
            lifecycle_transition: ?[]const u8 = null,
            notification_target_arn: ?[]const u8 = null,
            role_arn: ?[]const u8 = null,
            notification_metadata: ?[]const u8 = null,
            heartbeat_timeout: ?i64 = null,
            global_timeout: ?i64 = null,
            default_result: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .lifecycle_hook_name = "LifecycleHookName",
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .lifecycle_transition = "LifecycleTransition",
                    .notification_target_arn = "NotificationTargetARN",
                    .role_arn = "RoleARN",
                    .notification_metadata = "NotificationMetadata",
                    .heartbeat_timeout = "HeartbeatTimeout",
                    .global_timeout = "GlobalTimeout",
                    .default_result = "DefaultResult",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hooks = "LifecycleHooks",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_lifecycle_hook_types: struct {
    action_name: []const u8 = "DescribeLifecycleHookTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_lifecycle_hook_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_lifecycle_hook_types };
        }
    },
    Response: type = struct {
        lifecycle_hook_types: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hook_types = "LifecycleHookTypes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_load_balancers: struct {
    action_name: []const u8 = "DescribeLoadBalancers",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_load_balancers) } {
            return .{ .service_metadata = service_metadata, .action = describe_load_balancers };
        }
    },
    Response: type = struct {
        load_balancers: ?[]struct {
            load_balancer_name: ?[]const u8 = null,
            state: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .load_balancer_name = "LoadBalancerName",
                    .state = "State",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancers = "LoadBalancers",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_load_balancer_target_groups: struct {
    action_name: []const u8 = "DescribeLoadBalancerTargetGroups",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_load_balancer_target_groups) } {
            return .{ .service_metadata = service_metadata, .action = describe_load_balancer_target_groups };
        }
    },
    Response: type = struct {
        load_balancer_target_groups: ?[]struct {
            load_balancer_target_group_arn: ?[]const u8 = null,
            state: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .load_balancer_target_group_arn = "LoadBalancerTargetGroupARN",
                    .state = "State",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_target_groups = "LoadBalancerTargetGroups",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_metric_collection_types: struct {
    action_name: []const u8 = "DescribeMetricCollectionTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_metric_collection_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_metric_collection_types };
        }
    },
    Response: type = struct {
        metrics: ?[]struct {
            metric: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .metric = "Metric",
                };
                return @field(mappings, field_name);
            }
        } = null,
        granularities: ?[]struct {
            granularity: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .granularity = "Granularity",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metrics = "Metrics",
                .granularities = "Granularities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_notification_configurations: struct {
    action_name: []const u8 = "DescribeNotificationConfigurations",
    Request: type = struct {
        auto_scaling_group_names: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_names = "AutoScalingGroupNames",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_notification_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_notification_configurations };
        }
    },
    Response: type = struct {
        notification_configurations: []struct {
            auto_scaling_group_name: ?[]const u8 = null,
            topic_arn: ?[]const u8 = null,
            notification_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .topic_arn = "TopicARN",
                    .notification_type = "NotificationType",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .notification_configurations = "NotificationConfigurations",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_policies: struct {
    action_name: []const u8 = "DescribePolicies",
    Request: type = struct {
        auto_scaling_group_name: ?[]const u8 = null,
        policy_names: ?[][]const u8 = null,
        policy_types: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .policy_names = "PolicyNames",
                .policy_types = "PolicyTypes",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_policies) } {
            return .{ .service_metadata = service_metadata, .action = describe_policies };
        }
    },
    Response: type = struct {
        scaling_policies: ?[]struct {
            auto_scaling_group_name: ?[]const u8 = null,
            policy_name: ?[]const u8 = null,
            policy_arn: ?[]const u8 = null,
            policy_type: ?[]const u8 = null,
            adjustment_type: ?[]const u8 = null,
            min_adjustment_step: ?i64 = null,
            min_adjustment_magnitude: ?i64 = null,
            scaling_adjustment: ?i64 = null,
            cooldown: ?i64 = null,
            step_adjustments: ?[]StepAdjustment = null,
            metric_aggregation_type: ?[]const u8 = null,
            estimated_instance_warmup: ?i64 = null,
            alarms: ?[]Alarm = null,
            target_tracking_configuration: ?TargetTrackingConfiguration = null,
            enabled: ?bool = null,
            predictive_scaling_configuration: ?PredictiveScalingConfiguration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .policy_name = "PolicyName",
                    .policy_arn = "PolicyARN",
                    .policy_type = "PolicyType",
                    .adjustment_type = "AdjustmentType",
                    .min_adjustment_step = "MinAdjustmentStep",
                    .min_adjustment_magnitude = "MinAdjustmentMagnitude",
                    .scaling_adjustment = "ScalingAdjustment",
                    .cooldown = "Cooldown",
                    .step_adjustments = "StepAdjustments",
                    .metric_aggregation_type = "MetricAggregationType",
                    .estimated_instance_warmup = "EstimatedInstanceWarmup",
                    .alarms = "Alarms",
                    .target_tracking_configuration = "TargetTrackingConfiguration",
                    .enabled = "Enabled",
                    .predictive_scaling_configuration = "PredictiveScalingConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .scaling_policies = "ScalingPolicies",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const describe_scaling_activities: struct {
    action_name: []const u8 = "DescribeScalingActivities",
    Request: type = struct {
        activity_ids: ?[][]const u8 = null,
        auto_scaling_group_name: ?[]const u8 = null,
        include_deleted_groups: ?bool = null,
        max_records: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activity_ids = "ActivityIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .include_deleted_groups = "IncludeDeletedGroups",
                .max_records = "MaxRecords",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_scaling_activities) } {
            return .{ .service_metadata = service_metadata, .action = describe_scaling_activities };
        }
    },
    Response: type = struct {
        activities: []Activity,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activities = "Activities",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_scaling_process_types: struct {
    action_name: []const u8 = "DescribeScalingProcessTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_scaling_process_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_scaling_process_types };
        }
    },
    Response: type = struct {
        processes: ?[]struct {
            process_name: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .process_name = "ProcessName",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .processes = "Processes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_scheduled_actions: struct {
    action_name: []const u8 = "DescribeScheduledActions",
    Request: type = struct {
        auto_scaling_group_name: ?[]const u8 = null,
        scheduled_action_names: ?[][]const u8 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scheduled_action_names = "ScheduledActionNames",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_scheduled_actions) } {
            return .{ .service_metadata = service_metadata, .action = describe_scheduled_actions };
        }
    },
    Response: type = struct {
        scheduled_update_group_actions: ?[]struct {
            auto_scaling_group_name: ?[]const u8 = null,
            scheduled_action_name: ?[]const u8 = null,
            scheduled_action_arn: ?[]const u8 = null,
            time: ?i64 = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            recurrence: ?[]const u8 = null,
            min_size: ?i64 = null,
            max_size: ?i64 = null,
            desired_capacity: ?i64 = null,
            time_zone: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .auto_scaling_group_name = "AutoScalingGroupName",
                    .scheduled_action_name = "ScheduledActionName",
                    .scheduled_action_arn = "ScheduledActionARN",
                    .time = "Time",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .recurrence = "Recurrence",
                    .min_size = "MinSize",
                    .max_size = "MaxSize",
                    .desired_capacity = "DesiredCapacity",
                    .time_zone = "TimeZone",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .scheduled_update_group_actions = "ScheduledUpdateGroupActions",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_tags: struct {
    action_name: []const u8 = "DescribeTags",
    Request: type = struct {
        filters: ?[]Filter = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filters = "Filters",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_tags) } {
            return .{ .service_metadata = service_metadata, .action = describe_tags };
        }
    },
    Response: type = struct {
        tags: ?[]TagDescription = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_termination_policy_types: struct {
    action_name: []const u8 = "DescribeTerminationPolicyTypes",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_termination_policy_types) } {
            return .{ .service_metadata = service_metadata, .action = describe_termination_policy_types };
        }
    },
    Response: type = struct {
        termination_policy_types: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .termination_policy_types = "TerminationPolicyTypes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const describe_traffic_sources: struct {
    action_name: []const u8 = "DescribeTrafficSources",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        traffic_source_type: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_records: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .traffic_source_type = "TrafficSourceType",
                .next_token = "NextToken",
                .max_records = "MaxRecords",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_traffic_sources) } {
            return .{ .service_metadata = service_metadata, .action = describe_traffic_sources };
        }
    },
    Response: type = struct {
        traffic_sources: ?[]struct {
            traffic_source: ?[]const u8 = null,
            state: ?[]const u8 = null,
            identifier: ?[]const u8 = null,
            type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .traffic_source = "TrafficSource",
                    .state = "State",
                    .identifier = "Identifier",
                    .type = "Type",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .traffic_sources = "TrafficSources",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        ResourceContention,
    },
} = .{};
pub const describe_warm_pool: struct {
    action_name: []const u8 = "DescribeWarmPool",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        max_records: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .max_records = "MaxRecords",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_warm_pool) } {
            return .{ .service_metadata = service_metadata, .action = describe_warm_pool };
        }
    },
    Response: type = struct {
        warm_pool_configuration: ?WarmPoolConfiguration = null,
        instances: ?[]Instance = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .warm_pool_configuration = "WarmPoolConfiguration",
                .instances = "Instances",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const detach_instances: struct {
    action_name: []const u8 = "DetachInstances",
    Request: type = struct {
        instance_ids: ?[][]const u8 = null,
        auto_scaling_group_name: []const u8,
        should_decrement_desired_capacity: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .should_decrement_desired_capacity = "ShouldDecrementDesiredCapacity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_instances) } {
            return .{ .service_metadata = service_metadata, .action = detach_instances };
        }
    },
    Response: type = struct {
        activities: ?[]Activity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activities = "Activities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const detach_load_balancers: struct {
    action_name: []const u8 = "DetachLoadBalancers",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        load_balancer_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .load_balancer_names = "LoadBalancerNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_load_balancers) } {
            return .{ .service_metadata = service_metadata, .action = detach_load_balancers };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const detach_load_balancer_target_groups: struct {
    action_name: []const u8 = "DetachLoadBalancerTargetGroups",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        target_group_ar_ns: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .target_group_ar_ns = "TargetGroupARNs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_load_balancer_target_groups) } {
            return .{ .service_metadata = service_metadata, .action = detach_load_balancer_target_groups };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const detach_traffic_sources: struct {
    action_name: []const u8 = "DetachTrafficSources",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        traffic_sources: []TrafficSourceIdentifier,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .traffic_sources = "TrafficSources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_traffic_sources) } {
            return .{ .service_metadata = service_metadata, .action = detach_traffic_sources };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const disable_metrics_collection: struct {
    action_name: []const u8 = "DisableMetricsCollection",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        metrics: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .metrics = "Metrics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_metrics_collection) } {
            return .{ .service_metadata = service_metadata, .action = disable_metrics_collection };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const enable_metrics_collection: struct {
    action_name: []const u8 = "EnableMetricsCollection",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        metrics: ?[][]const u8 = null,
        granularity: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .metrics = "Metrics",
                .granularity = "Granularity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_metrics_collection) } {
            return .{ .service_metadata = service_metadata, .action = enable_metrics_collection };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const enter_standby: struct {
    action_name: []const u8 = "EnterStandby",
    Request: type = struct {
        instance_ids: ?[][]const u8 = null,
        auto_scaling_group_name: []const u8,
        should_decrement_desired_capacity: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .should_decrement_desired_capacity = "ShouldDecrementDesiredCapacity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enter_standby) } {
            return .{ .service_metadata = service_metadata, .action = enter_standby };
        }
    },
    Response: type = struct {
        activities: ?[]Activity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activities = "Activities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const execute_policy: struct {
    action_name: []const u8 = "ExecutePolicy",
    Request: type = struct {
        auto_scaling_group_name: ?[]const u8 = null,
        policy_name: []const u8,
        honor_cooldown: ?bool = null,
        metric_value: ?f64 = null,
        breach_threshold: ?f64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .policy_name = "PolicyName",
                .honor_cooldown = "HonorCooldown",
                .metric_value = "MetricValue",
                .breach_threshold = "BreachThreshold",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(execute_policy) } {
            return .{ .service_metadata = service_metadata, .action = execute_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ScalingActivityInProgress,
    },
} = .{};
pub const exit_standby: struct {
    action_name: []const u8 = "ExitStandby",
    Request: type = struct {
        instance_ids: ?[][]const u8 = null,
        auto_scaling_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(exit_standby) } {
            return .{ .service_metadata = service_metadata, .action = exit_standby };
        }
    },
    Response: type = struct {
        activities: ?[]Activity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activities = "Activities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const get_predictive_scaling_forecast: struct {
    action_name: []const u8 = "GetPredictiveScalingForecast",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        policy_name: []const u8,
        start_time: i64,
        end_time: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .policy_name = "PolicyName",
                .start_time = "StartTime",
                .end_time = "EndTime",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_predictive_scaling_forecast) } {
            return .{ .service_metadata = service_metadata, .action = get_predictive_scaling_forecast };
        }
    },
    Response: type = struct {
        load_forecast: []struct {
            timestamps: []i64,
            values: []f64,
            metric_specification: PredictiveScalingMetricSpecification,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamps = "Timestamps",
                    .values = "Values",
                    .metric_specification = "MetricSpecification",
                };
                return @field(mappings, field_name);
            }
        },
        capacity_forecast: struct {
            timestamps: []i64,
            values: []f64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamps = "Timestamps",
                    .values = "Values",
                };
                return @field(mappings, field_name);
            }
        },
        update_time: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_forecast = "LoadForecast",
                .capacity_forecast = "CapacityForecast",
                .update_time = "UpdateTime",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const put_lifecycle_hook: struct {
    action_name: []const u8 = "PutLifecycleHook",
    Request: type = struct {
        lifecycle_hook_name: []const u8,
        auto_scaling_group_name: []const u8,
        lifecycle_transition: ?[]const u8 = null,
        role_arn: ?[]const u8 = null,
        notification_target_arn: ?[]const u8 = null,
        notification_metadata: ?[]const u8 = null,
        heartbeat_timeout: ?i64 = null,
        default_result: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hook_name = "LifecycleHookName",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .lifecycle_transition = "LifecycleTransition",
                .role_arn = "RoleARN",
                .notification_target_arn = "NotificationTargetARN",
                .notification_metadata = "NotificationMetadata",
                .heartbeat_timeout = "HeartbeatTimeout",
                .default_result = "DefaultResult",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_lifecycle_hook) } {
            return .{ .service_metadata = service_metadata, .action = put_lifecycle_hook };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const put_notification_configuration: struct {
    action_name: []const u8 = "PutNotificationConfiguration",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        topic_arn: []const u8,
        notification_types: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .topic_arn = "TopicARN",
                .notification_types = "NotificationTypes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_notification_configuration) } {
            return .{ .service_metadata = service_metadata, .action = put_notification_configuration };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const put_scaling_policy: struct {
    action_name: []const u8 = "PutScalingPolicy",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        policy_name: []const u8,
        policy_type: ?[]const u8 = null,
        adjustment_type: ?[]const u8 = null,
        min_adjustment_step: ?i64 = null,
        min_adjustment_magnitude: ?i64 = null,
        scaling_adjustment: ?i64 = null,
        cooldown: ?i64 = null,
        metric_aggregation_type: ?[]const u8 = null,
        step_adjustments: ?[]StepAdjustment = null,
        estimated_instance_warmup: ?i64 = null,
        target_tracking_configuration: ?TargetTrackingConfiguration = null,
        enabled: ?bool = null,
        predictive_scaling_configuration: ?PredictiveScalingConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .policy_name = "PolicyName",
                .policy_type = "PolicyType",
                .adjustment_type = "AdjustmentType",
                .min_adjustment_step = "MinAdjustmentStep",
                .min_adjustment_magnitude = "MinAdjustmentMagnitude",
                .scaling_adjustment = "ScalingAdjustment",
                .cooldown = "Cooldown",
                .metric_aggregation_type = "MetricAggregationType",
                .step_adjustments = "StepAdjustments",
                .estimated_instance_warmup = "EstimatedInstanceWarmup",
                .target_tracking_configuration = "TargetTrackingConfiguration",
                .enabled = "Enabled",
                .predictive_scaling_configuration = "PredictiveScalingConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_scaling_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_scaling_policy };
        }
    },
    Response: type = struct {
        policy_arn: ?[]const u8 = null,
        alarms: ?[]Alarm = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyARN",
                .alarms = "Alarms",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
        ServiceLinkedRoleFailure,
    },
} = .{};
pub const put_scheduled_update_group_action: struct {
    action_name: []const u8 = "PutScheduledUpdateGroupAction",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scheduled_action_name: []const u8,
        time: ?i64 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        recurrence: ?[]const u8 = null,
        min_size: ?i64 = null,
        max_size: ?i64 = null,
        desired_capacity: ?i64 = null,
        time_zone: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scheduled_action_name = "ScheduledActionName",
                .time = "Time",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .recurrence = "Recurrence",
                .min_size = "MinSize",
                .max_size = "MaxSize",
                .desired_capacity = "DesiredCapacity",
                .time_zone = "TimeZone",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_scheduled_update_group_action) } {
            return .{ .service_metadata = service_metadata, .action = put_scheduled_update_group_action };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        AlreadyExists,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const put_warm_pool: struct {
    action_name: []const u8 = "PutWarmPool",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        max_group_prepared_capacity: ?i64 = null,
        min_size: ?i64 = null,
        pool_state: ?[]const u8 = null,
        instance_reuse_policy: ?InstanceReusePolicy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .max_group_prepared_capacity = "MaxGroupPreparedCapacity",
                .min_size = "MinSize",
                .pool_state = "PoolState",
                .instance_reuse_policy = "InstanceReusePolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_warm_pool) } {
            return .{ .service_metadata = service_metadata, .action = put_warm_pool };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const record_lifecycle_action_heartbeat: struct {
    action_name: []const u8 = "RecordLifecycleActionHeartbeat",
    Request: type = struct {
        lifecycle_hook_name: []const u8,
        auto_scaling_group_name: []const u8,
        lifecycle_action_token: ?[]const u8 = null,
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_hook_name = "LifecycleHookName",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .lifecycle_action_token = "LifecycleActionToken",
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(record_lifecycle_action_heartbeat) } {
            return .{ .service_metadata = service_metadata, .action = record_lifecycle_action_heartbeat };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const resume_processes: struct {
    action_name: []const u8 = "ResumeProcesses",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scaling_processes: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scaling_processes = "ScalingProcesses",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(resume_processes) } {
            return .{ .service_metadata = service_metadata, .action = resume_processes };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ResourceInUse,
    },
} = .{};
pub const rollback_instance_refresh: struct {
    action_name: []const u8 = "RollbackInstanceRefresh",
    Request: type = struct {
        auto_scaling_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(rollback_instance_refresh) } {
            return .{ .service_metadata = service_metadata, .action = rollback_instance_refresh };
        }
    },
    Response: type = struct {
        instance_refresh_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_refresh_id = "InstanceRefreshId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ActiveInstanceRefreshNotFound,
        IrreversibleInstanceRefresh,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const set_desired_capacity: struct {
    action_name: []const u8 = "SetDesiredCapacity",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        desired_capacity: i64,
        honor_cooldown: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .desired_capacity = "DesiredCapacity",
                .honor_cooldown = "HonorCooldown",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_desired_capacity) } {
            return .{ .service_metadata = service_metadata, .action = set_desired_capacity };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ScalingActivityInProgress,
    },
} = .{};
pub const set_instance_health: struct {
    action_name: []const u8 = "SetInstanceHealth",
    Request: type = struct {
        instance_id: []const u8,
        health_status: []const u8,
        should_respect_grace_period: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .health_status = "HealthStatus",
                .should_respect_grace_period = "ShouldRespectGracePeriod",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_instance_health) } {
            return .{ .service_metadata = service_metadata, .action = set_instance_health };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
    },
} = .{};
pub const set_instance_protection: struct {
    action_name: []const u8 = "SetInstanceProtection",
    Request: type = struct {
        instance_ids: [][]const u8,
        auto_scaling_group_name: []const u8,
        protected_from_scale_in: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
                .auto_scaling_group_name = "AutoScalingGroupName",
                .protected_from_scale_in = "ProtectedFromScaleIn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_instance_protection) } {
            return .{ .service_metadata = service_metadata, .action = set_instance_protection };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const start_instance_refresh: struct {
    action_name: []const u8 = "StartInstanceRefresh",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        strategy: ?[]const u8 = null,
        desired_configuration: ?DesiredConfiguration = null,
        preferences: ?RefreshPreferences = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .strategy = "Strategy",
                .desired_configuration = "DesiredConfiguration",
                .preferences = "Preferences",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_instance_refresh) } {
            return .{ .service_metadata = service_metadata, .action = start_instance_refresh };
        }
    },
    Response: type = struct {
        instance_refresh_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_refresh_id = "InstanceRefreshId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InstanceRefreshInProgress,
        LimitExceeded,
        ResourceContention,
    },
} = .{};
pub const suspend_processes: struct {
    action_name: []const u8 = "SuspendProcesses",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        scaling_processes: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .scaling_processes = "ScalingProcesses",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(suspend_processes) } {
            return .{ .service_metadata = service_metadata, .action = suspend_processes };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ResourceInUse,
    },
} = .{};
pub const terminate_instance_in_auto_scaling_group: struct {
    action_name: []const u8 = "TerminateInstanceInAutoScalingGroup",
    Request: type = struct {
        instance_id: []const u8,
        should_decrement_desired_capacity: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .should_decrement_desired_capacity = "ShouldDecrementDesiredCapacity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(terminate_instance_in_auto_scaling_group) } {
            return .{ .service_metadata = service_metadata, .action = terminate_instance_in_auto_scaling_group };
        }
    },
    Response: type = struct {
        activity: ?Activity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .activity = "Activity",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceContention,
        ScalingActivityInProgress,
    },
} = .{};
pub const update_auto_scaling_group: struct {
    action_name: []const u8 = "UpdateAutoScalingGroup",
    Request: type = struct {
        auto_scaling_group_name: []const u8,
        launch_configuration_name: ?[]const u8 = null,
        launch_template: ?LaunchTemplateSpecification = null,
        mixed_instances_policy: ?MixedInstancesPolicy = null,
        min_size: ?i64 = null,
        max_size: ?i64 = null,
        desired_capacity: ?i64 = null,
        default_cooldown: ?i64 = null,
        availability_zones: ?[][]const u8 = null,
        health_check_type: ?[]const u8 = null,
        health_check_grace_period: ?i64 = null,
        placement_group: ?[]const u8 = null,
        vpc_zone_identifier: ?[]const u8 = null,
        termination_policies: ?[][]const u8 = null,
        new_instances_protected_from_scale_in: ?bool = null,
        service_linked_role_arn: ?[]const u8 = null,
        max_instance_lifetime: ?i64 = null,
        capacity_rebalance: ?bool = null,
        context: ?[]const u8 = null,
        desired_capacity_type: ?[]const u8 = null,
        default_instance_warmup: ?i64 = null,
        instance_maintenance_policy: ?InstanceMaintenancePolicy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_scaling_group_name = "AutoScalingGroupName",
                .launch_configuration_name = "LaunchConfigurationName",
                .launch_template = "LaunchTemplate",
                .mixed_instances_policy = "MixedInstancesPolicy",
                .min_size = "MinSize",
                .max_size = "MaxSize",
                .desired_capacity = "DesiredCapacity",
                .default_cooldown = "DefaultCooldown",
                .availability_zones = "AvailabilityZones",
                .health_check_type = "HealthCheckType",
                .health_check_grace_period = "HealthCheckGracePeriod",
                .placement_group = "PlacementGroup",
                .vpc_zone_identifier = "VPCZoneIdentifier",
                .termination_policies = "TerminationPolicies",
                .new_instances_protected_from_scale_in = "NewInstancesProtectedFromScaleIn",
                .service_linked_role_arn = "ServiceLinkedRoleARN",
                .max_instance_lifetime = "MaxInstanceLifetime",
                .capacity_rebalance = "CapacityRebalance",
                .context = "Context",
                .desired_capacity_type = "DesiredCapacityType",
                .default_instance_warmup = "DefaultInstanceWarmup",
                .instance_maintenance_policy = "InstanceMaintenancePolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_auto_scaling_group) } {
            return .{ .service_metadata = service_metadata, .action = update_auto_scaling_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceContention,
        ScalingActivityInProgress,
        ServiceLinkedRoleFailure,
    },
} = .{};

pub const InstanceMaintenancePolicy = struct {
    min_healthy_percentage: ?i64 = null,
    max_healthy_percentage: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min_healthy_percentage = "MinHealthyPercentage",
            .max_healthy_percentage = "MaxHealthyPercentage",
        };
        return @field(mappings, field_name);
    }
};

pub const MixedInstancesPolicy = struct {
    launch_template: ?LaunchTemplate = null,
    instances_distribution: ?InstancesDistribution = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .launch_template = "LaunchTemplate",
            .instances_distribution = "InstancesDistribution",
        };
        return @field(mappings, field_name);
    }
};

pub const InstancesDistribution = struct {
    on_demand_allocation_strategy: ?[]const u8 = null,
    on_demand_base_capacity: ?i64 = null,
    on_demand_percentage_above_base_capacity: ?i64 = null,
    spot_allocation_strategy: ?[]const u8 = null,
    spot_instance_pools: ?i64 = null,
    spot_max_price: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .on_demand_allocation_strategy = "OnDemandAllocationStrategy",
            .on_demand_base_capacity = "OnDemandBaseCapacity",
            .on_demand_percentage_above_base_capacity = "OnDemandPercentageAboveBaseCapacity",
            .spot_allocation_strategy = "SpotAllocationStrategy",
            .spot_instance_pools = "SpotInstancePools",
            .spot_max_price = "SpotMaxPrice",
        };
        return @field(mappings, field_name);
    }
};

pub const LaunchTemplate = struct {
    launch_template_specification: ?LaunchTemplateSpecification = null,
    overrides: ?[]LaunchTemplateOverrides = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .launch_template_specification = "LaunchTemplateSpecification",
            .overrides = "Overrides",
        };
        return @field(mappings, field_name);
    }
};

pub const LaunchTemplateOverrides = struct {
    instance_type: ?[]const u8 = null,
    weighted_capacity: ?[]const u8 = null,
    launch_template_specification: ?LaunchTemplateSpecification = null,
    instance_requirements: ?InstanceRequirements = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .instance_type = "InstanceType",
            .weighted_capacity = "WeightedCapacity",
            .launch_template_specification = "LaunchTemplateSpecification",
            .instance_requirements = "InstanceRequirements",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceRequirements = struct {
    v_cpu_count: VCpuCountRequest,
    memory_mib: MemoryMiBRequest,
    cpu_manufacturers: ?[][]const u8 = null,
    memory_gi_b_per_v_cpu: ?MemoryGiBPerVCpuRequest = null,
    excluded_instance_types: ?[][]const u8 = null,
    instance_generations: ?[][]const u8 = null,
    spot_max_price_percentage_over_lowest_price: ?i64 = null,
    max_spot_price_as_percentage_of_optimal_on_demand_price: ?i64 = null,
    on_demand_max_price_percentage_over_lowest_price: ?i64 = null,
    bare_metal: ?[]const u8 = null,
    burstable_performance: ?[]const u8 = null,
    require_hibernate_support: ?bool = null,
    network_interface_count: ?NetworkInterfaceCountRequest = null,
    local_storage: ?[]const u8 = null,
    local_storage_types: ?[][]const u8 = null,
    total_local_storage_gb: ?TotalLocalStorageGBRequest = null,
    baseline_ebs_bandwidth_mbps: ?BaselineEbsBandwidthMbpsRequest = null,
    accelerator_types: ?[][]const u8 = null,
    accelerator_count: ?AcceleratorCountRequest = null,
    accelerator_manufacturers: ?[][]const u8 = null,
    accelerator_names: ?[][]const u8 = null,
    accelerator_total_memory_mib: ?AcceleratorTotalMemoryMiBRequest = null,
    network_bandwidth_gbps: ?NetworkBandwidthGbpsRequest = null,
    allowed_instance_types: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .v_cpu_count = "VCpuCount",
            .memory_mib = "MemoryMiB",
            .cpu_manufacturers = "CpuManufacturers",
            .memory_gi_b_per_v_cpu = "MemoryGiBPerVCpu",
            .excluded_instance_types = "ExcludedInstanceTypes",
            .instance_generations = "InstanceGenerations",
            .spot_max_price_percentage_over_lowest_price = "SpotMaxPricePercentageOverLowestPrice",
            .max_spot_price_as_percentage_of_optimal_on_demand_price = "MaxSpotPriceAsPercentageOfOptimalOnDemandPrice",
            .on_demand_max_price_percentage_over_lowest_price = "OnDemandMaxPricePercentageOverLowestPrice",
            .bare_metal = "BareMetal",
            .burstable_performance = "BurstablePerformance",
            .require_hibernate_support = "RequireHibernateSupport",
            .network_interface_count = "NetworkInterfaceCount",
            .local_storage = "LocalStorage",
            .local_storage_types = "LocalStorageTypes",
            .total_local_storage_gb = "TotalLocalStorageGB",
            .baseline_ebs_bandwidth_mbps = "BaselineEbsBandwidthMbps",
            .accelerator_types = "AcceleratorTypes",
            .accelerator_count = "AcceleratorCount",
            .accelerator_manufacturers = "AcceleratorManufacturers",
            .accelerator_names = "AcceleratorNames",
            .accelerator_total_memory_mib = "AcceleratorTotalMemoryMiB",
            .network_bandwidth_gbps = "NetworkBandwidthGbps",
            .allowed_instance_types = "AllowedInstanceTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkBandwidthGbpsRequest = struct {
    min: ?f64 = null,
    max: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const AcceleratorTotalMemoryMiBRequest = struct {
    min: ?i64 = null,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const AcceleratorCountRequest = struct {
    min: ?i64 = null,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const BaselineEbsBandwidthMbpsRequest = struct {
    min: ?i64 = null,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const TotalLocalStorageGBRequest = struct {
    min: ?f64 = null,
    max: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkInterfaceCountRequest = struct {
    min: ?i64 = null,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const MemoryGiBPerVCpuRequest = struct {
    min: ?f64 = null,
    max: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const MemoryMiBRequest = struct {
    min: i64,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const VCpuCountRequest = struct {
    min: i64,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min = "Min",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const LaunchTemplateSpecification = struct {
    launch_template_id: ?[]const u8 = null,
    launch_template_name: ?[]const u8 = null,
    version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .launch_template_id = "LaunchTemplateId",
            .launch_template_name = "LaunchTemplateName",
            .version = "Version",
        };
        return @field(mappings, field_name);
    }
};

pub const Activity = struct {
    activity_id: []const u8,
    auto_scaling_group_name: []const u8,
    description: ?[]const u8 = null,
    cause: []const u8,
    start_time: i64,
    end_time: ?i64 = null,
    status_code: []const u8,
    status_message: ?[]const u8 = null,
    progress: ?i64 = null,
    details: ?[]const u8 = null,
    auto_scaling_group_state: ?[]const u8 = null,
    auto_scaling_group_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .activity_id = "ActivityId",
            .auto_scaling_group_name = "AutoScalingGroupName",
            .description = "Description",
            .cause = "Cause",
            .start_time = "StartTime",
            .end_time = "EndTime",
            .status_code = "StatusCode",
            .status_message = "StatusMessage",
            .progress = "Progress",
            .details = "Details",
            .auto_scaling_group_state = "AutoScalingGroupState",
            .auto_scaling_group_arn = "AutoScalingGroupARN",
        };
        return @field(mappings, field_name);
    }
};

pub const RefreshPreferences = struct {
    min_healthy_percentage: ?i64 = null,
    instance_warmup: ?i64 = null,
    checkpoint_percentages: ?[]i64 = null,
    checkpoint_delay: ?i64 = null,
    skip_matching: ?bool = null,
    auto_rollback: ?bool = null,
    scale_in_protected_instances: ?[]const u8 = null,
    standby_instances: ?[]const u8 = null,
    alarm_specification: ?AlarmSpecification = null,
    max_healthy_percentage: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .min_healthy_percentage = "MinHealthyPercentage",
            .instance_warmup = "InstanceWarmup",
            .checkpoint_percentages = "CheckpointPercentages",
            .checkpoint_delay = "CheckpointDelay",
            .skip_matching = "SkipMatching",
            .auto_rollback = "AutoRollback",
            .scale_in_protected_instances = "ScaleInProtectedInstances",
            .standby_instances = "StandbyInstances",
            .alarm_specification = "AlarmSpecification",
            .max_healthy_percentage = "MaxHealthyPercentage",
        };
        return @field(mappings, field_name);
    }
};

pub const AlarmSpecification = struct {
    alarms: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .alarms = "Alarms",
        };
        return @field(mappings, field_name);
    }
};

pub const DesiredConfiguration = struct {
    launch_template: ?LaunchTemplateSpecification = null,
    mixed_instances_policy: ?MixedInstancesPolicy = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .launch_template = "LaunchTemplate",
            .mixed_instances_policy = "MixedInstancesPolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceReusePolicy = struct {
    reuse_on_scale_in: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .reuse_on_scale_in = "ReuseOnScaleIn",
        };
        return @field(mappings, field_name);
    }
};

pub const Alarm = struct {
    alarm_name: ?[]const u8 = null,
    alarm_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .alarm_name = "AlarmName",
            .alarm_arn = "AlarmARN",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingConfiguration = struct {
    metric_specifications: []PredictiveScalingMetricSpecification,
    mode: ?[]const u8 = null,
    scheduling_buffer_time: ?i64 = null,
    max_capacity_breach_behavior: ?[]const u8 = null,
    max_capacity_buffer: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_specifications = "MetricSpecifications",
            .mode = "Mode",
            .scheduling_buffer_time = "SchedulingBufferTime",
            .max_capacity_breach_behavior = "MaxCapacityBreachBehavior",
            .max_capacity_buffer = "MaxCapacityBuffer",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingMetricSpecification = struct {
    target_value: f64,
    predefined_metric_pair_specification: ?PredictiveScalingPredefinedMetricPair = null,
    predefined_scaling_metric_specification: ?PredictiveScalingPredefinedScalingMetric = null,
    predefined_load_metric_specification: ?PredictiveScalingPredefinedLoadMetric = null,
    customized_scaling_metric_specification: ?PredictiveScalingCustomizedScalingMetric = null,
    customized_load_metric_specification: ?PredictiveScalingCustomizedLoadMetric = null,
    customized_capacity_metric_specification: ?PredictiveScalingCustomizedCapacityMetric = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .target_value = "TargetValue",
            .predefined_metric_pair_specification = "PredefinedMetricPairSpecification",
            .predefined_scaling_metric_specification = "PredefinedScalingMetricSpecification",
            .predefined_load_metric_specification = "PredefinedLoadMetricSpecification",
            .customized_scaling_metric_specification = "CustomizedScalingMetricSpecification",
            .customized_load_metric_specification = "CustomizedLoadMetricSpecification",
            .customized_capacity_metric_specification = "CustomizedCapacityMetricSpecification",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingCustomizedCapacityMetric = struct {
    metric_data_queries: []MetricDataQuery,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_data_queries = "MetricDataQueries",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricDataQuery = struct {
    id: []const u8,
    expression: ?[]const u8 = null,
    metric_stat: ?MetricStat = null,
    label: ?[]const u8 = null,
    return_data: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .expression = "Expression",
            .metric_stat = "MetricStat",
            .label = "Label",
            .return_data = "ReturnData",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricStat = struct {
    metric: Metric,
    stat: []const u8,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric = "Metric",
            .stat = "Stat",
            .unit = "Unit",
        };
        return @field(mappings, field_name);
    }
};

pub const Metric = struct {
    namespace: []const u8,
    metric_name: []const u8,
    dimensions: ?[]MetricDimension = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .namespace = "Namespace",
            .metric_name = "MetricName",
            .dimensions = "Dimensions",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricDimension = struct {
    name: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingCustomizedLoadMetric = struct {
    metric_data_queries: []MetricDataQuery,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_data_queries = "MetricDataQueries",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingCustomizedScalingMetric = struct {
    metric_data_queries: []MetricDataQuery,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_data_queries = "MetricDataQueries",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingPredefinedLoadMetric = struct {
    predefined_metric_type: []const u8,
    resource_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .predefined_metric_type = "PredefinedMetricType",
            .resource_label = "ResourceLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingPredefinedScalingMetric = struct {
    predefined_metric_type: []const u8,
    resource_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .predefined_metric_type = "PredefinedMetricType",
            .resource_label = "ResourceLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const PredictiveScalingPredefinedMetricPair = struct {
    predefined_metric_type: []const u8,
    resource_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .predefined_metric_type = "PredefinedMetricType",
            .resource_label = "ResourceLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetTrackingConfiguration = struct {
    predefined_metric_specification: ?PredefinedMetricSpecification = null,
    customized_metric_specification: ?CustomizedMetricSpecification = null,
    target_value: f64,
    disable_scale_in: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .predefined_metric_specification = "PredefinedMetricSpecification",
            .customized_metric_specification = "CustomizedMetricSpecification",
            .target_value = "TargetValue",
            .disable_scale_in = "DisableScaleIn",
        };
        return @field(mappings, field_name);
    }
};

pub const CustomizedMetricSpecification = struct {
    metric_name: ?[]const u8 = null,
    namespace: ?[]const u8 = null,
    dimensions: ?[]MetricDimension = null,
    statistic: ?[]const u8 = null,
    unit: ?[]const u8 = null,
    metrics: ?[]TargetTrackingMetricDataQuery = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_name = "MetricName",
            .namespace = "Namespace",
            .dimensions = "Dimensions",
            .statistic = "Statistic",
            .unit = "Unit",
            .metrics = "Metrics",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetTrackingMetricDataQuery = struct {
    id: []const u8,
    expression: ?[]const u8 = null,
    metric_stat: ?TargetTrackingMetricStat = null,
    label: ?[]const u8 = null,
    return_data: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .expression = "Expression",
            .metric_stat = "MetricStat",
            .label = "Label",
            .return_data = "ReturnData",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetTrackingMetricStat = struct {
    metric: Metric,
    stat: []const u8,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric = "Metric",
            .stat = "Stat",
            .unit = "Unit",
        };
        return @field(mappings, field_name);
    }
};

pub const PredefinedMetricSpecification = struct {
    predefined_metric_type: []const u8,
    resource_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .predefined_metric_type = "PredefinedMetricType",
            .resource_label = "ResourceLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const StepAdjustment = struct {
    metric_interval_lower_bound: ?f64 = null,
    metric_interval_upper_bound: ?f64 = null,
    scaling_adjustment: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_interval_lower_bound = "MetricIntervalLowerBound",
            .metric_interval_upper_bound = "MetricIntervalUpperBound",
            .scaling_adjustment = "ScalingAdjustment",
        };
        return @field(mappings, field_name);
    }
};

pub const TrafficSourceIdentifier = struct {
    identifier: []const u8,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .identifier = "Identifier",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const Instance = struct {
    instance_id: []const u8,
    instance_type: ?[]const u8 = null,
    availability_zone: []const u8,
    lifecycle_state: []const u8,
    health_status: []const u8,
    launch_configuration_name: ?[]const u8 = null,
    launch_template: ?LaunchTemplateSpecification = null,
    protected_from_scale_in: bool,
    weighted_capacity: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .instance_id = "InstanceId",
            .instance_type = "InstanceType",
            .availability_zone = "AvailabilityZone",
            .lifecycle_state = "LifecycleState",
            .health_status = "HealthStatus",
            .launch_configuration_name = "LaunchConfigurationName",
            .launch_template = "LaunchTemplate",
            .protected_from_scale_in = "ProtectedFromScaleIn",
            .weighted_capacity = "WeightedCapacity",
        };
        return @field(mappings, field_name);
    }
};

pub const WarmPoolConfiguration = struct {
    max_group_prepared_capacity: ?i64 = null,
    min_size: ?i64 = null,
    pool_state: ?[]const u8 = null,
    status: ?[]const u8 = null,
    instance_reuse_policy: ?InstanceReusePolicy = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .max_group_prepared_capacity = "MaxGroupPreparedCapacity",
            .min_size = "MinSize",
            .pool_state = "PoolState",
            .status = "Status",
            .instance_reuse_policy = "InstanceReusePolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const TagDescription = struct {
    resource_id: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,
    propagate_at_launch: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_id = "ResourceId",
            .resource_type = "ResourceType",
            .key = "Key",
            .value = "Value",
            .propagate_at_launch = "PropagateAtLaunch",
        };
        return @field(mappings, field_name);
    }
};

pub const Filter = struct {
    name: ?[]const u8 = null,
    values: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .values = "Values",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceMetadataOptions = struct {
    http_tokens: ?[]const u8 = null,
    http_put_response_hop_limit: ?i64 = null,
    http_endpoint: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .http_tokens = "HttpTokens",
            .http_put_response_hop_limit = "HttpPutResponseHopLimit",
            .http_endpoint = "HttpEndpoint",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceMonitoring = struct {
    enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
        };
        return @field(mappings, field_name);
    }
};

pub const BlockDeviceMapping = struct {
    virtual_name: ?[]const u8 = null,
    device_name: []const u8,
    ebs: ?Ebs = null,
    no_device: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .virtual_name = "VirtualName",
            .device_name = "DeviceName",
            .ebs = "Ebs",
            .no_device = "NoDevice",
        };
        return @field(mappings, field_name);
    }
};

pub const Ebs = struct {
    snapshot_id: ?[]const u8 = null,
    volume_size: ?i64 = null,
    volume_type: ?[]const u8 = null,
    delete_on_termination: ?bool = null,
    iops: ?i64 = null,
    encrypted: ?bool = null,
    throughput: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .snapshot_id = "SnapshotId",
            .volume_size = "VolumeSize",
            .volume_type = "VolumeType",
            .delete_on_termination = "DeleteOnTermination",
            .iops = "Iops",
            .encrypted = "Encrypted",
            .throughput = "Throughput",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceRefreshProgressDetails = struct {
    live_pool_progress: ?InstanceRefreshLivePoolProgress = null,
    warm_pool_progress: ?InstanceRefreshWarmPoolProgress = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .live_pool_progress = "LivePoolProgress",
            .warm_pool_progress = "WarmPoolProgress",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceRefreshWarmPoolProgress = struct {
    percentage_complete: ?i64 = null,
    instances_to_update: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .percentage_complete = "PercentageComplete",
            .instances_to_update = "InstancesToUpdate",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceRefreshLivePoolProgress = struct {
    percentage_complete: ?i64 = null,
    instances_to_update: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .percentage_complete = "PercentageComplete",
            .instances_to_update = "InstancesToUpdate",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    resource_id: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,
    key: []const u8,
    value: ?[]const u8 = null,
    propagate_at_launch: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_id = "ResourceId",
            .resource_type = "ResourceType",
            .key = "Key",
            .value = "Value",
            .propagate_at_launch = "PropagateAtLaunch",
        };
        return @field(mappings, field_name);
    }
};

pub const FailedScheduledUpdateGroupActionRequest = struct {
    scheduled_action_name: []const u8,
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .scheduled_action_name = "ScheduledActionName",
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};
