const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-10-11";
pub const sdk_id: []const u8 = "chatbot";
pub const arn_namespace: ?[]const u8 = "chatbot";
pub const endpoint_prefix: []const u8 = "chatbot";
pub const sigv4_name: []const u8 = "chatbot";
pub const name: []const u8 = "WheatleyOrchestration_20171011";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-10-11",
    sdk_id: []const u8 = "chatbot",
    arn_namespace: ?[]const u8 = "chatbot",
    endpoint_prefix: []const u8 = "chatbot",
    sigv4_name: []const u8 = "chatbot",
    name: []const u8 = "WheatleyOrchestration_20171011",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const create_chime_webhook_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/create-chime-webhook-configuration",
        .success_code = 201,
    };

    action_name: []const u8 = "CreateChimeWebhookConfiguration",
    Request: type = struct {
        webhook_description: []const u8,
        webhook_url: []const u8,
        sns_topic_arns: [][]const u8,
        iam_role_arn: []const u8,
        configuration_name: []const u8,
        logging_level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .webhook_description = "WebhookDescription",
                .webhook_url = "WebhookUrl",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .configuration_name = "ConfigurationName",
                .logging_level = "LoggingLevel",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_chime_webhook_configuration) } {
            return .{ .service_metadata = service_metadata, .action = create_chime_webhook_configuration };
        }
    },
    Response: type = struct {
        webhook_configuration: ?ChimeWebhookConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .webhook_configuration = "WebhookConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Conflict,
        CreateChimeWebhookConfiguration,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
    },
} = .{};
pub const create_microsoft_teams_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/create-ms-teams-channel-configuration",
        .success_code = 201,
    };

    action_name: []const u8 = "CreateMicrosoftTeamsChannelConfiguration",
    Request: type = struct {
        channel_id: []const u8,
        channel_name: ?[]const u8 = null,
        team_id: []const u8,
        team_name: ?[]const u8 = null,
        tenant_id: []const u8,
        sns_topic_arns: ?[][]const u8 = null,
        iam_role_arn: []const u8,
        configuration_name: []const u8,
        logging_level: ?[]const u8 = null,
        guardrail_policy_arns: ?[][]const u8 = null,
        user_authorization_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_id = "ChannelId",
                .channel_name = "ChannelName",
                .team_id = "TeamId",
                .team_name = "TeamName",
                .tenant_id = "TenantId",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .configuration_name = "ConfigurationName",
                .logging_level = "LoggingLevel",
                .guardrail_policy_arns = "GuardrailPolicyArns",
                .user_authorization_required = "UserAuthorizationRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_microsoft_teams_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = create_microsoft_teams_channel_configuration };
        }
    },
    Response: type = struct {
        channel_configuration: ?TeamsChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_configuration = "ChannelConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Conflict,
        CreateTeamsChannelConfiguration,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
    },
} = .{};
pub const create_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/create-slack-channel-configuration",
        .success_code = 201,
    };

    action_name: []const u8 = "CreateSlackChannelConfiguration",
    Request: type = struct {
        slack_team_id: []const u8,
        slack_channel_id: []const u8,
        slack_channel_name: ?[]const u8 = null,
        sns_topic_arns: ?[][]const u8 = null,
        iam_role_arn: []const u8,
        configuration_name: []const u8,
        logging_level: ?[]const u8 = null,
        guardrail_policy_arns: ?[][]const u8 = null,
        user_authorization_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .slack_team_id = "SlackTeamId",
                .slack_channel_id = "SlackChannelId",
                .slack_channel_name = "SlackChannelName",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .configuration_name = "ConfigurationName",
                .logging_level = "LoggingLevel",
                .guardrail_policy_arns = "GuardrailPolicyArns",
                .user_authorization_required = "UserAuthorizationRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = create_slack_channel_configuration };
        }
    },
    Response: type = struct {
        channel_configuration: ?SlackChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_configuration = "ChannelConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Conflict,
        CreateSlackChannelConfiguration,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
    },
} = .{};
pub const delete_chime_webhook_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-chime-webhook-configuration",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteChimeWebhookConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_chime_webhook_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_chime_webhook_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteChimeWebhookConfiguration,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const delete_microsoft_teams_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-ms-teams-channel-configuration",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteMicrosoftTeamsChannelConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_microsoft_teams_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_microsoft_teams_channel_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteTeamsChannelConfiguration,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const delete_microsoft_teams_configured_team: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-ms-teams-configured-teams",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteMicrosoftTeamsConfiguredTeam",
    Request: type = struct {
        team_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "TeamId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_microsoft_teams_configured_team) } {
            return .{ .service_metadata = service_metadata, .action = delete_microsoft_teams_configured_team };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteTeamsConfiguredTeam,
        InvalidParameter,
    },
} = .{};
pub const delete_microsoft_teams_user_identity: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-ms-teams-user-identity",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteMicrosoftTeamsUserIdentity",
    Request: type = struct {
        chat_configuration_arn: []const u8,
        user_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .user_id = "UserId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_microsoft_teams_user_identity) } {
            return .{ .service_metadata = service_metadata, .action = delete_microsoft_teams_user_identity };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteMicrosoftTeamsUserIdentity,
        InvalidParameter,
        ResourceNotFound,
    },
} = .{};
pub const delete_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-slack-channel-configuration",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteSlackChannelConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_slack_channel_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteSlackChannelConfiguration,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const delete_slack_user_identity: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-slack-user-identity",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteSlackUserIdentity",
    Request: type = struct {
        chat_configuration_arn: []const u8,
        slack_team_id: []const u8,
        slack_user_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .slack_team_id = "SlackTeamId",
                .slack_user_id = "SlackUserId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_slack_user_identity) } {
            return .{ .service_metadata = service_metadata, .action = delete_slack_user_identity };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteSlackUserIdentity,
        InvalidParameter,
        ResourceNotFound,
    },
} = .{};
pub const delete_slack_workspace_authorization: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/delete-slack-workspace-authorization",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteSlackWorkspaceAuthorization",
    Request: type = struct {
        slack_team_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .slack_team_id = "SlackTeamId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_slack_workspace_authorization) } {
            return .{ .service_metadata = service_metadata, .action = delete_slack_workspace_authorization };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeleteSlackWorkspaceAuthorization,
        InvalidParameter,
    },
} = .{};
pub const describe_chime_webhook_configurations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/describe-chime-webhook-configurations",
        .success_code = 200,
    };

    action_name: []const u8 = "DescribeChimeWebhookConfigurations",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        chat_configuration_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_chime_webhook_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_chime_webhook_configurations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        webhook_configurations: ?[]ChimeWebhookConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .webhook_configurations = "WebhookConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DescribeChimeWebhookConfigurations,
        InvalidParameter,
        InvalidRequest,
    },
} = .{};
pub const describe_slack_channel_configurations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/describe-slack-channel-configurations",
        .success_code = 200,
    };

    action_name: []const u8 = "DescribeSlackChannelConfigurations",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        chat_configuration_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_slack_channel_configurations) } {
            return .{ .service_metadata = service_metadata, .action = describe_slack_channel_configurations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        slack_channel_configurations: ?[]SlackChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .slack_channel_configurations = "SlackChannelConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DescribeSlackChannelConfigurations,
        InvalidParameter,
        InvalidRequest,
    },
} = .{};
pub const describe_slack_user_identities: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/describe-slack-user-identities",
        .success_code = 200,
    };

    action_name: []const u8 = "DescribeSlackUserIdentities",
    Request: type = struct {
        chat_configuration_arn: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_slack_user_identities) } {
            return .{ .service_metadata = service_metadata, .action = describe_slack_user_identities };
        }
    },
    Response: type = struct {
        slack_user_identities: ?[]struct {
            iam_role_arn: []const u8,
            chat_configuration_arn: []const u8,
            slack_team_id: []const u8,
            slack_user_id: []const u8,
            aws_user_identity: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .iam_role_arn = "IamRoleArn",
                    .chat_configuration_arn = "ChatConfigurationArn",
                    .slack_team_id = "SlackTeamId",
                    .slack_user_id = "SlackUserId",
                    .aws_user_identity = "AwsUserIdentity",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .slack_user_identities = "SlackUserIdentities",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DescribeSlackUserIdentities,
        InvalidParameter,
        InvalidRequest,
    },
} = .{};
pub const describe_slack_workspaces: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/describe-slack-workspaces",
        .success_code = 200,
    };

    action_name: []const u8 = "DescribeSlackWorkspaces",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_slack_workspaces) } {
            return .{ .service_metadata = service_metadata, .action = describe_slack_workspaces };
        }
    },
    Response: type = struct {
        slack_workspaces: ?[]struct {
            slack_team_id: []const u8,
            slack_team_name: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .slack_team_id = "SlackTeamId",
                    .slack_team_name = "SlackTeamName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .slack_workspaces = "SlackWorkspaces",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DescribeSlackWorkspaces,
        InvalidParameter,
        InvalidRequest,
    },
} = .{};
pub const get_account_preferences: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/get-account-preferences",
        .success_code = 200,
    };

    action_name: []const u8 = "GetAccountPreferences",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_preferences) } {
            return .{ .service_metadata = service_metadata, .action = get_account_preferences };
        }
    },
    Response: type = struct {
        account_preferences: ?AccountPreferences = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_preferences = "AccountPreferences",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        GetAccountPreferences,
        InvalidRequest,
    },
} = .{};
pub const get_microsoft_teams_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/get-ms-teams-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "GetMicrosoftTeamsChannelConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_microsoft_teams_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = get_microsoft_teams_channel_configuration };
        }
    },
    Response: type = struct {
        channel_configuration: ?TeamsChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_configuration = "ChannelConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        GetTeamsChannelConfiguration,
        InvalidParameter,
        InvalidRequest,
    },
} = .{};
pub const list_microsoft_teams_channel_configurations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/list-ms-teams-channel-configurations",
        .success_code = 200,
    };

    action_name: []const u8 = "ListMicrosoftTeamsChannelConfigurations",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        team_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .team_id = "TeamId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_microsoft_teams_channel_configurations) } {
            return .{ .service_metadata = service_metadata, .action = list_microsoft_teams_channel_configurations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        team_channel_configurations: ?[]TeamsChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .team_channel_configurations = "TeamChannelConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ListTeamsChannelConfigurations,
    },
} = .{};
pub const list_microsoft_teams_configured_teams: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/list-ms-teams-configured-teams",
        .success_code = 200,
    };

    action_name: []const u8 = "ListMicrosoftTeamsConfiguredTeams",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_microsoft_teams_configured_teams) } {
            return .{ .service_metadata = service_metadata, .action = list_microsoft_teams_configured_teams };
        }
    },
    Response: type = struct {
        configured_teams: ?[]struct {
            tenant_id: []const u8,
            team_id: []const u8,
            team_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .tenant_id = "TenantId",
                    .team_id = "TeamId",
                    .team_name = "TeamName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configured_teams = "ConfiguredTeams",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ListMicrosoftTeamsConfiguredTeams,
    },
} = .{};
pub const list_microsoft_teams_user_identities: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/list-ms-teams-user-identities",
        .success_code = 200,
    };

    action_name: []const u8 = "ListMicrosoftTeamsUserIdentities",
    Request: type = struct {
        chat_configuration_arn: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_microsoft_teams_user_identities) } {
            return .{ .service_metadata = service_metadata, .action = list_microsoft_teams_user_identities };
        }
    },
    Response: type = struct {
        teams_user_identities: ?[]struct {
            iam_role_arn: []const u8,
            chat_configuration_arn: []const u8,
            team_id: []const u8,
            user_id: ?[]const u8 = null,
            aws_user_identity: ?[]const u8 = null,
            teams_channel_id: ?[]const u8 = null,
            teams_tenant_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .iam_role_arn = "IamRoleArn",
                    .chat_configuration_arn = "ChatConfigurationArn",
                    .team_id = "TeamId",
                    .user_id = "UserId",
                    .aws_user_identity = "AwsUserIdentity",
                    .teams_channel_id = "TeamsChannelId",
                    .teams_tenant_id = "TeamsTenantId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .teams_user_identities = "TeamsUserIdentities",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ListMicrosoftTeamsUserIdentities,
    },
} = .{};
pub const update_account_preferences: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/update-account-preferences",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateAccountPreferences",
    Request: type = struct {
        user_authorization_required: ?bool = null,
        training_data_collection_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_authorization_required = "UserAuthorizationRequired",
                .training_data_collection_enabled = "TrainingDataCollectionEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_account_preferences) } {
            return .{ .service_metadata = service_metadata, .action = update_account_preferences };
        }
    },
    Response: type = struct {
        account_preferences: ?AccountPreferences = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_preferences = "AccountPreferences",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        UpdateAccountPreferences,
    },
} = .{};
pub const update_chime_webhook_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/update-chime-webhook-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateChimeWebhookConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,
        webhook_description: ?[]const u8 = null,
        webhook_url: ?[]const u8 = null,
        sns_topic_arns: ?[][]const u8 = null,
        iam_role_arn: ?[]const u8 = null,
        logging_level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .webhook_description = "WebhookDescription",
                .webhook_url = "WebhookUrl",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .logging_level = "LoggingLevel",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_chime_webhook_configuration) } {
            return .{ .service_metadata = service_metadata, .action = update_chime_webhook_configuration };
        }
    },
    Response: type = struct {
        webhook_configuration: ?ChimeWebhookConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .webhook_configuration = "WebhookConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        UpdateChimeWebhookConfiguration,
    },
} = .{};
pub const update_microsoft_teams_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/update-ms-teams-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateMicrosoftTeamsChannelConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,
        channel_id: []const u8,
        channel_name: ?[]const u8 = null,
        sns_topic_arns: ?[][]const u8 = null,
        iam_role_arn: ?[]const u8 = null,
        logging_level: ?[]const u8 = null,
        guardrail_policy_arns: ?[][]const u8 = null,
        user_authorization_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .channel_id = "ChannelId",
                .channel_name = "ChannelName",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .logging_level = "LoggingLevel",
                .guardrail_policy_arns = "GuardrailPolicyArns",
                .user_authorization_required = "UserAuthorizationRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_microsoft_teams_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = update_microsoft_teams_channel_configuration };
        }
    },
    Response: type = struct {
        channel_configuration: ?TeamsChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_configuration = "ChannelConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        UpdateTeamsChannelConfiguration,
    },
} = .{};
pub const update_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/update-slack-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateSlackChannelConfiguration",
    Request: type = struct {
        chat_configuration_arn: []const u8,
        slack_channel_id: []const u8,
        slack_channel_name: ?[]const u8 = null,
        sns_topic_arns: ?[][]const u8 = null,
        iam_role_arn: ?[]const u8 = null,
        logging_level: ?[]const u8 = null,
        guardrail_policy_arns: ?[][]const u8 = null,
        user_authorization_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .chat_configuration_arn = "ChatConfigurationArn",
                .slack_channel_id = "SlackChannelId",
                .slack_channel_name = "SlackChannelName",
                .sns_topic_arns = "SnsTopicArns",
                .iam_role_arn = "IamRoleArn",
                .logging_level = "LoggingLevel",
                .guardrail_policy_arns = "GuardrailPolicyArns",
                .user_authorization_required = "UserAuthorizationRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = update_slack_channel_configuration };
        }
    },
    Response: type = struct {
        channel_configuration: ?SlackChannelConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_configuration = "ChannelConfiguration",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        UpdateSlackChannelConfiguration,
    },
} = .{};

pub const SlackChannelConfiguration = struct {
    slack_team_name: []const u8,
    slack_team_id: []const u8,
    slack_channel_id: []const u8,
    slack_channel_name: []const u8,
    chat_configuration_arn: []const u8,
    iam_role_arn: []const u8,
    sns_topic_arns: [][]const u8,
    configuration_name: ?[]const u8 = null,
    logging_level: ?[]const u8 = null,
    guardrail_policy_arns: ?[][]const u8 = null,
    user_authorization_required: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .slack_team_name = "SlackTeamName",
            .slack_team_id = "SlackTeamId",
            .slack_channel_id = "SlackChannelId",
            .slack_channel_name = "SlackChannelName",
            .chat_configuration_arn = "ChatConfigurationArn",
            .iam_role_arn = "IamRoleArn",
            .sns_topic_arns = "SnsTopicArns",
            .configuration_name = "ConfigurationName",
            .logging_level = "LoggingLevel",
            .guardrail_policy_arns = "GuardrailPolicyArns",
            .user_authorization_required = "UserAuthorizationRequired",
        };
        return @field(mappings, field_name);
    }
};

pub const TeamsChannelConfiguration = struct {
    channel_id: []const u8,
    channel_name: ?[]const u8 = null,
    team_id: []const u8,
    team_name: ?[]const u8 = null,
    tenant_id: []const u8,
    chat_configuration_arn: []const u8,
    iam_role_arn: []const u8,
    sns_topic_arns: [][]const u8,
    configuration_name: ?[]const u8 = null,
    logging_level: ?[]const u8 = null,
    guardrail_policy_arns: ?[][]const u8 = null,
    user_authorization_required: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .channel_id = "ChannelId",
            .channel_name = "ChannelName",
            .team_id = "TeamId",
            .team_name = "TeamName",
            .tenant_id = "TenantId",
            .chat_configuration_arn = "ChatConfigurationArn",
            .iam_role_arn = "IamRoleArn",
            .sns_topic_arns = "SnsTopicArns",
            .configuration_name = "ConfigurationName",
            .logging_level = "LoggingLevel",
            .guardrail_policy_arns = "GuardrailPolicyArns",
            .user_authorization_required = "UserAuthorizationRequired",
        };
        return @field(mappings, field_name);
    }
};

pub const ChimeWebhookConfiguration = struct {
    webhook_description: []const u8,
    chat_configuration_arn: []const u8,
    iam_role_arn: []const u8,
    sns_topic_arns: [][]const u8,
    configuration_name: ?[]const u8 = null,
    logging_level: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .webhook_description = "WebhookDescription",
            .chat_configuration_arn = "ChatConfigurationArn",
            .iam_role_arn = "IamRoleArn",
            .sns_topic_arns = "SnsTopicArns",
            .configuration_name = "ConfigurationName",
            .logging_level = "LoggingLevel",
        };
        return @field(mappings, field_name);
    }
};

pub const AccountPreferences = struct {
    user_authorization_required: ?bool = null,
    training_data_collection_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .user_authorization_required = "UserAuthorizationRequired",
            .training_data_collection_enabled = "TrainingDataCollectionEnabled",
        };
        return @field(mappings, field_name);
    }
};
