const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2010-05-15";
pub const sdk_id: []const u8 = "CloudFormation";
pub const arn_namespace: ?[]const u8 = "cloudformation";
pub const endpoint_prefix: []const u8 = "cloudformation";
pub const sigv4_name: []const u8 = "cloudformation";
pub const name: []const u8 = "CloudFormation";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query;

pub const service_metadata: struct {
    version: []const u8 = "2010-05-15",
    sdk_id: []const u8 = "CloudFormation",
    arn_namespace: ?[]const u8 = "cloudformation",
    endpoint_prefix: []const u8 = "cloudformation",
    sigv4_name: []const u8 = "cloudformation",
    name: []const u8 = "CloudFormation",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query,
} = .{};
pub const activate_organizations_access: struct {
    action_name: []const u8 = "ActivateOrganizationsAccess",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(activate_organizations_access) } {
            return .{ .service_metadata = service_metadata, .action = activate_organizations_access };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationNotFound,
    },
} = .{};
pub const activate_type: struct {
    action_name: []const u8 = "ActivateType",
    Request: type = struct {
        type: ?[]const u8 = null,
        public_type_arn: ?[]const u8 = null,
        publisher_id: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        type_name_alias: ?[]const u8 = null,
        auto_update: ?bool = null,
        logging_config: ?LoggingConfig = null,
        execution_role_arn: ?[]const u8 = null,
        version_bump: ?[]const u8 = null,
        major_version: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .public_type_arn = "PublicTypeArn",
                .publisher_id = "PublisherId",
                .type_name = "TypeName",
                .type_name_alias = "TypeNameAlias",
                .auto_update = "AutoUpdate",
                .logging_config = "LoggingConfig",
                .execution_role_arn = "ExecutionRoleArn",
                .version_bump = "VersionBump",
                .major_version = "MajorVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(activate_type) } {
            return .{ .service_metadata = service_metadata, .action = activate_type };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const batch_describe_type_configurations: struct {
    action_name: []const u8 = "BatchDescribeTypeConfigurations",
    Request: type = struct {
        type_configuration_identifiers: []TypeConfigurationIdentifier,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_configuration_identifiers = "TypeConfigurationIdentifiers",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_describe_type_configurations) } {
            return .{ .service_metadata = service_metadata, .action = batch_describe_type_configurations };
        }
    },
    Response: type = struct {
        errors: ?[]struct {
            error_code: ?[]const u8 = null,
            error_message: ?[]const u8 = null,
            type_configuration_identifier: ?TypeConfigurationIdentifier = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .error_code = "ErrorCode",
                    .error_message = "ErrorMessage",
                    .type_configuration_identifier = "TypeConfigurationIdentifier",
                };
                return @field(mappings, field_name);
            }
        } = null,
        unprocessed_type_configurations: ?[]TypeConfigurationIdentifier = null,
        type_configurations: ?[]struct {
            arn: ?[]const u8 = null,
            alias: ?[]const u8 = null,
            configuration: ?[]const u8 = null,
            last_updated: ?i64 = null,
            type_arn: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            is_default_configuration: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .alias = "Alias",
                    .configuration = "Configuration",
                    .last_updated = "LastUpdated",
                    .type_arn = "TypeArn",
                    .type_name = "TypeName",
                    .is_default_configuration = "IsDefaultConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .errors = "Errors",
                .unprocessed_type_configurations = "UnprocessedTypeConfigurations",
                .type_configurations = "TypeConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeConfigurationNotFound,
    },
} = .{};
pub const cancel_update_stack: struct {
    action_name: []const u8 = "CancelUpdateStack",
    Request: type = struct {
        stack_name: []const u8,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_update_stack) } {
            return .{ .service_metadata = service_metadata, .action = cancel_update_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        TokenAlreadyExists,
    },
} = .{};
pub const continue_update_rollback: struct {
    action_name: []const u8 = "ContinueUpdateRollback",
    Request: type = struct {
        stack_name: []const u8,
        role_arn: ?[]const u8 = null,
        resources_to_skip: ?[][]const u8 = null,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .role_arn = "RoleARN",
                .resources_to_skip = "ResourcesToSkip",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(continue_update_rollback) } {
            return .{ .service_metadata = service_metadata, .action = continue_update_rollback };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        TokenAlreadyExists,
    },
} = .{};
pub const create_change_set: struct {
    action_name: []const u8 = "CreateChangeSet",
    Request: type = struct {
        stack_name: []const u8,
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        use_previous_template: ?bool = null,
        parameters: ?[]Parameter = null,
        capabilities: ?[][]const u8 = null,
        resource_types: ?[][]const u8 = null,
        role_arn: ?[]const u8 = null,
        rollback_configuration: ?RollbackConfiguration = null,
        notification_ar_ns: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        change_set_name: []const u8,
        client_token: ?[]const u8 = null,
        description: ?[]const u8 = null,
        change_set_type: ?[]const u8 = null,
        resources_to_import: ?[]struct {
            resource_type: []const u8,
            logical_resource_id: []const u8,
            resource_identifier: []struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            },

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_type = "ResourceType",
                    .logical_resource_id = "LogicalResourceId",
                    .resource_identifier = "ResourceIdentifier",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "resource_identifier", field_name))
                    return try serializeMap(self.resource_identifier, self.fieldNameFor("resource_identifier"), options, out_stream);
                return false;
            }
        } = null,
        include_nested_stacks: ?bool = null,
        on_stack_failure: ?[]const u8 = null,
        import_existing_resources: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .use_previous_template = "UsePreviousTemplate",
                .parameters = "Parameters",
                .capabilities = "Capabilities",
                .resource_types = "ResourceTypes",
                .role_arn = "RoleARN",
                .rollback_configuration = "RollbackConfiguration",
                .notification_ar_ns = "NotificationARNs",
                .tags = "Tags",
                .change_set_name = "ChangeSetName",
                .client_token = "ClientToken",
                .description = "Description",
                .change_set_type = "ChangeSetType",
                .resources_to_import = "ResourcesToImport",
                .include_nested_stacks = "IncludeNestedStacks",
                .on_stack_failure = "OnStackFailure",
                .import_existing_resources = "ImportExistingResources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_change_set) } {
            return .{ .service_metadata = service_metadata, .action = create_change_set };
        }
    },
    Response: type = struct {
        id: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        InsufficientCapabilities,
        LimitExceeded,
    },
} = .{};
pub const create_generated_template: struct {
    action_name: []const u8 = "CreateGeneratedTemplate",
    Request: type = struct {
        resources: ?[]ResourceDefinition = null,
        generated_template_name: []const u8,
        stack_name: ?[]const u8 = null,
        template_configuration: ?TemplateConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resources = "Resources",
                .generated_template_name = "GeneratedTemplateName",
                .stack_name = "StackName",
                .template_configuration = "TemplateConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_generated_template) } {
            return .{ .service_metadata = service_metadata, .action = create_generated_template };
        }
    },
    Response: type = struct {
        generated_template_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_id = "GeneratedTemplateId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        ConcurrentResourcesLimitExceeded,
        LimitExceeded,
    },
} = .{};
pub const create_stack: struct {
    action_name: []const u8 = "CreateStack",
    Request: type = struct {
        stack_name: []const u8,
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        parameters: ?[]Parameter = null,
        disable_rollback: ?bool = null,
        rollback_configuration: ?RollbackConfiguration = null,
        timeout_in_minutes: ?i64 = null,
        notification_ar_ns: ?[][]const u8 = null,
        capabilities: ?[][]const u8 = null,
        resource_types: ?[][]const u8 = null,
        role_arn: ?[]const u8 = null,
        on_failure: ?[]const u8 = null,
        stack_policy_body: ?[]const u8 = null,
        stack_policy_url: ?[]const u8 = null,
        tags: ?[]Tag = null,
        client_request_token: ?[]const u8 = null,
        enable_termination_protection: ?bool = null,
        retain_except_on_create: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .parameters = "Parameters",
                .disable_rollback = "DisableRollback",
                .rollback_configuration = "RollbackConfiguration",
                .timeout_in_minutes = "TimeoutInMinutes",
                .notification_ar_ns = "NotificationARNs",
                .capabilities = "Capabilities",
                .resource_types = "ResourceTypes",
                .role_arn = "RoleARN",
                .on_failure = "OnFailure",
                .stack_policy_body = "StackPolicyBody",
                .stack_policy_url = "StackPolicyURL",
                .tags = "Tags",
                .client_request_token = "ClientRequestToken",
                .enable_termination_protection = "EnableTerminationProtection",
                .retain_except_on_create = "RetainExceptOnCreate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_stack) } {
            return .{ .service_metadata = service_metadata, .action = create_stack };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        InsufficientCapabilities,
        LimitExceeded,
        TokenAlreadyExists,
    },
} = .{};
pub const create_stack_instances: struct {
    action_name: []const u8 = "CreateStackInstances",
    Request: type = struct {
        stack_set_name: []const u8,
        accounts: ?[][]const u8 = null,
        deployment_targets: ?DeploymentTargets = null,
        regions: [][]const u8,
        parameter_overrides: ?[]Parameter = null,
        operation_preferences: ?StackSetOperationPreferences = null,
        operation_id: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .accounts = "Accounts",
                .deployment_targets = "DeploymentTargets",
                .regions = "Regions",
                .parameter_overrides = "ParameterOverrides",
                .operation_preferences = "OperationPreferences",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_stack_instances) } {
            return .{ .service_metadata = service_metadata, .action = create_stack_instances };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        LimitExceeded,
        OperationIdAlreadyExists,
        OperationInProgress,
        StackSetNotFound,
        StaleRequest,
    },
} = .{};
pub const create_stack_set: struct {
    action_name: []const u8 = "CreateStackSet",
    Request: type = struct {
        stack_set_name: []const u8,
        description: ?[]const u8 = null,
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        parameters: ?[]Parameter = null,
        capabilities: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        administration_role_arn: ?[]const u8 = null,
        execution_role_name: ?[]const u8 = null,
        permission_model: ?[]const u8 = null,
        auto_deployment: ?AutoDeployment = null,
        call_as: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        managed_execution: ?ManagedExecution = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .description = "Description",
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .stack_id = "StackId",
                .parameters = "Parameters",
                .capabilities = "Capabilities",
                .tags = "Tags",
                .administration_role_arn = "AdministrationRoleARN",
                .execution_role_name = "ExecutionRoleName",
                .permission_model = "PermissionModel",
                .auto_deployment = "AutoDeployment",
                .call_as = "CallAs",
                .client_request_token = "ClientRequestToken",
                .managed_execution = "ManagedExecution",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_stack_set) } {
            return .{ .service_metadata = service_metadata, .action = create_stack_set };
        }
    },
    Response: type = struct {
        stack_set_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_id = "StackSetId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CreatedButModified,
        LimitExceeded,
        NameAlreadyExists,
    },
} = .{};
pub const deactivate_organizations_access: struct {
    action_name: []const u8 = "DeactivateOrganizationsAccess",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deactivate_organizations_access) } {
            return .{ .service_metadata = service_metadata, .action = deactivate_organizations_access };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationNotFound,
    },
} = .{};
pub const deactivate_type: struct {
    action_name: []const u8 = "DeactivateType",
    Request: type = struct {
        type_name: ?[]const u8 = null,
        type: ?[]const u8 = null,
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_name = "TypeName",
                .type = "Type",
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deactivate_type) } {
            return .{ .service_metadata = service_metadata, .action = deactivate_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const delete_change_set: struct {
    action_name: []const u8 = "DeleteChangeSet",
    Request: type = struct {
        change_set_name: []const u8,
        stack_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_name = "ChangeSetName",
                .stack_name = "StackName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_change_set) } {
            return .{ .service_metadata = service_metadata, .action = delete_change_set };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidChangeSetStatus,
    },
} = .{};
pub const delete_generated_template: struct {
    action_name: []const u8 = "DeleteGeneratedTemplate",
    Request: type = struct {
        generated_template_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_name = "GeneratedTemplateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_generated_template) } {
            return .{ .service_metadata = service_metadata, .action = delete_generated_template };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentResourcesLimitExceeded,
        GeneratedTemplateNotFound,
    },
} = .{};
pub const delete_stack: struct {
    action_name: []const u8 = "DeleteStack",
    Request: type = struct {
        stack_name: []const u8,
        retain_resources: ?[][]const u8 = null,
        role_arn: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .retain_resources = "RetainResources",
                .role_arn = "RoleARN",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_stack) } {
            return .{ .service_metadata = service_metadata, .action = delete_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        TokenAlreadyExists,
    },
} = .{};
pub const delete_stack_instances: struct {
    action_name: []const u8 = "DeleteStackInstances",
    Request: type = struct {
        stack_set_name: []const u8,
        accounts: ?[][]const u8 = null,
        deployment_targets: ?DeploymentTargets = null,
        regions: [][]const u8,
        operation_preferences: ?StackSetOperationPreferences = null,
        retain_stacks: bool,
        operation_id: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .accounts = "Accounts",
                .deployment_targets = "DeploymentTargets",
                .regions = "Regions",
                .operation_preferences = "OperationPreferences",
                .retain_stacks = "RetainStacks",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_stack_instances) } {
            return .{ .service_metadata = service_metadata, .action = delete_stack_instances };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationIdAlreadyExists,
        OperationInProgress,
        StackSetNotFound,
        StaleRequest,
    },
} = .{};
pub const delete_stack_set: struct {
    action_name: []const u8 = "DeleteStackSet",
    Request: type = struct {
        stack_set_name: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_stack_set) } {
            return .{ .service_metadata = service_metadata, .action = delete_stack_set };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        OperationInProgress,
        StackSetNotEmpty,
    },
} = .{};
pub const deregister_type: struct {
    action_name: []const u8 = "DeregisterType",
    Request: type = struct {
        arn: ?[]const u8 = null,
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        version_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .type = "Type",
                .type_name = "TypeName",
                .version_id = "VersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_type) } {
            return .{ .service_metadata = service_metadata, .action = deregister_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const describe_account_limits: struct {
    action_name: []const u8 = "DescribeAccountLimits",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_account_limits) } {
            return .{ .service_metadata = service_metadata, .action = describe_account_limits };
        }
    },
    Response: type = struct {
        account_limits: ?[]struct {
            name: ?[]const u8 = null,
            value: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .value = "Value",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_limits = "AccountLimits",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_change_set: struct {
    action_name: []const u8 = "DescribeChangeSet",
    Request: type = struct {
        change_set_name: []const u8,
        stack_name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_name = "ChangeSetName",
                .stack_name = "StackName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_change_set) } {
            return .{ .service_metadata = service_metadata, .action = describe_change_set };
        }
    },
    Response: type = struct {
        change_set_name: ?[]const u8 = null,
        change_set_id: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        stack_name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        parameters: ?[]Parameter = null,
        creation_time: ?i64 = null,
        execution_status: ?[]const u8 = null,
        status: ?[]const u8 = null,
        status_reason: ?[]const u8 = null,
        notification_ar_ns: ?[][]const u8 = null,
        rollback_configuration: ?RollbackConfiguration = null,
        capabilities: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        changes: ?[]struct {
            type: ?[]const u8 = null,
            hook_invocation_count: ?i64 = null,
            resource_change: ?struct {
                action: ?[]const u8 = null,
                logical_resource_id: ?[]const u8 = null,
                physical_resource_id: ?[]const u8 = null,
                resource_type: ?[]const u8 = null,
                replacement: ?[]const u8 = null,
                scope: ?[][]const u8 = null,
                details: ?[]struct {
                    target: ?struct {
                        attribute: ?[]const u8 = null,
                        name: ?[]const u8 = null,
                        requires_recreation: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .attribute = "Attribute",
                                .name = "Name",
                                .requires_recreation = "RequiresRecreation",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    evaluation: ?[]const u8 = null,
                    change_source: ?[]const u8 = null,
                    causing_entity: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .target = "Target",
                            .evaluation = "Evaluation",
                            .change_source = "ChangeSource",
                            .causing_entity = "CausingEntity",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                change_set_id: ?[]const u8 = null,
                module_info: ?ModuleInfo = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .action = "Action",
                        .logical_resource_id = "LogicalResourceId",
                        .physical_resource_id = "PhysicalResourceId",
                        .resource_type = "ResourceType",
                        .replacement = "Replacement",
                        .scope = "Scope",
                        .details = "Details",
                        .change_set_id = "ChangeSetId",
                        .module_info = "ModuleInfo",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .type = "Type",
                    .hook_invocation_count = "HookInvocationCount",
                    .resource_change = "ResourceChange",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        include_nested_stacks: ?bool = null,
        parent_change_set_id: ?[]const u8 = null,
        root_change_set_id: ?[]const u8 = null,
        on_stack_failure: ?[]const u8 = null,
        import_existing_resources: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_name = "ChangeSetName",
                .change_set_id = "ChangeSetId",
                .stack_id = "StackId",
                .stack_name = "StackName",
                .description = "Description",
                .parameters = "Parameters",
                .creation_time = "CreationTime",
                .execution_status = "ExecutionStatus",
                .status = "Status",
                .status_reason = "StatusReason",
                .notification_ar_ns = "NotificationARNs",
                .rollback_configuration = "RollbackConfiguration",
                .capabilities = "Capabilities",
                .tags = "Tags",
                .changes = "Changes",
                .next_token = "NextToken",
                .include_nested_stacks = "IncludeNestedStacks",
                .parent_change_set_id = "ParentChangeSetId",
                .root_change_set_id = "RootChangeSetId",
                .on_stack_failure = "OnStackFailure",
                .import_existing_resources = "ImportExistingResources",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ChangeSetNotFound,
    },
} = .{};
pub const describe_change_set_hooks: struct {
    action_name: []const u8 = "DescribeChangeSetHooks",
    Request: type = struct {
        change_set_name: []const u8,
        stack_name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        logical_resource_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_name = "ChangeSetName",
                .stack_name = "StackName",
                .next_token = "NextToken",
                .logical_resource_id = "LogicalResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_change_set_hooks) } {
            return .{ .service_metadata = service_metadata, .action = describe_change_set_hooks };
        }
    },
    Response: type = struct {
        change_set_id: ?[]const u8 = null,
        change_set_name: ?[]const u8 = null,
        hooks: ?[]struct {
            invocation_point: ?[]const u8 = null,
            failure_mode: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            type_version_id: ?[]const u8 = null,
            type_configuration_version_id: ?[]const u8 = null,
            target_details: ?struct {
                target_type: ?[]const u8 = null,
                resource_target_details: ?struct {
                    logical_resource_id: ?[]const u8 = null,
                    resource_type: ?[]const u8 = null,
                    resource_action: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .logical_resource_id = "LogicalResourceId",
                            .resource_type = "ResourceType",
                            .resource_action = "ResourceAction",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .target_type = "TargetType",
                        .resource_target_details = "ResourceTargetDetails",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .invocation_point = "InvocationPoint",
                    .failure_mode = "FailureMode",
                    .type_name = "TypeName",
                    .type_version_id = "TypeVersionId",
                    .type_configuration_version_id = "TypeConfigurationVersionId",
                    .target_details = "TargetDetails",
                };
                return @field(mappings, field_name);
            }
        } = null,
        status: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        stack_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_id = "ChangeSetId",
                .change_set_name = "ChangeSetName",
                .hooks = "Hooks",
                .status = "Status",
                .next_token = "NextToken",
                .stack_id = "StackId",
                .stack_name = "StackName",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ChangeSetNotFound,
    },
} = .{};
pub const describe_generated_template: struct {
    action_name: []const u8 = "DescribeGeneratedTemplate",
    Request: type = struct {
        generated_template_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_name = "GeneratedTemplateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_generated_template) } {
            return .{ .service_metadata = service_metadata, .action = describe_generated_template };
        }
    },
    Response: type = struct {
        generated_template_id: ?[]const u8 = null,
        generated_template_name: ?[]const u8 = null,
        resources: ?[]struct {
            resource_type: ?[]const u8 = null,
            logical_resource_id: ?[]const u8 = null,
            resource_identifier: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            resource_status: ?[]const u8 = null,
            resource_status_reason: ?[]const u8 = null,
            warnings: ?[]struct {
                type: ?[]const u8 = null,
                properties: ?[]struct {
                    property_path: ?[]const u8 = null,
                    required: ?bool = null,
                    description: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .property_path = "PropertyPath",
                            .required = "Required",
                            .description = "Description",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .type = "Type",
                        .properties = "Properties",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_type = "ResourceType",
                    .logical_resource_id = "LogicalResourceId",
                    .resource_identifier = "ResourceIdentifier",
                    .resource_status = "ResourceStatus",
                    .resource_status_reason = "ResourceStatusReason",
                    .warnings = "Warnings",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "resource_identifier", field_name))
                    return try serializeMap(self.resource_identifier, self.fieldNameFor("resource_identifier"), options, out_stream);
                return false;
            }
        } = null,
        status: ?[]const u8 = null,
        status_reason: ?[]const u8 = null,
        creation_time: ?i64 = null,
        last_updated_time: ?i64 = null,
        progress: ?struct {
            resources_succeeded: ?i64 = null,
            resources_failed: ?i64 = null,
            resources_processing: ?i64 = null,
            resources_pending: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resources_succeeded = "ResourcesSucceeded",
                    .resources_failed = "ResourcesFailed",
                    .resources_processing = "ResourcesProcessing",
                    .resources_pending = "ResourcesPending",
                };
                return @field(mappings, field_name);
            }
        } = null,
        stack_id: ?[]const u8 = null,
        template_configuration: ?TemplateConfiguration = null,
        total_warnings: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_id = "GeneratedTemplateId",
                .generated_template_name = "GeneratedTemplateName",
                .resources = "Resources",
                .status = "Status",
                .status_reason = "StatusReason",
                .creation_time = "CreationTime",
                .last_updated_time = "LastUpdatedTime",
                .progress = "Progress",
                .stack_id = "StackId",
                .template_configuration = "TemplateConfiguration",
                .total_warnings = "TotalWarnings",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        GeneratedTemplateNotFound,
    },
} = .{};
pub const describe_organizations_access: struct {
    action_name: []const u8 = "DescribeOrganizationsAccess",
    Request: type = struct {
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_organizations_access) } {
            return .{ .service_metadata = service_metadata, .action = describe_organizations_access };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "Status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationNotFound,
    },
} = .{};
pub const describe_publisher: struct {
    action_name: []const u8 = "DescribePublisher",
    Request: type = struct {
        publisher_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .publisher_id = "PublisherId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_publisher) } {
            return .{ .service_metadata = service_metadata, .action = describe_publisher };
        }
    },
    Response: type = struct {
        publisher_id: ?[]const u8 = null,
        publisher_status: ?[]const u8 = null,
        identity_provider: ?[]const u8 = null,
        publisher_profile: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .publisher_id = "PublisherId",
                .publisher_status = "PublisherStatus",
                .identity_provider = "IdentityProvider",
                .publisher_profile = "PublisherProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const describe_resource_scan: struct {
    action_name: []const u8 = "DescribeResourceScan",
    Request: type = struct {
        resource_scan_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_id = "ResourceScanId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_resource_scan) } {
            return .{ .service_metadata = service_metadata, .action = describe_resource_scan };
        }
    },
    Response: type = struct {
        resource_scan_id: ?[]const u8 = null,
        status: ?[]const u8 = null,
        status_reason: ?[]const u8 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        percentage_completed: ?f64 = null,
        resource_types: ?[][]const u8 = null,
        resources_scanned: ?i64 = null,
        resources_read: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_id = "ResourceScanId",
                .status = "Status",
                .status_reason = "StatusReason",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .percentage_completed = "PercentageCompleted",
                .resource_types = "ResourceTypes",
                .resources_scanned = "ResourcesScanned",
                .resources_read = "ResourcesRead",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceScanNotFound,
    },
} = .{};
pub const describe_stack_drift_detection_status: struct {
    action_name: []const u8 = "DescribeStackDriftDetectionStatus",
    Request: type = struct {
        stack_drift_detection_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_drift_detection_id = "StackDriftDetectionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_drift_detection_status) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_drift_detection_status };
        }
    },
    Response: type = struct {
        stack_id: []const u8,
        stack_drift_detection_id: []const u8,
        stack_drift_status: ?[]const u8 = null,
        detection_status: []const u8,
        detection_status_reason: ?[]const u8 = null,
        drifted_stack_resource_count: ?i64 = null,
        timestamp: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .stack_drift_detection_id = "StackDriftDetectionId",
                .stack_drift_status = "StackDriftStatus",
                .detection_status = "DetectionStatus",
                .detection_status_reason = "DetectionStatusReason",
                .drifted_stack_resource_count = "DriftedStackResourceCount",
                .timestamp = "Timestamp",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stack_events: struct {
    action_name: []const u8 = "DescribeStackEvents",
    Request: type = struct {
        stack_name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_events) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_events };
        }
    },
    Response: type = struct {
        stack_events: ?[]struct {
            stack_id: []const u8,
            event_id: []const u8,
            stack_name: []const u8,
            logical_resource_id: ?[]const u8 = null,
            physical_resource_id: ?[]const u8 = null,
            resource_type: ?[]const u8 = null,
            timestamp: i64,
            resource_status: ?[]const u8 = null,
            resource_status_reason: ?[]const u8 = null,
            resource_properties: ?[]const u8 = null,
            client_request_token: ?[]const u8 = null,
            hook_type: ?[]const u8 = null,
            hook_status: ?[]const u8 = null,
            hook_status_reason: ?[]const u8 = null,
            hook_invocation_point: ?[]const u8 = null,
            hook_failure_mode: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .event_id = "EventId",
                    .stack_name = "StackName",
                    .logical_resource_id = "LogicalResourceId",
                    .physical_resource_id = "PhysicalResourceId",
                    .resource_type = "ResourceType",
                    .timestamp = "Timestamp",
                    .resource_status = "ResourceStatus",
                    .resource_status_reason = "ResourceStatusReason",
                    .resource_properties = "ResourceProperties",
                    .client_request_token = "ClientRequestToken",
                    .hook_type = "HookType",
                    .hook_status = "HookStatus",
                    .hook_status_reason = "HookStatusReason",
                    .hook_invocation_point = "HookInvocationPoint",
                    .hook_failure_mode = "HookFailureMode",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_events = "StackEvents",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stack_instance: struct {
    action_name: []const u8 = "DescribeStackInstance",
    Request: type = struct {
        stack_set_name: []const u8,
        stack_instance_account: []const u8,
        stack_instance_region: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .stack_instance_account = "StackInstanceAccount",
                .stack_instance_region = "StackInstanceRegion",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_instance) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_instance };
        }
    },
    Response: type = struct {
        stack_instance: ?struct {
            stack_set_id: ?[]const u8 = null,
            region: ?[]const u8 = null,
            account: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            parameter_overrides: ?[]Parameter = null,
            status: ?[]const u8 = null,
            stack_instance_status: ?StackInstanceComprehensiveStatus = null,
            status_reason: ?[]const u8 = null,
            organizational_unit_id: ?[]const u8 = null,
            drift_status: ?[]const u8 = null,
            last_drift_check_timestamp: ?i64 = null,
            last_operation_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_set_id = "StackSetId",
                    .region = "Region",
                    .account = "Account",
                    .stack_id = "StackId",
                    .parameter_overrides = "ParameterOverrides",
                    .status = "Status",
                    .stack_instance_status = "StackInstanceStatus",
                    .status_reason = "StatusReason",
                    .organizational_unit_id = "OrganizationalUnitId",
                    .drift_status = "DriftStatus",
                    .last_drift_check_timestamp = "LastDriftCheckTimestamp",
                    .last_operation_id = "LastOperationId",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_instance = "StackInstance",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        StackInstanceNotFound,
        StackSetNotFound,
    },
} = .{};
pub const describe_stack_resource: struct {
    action_name: []const u8 = "DescribeStackResource",
    Request: type = struct {
        stack_name: []const u8,
        logical_resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .logical_resource_id = "LogicalResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_resource) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_resource };
        }
    },
    Response: type = struct {
        stack_resource_detail: ?struct {
            stack_name: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            logical_resource_id: []const u8,
            physical_resource_id: ?[]const u8 = null,
            resource_type: []const u8,
            last_updated_timestamp: i64,
            resource_status: []const u8,
            resource_status_reason: ?[]const u8 = null,
            description: ?[]const u8 = null,
            metadata: ?[]const u8 = null,
            drift_information: ?StackResourceDriftInformation = null,
            module_info: ?ModuleInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_name = "StackName",
                    .stack_id = "StackId",
                    .logical_resource_id = "LogicalResourceId",
                    .physical_resource_id = "PhysicalResourceId",
                    .resource_type = "ResourceType",
                    .last_updated_timestamp = "LastUpdatedTimestamp",
                    .resource_status = "ResourceStatus",
                    .resource_status_reason = "ResourceStatusReason",
                    .description = "Description",
                    .metadata = "Metadata",
                    .drift_information = "DriftInformation",
                    .module_info = "ModuleInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_resource_detail = "StackResourceDetail",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stack_resource_drifts: struct {
    action_name: []const u8 = "DescribeStackResourceDrifts",
    Request: type = struct {
        stack_name: []const u8,
        stack_resource_drift_status_filters: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .stack_resource_drift_status_filters = "StackResourceDriftStatusFilters",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_resource_drifts) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_resource_drifts };
        }
    },
    Response: type = struct {
        stack_resource_drifts: []StackResourceDrift,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_resource_drifts = "StackResourceDrifts",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stack_resources: struct {
    action_name: []const u8 = "DescribeStackResources",
    Request: type = struct {
        stack_name: ?[]const u8 = null,
        logical_resource_id: ?[]const u8 = null,
        physical_resource_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .logical_resource_id = "LogicalResourceId",
                .physical_resource_id = "PhysicalResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_resources) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_resources };
        }
    },
    Response: type = struct {
        stack_resources: ?[]struct {
            stack_name: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            logical_resource_id: []const u8,
            physical_resource_id: ?[]const u8 = null,
            resource_type: []const u8,
            timestamp: i64,
            resource_status: []const u8,
            resource_status_reason: ?[]const u8 = null,
            description: ?[]const u8 = null,
            drift_information: ?StackResourceDriftInformation = null,
            module_info: ?ModuleInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_name = "StackName",
                    .stack_id = "StackId",
                    .logical_resource_id = "LogicalResourceId",
                    .physical_resource_id = "PhysicalResourceId",
                    .resource_type = "ResourceType",
                    .timestamp = "Timestamp",
                    .resource_status = "ResourceStatus",
                    .resource_status_reason = "ResourceStatusReason",
                    .description = "Description",
                    .drift_information = "DriftInformation",
                    .module_info = "ModuleInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_resources = "StackResources",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stacks: struct {
    action_name: []const u8 = "DescribeStacks",
    Request: type = struct {
        stack_name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stacks) } {
            return .{ .service_metadata = service_metadata, .action = describe_stacks };
        }
    },
    Response: type = struct {
        stacks: ?[]struct {
            stack_id: ?[]const u8 = null,
            stack_name: []const u8,
            change_set_id: ?[]const u8 = null,
            description: ?[]const u8 = null,
            parameters: ?[]Parameter = null,
            creation_time: i64,
            deletion_time: ?i64 = null,
            last_updated_time: ?i64 = null,
            rollback_configuration: ?RollbackConfiguration = null,
            stack_status: []const u8,
            stack_status_reason: ?[]const u8 = null,
            disable_rollback: ?bool = null,
            notification_ar_ns: ?[][]const u8 = null,
            timeout_in_minutes: ?i64 = null,
            capabilities: ?[][]const u8 = null,
            outputs: ?[]struct {
                output_key: ?[]const u8 = null,
                output_value: ?[]const u8 = null,
                description: ?[]const u8 = null,
                export_name: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .output_key = "OutputKey",
                        .output_value = "OutputValue",
                        .description = "Description",
                        .export_name = "ExportName",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            role_arn: ?[]const u8 = null,
            tags: ?[]Tag = null,
            enable_termination_protection: ?bool = null,
            parent_id: ?[]const u8 = null,
            root_id: ?[]const u8 = null,
            drift_information: ?struct {
                stack_drift_status: []const u8,
                last_check_timestamp: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .stack_drift_status = "StackDriftStatus",
                        .last_check_timestamp = "LastCheckTimestamp",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            retain_except_on_create: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .stack_name = "StackName",
                    .change_set_id = "ChangeSetId",
                    .description = "Description",
                    .parameters = "Parameters",
                    .creation_time = "CreationTime",
                    .deletion_time = "DeletionTime",
                    .last_updated_time = "LastUpdatedTime",
                    .rollback_configuration = "RollbackConfiguration",
                    .stack_status = "StackStatus",
                    .stack_status_reason = "StackStatusReason",
                    .disable_rollback = "DisableRollback",
                    .notification_ar_ns = "NotificationARNs",
                    .timeout_in_minutes = "TimeoutInMinutes",
                    .capabilities = "Capabilities",
                    .outputs = "Outputs",
                    .role_arn = "RoleARN",
                    .tags = "Tags",
                    .enable_termination_protection = "EnableTerminationProtection",
                    .parent_id = "ParentId",
                    .root_id = "RootId",
                    .drift_information = "DriftInformation",
                    .retain_except_on_create = "RetainExceptOnCreate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stacks = "Stacks",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_stack_set: struct {
    action_name: []const u8 = "DescribeStackSet",
    Request: type = struct {
        stack_set_name: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_set) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_set };
        }
    },
    Response: type = struct {
        stack_set: ?struct {
            stack_set_name: ?[]const u8 = null,
            stack_set_id: ?[]const u8 = null,
            description: ?[]const u8 = null,
            status: ?[]const u8 = null,
            template_body: ?[]const u8 = null,
            parameters: ?[]Parameter = null,
            capabilities: ?[][]const u8 = null,
            tags: ?[]Tag = null,
            stack_set_arn: ?[]const u8 = null,
            administration_role_arn: ?[]const u8 = null,
            execution_role_name: ?[]const u8 = null,
            stack_set_drift_detection_details: ?StackSetDriftDetectionDetails = null,
            auto_deployment: ?AutoDeployment = null,
            permission_model: ?[]const u8 = null,
            organizational_unit_ids: ?[][]const u8 = null,
            managed_execution: ?ManagedExecution = null,
            regions: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_set_name = "StackSetName",
                    .stack_set_id = "StackSetId",
                    .description = "Description",
                    .status = "Status",
                    .template_body = "TemplateBody",
                    .parameters = "Parameters",
                    .capabilities = "Capabilities",
                    .tags = "Tags",
                    .stack_set_arn = "StackSetARN",
                    .administration_role_arn = "AdministrationRoleARN",
                    .execution_role_name = "ExecutionRoleName",
                    .stack_set_drift_detection_details = "StackSetDriftDetectionDetails",
                    .auto_deployment = "AutoDeployment",
                    .permission_model = "PermissionModel",
                    .organizational_unit_ids = "OrganizationalUnitIds",
                    .managed_execution = "ManagedExecution",
                    .regions = "Regions",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set = "StackSet",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        StackSetNotFound,
    },
} = .{};
pub const describe_stack_set_operation: struct {
    action_name: []const u8 = "DescribeStackSetOperation",
    Request: type = struct {
        stack_set_name: []const u8,
        operation_id: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_set_operation) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_set_operation };
        }
    },
    Response: type = struct {
        stack_set_operation: ?struct {
            operation_id: ?[]const u8 = null,
            stack_set_id: ?[]const u8 = null,
            action: ?[]const u8 = null,
            status: ?[]const u8 = null,
            operation_preferences: ?StackSetOperationPreferences = null,
            retain_stacks: ?bool = null,
            administration_role_arn: ?[]const u8 = null,
            execution_role_name: ?[]const u8 = null,
            creation_timestamp: ?i64 = null,
            end_timestamp: ?i64 = null,
            deployment_targets: ?DeploymentTargets = null,
            stack_set_drift_detection_details: ?StackSetDriftDetectionDetails = null,
            status_reason: ?[]const u8 = null,
            status_details: ?StackSetOperationStatusDetails = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .operation_id = "OperationId",
                    .stack_set_id = "StackSetId",
                    .action = "Action",
                    .status = "Status",
                    .operation_preferences = "OperationPreferences",
                    .retain_stacks = "RetainStacks",
                    .administration_role_arn = "AdministrationRoleARN",
                    .execution_role_name = "ExecutionRoleName",
                    .creation_timestamp = "CreationTimestamp",
                    .end_timestamp = "EndTimestamp",
                    .deployment_targets = "DeploymentTargets",
                    .stack_set_drift_detection_details = "StackSetDriftDetectionDetails",
                    .status_reason = "StatusReason",
                    .status_details = "StatusDetails",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_operation = "StackSetOperation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        OperationNotFound,
        StackSetNotFound,
    },
} = .{};
pub const describe_type: struct {
    action_name: []const u8 = "DescribeType",
    Request: type = struct {
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        arn: ?[]const u8 = null,
        version_id: ?[]const u8 = null,
        publisher_id: ?[]const u8 = null,
        public_version_number: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .type_name = "TypeName",
                .arn = "Arn",
                .version_id = "VersionId",
                .publisher_id = "PublisherId",
                .public_version_number = "PublicVersionNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_type) } {
            return .{ .service_metadata = service_metadata, .action = describe_type };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        default_version_id: ?[]const u8 = null,
        is_default_version: ?bool = null,
        type_tests_status: ?[]const u8 = null,
        type_tests_status_description: ?[]const u8 = null,
        description: ?[]const u8 = null,
        schema: ?[]const u8 = null,
        provisioning_type: ?[]const u8 = null,
        deprecated_status: ?[]const u8 = null,
        logging_config: ?LoggingConfig = null,
        required_activated_types: ?[]struct {
            type_name_alias: ?[]const u8 = null,
            original_type_name: ?[]const u8 = null,
            publisher_id: ?[]const u8 = null,
            supported_major_versions: ?[]i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .type_name_alias = "TypeNameAlias",
                    .original_type_name = "OriginalTypeName",
                    .publisher_id = "PublisherId",
                    .supported_major_versions = "SupportedMajorVersions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        execution_role_arn: ?[]const u8 = null,
        visibility: ?[]const u8 = null,
        source_url: ?[]const u8 = null,
        documentation_url: ?[]const u8 = null,
        last_updated: ?i64 = null,
        time_created: ?i64 = null,
        configuration_schema: ?[]const u8 = null,
        publisher_id: ?[]const u8 = null,
        original_type_name: ?[]const u8 = null,
        original_type_arn: ?[]const u8 = null,
        public_version_number: ?[]const u8 = null,
        latest_public_version: ?[]const u8 = null,
        is_activated: ?bool = null,
        auto_update: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .type = "Type",
                .type_name = "TypeName",
                .default_version_id = "DefaultVersionId",
                .is_default_version = "IsDefaultVersion",
                .type_tests_status = "TypeTestsStatus",
                .type_tests_status_description = "TypeTestsStatusDescription",
                .description = "Description",
                .schema = "Schema",
                .provisioning_type = "ProvisioningType",
                .deprecated_status = "DeprecatedStatus",
                .logging_config = "LoggingConfig",
                .required_activated_types = "RequiredActivatedTypes",
                .execution_role_arn = "ExecutionRoleArn",
                .visibility = "Visibility",
                .source_url = "SourceUrl",
                .documentation_url = "DocumentationUrl",
                .last_updated = "LastUpdated",
                .time_created = "TimeCreated",
                .configuration_schema = "ConfigurationSchema",
                .publisher_id = "PublisherId",
                .original_type_name = "OriginalTypeName",
                .original_type_arn = "OriginalTypeArn",
                .public_version_number = "PublicVersionNumber",
                .latest_public_version = "LatestPublicVersion",
                .is_activated = "IsActivated",
                .auto_update = "AutoUpdate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const describe_type_registration: struct {
    action_name: []const u8 = "DescribeTypeRegistration",
    Request: type = struct {
        registration_token: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .registration_token = "RegistrationToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_type_registration) } {
            return .{ .service_metadata = service_metadata, .action = describe_type_registration };
        }
    },
    Response: type = struct {
        progress_status: ?[]const u8 = null,
        description: ?[]const u8 = null,
        type_arn: ?[]const u8 = null,
        type_version_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .progress_status = "ProgressStatus",
                .description = "Description",
                .type_arn = "TypeArn",
                .type_version_arn = "TypeVersionArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const detect_stack_drift: struct {
    action_name: []const u8 = "DetectStackDrift",
    Request: type = struct {
        stack_name: []const u8,
        logical_resource_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .logical_resource_ids = "LogicalResourceIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_stack_drift) } {
            return .{ .service_metadata = service_metadata, .action = detect_stack_drift };
        }
    },
    Response: type = struct {
        stack_drift_detection_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_drift_detection_id = "StackDriftDetectionId",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const detect_stack_resource_drift: struct {
    action_name: []const u8 = "DetectStackResourceDrift",
    Request: type = struct {
        stack_name: []const u8,
        logical_resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .logical_resource_id = "LogicalResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_stack_resource_drift) } {
            return .{ .service_metadata = service_metadata, .action = detect_stack_resource_drift };
        }
    },
    Response: type = struct {
        stack_resource_drift: StackResourceDrift,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_resource_drift = "StackResourceDrift",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const detect_stack_set_drift: struct {
    action_name: []const u8 = "DetectStackSetDrift",
    Request: type = struct {
        stack_set_name: []const u8,
        operation_preferences: ?StackSetOperationPreferences = null,
        operation_id: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .operation_preferences = "OperationPreferences",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_stack_set_drift) } {
            return .{ .service_metadata = service_metadata, .action = detect_stack_set_drift };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationInProgress,
        StackSetNotFound,
    },
} = .{};
pub const estimate_template_cost: struct {
    action_name: []const u8 = "EstimateTemplateCost",
    Request: type = struct {
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        parameters: ?[]Parameter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .parameters = "Parameters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(estimate_template_cost) } {
            return .{ .service_metadata = service_metadata, .action = estimate_template_cost };
        }
    },
    Response: type = struct {
        url: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .url = "Url",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const execute_change_set: struct {
    action_name: []const u8 = "ExecuteChangeSet",
    Request: type = struct {
        change_set_name: []const u8,
        stack_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        disable_rollback: ?bool = null,
        retain_except_on_create: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .change_set_name = "ChangeSetName",
                .stack_name = "StackName",
                .client_request_token = "ClientRequestToken",
                .disable_rollback = "DisableRollback",
                .retain_except_on_create = "RetainExceptOnCreate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(execute_change_set) } {
            return .{ .service_metadata = service_metadata, .action = execute_change_set };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ChangeSetNotFound,
        InsufficientCapabilities,
        InvalidChangeSetStatus,
        TokenAlreadyExists,
    },
} = .{};
pub const get_generated_template: struct {
    action_name: []const u8 = "GetGeneratedTemplate",
    Request: type = struct {
        format: ?[]const u8 = null,
        generated_template_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .format = "Format",
                .generated_template_name = "GeneratedTemplateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_generated_template) } {
            return .{ .service_metadata = service_metadata, .action = get_generated_template };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,
        template_body: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "Status",
                .template_body = "TemplateBody",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        GeneratedTemplateNotFound,
    },
} = .{};
pub const get_stack_policy: struct {
    action_name: []const u8 = "GetStackPolicy",
    Request: type = struct {
        stack_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_stack_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_stack_policy };
        }
    },
    Response: type = struct {
        stack_policy_body: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_policy_body = "StackPolicyBody",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const get_template: struct {
    action_name: []const u8 = "GetTemplate",
    Request: type = struct {
        stack_name: ?[]const u8 = null,
        change_set_name: ?[]const u8 = null,
        template_stage: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .change_set_name = "ChangeSetName",
                .template_stage = "TemplateStage",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_template) } {
            return .{ .service_metadata = service_metadata, .action = get_template };
        }
    },
    Response: type = struct {
        template_body: ?[]const u8 = null,
        stages_available: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .template_body = "TemplateBody",
                .stages_available = "StagesAvailable",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ChangeSetNotFound,
    },
} = .{};
pub const get_template_summary: struct {
    action_name: []const u8 = "GetTemplateSummary",
    Request: type = struct {
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        stack_name: ?[]const u8 = null,
        stack_set_name: ?[]const u8 = null,
        call_as: ?[]const u8 = null,
        template_summary_config: ?struct {
            treat_unrecognized_resource_types_as_warnings: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .treat_unrecognized_resource_types_as_warnings = "TreatUnrecognizedResourceTypesAsWarnings",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .stack_name = "StackName",
                .stack_set_name = "StackSetName",
                .call_as = "CallAs",
                .template_summary_config = "TemplateSummaryConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_template_summary) } {
            return .{ .service_metadata = service_metadata, .action = get_template_summary };
        }
    },
    Response: type = struct {
        parameters: ?[]struct {
            parameter_key: ?[]const u8 = null,
            default_value: ?[]const u8 = null,
            parameter_type: ?[]const u8 = null,
            no_echo: ?bool = null,
            description: ?[]const u8 = null,
            parameter_constraints: ?struct {
                allowed_values: ?[][]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .allowed_values = "AllowedValues",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .parameter_key = "ParameterKey",
                    .default_value = "DefaultValue",
                    .parameter_type = "ParameterType",
                    .no_echo = "NoEcho",
                    .description = "Description",
                    .parameter_constraints = "ParameterConstraints",
                };
                return @field(mappings, field_name);
            }
        } = null,
        description: ?[]const u8 = null,
        capabilities: ?[][]const u8 = null,
        capabilities_reason: ?[]const u8 = null,
        resource_types: ?[][]const u8 = null,
        version: ?[]const u8 = null,
        metadata: ?[]const u8 = null,
        declared_transforms: ?[][]const u8 = null,
        resource_identifier_summaries: ?[]struct {
            resource_type: ?[]const u8 = null,
            logical_resource_ids: ?[][]const u8 = null,
            resource_identifiers: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_type = "ResourceType",
                    .logical_resource_ids = "LogicalResourceIds",
                    .resource_identifiers = "ResourceIdentifiers",
                };
                return @field(mappings, field_name);
            }
        } = null,
        warnings: ?struct {
            unrecognized_resource_types: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .unrecognized_resource_types = "UnrecognizedResourceTypes",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .parameters = "Parameters",
                .description = "Description",
                .capabilities = "Capabilities",
                .capabilities_reason = "CapabilitiesReason",
                .resource_types = "ResourceTypes",
                .version = "Version",
                .metadata = "Metadata",
                .declared_transforms = "DeclaredTransforms",
                .resource_identifier_summaries = "ResourceIdentifierSummaries",
                .warnings = "Warnings",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        StackSetNotFound,
    },
} = .{};
pub const import_stacks_to_stack_set: struct {
    action_name: []const u8 = "ImportStacksToStackSet",
    Request: type = struct {
        stack_set_name: []const u8,
        stack_ids: ?[][]const u8 = null,
        stack_ids_url: ?[]const u8 = null,
        organizational_unit_ids: ?[][]const u8 = null,
        operation_preferences: ?StackSetOperationPreferences = null,
        operation_id: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .stack_ids = "StackIds",
                .stack_ids_url = "StackIdsUrl",
                .organizational_unit_ids = "OrganizationalUnitIds",
                .operation_preferences = "OperationPreferences",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_stacks_to_stack_set) } {
            return .{ .service_metadata = service_metadata, .action = import_stacks_to_stack_set };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        LimitExceeded,
        OperationIdAlreadyExists,
        OperationInProgress,
        StackNotFound,
        StackSetNotFound,
        StaleRequest,
    },
} = .{};
pub const list_change_sets: struct {
    action_name: []const u8 = "ListChangeSets",
    Request: type = struct {
        stack_name: []const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_change_sets) } {
            return .{ .service_metadata = service_metadata, .action = list_change_sets };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            stack_id: ?[]const u8 = null,
            stack_name: ?[]const u8 = null,
            change_set_id: ?[]const u8 = null,
            change_set_name: ?[]const u8 = null,
            execution_status: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            creation_time: ?i64 = null,
            description: ?[]const u8 = null,
            include_nested_stacks: ?bool = null,
            parent_change_set_id: ?[]const u8 = null,
            root_change_set_id: ?[]const u8 = null,
            import_existing_resources: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .stack_name = "StackName",
                    .change_set_id = "ChangeSetId",
                    .change_set_name = "ChangeSetName",
                    .execution_status = "ExecutionStatus",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .creation_time = "CreationTime",
                    .description = "Description",
                    .include_nested_stacks = "IncludeNestedStacks",
                    .parent_change_set_id = "ParentChangeSetId",
                    .root_change_set_id = "RootChangeSetId",
                    .import_existing_resources = "ImportExistingResources",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_exports: struct {
    action_name: []const u8 = "ListExports",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_exports) } {
            return .{ .service_metadata = service_metadata, .action = list_exports };
        }
    },
    Response: type = struct {
        exports: ?[]struct {
            exporting_stack_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            value: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .exporting_stack_id = "ExportingStackId",
                    .name = "Name",
                    .value = "Value",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .exports = "Exports",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_generated_templates: struct {
    action_name: []const u8 = "ListGeneratedTemplates",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_generated_templates) } {
            return .{ .service_metadata = service_metadata, .action = list_generated_templates };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            generated_template_id: ?[]const u8 = null,
            generated_template_name: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            creation_time: ?i64 = null,
            last_updated_time: ?i64 = null,
            number_of_resources: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .generated_template_id = "GeneratedTemplateId",
                    .generated_template_name = "GeneratedTemplateName",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .creation_time = "CreationTime",
                    .last_updated_time = "LastUpdatedTime",
                    .number_of_resources = "NumberOfResources",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_imports: struct {
    action_name: []const u8 = "ListImports",
    Request: type = struct {
        export_name: []const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_name = "ExportName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_imports) } {
            return .{ .service_metadata = service_metadata, .action = list_imports };
        }
    },
    Response: type = struct {
        imports: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .imports = "Imports",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_resource_scan_related_resources: struct {
    action_name: []const u8 = "ListResourceScanRelatedResources",
    Request: type = struct {
        resource_scan_id: []const u8,
        resources: []struct {
            resource_type: []const u8,
            resource_identifier: []struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            },

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_type = "ResourceType",
                    .resource_identifier = "ResourceIdentifier",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "resource_identifier", field_name))
                    return try serializeMap(self.resource_identifier, self.fieldNameFor("resource_identifier"), options, out_stream);
                return false;
            }
        },
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_id = "ResourceScanId",
                .resources = "Resources",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resource_scan_related_resources) } {
            return .{ .service_metadata = service_metadata, .action = list_resource_scan_related_resources };
        }
    },
    Response: type = struct {
        related_resources: ?[]ScannedResource = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .related_resources = "RelatedResources",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceScanInProgress,
        ResourceScanNotFound,
    },
} = .{};
pub const list_resource_scan_resources: struct {
    action_name: []const u8 = "ListResourceScanResources",
    Request: type = struct {
        resource_scan_id: []const u8,
        resource_identifier: ?[]const u8 = null,
        resource_type_prefix: ?[]const u8 = null,
        tag_key: ?[]const u8 = null,
        tag_value: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_id = "ResourceScanId",
                .resource_identifier = "ResourceIdentifier",
                .resource_type_prefix = "ResourceTypePrefix",
                .tag_key = "TagKey",
                .tag_value = "TagValue",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resource_scan_resources) } {
            return .{ .service_metadata = service_metadata, .action = list_resource_scan_resources };
        }
    },
    Response: type = struct {
        resources: ?[]ScannedResource = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resources = "Resources",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceScanInProgress,
        ResourceScanNotFound,
    },
} = .{};
pub const list_resource_scans: struct {
    action_name: []const u8 = "ListResourceScans",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resource_scans) } {
            return .{ .service_metadata = service_metadata, .action = list_resource_scans };
        }
    },
    Response: type = struct {
        resource_scan_summaries: ?[]struct {
            resource_scan_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            percentage_completed: ?f64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_scan_id = "ResourceScanId",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .percentage_completed = "PercentageCompleted",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_summaries = "ResourceScanSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_stack_instance_resource_drifts: struct {
    action_name: []const u8 = "ListStackInstanceResourceDrifts",
    Request: type = struct {
        stack_set_name: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        stack_instance_resource_drift_statuses: ?[][]const u8 = null,
        stack_instance_account: []const u8,
        stack_instance_region: []const u8,
        operation_id: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .stack_instance_resource_drift_statuses = "StackInstanceResourceDriftStatuses",
                .stack_instance_account = "StackInstanceAccount",
                .stack_instance_region = "StackInstanceRegion",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_instance_resource_drifts) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_instance_resource_drifts };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            stack_id: []const u8,
            logical_resource_id: []const u8,
            physical_resource_id: ?[]const u8 = null,
            physical_resource_id_context: ?[]PhysicalResourceIdContextKeyValuePair = null,
            resource_type: []const u8,
            property_differences: ?[]PropertyDifference = null,
            stack_resource_drift_status: []const u8,
            timestamp: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .logical_resource_id = "LogicalResourceId",
                    .physical_resource_id = "PhysicalResourceId",
                    .physical_resource_id_context = "PhysicalResourceIdContext",
                    .resource_type = "ResourceType",
                    .property_differences = "PropertyDifferences",
                    .stack_resource_drift_status = "StackResourceDriftStatus",
                    .timestamp = "Timestamp",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        OperationNotFound,
        StackInstanceNotFound,
        StackSetNotFound,
    },
} = .{};
pub const list_stack_instances: struct {
    action_name: []const u8 = "ListStackInstances",
    Request: type = struct {
        stack_set_name: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filters: ?[]struct {
            name: ?[]const u8 = null,
            values: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .values = "Values",
                };
                return @field(mappings, field_name);
            }
        } = null,
        stack_instance_account: ?[]const u8 = null,
        stack_instance_region: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .filters = "Filters",
                .stack_instance_account = "StackInstanceAccount",
                .stack_instance_region = "StackInstanceRegion",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_instances) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_instances };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            stack_set_id: ?[]const u8 = null,
            region: ?[]const u8 = null,
            account: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            stack_instance_status: ?StackInstanceComprehensiveStatus = null,
            organizational_unit_id: ?[]const u8 = null,
            drift_status: ?[]const u8 = null,
            last_drift_check_timestamp: ?i64 = null,
            last_operation_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_set_id = "StackSetId",
                    .region = "Region",
                    .account = "Account",
                    .stack_id = "StackId",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .stack_instance_status = "StackInstanceStatus",
                    .organizational_unit_id = "OrganizationalUnitId",
                    .drift_status = "DriftStatus",
                    .last_drift_check_timestamp = "LastDriftCheckTimestamp",
                    .last_operation_id = "LastOperationId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        StackSetNotFound,
    },
} = .{};
pub const list_stack_resources: struct {
    action_name: []const u8 = "ListStackResources",
    Request: type = struct {
        stack_name: []const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_resources) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_resources };
        }
    },
    Response: type = struct {
        stack_resource_summaries: ?[]struct {
            logical_resource_id: []const u8,
            physical_resource_id: ?[]const u8 = null,
            resource_type: []const u8,
            last_updated_timestamp: i64,
            resource_status: []const u8,
            resource_status_reason: ?[]const u8 = null,
            drift_information: ?struct {
                stack_resource_drift_status: []const u8,
                last_check_timestamp: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .stack_resource_drift_status = "StackResourceDriftStatus",
                        .last_check_timestamp = "LastCheckTimestamp",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            module_info: ?ModuleInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .logical_resource_id = "LogicalResourceId",
                    .physical_resource_id = "PhysicalResourceId",
                    .resource_type = "ResourceType",
                    .last_updated_timestamp = "LastUpdatedTimestamp",
                    .resource_status = "ResourceStatus",
                    .resource_status_reason = "ResourceStatusReason",
                    .drift_information = "DriftInformation",
                    .module_info = "ModuleInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_resource_summaries = "StackResourceSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_stacks: struct {
    action_name: []const u8 = "ListStacks",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        stack_status_filter: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .stack_status_filter = "StackStatusFilter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stacks) } {
            return .{ .service_metadata = service_metadata, .action = list_stacks };
        }
    },
    Response: type = struct {
        stack_summaries: ?[]struct {
            stack_id: ?[]const u8 = null,
            stack_name: []const u8,
            template_description: ?[]const u8 = null,
            creation_time: i64,
            last_updated_time: ?i64 = null,
            deletion_time: ?i64 = null,
            stack_status: []const u8,
            stack_status_reason: ?[]const u8 = null,
            parent_id: ?[]const u8 = null,
            root_id: ?[]const u8 = null,
            drift_information: ?struct {
                stack_drift_status: []const u8,
                last_check_timestamp: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .stack_drift_status = "StackDriftStatus",
                        .last_check_timestamp = "LastCheckTimestamp",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .stack_name = "StackName",
                    .template_description = "TemplateDescription",
                    .creation_time = "CreationTime",
                    .last_updated_time = "LastUpdatedTime",
                    .deletion_time = "DeletionTime",
                    .stack_status = "StackStatus",
                    .stack_status_reason = "StackStatusReason",
                    .parent_id = "ParentId",
                    .root_id = "RootId",
                    .drift_information = "DriftInformation",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_summaries = "StackSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_stack_set_operation_results: struct {
    action_name: []const u8 = "ListStackSetOperationResults",
    Request: type = struct {
        stack_set_name: []const u8,
        operation_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        call_as: ?[]const u8 = null,
        filters: ?[]struct {
            name: ?[]const u8 = null,
            values: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .values = "Values",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .operation_id = "OperationId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .call_as = "CallAs",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_set_operation_results) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_set_operation_results };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            account: ?[]const u8 = null,
            region: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_reason: ?[]const u8 = null,
            account_gate_result: ?struct {
                status: ?[]const u8 = null,
                status_reason: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .status = "Status",
                        .status_reason = "StatusReason",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            organizational_unit_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .account = "Account",
                    .region = "Region",
                    .status = "Status",
                    .status_reason = "StatusReason",
                    .account_gate_result = "AccountGateResult",
                    .organizational_unit_id = "OrganizationalUnitId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        OperationNotFound,
        StackSetNotFound,
    },
} = .{};
pub const list_stack_set_operations: struct {
    action_name: []const u8 = "ListStackSetOperations",
    Request: type = struct {
        stack_set_name: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_set_operations) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_set_operations };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            operation_id: ?[]const u8 = null,
            action: ?[]const u8 = null,
            status: ?[]const u8 = null,
            creation_timestamp: ?i64 = null,
            end_timestamp: ?i64 = null,
            status_reason: ?[]const u8 = null,
            status_details: ?StackSetOperationStatusDetails = null,
            operation_preferences: ?StackSetOperationPreferences = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .operation_id = "OperationId",
                    .action = "Action",
                    .status = "Status",
                    .creation_timestamp = "CreationTimestamp",
                    .end_timestamp = "EndTimestamp",
                    .status_reason = "StatusReason",
                    .status_details = "StatusDetails",
                    .operation_preferences = "OperationPreferences",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        StackSetNotFound,
    },
} = .{};
pub const list_stack_sets: struct {
    action_name: []const u8 = "ListStackSets",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        status: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .status = "Status",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_stack_sets) } {
            return .{ .service_metadata = service_metadata, .action = list_stack_sets };
        }
    },
    Response: type = struct {
        summaries: ?[]struct {
            stack_set_name: ?[]const u8 = null,
            stack_set_id: ?[]const u8 = null,
            description: ?[]const u8 = null,
            status: ?[]const u8 = null,
            auto_deployment: ?AutoDeployment = null,
            permission_model: ?[]const u8 = null,
            drift_status: ?[]const u8 = null,
            last_drift_check_timestamp: ?i64 = null,
            managed_execution: ?ManagedExecution = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_set_name = "StackSetName",
                    .stack_set_id = "StackSetId",
                    .description = "Description",
                    .status = "Status",
                    .auto_deployment = "AutoDeployment",
                    .permission_model = "PermissionModel",
                    .drift_status = "DriftStatus",
                    .last_drift_check_timestamp = "LastDriftCheckTimestamp",
                    .managed_execution = "ManagedExecution",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summaries = "Summaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_type_registrations: struct {
    action_name: []const u8 = "ListTypeRegistrations",
    Request: type = struct {
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        type_arn: ?[]const u8 = null,
        registration_status_filter: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .type_name = "TypeName",
                .type_arn = "TypeArn",
                .registration_status_filter = "RegistrationStatusFilter",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_type_registrations) } {
            return .{ .service_metadata = service_metadata, .action = list_type_registrations };
        }
    },
    Response: type = struct {
        registration_token_list: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .registration_token_list = "RegistrationTokenList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const list_types: struct {
    action_name: []const u8 = "ListTypes",
    Request: type = struct {
        visibility: ?[]const u8 = null,
        provisioning_type: ?[]const u8 = null,
        deprecated_status: ?[]const u8 = null,
        type: ?[]const u8 = null,
        filters: ?struct {
            category: ?[]const u8 = null,
            publisher_id: ?[]const u8 = null,
            type_name_prefix: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .category = "Category",
                    .publisher_id = "PublisherId",
                    .type_name_prefix = "TypeNamePrefix",
                };
                return @field(mappings, field_name);
            }
        } = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .visibility = "Visibility",
                .provisioning_type = "ProvisioningType",
                .deprecated_status = "DeprecatedStatus",
                .type = "Type",
                .filters = "Filters",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_types) } {
            return .{ .service_metadata = service_metadata, .action = list_types };
        }
    },
    Response: type = struct {
        type_summaries: ?[]struct {
            type: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            default_version_id: ?[]const u8 = null,
            type_arn: ?[]const u8 = null,
            last_updated: ?i64 = null,
            description: ?[]const u8 = null,
            publisher_id: ?[]const u8 = null,
            original_type_name: ?[]const u8 = null,
            public_version_number: ?[]const u8 = null,
            latest_public_version: ?[]const u8 = null,
            publisher_identity: ?[]const u8 = null,
            publisher_name: ?[]const u8 = null,
            is_activated: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .type = "Type",
                    .type_name = "TypeName",
                    .default_version_id = "DefaultVersionId",
                    .type_arn = "TypeArn",
                    .last_updated = "LastUpdated",
                    .description = "Description",
                    .publisher_id = "PublisherId",
                    .original_type_name = "OriginalTypeName",
                    .public_version_number = "PublicVersionNumber",
                    .latest_public_version = "LatestPublicVersion",
                    .publisher_identity = "PublisherIdentity",
                    .publisher_name = "PublisherName",
                    .is_activated = "IsActivated",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_summaries = "TypeSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const list_type_versions: struct {
    action_name: []const u8 = "ListTypeVersions",
    Request: type = struct {
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        arn: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        deprecated_status: ?[]const u8 = null,
        publisher_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .type_name = "TypeName",
                .arn = "Arn",
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .deprecated_status = "DeprecatedStatus",
                .publisher_id = "PublisherId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_type_versions) } {
            return .{ .service_metadata = service_metadata, .action = list_type_versions };
        }
    },
    Response: type = struct {
        type_version_summaries: ?[]struct {
            type: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            version_id: ?[]const u8 = null,
            is_default_version: ?bool = null,
            arn: ?[]const u8 = null,
            time_created: ?i64 = null,
            description: ?[]const u8 = null,
            public_version_number: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .type = "Type",
                    .type_name = "TypeName",
                    .version_id = "VersionId",
                    .is_default_version = "IsDefaultVersion",
                    .arn = "Arn",
                    .time_created = "TimeCreated",
                    .description = "Description",
                    .public_version_number = "PublicVersionNumber",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_version_summaries = "TypeVersionSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const publish_type: struct {
    action_name: []const u8 = "PublishType",
    Request: type = struct {
        type: ?[]const u8 = null,
        arn: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        public_version_number: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .arn = "Arn",
                .type_name = "TypeName",
                .public_version_number = "PublicVersionNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(publish_type) } {
            return .{ .service_metadata = service_metadata, .action = publish_type };
        }
    },
    Response: type = struct {
        public_type_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .public_type_arn = "PublicTypeArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const record_handler_progress: struct {
    action_name: []const u8 = "RecordHandlerProgress",
    Request: type = struct {
        bearer_token: []const u8,
        operation_status: []const u8,
        current_operation_status: ?[]const u8 = null,
        status_message: ?[]const u8 = null,
        error_code: ?[]const u8 = null,
        resource_model: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bearer_token = "BearerToken",
                .operation_status = "OperationStatus",
                .current_operation_status = "CurrentOperationStatus",
                .status_message = "StatusMessage",
                .error_code = "ErrorCode",
                .resource_model = "ResourceModel",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(record_handler_progress) } {
            return .{ .service_metadata = service_metadata, .action = record_handler_progress };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidStateTransition,
        OperationStatusCheckFailed,
    },
} = .{};
pub const register_publisher: struct {
    action_name: []const u8 = "RegisterPublisher",
    Request: type = struct {
        accept_terms_and_conditions: ?bool = null,
        connection_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .accept_terms_and_conditions = "AcceptTermsAndConditions",
                .connection_arn = "ConnectionArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_publisher) } {
            return .{ .service_metadata = service_metadata, .action = register_publisher };
        }
    },
    Response: type = struct {
        publisher_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .publisher_id = "PublisherId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const register_type: struct {
    action_name: []const u8 = "RegisterType",
    Request: type = struct {
        type: ?[]const u8 = null,
        type_name: []const u8,
        schema_handler_package: []const u8,
        logging_config: ?LoggingConfig = null,
        execution_role_arn: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type = "Type",
                .type_name = "TypeName",
                .schema_handler_package = "SchemaHandlerPackage",
                .logging_config = "LoggingConfig",
                .execution_role_arn = "ExecutionRoleArn",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_type) } {
            return .{ .service_metadata = service_metadata, .action = register_type };
        }
    },
    Response: type = struct {
        registration_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .registration_token = "RegistrationToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
    },
} = .{};
pub const rollback_stack: struct {
    action_name: []const u8 = "RollbackStack",
    Request: type = struct {
        stack_name: []const u8,
        role_arn: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        retain_except_on_create: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .role_arn = "RoleARN",
                .client_request_token = "ClientRequestToken",
                .retain_except_on_create = "RetainExceptOnCreate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(rollback_stack) } {
            return .{ .service_metadata = service_metadata, .action = rollback_stack };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        TokenAlreadyExists,
    },
} = .{};
pub const set_stack_policy: struct {
    action_name: []const u8 = "SetStackPolicy",
    Request: type = struct {
        stack_name: []const u8,
        stack_policy_body: ?[]const u8 = null,
        stack_policy_url: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .stack_policy_body = "StackPolicyBody",
                .stack_policy_url = "StackPolicyURL",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_stack_policy) } {
            return .{ .service_metadata = service_metadata, .action = set_stack_policy };
        }
    },
    Response: type = struct {},
} = .{};
pub const set_type_configuration: struct {
    action_name: []const u8 = "SetTypeConfiguration",
    Request: type = struct {
        type_arn: ?[]const u8 = null,
        configuration: []const u8,
        configuration_alias: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_arn = "TypeArn",
                .configuration = "Configuration",
                .configuration_alias = "ConfigurationAlias",
                .type_name = "TypeName",
                .type = "Type",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_type_configuration) } {
            return .{ .service_metadata = service_metadata, .action = set_type_configuration };
        }
    },
    Response: type = struct {
        configuration_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .configuration_arn = "ConfigurationArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const set_type_default_version: struct {
    action_name: []const u8 = "SetTypeDefaultVersion",
    Request: type = struct {
        arn: ?[]const u8 = null,
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        version_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .type = "Type",
                .type_name = "TypeName",
                .version_id = "VersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_type_default_version) } {
            return .{ .service_metadata = service_metadata, .action = set_type_default_version };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const signal_resource: struct {
    action_name: []const u8 = "SignalResource",
    Request: type = struct {
        stack_name: []const u8,
        logical_resource_id: []const u8,
        unique_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .logical_resource_id = "LogicalResourceId",
                .unique_id = "UniqueId",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(signal_resource) } {
            return .{ .service_metadata = service_metadata, .action = signal_resource };
        }
    },
    Response: type = struct {},
} = .{};
pub const start_resource_scan: struct {
    action_name: []const u8 = "StartResourceScan",
    Request: type = struct {
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_resource_scan) } {
            return .{ .service_metadata = service_metadata, .action = start_resource_scan };
        }
    },
    Response: type = struct {
        resource_scan_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_scan_id = "ResourceScanId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceScanInProgress,
        ResourceScanLimitExceeded,
    },
} = .{};
pub const stop_stack_set_operation: struct {
    action_name: []const u8 = "StopStackSetOperation",
    Request: type = struct {
        stack_set_name: []const u8,
        operation_id: []const u8,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_stack_set_operation) } {
            return .{ .service_metadata = service_metadata, .action = stop_stack_set_operation };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationNotFound,
        StackSetNotFound,
    },
} = .{};
pub const test_type: struct {
    action_name: []const u8 = "TestType",
    Request: type = struct {
        arn: ?[]const u8 = null,
        type: ?[]const u8 = null,
        type_name: ?[]const u8 = null,
        version_id: ?[]const u8 = null,
        log_delivery_bucket: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .type = "Type",
                .type_name = "TypeName",
                .version_id = "VersionId",
                .log_delivery_bucket = "LogDeliveryBucket",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(test_type) } {
            return .{ .service_metadata = service_metadata, .action = test_type };
        }
    },
    Response: type = struct {
        type_version_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .type_version_arn = "TypeVersionArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CFNRegistry,
        TypeNotFound,
    },
} = .{};
pub const update_generated_template: struct {
    action_name: []const u8 = "UpdateGeneratedTemplate",
    Request: type = struct {
        generated_template_name: []const u8,
        new_generated_template_name: ?[]const u8 = null,
        add_resources: ?[]ResourceDefinition = null,
        remove_resources: ?[][]const u8 = null,
        refresh_all_resources: ?bool = null,
        template_configuration: ?TemplateConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_name = "GeneratedTemplateName",
                .new_generated_template_name = "NewGeneratedTemplateName",
                .add_resources = "AddResources",
                .remove_resources = "RemoveResources",
                .refresh_all_resources = "RefreshAllResources",
                .template_configuration = "TemplateConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_generated_template) } {
            return .{ .service_metadata = service_metadata, .action = update_generated_template };
        }
    },
    Response: type = struct {
        generated_template_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .generated_template_id = "GeneratedTemplateId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlreadyExists,
        GeneratedTemplateNotFound,
        LimitExceeded,
    },
} = .{};
pub const update_stack: struct {
    action_name: []const u8 = "UpdateStack",
    Request: type = struct {
        stack_name: []const u8,
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        use_previous_template: ?bool = null,
        stack_policy_during_update_body: ?[]const u8 = null,
        stack_policy_during_update_url: ?[]const u8 = null,
        parameters: ?[]Parameter = null,
        capabilities: ?[][]const u8 = null,
        resource_types: ?[][]const u8 = null,
        role_arn: ?[]const u8 = null,
        rollback_configuration: ?RollbackConfiguration = null,
        stack_policy_body: ?[]const u8 = null,
        stack_policy_url: ?[]const u8 = null,
        notification_ar_ns: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        disable_rollback: ?bool = null,
        client_request_token: ?[]const u8 = null,
        retain_except_on_create: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_name = "StackName",
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .use_previous_template = "UsePreviousTemplate",
                .stack_policy_during_update_body = "StackPolicyDuringUpdateBody",
                .stack_policy_during_update_url = "StackPolicyDuringUpdateURL",
                .parameters = "Parameters",
                .capabilities = "Capabilities",
                .resource_types = "ResourceTypes",
                .role_arn = "RoleARN",
                .rollback_configuration = "RollbackConfiguration",
                .stack_policy_body = "StackPolicyBody",
                .stack_policy_url = "StackPolicyURL",
                .notification_ar_ns = "NotificationARNs",
                .tags = "Tags",
                .disable_rollback = "DisableRollback",
                .client_request_token = "ClientRequestToken",
                .retain_except_on_create = "RetainExceptOnCreate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_stack) } {
            return .{ .service_metadata = service_metadata, .action = update_stack };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InsufficientCapabilities,
        TokenAlreadyExists,
    },
} = .{};
pub const update_stack_instances: struct {
    action_name: []const u8 = "UpdateStackInstances",
    Request: type = struct {
        stack_set_name: []const u8,
        accounts: ?[][]const u8 = null,
        deployment_targets: ?DeploymentTargets = null,
        regions: [][]const u8,
        parameter_overrides: ?[]Parameter = null,
        operation_preferences: ?StackSetOperationPreferences = null,
        operation_id: ?[]const u8 = null,
        call_as: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .accounts = "Accounts",
                .deployment_targets = "DeploymentTargets",
                .regions = "Regions",
                .parameter_overrides = "ParameterOverrides",
                .operation_preferences = "OperationPreferences",
                .operation_id = "OperationId",
                .call_as = "CallAs",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_stack_instances) } {
            return .{ .service_metadata = service_metadata, .action = update_stack_instances };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationIdAlreadyExists,
        OperationInProgress,
        StackInstanceNotFound,
        StackSetNotFound,
        StaleRequest,
    },
} = .{};
pub const update_stack_set: struct {
    action_name: []const u8 = "UpdateStackSet",
    Request: type = struct {
        stack_set_name: []const u8,
        description: ?[]const u8 = null,
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,
        use_previous_template: ?bool = null,
        parameters: ?[]Parameter = null,
        capabilities: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        operation_preferences: ?StackSetOperationPreferences = null,
        administration_role_arn: ?[]const u8 = null,
        execution_role_name: ?[]const u8 = null,
        deployment_targets: ?DeploymentTargets = null,
        permission_model: ?[]const u8 = null,
        auto_deployment: ?AutoDeployment = null,
        operation_id: ?[]const u8 = null,
        accounts: ?[][]const u8 = null,
        regions: ?[][]const u8 = null,
        call_as: ?[]const u8 = null,
        managed_execution: ?ManagedExecution = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_set_name = "StackSetName",
                .description = "Description",
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
                .use_previous_template = "UsePreviousTemplate",
                .parameters = "Parameters",
                .capabilities = "Capabilities",
                .tags = "Tags",
                .operation_preferences = "OperationPreferences",
                .administration_role_arn = "AdministrationRoleARN",
                .execution_role_name = "ExecutionRoleName",
                .deployment_targets = "DeploymentTargets",
                .permission_model = "PermissionModel",
                .auto_deployment = "AutoDeployment",
                .operation_id = "OperationId",
                .accounts = "Accounts",
                .regions = "Regions",
                .call_as = "CallAs",
                .managed_execution = "ManagedExecution",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_stack_set) } {
            return .{ .service_metadata = service_metadata, .action = update_stack_set };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidOperation,
        OperationIdAlreadyExists,
        OperationInProgress,
        StackInstanceNotFound,
        StackSetNotFound,
        StaleRequest,
    },
} = .{};
pub const update_termination_protection: struct {
    action_name: []const u8 = "UpdateTerminationProtection",
    Request: type = struct {
        enable_termination_protection: bool,
        stack_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .enable_termination_protection = "EnableTerminationProtection",
                .stack_name = "StackName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_termination_protection) } {
            return .{ .service_metadata = service_metadata, .action = update_termination_protection };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const validate_template: struct {
    action_name: []const u8 = "ValidateTemplate",
    Request: type = struct {
        template_body: ?[]const u8 = null,
        template_url: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .template_body = "TemplateBody",
                .template_url = "TemplateURL",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(validate_template) } {
            return .{ .service_metadata = service_metadata, .action = validate_template };
        }
    },
    Response: type = struct {
        parameters: ?[]struct {
            parameter_key: ?[]const u8 = null,
            default_value: ?[]const u8 = null,
            no_echo: ?bool = null,
            description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .parameter_key = "ParameterKey",
                    .default_value = "DefaultValue",
                    .no_echo = "NoEcho",
                    .description = "Description",
                };
                return @field(mappings, field_name);
            }
        } = null,
        description: ?[]const u8 = null,
        capabilities: ?[][]const u8 = null,
        capabilities_reason: ?[]const u8 = null,
        declared_transforms: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .parameters = "Parameters",
                .description = "Description",
                .capabilities = "Capabilities",
                .capabilities_reason = "CapabilitiesReason",
                .declared_transforms = "DeclaredTransforms",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};

pub const ManagedExecution = struct {
    active: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .active = "Active",
        };
        return @field(mappings, field_name);
    }
};

pub const AutoDeployment = struct {
    enabled: ?bool = null,
    retain_stacks_on_account_removal: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
            .retain_stacks_on_account_removal = "RetainStacksOnAccountRemoval",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentTargets = struct {
    accounts: ?[][]const u8 = null,
    accounts_url: ?[]const u8 = null,
    organizational_unit_ids: ?[][]const u8 = null,
    account_filter_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .accounts = "Accounts",
            .accounts_url = "AccountsUrl",
            .organizational_unit_ids = "OrganizationalUnitIds",
            .account_filter_type = "AccountFilterType",
        };
        return @field(mappings, field_name);
    }
};

pub const StackSetOperationPreferences = struct {
    region_concurrency_type: ?[]const u8 = null,
    region_order: ?[][]const u8 = null,
    failure_tolerance_count: ?i64 = null,
    failure_tolerance_percentage: ?i64 = null,
    max_concurrent_count: ?i64 = null,
    max_concurrent_percentage: ?i64 = null,
    concurrency_mode: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .region_concurrency_type = "RegionConcurrencyType",
            .region_order = "RegionOrder",
            .failure_tolerance_count = "FailureToleranceCount",
            .failure_tolerance_percentage = "FailureTolerancePercentage",
            .max_concurrent_count = "MaxConcurrentCount",
            .max_concurrent_percentage = "MaxConcurrentPercentage",
            .concurrency_mode = "ConcurrencyMode",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const Parameter = struct {
    parameter_key: ?[]const u8 = null,
    parameter_value: ?[]const u8 = null,
    use_previous_value: ?bool = null,
    resolved_value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .parameter_key = "ParameterKey",
            .parameter_value = "ParameterValue",
            .use_previous_value = "UsePreviousValue",
            .resolved_value = "ResolvedValue",
        };
        return @field(mappings, field_name);
    }
};

pub const RollbackConfiguration = struct {
    rollback_triggers: ?[]RollbackTrigger = null,
    monitoring_time_in_minutes: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rollback_triggers = "RollbackTriggers",
            .monitoring_time_in_minutes = "MonitoringTimeInMinutes",
        };
        return @field(mappings, field_name);
    }
};

pub const RollbackTrigger = struct {
    arn: []const u8,
    type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "Arn",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const TemplateConfiguration = struct {
    deletion_policy: ?[]const u8 = null,
    update_replace_policy: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deletion_policy = "DeletionPolicy",
            .update_replace_policy = "UpdateReplacePolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const ResourceDefinition = struct {
    resource_type: []const u8,
    logical_resource_id: ?[]const u8 = null,
    resource_identifier: []struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    },

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_type = "ResourceType",
            .logical_resource_id = "LogicalResourceId",
            .resource_identifier = "ResourceIdentifier",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "resource_identifier", field_name))
            return try serializeMap(self.resource_identifier, self.fieldNameFor("resource_identifier"), options, out_stream);
        return false;
    }
};

pub const LoggingConfig = struct {
    log_role_arn: []const u8,
    log_group_name: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_role_arn = "LogRoleArn",
            .log_group_name = "LogGroupName",
        };
        return @field(mappings, field_name);
    }
};

pub const StackSetOperationStatusDetails = struct {
    failed_stack_instances_count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .failed_stack_instances_count = "FailedStackInstancesCount",
        };
        return @field(mappings, field_name);
    }
};

pub const ModuleInfo = struct {
    type_hierarchy: ?[]const u8 = null,
    logical_id_hierarchy: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type_hierarchy = "TypeHierarchy",
            .logical_id_hierarchy = "LogicalIdHierarchy",
        };
        return @field(mappings, field_name);
    }
};

pub const StackInstanceComprehensiveStatus = struct {
    detailed_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .detailed_status = "DetailedStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const PropertyDifference = struct {
    property_path: []const u8,
    expected_value: []const u8,
    actual_value: []const u8,
    difference_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .property_path = "PropertyPath",
            .expected_value = "ExpectedValue",
            .actual_value = "ActualValue",
            .difference_type = "DifferenceType",
        };
        return @field(mappings, field_name);
    }
};

pub const PhysicalResourceIdContextKeyValuePair = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const ScannedResource = struct {
    resource_type: ?[]const u8 = null,
    resource_identifier: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    managed_by_stack: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_type = "ResourceType",
            .resource_identifier = "ResourceIdentifier",
            .managed_by_stack = "ManagedByStack",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "resource_identifier", field_name))
            return try serializeMap(self.resource_identifier, self.fieldNameFor("resource_identifier"), options, out_stream);
        return false;
    }
};

pub const StackResourceDrift = struct {
    stack_id: []const u8,
    logical_resource_id: []const u8,
    physical_resource_id: ?[]const u8 = null,
    physical_resource_id_context: ?[]PhysicalResourceIdContextKeyValuePair = null,
    resource_type: []const u8,
    expected_properties: ?[]const u8 = null,
    actual_properties: ?[]const u8 = null,
    property_differences: ?[]PropertyDifference = null,
    stack_resource_drift_status: []const u8,
    timestamp: i64,
    module_info: ?ModuleInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .stack_id = "StackId",
            .logical_resource_id = "LogicalResourceId",
            .physical_resource_id = "PhysicalResourceId",
            .physical_resource_id_context = "PhysicalResourceIdContext",
            .resource_type = "ResourceType",
            .expected_properties = "ExpectedProperties",
            .actual_properties = "ActualProperties",
            .property_differences = "PropertyDifferences",
            .stack_resource_drift_status = "StackResourceDriftStatus",
            .timestamp = "Timestamp",
            .module_info = "ModuleInfo",
        };
        return @field(mappings, field_name);
    }
};

pub const StackSetDriftDetectionDetails = struct {
    drift_status: ?[]const u8 = null,
    drift_detection_status: ?[]const u8 = null,
    last_drift_check_timestamp: ?i64 = null,
    total_stack_instances_count: ?i64 = null,
    drifted_stack_instances_count: ?i64 = null,
    in_sync_stack_instances_count: ?i64 = null,
    in_progress_stack_instances_count: ?i64 = null,
    failed_stack_instances_count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .drift_status = "DriftStatus",
            .drift_detection_status = "DriftDetectionStatus",
            .last_drift_check_timestamp = "LastDriftCheckTimestamp",
            .total_stack_instances_count = "TotalStackInstancesCount",
            .drifted_stack_instances_count = "DriftedStackInstancesCount",
            .in_sync_stack_instances_count = "InSyncStackInstancesCount",
            .in_progress_stack_instances_count = "InProgressStackInstancesCount",
            .failed_stack_instances_count = "FailedStackInstancesCount",
        };
        return @field(mappings, field_name);
    }
};

pub const StackResourceDriftInformation = struct {
    stack_resource_drift_status: []const u8,
    last_check_timestamp: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .stack_resource_drift_status = "StackResourceDriftStatus",
            .last_check_timestamp = "LastCheckTimestamp",
        };
        return @field(mappings, field_name);
    }
};

pub const TypeConfigurationIdentifier = struct {
    type_arn: ?[]const u8 = null,
    type_configuration_alias: ?[]const u8 = null,
    type_configuration_arn: ?[]const u8 = null,
    type: ?[]const u8 = null,
    type_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type_arn = "TypeArn",
            .type_configuration_alias = "TypeConfigurationAlias",
            .type_configuration_arn = "TypeConfigurationArn",
            .type = "Type",
            .type_name = "TypeName",
        };
        return @field(mappings, field_name);
    }
};
