const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2013-01-01";
pub const sdk_id: []const u8 = "CloudSearch";
pub const arn_namespace: ?[]const u8 = "cloudsearch";
pub const endpoint_prefix: []const u8 = "cloudsearch";
pub const sigv4_name: []const u8 = "cloudsearch";
pub const name: []const u8 = "A9SearchCloudConfigService2013";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query;

pub const service_metadata: struct {
    version: []const u8 = "2013-01-01",
    sdk_id: []const u8 = "CloudSearch",
    arn_namespace: ?[]const u8 = "cloudsearch",
    endpoint_prefix: []const u8 = "cloudsearch",
    sigv4_name: []const u8 = "cloudsearch",
    name: []const u8 = "A9SearchCloudConfigService2013",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query,
} = .{};
pub const build_suggesters: struct {
    action_name: []const u8 = "BuildSuggesters",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(build_suggesters) } {
            return .{ .service_metadata = service_metadata, .action = build_suggesters };
        }
    },
    Response: type = struct {
        field_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .field_names = "FieldNames",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_domain: struct {
    action_name: []const u8 = "CreateDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_domain) } {
            return .{ .service_metadata = service_metadata, .action = create_domain };
        }
    },
    Response: type = struct {
        domain_status: ?DomainStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_status = "DomainStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        LimitExceeded,
        ResourceAlreadyExists,
        Validation,
    },
} = .{};
pub const define_analysis_scheme: struct {
    action_name: []const u8 = "DefineAnalysisScheme",
    Request: type = struct {
        domain_name: []const u8,
        analysis_scheme: AnalysisScheme,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .analysis_scheme = "AnalysisScheme",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(define_analysis_scheme) } {
            return .{ .service_metadata = service_metadata, .action = define_analysis_scheme };
        }
    },
    Response: type = struct {
        analysis_scheme: AnalysisSchemeStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .analysis_scheme = "AnalysisScheme",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const define_expression: struct {
    action_name: []const u8 = "DefineExpression",
    Request: type = struct {
        domain_name: []const u8,
        expression: Expression,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .expression = "Expression",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(define_expression) } {
            return .{ .service_metadata = service_metadata, .action = define_expression };
        }
    },
    Response: type = struct {
        expression: ExpressionStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .expression = "Expression",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const define_index_field: struct {
    action_name: []const u8 = "DefineIndexField",
    Request: type = struct {
        domain_name: []const u8,
        index_field: IndexField,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .index_field = "IndexField",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(define_index_field) } {
            return .{ .service_metadata = service_metadata, .action = define_index_field };
        }
    },
    Response: type = struct {
        index_field: IndexFieldStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .index_field = "IndexField",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const define_suggester: struct {
    action_name: []const u8 = "DefineSuggester",
    Request: type = struct {
        domain_name: []const u8,
        suggester: Suggester,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .suggester = "Suggester",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(define_suggester) } {
            return .{ .service_metadata = service_metadata, .action = define_suggester };
        }
    },
    Response: type = struct {
        suggester: SuggesterStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .suggester = "Suggester",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_analysis_scheme: struct {
    action_name: []const u8 = "DeleteAnalysisScheme",
    Request: type = struct {
        domain_name: []const u8,
        analysis_scheme_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .analysis_scheme_name = "AnalysisSchemeName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_analysis_scheme) } {
            return .{ .service_metadata = service_metadata, .action = delete_analysis_scheme };
        }
    },
    Response: type = struct {
        analysis_scheme: AnalysisSchemeStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .analysis_scheme = "AnalysisScheme",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_domain: struct {
    action_name: []const u8 = "DeleteDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_domain) } {
            return .{ .service_metadata = service_metadata, .action = delete_domain };
        }
    },
    Response: type = struct {
        domain_status: ?DomainStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_status = "DomainStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
    },
} = .{};
pub const delete_expression: struct {
    action_name: []const u8 = "DeleteExpression",
    Request: type = struct {
        domain_name: []const u8,
        expression_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .expression_name = "ExpressionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_expression) } {
            return .{ .service_metadata = service_metadata, .action = delete_expression };
        }
    },
    Response: type = struct {
        expression: ExpressionStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .expression = "Expression",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_index_field: struct {
    action_name: []const u8 = "DeleteIndexField",
    Request: type = struct {
        domain_name: []const u8,
        index_field_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .index_field_name = "IndexFieldName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_index_field) } {
            return .{ .service_metadata = service_metadata, .action = delete_index_field };
        }
    },
    Response: type = struct {
        index_field: IndexFieldStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .index_field = "IndexField",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_suggester: struct {
    action_name: []const u8 = "DeleteSuggester",
    Request: type = struct {
        domain_name: []const u8,
        suggester_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .suggester_name = "SuggesterName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_suggester) } {
            return .{ .service_metadata = service_metadata, .action = delete_suggester };
        }
    },
    Response: type = struct {
        suggester: SuggesterStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .suggester = "Suggester",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_analysis_schemes: struct {
    action_name: []const u8 = "DescribeAnalysisSchemes",
    Request: type = struct {
        domain_name: []const u8,
        analysis_scheme_names: ?[][]const u8 = null,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .analysis_scheme_names = "AnalysisSchemeNames",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_analysis_schemes) } {
            return .{ .service_metadata = service_metadata, .action = describe_analysis_schemes };
        }
    },
    Response: type = struct {
        analysis_schemes: []AnalysisSchemeStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .analysis_schemes = "AnalysisSchemes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const describe_availability_options: struct {
    action_name: []const u8 = "DescribeAvailabilityOptions",
    Request: type = struct {
        domain_name: []const u8,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_availability_options) } {
            return .{ .service_metadata = service_metadata, .action = describe_availability_options };
        }
    },
    Response: type = struct {
        availability_options: ?AvailabilityOptionsStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .availability_options = "AvailabilityOptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        DisabledOperation,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const describe_domain_endpoint_options: struct {
    action_name: []const u8 = "DescribeDomainEndpointOptions",
    Request: type = struct {
        domain_name: []const u8,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_domain_endpoint_options) } {
            return .{ .service_metadata = service_metadata, .action = describe_domain_endpoint_options };
        }
    },
    Response: type = struct {
        domain_endpoint_options: ?DomainEndpointOptionsStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_endpoint_options = "DomainEndpointOptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        DisabledOperation,
        Internal,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const describe_domains: struct {
    action_name: []const u8 = "DescribeDomains",
    Request: type = struct {
        domain_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_names = "DomainNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_domains) } {
            return .{ .service_metadata = service_metadata, .action = describe_domains };
        }
    },
    Response: type = struct {
        domain_status_list: []DomainStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_status_list = "DomainStatusList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
    },
} = .{};
pub const describe_expressions: struct {
    action_name: []const u8 = "DescribeExpressions",
    Request: type = struct {
        domain_name: []const u8,
        expression_names: ?[][]const u8 = null,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .expression_names = "ExpressionNames",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_expressions) } {
            return .{ .service_metadata = service_metadata, .action = describe_expressions };
        }
    },
    Response: type = struct {
        expressions: []ExpressionStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .expressions = "Expressions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const describe_index_fields: struct {
    action_name: []const u8 = "DescribeIndexFields",
    Request: type = struct {
        domain_name: []const u8,
        field_names: ?[][]const u8 = null,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .field_names = "FieldNames",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_index_fields) } {
            return .{ .service_metadata = service_metadata, .action = describe_index_fields };
        }
    },
    Response: type = struct {
        index_fields: []IndexFieldStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .index_fields = "IndexFields",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const describe_scaling_parameters: struct {
    action_name: []const u8 = "DescribeScalingParameters",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_scaling_parameters) } {
            return .{ .service_metadata = service_metadata, .action = describe_scaling_parameters };
        }
    },
    Response: type = struct {
        scaling_parameters: ScalingParametersStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .scaling_parameters = "ScalingParameters",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const describe_service_access_policies: struct {
    action_name: []const u8 = "DescribeServiceAccessPolicies",
    Request: type = struct {
        domain_name: []const u8,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_service_access_policies) } {
            return .{ .service_metadata = service_metadata, .action = describe_service_access_policies };
        }
    },
    Response: type = struct {
        access_policies: AccessPoliciesStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_policies = "AccessPolicies",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const describe_suggesters: struct {
    action_name: []const u8 = "DescribeSuggesters",
    Request: type = struct {
        domain_name: []const u8,
        suggester_names: ?[][]const u8 = null,
        deployed: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .suggester_names = "SuggesterNames",
                .deployed = "Deployed",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_suggesters) } {
            return .{ .service_metadata = service_metadata, .action = describe_suggesters };
        }
    },
    Response: type = struct {
        suggesters: []SuggesterStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .suggesters = "Suggesters",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
    },
} = .{};
pub const index_documents: struct {
    action_name: []const u8 = "IndexDocuments",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(index_documents) } {
            return .{ .service_metadata = service_metadata, .action = index_documents };
        }
    },
    Response: type = struct {
        field_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .field_names = "FieldNames",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const list_domain_names: struct {
    action_name: []const u8 = "ListDomainNames",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_domain_names) } {
            return .{ .service_metadata = service_metadata, .action = list_domain_names };
        }
    },
    Response: type = struct {
        domain_names: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_names = "DomainNames",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "domain_names", field_name))
                return try serializeMap(self.domain_names, self.fieldNameFor("domain_names"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        Base,
    },
} = .{};
pub const update_availability_options: struct {
    action_name: []const u8 = "UpdateAvailabilityOptions",
    Request: type = struct {
        domain_name: []const u8,
        multi_az: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .multi_az = "MultiAZ",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_availability_options) } {
            return .{ .service_metadata = service_metadata, .action = update_availability_options };
        }
    },
    Response: type = struct {
        availability_options: ?AvailabilityOptionsStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .availability_options = "AvailabilityOptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        DisabledOperation,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_domain_endpoint_options: struct {
    action_name: []const u8 = "UpdateDomainEndpointOptions",
    Request: type = struct {
        domain_name: []const u8,
        domain_endpoint_options: DomainEndpointOptions,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .domain_endpoint_options = "DomainEndpointOptions",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_domain_endpoint_options) } {
            return .{ .service_metadata = service_metadata, .action = update_domain_endpoint_options };
        }
    },
    Response: type = struct {
        domain_endpoint_options: ?DomainEndpointOptionsStatus = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_endpoint_options = "DomainEndpointOptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        DisabledOperation,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_scaling_parameters: struct {
    action_name: []const u8 = "UpdateScalingParameters",
    Request: type = struct {
        domain_name: []const u8,
        scaling_parameters: ScalingParameters,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .scaling_parameters = "ScalingParameters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_scaling_parameters) } {
            return .{ .service_metadata = service_metadata, .action = update_scaling_parameters };
        }
    },
    Response: type = struct {
        scaling_parameters: ScalingParametersStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .scaling_parameters = "ScalingParameters",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_service_access_policies: struct {
    action_name: []const u8 = "UpdateServiceAccessPolicies",
    Request: type = struct {
        domain_name: []const u8,
        access_policies: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .access_policies = "AccessPolicies",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_service_access_policies) } {
            return .{ .service_metadata = service_metadata, .action = update_service_access_policies };
        }
    },
    Response: type = struct {
        access_policies: AccessPoliciesStatus,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_policies = "AccessPolicies",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Base,
        Internal,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
        Validation,
    },
} = .{};

pub const AccessPoliciesStatus = struct {
    options: []const u8,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const OptionStatus = struct {
    creation_date: i64,
    update_date: i64,
    update_version: ?i64 = null,
    state: []const u8,
    pending_deletion: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .creation_date = "CreationDate",
            .update_date = "UpdateDate",
            .update_version = "UpdateVersion",
            .state = "State",
            .pending_deletion = "PendingDeletion",
        };
        return @field(mappings, field_name);
    }
};

pub const ScalingParametersStatus = struct {
    options: ScalingParameters,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const ScalingParameters = struct {
    desired_instance_type: ?[]const u8 = null,
    desired_replication_count: ?i64 = null,
    desired_partition_count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .desired_instance_type = "DesiredInstanceType",
            .desired_replication_count = "DesiredReplicationCount",
            .desired_partition_count = "DesiredPartitionCount",
        };
        return @field(mappings, field_name);
    }
};

pub const DomainEndpointOptionsStatus = struct {
    options: DomainEndpointOptions,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const DomainEndpointOptions = struct {
    enforce_https: ?bool = null,
    tls_security_policy: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enforce_https = "EnforceHTTPS",
            .tls_security_policy = "TLSSecurityPolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const AvailabilityOptionsStatus = struct {
    options: bool,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const SuggesterStatus = struct {
    options: Suggester,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const Suggester = struct {
    suggester_name: []const u8,
    document_suggester_options: DocumentSuggesterOptions,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .suggester_name = "SuggesterName",
            .document_suggester_options = "DocumentSuggesterOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentSuggesterOptions = struct {
    source_field: []const u8,
    fuzzy_matching: ?[]const u8 = null,
    sort_expression: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .source_field = "SourceField",
            .fuzzy_matching = "FuzzyMatching",
            .sort_expression = "SortExpression",
        };
        return @field(mappings, field_name);
    }
};

pub const IndexFieldStatus = struct {
    options: IndexField,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const IndexField = struct {
    index_field_name: []const u8,
    index_field_type: []const u8,
    int_options: ?IntOptions = null,
    double_options: ?DoubleOptions = null,
    literal_options: ?LiteralOptions = null,
    text_options: ?TextOptions = null,
    date_options: ?DateOptions = null,
    lat_lon_options: ?LatLonOptions = null,
    int_array_options: ?IntArrayOptions = null,
    double_array_options: ?DoubleArrayOptions = null,
    literal_array_options: ?LiteralArrayOptions = null,
    text_array_options: ?TextArrayOptions = null,
    date_array_options: ?DateArrayOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .index_field_name = "IndexFieldName",
            .index_field_type = "IndexFieldType",
            .int_options = "IntOptions",
            .double_options = "DoubleOptions",
            .literal_options = "LiteralOptions",
            .text_options = "TextOptions",
            .date_options = "DateOptions",
            .lat_lon_options = "LatLonOptions",
            .int_array_options = "IntArrayOptions",
            .double_array_options = "DoubleArrayOptions",
            .literal_array_options = "LiteralArrayOptions",
            .text_array_options = "TextArrayOptions",
            .date_array_options = "DateArrayOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const DateArrayOptions = struct {
    default_value: ?[]const u8 = null,
    source_fields: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_fields = "SourceFields",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const TextArrayOptions = struct {
    default_value: ?[]const u8 = null,
    source_fields: ?[]const u8 = null,
    return_enabled: ?bool = null,
    highlight_enabled: ?bool = null,
    analysis_scheme: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_fields = "SourceFields",
            .return_enabled = "ReturnEnabled",
            .highlight_enabled = "HighlightEnabled",
            .analysis_scheme = "AnalysisScheme",
        };
        return @field(mappings, field_name);
    }
};

pub const LiteralArrayOptions = struct {
    default_value: ?[]const u8 = null,
    source_fields: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_fields = "SourceFields",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const DoubleArrayOptions = struct {
    default_value: ?f64 = null,
    source_fields: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_fields = "SourceFields",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const IntArrayOptions = struct {
    default_value: ?i64 = null,
    source_fields: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_fields = "SourceFields",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const LatLonOptions = struct {
    default_value: ?[]const u8 = null,
    source_field: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const DateOptions = struct {
    default_value: ?[]const u8 = null,
    source_field: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const TextOptions = struct {
    default_value: ?[]const u8 = null,
    source_field: ?[]const u8 = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,
    highlight_enabled: ?bool = null,
    analysis_scheme: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
            .highlight_enabled = "HighlightEnabled",
            .analysis_scheme = "AnalysisScheme",
        };
        return @field(mappings, field_name);
    }
};

pub const LiteralOptions = struct {
    default_value: ?[]const u8 = null,
    source_field: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const DoubleOptions = struct {
    default_value: ?f64 = null,
    source_field: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const IntOptions = struct {
    default_value: ?i64 = null,
    source_field: ?[]const u8 = null,
    facet_enabled: ?bool = null,
    search_enabled: ?bool = null,
    return_enabled: ?bool = null,
    sort_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_value = "DefaultValue",
            .source_field = "SourceField",
            .facet_enabled = "FacetEnabled",
            .search_enabled = "SearchEnabled",
            .return_enabled = "ReturnEnabled",
            .sort_enabled = "SortEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const ExpressionStatus = struct {
    options: Expression,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const Expression = struct {
    expression_name: []const u8,
    expression_value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .expression_name = "ExpressionName",
            .expression_value = "ExpressionValue",
        };
        return @field(mappings, field_name);
    }
};

pub const DomainStatus = struct {
    domain_id: []const u8,
    domain_name: []const u8,
    arn: ?[]const u8 = null,
    created: ?bool = null,
    deleted: ?bool = null,
    doc_service: ?ServiceEndpoint = null,
    search_service: ?ServiceEndpoint = null,
    requires_index_documents: bool,
    processing: ?bool = null,
    search_instance_type: ?[]const u8 = null,
    search_partition_count: ?i64 = null,
    search_instance_count: ?i64 = null,
    limits: ?Limits = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .domain_id = "DomainId",
            .domain_name = "DomainName",
            .arn = "ARN",
            .created = "Created",
            .deleted = "Deleted",
            .doc_service = "DocService",
            .search_service = "SearchService",
            .requires_index_documents = "RequiresIndexDocuments",
            .processing = "Processing",
            .search_instance_type = "SearchInstanceType",
            .search_partition_count = "SearchPartitionCount",
            .search_instance_count = "SearchInstanceCount",
            .limits = "Limits",
        };
        return @field(mappings, field_name);
    }
};

pub const Limits = struct {
    maximum_replication_count: i64,
    maximum_partition_count: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .maximum_replication_count = "MaximumReplicationCount",
            .maximum_partition_count = "MaximumPartitionCount",
        };
        return @field(mappings, field_name);
    }
};

pub const ServiceEndpoint = struct {
    endpoint: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .endpoint = "Endpoint",
        };
        return @field(mappings, field_name);
    }
};

pub const AnalysisSchemeStatus = struct {
    options: AnalysisScheme,
    status: OptionStatus,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .options = "Options",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const AnalysisScheme = struct {
    analysis_scheme_name: []const u8,
    analysis_scheme_language: []const u8,
    analysis_options: ?AnalysisOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .analysis_scheme_name = "AnalysisSchemeName",
            .analysis_scheme_language = "AnalysisSchemeLanguage",
            .analysis_options = "AnalysisOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const AnalysisOptions = struct {
    synonyms: ?[]const u8 = null,
    stopwords: ?[]const u8 = null,
    stemming_dictionary: ?[]const u8 = null,
    japanese_tokenization_dictionary: ?[]const u8 = null,
    algorithmic_stemming: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .synonyms = "Synonyms",
            .stopwords = "Stopwords",
            .stemming_dictionary = "StemmingDictionary",
            .japanese_tokenization_dictionary = "JapaneseTokenizationDictionary",
            .algorithmic_stemming = "AlgorithmicStemming",
        };
        return @field(mappings, field_name);
    }
};
