const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2010-08-01";
pub const sdk_id: []const u8 = "CloudWatch";
pub const arn_namespace: ?[]const u8 = "monitoring";
pub const endpoint_prefix: []const u8 = "monitoring";
pub const sigv4_name: []const u8 = "monitoring";
pub const name: []const u8 = "GraniteServiceVersion20100801";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query;

pub const service_metadata: struct {
    version: []const u8 = "2010-08-01",
    sdk_id: []const u8 = "CloudWatch",
    arn_namespace: ?[]const u8 = "monitoring",
    endpoint_prefix: []const u8 = "monitoring",
    sigv4_name: []const u8 = "monitoring",
    name: []const u8 = "GraniteServiceVersion20100801",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query,
} = .{};
pub const delete_alarms: struct {
    action_name: []const u8 = "DeleteAlarms",
    Request: type = struct {
        alarm_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_names = "AlarmNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_alarms) } {
            return .{ .service_metadata = service_metadata, .action = delete_alarms };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
    },
} = .{};
pub const delete_anomaly_detector: struct {
    action_name: []const u8 = "DeleteAnomalyDetector",
    Request: type = struct {
        namespace: ?[]const u8 = null,
        metric_name: ?[]const u8 = null,
        dimensions: ?[]Dimension = null,
        stat: ?[]const u8 = null,
        single_metric_anomaly_detector: ?SingleMetricAnomalyDetector = null,
        metric_math_anomaly_detector: ?MetricMathAnomalyDetector = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .namespace = "Namespace",
                .metric_name = "MetricName",
                .dimensions = "Dimensions",
                .stat = "Stat",
                .single_metric_anomaly_detector = "SingleMetricAnomalyDetector",
                .metric_math_anomaly_detector = "MetricMathAnomalyDetector",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_anomaly_detector) } {
            return .{ .service_metadata = service_metadata, .action = delete_anomaly_detector };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        MissingRequiredParameter,
        ResourceNotFound,
    },
} = .{};
pub const delete_dashboards: struct {
    action_name: []const u8 = "DeleteDashboards",
    Request: type = struct {
        dashboard_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_names = "DashboardNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_dashboards) } {
            return .{ .service_metadata = service_metadata, .action = delete_dashboards };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DashboardNotFoundError,
        InternalService,
        InvalidParameterValue,
    },
} = .{};
pub const delete_insight_rules: struct {
    action_name: []const u8 = "DeleteInsightRules",
    Request: type = struct {
        rule_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_names = "RuleNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = delete_insight_rules };
        }
    },
    Response: type = struct {
        failures: ?[]PartialFailure = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failures = "Failures",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const delete_metric_stream: struct {
    action_name: []const u8 = "DeleteMetricStream",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_metric_stream) } {
            return .{ .service_metadata = service_metadata, .action = delete_metric_stream };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const describe_alarm_history: struct {
    action_name: []const u8 = "DescribeAlarmHistory",
    Request: type = struct {
        alarm_name: ?[]const u8 = null,
        alarm_types: ?[][]const u8 = null,
        history_item_type: ?[]const u8 = null,
        start_date: ?i64 = null,
        end_date: ?i64 = null,
        max_records: ?i64 = null,
        next_token: ?[]const u8 = null,
        scan_by: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "AlarmName",
                .alarm_types = "AlarmTypes",
                .history_item_type = "HistoryItemType",
                .start_date = "StartDate",
                .end_date = "EndDate",
                .max_records = "MaxRecords",
                .next_token = "NextToken",
                .scan_by = "ScanBy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_alarm_history) } {
            return .{ .service_metadata = service_metadata, .action = describe_alarm_history };
        }
    },
    Response: type = struct {
        alarm_history_items: ?[]struct {
            alarm_name: ?[]const u8 = null,
            alarm_type: ?[]const u8 = null,
            timestamp: ?i64 = null,
            history_item_type: ?[]const u8 = null,
            history_summary: ?[]const u8 = null,
            history_data: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .alarm_name = "AlarmName",
                    .alarm_type = "AlarmType",
                    .timestamp = "Timestamp",
                    .history_item_type = "HistoryItemType",
                    .history_summary = "HistorySummary",
                    .history_data = "HistoryData",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_history_items = "AlarmHistoryItems",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const describe_alarms: struct {
    action_name: []const u8 = "DescribeAlarms",
    Request: type = struct {
        alarm_names: ?[][]const u8 = null,
        alarm_name_prefix: ?[]const u8 = null,
        alarm_types: ?[][]const u8 = null,
        children_of_alarm_name: ?[]const u8 = null,
        parents_of_alarm_name: ?[]const u8 = null,
        state_value: ?[]const u8 = null,
        action_prefix: ?[]const u8 = null,
        max_records: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_names = "AlarmNames",
                .alarm_name_prefix = "AlarmNamePrefix",
                .alarm_types = "AlarmTypes",
                .children_of_alarm_name = "ChildrenOfAlarmName",
                .parents_of_alarm_name = "ParentsOfAlarmName",
                .state_value = "StateValue",
                .action_prefix = "ActionPrefix",
                .max_records = "MaxRecords",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_alarms) } {
            return .{ .service_metadata = service_metadata, .action = describe_alarms };
        }
    },
    Response: type = struct {
        composite_alarms: ?[]struct {
            actions_enabled: ?bool = null,
            alarm_actions: ?[][]const u8 = null,
            alarm_arn: ?[]const u8 = null,
            alarm_configuration_updated_timestamp: ?i64 = null,
            alarm_description: ?[]const u8 = null,
            alarm_name: ?[]const u8 = null,
            alarm_rule: ?[]const u8 = null,
            insufficient_data_actions: ?[][]const u8 = null,
            ok_actions: ?[][]const u8 = null,
            state_reason: ?[]const u8 = null,
            state_reason_data: ?[]const u8 = null,
            state_updated_timestamp: ?i64 = null,
            state_value: ?[]const u8 = null,
            state_transitioned_timestamp: ?i64 = null,
            actions_suppressed_by: ?[]const u8 = null,
            actions_suppressed_reason: ?[]const u8 = null,
            actions_suppressor: ?[]const u8 = null,
            actions_suppressor_wait_period: ?i64 = null,
            actions_suppressor_extension_period: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .actions_enabled = "ActionsEnabled",
                    .alarm_actions = "AlarmActions",
                    .alarm_arn = "AlarmArn",
                    .alarm_configuration_updated_timestamp = "AlarmConfigurationUpdatedTimestamp",
                    .alarm_description = "AlarmDescription",
                    .alarm_name = "AlarmName",
                    .alarm_rule = "AlarmRule",
                    .insufficient_data_actions = "InsufficientDataActions",
                    .ok_actions = "OKActions",
                    .state_reason = "StateReason",
                    .state_reason_data = "StateReasonData",
                    .state_updated_timestamp = "StateUpdatedTimestamp",
                    .state_value = "StateValue",
                    .state_transitioned_timestamp = "StateTransitionedTimestamp",
                    .actions_suppressed_by = "ActionsSuppressedBy",
                    .actions_suppressed_reason = "ActionsSuppressedReason",
                    .actions_suppressor = "ActionsSuppressor",
                    .actions_suppressor_wait_period = "ActionsSuppressorWaitPeriod",
                    .actions_suppressor_extension_period = "ActionsSuppressorExtensionPeriod",
                };
                return @field(mappings, field_name);
            }
        } = null,
        metric_alarms: ?[]MetricAlarm = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .composite_alarms = "CompositeAlarms",
                .metric_alarms = "MetricAlarms",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const describe_alarms_for_metric: struct {
    action_name: []const u8 = "DescribeAlarmsForMetric",
    Request: type = struct {
        metric_name: []const u8,
        namespace: []const u8,
        statistic: ?[]const u8 = null,
        extended_statistic: ?[]const u8 = null,
        dimensions: ?[]Dimension = null,
        period: ?i64 = null,
        unit: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "MetricName",
                .namespace = "Namespace",
                .statistic = "Statistic",
                .extended_statistic = "ExtendedStatistic",
                .dimensions = "Dimensions",
                .period = "Period",
                .unit = "Unit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_alarms_for_metric) } {
            return .{ .service_metadata = service_metadata, .action = describe_alarms_for_metric };
        }
    },
    Response: type = struct {
        metric_alarms: ?[]MetricAlarm = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_alarms = "MetricAlarms",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_anomaly_detectors: struct {
    action_name: []const u8 = "DescribeAnomalyDetectors",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        namespace: ?[]const u8 = null,
        metric_name: ?[]const u8 = null,
        dimensions: ?[]Dimension = null,
        anomaly_detector_types: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .namespace = "Namespace",
                .metric_name = "MetricName",
                .dimensions = "Dimensions",
                .anomaly_detector_types = "AnomalyDetectorTypes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_anomaly_detectors) } {
            return .{ .service_metadata = service_metadata, .action = describe_anomaly_detectors };
        }
    },
    Response: type = struct {
        anomaly_detectors: ?[]struct {
            namespace: ?[]const u8 = null,
            metric_name: ?[]const u8 = null,
            dimensions: ?[]Dimension = null,
            stat: ?[]const u8 = null,
            configuration: ?AnomalyDetectorConfiguration = null,
            state_value: ?[]const u8 = null,
            single_metric_anomaly_detector: ?SingleMetricAnomalyDetector = null,
            metric_math_anomaly_detector: ?MetricMathAnomalyDetector = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .namespace = "Namespace",
                    .metric_name = "MetricName",
                    .dimensions = "Dimensions",
                    .stat = "Stat",
                    .configuration = "Configuration",
                    .state_value = "StateValue",
                    .single_metric_anomaly_detector = "SingleMetricAnomalyDetector",
                    .metric_math_anomaly_detector = "MetricMathAnomalyDetector",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .anomaly_detectors = "AnomalyDetectors",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidNextToken,
        InvalidParameterCombination,
        InvalidParameterValue,
    },
} = .{};
pub const describe_insight_rules: struct {
    action_name: []const u8 = "DescribeInsightRules",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = describe_insight_rules };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        insight_rules: ?[]struct {
            name: []const u8,
            state: []const u8,
            schema: []const u8,
            definition: []const u8,
            managed_rule: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .state = "State",
                    .schema = "Schema",
                    .definition = "Definition",
                    .managed_rule = "ManagedRule",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .insight_rules = "InsightRules",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const disable_alarm_actions: struct {
    action_name: []const u8 = "DisableAlarmActions",
    Request: type = struct {
        alarm_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_names = "AlarmNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_alarm_actions) } {
            return .{ .service_metadata = service_metadata, .action = disable_alarm_actions };
        }
    },
    Response: type = struct {},
} = .{};
pub const disable_insight_rules: struct {
    action_name: []const u8 = "DisableInsightRules",
    Request: type = struct {
        rule_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_names = "RuleNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = disable_insight_rules };
        }
    },
    Response: type = struct {
        failures: ?[]PartialFailure = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failures = "Failures",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const enable_alarm_actions: struct {
    action_name: []const u8 = "EnableAlarmActions",
    Request: type = struct {
        alarm_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_names = "AlarmNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_alarm_actions) } {
            return .{ .service_metadata = service_metadata, .action = enable_alarm_actions };
        }
    },
    Response: type = struct {},
} = .{};
pub const enable_insight_rules: struct {
    action_name: []const u8 = "EnableInsightRules",
    Request: type = struct {
        rule_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_names = "RuleNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = enable_insight_rules };
        }
    },
    Response: type = struct {
        failures: ?[]PartialFailure = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failures = "Failures",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        LimitExceeded,
        MissingRequiredParameter,
    },
} = .{};
pub const get_dashboard: struct {
    action_name: []const u8 = "GetDashboard",
    Request: type = struct {
        dashboard_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_name = "DashboardName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_dashboard) } {
            return .{ .service_metadata = service_metadata, .action = get_dashboard };
        }
    },
    Response: type = struct {
        dashboard_arn: ?[]const u8 = null,
        dashboard_body: ?[]const u8 = null,
        dashboard_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_arn = "DashboardArn",
                .dashboard_body = "DashboardBody",
                .dashboard_name = "DashboardName",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DashboardNotFoundError,
        InternalService,
        InvalidParameterValue,
    },
} = .{};
pub const get_insight_rule_report: struct {
    action_name: []const u8 = "GetInsightRuleReport",
    Request: type = struct {
        rule_name: []const u8,
        start_time: i64,
        end_time: i64,
        period: i64,
        max_contributor_count: ?i64 = null,
        metrics: ?[][]const u8 = null,
        order_by: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_name = "RuleName",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .period = "Period",
                .max_contributor_count = "MaxContributorCount",
                .metrics = "Metrics",
                .order_by = "OrderBy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_insight_rule_report) } {
            return .{ .service_metadata = service_metadata, .action = get_insight_rule_report };
        }
    },
    Response: type = struct {
        key_labels: ?[][]const u8 = null,
        aggregation_statistic: ?[]const u8 = null,
        aggregate_value: ?f64 = null,
        approximate_unique_count: ?i64 = null,
        contributors: ?[]struct {
            keys: [][]const u8,
            approximate_aggregate_value: f64,
            datapoints: []struct {
                timestamp: i64,
                approximate_value: f64,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .timestamp = "Timestamp",
                        .approximate_value = "ApproximateValue",
                    };
                    return @field(mappings, field_name);
                }
            },

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .keys = "Keys",
                    .approximate_aggregate_value = "ApproximateAggregateValue",
                    .datapoints = "Datapoints",
                };
                return @field(mappings, field_name);
            }
        } = null,
        metric_datapoints: ?[]struct {
            timestamp: i64,
            unique_contributors: ?f64 = null,
            max_contributor_value: ?f64 = null,
            sample_count: ?f64 = null,
            average: ?f64 = null,
            sum: ?f64 = null,
            minimum: ?f64 = null,
            maximum: ?f64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamp = "Timestamp",
                    .unique_contributors = "UniqueContributors",
                    .max_contributor_value = "MaxContributorValue",
                    .sample_count = "SampleCount",
                    .average = "Average",
                    .sum = "Sum",
                    .minimum = "Minimum",
                    .maximum = "Maximum",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_labels = "KeyLabels",
                .aggregation_statistic = "AggregationStatistic",
                .aggregate_value = "AggregateValue",
                .approximate_unique_count = "ApproximateUniqueCount",
                .contributors = "Contributors",
                .metric_datapoints = "MetricDatapoints",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        MissingRequiredParameter,
        ResourceNotFound,
    },
} = .{};
pub const get_metric_data: struct {
    action_name: []const u8 = "GetMetricData",
    Request: type = struct {
        metric_data_queries: []MetricDataQuery,
        start_time: i64,
        end_time: i64,
        next_token: ?[]const u8 = null,
        scan_by: ?[]const u8 = null,
        max_datapoints: ?i64 = null,
        label_options: ?struct {
            timezone: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timezone = "Timezone",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_data_queries = "MetricDataQueries",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .next_token = "NextToken",
                .scan_by = "ScanBy",
                .max_datapoints = "MaxDatapoints",
                .label_options = "LabelOptions",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_metric_data };
        }
    },
    Response: type = struct {
        metric_data_results: ?[]struct {
            id: ?[]const u8 = null,
            label: ?[]const u8 = null,
            timestamps: ?[]i64 = null,
            values: ?[]f64 = null,
            status_code: ?[]const u8 = null,
            messages: ?[]MessageData = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .label = "Label",
                    .timestamps = "Timestamps",
                    .values = "Values",
                    .status_code = "StatusCode",
                    .messages = "Messages",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        messages: ?[]MessageData = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_data_results = "MetricDataResults",
                .next_token = "NextToken",
                .messages = "Messages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const get_metric_statistics: struct {
    action_name: []const u8 = "GetMetricStatistics",
    Request: type = struct {
        namespace: []const u8,
        metric_name: []const u8,
        dimensions: ?[]Dimension = null,
        start_time: i64,
        end_time: i64,
        period: i64,
        statistics: ?[][]const u8 = null,
        extended_statistics: ?[][]const u8 = null,
        unit: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .namespace = "Namespace",
                .metric_name = "MetricName",
                .dimensions = "Dimensions",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .period = "Period",
                .statistics = "Statistics",
                .extended_statistics = "ExtendedStatistics",
                .unit = "Unit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_metric_statistics) } {
            return .{ .service_metadata = service_metadata, .action = get_metric_statistics };
        }
    },
    Response: type = struct {
        label: ?[]const u8 = null,
        datapoints: ?[]struct {
            timestamp: ?i64 = null,
            sample_count: ?f64 = null,
            average: ?f64 = null,
            sum: ?f64 = null,
            minimum: ?f64 = null,
            maximum: ?f64 = null,
            unit: ?[]const u8 = null,
            extended_statistics: ?[]struct {
                key: ?[]const u8 = null,
                value: ?f64 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamp = "Timestamp",
                    .sample_count = "SampleCount",
                    .average = "Average",
                    .sum = "Sum",
                    .minimum = "Minimum",
                    .maximum = "Maximum",
                    .unit = "Unit",
                    .extended_statistics = "ExtendedStatistics",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "extended_statistics", field_name))
                    return try serializeMap(self.extended_statistics, self.fieldNameFor("extended_statistics"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .label = "Label",
                .datapoints = "Datapoints",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const get_metric_stream: struct {
    action_name: []const u8 = "GetMetricStream",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_metric_stream) } {
            return .{ .service_metadata = service_metadata, .action = get_metric_stream };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,
        name: ?[]const u8 = null,
        include_filters: ?[]MetricStreamFilter = null,
        exclude_filters: ?[]MetricStreamFilter = null,
        firehose_arn: ?[]const u8 = null,
        role_arn: ?[]const u8 = null,
        state: ?[]const u8 = null,
        creation_date: ?i64 = null,
        last_update_date: ?i64 = null,
        output_format: ?[]const u8 = null,
        statistics_configurations: ?[]MetricStreamStatisticsConfiguration = null,
        include_linked_accounts_metrics: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .name = "Name",
                .include_filters = "IncludeFilters",
                .exclude_filters = "ExcludeFilters",
                .firehose_arn = "FirehoseArn",
                .role_arn = "RoleArn",
                .state = "State",
                .creation_date = "CreationDate",
                .last_update_date = "LastUpdateDate",
                .output_format = "OutputFormat",
                .statistics_configurations = "StatisticsConfigurations",
                .include_linked_accounts_metrics = "IncludeLinkedAccountsMetrics",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        MissingRequiredParameter,
        ResourceNotFound,
    },
} = .{};
pub const get_metric_widget_image: struct {
    action_name: []const u8 = "GetMetricWidgetImage",
    Request: type = struct {
        metric_widget: []const u8,
        output_format: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_widget = "MetricWidget",
                .output_format = "OutputFormat",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_metric_widget_image) } {
            return .{ .service_metadata = service_metadata, .action = get_metric_widget_image };
        }
    },
    Response: type = struct {
        metric_widget_image: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_widget_image = "MetricWidgetImage",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_dashboards: struct {
    action_name: []const u8 = "ListDashboards",
    Request: type = struct {
        dashboard_name_prefix: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_name_prefix = "DashboardNamePrefix",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_dashboards) } {
            return .{ .service_metadata = service_metadata, .action = list_dashboards };
        }
    },
    Response: type = struct {
        dashboard_entries: ?[]struct {
            dashboard_name: ?[]const u8 = null,
            dashboard_arn: ?[]const u8 = null,
            last_modified: ?i64 = null,
            size: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .dashboard_name = "DashboardName",
                    .dashboard_arn = "DashboardArn",
                    .last_modified = "LastModified",
                    .size = "Size",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_entries = "DashboardEntries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
    },
} = .{};
pub const list_managed_insight_rules: struct {
    action_name: []const u8 = "ListManagedInsightRules",
    Request: type = struct {
        resource_arn: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_managed_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = list_managed_insight_rules };
        }
    },
    Response: type = struct {
        managed_rules: ?[]struct {
            template_name: ?[]const u8 = null,
            resource_arn: ?[]const u8 = null,
            rule_state: ?struct {
                rule_name: []const u8,
                state: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .rule_name = "RuleName",
                        .state = "State",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .template_name = "TemplateName",
                    .resource_arn = "ResourceARN",
                    .rule_state = "RuleState",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .managed_rules = "ManagedRules",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const list_metrics: struct {
    action_name: []const u8 = "ListMetrics",
    Request: type = struct {
        namespace: ?[]const u8 = null,
        metric_name: ?[]const u8 = null,
        dimensions: ?[]struct {
            name: []const u8,
            value: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .value = "Value",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        recently_active: ?[]const u8 = null,
        include_linked_accounts: ?bool = null,
        owning_account: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .namespace = "Namespace",
                .metric_name = "MetricName",
                .dimensions = "Dimensions",
                .next_token = "NextToken",
                .recently_active = "RecentlyActive",
                .include_linked_accounts = "IncludeLinkedAccounts",
                .owning_account = "OwningAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_metrics) } {
            return .{ .service_metadata = service_metadata, .action = list_metrics };
        }
    },
    Response: type = struct {
        metrics: ?[]Metric = null,
        next_token: ?[]const u8 = null,
        owning_accounts: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metrics = "Metrics",
                .next_token = "NextToken",
                .owning_accounts = "OwningAccounts",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
    },
} = .{};
pub const list_metric_streams: struct {
    action_name: []const u8 = "ListMetricStreams",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_metric_streams) } {
            return .{ .service_metadata = service_metadata, .action = list_metric_streams };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        entries: ?[]struct {
            arn: ?[]const u8 = null,
            creation_date: ?i64 = null,
            last_update_date: ?i64 = null,
            name: ?[]const u8 = null,
            firehose_arn: ?[]const u8 = null,
            state: ?[]const u8 = null,
            output_format: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .creation_date = "CreationDate",
                    .last_update_date = "LastUpdateDate",
                    .name = "Name",
                    .firehose_arn = "FirehoseArn",
                    .state = "State",
                    .output_format = "OutputFormat",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .entries = "Entries",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidNextToken,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
        ResourceNotFound,
    },
} = .{};
pub const put_anomaly_detector: struct {
    action_name: []const u8 = "PutAnomalyDetector",
    Request: type = struct {
        namespace: ?[]const u8 = null,
        metric_name: ?[]const u8 = null,
        dimensions: ?[]Dimension = null,
        stat: ?[]const u8 = null,
        configuration: ?AnomalyDetectorConfiguration = null,
        single_metric_anomaly_detector: ?SingleMetricAnomalyDetector = null,
        metric_math_anomaly_detector: ?MetricMathAnomalyDetector = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .namespace = "Namespace",
                .metric_name = "MetricName",
                .dimensions = "Dimensions",
                .stat = "Stat",
                .configuration = "Configuration",
                .single_metric_anomaly_detector = "SingleMetricAnomalyDetector",
                .metric_math_anomaly_detector = "MetricMathAnomalyDetector",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_anomaly_detector) } {
            return .{ .service_metadata = service_metadata, .action = put_anomaly_detector };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        LimitExceeded,
        MissingRequiredParameter,
    },
} = .{};
pub const put_composite_alarm: struct {
    action_name: []const u8 = "PutCompositeAlarm",
    Request: type = struct {
        actions_enabled: ?bool = null,
        alarm_actions: ?[][]const u8 = null,
        alarm_description: ?[]const u8 = null,
        alarm_name: []const u8,
        alarm_rule: []const u8,
        insufficient_data_actions: ?[][]const u8 = null,
        ok_actions: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        actions_suppressor: ?[]const u8 = null,
        actions_suppressor_wait_period: ?i64 = null,
        actions_suppressor_extension_period: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .actions_enabled = "ActionsEnabled",
                .alarm_actions = "AlarmActions",
                .alarm_description = "AlarmDescription",
                .alarm_name = "AlarmName",
                .alarm_rule = "AlarmRule",
                .insufficient_data_actions = "InsufficientDataActions",
                .ok_actions = "OKActions",
                .tags = "Tags",
                .actions_suppressor = "ActionsSuppressor",
                .actions_suppressor_wait_period = "ActionsSuppressorWaitPeriod",
                .actions_suppressor_extension_period = "ActionsSuppressorExtensionPeriod",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_composite_alarm) } {
            return .{ .service_metadata = service_metadata, .action = put_composite_alarm };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
    },
} = .{};
pub const put_dashboard: struct {
    action_name: []const u8 = "PutDashboard",
    Request: type = struct {
        dashboard_name: []const u8,
        dashboard_body: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_name = "DashboardName",
                .dashboard_body = "DashboardBody",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_dashboard) } {
            return .{ .service_metadata = service_metadata, .action = put_dashboard };
        }
    },
    Response: type = struct {
        dashboard_validation_messages: ?[]DashboardValidationMessage = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dashboard_validation_messages = "DashboardValidationMessages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DashboardInvalidInputError,
        InternalService,
    },
} = .{};
pub const put_insight_rule: struct {
    action_name: []const u8 = "PutInsightRule",
    Request: type = struct {
        rule_name: []const u8,
        rule_state: ?[]const u8 = null,
        rule_definition: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_name = "RuleName",
                .rule_state = "RuleState",
                .rule_definition = "RuleDefinition",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_insight_rule) } {
            return .{ .service_metadata = service_metadata, .action = put_insight_rule };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        LimitExceeded,
        MissingRequiredParameter,
    },
} = .{};
pub const put_managed_insight_rules: struct {
    action_name: []const u8 = "PutManagedInsightRules",
    Request: type = struct {
        managed_rules: []struct {
            template_name: []const u8,
            resource_arn: []const u8,
            tags: ?[]Tag = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .template_name = "TemplateName",
                    .resource_arn = "ResourceARN",
                    .tags = "Tags",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .managed_rules = "ManagedRules",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_managed_insight_rules) } {
            return .{ .service_metadata = service_metadata, .action = put_managed_insight_rules };
        }
    },
    Response: type = struct {
        failures: ?[]PartialFailure = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failures = "Failures",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const put_metric_alarm: struct {
    action_name: []const u8 = "PutMetricAlarm",
    Request: type = struct {
        alarm_name: []const u8,
        alarm_description: ?[]const u8 = null,
        actions_enabled: ?bool = null,
        ok_actions: ?[][]const u8 = null,
        alarm_actions: ?[][]const u8 = null,
        insufficient_data_actions: ?[][]const u8 = null,
        metric_name: ?[]const u8 = null,
        namespace: ?[]const u8 = null,
        statistic: ?[]const u8 = null,
        extended_statistic: ?[]const u8 = null,
        dimensions: ?[]Dimension = null,
        period: ?i64 = null,
        unit: ?[]const u8 = null,
        evaluation_periods: i64,
        datapoints_to_alarm: ?i64 = null,
        threshold: ?f64 = null,
        comparison_operator: []const u8,
        treat_missing_data: ?[]const u8 = null,
        evaluate_low_sample_count_percentile: ?[]const u8 = null,
        metrics: ?[]MetricDataQuery = null,
        tags: ?[]Tag = null,
        threshold_metric_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "AlarmName",
                .alarm_description = "AlarmDescription",
                .actions_enabled = "ActionsEnabled",
                .ok_actions = "OKActions",
                .alarm_actions = "AlarmActions",
                .insufficient_data_actions = "InsufficientDataActions",
                .metric_name = "MetricName",
                .namespace = "Namespace",
                .statistic = "Statistic",
                .extended_statistic = "ExtendedStatistic",
                .dimensions = "Dimensions",
                .period = "Period",
                .unit = "Unit",
                .evaluation_periods = "EvaluationPeriods",
                .datapoints_to_alarm = "DatapointsToAlarm",
                .threshold = "Threshold",
                .comparison_operator = "ComparisonOperator",
                .treat_missing_data = "TreatMissingData",
                .evaluate_low_sample_count_percentile = "EvaluateLowSampleCountPercentile",
                .metrics = "Metrics",
                .tags = "Tags",
                .threshold_metric_id = "ThresholdMetricId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_metric_alarm) } {
            return .{ .service_metadata = service_metadata, .action = put_metric_alarm };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
    },
} = .{};
pub const put_metric_data: struct {
    action_name: []const u8 = "PutMetricData",
    Request: type = struct {
        namespace: []const u8,
        metric_data: []struct {
            metric_name: []const u8,
            dimensions: ?[]Dimension = null,
            timestamp: ?i64 = null,
            value: ?f64 = null,
            statistic_values: ?struct {
                sample_count: f64,
                sum: f64,
                minimum: f64,
                maximum: f64,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .sample_count = "SampleCount",
                        .sum = "Sum",
                        .minimum = "Minimum",
                        .maximum = "Maximum",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            values: ?[]f64 = null,
            counts: ?[]f64 = null,
            unit: ?[]const u8 = null,
            storage_resolution: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .metric_name = "MetricName",
                    .dimensions = "Dimensions",
                    .timestamp = "Timestamp",
                    .value = "Value",
                    .statistic_values = "StatisticValues",
                    .values = "Values",
                    .counts = "Counts",
                    .unit = "Unit",
                    .storage_resolution = "StorageResolution",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .namespace = "Namespace",
                .metric_data = "MetricData",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = put_metric_data };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const put_metric_stream: struct {
    action_name: []const u8 = "PutMetricStream",
    Request: type = struct {
        name: []const u8,
        include_filters: ?[]MetricStreamFilter = null,
        exclude_filters: ?[]MetricStreamFilter = null,
        firehose_arn: []const u8,
        role_arn: []const u8,
        output_format: []const u8,
        tags: ?[]Tag = null,
        statistics_configurations: ?[]MetricStreamStatisticsConfiguration = null,
        include_linked_accounts_metrics: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .include_filters = "IncludeFilters",
                .exclude_filters = "ExcludeFilters",
                .firehose_arn = "FirehoseArn",
                .role_arn = "RoleArn",
                .output_format = "OutputFormat",
                .tags = "Tags",
                .statistics_configurations = "StatisticsConfigurations",
                .include_linked_accounts_metrics = "IncludeLinkedAccountsMetrics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_metric_stream) } {
            return .{ .service_metadata = service_metadata, .action = put_metric_stream };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalService,
        InvalidParameterCombination,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const set_alarm_state: struct {
    action_name: []const u8 = "SetAlarmState",
    Request: type = struct {
        alarm_name: []const u8,
        state_value: []const u8,
        state_reason: []const u8,
        state_reason_data: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "AlarmName",
                .state_value = "StateValue",
                .state_reason = "StateReason",
                .state_reason_data = "StateReasonData",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_alarm_state) } {
            return .{ .service_metadata = service_metadata, .action = set_alarm_state };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidFormat,
        ResourceNotFound,
    },
} = .{};
pub const start_metric_streams: struct {
    action_name: []const u8 = "StartMetricStreams",
    Request: type = struct {
        names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .names = "Names",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_metric_streams) } {
            return .{ .service_metadata = service_metadata, .action = start_metric_streams };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const stop_metric_streams: struct {
    action_name: []const u8 = "StopMetricStreams",
    Request: type = struct {
        names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .names = "Names",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_metric_streams) } {
            return .{ .service_metadata = service_metadata, .action = stop_metric_streams };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameterValue,
        MissingRequiredParameter,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalService,
        InvalidParameterValue,
        ResourceNotFound,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalService,
        InvalidParameterValue,
        ResourceNotFound,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricStreamStatisticsConfiguration = struct {
    include_metrics: []MetricStreamStatisticsMetric,
    additional_statistics: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .include_metrics = "IncludeMetrics",
            .additional_statistics = "AdditionalStatistics",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricStreamStatisticsMetric = struct {
    namespace: []const u8,
    metric_name: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .namespace = "Namespace",
            .metric_name = "MetricName",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricStreamFilter = struct {
    namespace: ?[]const u8 = null,
    metric_names: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .namespace = "Namespace",
            .metric_names = "MetricNames",
        };
        return @field(mappings, field_name);
    }
};

pub const Dimension = struct {
    name: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricDataQuery = struct {
    id: []const u8,
    metric_stat: ?MetricStat = null,
    expression: ?[]const u8 = null,
    label: ?[]const u8 = null,
    return_data: ?bool = null,
    period: ?i64 = null,
    account_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .metric_stat = "MetricStat",
            .expression = "Expression",
            .label = "Label",
            .return_data = "ReturnData",
            .period = "Period",
            .account_id = "AccountId",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricStat = struct {
    metric: Metric,
    period: i64,
    stat: []const u8,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric = "Metric",
            .period = "Period",
            .stat = "Stat",
            .unit = "Unit",
        };
        return @field(mappings, field_name);
    }
};

pub const Metric = struct {
    namespace: ?[]const u8 = null,
    metric_name: ?[]const u8 = null,
    dimensions: ?[]Dimension = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .namespace = "Namespace",
            .metric_name = "MetricName",
            .dimensions = "Dimensions",
        };
        return @field(mappings, field_name);
    }
};

pub const PartialFailure = struct {
    failure_resource: ?[]const u8 = null,
    exception_type: ?[]const u8 = null,
    failure_code: ?[]const u8 = null,
    failure_description: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .failure_resource = "FailureResource",
            .exception_type = "ExceptionType",
            .failure_code = "FailureCode",
            .failure_description = "FailureDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const DashboardValidationMessage = struct {
    data_path: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_path = "DataPath",
            .message = "Message",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricMathAnomalyDetector = struct {
    metric_data_queries: ?[]MetricDataQuery = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_data_queries = "MetricDataQueries",
        };
        return @field(mappings, field_name);
    }
};

pub const SingleMetricAnomalyDetector = struct {
    namespace: ?[]const u8 = null,
    metric_name: ?[]const u8 = null,
    dimensions: ?[]Dimension = null,
    stat: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .namespace = "Namespace",
            .metric_name = "MetricName",
            .dimensions = "Dimensions",
            .stat = "Stat",
        };
        return @field(mappings, field_name);
    }
};

pub const AnomalyDetectorConfiguration = struct {
    excluded_time_ranges: ?[]Range = null,
    metric_timezone: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .excluded_time_ranges = "ExcludedTimeRanges",
            .metric_timezone = "MetricTimezone",
        };
        return @field(mappings, field_name);
    }
};

pub const Range = struct {
    start_time: i64,
    end_time: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .start_time = "StartTime",
            .end_time = "EndTime",
        };
        return @field(mappings, field_name);
    }
};

pub const MessageData = struct {
    code: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "Code",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricAlarm = struct {
    alarm_name: ?[]const u8 = null,
    alarm_arn: ?[]const u8 = null,
    alarm_description: ?[]const u8 = null,
    alarm_configuration_updated_timestamp: ?i64 = null,
    actions_enabled: ?bool = null,
    ok_actions: ?[][]const u8 = null,
    alarm_actions: ?[][]const u8 = null,
    insufficient_data_actions: ?[][]const u8 = null,
    state_value: ?[]const u8 = null,
    state_reason: ?[]const u8 = null,
    state_reason_data: ?[]const u8 = null,
    state_updated_timestamp: ?i64 = null,
    metric_name: ?[]const u8 = null,
    namespace: ?[]const u8 = null,
    statistic: ?[]const u8 = null,
    extended_statistic: ?[]const u8 = null,
    dimensions: ?[]Dimension = null,
    period: ?i64 = null,
    unit: ?[]const u8 = null,
    evaluation_periods: ?i64 = null,
    datapoints_to_alarm: ?i64 = null,
    threshold: ?f64 = null,
    comparison_operator: ?[]const u8 = null,
    treat_missing_data: ?[]const u8 = null,
    evaluate_low_sample_count_percentile: ?[]const u8 = null,
    metrics: ?[]MetricDataQuery = null,
    threshold_metric_id: ?[]const u8 = null,
    evaluation_state: ?[]const u8 = null,
    state_transitioned_timestamp: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .alarm_name = "AlarmName",
            .alarm_arn = "AlarmArn",
            .alarm_description = "AlarmDescription",
            .alarm_configuration_updated_timestamp = "AlarmConfigurationUpdatedTimestamp",
            .actions_enabled = "ActionsEnabled",
            .ok_actions = "OKActions",
            .alarm_actions = "AlarmActions",
            .insufficient_data_actions = "InsufficientDataActions",
            .state_value = "StateValue",
            .state_reason = "StateReason",
            .state_reason_data = "StateReasonData",
            .state_updated_timestamp = "StateUpdatedTimestamp",
            .metric_name = "MetricName",
            .namespace = "Namespace",
            .statistic = "Statistic",
            .extended_statistic = "ExtendedStatistic",
            .dimensions = "Dimensions",
            .period = "Period",
            .unit = "Unit",
            .evaluation_periods = "EvaluationPeriods",
            .datapoints_to_alarm = "DatapointsToAlarm",
            .threshold = "Threshold",
            .comparison_operator = "ComparisonOperator",
            .treat_missing_data = "TreatMissingData",
            .evaluate_low_sample_count_percentile = "EvaluateLowSampleCountPercentile",
            .metrics = "Metrics",
            .threshold_metric_id = "ThresholdMetricId",
            .evaluation_state = "EvaluationState",
            .state_transitioned_timestamp = "StateTransitionedTimestamp",
        };
        return @field(mappings, field_name);
    }
};
