const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2016-10-06";
pub const sdk_id: []const u8 = "CodeBuild";
pub const arn_namespace: ?[]const u8 = "codebuild";
pub const endpoint_prefix: []const u8 = "codebuild";
pub const sigv4_name: []const u8 = "codebuild";
pub const name: []const u8 = "CodeBuild_20161006";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2016-10-06",
    sdk_id: []const u8 = "CodeBuild",
    arn_namespace: ?[]const u8 = "codebuild",
    endpoint_prefix: []const u8 = "codebuild",
    sigv4_name: []const u8 = "codebuild",
    name: []const u8 = "CodeBuild_20161006",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const batch_delete_builds: struct {
    action_name: []const u8 = "BatchDeleteBuilds",
    Request: type = struct {
        ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_delete_builds) } {
            return .{ .service_metadata = service_metadata, .action = batch_delete_builds };
        }
    },
    Response: type = struct {
        builds_deleted: ?[][]const u8 = null,
        builds_not_deleted: ?[]BuildNotDeleted = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .builds_deleted = "buildsDeleted",
                .builds_not_deleted = "buildsNotDeleted",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_build_batches: struct {
    action_name: []const u8 = "BatchGetBuildBatches",
    Request: type = struct {
        ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_build_batches) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_build_batches };
        }
    },
    Response: type = struct {
        build_batches: ?[]BuildBatch = null,
        build_batches_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build_batches = "buildBatches",
                .build_batches_not_found = "buildBatchesNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_builds: struct {
    action_name: []const u8 = "BatchGetBuilds",
    Request: type = struct {
        ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_builds) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_builds };
        }
    },
    Response: type = struct {
        builds: ?[]Build = null,
        builds_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .builds = "builds",
                .builds_not_found = "buildsNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_fleets: struct {
    action_name: []const u8 = "BatchGetFleets",
    Request: type = struct {
        names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .names = "names",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_fleets) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_fleets };
        }
    },
    Response: type = struct {
        fleets: ?[]Fleet = null,
        fleets_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .fleets = "fleets",
                .fleets_not_found = "fleetsNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_projects: struct {
    action_name: []const u8 = "BatchGetProjects",
    Request: type = struct {
        names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .names = "names",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_projects) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_projects };
        }
    },
    Response: type = struct {
        projects: ?[]Project = null,
        projects_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .projects = "projects",
                .projects_not_found = "projectsNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_report_groups: struct {
    action_name: []const u8 = "BatchGetReportGroups",
    Request: type = struct {
        report_group_arns: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_group_arns = "reportGroupArns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_report_groups) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_report_groups };
        }
    },
    Response: type = struct {
        report_groups: ?[]ReportGroup = null,
        report_groups_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_groups = "reportGroups",
                .report_groups_not_found = "reportGroupsNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const batch_get_reports: struct {
    action_name: []const u8 = "BatchGetReports",
    Request: type = struct {
        report_arns: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_arns = "reportArns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_reports) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_reports };
        }
    },
    Response: type = struct {
        reports: ?[]struct {
            arn: ?[]const u8 = null,
            type: ?[]const u8 = null,
            name: ?[]const u8 = null,
            report_group_arn: ?[]const u8 = null,
            execution_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            created: ?i64 = null,
            expired: ?i64 = null,
            export_config: ?ReportExportConfig = null,
            truncated: ?bool = null,
            test_summary: ?struct {
                total: i64,
                status_counts: []struct {
                    key: ?[]const u8 = null,
                    value: ?i64 = null,
                },
                duration_in_nano_seconds: i64,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .total = "total",
                        .status_counts = "statusCounts",
                        .duration_in_nano_seconds = "durationInNanoSeconds",
                    };
                    return @field(mappings, field_name);
                }

                pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                    if (std.mem.eql(u8, "status_counts", field_name))
                        return try serializeMap(self.status_counts, self.fieldNameFor("status_counts"), options, out_stream);
                    return false;
                }
            } = null,
            code_coverage_summary: ?struct {
                line_coverage_percentage: ?f64 = null,
                lines_covered: ?i64 = null,
                lines_missed: ?i64 = null,
                branch_coverage_percentage: ?f64 = null,
                branches_covered: ?i64 = null,
                branches_missed: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .line_coverage_percentage = "lineCoveragePercentage",
                        .lines_covered = "linesCovered",
                        .lines_missed = "linesMissed",
                        .branch_coverage_percentage = "branchCoveragePercentage",
                        .branches_covered = "branchesCovered",
                        .branches_missed = "branchesMissed",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "arn",
                    .type = "type",
                    .name = "name",
                    .report_group_arn = "reportGroupArn",
                    .execution_id = "executionId",
                    .status = "status",
                    .created = "created",
                    .expired = "expired",
                    .export_config = "exportConfig",
                    .truncated = "truncated",
                    .test_summary = "testSummary",
                    .code_coverage_summary = "codeCoverageSummary",
                };
                return @field(mappings, field_name);
            }
        } = null,
        reports_not_found: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .reports = "reports",
                .reports_not_found = "reportsNotFound",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const create_fleet: struct {
    action_name: []const u8 = "CreateFleet",
    Request: type = struct {
        name: []const u8,
        base_capacity: i64,
        environment_type: []const u8,
        compute_type: []const u8,
        scaling_configuration: ?ScalingConfigurationInput = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .base_capacity = "baseCapacity",
                .environment_type = "environmentType",
                .compute_type = "computeType",
                .scaling_configuration = "scalingConfiguration",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_fleet) } {
            return .{ .service_metadata = service_metadata, .action = create_fleet };
        }
    },
    Response: type = struct {
        fleet: ?Fleet = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .fleet = "fleet",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceAlreadyExists,
    },
} = .{};
pub const create_project: struct {
    action_name: []const u8 = "CreateProject",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        source: ProjectSource,
        secondary_sources: ?[]ProjectSource = null,
        source_version: ?[]const u8 = null,
        secondary_source_versions: ?[]ProjectSourceVersion = null,
        artifacts: ProjectArtifacts,
        secondary_artifacts: ?[]ProjectArtifacts = null,
        cache: ?ProjectCache = null,
        environment: ProjectEnvironment,
        service_role: []const u8,
        timeout_in_minutes: ?i64 = null,
        queued_timeout_in_minutes: ?i64 = null,
        encryption_key: ?[]const u8 = null,
        tags: ?[]Tag = null,
        vpc_config: ?VpcConfig = null,
        badge_enabled: ?bool = null,
        logs_config: ?LogsConfig = null,
        file_system_locations: ?[]ProjectFileSystemLocation = null,
        build_batch_config: ?ProjectBuildBatchConfig = null,
        concurrent_build_limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .source = "source",
                .secondary_sources = "secondarySources",
                .source_version = "sourceVersion",
                .secondary_source_versions = "secondarySourceVersions",
                .artifacts = "artifacts",
                .secondary_artifacts = "secondaryArtifacts",
                .cache = "cache",
                .environment = "environment",
                .service_role = "serviceRole",
                .timeout_in_minutes = "timeoutInMinutes",
                .queued_timeout_in_minutes = "queuedTimeoutInMinutes",
                .encryption_key = "encryptionKey",
                .tags = "tags",
                .vpc_config = "vpcConfig",
                .badge_enabled = "badgeEnabled",
                .logs_config = "logsConfig",
                .file_system_locations = "fileSystemLocations",
                .build_batch_config = "buildBatchConfig",
                .concurrent_build_limit = "concurrentBuildLimit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_project) } {
            return .{ .service_metadata = service_metadata, .action = create_project };
        }
    },
    Response: type = struct {
        project: ?Project = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project = "project",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceAlreadyExists,
    },
} = .{};
pub const create_report_group: struct {
    action_name: []const u8 = "CreateReportGroup",
    Request: type = struct {
        name: []const u8,
        type: []const u8,
        export_config: ReportExportConfig,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .type = "type",
                .export_config = "exportConfig",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_report_group) } {
            return .{ .service_metadata = service_metadata, .action = create_report_group };
        }
    },
    Response: type = struct {
        report_group: ?ReportGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_group = "reportGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceAlreadyExists,
    },
} = .{};
pub const create_webhook: struct {
    action_name: []const u8 = "CreateWebhook",
    Request: type = struct {
        project_name: []const u8,
        branch_filter: ?[]const u8 = null,
        filter_groups: ?[][]WebhookFilter = null,
        build_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .branch_filter = "branchFilter",
                .filter_groups = "filterGroups",
                .build_type = "buildType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_webhook) } {
            return .{ .service_metadata = service_metadata, .action = create_webhook };
        }
    },
    Response: type = struct {
        webhook: ?Webhook = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .webhook = "webhook",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OAuthProvider,
        ResourceAlreadyExists,
        ResourceNotFound,
    },
} = .{};
pub const delete_build_batch: struct {
    action_name: []const u8 = "DeleteBuildBatch",
    Request: type = struct {
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_build_batch) } {
            return .{ .service_metadata = service_metadata, .action = delete_build_batch };
        }
    },
    Response: type = struct {
        status_code: ?[]const u8 = null,
        builds_deleted: ?[][]const u8 = null,
        builds_not_deleted: ?[]BuildNotDeleted = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status_code = "statusCode",
                .builds_deleted = "buildsDeleted",
                .builds_not_deleted = "buildsNotDeleted",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_fleet: struct {
    action_name: []const u8 = "DeleteFleet",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_fleet) } {
            return .{ .service_metadata = service_metadata, .action = delete_fleet };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_project: struct {
    action_name: []const u8 = "DeleteProject",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_project) } {
            return .{ .service_metadata = service_metadata, .action = delete_project };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_report: struct {
    action_name: []const u8 = "DeleteReport",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_report) } {
            return .{ .service_metadata = service_metadata, .action = delete_report };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_report_group: struct {
    action_name: []const u8 = "DeleteReportGroup",
    Request: type = struct {
        arn: []const u8,
        delete_reports: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
                .delete_reports = "deleteReports",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_report_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_report_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_resource_policy: struct {
    action_name: []const u8 = "DeleteResourcePolicy",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_resource_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const delete_source_credentials: struct {
    action_name: []const u8 = "DeleteSourceCredentials",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_source_credentials) } {
            return .{ .service_metadata = service_metadata, .action = delete_source_credentials };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const delete_webhook: struct {
    action_name: []const u8 = "DeleteWebhook",
    Request: type = struct {
        project_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_webhook) } {
            return .{ .service_metadata = service_metadata, .action = delete_webhook };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OAuthProvider,
        ResourceNotFound,
    },
} = .{};
pub const describe_code_coverages: struct {
    action_name: []const u8 = "DescribeCodeCoverages",
    Request: type = struct {
        report_arn: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        sort_order: ?[]const u8 = null,
        sort_by: ?[]const u8 = null,
        min_line_coverage_percentage: ?f64 = null,
        max_line_coverage_percentage: ?f64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_arn = "reportArn",
                .next_token = "nextToken",
                .max_results = "maxResults",
                .sort_order = "sortOrder",
                .sort_by = "sortBy",
                .min_line_coverage_percentage = "minLineCoveragePercentage",
                .max_line_coverage_percentage = "maxLineCoveragePercentage",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_code_coverages) } {
            return .{ .service_metadata = service_metadata, .action = describe_code_coverages };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        code_coverages: ?[]struct {
            id: ?[]const u8 = null,
            report_arn: ?[]const u8 = null,
            file_path: ?[]const u8 = null,
            line_coverage_percentage: ?f64 = null,
            lines_covered: ?i64 = null,
            lines_missed: ?i64 = null,
            branch_coverage_percentage: ?f64 = null,
            branches_covered: ?i64 = null,
            branches_missed: ?i64 = null,
            expired: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "id",
                    .report_arn = "reportARN",
                    .file_path = "filePath",
                    .line_coverage_percentage = "lineCoveragePercentage",
                    .lines_covered = "linesCovered",
                    .lines_missed = "linesMissed",
                    .branch_coverage_percentage = "branchCoveragePercentage",
                    .branches_covered = "branchesCovered",
                    .branches_missed = "branchesMissed",
                    .expired = "expired",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .code_coverages = "codeCoverages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const describe_test_cases: struct {
    action_name: []const u8 = "DescribeTestCases",
    Request: type = struct {
        report_arn: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filter: ?struct {
            status: ?[]const u8 = null,
            keyword: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "status",
                    .keyword = "keyword",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_arn = "reportArn",
                .next_token = "nextToken",
                .max_results = "maxResults",
                .filter = "filter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_test_cases) } {
            return .{ .service_metadata = service_metadata, .action = describe_test_cases };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        test_cases: ?[]struct {
            report_arn: ?[]const u8 = null,
            test_raw_data_path: ?[]const u8 = null,
            prefix: ?[]const u8 = null,
            name: ?[]const u8 = null,
            status: ?[]const u8 = null,
            duration_in_nano_seconds: ?i64 = null,
            message: ?[]const u8 = null,
            expired: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .report_arn = "reportArn",
                    .test_raw_data_path = "testRawDataPath",
                    .prefix = "prefix",
                    .name = "name",
                    .status = "status",
                    .duration_in_nano_seconds = "durationInNanoSeconds",
                    .message = "message",
                    .expired = "expired",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .test_cases = "testCases",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const get_report_group_trend: struct {
    action_name: []const u8 = "GetReportGroupTrend",
    Request: type = struct {
        report_group_arn: []const u8,
        num_of_reports: ?i64 = null,
        trend_field: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_group_arn = "reportGroupArn",
                .num_of_reports = "numOfReports",
                .trend_field = "trendField",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_report_group_trend) } {
            return .{ .service_metadata = service_metadata, .action = get_report_group_trend };
        }
    },
    Response: type = struct {
        stats: ?struct {
            average: ?[]const u8 = null,
            max: ?[]const u8 = null,
            min: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .average = "average",
                    .max = "max",
                    .min = "min",
                };
                return @field(mappings, field_name);
            }
        } = null,
        raw_data: ?[]struct {
            report_arn: ?[]const u8 = null,
            data: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .report_arn = "reportArn",
                    .data = "data",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stats = "stats",
                .raw_data = "rawData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const get_resource_policy: struct {
    action_name: []const u8 = "GetResourcePolicy",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_resource_policy };
        }
    },
    Response: type = struct {
        policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "policy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const import_source_credentials: struct {
    action_name: []const u8 = "ImportSourceCredentials",
    Request: type = struct {
        username: ?[]const u8 = null,
        token: []const u8,
        server_type: []const u8,
        auth_type: []const u8,
        should_overwrite: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .username = "username",
                .token = "token",
                .server_type = "serverType",
                .auth_type = "authType",
                .should_overwrite = "shouldOverwrite",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_source_credentials) } {
            return .{ .service_metadata = service_metadata, .action = import_source_credentials };
        }
    },
    Response: type = struct {
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceAlreadyExists,
    },
} = .{};
pub const invalidate_project_cache: struct {
    action_name: []const u8 = "InvalidateProjectCache",
    Request: type = struct {
        project_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(invalidate_project_cache) } {
            return .{ .service_metadata = service_metadata, .action = invalidate_project_cache };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_build_batches: struct {
    action_name: []const u8 = "ListBuildBatches",
    Request: type = struct {
        filter: ?BuildBatchFilter = null,
        max_results: ?i64 = null,
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "filter",
                .max_results = "maxResults",
                .sort_order = "sortOrder",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_build_batches) } {
            return .{ .service_metadata = service_metadata, .action = list_build_batches };
        }
    },
    Response: type = struct {
        ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_build_batches_for_project: struct {
    action_name: []const u8 = "ListBuildBatchesForProject",
    Request: type = struct {
        project_name: ?[]const u8 = null,
        filter: ?BuildBatchFilter = null,
        max_results: ?i64 = null,
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .filter = "filter",
                .max_results = "maxResults",
                .sort_order = "sortOrder",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_build_batches_for_project) } {
            return .{ .service_metadata = service_metadata, .action = list_build_batches_for_project };
        }
    },
    Response: type = struct {
        ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_builds: struct {
    action_name: []const u8 = "ListBuilds",
    Request: type = struct {
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_order = "sortOrder",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_builds) } {
            return .{ .service_metadata = service_metadata, .action = list_builds };
        }
    },
    Response: type = struct {
        ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_builds_for_project: struct {
    action_name: []const u8 = "ListBuildsForProject",
    Request: type = struct {
        project_name: []const u8,
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .sort_order = "sortOrder",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_builds_for_project) } {
            return .{ .service_metadata = service_metadata, .action = list_builds_for_project };
        }
    },
    Response: type = struct {
        ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ids = "ids",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_curated_environment_images: struct {
    action_name: []const u8 = "ListCuratedEnvironmentImages",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_curated_environment_images) } {
            return .{ .service_metadata = service_metadata, .action = list_curated_environment_images };
        }
    },
    Response: type = struct {
        platforms: ?[]struct {
            platform: ?[]const u8 = null,
            languages: ?[]struct {
                language: ?[]const u8 = null,
                images: ?[]struct {
                    name: ?[]const u8 = null,
                    description: ?[]const u8 = null,
                    versions: ?[][]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .name = "name",
                            .description = "description",
                            .versions = "versions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .language = "language",
                        .images = "images",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .platform = "platform",
                    .languages = "languages",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .platforms = "platforms",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_fleets: struct {
    action_name: []const u8 = "ListFleets",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        sort_order: ?[]const u8 = null,
        sort_by: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .max_results = "maxResults",
                .sort_order = "sortOrder",
                .sort_by = "sortBy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_fleets) } {
            return .{ .service_metadata = service_metadata, .action = list_fleets };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        fleets: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .fleets = "fleets",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_projects: struct {
    action_name: []const u8 = "ListProjects",
    Request: type = struct {
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_by = "sortBy",
                .sort_order = "sortOrder",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_projects) } {
            return .{ .service_metadata = service_metadata, .action = list_projects };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        projects: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .projects = "projects",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_report_groups: struct {
    action_name: []const u8 = "ListReportGroups",
    Request: type = struct {
        sort_order: ?[]const u8 = null,
        sort_by: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_order = "sortOrder",
                .sort_by = "sortBy",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_report_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_report_groups };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        report_groups: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .report_groups = "reportGroups",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_reports: struct {
    action_name: []const u8 = "ListReports",
    Request: type = struct {
        sort_order: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        filter: ?ReportFilter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_order = "sortOrder",
                .next_token = "nextToken",
                .max_results = "maxResults",
                .filter = "filter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_reports) } {
            return .{ .service_metadata = service_metadata, .action = list_reports };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        reports: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .reports = "reports",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_reports_for_report_group: struct {
    action_name: []const u8 = "ListReportsForReportGroup",
    Request: type = struct {
        report_group_arn: []const u8,
        next_token: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,
        max_results: ?i64 = null,
        filter: ?ReportFilter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_group_arn = "reportGroupArn",
                .next_token = "nextToken",
                .sort_order = "sortOrder",
                .max_results = "maxResults",
                .filter = "filter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_reports_for_report_group) } {
            return .{ .service_metadata = service_metadata, .action = list_reports_for_report_group };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        reports: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .reports = "reports",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_shared_projects: struct {
    action_name: []const u8 = "ListSharedProjects",
    Request: type = struct {
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_by = "sortBy",
                .sort_order = "sortOrder",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_shared_projects) } {
            return .{ .service_metadata = service_metadata, .action = list_shared_projects };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        projects: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .projects = "projects",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_shared_report_groups: struct {
    action_name: []const u8 = "ListSharedReportGroups",
    Request: type = struct {
        sort_order: ?[]const u8 = null,
        sort_by: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sort_order = "sortOrder",
                .sort_by = "sortBy",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_shared_report_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_shared_report_groups };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        report_groups: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .report_groups = "reportGroups",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_source_credentials: struct {
    action_name: []const u8 = "ListSourceCredentials",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_source_credentials) } {
            return .{ .service_metadata = service_metadata, .action = list_source_credentials };
        }
    },
    Response: type = struct {
        source_credentials_infos: ?[]struct {
            arn: ?[]const u8 = null,
            server_type: ?[]const u8 = null,
            auth_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "arn",
                    .server_type = "serverType",
                    .auth_type = "authType",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .source_credentials_infos = "sourceCredentialsInfos",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const put_resource_policy: struct {
    action_name: []const u8 = "PutResourcePolicy",
    Request: type = struct {
        policy: []const u8,
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "policy",
                .resource_arn = "resourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_resource_policy };
        }
    },
    Response: type = struct {
        resource_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const retry_build: struct {
    action_name: []const u8 = "RetryBuild",
    Request: type = struct {
        id: ?[]const u8 = null,
        idempotency_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "id",
                .idempotency_token = "idempotencyToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(retry_build) } {
            return .{ .service_metadata = service_metadata, .action = retry_build };
        }
    },
    Response: type = struct {
        build: ?Build = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build = "build",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const retry_build_batch: struct {
    action_name: []const u8 = "RetryBuildBatch",
    Request: type = struct {
        id: ?[]const u8 = null,
        idempotency_token: ?[]const u8 = null,
        retry_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "id",
                .idempotency_token = "idempotencyToken",
                .retry_type = "retryType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(retry_build_batch) } {
            return .{ .service_metadata = service_metadata, .action = retry_build_batch };
        }
    },
    Response: type = struct {
        build_batch: ?BuildBatch = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build_batch = "buildBatch",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const start_build: struct {
    action_name: []const u8 = "StartBuild",
    Request: type = struct {
        project_name: []const u8,
        secondary_sources_override: ?[]ProjectSource = null,
        secondary_sources_version_override: ?[]ProjectSourceVersion = null,
        source_version: ?[]const u8 = null,
        artifacts_override: ?ProjectArtifacts = null,
        secondary_artifacts_override: ?[]ProjectArtifacts = null,
        environment_variables_override: ?[]EnvironmentVariable = null,
        source_type_override: ?[]const u8 = null,
        source_location_override: ?[]const u8 = null,
        source_auth_override: ?SourceAuth = null,
        git_clone_depth_override: ?i64 = null,
        git_submodules_config_override: ?GitSubmodulesConfig = null,
        buildspec_override: ?[]const u8 = null,
        insecure_ssl_override: ?bool = null,
        report_build_status_override: ?bool = null,
        build_status_config_override: ?BuildStatusConfig = null,
        environment_type_override: ?[]const u8 = null,
        image_override: ?[]const u8 = null,
        compute_type_override: ?[]const u8 = null,
        certificate_override: ?[]const u8 = null,
        cache_override: ?ProjectCache = null,
        service_role_override: ?[]const u8 = null,
        privileged_mode_override: ?bool = null,
        timeout_in_minutes_override: ?i64 = null,
        queued_timeout_in_minutes_override: ?i64 = null,
        encryption_key_override: ?[]const u8 = null,
        idempotency_token: ?[]const u8 = null,
        logs_config_override: ?LogsConfig = null,
        registry_credential_override: ?RegistryCredential = null,
        image_pull_credentials_type_override: ?[]const u8 = null,
        debug_session_enabled: ?bool = null,
        fleet_override: ?ProjectFleet = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .secondary_sources_override = "secondarySourcesOverride",
                .secondary_sources_version_override = "secondarySourcesVersionOverride",
                .source_version = "sourceVersion",
                .artifacts_override = "artifactsOverride",
                .secondary_artifacts_override = "secondaryArtifactsOverride",
                .environment_variables_override = "environmentVariablesOverride",
                .source_type_override = "sourceTypeOverride",
                .source_location_override = "sourceLocationOverride",
                .source_auth_override = "sourceAuthOverride",
                .git_clone_depth_override = "gitCloneDepthOverride",
                .git_submodules_config_override = "gitSubmodulesConfigOverride",
                .buildspec_override = "buildspecOverride",
                .insecure_ssl_override = "insecureSslOverride",
                .report_build_status_override = "reportBuildStatusOverride",
                .build_status_config_override = "buildStatusConfigOverride",
                .environment_type_override = "environmentTypeOverride",
                .image_override = "imageOverride",
                .compute_type_override = "computeTypeOverride",
                .certificate_override = "certificateOverride",
                .cache_override = "cacheOverride",
                .service_role_override = "serviceRoleOverride",
                .privileged_mode_override = "privilegedModeOverride",
                .timeout_in_minutes_override = "timeoutInMinutesOverride",
                .queued_timeout_in_minutes_override = "queuedTimeoutInMinutesOverride",
                .encryption_key_override = "encryptionKeyOverride",
                .idempotency_token = "idempotencyToken",
                .logs_config_override = "logsConfigOverride",
                .registry_credential_override = "registryCredentialOverride",
                .image_pull_credentials_type_override = "imagePullCredentialsTypeOverride",
                .debug_session_enabled = "debugSessionEnabled",
                .fleet_override = "fleetOverride",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_build) } {
            return .{ .service_metadata = service_metadata, .action = start_build };
        }
    },
    Response: type = struct {
        build: ?Build = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build = "build",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const start_build_batch: struct {
    action_name: []const u8 = "StartBuildBatch",
    Request: type = struct {
        project_name: []const u8,
        secondary_sources_override: ?[]ProjectSource = null,
        secondary_sources_version_override: ?[]ProjectSourceVersion = null,
        source_version: ?[]const u8 = null,
        artifacts_override: ?ProjectArtifacts = null,
        secondary_artifacts_override: ?[]ProjectArtifacts = null,
        environment_variables_override: ?[]EnvironmentVariable = null,
        source_type_override: ?[]const u8 = null,
        source_location_override: ?[]const u8 = null,
        source_auth_override: ?SourceAuth = null,
        git_clone_depth_override: ?i64 = null,
        git_submodules_config_override: ?GitSubmodulesConfig = null,
        buildspec_override: ?[]const u8 = null,
        insecure_ssl_override: ?bool = null,
        report_build_batch_status_override: ?bool = null,
        environment_type_override: ?[]const u8 = null,
        image_override: ?[]const u8 = null,
        compute_type_override: ?[]const u8 = null,
        certificate_override: ?[]const u8 = null,
        cache_override: ?ProjectCache = null,
        service_role_override: ?[]const u8 = null,
        privileged_mode_override: ?bool = null,
        build_timeout_in_minutes_override: ?i64 = null,
        queued_timeout_in_minutes_override: ?i64 = null,
        encryption_key_override: ?[]const u8 = null,
        idempotency_token: ?[]const u8 = null,
        logs_config_override: ?LogsConfig = null,
        registry_credential_override: ?RegistryCredential = null,
        image_pull_credentials_type_override: ?[]const u8 = null,
        build_batch_config_override: ?ProjectBuildBatchConfig = null,
        debug_session_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .secondary_sources_override = "secondarySourcesOverride",
                .secondary_sources_version_override = "secondarySourcesVersionOverride",
                .source_version = "sourceVersion",
                .artifacts_override = "artifactsOverride",
                .secondary_artifacts_override = "secondaryArtifactsOverride",
                .environment_variables_override = "environmentVariablesOverride",
                .source_type_override = "sourceTypeOverride",
                .source_location_override = "sourceLocationOverride",
                .source_auth_override = "sourceAuthOverride",
                .git_clone_depth_override = "gitCloneDepthOverride",
                .git_submodules_config_override = "gitSubmodulesConfigOverride",
                .buildspec_override = "buildspecOverride",
                .insecure_ssl_override = "insecureSslOverride",
                .report_build_batch_status_override = "reportBuildBatchStatusOverride",
                .environment_type_override = "environmentTypeOverride",
                .image_override = "imageOverride",
                .compute_type_override = "computeTypeOverride",
                .certificate_override = "certificateOverride",
                .cache_override = "cacheOverride",
                .service_role_override = "serviceRoleOverride",
                .privileged_mode_override = "privilegedModeOverride",
                .build_timeout_in_minutes_override = "buildTimeoutInMinutesOverride",
                .queued_timeout_in_minutes_override = "queuedTimeoutInMinutesOverride",
                .encryption_key_override = "encryptionKeyOverride",
                .idempotency_token = "idempotencyToken",
                .logs_config_override = "logsConfigOverride",
                .registry_credential_override = "registryCredentialOverride",
                .image_pull_credentials_type_override = "imagePullCredentialsTypeOverride",
                .build_batch_config_override = "buildBatchConfigOverride",
                .debug_session_enabled = "debugSessionEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_build_batch) } {
            return .{ .service_metadata = service_metadata, .action = start_build_batch };
        }
    },
    Response: type = struct {
        build_batch: ?BuildBatch = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build_batch = "buildBatch",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const stop_build: struct {
    action_name: []const u8 = "StopBuild",
    Request: type = struct {
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_build) } {
            return .{ .service_metadata = service_metadata, .action = stop_build };
        }
    },
    Response: type = struct {
        build: ?Build = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build = "build",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const stop_build_batch: struct {
    action_name: []const u8 = "StopBuildBatch",
    Request: type = struct {
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_build_batch) } {
            return .{ .service_metadata = service_metadata, .action = stop_build_batch };
        }
    },
    Response: type = struct {
        build_batch: ?BuildBatch = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .build_batch = "buildBatch",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const update_fleet: struct {
    action_name: []const u8 = "UpdateFleet",
    Request: type = struct {
        arn: []const u8,
        base_capacity: ?i64 = null,
        environment_type: ?[]const u8 = null,
        compute_type: ?[]const u8 = null,
        scaling_configuration: ?ScalingConfigurationInput = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
                .base_capacity = "baseCapacity",
                .environment_type = "environmentType",
                .compute_type = "computeType",
                .scaling_configuration = "scalingConfiguration",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_fleet) } {
            return .{ .service_metadata = service_metadata, .action = update_fleet };
        }
    },
    Response: type = struct {
        fleet: ?Fleet = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .fleet = "fleet",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccountLimitExceeded,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const update_project: struct {
    action_name: []const u8 = "UpdateProject",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        source: ?ProjectSource = null,
        secondary_sources: ?[]ProjectSource = null,
        source_version: ?[]const u8 = null,
        secondary_source_versions: ?[]ProjectSourceVersion = null,
        artifacts: ?ProjectArtifacts = null,
        secondary_artifacts: ?[]ProjectArtifacts = null,
        cache: ?ProjectCache = null,
        environment: ?ProjectEnvironment = null,
        service_role: ?[]const u8 = null,
        timeout_in_minutes: ?i64 = null,
        queued_timeout_in_minutes: ?i64 = null,
        encryption_key: ?[]const u8 = null,
        tags: ?[]Tag = null,
        vpc_config: ?VpcConfig = null,
        badge_enabled: ?bool = null,
        logs_config: ?LogsConfig = null,
        file_system_locations: ?[]ProjectFileSystemLocation = null,
        build_batch_config: ?ProjectBuildBatchConfig = null,
        concurrent_build_limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .source = "source",
                .secondary_sources = "secondarySources",
                .source_version = "sourceVersion",
                .secondary_source_versions = "secondarySourceVersions",
                .artifacts = "artifacts",
                .secondary_artifacts = "secondaryArtifacts",
                .cache = "cache",
                .environment = "environment",
                .service_role = "serviceRole",
                .timeout_in_minutes = "timeoutInMinutes",
                .queued_timeout_in_minutes = "queuedTimeoutInMinutes",
                .encryption_key = "encryptionKey",
                .tags = "tags",
                .vpc_config = "vpcConfig",
                .badge_enabled = "badgeEnabled",
                .logs_config = "logsConfig",
                .file_system_locations = "fileSystemLocations",
                .build_batch_config = "buildBatchConfig",
                .concurrent_build_limit = "concurrentBuildLimit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_project) } {
            return .{ .service_metadata = service_metadata, .action = update_project };
        }
    },
    Response: type = struct {
        project: ?Project = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project = "project",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const update_project_visibility: struct {
    action_name: []const u8 = "UpdateProjectVisibility",
    Request: type = struct {
        project_arn: []const u8,
        project_visibility: []const u8,
        resource_access_role: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_arn = "projectArn",
                .project_visibility = "projectVisibility",
                .resource_access_role = "resourceAccessRole",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_project_visibility) } {
            return .{ .service_metadata = service_metadata, .action = update_project_visibility };
        }
    },
    Response: type = struct {
        project_arn: ?[]const u8 = null,
        public_project_alias: ?[]const u8 = null,
        project_visibility: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_arn = "projectArn",
                .public_project_alias = "publicProjectAlias",
                .project_visibility = "projectVisibility",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const update_report_group: struct {
    action_name: []const u8 = "UpdateReportGroup",
    Request: type = struct {
        arn: []const u8,
        export_config: ?ReportExportConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "arn",
                .export_config = "exportConfig",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_report_group) } {
            return .{ .service_metadata = service_metadata, .action = update_report_group };
        }
    },
    Response: type = struct {
        report_group: ?ReportGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .report_group = "reportGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const update_webhook: struct {
    action_name: []const u8 = "UpdateWebhook",
    Request: type = struct {
        project_name: []const u8,
        branch_filter: ?[]const u8 = null,
        rotate_secret: ?bool = null,
        filter_groups: ?[][]WebhookFilter = null,
        build_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .project_name = "projectName",
                .branch_filter = "branchFilter",
                .rotate_secret = "rotateSecret",
                .filter_groups = "filterGroups",
                .build_type = "buildType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_webhook) } {
            return .{ .service_metadata = service_metadata, .action = update_webhook };
        }
    },
    Response: type = struct {
        webhook: ?Webhook = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .webhook = "webhook",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OAuthProvider,
        ResourceNotFound,
    },
} = .{};

pub const Webhook = struct {
    url: ?[]const u8 = null,
    payload_url: ?[]const u8 = null,
    secret: ?[]const u8 = null,
    branch_filter: ?[]const u8 = null,
    filter_groups: ?[][]WebhookFilter = null,
    build_type: ?[]const u8 = null,
    last_modified_secret: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .url = "url",
            .payload_url = "payloadUrl",
            .secret = "secret",
            .branch_filter = "branchFilter",
            .filter_groups = "filterGroups",
            .build_type = "buildType",
            .last_modified_secret = "lastModifiedSecret",
        };
        return @field(mappings, field_name);
    }
};

pub const WebhookFilter = struct {
    type: []const u8,
    pattern: []const u8,
    exclude_matched_pattern: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .pattern = "pattern",
            .exclude_matched_pattern = "excludeMatchedPattern",
        };
        return @field(mappings, field_name);
    }
};

pub const ReportGroup = struct {
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    type: ?[]const u8 = null,
    export_config: ?ReportExportConfig = null,
    created: ?i64 = null,
    last_modified: ?i64 = null,
    tags: ?[]Tag = null,
    status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "arn",
            .name = "name",
            .type = "type",
            .export_config = "exportConfig",
            .created = "created",
            .last_modified = "lastModified",
            .tags = "tags",
            .status = "status",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "key",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const ReportExportConfig = struct {
    export_config_type: ?[]const u8 = null,
    s3_destination: ?S3ReportExportConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .export_config_type = "exportConfigType",
            .s3_destination = "s3Destination",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ReportExportConfig = struct {
    bucket: ?[]const u8 = null,
    bucket_owner: ?[]const u8 = null,
    path: ?[]const u8 = null,
    packaging: ?[]const u8 = null,
    encryption_key: ?[]const u8 = null,
    encryption_disabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket = "bucket",
            .bucket_owner = "bucketOwner",
            .path = "path",
            .packaging = "packaging",
            .encryption_key = "encryptionKey",
            .encryption_disabled = "encryptionDisabled",
        };
        return @field(mappings, field_name);
    }
};

pub const Project = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    description: ?[]const u8 = null,
    source: ?ProjectSource = null,
    secondary_sources: ?[]ProjectSource = null,
    source_version: ?[]const u8 = null,
    secondary_source_versions: ?[]ProjectSourceVersion = null,
    artifacts: ?ProjectArtifacts = null,
    secondary_artifacts: ?[]ProjectArtifacts = null,
    cache: ?ProjectCache = null,
    environment: ?ProjectEnvironment = null,
    service_role: ?[]const u8 = null,
    timeout_in_minutes: ?i64 = null,
    queued_timeout_in_minutes: ?i64 = null,
    encryption_key: ?[]const u8 = null,
    tags: ?[]Tag = null,
    created: ?i64 = null,
    last_modified: ?i64 = null,
    webhook: ?Webhook = null,
    vpc_config: ?VpcConfig = null,
    badge: ?ProjectBadge = null,
    logs_config: ?LogsConfig = null,
    file_system_locations: ?[]ProjectFileSystemLocation = null,
    build_batch_config: ?ProjectBuildBatchConfig = null,
    concurrent_build_limit: ?i64 = null,
    project_visibility: ?[]const u8 = null,
    public_project_alias: ?[]const u8 = null,
    resource_access_role: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .description = "description",
            .source = "source",
            .secondary_sources = "secondarySources",
            .source_version = "sourceVersion",
            .secondary_source_versions = "secondarySourceVersions",
            .artifacts = "artifacts",
            .secondary_artifacts = "secondaryArtifacts",
            .cache = "cache",
            .environment = "environment",
            .service_role = "serviceRole",
            .timeout_in_minutes = "timeoutInMinutes",
            .queued_timeout_in_minutes = "queuedTimeoutInMinutes",
            .encryption_key = "encryptionKey",
            .tags = "tags",
            .created = "created",
            .last_modified = "lastModified",
            .webhook = "webhook",
            .vpc_config = "vpcConfig",
            .badge = "badge",
            .logs_config = "logsConfig",
            .file_system_locations = "fileSystemLocations",
            .build_batch_config = "buildBatchConfig",
            .concurrent_build_limit = "concurrentBuildLimit",
            .project_visibility = "projectVisibility",
            .public_project_alias = "publicProjectAlias",
            .resource_access_role = "resourceAccessRole",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectBuildBatchConfig = struct {
    service_role: ?[]const u8 = null,
    combine_artifacts: ?bool = null,
    restrictions: ?BatchRestrictions = null,
    timeout_in_mins: ?i64 = null,
    batch_report_mode: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .service_role = "serviceRole",
            .combine_artifacts = "combineArtifacts",
            .restrictions = "restrictions",
            .timeout_in_mins = "timeoutInMins",
            .batch_report_mode = "batchReportMode",
        };
        return @field(mappings, field_name);
    }
};

pub const BatchRestrictions = struct {
    maximum_builds_allowed: ?i64 = null,
    compute_types_allowed: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .maximum_builds_allowed = "maximumBuildsAllowed",
            .compute_types_allowed = "computeTypesAllowed",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectFileSystemLocation = struct {
    type: ?[]const u8 = null,
    location: ?[]const u8 = null,
    mount_point: ?[]const u8 = null,
    identifier: ?[]const u8 = null,
    mount_options: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .location = "location",
            .mount_point = "mountPoint",
            .identifier = "identifier",
            .mount_options = "mountOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const LogsConfig = struct {
    cloud_watch_logs: ?CloudWatchLogsConfig = null,
    s3_logs: ?S3LogsConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .cloud_watch_logs = "cloudWatchLogs",
            .s3_logs = "s3Logs",
        };
        return @field(mappings, field_name);
    }
};

pub const S3LogsConfig = struct {
    status: []const u8,
    location: ?[]const u8 = null,
    encryption_disabled: ?bool = null,
    bucket_owner_access: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status = "status",
            .location = "location",
            .encryption_disabled = "encryptionDisabled",
            .bucket_owner_access = "bucketOwnerAccess",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLogsConfig = struct {
    status: []const u8,
    group_name: ?[]const u8 = null,
    stream_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status = "status",
            .group_name = "groupName",
            .stream_name = "streamName",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectBadge = struct {
    badge_enabled: ?bool = null,
    badge_request_url: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .badge_enabled = "badgeEnabled",
            .badge_request_url = "badgeRequestUrl",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfig = struct {
    vpc_id: ?[]const u8 = null,
    subnets: ?[][]const u8 = null,
    security_group_ids: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .vpc_id = "vpcId",
            .subnets = "subnets",
            .security_group_ids = "securityGroupIds",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectEnvironment = struct {
    type: []const u8,
    image: []const u8,
    compute_type: []const u8,
    fleet: ?ProjectFleet = null,
    environment_variables: ?[]EnvironmentVariable = null,
    privileged_mode: ?bool = null,
    certificate: ?[]const u8 = null,
    registry_credential: ?RegistryCredential = null,
    image_pull_credentials_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .image = "image",
            .compute_type = "computeType",
            .fleet = "fleet",
            .environment_variables = "environmentVariables",
            .privileged_mode = "privilegedMode",
            .certificate = "certificate",
            .registry_credential = "registryCredential",
            .image_pull_credentials_type = "imagePullCredentialsType",
        };
        return @field(mappings, field_name);
    }
};

pub const RegistryCredential = struct {
    credential: []const u8,
    credential_provider: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .credential = "credential",
            .credential_provider = "credentialProvider",
        };
        return @field(mappings, field_name);
    }
};

pub const EnvironmentVariable = struct {
    name: []const u8,
    value: []const u8,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .value = "value",
            .type = "type",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectFleet = struct {
    fleet_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .fleet_arn = "fleetArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectCache = struct {
    type: []const u8,
    location: ?[]const u8 = null,
    modes: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .location = "location",
            .modes = "modes",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectArtifacts = struct {
    type: []const u8,
    location: ?[]const u8 = null,
    path: ?[]const u8 = null,
    namespace_type: ?[]const u8 = null,
    name: ?[]const u8 = null,
    packaging: ?[]const u8 = null,
    override_artifact_name: ?bool = null,
    encryption_disabled: ?bool = null,
    artifact_identifier: ?[]const u8 = null,
    bucket_owner_access: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .location = "location",
            .path = "path",
            .namespace_type = "namespaceType",
            .name = "name",
            .packaging = "packaging",
            .override_artifact_name = "overrideArtifactName",
            .encryption_disabled = "encryptionDisabled",
            .artifact_identifier = "artifactIdentifier",
            .bucket_owner_access = "bucketOwnerAccess",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectSourceVersion = struct {
    source_identifier: []const u8,
    source_version: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .source_identifier = "sourceIdentifier",
            .source_version = "sourceVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const ProjectSource = struct {
    type: []const u8,
    location: ?[]const u8 = null,
    git_clone_depth: ?i64 = null,
    git_submodules_config: ?GitSubmodulesConfig = null,
    buildspec: ?[]const u8 = null,
    auth: ?SourceAuth = null,
    report_build_status: ?bool = null,
    build_status_config: ?BuildStatusConfig = null,
    insecure_ssl: ?bool = null,
    source_identifier: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .location = "location",
            .git_clone_depth = "gitCloneDepth",
            .git_submodules_config = "gitSubmodulesConfig",
            .buildspec = "buildspec",
            .auth = "auth",
            .report_build_status = "reportBuildStatus",
            .build_status_config = "buildStatusConfig",
            .insecure_ssl = "insecureSsl",
            .source_identifier = "sourceIdentifier",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildStatusConfig = struct {
    context: ?[]const u8 = null,
    target_url: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .context = "context",
            .target_url = "targetUrl",
        };
        return @field(mappings, field_name);
    }
};

pub const SourceAuth = struct {
    type: []const u8,
    resource: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .resource = "resource",
        };
        return @field(mappings, field_name);
    }
};

pub const GitSubmodulesConfig = struct {
    fetch_submodules: bool,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .fetch_submodules = "fetchSubmodules",
        };
        return @field(mappings, field_name);
    }
};

pub const Fleet = struct {
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    id: ?[]const u8 = null,
    created: ?i64 = null,
    last_modified: ?i64 = null,
    status: ?FleetStatus = null,
    base_capacity: ?i64 = null,
    environment_type: ?[]const u8 = null,
    compute_type: ?[]const u8 = null,
    scaling_configuration: ?ScalingConfigurationOutput = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "arn",
            .name = "name",
            .id = "id",
            .created = "created",
            .last_modified = "lastModified",
            .status = "status",
            .base_capacity = "baseCapacity",
            .environment_type = "environmentType",
            .compute_type = "computeType",
            .scaling_configuration = "scalingConfiguration",
            .tags = "tags",
        };
        return @field(mappings, field_name);
    }
};

pub const ScalingConfigurationOutput = struct {
    scaling_type: ?[]const u8 = null,
    target_tracking_scaling_configs: ?[]TargetTrackingScalingConfiguration = null,
    max_capacity: ?i64 = null,
    desired_capacity: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .scaling_type = "scalingType",
            .target_tracking_scaling_configs = "targetTrackingScalingConfigs",
            .max_capacity = "maxCapacity",
            .desired_capacity = "desiredCapacity",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetTrackingScalingConfiguration = struct {
    metric_type: ?[]const u8 = null,
    target_value: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_type = "metricType",
            .target_value = "targetValue",
        };
        return @field(mappings, field_name);
    }
};

pub const FleetStatus = struct {
    status_code: ?[]const u8 = null,
    context: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status_code = "statusCode",
            .context = "context",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const ScalingConfigurationInput = struct {
    scaling_type: ?[]const u8 = null,
    target_tracking_scaling_configs: ?[]TargetTrackingScalingConfiguration = null,
    max_capacity: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .scaling_type = "scalingType",
            .target_tracking_scaling_configs = "targetTrackingScalingConfigs",
            .max_capacity = "maxCapacity",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildBatch = struct {
    id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    start_time: ?i64 = null,
    end_time: ?i64 = null,
    current_phase: ?[]const u8 = null,
    build_batch_status: ?[]const u8 = null,
    source_version: ?[]const u8 = null,
    resolved_source_version: ?[]const u8 = null,
    project_name: ?[]const u8 = null,
    phases: ?[]BuildBatchPhase = null,
    source: ?ProjectSource = null,
    secondary_sources: ?[]ProjectSource = null,
    secondary_source_versions: ?[]ProjectSourceVersion = null,
    artifacts: ?BuildArtifacts = null,
    secondary_artifacts: ?[]BuildArtifacts = null,
    cache: ?ProjectCache = null,
    environment: ?ProjectEnvironment = null,
    service_role: ?[]const u8 = null,
    log_config: ?LogsConfig = null,
    build_timeout_in_minutes: ?i64 = null,
    queued_timeout_in_minutes: ?i64 = null,
    complete: ?bool = null,
    initiator: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    encryption_key: ?[]const u8 = null,
    build_batch_number: ?i64 = null,
    file_system_locations: ?[]ProjectFileSystemLocation = null,
    build_batch_config: ?ProjectBuildBatchConfig = null,
    build_groups: ?[]BuildGroup = null,
    debug_session_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .arn = "arn",
            .start_time = "startTime",
            .end_time = "endTime",
            .current_phase = "currentPhase",
            .build_batch_status = "buildBatchStatus",
            .source_version = "sourceVersion",
            .resolved_source_version = "resolvedSourceVersion",
            .project_name = "projectName",
            .phases = "phases",
            .source = "source",
            .secondary_sources = "secondarySources",
            .secondary_source_versions = "secondarySourceVersions",
            .artifacts = "artifacts",
            .secondary_artifacts = "secondaryArtifacts",
            .cache = "cache",
            .environment = "environment",
            .service_role = "serviceRole",
            .log_config = "logConfig",
            .build_timeout_in_minutes = "buildTimeoutInMinutes",
            .queued_timeout_in_minutes = "queuedTimeoutInMinutes",
            .complete = "complete",
            .initiator = "initiator",
            .vpc_config = "vpcConfig",
            .encryption_key = "encryptionKey",
            .build_batch_number = "buildBatchNumber",
            .file_system_locations = "fileSystemLocations",
            .build_batch_config = "buildBatchConfig",
            .build_groups = "buildGroups",
            .debug_session_enabled = "debugSessionEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildGroup = struct {
    identifier: ?[]const u8 = null,
    depends_on: ?[][]const u8 = null,
    ignore_failure: ?bool = null,
    current_build_summary: ?BuildSummary = null,
    prior_build_summary_list: ?[]BuildSummary = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .identifier = "identifier",
            .depends_on = "dependsOn",
            .ignore_failure = "ignoreFailure",
            .current_build_summary = "currentBuildSummary",
            .prior_build_summary_list = "priorBuildSummaryList",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildSummary = struct {
    arn: ?[]const u8 = null,
    requested_on: ?i64 = null,
    build_status: ?[]const u8 = null,
    primary_artifact: ?ResolvedArtifact = null,
    secondary_artifacts: ?[]ResolvedArtifact = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "arn",
            .requested_on = "requestedOn",
            .build_status = "buildStatus",
            .primary_artifact = "primaryArtifact",
            .secondary_artifacts = "secondaryArtifacts",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolvedArtifact = struct {
    type: ?[]const u8 = null,
    location: ?[]const u8 = null,
    identifier: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .location = "location",
            .identifier = "identifier",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildArtifacts = struct {
    location: ?[]const u8 = null,
    sha256sum: ?[]const u8 = null,
    md5sum: ?[]const u8 = null,
    override_artifact_name: ?bool = null,
    encryption_disabled: ?bool = null,
    artifact_identifier: ?[]const u8 = null,
    bucket_owner_access: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .location = "location",
            .sha256sum = "sha256sum",
            .md5sum = "md5sum",
            .override_artifact_name = "overrideArtifactName",
            .encryption_disabled = "encryptionDisabled",
            .artifact_identifier = "artifactIdentifier",
            .bucket_owner_access = "bucketOwnerAccess",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildBatchPhase = struct {
    phase_type: ?[]const u8 = null,
    phase_status: ?[]const u8 = null,
    start_time: ?i64 = null,
    end_time: ?i64 = null,
    duration_in_seconds: ?i64 = null,
    contexts: ?[]PhaseContext = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .phase_type = "phaseType",
            .phase_status = "phaseStatus",
            .start_time = "startTime",
            .end_time = "endTime",
            .duration_in_seconds = "durationInSeconds",
            .contexts = "contexts",
        };
        return @field(mappings, field_name);
    }
};

pub const PhaseContext = struct {
    status_code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status_code = "statusCode",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const Build = struct {
    id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    build_number: ?i64 = null,
    start_time: ?i64 = null,
    end_time: ?i64 = null,
    current_phase: ?[]const u8 = null,
    build_status: ?[]const u8 = null,
    source_version: ?[]const u8 = null,
    resolved_source_version: ?[]const u8 = null,
    project_name: ?[]const u8 = null,
    phases: ?[]BuildPhase = null,
    source: ?ProjectSource = null,
    secondary_sources: ?[]ProjectSource = null,
    secondary_source_versions: ?[]ProjectSourceVersion = null,
    artifacts: ?BuildArtifacts = null,
    secondary_artifacts: ?[]BuildArtifacts = null,
    cache: ?ProjectCache = null,
    environment: ?ProjectEnvironment = null,
    service_role: ?[]const u8 = null,
    logs: ?LogsLocation = null,
    timeout_in_minutes: ?i64 = null,
    queued_timeout_in_minutes: ?i64 = null,
    build_complete: ?bool = null,
    initiator: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    network_interface: ?NetworkInterface = null,
    encryption_key: ?[]const u8 = null,
    exported_environment_variables: ?[]ExportedEnvironmentVariable = null,
    report_arns: ?[][]const u8 = null,
    file_system_locations: ?[]ProjectFileSystemLocation = null,
    debug_session: ?DebugSession = null,
    build_batch_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .arn = "arn",
            .build_number = "buildNumber",
            .start_time = "startTime",
            .end_time = "endTime",
            .current_phase = "currentPhase",
            .build_status = "buildStatus",
            .source_version = "sourceVersion",
            .resolved_source_version = "resolvedSourceVersion",
            .project_name = "projectName",
            .phases = "phases",
            .source = "source",
            .secondary_sources = "secondarySources",
            .secondary_source_versions = "secondarySourceVersions",
            .artifacts = "artifacts",
            .secondary_artifacts = "secondaryArtifacts",
            .cache = "cache",
            .environment = "environment",
            .service_role = "serviceRole",
            .logs = "logs",
            .timeout_in_minutes = "timeoutInMinutes",
            .queued_timeout_in_minutes = "queuedTimeoutInMinutes",
            .build_complete = "buildComplete",
            .initiator = "initiator",
            .vpc_config = "vpcConfig",
            .network_interface = "networkInterface",
            .encryption_key = "encryptionKey",
            .exported_environment_variables = "exportedEnvironmentVariables",
            .report_arns = "reportArns",
            .file_system_locations = "fileSystemLocations",
            .debug_session = "debugSession",
            .build_batch_arn = "buildBatchArn",
        };
        return @field(mappings, field_name);
    }
};

pub const DebugSession = struct {
    session_enabled: ?bool = null,
    session_target: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .session_enabled = "sessionEnabled",
            .session_target = "sessionTarget",
        };
        return @field(mappings, field_name);
    }
};

pub const ExportedEnvironmentVariable = struct {
    name: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkInterface = struct {
    subnet_id: ?[]const u8 = null,
    network_interface_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .subnet_id = "subnetId",
            .network_interface_id = "networkInterfaceId",
        };
        return @field(mappings, field_name);
    }
};

pub const LogsLocation = struct {
    group_name: ?[]const u8 = null,
    stream_name: ?[]const u8 = null,
    deep_link: ?[]const u8 = null,
    s3_deep_link: ?[]const u8 = null,
    cloud_watch_logs_arn: ?[]const u8 = null,
    s3_logs_arn: ?[]const u8 = null,
    cloud_watch_logs: ?CloudWatchLogsConfig = null,
    s3_logs: ?S3LogsConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .group_name = "groupName",
            .stream_name = "streamName",
            .deep_link = "deepLink",
            .s3_deep_link = "s3DeepLink",
            .cloud_watch_logs_arn = "cloudWatchLogsArn",
            .s3_logs_arn = "s3LogsArn",
            .cloud_watch_logs = "cloudWatchLogs",
            .s3_logs = "s3Logs",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildPhase = struct {
    phase_type: ?[]const u8 = null,
    phase_status: ?[]const u8 = null,
    start_time: ?i64 = null,
    end_time: ?i64 = null,
    duration_in_seconds: ?i64 = null,
    contexts: ?[]PhaseContext = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .phase_type = "phaseType",
            .phase_status = "phaseStatus",
            .start_time = "startTime",
            .end_time = "endTime",
            .duration_in_seconds = "durationInSeconds",
            .contexts = "contexts",
        };
        return @field(mappings, field_name);
    }
};

pub const ReportFilter = struct {
    status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status = "status",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildBatchFilter = struct {
    status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status = "status",
        };
        return @field(mappings, field_name);
    }
};

pub const BuildNotDeleted = struct {
    id: ?[]const u8 = null,
    status_code: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .status_code = "statusCode",
        };
        return @field(mappings, field_name);
    }
};
