const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2014-10-06";
pub const sdk_id: []const u8 = "CodeDeploy";
pub const arn_namespace: ?[]const u8 = "codedeploy";
pub const endpoint_prefix: []const u8 = "codedeploy";
pub const sigv4_name: []const u8 = "codedeploy";
pub const name: []const u8 = "CodeDeploy_20141006";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2014-10-06",
    sdk_id: []const u8 = "CodeDeploy",
    arn_namespace: ?[]const u8 = "codedeploy",
    endpoint_prefix: []const u8 = "codedeploy",
    sigv4_name: []const u8 = "codedeploy",
    name: []const u8 = "CodeDeploy_20141006",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const add_tags_to_on_premises_instances: struct {
    action_name: []const u8 = "AddTagsToOnPremisesInstances",
    Request: type = struct {
        tags: []Tag,
        instance_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
                .instance_names = "instanceNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_tags_to_on_premises_instances) } {
            return .{ .service_metadata = service_metadata, .action = add_tags_to_on_premises_instances };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InstanceLimitExceeded,
        InstanceNameRequired,
        InstanceNotRegistered,
        InvalidInstanceName,
        InvalidTag,
        TagLimitExceeded,
        TagRequired,
    },
} = .{};
pub const batch_get_application_revisions: struct {
    action_name: []const u8 = "BatchGetApplicationRevisions",
    Request: type = struct {
        application_name: []const u8,
        revisions: []RevisionLocation,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .revisions = "revisions",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_application_revisions) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_application_revisions };
        }
    },
    Response: type = struct {
        application_name: ?[]const u8 = null,
        error_message: ?[]const u8 = null,
        revisions: ?[]struct {
            revision_location: ?RevisionLocation = null,
            generic_revision_info: ?GenericRevisionInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .revision_location = "revisionLocation",
                    .generic_revision_info = "genericRevisionInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .error_message = "errorMessage",
                .revisions = "revisions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        BatchLimitExceeded,
        InvalidApplicationName,
        InvalidRevision,
        RevisionRequired,
    },
} = .{};
pub const batch_get_applications: struct {
    action_name: []const u8 = "BatchGetApplications",
    Request: type = struct {
        application_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_names = "applicationNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_applications) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_applications };
        }
    },
    Response: type = struct {
        applications_info: ?[]ApplicationInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .applications_info = "applicationsInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        BatchLimitExceeded,
        InvalidApplicationName,
    },
} = .{};
pub const batch_get_deployment_groups: struct {
    action_name: []const u8 = "BatchGetDeploymentGroups",
    Request: type = struct {
        application_name: []const u8,
        deployment_group_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_names = "deploymentGroupNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_deployment_groups) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_deployment_groups };
        }
    },
    Response: type = struct {
        deployment_groups_info: ?[]DeploymentGroupInfo = null,
        error_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_groups_info = "deploymentGroupsInfo",
                .error_message = "errorMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        BatchLimitExceeded,
        DeploymentConfigDoesNotExist,
        DeploymentGroupNameRequired,
        InvalidApplicationName,
        InvalidDeploymentGroupName,
    },
} = .{};
pub const batch_get_deployment_instances: struct {
    action_name: []const u8 = "BatchGetDeploymentInstances",
    Request: type = struct {
        deployment_id: []const u8,
        instance_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .instance_ids = "instanceIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_deployment_instances) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_deployment_instances };
        }
    },
    Response: type = struct {
        instances_summary: ?[]InstanceSummary = null,
        error_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instances_summary = "instancesSummary",
                .error_message = "errorMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchLimitExceeded,
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        InstanceIdRequired,
        InvalidComputePlatform,
        InvalidDeploymentId,
        InvalidInstanceName,
    },
} = .{};
pub const batch_get_deployments: struct {
    action_name: []const u8 = "BatchGetDeployments",
    Request: type = struct {
        deployment_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_ids = "deploymentIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_deployments) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_deployments };
        }
    },
    Response: type = struct {
        deployments_info: ?[]DeploymentInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployments_info = "deploymentsInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchLimitExceeded,
        DeploymentIdRequired,
        InvalidDeploymentId,
    },
} = .{};
pub const batch_get_deployment_targets: struct {
    action_name: []const u8 = "BatchGetDeploymentTargets",
    Request: type = struct {
        deployment_id: []const u8,
        target_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .target_ids = "targetIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_deployment_targets) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_deployment_targets };
        }
    },
    Response: type = struct {
        deployment_targets: ?[]DeploymentTarget = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_targets = "deploymentTargets",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentNotStarted,
        DeploymentTargetDoesNotExist,
        DeploymentTargetIdRequired,
        DeploymentTargetListSizeExceeded,
        InstanceDoesNotExist,
        InvalidDeploymentId,
        InvalidDeploymentTargetId,
    },
} = .{};
pub const batch_get_on_premises_instances: struct {
    action_name: []const u8 = "BatchGetOnPremisesInstances",
    Request: type = struct {
        instance_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_names = "instanceNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_on_premises_instances) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_on_premises_instances };
        }
    },
    Response: type = struct {
        instance_infos: ?[]InstanceInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_infos = "instanceInfos",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchLimitExceeded,
        InstanceNameRequired,
        InvalidInstanceName,
    },
} = .{};
pub const continue_deployment: struct {
    action_name: []const u8 = "ContinueDeployment",
    Request: type = struct {
        deployment_id: ?[]const u8 = null,
        deployment_wait_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .deployment_wait_type = "deploymentWaitType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(continue_deployment) } {
            return .{ .service_metadata = service_metadata, .action = continue_deployment };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeploymentAlreadyCompleted,
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentIsNotInReadyState,
        InvalidDeploymentId,
        InvalidDeploymentStatus,
        InvalidDeploymentWaitType,
        UnsupportedActionForDeploymentType,
    },
} = .{};
pub const create_application: struct {
    action_name: []const u8 = "CreateApplication",
    Request: type = struct {
        application_name: []const u8,
        compute_platform: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .compute_platform = "computePlatform",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application) } {
            return .{ .service_metadata = service_metadata, .action = create_application };
        }
    },
    Response: type = struct {
        application_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_id = "applicationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationAlreadyExists,
        ApplicationLimitExceeded,
        ApplicationNameRequired,
        InvalidApplicationName,
        InvalidComputePlatform,
        InvalidTagsToAdd,
    },
} = .{};
pub const create_deployment: struct {
    action_name: []const u8 = "CreateDeployment",
    Request: type = struct {
        application_name: []const u8,
        deployment_group_name: ?[]const u8 = null,
        revision: ?RevisionLocation = null,
        deployment_config_name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        ignore_application_stop_failures: ?bool = null,
        target_instances: ?TargetInstances = null,
        auto_rollback_configuration: ?AutoRollbackConfiguration = null,
        update_outdated_instances_only: ?bool = null,
        file_exists_behavior: ?[]const u8 = null,
        override_alarm_configuration: ?AlarmConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_name = "deploymentGroupName",
                .revision = "revision",
                .deployment_config_name = "deploymentConfigName",
                .description = "description",
                .ignore_application_stop_failures = "ignoreApplicationStopFailures",
                .target_instances = "targetInstances",
                .auto_rollback_configuration = "autoRollbackConfiguration",
                .update_outdated_instances_only = "updateOutdatedInstancesOnly",
                .file_exists_behavior = "fileExistsBehavior",
                .override_alarm_configuration = "overrideAlarmConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_deployment) } {
            return .{ .service_metadata = service_metadata, .action = create_deployment };
        }
    },
    Response: type = struct {
        deployment_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlarmsLimitExceeded,
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DeploymentConfigDoesNotExist,
        DeploymentGroupDoesNotExist,
        DeploymentGroupNameRequired,
        DeploymentLimitExceeded,
        DescriptionTooLong,
        InvalidAlarmConfig,
        InvalidApplicationName,
        InvalidAutoRollbackConfig,
        InvalidAutoScalingGroup,
        InvalidDeploymentConfigName,
        InvalidDeploymentGroupName,
        InvalidFileExistsBehavior,
        InvalidGitHubAccountToken,
        InvalidIgnoreApplicationStopFailuresValue,
        InvalidLoadBalancerInfo,
        InvalidRevision,
        InvalidRole,
        InvalidTargetInstances,
        InvalidTrafficRoutingConfiguration,
        InvalidUpdateOutdatedInstancesOnlyValue,
        RevisionDoesNotExist,
        RevisionRequired,
        Throttling,
    },
} = .{};
pub const create_deployment_config: struct {
    action_name: []const u8 = "CreateDeploymentConfig",
    Request: type = struct {
        deployment_config_name: []const u8,
        minimum_healthy_hosts: ?MinimumHealthyHosts = null,
        traffic_routing_config: ?TrafficRoutingConfig = null,
        compute_platform: ?[]const u8 = null,
        zonal_config: ?ZonalConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_config_name = "deploymentConfigName",
                .minimum_healthy_hosts = "minimumHealthyHosts",
                .traffic_routing_config = "trafficRoutingConfig",
                .compute_platform = "computePlatform",
                .zonal_config = "zonalConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_deployment_config) } {
            return .{ .service_metadata = service_metadata, .action = create_deployment_config };
        }
    },
    Response: type = struct {
        deployment_config_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_config_id = "deploymentConfigId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentConfigAlreadyExists,
        DeploymentConfigLimitExceeded,
        DeploymentConfigNameRequired,
        InvalidComputePlatform,
        InvalidDeploymentConfigName,
        InvalidMinimumHealthyHostValue,
        InvalidTrafficRoutingConfiguration,
        InvalidZonalDeploymentConfiguration,
    },
} = .{};
pub const create_deployment_group: struct {
    action_name: []const u8 = "CreateDeploymentGroup",
    Request: type = struct {
        application_name: []const u8,
        deployment_group_name: []const u8,
        deployment_config_name: ?[]const u8 = null,
        ec2_tag_filters: ?[]EC2TagFilter = null,
        on_premises_instance_tag_filters: ?[]TagFilter = null,
        auto_scaling_groups: ?[][]const u8 = null,
        service_role_arn: []const u8,
        trigger_configurations: ?[]TriggerConfig = null,
        alarm_configuration: ?AlarmConfiguration = null,
        auto_rollback_configuration: ?AutoRollbackConfiguration = null,
        outdated_instances_strategy: ?[]const u8 = null,
        deployment_style: ?DeploymentStyle = null,
        blue_green_deployment_configuration: ?BlueGreenDeploymentConfiguration = null,
        load_balancer_info: ?LoadBalancerInfo = null,
        ec2_tag_set: ?EC2TagSet = null,
        ecs_services: ?[]ECSService = null,
        on_premises_tag_set: ?OnPremisesTagSet = null,
        tags: ?[]Tag = null,
        termination_hook_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_name = "deploymentGroupName",
                .deployment_config_name = "deploymentConfigName",
                .ec2_tag_filters = "ec2TagFilters",
                .on_premises_instance_tag_filters = "onPremisesInstanceTagFilters",
                .auto_scaling_groups = "autoScalingGroups",
                .service_role_arn = "serviceRoleArn",
                .trigger_configurations = "triggerConfigurations",
                .alarm_configuration = "alarmConfiguration",
                .auto_rollback_configuration = "autoRollbackConfiguration",
                .outdated_instances_strategy = "outdatedInstancesStrategy",
                .deployment_style = "deploymentStyle",
                .blue_green_deployment_configuration = "blueGreenDeploymentConfiguration",
                .load_balancer_info = "loadBalancerInfo",
                .ec2_tag_set = "ec2TagSet",
                .ecs_services = "ecsServices",
                .on_premises_tag_set = "onPremisesTagSet",
                .tags = "tags",
                .termination_hook_enabled = "terminationHookEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_deployment_group) } {
            return .{ .service_metadata = service_metadata, .action = create_deployment_group };
        }
    },
    Response: type = struct {
        deployment_group_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_group_id = "deploymentGroupId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlarmsLimitExceeded,
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DeploymentConfigDoesNotExist,
        DeploymentGroupAlreadyExists,
        DeploymentGroupLimitExceeded,
        DeploymentGroupNameRequired,
        ECSServiceMappingLimitExceeded,
        InvalidAlarmConfig,
        InvalidApplicationName,
        InvalidAutoRollbackConfig,
        InvalidAutoScalingGroup,
        InvalidBlueGreenDeploymentConfiguration,
        InvalidDeploymentConfigName,
        InvalidDeploymentGroupName,
        InvalidDeploymentStyle,
        InvalidEC2TagCombination,
        InvalidEC2Tag,
        InvalidECSService,
        InvalidInput,
        InvalidLoadBalancerInfo,
        InvalidOnPremisesTagCombination,
        InvalidRole,
        InvalidTag,
        InvalidTagsToAdd,
        InvalidTargetGroupPair,
        InvalidTrafficRoutingConfiguration,
        InvalidTriggerConfig,
        LifecycleHookLimitExceeded,
        RoleRequired,
        TagSetListLimitExceeded,
        Throttling,
        TriggerTargetsLimitExceeded,
    },
} = .{};
pub const delete_application: struct {
    action_name: []const u8 = "DeleteApplication",
    Request: type = struct {
        application_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application) } {
            return .{ .service_metadata = service_metadata, .action = delete_application };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ApplicationNameRequired,
        InvalidApplicationName,
        InvalidRole,
    },
} = .{};
pub const delete_deployment_config: struct {
    action_name: []const u8 = "DeleteDeploymentConfig",
    Request: type = struct {
        deployment_config_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_config_name = "deploymentConfigName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_deployment_config) } {
            return .{ .service_metadata = service_metadata, .action = delete_deployment_config };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeploymentConfigInUse,
        DeploymentConfigNameRequired,
        InvalidDeploymentConfigName,
        InvalidOperation,
    },
} = .{};
pub const delete_deployment_group: struct {
    action_name: []const u8 = "DeleteDeploymentGroup",
    Request: type = struct {
        application_name: []const u8,
        deployment_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_name = "deploymentGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_deployment_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_deployment_group };
        }
    },
    Response: type = struct {
        hooks_not_cleaned_up: ?[]AutoScalingGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hooks_not_cleaned_up = "hooksNotCleanedUp",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationNameRequired,
        DeploymentGroupNameRequired,
        InvalidApplicationName,
        InvalidDeploymentGroupName,
        InvalidRole,
    },
} = .{};
pub const delete_git_hub_account_token: struct {
    action_name: []const u8 = "DeleteGitHubAccountToken",
    Request: type = struct {
        token_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .token_name = "tokenName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_git_hub_account_token) } {
            return .{ .service_metadata = service_metadata, .action = delete_git_hub_account_token };
        }
    },
    Response: type = struct {
        token_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .token_name = "tokenName",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        GitHubAccountTokenDoesNotExist,
        GitHubAccountTokenNameRequired,
        InvalidGitHubAccountTokenName,
        OperationNotSupported,
        ResourceValidation,
    },
} = .{};
pub const delete_resources_by_external_id: struct {
    action_name: []const u8 = "DeleteResourcesByExternalId",
    Request: type = struct {
        external_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .external_id = "externalId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resources_by_external_id) } {
            return .{ .service_metadata = service_metadata, .action = delete_resources_by_external_id };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const deregister_on_premises_instance: struct {
    action_name: []const u8 = "DeregisterOnPremisesInstance",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_on_premises_instance) } {
            return .{ .service_metadata = service_metadata, .action = deregister_on_premises_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InstanceNameRequired,
        InvalidInstanceName,
    },
} = .{};
pub const get_application: struct {
    action_name: []const u8 = "GetApplication",
    Request: type = struct {
        application_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_application) } {
            return .{ .service_metadata = service_metadata, .action = get_application };
        }
    },
    Response: type = struct {
        application: ?ApplicationInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application = "application",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        InvalidApplicationName,
    },
} = .{};
pub const get_application_revision: struct {
    action_name: []const u8 = "GetApplicationRevision",
    Request: type = struct {
        application_name: []const u8,
        revision: RevisionLocation,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .revision = "revision",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_application_revision) } {
            return .{ .service_metadata = service_metadata, .action = get_application_revision };
        }
    },
    Response: type = struct {
        application_name: ?[]const u8 = null,
        revision: ?RevisionLocation = null,
        revision_info: ?GenericRevisionInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .revision = "revision",
                .revision_info = "revisionInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        InvalidApplicationName,
        InvalidRevision,
        RevisionDoesNotExist,
        RevisionRequired,
    },
} = .{};
pub const get_deployment: struct {
    action_name: []const u8 = "GetDeployment",
    Request: type = struct {
        deployment_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_deployment) } {
            return .{ .service_metadata = service_metadata, .action = get_deployment };
        }
    },
    Response: type = struct {
        deployment_info: ?DeploymentInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_info = "deploymentInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        InvalidDeploymentId,
    },
} = .{};
pub const get_deployment_config: struct {
    action_name: []const u8 = "GetDeploymentConfig",
    Request: type = struct {
        deployment_config_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_config_name = "deploymentConfigName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_deployment_config) } {
            return .{ .service_metadata = service_metadata, .action = get_deployment_config };
        }
    },
    Response: type = struct {
        deployment_config_info: ?struct {
            deployment_config_id: ?[]const u8 = null,
            deployment_config_name: ?[]const u8 = null,
            minimum_healthy_hosts: ?MinimumHealthyHosts = null,
            create_time: ?i64 = null,
            compute_platform: ?[]const u8 = null,
            traffic_routing_config: ?TrafficRoutingConfig = null,
            zonal_config: ?ZonalConfig = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .deployment_config_id = "deploymentConfigId",
                    .deployment_config_name = "deploymentConfigName",
                    .minimum_healthy_hosts = "minimumHealthyHosts",
                    .create_time = "createTime",
                    .compute_platform = "computePlatform",
                    .traffic_routing_config = "trafficRoutingConfig",
                    .zonal_config = "zonalConfig",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_config_info = "deploymentConfigInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentConfigDoesNotExist,
        DeploymentConfigNameRequired,
        InvalidComputePlatform,
        InvalidDeploymentConfigName,
    },
} = .{};
pub const get_deployment_group: struct {
    action_name: []const u8 = "GetDeploymentGroup",
    Request: type = struct {
        application_name: []const u8,
        deployment_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_name = "deploymentGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_deployment_group) } {
            return .{ .service_metadata = service_metadata, .action = get_deployment_group };
        }
    },
    Response: type = struct {
        deployment_group_info: ?DeploymentGroupInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_group_info = "deploymentGroupInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DeploymentConfigDoesNotExist,
        DeploymentGroupDoesNotExist,
        DeploymentGroupNameRequired,
        InvalidApplicationName,
        InvalidDeploymentGroupName,
    },
} = .{};
pub const get_deployment_instance: struct {
    action_name: []const u8 = "GetDeploymentInstance",
    Request: type = struct {
        deployment_id: []const u8,
        instance_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .instance_id = "instanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_deployment_instance) } {
            return .{ .service_metadata = service_metadata, .action = get_deployment_instance };
        }
    },
    Response: type = struct {
        instance_summary: ?InstanceSummary = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_summary = "instanceSummary",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        InstanceDoesNotExist,
        InstanceIdRequired,
        InvalidComputePlatform,
        InvalidDeploymentId,
        InvalidInstanceName,
    },
} = .{};
pub const get_deployment_target: struct {
    action_name: []const u8 = "GetDeploymentTarget",
    Request: type = struct {
        deployment_id: []const u8,
        target_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .target_id = "targetId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_deployment_target) } {
            return .{ .service_metadata = service_metadata, .action = get_deployment_target };
        }
    },
    Response: type = struct {
        deployment_target: ?DeploymentTarget = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_target = "deploymentTarget",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentNotStarted,
        DeploymentTargetDoesNotExist,
        DeploymentTargetIdRequired,
        InvalidDeploymentId,
        InvalidDeploymentTargetId,
        InvalidInstanceName,
    },
} = .{};
pub const get_on_premises_instance: struct {
    action_name: []const u8 = "GetOnPremisesInstance",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_on_premises_instance) } {
            return .{ .service_metadata = service_metadata, .action = get_on_premises_instance };
        }
    },
    Response: type = struct {
        instance_info: ?InstanceInfo = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_info = "instanceInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InstanceNameRequired,
        InstanceNotRegistered,
        InvalidInstanceName,
    },
} = .{};
pub const list_application_revisions: struct {
    action_name: []const u8 = "ListApplicationRevisions",
    Request: type = struct {
        application_name: []const u8,
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,
        s3_bucket: ?[]const u8 = null,
        s3_key_prefix: ?[]const u8 = null,
        deployed: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .sort_by = "sortBy",
                .sort_order = "sortOrder",
                .s3_bucket = "s3Bucket",
                .s3_key_prefix = "s3KeyPrefix",
                .deployed = "deployed",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_application_revisions) } {
            return .{ .service_metadata = service_metadata, .action = list_application_revisions };
        }
    },
    Response: type = struct {
        revisions: ?[]RevisionLocation = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .revisions = "revisions",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        BucketNameFilterRequired,
        InvalidApplicationName,
        InvalidBucketNameFilter,
        InvalidDeployedStateFilter,
        InvalidKeyPrefixFilter,
        InvalidNextToken,
        InvalidSortBy,
        InvalidSortOrder,
    },
} = .{};
pub const list_applications: struct {
    action_name: []const u8 = "ListApplications",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_applications) } {
            return .{ .service_metadata = service_metadata, .action = list_applications };
        }
    },
    Response: type = struct {
        applications: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .applications = "applications",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const list_deployment_configs: struct {
    action_name: []const u8 = "ListDeploymentConfigs",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_deployment_configs) } {
            return .{ .service_metadata = service_metadata, .action = list_deployment_configs };
        }
    },
    Response: type = struct {
        deployment_configs_list: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_configs_list = "deploymentConfigsList",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
    },
} = .{};
pub const list_deployment_groups: struct {
    action_name: []const u8 = "ListDeploymentGroups",
    Request: type = struct {
        application_name: []const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_deployment_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_deployment_groups };
        }
    },
    Response: type = struct {
        application_name: ?[]const u8 = null,
        deployment_groups: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_groups = "deploymentGroups",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        InvalidApplicationName,
        InvalidNextToken,
    },
} = .{};
pub const list_deployment_instances: struct {
    action_name: []const u8 = "ListDeploymentInstances",
    Request: type = struct {
        deployment_id: []const u8,
        next_token: ?[]const u8 = null,
        instance_status_filter: ?[][]const u8 = null,
        instance_type_filter: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .next_token = "nextToken",
                .instance_status_filter = "instanceStatusFilter",
                .instance_type_filter = "instanceTypeFilter",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_deployment_instances) } {
            return .{ .service_metadata = service_metadata, .action = list_deployment_instances };
        }
    },
    Response: type = struct {
        instances_list: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instances_list = "instancesList",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentNotStarted,
        InvalidComputePlatform,
        InvalidDeploymentId,
        InvalidDeploymentInstanceType,
        InvalidInstanceStatus,
        InvalidInstanceType,
        InvalidNextToken,
        InvalidTargetFilterName,
    },
} = .{};
pub const list_deployments: struct {
    action_name: []const u8 = "ListDeployments",
    Request: type = struct {
        application_name: ?[]const u8 = null,
        deployment_group_name: ?[]const u8 = null,
        external_id: ?[]const u8 = null,
        include_only_statuses: ?[][]const u8 = null,
        create_time_range: ?struct {
            start: ?i64 = null,
            end: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .start = "start",
                    .end = "end",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .deployment_group_name = "deploymentGroupName",
                .external_id = "externalId",
                .include_only_statuses = "includeOnlyStatuses",
                .create_time_range = "createTimeRange",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_deployments) } {
            return .{ .service_metadata = service_metadata, .action = list_deployments };
        }
    },
    Response: type = struct {
        deployments: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployments = "deployments",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DeploymentGroupDoesNotExist,
        DeploymentGroupNameRequired,
        InvalidApplicationName,
        InvalidDeploymentGroupName,
        InvalidDeploymentStatus,
        InvalidExternalId,
        InvalidInput,
        InvalidNextToken,
        InvalidTimeRange,
    },
} = .{};
pub const list_deployment_targets: struct {
    action_name: []const u8 = "ListDeploymentTargets",
    Request: type = struct {
        deployment_id: []const u8,
        next_token: ?[]const u8 = null,
        target_filters: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[][]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .next_token = "nextToken",
                .target_filters = "targetFilters",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "target_filters", field_name))
                return try serializeMap(self.target_filters, self.fieldNameFor("target_filters"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_deployment_targets) } {
            return .{ .service_metadata = service_metadata, .action = list_deployment_targets };
        }
    },
    Response: type = struct {
        target_ids: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .target_ids = "targetIds",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentNotStarted,
        InvalidDeploymentId,
        InvalidDeploymentInstanceType,
        InvalidInstanceStatus,
        InvalidInstanceType,
        InvalidNextToken,
        InvalidTargetFilterName,
    },
} = .{};
pub const list_git_hub_account_token_names: struct {
    action_name: []const u8 = "ListGitHubAccountTokenNames",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_git_hub_account_token_names) } {
            return .{ .service_metadata = service_metadata, .action = list_git_hub_account_token_names };
        }
    },
    Response: type = struct {
        token_name_list: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .token_name_list = "tokenNameList",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        OperationNotSupported,
        ResourceValidation,
    },
} = .{};
pub const list_on_premises_instances: struct {
    action_name: []const u8 = "ListOnPremisesInstances",
    Request: type = struct {
        registration_status: ?[]const u8 = null,
        tag_filters: ?[]TagFilter = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .registration_status = "registrationStatus",
                .tag_filters = "tagFilters",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_on_premises_instances) } {
            return .{ .service_metadata = service_metadata, .action = list_on_premises_instances };
        }
    },
    Response: type = struct {
        instance_names: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_names = "instanceNames",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidNextToken,
        InvalidRegistrationStatus,
        InvalidTagFilter,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ArnNotSupported,
        InvalidArn,
        ResourceArnRequired,
    },
} = .{};
pub const put_lifecycle_event_hook_execution_status: struct {
    action_name: []const u8 = "PutLifecycleEventHookExecutionStatus",
    Request: type = struct {
        deployment_id: ?[]const u8 = null,
        lifecycle_event_hook_execution_id: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .lifecycle_event_hook_execution_id = "lifecycleEventHookExecutionId",
                .status = "status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_lifecycle_event_hook_execution_status) } {
            return .{ .service_metadata = service_metadata, .action = put_lifecycle_event_hook_execution_status };
        }
    },
    Response: type = struct {
        lifecycle_event_hook_execution_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_event_hook_execution_id = "lifecycleEventHookExecutionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        InvalidDeploymentId,
        InvalidLifecycleEventHookExecutionId,
        InvalidLifecycleEventHookExecutionStatus,
        LifecycleEventAlreadyCompleted,
        UnsupportedActionForDeploymentType,
    },
} = .{};
pub const register_application_revision: struct {
    action_name: []const u8 = "RegisterApplicationRevision",
    Request: type = struct {
        application_name: []const u8,
        description: ?[]const u8 = null,
        revision: RevisionLocation,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .description = "description",
                .revision = "revision",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_application_revision) } {
            return .{ .service_metadata = service_metadata, .action = register_application_revision };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DescriptionTooLong,
        InvalidApplicationName,
        InvalidRevision,
        RevisionRequired,
    },
} = .{};
pub const register_on_premises_instance: struct {
    action_name: []const u8 = "RegisterOnPremisesInstance",
    Request: type = struct {
        instance_name: []const u8,
        iam_session_arn: ?[]const u8 = null,
        iam_user_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .iam_session_arn = "iamSessionArn",
                .iam_user_arn = "iamUserArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_on_premises_instance) } {
            return .{ .service_metadata = service_metadata, .action = register_on_premises_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        IamArnRequired,
        IamSessionArnAlreadyRegistered,
        IamUserArnAlreadyRegistered,
        IamUserArnRequired,
        InstanceNameAlreadyRegistered,
        InstanceNameRequired,
        InvalidIamSessionArn,
        InvalidIamUserArn,
        InvalidInstanceName,
        MultipleIamArnsProvided,
    },
} = .{};
pub const remove_tags_from_on_premises_instances: struct {
    action_name: []const u8 = "RemoveTagsFromOnPremisesInstances",
    Request: type = struct {
        tags: []Tag,
        instance_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
                .instance_names = "instanceNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(remove_tags_from_on_premises_instances) } {
            return .{ .service_metadata = service_metadata, .action = remove_tags_from_on_premises_instances };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InstanceLimitExceeded,
        InstanceNameRequired,
        InstanceNotRegistered,
        InvalidInstanceName,
        InvalidTag,
        TagLimitExceeded,
        TagRequired,
    },
} = .{};
pub const skip_wait_time_for_instance_termination: struct {
    action_name: []const u8 = "SkipWaitTimeForInstanceTermination",
    Request: type = struct {
        deployment_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(skip_wait_time_for_instance_termination) } {
            return .{ .service_metadata = service_metadata, .action = skip_wait_time_for_instance_termination };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeploymentAlreadyCompleted,
        DeploymentDoesNotExist,
        DeploymentIdRequired,
        DeploymentNotStarted,
        InvalidDeploymentId,
        UnsupportedActionForDeploymentType,
    },
} = .{};
pub const stop_deployment: struct {
    action_name: []const u8 = "StopDeployment",
    Request: type = struct {
        deployment_id: []const u8,
        auto_rollback_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "deploymentId",
                .auto_rollback_enabled = "autoRollbackEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_deployment) } {
            return .{ .service_metadata = service_metadata, .action = stop_deployment };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,
        status_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "status",
                .status_message = "statusMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DeploymentAlreadyCompleted,
        DeploymentDoesNotExist,
        DeploymentGroupDoesNotExist,
        DeploymentIdRequired,
        InvalidDeploymentId,
        UnsupportedActionForDeploymentType,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ArnNotSupported,
        DeploymentConfigDoesNotExist,
        DeploymentGroupDoesNotExist,
        InvalidArn,
        InvalidTagsToAdd,
        ResourceArnRequired,
        TagRequired,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ApplicationDoesNotExist,
        ArnNotSupported,
        DeploymentConfigDoesNotExist,
        DeploymentGroupDoesNotExist,
        InvalidArn,
        InvalidTagsToAdd,
        ResourceArnRequired,
        TagRequired,
    },
} = .{};
pub const update_application: struct {
    action_name: []const u8 = "UpdateApplication",
    Request: type = struct {
        application_name: ?[]const u8 = null,
        new_application_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .new_application_name = "newApplicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application) } {
            return .{ .service_metadata = service_metadata, .action = update_application };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ApplicationAlreadyExists,
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        InvalidApplicationName,
    },
} = .{};
pub const update_deployment_group: struct {
    action_name: []const u8 = "UpdateDeploymentGroup",
    Request: type = struct {
        application_name: []const u8,
        current_deployment_group_name: []const u8,
        new_deployment_group_name: ?[]const u8 = null,
        deployment_config_name: ?[]const u8 = null,
        ec2_tag_filters: ?[]EC2TagFilter = null,
        on_premises_instance_tag_filters: ?[]TagFilter = null,
        auto_scaling_groups: ?[][]const u8 = null,
        service_role_arn: ?[]const u8 = null,
        trigger_configurations: ?[]TriggerConfig = null,
        alarm_configuration: ?AlarmConfiguration = null,
        auto_rollback_configuration: ?AutoRollbackConfiguration = null,
        outdated_instances_strategy: ?[]const u8 = null,
        deployment_style: ?DeploymentStyle = null,
        blue_green_deployment_configuration: ?BlueGreenDeploymentConfiguration = null,
        load_balancer_info: ?LoadBalancerInfo = null,
        ec2_tag_set: ?EC2TagSet = null,
        ecs_services: ?[]ECSService = null,
        on_premises_tag_set: ?OnPremisesTagSet = null,
        termination_hook_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "applicationName",
                .current_deployment_group_name = "currentDeploymentGroupName",
                .new_deployment_group_name = "newDeploymentGroupName",
                .deployment_config_name = "deploymentConfigName",
                .ec2_tag_filters = "ec2TagFilters",
                .on_premises_instance_tag_filters = "onPremisesInstanceTagFilters",
                .auto_scaling_groups = "autoScalingGroups",
                .service_role_arn = "serviceRoleArn",
                .trigger_configurations = "triggerConfigurations",
                .alarm_configuration = "alarmConfiguration",
                .auto_rollback_configuration = "autoRollbackConfiguration",
                .outdated_instances_strategy = "outdatedInstancesStrategy",
                .deployment_style = "deploymentStyle",
                .blue_green_deployment_configuration = "blueGreenDeploymentConfiguration",
                .load_balancer_info = "loadBalancerInfo",
                .ec2_tag_set = "ec2TagSet",
                .ecs_services = "ecsServices",
                .on_premises_tag_set = "onPremisesTagSet",
                .termination_hook_enabled = "terminationHookEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_deployment_group) } {
            return .{ .service_metadata = service_metadata, .action = update_deployment_group };
        }
    },
    Response: type = struct {
        hooks_not_cleaned_up: ?[]AutoScalingGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hooks_not_cleaned_up = "hooksNotCleanedUp",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AlarmsLimitExceeded,
        ApplicationDoesNotExist,
        ApplicationNameRequired,
        DeploymentConfigDoesNotExist,
        DeploymentGroupAlreadyExists,
        DeploymentGroupDoesNotExist,
        DeploymentGroupNameRequired,
        ECSServiceMappingLimitExceeded,
        InvalidAlarmConfig,
        InvalidApplicationName,
        InvalidAutoRollbackConfig,
        InvalidAutoScalingGroup,
        InvalidBlueGreenDeploymentConfiguration,
        InvalidDeploymentConfigName,
        InvalidDeploymentGroupName,
        InvalidDeploymentStyle,
        InvalidEC2TagCombination,
        InvalidEC2Tag,
        InvalidECSService,
        InvalidInput,
        InvalidLoadBalancerInfo,
        InvalidOnPremisesTagCombination,
        InvalidRole,
        InvalidTag,
        InvalidTargetGroupPair,
        InvalidTrafficRoutingConfiguration,
        InvalidTriggerConfig,
        LifecycleHookLimitExceeded,
        TagSetListLimitExceeded,
        Throttling,
        TriggerTargetsLimitExceeded,
    },
} = .{};

pub const AutoScalingGroup = struct {
    name: ?[]const u8 = null,
    hook: ?[]const u8 = null,
    termination_hook: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .hook = "hook",
            .termination_hook = "terminationHook",
        };
        return @field(mappings, field_name);
    }
};

pub const OnPremisesTagSet = struct {
    on_premises_tag_set_list: ?[][]TagFilter = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .on_premises_tag_set_list = "onPremisesTagSetList",
        };
        return @field(mappings, field_name);
    }
};

pub const TagFilter = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const ECSService = struct {
    service_name: ?[]const u8 = null,
    cluster_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .service_name = "serviceName",
            .cluster_name = "clusterName",
        };
        return @field(mappings, field_name);
    }
};

pub const EC2TagSet = struct {
    ec2_tag_set_list: ?[][]EC2TagFilter = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ec2_tag_set_list = "ec2TagSetList",
        };
        return @field(mappings, field_name);
    }
};

pub const EC2TagFilter = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const LoadBalancerInfo = struct {
    elb_info_list: ?[]ELBInfo = null,
    target_group_info_list: ?[]TargetGroupInfo = null,
    target_group_pair_info_list: ?[]TargetGroupPairInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .elb_info_list = "elbInfoList",
            .target_group_info_list = "targetGroupInfoList",
            .target_group_pair_info_list = "targetGroupPairInfoList",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetGroupPairInfo = struct {
    target_groups: ?[]TargetGroupInfo = null,
    prod_traffic_route: ?TrafficRoute = null,
    test_traffic_route: ?TrafficRoute = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .target_groups = "targetGroups",
            .prod_traffic_route = "prodTrafficRoute",
            .test_traffic_route = "testTrafficRoute",
        };
        return @field(mappings, field_name);
    }
};

pub const TrafficRoute = struct {
    listener_arns: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .listener_arns = "listenerArns",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetGroupInfo = struct {
    name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
        };
        return @field(mappings, field_name);
    }
};

pub const ELBInfo = struct {
    name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
        };
        return @field(mappings, field_name);
    }
};

pub const BlueGreenDeploymentConfiguration = struct {
    terminate_blue_instances_on_deployment_success: ?BlueInstanceTerminationOption = null,
    deployment_ready_option: ?DeploymentReadyOption = null,
    green_fleet_provisioning_option: ?GreenFleetProvisioningOption = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .terminate_blue_instances_on_deployment_success = "terminateBlueInstancesOnDeploymentSuccess",
            .deployment_ready_option = "deploymentReadyOption",
            .green_fleet_provisioning_option = "greenFleetProvisioningOption",
        };
        return @field(mappings, field_name);
    }
};

pub const GreenFleetProvisioningOption = struct {
    action: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action = "action",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentReadyOption = struct {
    action_on_timeout: ?[]const u8 = null,
    wait_time_in_minutes: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action_on_timeout = "actionOnTimeout",
            .wait_time_in_minutes = "waitTimeInMinutes",
        };
        return @field(mappings, field_name);
    }
};

pub const BlueInstanceTerminationOption = struct {
    action: ?[]const u8 = null,
    termination_wait_time_in_minutes: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action = "action",
            .termination_wait_time_in_minutes = "terminationWaitTimeInMinutes",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentStyle = struct {
    deployment_type: ?[]const u8 = null,
    deployment_option: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_type = "deploymentType",
            .deployment_option = "deploymentOption",
        };
        return @field(mappings, field_name);
    }
};

pub const AutoRollbackConfiguration = struct {
    enabled: ?bool = null,
    events: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "enabled",
            .events = "events",
        };
        return @field(mappings, field_name);
    }
};

pub const AlarmConfiguration = struct {
    enabled: ?bool = null,
    ignore_poll_alarm_failure: ?bool = null,
    alarms: ?[]Alarm = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "enabled",
            .ignore_poll_alarm_failure = "ignorePollAlarmFailure",
            .alarms = "alarms",
        };
        return @field(mappings, field_name);
    }
};

pub const Alarm = struct {
    name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
        };
        return @field(mappings, field_name);
    }
};

pub const TriggerConfig = struct {
    trigger_name: ?[]const u8 = null,
    trigger_target_arn: ?[]const u8 = null,
    trigger_events: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .trigger_name = "triggerName",
            .trigger_target_arn = "triggerTargetArn",
            .trigger_events = "triggerEvents",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const RevisionLocation = struct {
    revision_type: ?[]const u8 = null,
    s3_location: ?S3Location = null,
    git_hub_location: ?GitHubLocation = null,
    string: ?RawString = null,
    app_spec_content: ?AppSpecContent = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .revision_type = "revisionType",
            .s3_location = "s3Location",
            .git_hub_location = "gitHubLocation",
            .string = "string",
            .app_spec_content = "appSpecContent",
        };
        return @field(mappings, field_name);
    }
};

pub const AppSpecContent = struct {
    content: ?[]const u8 = null,
    sha256: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .content = "content",
            .sha256 = "sha256",
        };
        return @field(mappings, field_name);
    }
};

pub const RawString = struct {
    content: ?[]const u8 = null,
    sha256: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .content = "content",
            .sha256 = "sha256",
        };
        return @field(mappings, field_name);
    }
};

pub const GitHubLocation = struct {
    repository: ?[]const u8 = null,
    commit_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .repository = "repository",
            .commit_id = "commitId",
        };
        return @field(mappings, field_name);
    }
};

pub const S3Location = struct {
    bucket: ?[]const u8 = null,
    key: ?[]const u8 = null,
    bundle_type: ?[]const u8 = null,
    version: ?[]const u8 = null,
    e_tag: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket = "bucket",
            .key = "key",
            .bundle_type = "bundleType",
            .version = "version",
            .e_tag = "eTag",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceInfo = struct {
    instance_name: ?[]const u8 = null,
    iam_session_arn: ?[]const u8 = null,
    iam_user_arn: ?[]const u8 = null,
    instance_arn: ?[]const u8 = null,
    register_time: ?i64 = null,
    deregister_time: ?i64 = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .instance_name = "instanceName",
            .iam_session_arn = "iamSessionArn",
            .iam_user_arn = "iamUserArn",
            .instance_arn = "instanceArn",
            .register_time = "registerTime",
            .deregister_time = "deregisterTime",
            .tags = "tags",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentTarget = struct {
    deployment_target_type: ?[]const u8 = null,
    instance_target: ?InstanceTarget = null,
    lambda_target: ?LambdaTarget = null,
    ecs_target: ?ECSTarget = null,
    cloud_formation_target: ?CloudFormationTarget = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_target_type = "deploymentTargetType",
            .instance_target = "instanceTarget",
            .lambda_target = "lambdaTarget",
            .ecs_target = "ecsTarget",
            .cloud_formation_target = "cloudFormationTarget",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudFormationTarget = struct {
    deployment_id: ?[]const u8 = null,
    target_id: ?[]const u8 = null,
    last_updated_at: ?i64 = null,
    lifecycle_events: ?[]LifecycleEvent = null,
    status: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,
    target_version_weight: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .target_id = "targetId",
            .last_updated_at = "lastUpdatedAt",
            .lifecycle_events = "lifecycleEvents",
            .status = "status",
            .resource_type = "resourceType",
            .target_version_weight = "targetVersionWeight",
        };
        return @field(mappings, field_name);
    }
};

pub const LifecycleEvent = struct {
    lifecycle_event_name: ?[]const u8 = null,
    diagnostics: ?Diagnostics = null,
    start_time: ?i64 = null,
    end_time: ?i64 = null,
    status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .lifecycle_event_name = "lifecycleEventName",
            .diagnostics = "diagnostics",
            .start_time = "startTime",
            .end_time = "endTime",
            .status = "status",
        };
        return @field(mappings, field_name);
    }
};

pub const Diagnostics = struct {
    error_code: ?[]const u8 = null,
    script_name: ?[]const u8 = null,
    message: ?[]const u8 = null,
    log_tail: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .error_code = "errorCode",
            .script_name = "scriptName",
            .message = "message",
            .log_tail = "logTail",
        };
        return @field(mappings, field_name);
    }
};

pub const ECSTarget = struct {
    deployment_id: ?[]const u8 = null,
    target_id: ?[]const u8 = null,
    target_arn: ?[]const u8 = null,
    last_updated_at: ?i64 = null,
    lifecycle_events: ?[]LifecycleEvent = null,
    status: ?[]const u8 = null,
    task_sets_info: ?[]ECSTaskSet = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .target_id = "targetId",
            .target_arn = "targetArn",
            .last_updated_at = "lastUpdatedAt",
            .lifecycle_events = "lifecycleEvents",
            .status = "status",
            .task_sets_info = "taskSetsInfo",
        };
        return @field(mappings, field_name);
    }
};

pub const ECSTaskSet = struct {
    identifer: ?[]const u8 = null,
    desired_count: ?i64 = null,
    pending_count: ?i64 = null,
    running_count: ?i64 = null,
    status: ?[]const u8 = null,
    traffic_weight: ?f64 = null,
    target_group: ?TargetGroupInfo = null,
    task_set_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .identifer = "identifer",
            .desired_count = "desiredCount",
            .pending_count = "pendingCount",
            .running_count = "runningCount",
            .status = "status",
            .traffic_weight = "trafficWeight",
            .target_group = "targetGroup",
            .task_set_label = "taskSetLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const LambdaTarget = struct {
    deployment_id: ?[]const u8 = null,
    target_id: ?[]const u8 = null,
    target_arn: ?[]const u8 = null,
    status: ?[]const u8 = null,
    last_updated_at: ?i64 = null,
    lifecycle_events: ?[]LifecycleEvent = null,
    lambda_function_info: ?LambdaFunctionInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .target_id = "targetId",
            .target_arn = "targetArn",
            .status = "status",
            .last_updated_at = "lastUpdatedAt",
            .lifecycle_events = "lifecycleEvents",
            .lambda_function_info = "lambdaFunctionInfo",
        };
        return @field(mappings, field_name);
    }
};

pub const LambdaFunctionInfo = struct {
    function_name: ?[]const u8 = null,
    function_alias: ?[]const u8 = null,
    current_version: ?[]const u8 = null,
    target_version: ?[]const u8 = null,
    target_version_weight: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .function_name = "functionName",
            .function_alias = "functionAlias",
            .current_version = "currentVersion",
            .target_version = "targetVersion",
            .target_version_weight = "targetVersionWeight",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceTarget = struct {
    deployment_id: ?[]const u8 = null,
    target_id: ?[]const u8 = null,
    target_arn: ?[]const u8 = null,
    status: ?[]const u8 = null,
    last_updated_at: ?i64 = null,
    lifecycle_events: ?[]LifecycleEvent = null,
    instance_label: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .target_id = "targetId",
            .target_arn = "targetArn",
            .status = "status",
            .last_updated_at = "lastUpdatedAt",
            .lifecycle_events = "lifecycleEvents",
            .instance_label = "instanceLabel",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceSummary = struct {
    deployment_id: ?[]const u8 = null,
    instance_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    last_updated_at: ?i64 = null,
    lifecycle_events: ?[]LifecycleEvent = null,
    instance_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .instance_id = "instanceId",
            .status = "status",
            .last_updated_at = "lastUpdatedAt",
            .lifecycle_events = "lifecycleEvents",
            .instance_type = "instanceType",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentGroupInfo = struct {
    application_name: ?[]const u8 = null,
    deployment_group_id: ?[]const u8 = null,
    deployment_group_name: ?[]const u8 = null,
    deployment_config_name: ?[]const u8 = null,
    ec2_tag_filters: ?[]EC2TagFilter = null,
    on_premises_instance_tag_filters: ?[]TagFilter = null,
    auto_scaling_groups: ?[]AutoScalingGroup = null,
    service_role_arn: ?[]const u8 = null,
    target_revision: ?RevisionLocation = null,
    trigger_configurations: ?[]TriggerConfig = null,
    alarm_configuration: ?AlarmConfiguration = null,
    auto_rollback_configuration: ?AutoRollbackConfiguration = null,
    deployment_style: ?DeploymentStyle = null,
    outdated_instances_strategy: ?[]const u8 = null,
    blue_green_deployment_configuration: ?BlueGreenDeploymentConfiguration = null,
    load_balancer_info: ?LoadBalancerInfo = null,
    last_successful_deployment: ?LastDeploymentInfo = null,
    last_attempted_deployment: ?LastDeploymentInfo = null,
    ec2_tag_set: ?EC2TagSet = null,
    on_premises_tag_set: ?OnPremisesTagSet = null,
    compute_platform: ?[]const u8 = null,
    ecs_services: ?[]ECSService = null,
    termination_hook_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_name = "applicationName",
            .deployment_group_id = "deploymentGroupId",
            .deployment_group_name = "deploymentGroupName",
            .deployment_config_name = "deploymentConfigName",
            .ec2_tag_filters = "ec2TagFilters",
            .on_premises_instance_tag_filters = "onPremisesInstanceTagFilters",
            .auto_scaling_groups = "autoScalingGroups",
            .service_role_arn = "serviceRoleArn",
            .target_revision = "targetRevision",
            .trigger_configurations = "triggerConfigurations",
            .alarm_configuration = "alarmConfiguration",
            .auto_rollback_configuration = "autoRollbackConfiguration",
            .deployment_style = "deploymentStyle",
            .outdated_instances_strategy = "outdatedInstancesStrategy",
            .blue_green_deployment_configuration = "blueGreenDeploymentConfiguration",
            .load_balancer_info = "loadBalancerInfo",
            .last_successful_deployment = "lastSuccessfulDeployment",
            .last_attempted_deployment = "lastAttemptedDeployment",
            .ec2_tag_set = "ec2TagSet",
            .on_premises_tag_set = "onPremisesTagSet",
            .compute_platform = "computePlatform",
            .ecs_services = "ecsServices",
            .termination_hook_enabled = "terminationHookEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const LastDeploymentInfo = struct {
    deployment_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    end_time: ?i64 = null,
    create_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deployment_id = "deploymentId",
            .status = "status",
            .end_time = "endTime",
            .create_time = "createTime",
        };
        return @field(mappings, field_name);
    }
};

pub const ZonalConfig = struct {
    first_zone_monitor_duration_in_seconds: ?i64 = null,
    monitor_duration_in_seconds: ?i64 = null,
    minimum_healthy_hosts_per_zone: ?MinimumHealthyHostsPerZone = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .first_zone_monitor_duration_in_seconds = "firstZoneMonitorDurationInSeconds",
            .monitor_duration_in_seconds = "monitorDurationInSeconds",
            .minimum_healthy_hosts_per_zone = "minimumHealthyHostsPerZone",
        };
        return @field(mappings, field_name);
    }
};

pub const MinimumHealthyHostsPerZone = struct {
    type: ?[]const u8 = null,
    value: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const TrafficRoutingConfig = struct {
    type: ?[]const u8 = null,
    time_based_canary: ?TimeBasedCanary = null,
    time_based_linear: ?TimeBasedLinear = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .time_based_canary = "timeBasedCanary",
            .time_based_linear = "timeBasedLinear",
        };
        return @field(mappings, field_name);
    }
};

pub const TimeBasedLinear = struct {
    linear_percentage: ?i64 = null,
    linear_interval: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .linear_percentage = "linearPercentage",
            .linear_interval = "linearInterval",
        };
        return @field(mappings, field_name);
    }
};

pub const TimeBasedCanary = struct {
    canary_percentage: ?i64 = null,
    canary_interval: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .canary_percentage = "canaryPercentage",
            .canary_interval = "canaryInterval",
        };
        return @field(mappings, field_name);
    }
};

pub const MinimumHealthyHosts = struct {
    type: ?[]const u8 = null,
    value: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "type",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentInfo = struct {
    application_name: ?[]const u8 = null,
    deployment_group_name: ?[]const u8 = null,
    deployment_config_name: ?[]const u8 = null,
    deployment_id: ?[]const u8 = null,
    previous_revision: ?RevisionLocation = null,
    revision: ?RevisionLocation = null,
    status: ?[]const u8 = null,
    error_information: ?ErrorInformation = null,
    create_time: ?i64 = null,
    start_time: ?i64 = null,
    complete_time: ?i64 = null,
    deployment_overview: ?DeploymentOverview = null,
    description: ?[]const u8 = null,
    creator: ?[]const u8 = null,
    ignore_application_stop_failures: ?bool = null,
    auto_rollback_configuration: ?AutoRollbackConfiguration = null,
    update_outdated_instances_only: ?bool = null,
    rollback_info: ?RollbackInfo = null,
    deployment_style: ?DeploymentStyle = null,
    target_instances: ?TargetInstances = null,
    instance_termination_wait_time_started: ?bool = null,
    blue_green_deployment_configuration: ?BlueGreenDeploymentConfiguration = null,
    load_balancer_info: ?LoadBalancerInfo = null,
    additional_deployment_status_info: ?[]const u8 = null,
    file_exists_behavior: ?[]const u8 = null,
    deployment_status_messages: ?[][]const u8 = null,
    compute_platform: ?[]const u8 = null,
    external_id: ?[]const u8 = null,
    related_deployments: ?RelatedDeployments = null,
    override_alarm_configuration: ?AlarmConfiguration = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_name = "applicationName",
            .deployment_group_name = "deploymentGroupName",
            .deployment_config_name = "deploymentConfigName",
            .deployment_id = "deploymentId",
            .previous_revision = "previousRevision",
            .revision = "revision",
            .status = "status",
            .error_information = "errorInformation",
            .create_time = "createTime",
            .start_time = "startTime",
            .complete_time = "completeTime",
            .deployment_overview = "deploymentOverview",
            .description = "description",
            .creator = "creator",
            .ignore_application_stop_failures = "ignoreApplicationStopFailures",
            .auto_rollback_configuration = "autoRollbackConfiguration",
            .update_outdated_instances_only = "updateOutdatedInstancesOnly",
            .rollback_info = "rollbackInfo",
            .deployment_style = "deploymentStyle",
            .target_instances = "targetInstances",
            .instance_termination_wait_time_started = "instanceTerminationWaitTimeStarted",
            .blue_green_deployment_configuration = "blueGreenDeploymentConfiguration",
            .load_balancer_info = "loadBalancerInfo",
            .additional_deployment_status_info = "additionalDeploymentStatusInfo",
            .file_exists_behavior = "fileExistsBehavior",
            .deployment_status_messages = "deploymentStatusMessages",
            .compute_platform = "computePlatform",
            .external_id = "externalId",
            .related_deployments = "relatedDeployments",
            .override_alarm_configuration = "overrideAlarmConfiguration",
        };
        return @field(mappings, field_name);
    }
};

pub const RelatedDeployments = struct {
    auto_update_outdated_instances_root_deployment_id: ?[]const u8 = null,
    auto_update_outdated_instances_deployment_ids: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .auto_update_outdated_instances_root_deployment_id = "autoUpdateOutdatedInstancesRootDeploymentId",
            .auto_update_outdated_instances_deployment_ids = "autoUpdateOutdatedInstancesDeploymentIds",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetInstances = struct {
    tag_filters: ?[]EC2TagFilter = null,
    auto_scaling_groups: ?[][]const u8 = null,
    ec2_tag_set: ?EC2TagSet = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .tag_filters = "tagFilters",
            .auto_scaling_groups = "autoScalingGroups",
            .ec2_tag_set = "ec2TagSet",
        };
        return @field(mappings, field_name);
    }
};

pub const RollbackInfo = struct {
    rollback_deployment_id: ?[]const u8 = null,
    rollback_triggering_deployment_id: ?[]const u8 = null,
    rollback_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rollback_deployment_id = "rollbackDeploymentId",
            .rollback_triggering_deployment_id = "rollbackTriggeringDeploymentId",
            .rollback_message = "rollbackMessage",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentOverview = struct {
    pending: ?i64 = null,
    in_progress: ?i64 = null,
    succeeded: ?i64 = null,
    failed: ?i64 = null,
    skipped: ?i64 = null,
    ready: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .pending = "Pending",
            .in_progress = "InProgress",
            .succeeded = "Succeeded",
            .failed = "Failed",
            .skipped = "Skipped",
            .ready = "Ready",
        };
        return @field(mappings, field_name);
    }
};

pub const ErrorInformation = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const GenericRevisionInfo = struct {
    description: ?[]const u8 = null,
    deployment_groups: ?[][]const u8 = null,
    first_used_time: ?i64 = null,
    last_used_time: ?i64 = null,
    register_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .description = "description",
            .deployment_groups = "deploymentGroups",
            .first_used_time = "firstUsedTime",
            .last_used_time = "lastUsedTime",
            .register_time = "registerTime",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationInfo = struct {
    application_id: ?[]const u8 = null,
    application_name: ?[]const u8 = null,
    create_time: ?i64 = null,
    linked_to_git_hub: ?bool = null,
    git_hub_account_name: ?[]const u8 = null,
    compute_platform: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_id = "applicationId",
            .application_name = "applicationName",
            .create_time = "createTime",
            .linked_to_git_hub = "linkedToGitHub",
            .git_hub_account_name = "gitHubAccountName",
            .compute_platform = "computePlatform",
        };
        return @field(mappings, field_name);
    }
};
