const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-11-27";
pub const sdk_id: []const u8 = "Comprehend";
pub const arn_namespace: ?[]const u8 = "comprehend";
pub const endpoint_prefix: []const u8 = "comprehend";
pub const sigv4_name: []const u8 = "comprehend";
pub const name: []const u8 = "Comprehend_20171127";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-11-27",
    sdk_id: []const u8 = "Comprehend",
    arn_namespace: ?[]const u8 = "comprehend",
    endpoint_prefix: []const u8 = "comprehend",
    sigv4_name: []const u8 = "comprehend",
    name: []const u8 = "Comprehend_20171127",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const batch_detect_dominant_language: struct {
    action_name: []const u8 = "BatchDetectDominantLanguage",
    Request: type = struct {
        text_list: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_dominant_language) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_dominant_language };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            languages: ?[]DominantLanguage = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .languages = "Languages",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
    },
} = .{};
pub const batch_detect_entities: struct {
    action_name: []const u8 = "BatchDetectEntities",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_entities) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_entities };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            entities: ?[]Entity = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .entities = "Entities",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_key_phrases: struct {
    action_name: []const u8 = "BatchDetectKeyPhrases",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_key_phrases) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_key_phrases };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            key_phrases: ?[]KeyPhrase = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .key_phrases = "KeyPhrases",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_sentiment: struct {
    action_name: []const u8 = "BatchDetectSentiment",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_sentiment };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            sentiment: ?[]const u8 = null,
            sentiment_score: ?SentimentScore = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .sentiment = "Sentiment",
                    .sentiment_score = "SentimentScore",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_syntax: struct {
    action_name: []const u8 = "BatchDetectSyntax",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_syntax) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_syntax };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            syntax_tokens: ?[]SyntaxToken = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .syntax_tokens = "SyntaxTokens",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_targeted_sentiment: struct {
    action_name: []const u8 = "BatchDetectTargetedSentiment",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_targeted_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_targeted_sentiment };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            entities: ?[]TargetedSentimentEntity = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .entities = "Entities",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const classify_document: struct {
    action_name: []const u8 = "ClassifyDocument",
    Request: type = struct {
        text: ?[]const u8 = null,
        endpoint_arn: []const u8,
        bytes: ?[]const u8 = null,
        document_reader_config: ?DocumentReaderConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .endpoint_arn = "EndpointArn",
                .bytes = "Bytes",
                .document_reader_config = "DocumentReaderConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(classify_document) } {
            return .{ .service_metadata = service_metadata, .action = classify_document };
        }
    },
    Response: type = struct {
        classes: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,
            page: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                    .page = "Page",
                };
                return @field(mappings, field_name);
            }
        } = null,
        labels: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,
            page: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                    .page = "Page",
                };
                return @field(mappings, field_name);
            }
        } = null,
        document_metadata: ?DocumentMetadata = null,
        document_type: ?[]DocumentTypeListItem = null,
        errors: ?[]ErrorsListItem = null,
        warnings: ?[]struct {
            page: ?i64 = null,
            warn_code: ?[]const u8 = null,
            warn_message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .page = "Page",
                    .warn_code = "WarnCode",
                    .warn_message = "WarnMessage",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .classes = "Classes",
                .labels = "Labels",
                .document_metadata = "DocumentMetadata",
                .document_type = "DocumentType",
                .errors = "Errors",
                .warnings = "Warnings",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceUnavailable,
        TextSizeLimitExceeded,
    },
} = .{};
pub const contains_pii_entities: struct {
    action_name: []const u8 = "ContainsPiiEntities",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(contains_pii_entities) } {
            return .{ .service_metadata = service_metadata, .action = contains_pii_entities };
        }
    },
    Response: type = struct {
        labels: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .labels = "Labels",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const create_dataset: struct {
    action_name: []const u8 = "CreateDataset",
    Request: type = struct {
        flywheel_arn: []const u8,
        dataset_name: []const u8,
        dataset_type: ?[]const u8 = null,
        description: ?[]const u8 = null,
        input_data_config: struct {
            augmented_manifests: ?[]struct {
                attribute_names: [][]const u8,
                s3_uri: []const u8,
                annotation_data_s3_uri: ?[]const u8 = null,
                source_documents_s3_uri: ?[]const u8 = null,
                document_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .attribute_names = "AttributeNames",
                        .s3_uri = "S3Uri",
                        .annotation_data_s3_uri = "AnnotationDataS3Uri",
                        .source_documents_s3_uri = "SourceDocumentsS3Uri",
                        .document_type = "DocumentType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            data_format: ?[]const u8 = null,
            document_classifier_input_data_config: ?struct {
                s3_uri: []const u8,
                label_delimiter: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .s3_uri = "S3Uri",
                        .label_delimiter = "LabelDelimiter",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            entity_recognizer_input_data_config: ?struct {
                annotations: ?struct {
                    s3_uri: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .s3_uri = "S3Uri",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                documents: struct {
                    s3_uri: []const u8,
                    input_format: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .s3_uri = "S3Uri",
                            .input_format = "InputFormat",
                        };
                        return @field(mappings, field_name);
                    }
                },
                entity_list: ?struct {
                    s3_uri: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .s3_uri = "S3Uri",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .annotations = "Annotations",
                        .documents = "Documents",
                        .entity_list = "EntityList",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .augmented_manifests = "AugmentedManifests",
                    .data_format = "DataFormat",
                    .document_classifier_input_data_config = "DocumentClassifierInputDataConfig",
                    .entity_recognizer_input_data_config = "EntityRecognizerInputDataConfig",
                };
                return @field(mappings, field_name);
            }
        },
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .dataset_name = "DatasetName",
                .dataset_type = "DatasetType",
                .description = "Description",
                .input_data_config = "InputDataConfig",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_dataset) } {
            return .{ .service_metadata = service_metadata, .action = create_dataset };
        }
    },
    Response: type = struct {
        dataset_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dataset_arn = "DatasetArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const create_document_classifier: struct {
    action_name: []const u8 = "CreateDocumentClassifier",
    Request: type = struct {
        document_classifier_name: []const u8,
        version_name: ?[]const u8 = null,
        data_access_role_arn: []const u8,
        tags: ?[]Tag = null,
        input_data_config: DocumentClassifierInputDataConfig,
        output_data_config: ?DocumentClassifierOutputDataConfig = null,
        client_request_token: ?[]const u8 = null,
        language_code: []const u8,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        mode: ?[]const u8 = null,
        model_kms_key_id: ?[]const u8 = null,
        model_policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_name = "DocumentClassifierName",
                .version_name = "VersionName",
                .data_access_role_arn = "DataAccessRoleArn",
                .tags = "Tags",
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .client_request_token = "ClientRequestToken",
                .language_code = "LanguageCode",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .mode = "Mode",
                .model_kms_key_id = "ModelKmsKeyId",
                .model_policy = "ModelPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = create_document_classifier };
        }
    },
    Response: type = struct {
        document_classifier_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        TooManyRequests,
        TooManyTags,
        UnsupportedLanguage,
    },
} = .{};
pub const create_endpoint: struct {
    action_name: []const u8 = "CreateEndpoint",
    Request: type = struct {
        endpoint_name: []const u8,
        model_arn: ?[]const u8 = null,
        desired_inference_units: i64,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,
        data_access_role_arn: ?[]const u8 = null,
        flywheel_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_name = "EndpointName",
                .model_arn = "ModelArn",
                .desired_inference_units = "DesiredInferenceUnits",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
                .data_access_role_arn = "DataAccessRoleArn",
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = create_endpoint };
        }
    },
    Response: type = struct {
        endpoint_arn: ?[]const u8 = null,
        model_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
                .model_arn = "ModelArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const create_entity_recognizer: struct {
    action_name: []const u8 = "CreateEntityRecognizer",
    Request: type = struct {
        recognizer_name: []const u8,
        version_name: ?[]const u8 = null,
        data_access_role_arn: []const u8,
        tags: ?[]Tag = null,
        input_data_config: EntityRecognizerInputDataConfig,
        client_request_token: ?[]const u8 = null,
        language_code: []const u8,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        model_kms_key_id: ?[]const u8 = null,
        model_policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .recognizer_name = "RecognizerName",
                .version_name = "VersionName",
                .data_access_role_arn = "DataAccessRoleArn",
                .tags = "Tags",
                .input_data_config = "InputDataConfig",
                .client_request_token = "ClientRequestToken",
                .language_code = "LanguageCode",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .model_kms_key_id = "ModelKmsKeyId",
                .model_policy = "ModelPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = create_entity_recognizer };
        }
    },
    Response: type = struct {
        entity_recognizer_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        TooManyRequests,
        TooManyTags,
        UnsupportedLanguage,
    },
} = .{};
pub const create_flywheel: struct {
    action_name: []const u8 = "CreateFlywheel",
    Request: type = struct {
        flywheel_name: []const u8,
        active_model_arn: ?[]const u8 = null,
        data_access_role_arn: []const u8,
        task_config: ?TaskConfig = null,
        model_type: ?[]const u8 = null,
        data_lake_s3_uri: []const u8,
        data_security_config: ?DataSecurityConfig = null,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_name = "FlywheelName",
                .active_model_arn = "ActiveModelArn",
                .data_access_role_arn = "DataAccessRoleArn",
                .task_config = "TaskConfig",
                .model_type = "ModelType",
                .data_lake_s3_uri = "DataLakeS3Uri",
                .data_security_config = "DataSecurityConfig",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_flywheel) } {
            return .{ .service_metadata = service_metadata, .action = create_flywheel };
        }
    },
    Response: type = struct {
        flywheel_arn: ?[]const u8 = null,
        active_model_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .active_model_arn = "ActiveModelArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
        UnsupportedLanguage,
    },
} = .{};
pub const delete_document_classifier: struct {
    action_name: []const u8 = "DeleteDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = delete_document_classifier };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const delete_endpoint: struct {
    action_name: []const u8 = "DeleteEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = delete_endpoint };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const delete_entity_recognizer: struct {
    action_name: []const u8 = "DeleteEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = delete_entity_recognizer };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const delete_flywheel: struct {
    action_name: []const u8 = "DeleteFlywheel",
    Request: type = struct {
        flywheel_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_flywheel) } {
            return .{ .service_metadata = service_metadata, .action = delete_flywheel };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const delete_resource_policy: struct {
    action_name: []const u8 = "DeleteResourcePolicy",
    Request: type = struct {
        resource_arn: []const u8,
        policy_revision_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .policy_revision_id = "PolicyRevisionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_resource_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const describe_dataset: struct {
    action_name: []const u8 = "DescribeDataset",
    Request: type = struct {
        dataset_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dataset_arn = "DatasetArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_dataset) } {
            return .{ .service_metadata = service_metadata, .action = describe_dataset };
        }
    },
    Response: type = struct {
        dataset_properties: ?DatasetProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dataset_properties = "DatasetProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_document_classification_job: struct {
    action_name: []const u8 = "DescribeDocumentClassificationJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_document_classification_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_document_classification_job };
        }
    },
    Response: type = struct {
        document_classification_job_properties: ?DocumentClassificationJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classification_job_properties = "DocumentClassificationJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_document_classifier: struct {
    action_name: []const u8 = "DescribeDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = describe_document_classifier };
        }
    },
    Response: type = struct {
        document_classifier_properties: ?DocumentClassifierProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_properties = "DocumentClassifierProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_dominant_language_detection_job: struct {
    action_name: []const u8 = "DescribeDominantLanguageDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        dominant_language_detection_job_properties: ?DominantLanguageDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dominant_language_detection_job_properties = "DominantLanguageDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_endpoint: struct {
    action_name: []const u8 = "DescribeEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = describe_endpoint };
        }
    },
    Response: type = struct {
        endpoint_properties: ?EndpointProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_properties = "EndpointProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_entities_detection_job: struct {
    action_name: []const u8 = "DescribeEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_entities_detection_job };
        }
    },
    Response: type = struct {
        entities_detection_job_properties: ?EntitiesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities_detection_job_properties = "EntitiesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_entity_recognizer: struct {
    action_name: []const u8 = "DescribeEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = describe_entity_recognizer };
        }
    },
    Response: type = struct {
        entity_recognizer_properties: ?EntityRecognizerProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_properties = "EntityRecognizerProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_events_detection_job: struct {
    action_name: []const u8 = "DescribeEventsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_events_detection_job };
        }
    },
    Response: type = struct {
        events_detection_job_properties: ?EventsDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events_detection_job_properties = "EventsDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_flywheel: struct {
    action_name: []const u8 = "DescribeFlywheel",
    Request: type = struct {
        flywheel_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_flywheel) } {
            return .{ .service_metadata = service_metadata, .action = describe_flywheel };
        }
    },
    Response: type = struct {
        flywheel_properties: ?FlywheelProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_properties = "FlywheelProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_flywheel_iteration: struct {
    action_name: []const u8 = "DescribeFlywheelIteration",
    Request: type = struct {
        flywheel_arn: []const u8,
        flywheel_iteration_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .flywheel_iteration_id = "FlywheelIterationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_flywheel_iteration) } {
            return .{ .service_metadata = service_metadata, .action = describe_flywheel_iteration };
        }
    },
    Response: type = struct {
        flywheel_iteration_properties: ?FlywheelIterationProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_iteration_properties = "FlywheelIterationProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_key_phrases_detection_job: struct {
    action_name: []const u8 = "DescribeKeyPhrasesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        key_phrases_detection_job_properties: ?KeyPhrasesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases_detection_job_properties = "KeyPhrasesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_pii_entities_detection_job: struct {
    action_name: []const u8 = "DescribePiiEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        pii_entities_detection_job_properties: ?PiiEntitiesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pii_entities_detection_job_properties = "PiiEntitiesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_resource_policy: struct {
    action_name: []const u8 = "DescribeResourcePolicy",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = describe_resource_policy };
        }
    },
    Response: type = struct {
        resource_policy: ?[]const u8 = null,
        creation_time: ?i64 = null,
        last_modified_time: ?i64 = null,
        policy_revision_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_policy = "ResourcePolicy",
                .creation_time = "CreationTime",
                .last_modified_time = "LastModifiedTime",
                .policy_revision_id = "PolicyRevisionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const describe_sentiment_detection_job: struct {
    action_name: []const u8 = "DescribeSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_sentiment_detection_job };
        }
    },
    Response: type = struct {
        sentiment_detection_job_properties: ?SentimentDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment_detection_job_properties = "SentimentDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_targeted_sentiment_detection_job: struct {
    action_name: []const u8 = "DescribeTargetedSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_targeted_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_targeted_sentiment_detection_job };
        }
    },
    Response: type = struct {
        targeted_sentiment_detection_job_properties: ?TargetedSentimentDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .targeted_sentiment_detection_job_properties = "TargetedSentimentDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_topics_detection_job: struct {
    action_name: []const u8 = "DescribeTopicsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_topics_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_topics_detection_job };
        }
    },
    Response: type = struct {
        topics_detection_job_properties: ?TopicsDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .topics_detection_job_properties = "TopicsDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const detect_dominant_language: struct {
    action_name: []const u8 = "DetectDominantLanguage",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_dominant_language) } {
            return .{ .service_metadata = service_metadata, .action = detect_dominant_language };
        }
    },
    Response: type = struct {
        languages: ?[]DominantLanguage = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .languages = "Languages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
    },
} = .{};
pub const detect_entities: struct {
    action_name: []const u8 = "DetectEntities",
    Request: type = struct {
        text: ?[]const u8 = null,
        language_code: ?[]const u8 = null,
        endpoint_arn: ?[]const u8 = null,
        bytes: ?[]const u8 = null,
        document_reader_config: ?DocumentReaderConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
                .endpoint_arn = "EndpointArn",
                .bytes = "Bytes",
                .document_reader_config = "DocumentReaderConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_entities) } {
            return .{ .service_metadata = service_metadata, .action = detect_entities };
        }
    },
    Response: type = struct {
        entities: ?[]Entity = null,
        document_metadata: ?DocumentMetadata = null,
        document_type: ?[]DocumentTypeListItem = null,
        blocks: ?[]struct {
            id: ?[]const u8 = null,
            block_type: ?[]const u8 = null,
            text: ?[]const u8 = null,
            page: ?i64 = null,
            geometry: ?struct {
                bounding_box: ?struct {
                    height: ?f32 = null,
                    left: ?f32 = null,
                    top: ?f32 = null,
                    width: ?f32 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .height = "Height",
                            .left = "Left",
                            .top = "Top",
                            .width = "Width",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                polygon: ?[]struct {
                    x: ?f32 = null,
                    y: ?f32 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .x = "X",
                            .y = "Y",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .bounding_box = "BoundingBox",
                        .polygon = "Polygon",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            relationships: ?[]struct {
                ids: ?[][]const u8 = null,
                type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .ids = "Ids",
                        .type = "Type",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .block_type = "BlockType",
                    .text = "Text",
                    .page = "Page",
                    .geometry = "Geometry",
                    .relationships = "Relationships",
                };
                return @field(mappings, field_name);
            }
        } = null,
        errors: ?[]ErrorsListItem = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .document_metadata = "DocumentMetadata",
                .document_type = "DocumentType",
                .blocks = "Blocks",
                .errors = "Errors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceUnavailable,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_key_phrases: struct {
    action_name: []const u8 = "DetectKeyPhrases",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_key_phrases) } {
            return .{ .service_metadata = service_metadata, .action = detect_key_phrases };
        }
    },
    Response: type = struct {
        key_phrases: ?[]KeyPhrase = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases = "KeyPhrases",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_pii_entities: struct {
    action_name: []const u8 = "DetectPiiEntities",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_pii_entities) } {
            return .{ .service_metadata = service_metadata, .action = detect_pii_entities };
        }
    },
    Response: type = struct {
        entities: ?[]struct {
            score: ?f32 = null,
            type: ?[]const u8 = null,
            begin_offset: ?i64 = null,
            end_offset: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .score = "Score",
                    .type = "Type",
                    .begin_offset = "BeginOffset",
                    .end_offset = "EndOffset",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_sentiment: struct {
    action_name: []const u8 = "DetectSentiment",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = detect_sentiment };
        }
    },
    Response: type = struct {
        sentiment: ?[]const u8 = null,
        sentiment_score: ?SentimentScore = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment = "Sentiment",
                .sentiment_score = "SentimentScore",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_syntax: struct {
    action_name: []const u8 = "DetectSyntax",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_syntax) } {
            return .{ .service_metadata = service_metadata, .action = detect_syntax };
        }
    },
    Response: type = struct {
        syntax_tokens: ?[]SyntaxToken = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .syntax_tokens = "SyntaxTokens",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_targeted_sentiment: struct {
    action_name: []const u8 = "DetectTargetedSentiment",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_targeted_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = detect_targeted_sentiment };
        }
    },
    Response: type = struct {
        entities: ?[]TargetedSentimentEntity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_toxic_content: struct {
    action_name: []const u8 = "DetectToxicContent",
    Request: type = struct {
        text_segments: []struct {
            text: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .text = "Text",
                };
                return @field(mappings, field_name);
            }
        },
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_segments = "TextSegments",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_toxic_content) } {
            return .{ .service_metadata = service_metadata, .action = detect_toxic_content };
        }
    },
    Response: type = struct {
        result_list: ?[]struct {
            labels: ?[]struct {
                name: ?[]const u8 = null,
                score: ?f32 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .name = "Name",
                        .score = "Score",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            toxicity: ?f32 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .labels = "Labels",
                    .toxicity = "Toxicity",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const import_model: struct {
    action_name: []const u8 = "ImportModel",
    Request: type = struct {
        source_model_arn: []const u8,
        model_name: ?[]const u8 = null,
        version_name: ?[]const u8 = null,
        model_kms_key_id: ?[]const u8 = null,
        data_access_role_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .source_model_arn = "SourceModelArn",
                .model_name = "ModelName",
                .version_name = "VersionName",
                .model_kms_key_id = "ModelKmsKeyId",
                .data_access_role_arn = "DataAccessRoleArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_model) } {
            return .{ .service_metadata = service_metadata, .action = import_model };
        }
    },
    Response: type = struct {
        model_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_arn = "ModelArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const list_datasets: struct {
    action_name: []const u8 = "ListDatasets",
    Request: type = struct {
        flywheel_arn: ?[]const u8 = null,
        filter: ?struct {
            status: ?[]const u8 = null,
            dataset_type: ?[]const u8 = null,
            creation_time_after: ?i64 = null,
            creation_time_before: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .dataset_type = "DatasetType",
                    .creation_time_after = "CreationTimeAfter",
                    .creation_time_before = "CreationTimeBefore",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_datasets) } {
            return .{ .service_metadata = service_metadata, .action = list_datasets };
        }
    },
    Response: type = struct {
        dataset_properties_list: ?[]DatasetProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dataset_properties_list = "DatasetPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const list_document_classification_jobs: struct {
    action_name: []const u8 = "ListDocumentClassificationJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_document_classification_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_document_classification_jobs };
        }
    },
    Response: type = struct {
        document_classification_job_properties_list: ?[]DocumentClassificationJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classification_job_properties_list = "DocumentClassificationJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_document_classifiers: struct {
    action_name: []const u8 = "ListDocumentClassifiers",
    Request: type = struct {
        filter: ?struct {
            status: ?[]const u8 = null,
            document_classifier_name: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .document_classifier_name = "DocumentClassifierName",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_document_classifiers) } {
            return .{ .service_metadata = service_metadata, .action = list_document_classifiers };
        }
    },
    Response: type = struct {
        document_classifier_properties_list: ?[]DocumentClassifierProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_properties_list = "DocumentClassifierPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_document_classifier_summaries: struct {
    action_name: []const u8 = "ListDocumentClassifierSummaries",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_document_classifier_summaries) } {
            return .{ .service_metadata = service_metadata, .action = list_document_classifier_summaries };
        }
    },
    Response: type = struct {
        document_classifier_summaries_list: ?[]struct {
            document_classifier_name: ?[]const u8 = null,
            number_of_versions: ?i64 = null,
            latest_version_created_at: ?i64 = null,
            latest_version_name: ?[]const u8 = null,
            latest_version_status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .document_classifier_name = "DocumentClassifierName",
                    .number_of_versions = "NumberOfVersions",
                    .latest_version_created_at = "LatestVersionCreatedAt",
                    .latest_version_name = "LatestVersionName",
                    .latest_version_status = "LatestVersionStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_summaries_list = "DocumentClassifierSummariesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_dominant_language_detection_jobs: struct {
    action_name: []const u8 = "ListDominantLanguageDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_dominant_language_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_dominant_language_detection_jobs };
        }
    },
    Response: type = struct {
        dominant_language_detection_job_properties_list: ?[]DominantLanguageDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dominant_language_detection_job_properties_list = "DominantLanguageDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_endpoints: struct {
    action_name: []const u8 = "ListEndpoints",
    Request: type = struct {
        filter: ?struct {
            model_arn: ?[]const u8 = null,
            status: ?[]const u8 = null,
            creation_time_before: ?i64 = null,
            creation_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_arn = "ModelArn",
                    .status = "Status",
                    .creation_time_before = "CreationTimeBefore",
                    .creation_time_after = "CreationTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_endpoints) } {
            return .{ .service_metadata = service_metadata, .action = list_endpoints };
        }
    },
    Response: type = struct {
        endpoint_properties_list: ?[]EndpointProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_properties_list = "EndpointPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_entities_detection_jobs: struct {
    action_name: []const u8 = "ListEntitiesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entities_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_entities_detection_jobs };
        }
    },
    Response: type = struct {
        entities_detection_job_properties_list: ?[]EntitiesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities_detection_job_properties_list = "EntitiesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_entity_recognizers: struct {
    action_name: []const u8 = "ListEntityRecognizers",
    Request: type = struct {
        filter: ?struct {
            status: ?[]const u8 = null,
            recognizer_name: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .recognizer_name = "RecognizerName",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entity_recognizers) } {
            return .{ .service_metadata = service_metadata, .action = list_entity_recognizers };
        }
    },
    Response: type = struct {
        entity_recognizer_properties_list: ?[]EntityRecognizerProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_properties_list = "EntityRecognizerPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_entity_recognizer_summaries: struct {
    action_name: []const u8 = "ListEntityRecognizerSummaries",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entity_recognizer_summaries) } {
            return .{ .service_metadata = service_metadata, .action = list_entity_recognizer_summaries };
        }
    },
    Response: type = struct {
        entity_recognizer_summaries_list: ?[]struct {
            recognizer_name: ?[]const u8 = null,
            number_of_versions: ?i64 = null,
            latest_version_created_at: ?i64 = null,
            latest_version_name: ?[]const u8 = null,
            latest_version_status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .recognizer_name = "RecognizerName",
                    .number_of_versions = "NumberOfVersions",
                    .latest_version_created_at = "LatestVersionCreatedAt",
                    .latest_version_name = "LatestVersionName",
                    .latest_version_status = "LatestVersionStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_summaries_list = "EntityRecognizerSummariesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_events_detection_jobs: struct {
    action_name: []const u8 = "ListEventsDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_events_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_events_detection_jobs };
        }
    },
    Response: type = struct {
        events_detection_job_properties_list: ?[]EventsDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events_detection_job_properties_list = "EventsDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_flywheel_iteration_history: struct {
    action_name: []const u8 = "ListFlywheelIterationHistory",
    Request: type = struct {
        flywheel_arn: []const u8,
        filter: ?struct {
            creation_time_after: ?i64 = null,
            creation_time_before: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .creation_time_after = "CreationTimeAfter",
                    .creation_time_before = "CreationTimeBefore",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_flywheel_iteration_history) } {
            return .{ .service_metadata = service_metadata, .action = list_flywheel_iteration_history };
        }
    },
    Response: type = struct {
        flywheel_iteration_properties_list: ?[]FlywheelIterationProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_iteration_properties_list = "FlywheelIterationPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const list_flywheels: struct {
    action_name: []const u8 = "ListFlywheels",
    Request: type = struct {
        filter: ?struct {
            status: ?[]const u8 = null,
            creation_time_after: ?i64 = null,
            creation_time_before: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .creation_time_after = "CreationTimeAfter",
                    .creation_time_before = "CreationTimeBefore",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_flywheels) } {
            return .{ .service_metadata = service_metadata, .action = list_flywheels };
        }
    },
    Response: type = struct {
        flywheel_summary_list: ?[]struct {
            flywheel_arn: ?[]const u8 = null,
            active_model_arn: ?[]const u8 = null,
            data_lake_s3_uri: ?[]const u8 = null,
            status: ?[]const u8 = null,
            model_type: ?[]const u8 = null,
            message: ?[]const u8 = null,
            creation_time: ?i64 = null,
            last_modified_time: ?i64 = null,
            latest_flywheel_iteration: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .flywheel_arn = "FlywheelArn",
                    .active_model_arn = "ActiveModelArn",
                    .data_lake_s3_uri = "DataLakeS3Uri",
                    .status = "Status",
                    .model_type = "ModelType",
                    .message = "Message",
                    .creation_time = "CreationTime",
                    .last_modified_time = "LastModifiedTime",
                    .latest_flywheel_iteration = "LatestFlywheelIteration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_summary_list = "FlywheelSummaryList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_key_phrases_detection_jobs: struct {
    action_name: []const u8 = "ListKeyPhrasesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_key_phrases_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_key_phrases_detection_jobs };
        }
    },
    Response: type = struct {
        key_phrases_detection_job_properties_list: ?[]KeyPhrasesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases_detection_job_properties_list = "KeyPhrasesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_pii_entities_detection_jobs: struct {
    action_name: []const u8 = "ListPiiEntitiesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_pii_entities_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_pii_entities_detection_jobs };
        }
    },
    Response: type = struct {
        pii_entities_detection_job_properties_list: ?[]PiiEntitiesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pii_entities_detection_job_properties_list = "PiiEntitiesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_sentiment_detection_jobs: struct {
    action_name: []const u8 = "ListSentimentDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_sentiment_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_sentiment_detection_jobs };
        }
    },
    Response: type = struct {
        sentiment_detection_job_properties_list: ?[]SentimentDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment_detection_job_properties_list = "SentimentDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        resource_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const list_targeted_sentiment_detection_jobs: struct {
    action_name: []const u8 = "ListTargetedSentimentDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_targeted_sentiment_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_targeted_sentiment_detection_jobs };
        }
    },
    Response: type = struct {
        targeted_sentiment_detection_job_properties_list: ?[]TargetedSentimentDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .targeted_sentiment_detection_job_properties_list = "TargetedSentimentDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_topics_detection_jobs: struct {
    action_name: []const u8 = "ListTopicsDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_topics_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_topics_detection_jobs };
        }
    },
    Response: type = struct {
        topics_detection_job_properties_list: ?[]TopicsDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .topics_detection_job_properties_list = "TopicsDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const put_resource_policy: struct {
    action_name: []const u8 = "PutResourcePolicy",
    Request: type = struct {
        resource_arn: []const u8,
        resource_policy: []const u8,
        policy_revision_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .resource_policy = "ResourcePolicy",
                .policy_revision_id = "PolicyRevisionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_resource_policy };
        }
    },
    Response: type = struct {
        policy_revision_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_revision_id = "PolicyRevisionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const start_document_classification_job: struct {
    action_name: []const u8 = "StartDocumentClassificationJob",
    Request: type = struct {
        job_name: ?[]const u8 = null,
        document_classifier_arn: ?[]const u8 = null,
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,
        flywheel_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_name = "JobName",
                .document_classifier_arn = "DocumentClassifierArn",
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_document_classification_job) } {
            return .{ .service_metadata = service_metadata, .action = start_document_classification_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,
        document_classifier_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_dominant_language_detection_job: struct {
    action_name: []const u8 = "StartDominantLanguageDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_entities_detection_job: struct {
    action_name: []const u8 = "StartEntitiesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        entity_recognizer_arn: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,
        flywheel_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .entity_recognizer_arn = "EntityRecognizerArn",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,
        entity_recognizer_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_events_detection_job: struct {
    action_name: []const u8 = "StartEventsDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        target_event_types: [][]const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .target_event_types = "TargetEventTypes",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_events_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_flywheel_iteration: struct {
    action_name: []const u8 = "StartFlywheelIteration",
    Request: type = struct {
        flywheel_arn: []const u8,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_flywheel_iteration) } {
            return .{ .service_metadata = service_metadata, .action = start_flywheel_iteration };
        }
    },
    Response: type = struct {
        flywheel_arn: ?[]const u8 = null,
        flywheel_iteration_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .flywheel_iteration_id = "FlywheelIterationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const start_key_phrases_detection_job: struct {
    action_name: []const u8 = "StartKeyPhrasesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_pii_entities_detection_job: struct {
    action_name: []const u8 = "StartPiiEntitiesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        mode: []const u8,
        redaction_config: ?RedactionConfig = null,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .mode = "Mode",
                .redaction_config = "RedactionConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_sentiment_detection_job: struct {
    action_name: []const u8 = "StartSentimentDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_targeted_sentiment_detection_job: struct {
    action_name: []const u8 = "StartTargetedSentimentDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_targeted_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_targeted_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const start_topics_detection_job: struct {
    action_name: []const u8 = "StartTopicsDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        number_of_topics: ?i64 = null,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .number_of_topics = "NumberOfTopics",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_topics_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_topics_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_arn: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_arn = "JobArn",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const stop_dominant_language_detection_job: struct {
    action_name: []const u8 = "StopDominantLanguageDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_entities_detection_job: struct {
    action_name: []const u8 = "StopEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_events_detection_job: struct {
    action_name: []const u8 = "StopEventsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_events_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_key_phrases_detection_job: struct {
    action_name: []const u8 = "StopKeyPhrasesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_pii_entities_detection_job: struct {
    action_name: []const u8 = "StopPiiEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_sentiment_detection_job: struct {
    action_name: []const u8 = "StopSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_targeted_sentiment_detection_job: struct {
    action_name: []const u8 = "StopTargetedSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_targeted_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_targeted_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_training_document_classifier: struct {
    action_name: []const u8 = "StopTrainingDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_training_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = stop_training_document_classifier };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const stop_training_entity_recognizer: struct {
    action_name: []const u8 = "StopTrainingEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_training_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = stop_training_entity_recognizer };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyTagKeys,
    },
} = .{};
pub const update_endpoint: struct {
    action_name: []const u8 = "UpdateEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,
        desired_model_arn: ?[]const u8 = null,
        desired_inference_units: ?i64 = null,
        desired_data_access_role_arn: ?[]const u8 = null,
        flywheel_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
                .desired_model_arn = "DesiredModelArn",
                .desired_inference_units = "DesiredInferenceUnits",
                .desired_data_access_role_arn = "DesiredDataAccessRoleArn",
                .flywheel_arn = "FlywheelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = update_endpoint };
        }
    },
    Response: type = struct {
        desired_model_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .desired_model_arn = "DesiredModelArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const update_flywheel: struct {
    action_name: []const u8 = "UpdateFlywheel",
    Request: type = struct {
        flywheel_arn: []const u8,
        active_model_arn: ?[]const u8 = null,
        data_access_role_arn: ?[]const u8 = null,
        data_security_config: ?struct {
            model_kms_key_id: ?[]const u8 = null,
            volume_kms_key_id: ?[]const u8 = null,
            vpc_config: ?VpcConfig = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_kms_key_id = "ModelKmsKeyId",
                    .volume_kms_key_id = "VolumeKmsKeyId",
                    .vpc_config = "VpcConfig",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_arn = "FlywheelArn",
                .active_model_arn = "ActiveModelArn",
                .data_access_role_arn = "DataAccessRoleArn",
                .data_security_config = "DataSecurityConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_flywheel) } {
            return .{ .service_metadata = service_metadata, .action = update_flywheel };
        }
    },
    Response: type = struct {
        flywheel_properties: ?FlywheelProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .flywheel_properties = "FlywheelProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};

pub const FlywheelProperties = struct {
    flywheel_arn: ?[]const u8 = null,
    active_model_arn: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    task_config: ?TaskConfig = null,
    data_lake_s3_uri: ?[]const u8 = null,
    data_security_config: ?DataSecurityConfig = null,
    status: ?[]const u8 = null,
    model_type: ?[]const u8 = null,
    message: ?[]const u8 = null,
    creation_time: ?i64 = null,
    last_modified_time: ?i64 = null,
    latest_flywheel_iteration: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .flywheel_arn = "FlywheelArn",
            .active_model_arn = "ActiveModelArn",
            .data_access_role_arn = "DataAccessRoleArn",
            .task_config = "TaskConfig",
            .data_lake_s3_uri = "DataLakeS3Uri",
            .data_security_config = "DataSecurityConfig",
            .status = "Status",
            .model_type = "ModelType",
            .message = "Message",
            .creation_time = "CreationTime",
            .last_modified_time = "LastModifiedTime",
            .latest_flywheel_iteration = "LatestFlywheelIteration",
        };
        return @field(mappings, field_name);
    }
};

pub const DataSecurityConfig = struct {
    model_kms_key_id: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    data_lake_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .model_kms_key_id = "ModelKmsKeyId",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .data_lake_kms_key_id = "DataLakeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfig = struct {
    security_group_ids: [][]const u8,
    subnets: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .security_group_ids = "SecurityGroupIds",
            .subnets = "Subnets",
        };
        return @field(mappings, field_name);
    }
};

pub const TaskConfig = struct {
    language_code: []const u8,
    document_classification_config: ?DocumentClassificationConfig = null,
    entity_recognition_config: ?EntityRecognitionConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .language_code = "LanguageCode",
            .document_classification_config = "DocumentClassificationConfig",
            .entity_recognition_config = "EntityRecognitionConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognitionConfig = struct {
    entity_types: []EntityTypesListItem,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .entity_types = "EntityTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityTypesListItem = struct {
    type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassificationConfig = struct {
    mode: []const u8,
    labels: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .mode = "Mode",
            .labels = "Labels",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const OutputDataConfig = struct {
    s3_uri: []const u8,
    kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const InputDataConfig = struct {
    s3_uri: []const u8,
    input_format: ?[]const u8 = null,
    document_reader_config: ?DocumentReaderConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .input_format = "InputFormat",
            .document_reader_config = "DocumentReaderConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentReaderConfig = struct {
    document_read_action: []const u8,
    document_read_mode: ?[]const u8 = null,
    feature_types: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .document_read_action = "DocumentReadAction",
            .document_read_mode = "DocumentReadMode",
            .feature_types = "FeatureTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const RedactionConfig = struct {
    pii_entity_types: ?[][]const u8 = null,
    mask_mode: ?[]const u8 = null,
    mask_character: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .pii_entity_types = "PiiEntityTypes",
            .mask_mode = "MaskMode",
            .mask_character = "MaskCharacter",
        };
        return @field(mappings, field_name);
    }
};

pub const TopicsDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    number_of_topics: ?i64 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .number_of_topics = "NumberOfTopics",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetedSentimentDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const SentimentDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const PiiEntitiesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?PiiOutputDataConfig = null,
    redaction_config: ?RedactionConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    mode: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .redaction_config = "RedactionConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .mode = "Mode",
        };
        return @field(mappings, field_name);
    }
};

pub const PiiOutputDataConfig = struct {
    s3_uri: []const u8,
    kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const KeyPhrasesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const FlywheelIterationProperties = struct {
    flywheel_arn: ?[]const u8 = null,
    flywheel_iteration_id: ?[]const u8 = null,
    creation_time: ?i64 = null,
    end_time: ?i64 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    evaluated_model_arn: ?[]const u8 = null,
    evaluated_model_metrics: ?FlywheelModelEvaluationMetrics = null,
    trained_model_arn: ?[]const u8 = null,
    trained_model_metrics: ?FlywheelModelEvaluationMetrics = null,
    evaluation_manifest_s3_prefix: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .flywheel_arn = "FlywheelArn",
            .flywheel_iteration_id = "FlywheelIterationId",
            .creation_time = "CreationTime",
            .end_time = "EndTime",
            .status = "Status",
            .message = "Message",
            .evaluated_model_arn = "EvaluatedModelArn",
            .evaluated_model_metrics = "EvaluatedModelMetrics",
            .trained_model_arn = "TrainedModelArn",
            .trained_model_metrics = "TrainedModelMetrics",
            .evaluation_manifest_s3_prefix = "EvaluationManifestS3Prefix",
        };
        return @field(mappings, field_name);
    }
};

pub const FlywheelModelEvaluationMetrics = struct {
    average_f1_score: ?f64 = null,
    average_precision: ?f64 = null,
    average_recall: ?f64 = null,
    average_accuracy: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .average_f1_score = "AverageF1Score",
            .average_precision = "AveragePrecision",
            .average_recall = "AverageRecall",
            .average_accuracy = "AverageAccuracy",
        };
        return @field(mappings, field_name);
    }
};

pub const EventsDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    target_event_types: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .target_event_types = "TargetEventTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerProperties = struct {
    entity_recognizer_arn: ?[]const u8 = null,
    language_code: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    training_start_time: ?i64 = null,
    training_end_time: ?i64 = null,
    input_data_config: ?EntityRecognizerInputDataConfig = null,
    recognizer_metadata: ?EntityRecognizerMetadata = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    model_kms_key_id: ?[]const u8 = null,
    version_name: ?[]const u8 = null,
    source_model_arn: ?[]const u8 = null,
    flywheel_arn: ?[]const u8 = null,
    output_data_config: ?EntityRecognizerOutputDataConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .entity_recognizer_arn = "EntityRecognizerArn",
            .language_code = "LanguageCode",
            .status = "Status",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .training_start_time = "TrainingStartTime",
            .training_end_time = "TrainingEndTime",
            .input_data_config = "InputDataConfig",
            .recognizer_metadata = "RecognizerMetadata",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .model_kms_key_id = "ModelKmsKeyId",
            .version_name = "VersionName",
            .source_model_arn = "SourceModelArn",
            .flywheel_arn = "FlywheelArn",
            .output_data_config = "OutputDataConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerOutputDataConfig = struct {
    flywheel_stats_s3_prefix: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .flywheel_stats_s3_prefix = "FlywheelStatsS3Prefix",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerMetadata = struct {
    number_of_trained_documents: ?i64 = null,
    number_of_test_documents: ?i64 = null,
    evaluation_metrics: ?EntityRecognizerEvaluationMetrics = null,
    entity_types: ?[]EntityRecognizerMetadataEntityTypesListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .number_of_trained_documents = "NumberOfTrainedDocuments",
            .number_of_test_documents = "NumberOfTestDocuments",
            .evaluation_metrics = "EvaluationMetrics",
            .entity_types = "EntityTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerMetadataEntityTypesListItem = struct {
    type: ?[]const u8 = null,
    evaluation_metrics: ?EntityTypesEvaluationMetrics = null,
    number_of_train_mentions: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .evaluation_metrics = "EvaluationMetrics",
            .number_of_train_mentions = "NumberOfTrainMentions",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityTypesEvaluationMetrics = struct {
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerEvaluationMetrics = struct {
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerInputDataConfig = struct {
    data_format: ?[]const u8 = null,
    entity_types: []EntityTypesListItem,
    documents: ?EntityRecognizerDocuments = null,
    annotations: ?EntityRecognizerAnnotations = null,
    entity_list: ?EntityRecognizerEntityList = null,
    augmented_manifests: ?[]AugmentedManifestsListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_format = "DataFormat",
            .entity_types = "EntityTypes",
            .documents = "Documents",
            .annotations = "Annotations",
            .entity_list = "EntityList",
            .augmented_manifests = "AugmentedManifests",
        };
        return @field(mappings, field_name);
    }
};

pub const AugmentedManifestsListItem = struct {
    s3_uri: []const u8,
    split: ?[]const u8 = null,
    attribute_names: [][]const u8,
    annotation_data_s3_uri: ?[]const u8 = null,
    source_documents_s3_uri: ?[]const u8 = null,
    document_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .split = "Split",
            .attribute_names = "AttributeNames",
            .annotation_data_s3_uri = "AnnotationDataS3Uri",
            .source_documents_s3_uri = "SourceDocumentsS3Uri",
            .document_type = "DocumentType",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerEntityList = struct {
    s3_uri: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerAnnotations = struct {
    s3_uri: []const u8,
    test_s3_uri: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .test_s3_uri = "TestS3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerDocuments = struct {
    s3_uri: []const u8,
    test_s3_uri: ?[]const u8 = null,
    input_format: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .test_s3_uri = "TestS3Uri",
            .input_format = "InputFormat",
        };
        return @field(mappings, field_name);
    }
};

pub const EntitiesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    entity_recognizer_arn: ?[]const u8 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    flywheel_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .entity_recognizer_arn = "EntityRecognizerArn",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .flywheel_arn = "FlywheelArn",
        };
        return @field(mappings, field_name);
    }
};

pub const EndpointProperties = struct {
    endpoint_arn: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    model_arn: ?[]const u8 = null,
    desired_model_arn: ?[]const u8 = null,
    desired_inference_units: ?i64 = null,
    current_inference_units: ?i64 = null,
    creation_time: ?i64 = null,
    last_modified_time: ?i64 = null,
    data_access_role_arn: ?[]const u8 = null,
    desired_data_access_role_arn: ?[]const u8 = null,
    flywheel_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .endpoint_arn = "EndpointArn",
            .status = "Status",
            .message = "Message",
            .model_arn = "ModelArn",
            .desired_model_arn = "DesiredModelArn",
            .desired_inference_units = "DesiredInferenceUnits",
            .current_inference_units = "CurrentInferenceUnits",
            .creation_time = "CreationTime",
            .last_modified_time = "LastModifiedTime",
            .data_access_role_arn = "DataAccessRoleArn",
            .desired_data_access_role_arn = "DesiredDataAccessRoleArn",
            .flywheel_arn = "FlywheelArn",
        };
        return @field(mappings, field_name);
    }
};

pub const DominantLanguageDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierProperties = struct {
    document_classifier_arn: ?[]const u8 = null,
    language_code: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    training_start_time: ?i64 = null,
    training_end_time: ?i64 = null,
    input_data_config: ?DocumentClassifierInputDataConfig = null,
    output_data_config: ?DocumentClassifierOutputDataConfig = null,
    classifier_metadata: ?ClassifierMetadata = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    mode: ?[]const u8 = null,
    model_kms_key_id: ?[]const u8 = null,
    version_name: ?[]const u8 = null,
    source_model_arn: ?[]const u8 = null,
    flywheel_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .document_classifier_arn = "DocumentClassifierArn",
            .language_code = "LanguageCode",
            .status = "Status",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .training_start_time = "TrainingStartTime",
            .training_end_time = "TrainingEndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .classifier_metadata = "ClassifierMetadata",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .mode = "Mode",
            .model_kms_key_id = "ModelKmsKeyId",
            .version_name = "VersionName",
            .source_model_arn = "SourceModelArn",
            .flywheel_arn = "FlywheelArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ClassifierMetadata = struct {
    number_of_labels: ?i64 = null,
    number_of_trained_documents: ?i64 = null,
    number_of_test_documents: ?i64 = null,
    evaluation_metrics: ?ClassifierEvaluationMetrics = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .number_of_labels = "NumberOfLabels",
            .number_of_trained_documents = "NumberOfTrainedDocuments",
            .number_of_test_documents = "NumberOfTestDocuments",
            .evaluation_metrics = "EvaluationMetrics",
        };
        return @field(mappings, field_name);
    }
};

pub const ClassifierEvaluationMetrics = struct {
    accuracy: ?f64 = null,
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,
    micro_precision: ?f64 = null,
    micro_recall: ?f64 = null,
    micro_f1_score: ?f64 = null,
    hamming_loss: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .accuracy = "Accuracy",
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
            .micro_precision = "MicroPrecision",
            .micro_recall = "MicroRecall",
            .micro_f1_score = "MicroF1Score",
            .hamming_loss = "HammingLoss",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierOutputDataConfig = struct {
    s3_uri: ?[]const u8 = null,
    kms_key_id: ?[]const u8 = null,
    flywheel_stats_s3_prefix: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
            .flywheel_stats_s3_prefix = "FlywheelStatsS3Prefix",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierInputDataConfig = struct {
    data_format: ?[]const u8 = null,
    s3_uri: ?[]const u8 = null,
    test_s3_uri: ?[]const u8 = null,
    label_delimiter: ?[]const u8 = null,
    augmented_manifests: ?[]AugmentedManifestsListItem = null,
    document_type: ?[]const u8 = null,
    documents: ?DocumentClassifierDocuments = null,
    document_reader_config: ?DocumentReaderConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_format = "DataFormat",
            .s3_uri = "S3Uri",
            .test_s3_uri = "TestS3Uri",
            .label_delimiter = "LabelDelimiter",
            .augmented_manifests = "AugmentedManifests",
            .document_type = "DocumentType",
            .documents = "Documents",
            .document_reader_config = "DocumentReaderConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierDocuments = struct {
    s3_uri: []const u8,
    test_s3_uri: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .test_s3_uri = "TestS3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassificationJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_arn: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    document_classifier_arn: ?[]const u8 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    flywheel_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_arn = "JobArn",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .document_classifier_arn = "DocumentClassifierArn",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .flywheel_arn = "FlywheelArn",
        };
        return @field(mappings, field_name);
    }
};

pub const DatasetProperties = struct {
    dataset_arn: ?[]const u8 = null,
    dataset_name: ?[]const u8 = null,
    dataset_type: ?[]const u8 = null,
    dataset_s3_uri: ?[]const u8 = null,
    description: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    number_of_documents: ?i64 = null,
    creation_time: ?i64 = null,
    end_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .dataset_arn = "DatasetArn",
            .dataset_name = "DatasetName",
            .dataset_type = "DatasetType",
            .dataset_s3_uri = "DatasetS3Uri",
            .description = "Description",
            .status = "Status",
            .message = "Message",
            .number_of_documents = "NumberOfDocuments",
            .creation_time = "CreationTime",
            .end_time = "EndTime",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetedSentimentEntity = struct {
    descriptive_mention_index: ?[]i64 = null,
    mentions: ?[]TargetedSentimentMention = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .descriptive_mention_index = "DescriptiveMentionIndex",
            .mentions = "Mentions",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetedSentimentMention = struct {
    score: ?f32 = null,
    group_score: ?f32 = null,
    text: ?[]const u8 = null,
    type: ?[]const u8 = null,
    mention_sentiment: ?MentionSentiment = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .score = "Score",
            .group_score = "GroupScore",
            .text = "Text",
            .type = "Type",
            .mention_sentiment = "MentionSentiment",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
        };
        return @field(mappings, field_name);
    }
};

pub const MentionSentiment = struct {
    sentiment: ?[]const u8 = null,
    sentiment_score: ?SentimentScore = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .sentiment = "Sentiment",
            .sentiment_score = "SentimentScore",
        };
        return @field(mappings, field_name);
    }
};

pub const SentimentScore = struct {
    positive: ?f32 = null,
    negative: ?f32 = null,
    neutral: ?f32 = null,
    mixed: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .positive = "Positive",
            .negative = "Negative",
            .neutral = "Neutral",
            .mixed = "Mixed",
        };
        return @field(mappings, field_name);
    }
};

pub const SyntaxToken = struct {
    token_id: ?i64 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    part_of_speech: ?PartOfSpeechTag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .token_id = "TokenId",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .part_of_speech = "PartOfSpeech",
        };
        return @field(mappings, field_name);
    }
};

pub const PartOfSpeechTag = struct {
    tag: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .tag = "Tag",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const KeyPhrase = struct {
    score: ?f32 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .score = "Score",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
        };
        return @field(mappings, field_name);
    }
};

pub const ErrorsListItem = struct {
    page: ?i64 = null,
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .page = "Page",
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentTypeListItem = struct {
    page: ?i64 = null,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .page = "Page",
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentMetadata = struct {
    pages: ?i64 = null,
    extracted_characters: ?[]ExtractedCharactersListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .pages = "Pages",
            .extracted_characters = "ExtractedCharacters",
        };
        return @field(mappings, field_name);
    }
};

pub const ExtractedCharactersListItem = struct {
    page: ?i64 = null,
    count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .page = "Page",
            .count = "Count",
        };
        return @field(mappings, field_name);
    }
};

pub const Entity = struct {
    score: ?f32 = null,
    type: ?[]const u8 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    block_references: ?[]BlockReference = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .score = "Score",
            .type = "Type",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .block_references = "BlockReferences",
        };
        return @field(mappings, field_name);
    }
};

pub const BlockReference = struct {
    block_id: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    child_blocks: ?[]ChildBlock = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .block_id = "BlockId",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .child_blocks = "ChildBlocks",
        };
        return @field(mappings, field_name);
    }
};

pub const ChildBlock = struct {
    child_block_id: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .child_block_id = "ChildBlockId",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
        };
        return @field(mappings, field_name);
    }
};

pub const DominantLanguage = struct {
    language_code: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .language_code = "LanguageCode",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const BatchItemError = struct {
    index: ?i64 = null,
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .index = "Index",
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};
