const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-10-30";
pub const sdk_id: []const u8 = "ComprehendMedical";
pub const arn_namespace: ?[]const u8 = "comprehendmedical";
pub const endpoint_prefix: []const u8 = "comprehendmedical";
pub const sigv4_name: []const u8 = "comprehendmedical";
pub const name: []const u8 = "ComprehendMedical_20181030";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-10-30",
    sdk_id: []const u8 = "ComprehendMedical",
    arn_namespace: ?[]const u8 = "comprehendmedical",
    endpoint_prefix: []const u8 = "comprehendmedical",
    sigv4_name: []const u8 = "comprehendmedical",
    name: []const u8 = "ComprehendMedical_20181030",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const describe_entities_detection_v2_job: struct {
    action_name: []const u8 = "DescribeEntitiesDetectionV2Job",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_entities_detection_v2_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_entities_detection_v2_job };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties: ?ComprehendMedicalAsyncJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties = "ComprehendMedicalAsyncJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_icd10cm_inference_job: struct {
    action_name: []const u8 = "DescribeICD10CMInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_icd10cm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_icd10cm_inference_job };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties: ?ComprehendMedicalAsyncJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties = "ComprehendMedicalAsyncJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_phi_detection_job: struct {
    action_name: []const u8 = "DescribePHIDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_phi_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_phi_detection_job };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties: ?ComprehendMedicalAsyncJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties = "ComprehendMedicalAsyncJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_rx_norm_inference_job: struct {
    action_name: []const u8 = "DescribeRxNormInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_rx_norm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_rx_norm_inference_job };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties: ?ComprehendMedicalAsyncJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties = "ComprehendMedicalAsyncJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_snomedct_inference_job: struct {
    action_name: []const u8 = "DescribeSNOMEDCTInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_snomedct_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_snomedct_inference_job };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties: ?ComprehendMedicalAsyncJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties = "ComprehendMedicalAsyncJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const detect_entities: struct {
    action_name: []const u8 = "DetectEntities",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_entities) } {
            return .{ .service_metadata = service_metadata, .action = detect_entities };
        }
    },
    Response: type = struct {
        entities: []Entity,
        unmapped_attributes: ?[]UnmappedAttribute = null,
        pagination_token: ?[]const u8 = null,
        model_version: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .unmapped_attributes = "UnmappedAttributes",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const detect_entities_v2: struct {
    action_name: []const u8 = "DetectEntitiesV2",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_entities_v2) } {
            return .{ .service_metadata = service_metadata, .action = detect_entities_v2 };
        }
    },
    Response: type = struct {
        entities: []Entity,
        unmapped_attributes: ?[]UnmappedAttribute = null,
        pagination_token: ?[]const u8 = null,
        model_version: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .unmapped_attributes = "UnmappedAttributes",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const detect_phi: struct {
    action_name: []const u8 = "DetectPHI",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_phi) } {
            return .{ .service_metadata = service_metadata, .action = detect_phi };
        }
    },
    Response: type = struct {
        entities: []Entity,
        pagination_token: ?[]const u8 = null,
        model_version: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const infer_icd10cm: struct {
    action_name: []const u8 = "InferICD10CM",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(infer_icd10cm) } {
            return .{ .service_metadata = service_metadata, .action = infer_icd10cm };
        }
    },
    Response: type = struct {
        entities: []struct {
            id: ?i64 = null,
            text: ?[]const u8 = null,
            category: ?[]const u8 = null,
            type: ?[]const u8 = null,
            score: ?f32 = null,
            begin_offset: ?i64 = null,
            end_offset: ?i64 = null,
            attributes: ?[]struct {
                type: ?[]const u8 = null,
                score: ?f32 = null,
                relationship_score: ?f32 = null,
                id: ?i64 = null,
                begin_offset: ?i64 = null,
                end_offset: ?i64 = null,
                text: ?[]const u8 = null,
                traits: ?[]ICD10CMTrait = null,
                category: ?[]const u8 = null,
                relationship_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .type = "Type",
                        .score = "Score",
                        .relationship_score = "RelationshipScore",
                        .id = "Id",
                        .begin_offset = "BeginOffset",
                        .end_offset = "EndOffset",
                        .text = "Text",
                        .traits = "Traits",
                        .category = "Category",
                        .relationship_type = "RelationshipType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            traits: ?[]ICD10CMTrait = null,
            icd10cm_concepts: ?[]struct {
                description: ?[]const u8 = null,
                code: ?[]const u8 = null,
                score: ?f32 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .description = "Description",
                        .code = "Code",
                        .score = "Score",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .text = "Text",
                    .category = "Category",
                    .type = "Type",
                    .score = "Score",
                    .begin_offset = "BeginOffset",
                    .end_offset = "EndOffset",
                    .attributes = "Attributes",
                    .traits = "Traits",
                    .icd10cm_concepts = "ICD10CMConcepts",
                };
                return @field(mappings, field_name);
            }
        },
        pagination_token: ?[]const u8 = null,
        model_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const infer_rx_norm: struct {
    action_name: []const u8 = "InferRxNorm",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(infer_rx_norm) } {
            return .{ .service_metadata = service_metadata, .action = infer_rx_norm };
        }
    },
    Response: type = struct {
        entities: []struct {
            id: ?i64 = null,
            text: ?[]const u8 = null,
            category: ?[]const u8 = null,
            type: ?[]const u8 = null,
            score: ?f32 = null,
            begin_offset: ?i64 = null,
            end_offset: ?i64 = null,
            attributes: ?[]struct {
                type: ?[]const u8 = null,
                score: ?f32 = null,
                relationship_score: ?f32 = null,
                id: ?i64 = null,
                begin_offset: ?i64 = null,
                end_offset: ?i64 = null,
                text: ?[]const u8 = null,
                traits: ?[]RxNormTrait = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .type = "Type",
                        .score = "Score",
                        .relationship_score = "RelationshipScore",
                        .id = "Id",
                        .begin_offset = "BeginOffset",
                        .end_offset = "EndOffset",
                        .text = "Text",
                        .traits = "Traits",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            traits: ?[]RxNormTrait = null,
            rx_norm_concepts: ?[]struct {
                description: ?[]const u8 = null,
                code: ?[]const u8 = null,
                score: ?f32 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .description = "Description",
                        .code = "Code",
                        .score = "Score",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .text = "Text",
                    .category = "Category",
                    .type = "Type",
                    .score = "Score",
                    .begin_offset = "BeginOffset",
                    .end_offset = "EndOffset",
                    .attributes = "Attributes",
                    .traits = "Traits",
                    .rx_norm_concepts = "RxNormConcepts",
                };
                return @field(mappings, field_name);
            }
        },
        pagination_token: ?[]const u8 = null,
        model_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const infer_snomedct: struct {
    action_name: []const u8 = "InferSNOMEDCT",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(infer_snomedct) } {
            return .{ .service_metadata = service_metadata, .action = infer_snomedct };
        }
    },
    Response: type = struct {
        entities: []struct {
            id: ?i64 = null,
            text: ?[]const u8 = null,
            category: ?[]const u8 = null,
            type: ?[]const u8 = null,
            score: ?f32 = null,
            begin_offset: ?i64 = null,
            end_offset: ?i64 = null,
            attributes: ?[]struct {
                category: ?[]const u8 = null,
                type: ?[]const u8 = null,
                score: ?f32 = null,
                relationship_score: ?f32 = null,
                relationship_type: ?[]const u8 = null,
                id: ?i64 = null,
                begin_offset: ?i64 = null,
                end_offset: ?i64 = null,
                text: ?[]const u8 = null,
                traits: ?[]SNOMEDCTTrait = null,
                snomedct_concepts: ?[]SNOMEDCTConcept = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .category = "Category",
                        .type = "Type",
                        .score = "Score",
                        .relationship_score = "RelationshipScore",
                        .relationship_type = "RelationshipType",
                        .id = "Id",
                        .begin_offset = "BeginOffset",
                        .end_offset = "EndOffset",
                        .text = "Text",
                        .traits = "Traits",
                        .snomedct_concepts = "SNOMEDCTConcepts",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            traits: ?[]SNOMEDCTTrait = null,
            snomedct_concepts: ?[]SNOMEDCTConcept = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .text = "Text",
                    .category = "Category",
                    .type = "Type",
                    .score = "Score",
                    .begin_offset = "BeginOffset",
                    .end_offset = "EndOffset",
                    .attributes = "Attributes",
                    .traits = "Traits",
                    .snomedct_concepts = "SNOMEDCTConcepts",
                };
                return @field(mappings, field_name);
            }
        },
        pagination_token: ?[]const u8 = null,
        model_version: ?[]const u8 = null,
        snomedct_details: ?struct {
            edition: ?[]const u8 = null,
            language: ?[]const u8 = null,
            version_date: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .edition = "Edition",
                    .language = "Language",
                    .version_date = "VersionDate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        characters: ?struct {
            original_text_characters: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .original_text_characters = "OriginalTextCharacters",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
                .pagination_token = "PaginationToken",
                .model_version = "ModelVersion",
                .snomedct_details = "SNOMEDCTDetails",
                .characters = "Characters",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidEncoding,
        InvalidRequest,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
    },
} = .{};
pub const list_entities_detection_v2_jobs: struct {
    action_name: []const u8 = "ListEntitiesDetectionV2Jobs",
    Request: type = struct {
        filter: ?ComprehendMedicalAsyncJobFilter = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entities_detection_v2_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_entities_detection_v2_jobs };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties_list: ?[]ComprehendMedicalAsyncJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties_list = "ComprehendMedicalAsyncJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
        Validation,
    },
} = .{};
pub const list_icd10cm_inference_jobs: struct {
    action_name: []const u8 = "ListICD10CMInferenceJobs",
    Request: type = struct {
        filter: ?ComprehendMedicalAsyncJobFilter = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_icd10cm_inference_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_icd10cm_inference_jobs };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties_list: ?[]ComprehendMedicalAsyncJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties_list = "ComprehendMedicalAsyncJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
        Validation,
    },
} = .{};
pub const list_phi_detection_jobs: struct {
    action_name: []const u8 = "ListPHIDetectionJobs",
    Request: type = struct {
        filter: ?ComprehendMedicalAsyncJobFilter = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_phi_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_phi_detection_jobs };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties_list: ?[]ComprehendMedicalAsyncJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties_list = "ComprehendMedicalAsyncJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
        Validation,
    },
} = .{};
pub const list_rx_norm_inference_jobs: struct {
    action_name: []const u8 = "ListRxNormInferenceJobs",
    Request: type = struct {
        filter: ?ComprehendMedicalAsyncJobFilter = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_rx_norm_inference_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_rx_norm_inference_jobs };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties_list: ?[]ComprehendMedicalAsyncJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties_list = "ComprehendMedicalAsyncJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
        Validation,
    },
} = .{};
pub const list_snomedct_inference_jobs: struct {
    action_name: []const u8 = "ListSNOMEDCTInferenceJobs",
    Request: type = struct {
        filter: ?ComprehendMedicalAsyncJobFilter = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_snomedct_inference_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_snomedct_inference_jobs };
        }
    },
    Response: type = struct {
        comprehend_medical_async_job_properties_list: ?[]ComprehendMedicalAsyncJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .comprehend_medical_async_job_properties_list = "ComprehendMedicalAsyncJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
        Validation,
    },
} = .{};
pub const start_entities_detection_v2_job: struct {
    action_name: []const u8 = "StartEntitiesDetectionV2Job",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        kms_key: ?[]const u8 = null,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .kms_key = "KMSKey",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_entities_detection_v2_job) } {
            return .{ .service_metadata = service_metadata, .action = start_entities_detection_v2_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const start_icd10cm_inference_job: struct {
    action_name: []const u8 = "StartICD10CMInferenceJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        kms_key: ?[]const u8 = null,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .kms_key = "KMSKey",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_icd10cm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = start_icd10cm_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const start_phi_detection_job: struct {
    action_name: []const u8 = "StartPHIDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        kms_key: ?[]const u8 = null,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .kms_key = "KMSKey",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_phi_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_phi_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const start_rx_norm_inference_job: struct {
    action_name: []const u8 = "StartRxNormInferenceJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        kms_key: ?[]const u8 = null,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .kms_key = "KMSKey",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_rx_norm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = start_rx_norm_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const start_snomedct_inference_job: struct {
    action_name: []const u8 = "StartSNOMEDCTInferenceJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        kms_key: ?[]const u8 = null,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .kms_key = "KMSKey",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_snomedct_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = start_snomedct_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const stop_entities_detection_v2_job: struct {
    action_name: []const u8 = "StopEntitiesDetectionV2Job",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_entities_detection_v2_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_entities_detection_v2_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const stop_icd10cm_inference_job: struct {
    action_name: []const u8 = "StopICD10CMInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_icd10cm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_icd10cm_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const stop_phi_detection_job: struct {
    action_name: []const u8 = "StopPHIDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_phi_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_phi_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const stop_rx_norm_inference_job: struct {
    action_name: []const u8 = "StopRxNormInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_rx_norm_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_rx_norm_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const stop_snomedct_inference_job: struct {
    action_name: []const u8 = "StopSNOMEDCTInferenceJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_snomedct_inference_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_snomedct_inference_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};

pub const OutputDataConfig = struct {
    s3_bucket: []const u8,
    s3_key: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_bucket = "S3Bucket",
            .s3_key = "S3Key",
        };
        return @field(mappings, field_name);
    }
};

pub const InputDataConfig = struct {
    s3_bucket: []const u8,
    s3_key: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_bucket = "S3Bucket",
            .s3_key = "S3Key",
        };
        return @field(mappings, field_name);
    }
};

pub const ComprehendMedicalAsyncJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    expiration_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    manifest_file_path: ?[]const u8 = null,
    kms_key: ?[]const u8 = null,
    model_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .expiration_time = "ExpirationTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .manifest_file_path = "ManifestFilePath",
            .kms_key = "KMSKey",
            .model_version = "ModelVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const ComprehendMedicalAsyncJobFilter = struct {
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    submit_time_before: ?i64 = null,
    submit_time_after: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_name = "JobName",
            .job_status = "JobStatus",
            .submit_time_before = "SubmitTimeBefore",
            .submit_time_after = "SubmitTimeAfter",
        };
        return @field(mappings, field_name);
    }
};

pub const SNOMEDCTConcept = struct {
    description: ?[]const u8 = null,
    code: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .description = "Description",
            .code = "Code",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const SNOMEDCTTrait = struct {
    name: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const RxNormTrait = struct {
    name: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const ICD10CMTrait = struct {
    name: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const Entity = struct {
    id: ?i64 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    score: ?f32 = null,
    text: ?[]const u8 = null,
    category: ?[]const u8 = null,
    type: ?[]const u8 = null,
    traits: ?[]Trait = null,
    attributes: ?[]Attribute = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .score = "Score",
            .text = "Text",
            .category = "Category",
            .type = "Type",
            .traits = "Traits",
            .attributes = "Attributes",
        };
        return @field(mappings, field_name);
    }
};

pub const Attribute = struct {
    type: ?[]const u8 = null,
    score: ?f32 = null,
    relationship_score: ?f32 = null,
    relationship_type: ?[]const u8 = null,
    id: ?i64 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    text: ?[]const u8 = null,
    category: ?[]const u8 = null,
    traits: ?[]Trait = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .score = "Score",
            .relationship_score = "RelationshipScore",
            .relationship_type = "RelationshipType",
            .id = "Id",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .text = "Text",
            .category = "Category",
            .traits = "Traits",
        };
        return @field(mappings, field_name);
    }
};

pub const Trait = struct {
    name: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const UnmappedAttribute = struct {
    type: ?[]const u8 = null,
    attribute: ?Attribute = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .attribute = "Attribute",
        };
        return @field(mappings, field_name);
    }
};
