const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2015-08-04";
pub const sdk_id: []const u8 = "Firehose";
pub const arn_namespace: ?[]const u8 = "firehose";
pub const endpoint_prefix: []const u8 = "firehose";
pub const sigv4_name: []const u8 = "firehose";
pub const name: []const u8 = "Firehose_20150804";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2015-08-04",
    sdk_id: []const u8 = "Firehose",
    arn_namespace: ?[]const u8 = "firehose",
    endpoint_prefix: []const u8 = "firehose",
    sigv4_name: []const u8 = "firehose",
    name: []const u8 = "Firehose_20150804",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const create_delivery_stream: struct {
    action_name: []const u8 = "CreateDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        delivery_stream_type: ?[]const u8 = null,
        kinesis_stream_source_configuration: ?struct {
            kinesis_stream_arn: []const u8,
            role_arn: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .kinesis_stream_arn = "KinesisStreamARN",
                    .role_arn = "RoleARN",
                };
                return @field(mappings, field_name);
            }
        } = null,
        delivery_stream_encryption_configuration_input: ?DeliveryStreamEncryptionConfigurationInput = null,
        s3_destination_configuration: ?S3DestinationConfiguration = null,
        extended_s3_destination_configuration: ?struct {
            role_arn: []const u8,
            bucket_arn: []const u8,
            prefix: ?[]const u8 = null,
            error_output_prefix: ?[]const u8 = null,
            buffering_hints: ?BufferingHints = null,
            compression_format: ?[]const u8 = null,
            encryption_configuration: ?EncryptionConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            processing_configuration: ?ProcessingConfiguration = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_backup_configuration: ?S3DestinationConfiguration = null,
            data_format_conversion_configuration: ?DataFormatConversionConfiguration = null,
            dynamic_partitioning_configuration: ?DynamicPartitioningConfiguration = null,
            file_extension: ?[]const u8 = null,
            custom_time_zone: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .bucket_arn = "BucketARN",
                    .prefix = "Prefix",
                    .error_output_prefix = "ErrorOutputPrefix",
                    .buffering_hints = "BufferingHints",
                    .compression_format = "CompressionFormat",
                    .encryption_configuration = "EncryptionConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .processing_configuration = "ProcessingConfiguration",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_backup_configuration = "S3BackupConfiguration",
                    .data_format_conversion_configuration = "DataFormatConversionConfiguration",
                    .dynamic_partitioning_configuration = "DynamicPartitioningConfiguration",
                    .file_extension = "FileExtension",
                    .custom_time_zone = "CustomTimeZone",
                };
                return @field(mappings, field_name);
            }
        } = null,
        redshift_destination_configuration: ?struct {
            role_arn: []const u8,
            cluster_jdbcurl: []const u8,
            copy_command: CopyCommand,
            username: []const u8,
            password: []const u8,
            retry_options: ?RedshiftRetryOptions = null,
            s3_configuration: S3DestinationConfiguration,
            processing_configuration: ?ProcessingConfiguration = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_backup_configuration: ?S3DestinationConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .cluster_jdbcurl = "ClusterJDBCURL",
                    .copy_command = "CopyCommand",
                    .username = "Username",
                    .password = "Password",
                    .retry_options = "RetryOptions",
                    .s3_configuration = "S3Configuration",
                    .processing_configuration = "ProcessingConfiguration",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_backup_configuration = "S3BackupConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        elasticsearch_destination_configuration: ?struct {
            role_arn: []const u8,
            domain_arn: ?[]const u8 = null,
            cluster_endpoint: ?[]const u8 = null,
            index_name: []const u8,
            type_name: ?[]const u8 = null,
            index_rotation_period: ?[]const u8 = null,
            buffering_hints: ?ElasticsearchBufferingHints = null,
            retry_options: ?ElasticsearchRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            vpc_configuration: ?VpcConfiguration = null,
            document_id_options: ?DocumentIdOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .domain_arn = "DomainARN",
                    .cluster_endpoint = "ClusterEndpoint",
                    .index_name = "IndexName",
                    .type_name = "TypeName",
                    .index_rotation_period = "IndexRotationPeriod",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .vpc_configuration = "VpcConfiguration",
                    .document_id_options = "DocumentIdOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        amazonopensearchservice_destination_configuration: ?struct {
            role_arn: []const u8,
            domain_arn: ?[]const u8 = null,
            cluster_endpoint: ?[]const u8 = null,
            index_name: []const u8,
            type_name: ?[]const u8 = null,
            index_rotation_period: ?[]const u8 = null,
            buffering_hints: ?AmazonopensearchserviceBufferingHints = null,
            retry_options: ?AmazonopensearchserviceRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            vpc_configuration: ?VpcConfiguration = null,
            document_id_options: ?DocumentIdOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .domain_arn = "DomainARN",
                    .cluster_endpoint = "ClusterEndpoint",
                    .index_name = "IndexName",
                    .type_name = "TypeName",
                    .index_rotation_period = "IndexRotationPeriod",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .vpc_configuration = "VpcConfiguration",
                    .document_id_options = "DocumentIdOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        splunk_destination_configuration: ?struct {
            hec_endpoint: []const u8,
            hec_endpoint_type: []const u8,
            hec_token: []const u8,
            hec_acknowledgment_timeout_in_seconds: ?i64 = null,
            retry_options: ?SplunkRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            buffering_hints: ?SplunkBufferingHints = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .hec_endpoint = "HECEndpoint",
                    .hec_endpoint_type = "HECEndpointType",
                    .hec_token = "HECToken",
                    .hec_acknowledgment_timeout_in_seconds = "HECAcknowledgmentTimeoutInSeconds",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .buffering_hints = "BufferingHints",
                };
                return @field(mappings, field_name);
            }
        } = null,
        http_endpoint_destination_configuration: ?struct {
            endpoint_configuration: HttpEndpointConfiguration,
            buffering_hints: ?HttpEndpointBufferingHints = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            request_configuration: ?HttpEndpointRequestConfiguration = null,
            processing_configuration: ?ProcessingConfiguration = null,
            role_arn: ?[]const u8 = null,
            retry_options: ?HttpEndpointRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .endpoint_configuration = "EndpointConfiguration",
                    .buffering_hints = "BufferingHints",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .request_configuration = "RequestConfiguration",
                    .processing_configuration = "ProcessingConfiguration",
                    .role_arn = "RoleARN",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        tags: ?[]Tag = null,
        amazon_open_search_serverless_destination_configuration: ?struct {
            role_arn: []const u8,
            collection_endpoint: ?[]const u8 = null,
            index_name: []const u8,
            buffering_hints: ?AmazonOpenSearchServerlessBufferingHints = null,
            retry_options: ?AmazonOpenSearchServerlessRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            vpc_configuration: ?VpcConfiguration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .collection_endpoint = "CollectionEndpoint",
                    .index_name = "IndexName",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .vpc_configuration = "VpcConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        msk_source_configuration: ?struct {
            msk_cluster_arn: []const u8,
            topic_name: []const u8,
            authentication_configuration: AuthenticationConfiguration,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .msk_cluster_arn = "MSKClusterARN",
                    .topic_name = "TopicName",
                    .authentication_configuration = "AuthenticationConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        snowflake_destination_configuration: ?struct {
            account_url: []const u8,
            private_key: []const u8,
            key_passphrase: ?[]const u8 = null,
            user: []const u8,
            database: []const u8,
            schema: []const u8,
            table: []const u8,
            snowflake_role_configuration: ?SnowflakeRoleConfiguration = null,
            data_loading_option: ?[]const u8 = null,
            meta_data_column_name: ?[]const u8 = null,
            content_column_name: ?[]const u8 = null,
            snowflake_vpc_configuration: ?SnowflakeVpcConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            processing_configuration: ?ProcessingConfiguration = null,
            role_arn: []const u8,
            retry_options: ?SnowflakeRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_configuration: S3DestinationConfiguration,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .account_url = "AccountUrl",
                    .private_key = "PrivateKey",
                    .key_passphrase = "KeyPassphrase",
                    .user = "User",
                    .database = "Database",
                    .schema = "Schema",
                    .table = "Table",
                    .snowflake_role_configuration = "SnowflakeRoleConfiguration",
                    .data_loading_option = "DataLoadingOption",
                    .meta_data_column_name = "MetaDataColumnName",
                    .content_column_name = "ContentColumnName",
                    .snowflake_vpc_configuration = "SnowflakeVpcConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .processing_configuration = "ProcessingConfiguration",
                    .role_arn = "RoleARN",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_configuration = "S3Configuration",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .delivery_stream_type = "DeliveryStreamType",
                .kinesis_stream_source_configuration = "KinesisStreamSourceConfiguration",
                .delivery_stream_encryption_configuration_input = "DeliveryStreamEncryptionConfigurationInput",
                .s3_destination_configuration = "S3DestinationConfiguration",
                .extended_s3_destination_configuration = "ExtendedS3DestinationConfiguration",
                .redshift_destination_configuration = "RedshiftDestinationConfiguration",
                .elasticsearch_destination_configuration = "ElasticsearchDestinationConfiguration",
                .amazonopensearchservice_destination_configuration = "AmazonopensearchserviceDestinationConfiguration",
                .splunk_destination_configuration = "SplunkDestinationConfiguration",
                .http_endpoint_destination_configuration = "HttpEndpointDestinationConfiguration",
                .tags = "Tags",
                .amazon_open_search_serverless_destination_configuration = "AmazonOpenSearchServerlessDestinationConfiguration",
                .msk_source_configuration = "MSKSourceConfiguration",
                .snowflake_destination_configuration = "SnowflakeDestinationConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = create_delivery_stream };
        }
    },
    Response: type = struct {
        delivery_stream_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_arn = "DeliveryStreamARN",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidKMSResource,
        LimitExceeded,
        ResourceInUse,
    },
} = .{};
pub const delete_delivery_stream: struct {
    action_name: []const u8 = "DeleteDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        allow_force_delete: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .allow_force_delete = "AllowForceDelete",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = delete_delivery_stream };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const describe_delivery_stream: struct {
    action_name: []const u8 = "DescribeDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        limit: ?i64 = null,
        exclusive_start_destination_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .limit = "Limit",
                .exclusive_start_destination_id = "ExclusiveStartDestinationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = describe_delivery_stream };
        }
    },
    Response: type = struct {
        delivery_stream_description: struct {
            delivery_stream_name: []const u8,
            delivery_stream_arn: []const u8,
            delivery_stream_status: []const u8,
            failure_description: ?FailureDescription = null,
            delivery_stream_encryption_configuration: ?struct {
                key_arn: ?[]const u8 = null,
                key_type: ?[]const u8 = null,
                status: ?[]const u8 = null,
                failure_description: ?FailureDescription = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .key_arn = "KeyARN",
                        .key_type = "KeyType",
                        .status = "Status",
                        .failure_description = "FailureDescription",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            delivery_stream_type: []const u8,
            version_id: []const u8,
            create_timestamp: ?i64 = null,
            last_update_timestamp: ?i64 = null,
            source: ?struct {
                kinesis_stream_source_description: ?struct {
                    kinesis_stream_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,
                    delivery_start_timestamp: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .kinesis_stream_arn = "KinesisStreamARN",
                            .role_arn = "RoleARN",
                            .delivery_start_timestamp = "DeliveryStartTimestamp",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                msk_source_description: ?struct {
                    msk_cluster_arn: ?[]const u8 = null,
                    topic_name: ?[]const u8 = null,
                    authentication_configuration: ?AuthenticationConfiguration = null,
                    delivery_start_timestamp: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .msk_cluster_arn = "MSKClusterARN",
                            .topic_name = "TopicName",
                            .authentication_configuration = "AuthenticationConfiguration",
                            .delivery_start_timestamp = "DeliveryStartTimestamp",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .kinesis_stream_source_description = "KinesisStreamSourceDescription",
                        .msk_source_description = "MSKSourceDescription",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            destinations: []struct {
                destination_id: []const u8,
                s3_destination_description: ?S3DestinationDescription = null,
                extended_s3_destination_description: ?struct {
                    role_arn: []const u8,
                    bucket_arn: []const u8,
                    prefix: ?[]const u8 = null,
                    error_output_prefix: ?[]const u8 = null,
                    buffering_hints: BufferingHints,
                    compression_format: []const u8,
                    encryption_configuration: EncryptionConfiguration,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_backup_description: ?S3DestinationDescription = null,
                    data_format_conversion_configuration: ?DataFormatConversionConfiguration = null,
                    dynamic_partitioning_configuration: ?DynamicPartitioningConfiguration = null,
                    file_extension: ?[]const u8 = null,
                    custom_time_zone: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .role_arn = "RoleARN",
                            .bucket_arn = "BucketARN",
                            .prefix = "Prefix",
                            .error_output_prefix = "ErrorOutputPrefix",
                            .buffering_hints = "BufferingHints",
                            .compression_format = "CompressionFormat",
                            .encryption_configuration = "EncryptionConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .processing_configuration = "ProcessingConfiguration",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_backup_description = "S3BackupDescription",
                            .data_format_conversion_configuration = "DataFormatConversionConfiguration",
                            .dynamic_partitioning_configuration = "DynamicPartitioningConfiguration",
                            .file_extension = "FileExtension",
                            .custom_time_zone = "CustomTimeZone",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                redshift_destination_description: ?struct {
                    role_arn: []const u8,
                    cluster_jdbcurl: []const u8,
                    copy_command: CopyCommand,
                    username: []const u8,
                    retry_options: ?RedshiftRetryOptions = null,
                    s3_destination_description: S3DestinationDescription,
                    processing_configuration: ?ProcessingConfiguration = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_backup_description: ?S3DestinationDescription = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .role_arn = "RoleARN",
                            .cluster_jdbcurl = "ClusterJDBCURL",
                            .copy_command = "CopyCommand",
                            .username = "Username",
                            .retry_options = "RetryOptions",
                            .s3_destination_description = "S3DestinationDescription",
                            .processing_configuration = "ProcessingConfiguration",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_backup_description = "S3BackupDescription",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                elasticsearch_destination_description: ?struct {
                    role_arn: ?[]const u8 = null,
                    domain_arn: ?[]const u8 = null,
                    cluster_endpoint: ?[]const u8 = null,
                    index_name: ?[]const u8 = null,
                    type_name: ?[]const u8 = null,
                    index_rotation_period: ?[]const u8 = null,
                    buffering_hints: ?ElasticsearchBufferingHints = null,
                    retry_options: ?ElasticsearchRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    vpc_configuration_description: ?VpcConfigurationDescription = null,
                    document_id_options: ?DocumentIdOptions = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .role_arn = "RoleARN",
                            .domain_arn = "DomainARN",
                            .cluster_endpoint = "ClusterEndpoint",
                            .index_name = "IndexName",
                            .type_name = "TypeName",
                            .index_rotation_period = "IndexRotationPeriod",
                            .buffering_hints = "BufferingHints",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                            .processing_configuration = "ProcessingConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .vpc_configuration_description = "VpcConfigurationDescription",
                            .document_id_options = "DocumentIdOptions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                amazonopensearchservice_destination_description: ?struct {
                    role_arn: ?[]const u8 = null,
                    domain_arn: ?[]const u8 = null,
                    cluster_endpoint: ?[]const u8 = null,
                    index_name: ?[]const u8 = null,
                    type_name: ?[]const u8 = null,
                    index_rotation_period: ?[]const u8 = null,
                    buffering_hints: ?AmazonopensearchserviceBufferingHints = null,
                    retry_options: ?AmazonopensearchserviceRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    vpc_configuration_description: ?VpcConfigurationDescription = null,
                    document_id_options: ?DocumentIdOptions = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .role_arn = "RoleARN",
                            .domain_arn = "DomainARN",
                            .cluster_endpoint = "ClusterEndpoint",
                            .index_name = "IndexName",
                            .type_name = "TypeName",
                            .index_rotation_period = "IndexRotationPeriod",
                            .buffering_hints = "BufferingHints",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                            .processing_configuration = "ProcessingConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .vpc_configuration_description = "VpcConfigurationDescription",
                            .document_id_options = "DocumentIdOptions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                splunk_destination_description: ?struct {
                    hec_endpoint: ?[]const u8 = null,
                    hec_endpoint_type: ?[]const u8 = null,
                    hec_token: ?[]const u8 = null,
                    hec_acknowledgment_timeout_in_seconds: ?i64 = null,
                    retry_options: ?SplunkRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    buffering_hints: ?SplunkBufferingHints = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .hec_endpoint = "HECEndpoint",
                            .hec_endpoint_type = "HECEndpointType",
                            .hec_token = "HECToken",
                            .hec_acknowledgment_timeout_in_seconds = "HECAcknowledgmentTimeoutInSeconds",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                            .processing_configuration = "ProcessingConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .buffering_hints = "BufferingHints",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                http_endpoint_destination_description: ?struct {
                    endpoint_configuration: ?struct {
                        url: ?[]const u8 = null,
                        name: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .url = "Url",
                                .name = "Name",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    buffering_hints: ?HttpEndpointBufferingHints = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    request_configuration: ?HttpEndpointRequestConfiguration = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    role_arn: ?[]const u8 = null,
                    retry_options: ?HttpEndpointRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .endpoint_configuration = "EndpointConfiguration",
                            .buffering_hints = "BufferingHints",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .request_configuration = "RequestConfiguration",
                            .processing_configuration = "ProcessingConfiguration",
                            .role_arn = "RoleARN",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                snowflake_destination_description: ?struct {
                    account_url: ?[]const u8 = null,
                    user: ?[]const u8 = null,
                    database: ?[]const u8 = null,
                    schema: ?[]const u8 = null,
                    table: ?[]const u8 = null,
                    snowflake_role_configuration: ?SnowflakeRoleConfiguration = null,
                    data_loading_option: ?[]const u8 = null,
                    meta_data_column_name: ?[]const u8 = null,
                    content_column_name: ?[]const u8 = null,
                    snowflake_vpc_configuration: ?SnowflakeVpcConfiguration = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    role_arn: ?[]const u8 = null,
                    retry_options: ?SnowflakeRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .account_url = "AccountUrl",
                            .user = "User",
                            .database = "Database",
                            .schema = "Schema",
                            .table = "Table",
                            .snowflake_role_configuration = "SnowflakeRoleConfiguration",
                            .data_loading_option = "DataLoadingOption",
                            .meta_data_column_name = "MetaDataColumnName",
                            .content_column_name = "ContentColumnName",
                            .snowflake_vpc_configuration = "SnowflakeVpcConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .processing_configuration = "ProcessingConfiguration",
                            .role_arn = "RoleARN",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                amazon_open_search_serverless_destination_description: ?struct {
                    role_arn: ?[]const u8 = null,
                    collection_endpoint: ?[]const u8 = null,
                    index_name: ?[]const u8 = null,
                    buffering_hints: ?AmazonOpenSearchServerlessBufferingHints = null,
                    retry_options: ?AmazonOpenSearchServerlessRetryOptions = null,
                    s3_backup_mode: ?[]const u8 = null,
                    s3_destination_description: ?S3DestinationDescription = null,
                    processing_configuration: ?ProcessingConfiguration = null,
                    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
                    vpc_configuration_description: ?VpcConfigurationDescription = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .role_arn = "RoleARN",
                            .collection_endpoint = "CollectionEndpoint",
                            .index_name = "IndexName",
                            .buffering_hints = "BufferingHints",
                            .retry_options = "RetryOptions",
                            .s3_backup_mode = "S3BackupMode",
                            .s3_destination_description = "S3DestinationDescription",
                            .processing_configuration = "ProcessingConfiguration",
                            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                            .vpc_configuration_description = "VpcConfigurationDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .destination_id = "DestinationId",
                        .s3_destination_description = "S3DestinationDescription",
                        .extended_s3_destination_description = "ExtendedS3DestinationDescription",
                        .redshift_destination_description = "RedshiftDestinationDescription",
                        .elasticsearch_destination_description = "ElasticsearchDestinationDescription",
                        .amazonopensearchservice_destination_description = "AmazonopensearchserviceDestinationDescription",
                        .splunk_destination_description = "SplunkDestinationDescription",
                        .http_endpoint_destination_description = "HttpEndpointDestinationDescription",
                        .snowflake_destination_description = "SnowflakeDestinationDescription",
                        .amazon_open_search_serverless_destination_description = "AmazonOpenSearchServerlessDestinationDescription",
                    };
                    return @field(mappings, field_name);
                }
            },
            has_more_destinations: bool,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .delivery_stream_name = "DeliveryStreamName",
                    .delivery_stream_arn = "DeliveryStreamARN",
                    .delivery_stream_status = "DeliveryStreamStatus",
                    .failure_description = "FailureDescription",
                    .delivery_stream_encryption_configuration = "DeliveryStreamEncryptionConfiguration",
                    .delivery_stream_type = "DeliveryStreamType",
                    .version_id = "VersionId",
                    .create_timestamp = "CreateTimestamp",
                    .last_update_timestamp = "LastUpdateTimestamp",
                    .source = "Source",
                    .destinations = "Destinations",
                    .has_more_destinations = "HasMoreDestinations",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_description = "DeliveryStreamDescription",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
    },
} = .{};
pub const list_delivery_streams: struct {
    action_name: []const u8 = "ListDeliveryStreams",
    Request: type = struct {
        limit: ?i64 = null,
        delivery_stream_type: ?[]const u8 = null,
        exclusive_start_delivery_stream_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .limit = "Limit",
                .delivery_stream_type = "DeliveryStreamType",
                .exclusive_start_delivery_stream_name = "ExclusiveStartDeliveryStreamName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_delivery_streams) } {
            return .{ .service_metadata = service_metadata, .action = list_delivery_streams };
        }
    },
    Response: type = struct {
        delivery_stream_names: [][]const u8,
        has_more_delivery_streams: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_names = "DeliveryStreamNames",
                .has_more_delivery_streams = "HasMoreDeliveryStreams",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_tags_for_delivery_stream: struct {
    action_name: []const u8 = "ListTagsForDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        exclusive_start_tag_key: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .exclusive_start_tag_key = "ExclusiveStartTagKey",
                .limit = "Limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_delivery_stream };
        }
    },
    Response: type = struct {
        tags: []Tag,
        has_more_tags: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .has_more_tags = "HasMoreTags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_record: struct {
    action_name: []const u8 = "PutRecord",
    Request: type = struct {
        delivery_stream_name: []const u8,
        record: Record,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .record = "Record",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_record) } {
            return .{ .service_metadata = service_metadata, .action = put_record };
        }
    },
    Response: type = struct {
        record_id: []const u8,
        encrypted: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .record_id = "RecordId",
                .encrypted = "Encrypted",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidKMSResource,
        InvalidSource,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const put_record_batch: struct {
    action_name: []const u8 = "PutRecordBatch",
    Request: type = struct {
        delivery_stream_name: []const u8,
        records: []Record,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .records = "Records",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_record_batch) } {
            return .{ .service_metadata = service_metadata, .action = put_record_batch };
        }
    },
    Response: type = struct {
        failed_put_count: i64,
        encrypted: ?bool = null,
        request_responses: []struct {
            record_id: ?[]const u8 = null,
            error_code: ?[]const u8 = null,
            error_message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .record_id = "RecordId",
                    .error_code = "ErrorCode",
                    .error_message = "ErrorMessage",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failed_put_count = "FailedPutCount",
                .encrypted = "Encrypted",
                .request_responses = "RequestResponses",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidKMSResource,
        InvalidSource,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const start_delivery_stream_encryption: struct {
    action_name: []const u8 = "StartDeliveryStreamEncryption",
    Request: type = struct {
        delivery_stream_name: []const u8,
        delivery_stream_encryption_configuration_input: ?DeliveryStreamEncryptionConfigurationInput = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .delivery_stream_encryption_configuration_input = "DeliveryStreamEncryptionConfigurationInput",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_delivery_stream_encryption) } {
            return .{ .service_metadata = service_metadata, .action = start_delivery_stream_encryption };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidKMSResource,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const stop_delivery_stream_encryption: struct {
    action_name: []const u8 = "StopDeliveryStreamEncryption",
    Request: type = struct {
        delivery_stream_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_delivery_stream_encryption) } {
            return .{ .service_metadata = service_metadata, .action = stop_delivery_stream_encryption };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const tag_delivery_stream: struct {
    action_name: []const u8 = "TagDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = tag_delivery_stream };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const untag_delivery_stream: struct {
    action_name: []const u8 = "UntagDeliveryStream",
    Request: type = struct {
        delivery_stream_name: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_delivery_stream) } {
            return .{ .service_metadata = service_metadata, .action = untag_delivery_stream };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const update_destination: struct {
    action_name: []const u8 = "UpdateDestination",
    Request: type = struct {
        delivery_stream_name: []const u8,
        current_delivery_stream_version_id: []const u8,
        destination_id: []const u8,
        s3_destination_update: ?S3DestinationUpdate = null,
        extended_s3_destination_update: ?struct {
            role_arn: ?[]const u8 = null,
            bucket_arn: ?[]const u8 = null,
            prefix: ?[]const u8 = null,
            error_output_prefix: ?[]const u8 = null,
            buffering_hints: ?BufferingHints = null,
            compression_format: ?[]const u8 = null,
            encryption_configuration: ?EncryptionConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            processing_configuration: ?ProcessingConfiguration = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_backup_update: ?S3DestinationUpdate = null,
            data_format_conversion_configuration: ?DataFormatConversionConfiguration = null,
            dynamic_partitioning_configuration: ?DynamicPartitioningConfiguration = null,
            file_extension: ?[]const u8 = null,
            custom_time_zone: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .bucket_arn = "BucketARN",
                    .prefix = "Prefix",
                    .error_output_prefix = "ErrorOutputPrefix",
                    .buffering_hints = "BufferingHints",
                    .compression_format = "CompressionFormat",
                    .encryption_configuration = "EncryptionConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .processing_configuration = "ProcessingConfiguration",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_backup_update = "S3BackupUpdate",
                    .data_format_conversion_configuration = "DataFormatConversionConfiguration",
                    .dynamic_partitioning_configuration = "DynamicPartitioningConfiguration",
                    .file_extension = "FileExtension",
                    .custom_time_zone = "CustomTimeZone",
                };
                return @field(mappings, field_name);
            }
        } = null,
        redshift_destination_update: ?struct {
            role_arn: ?[]const u8 = null,
            cluster_jdbcurl: ?[]const u8 = null,
            copy_command: ?CopyCommand = null,
            username: ?[]const u8 = null,
            password: ?[]const u8 = null,
            retry_options: ?RedshiftRetryOptions = null,
            s3_update: ?S3DestinationUpdate = null,
            processing_configuration: ?ProcessingConfiguration = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_backup_update: ?S3DestinationUpdate = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .cluster_jdbcurl = "ClusterJDBCURL",
                    .copy_command = "CopyCommand",
                    .username = "Username",
                    .password = "Password",
                    .retry_options = "RetryOptions",
                    .s3_update = "S3Update",
                    .processing_configuration = "ProcessingConfiguration",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_backup_update = "S3BackupUpdate",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        elasticsearch_destination_update: ?struct {
            role_arn: ?[]const u8 = null,
            domain_arn: ?[]const u8 = null,
            cluster_endpoint: ?[]const u8 = null,
            index_name: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            index_rotation_period: ?[]const u8 = null,
            buffering_hints: ?ElasticsearchBufferingHints = null,
            retry_options: ?ElasticsearchRetryOptions = null,
            s3_update: ?S3DestinationUpdate = null,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            document_id_options: ?DocumentIdOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .domain_arn = "DomainARN",
                    .cluster_endpoint = "ClusterEndpoint",
                    .index_name = "IndexName",
                    .type_name = "TypeName",
                    .index_rotation_period = "IndexRotationPeriod",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_update = "S3Update",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .document_id_options = "DocumentIdOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        amazonopensearchservice_destination_update: ?struct {
            role_arn: ?[]const u8 = null,
            domain_arn: ?[]const u8 = null,
            cluster_endpoint: ?[]const u8 = null,
            index_name: ?[]const u8 = null,
            type_name: ?[]const u8 = null,
            index_rotation_period: ?[]const u8 = null,
            buffering_hints: ?AmazonopensearchserviceBufferingHints = null,
            retry_options: ?AmazonopensearchserviceRetryOptions = null,
            s3_update: ?S3DestinationUpdate = null,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            document_id_options: ?DocumentIdOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .domain_arn = "DomainARN",
                    .cluster_endpoint = "ClusterEndpoint",
                    .index_name = "IndexName",
                    .type_name = "TypeName",
                    .index_rotation_period = "IndexRotationPeriod",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_update = "S3Update",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .document_id_options = "DocumentIdOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        splunk_destination_update: ?struct {
            hec_endpoint: ?[]const u8 = null,
            hec_endpoint_type: ?[]const u8 = null,
            hec_token: ?[]const u8 = null,
            hec_acknowledgment_timeout_in_seconds: ?i64 = null,
            retry_options: ?SplunkRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_update: ?S3DestinationUpdate = null,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            buffering_hints: ?SplunkBufferingHints = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .hec_endpoint = "HECEndpoint",
                    .hec_endpoint_type = "HECEndpointType",
                    .hec_token = "HECToken",
                    .hec_acknowledgment_timeout_in_seconds = "HECAcknowledgmentTimeoutInSeconds",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_update = "S3Update",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .buffering_hints = "BufferingHints",
                };
                return @field(mappings, field_name);
            }
        } = null,
        http_endpoint_destination_update: ?struct {
            endpoint_configuration: ?HttpEndpointConfiguration = null,
            buffering_hints: ?HttpEndpointBufferingHints = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            request_configuration: ?HttpEndpointRequestConfiguration = null,
            processing_configuration: ?ProcessingConfiguration = null,
            role_arn: ?[]const u8 = null,
            retry_options: ?HttpEndpointRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_update: ?S3DestinationUpdate = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .endpoint_configuration = "EndpointConfiguration",
                    .buffering_hints = "BufferingHints",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .request_configuration = "RequestConfiguration",
                    .processing_configuration = "ProcessingConfiguration",
                    .role_arn = "RoleARN",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_update = "S3Update",
                };
                return @field(mappings, field_name);
            }
        } = null,
        amazon_open_search_serverless_destination_update: ?struct {
            role_arn: ?[]const u8 = null,
            collection_endpoint: ?[]const u8 = null,
            index_name: ?[]const u8 = null,
            buffering_hints: ?AmazonOpenSearchServerlessBufferingHints = null,
            retry_options: ?AmazonOpenSearchServerlessRetryOptions = null,
            s3_update: ?S3DestinationUpdate = null,
            processing_configuration: ?ProcessingConfiguration = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .collection_endpoint = "CollectionEndpoint",
                    .index_name = "IndexName",
                    .buffering_hints = "BufferingHints",
                    .retry_options = "RetryOptions",
                    .s3_update = "S3Update",
                    .processing_configuration = "ProcessingConfiguration",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                };
                return @field(mappings, field_name);
            }
        } = null,
        snowflake_destination_update: ?struct {
            account_url: ?[]const u8 = null,
            private_key: ?[]const u8 = null,
            key_passphrase: ?[]const u8 = null,
            user: ?[]const u8 = null,
            database: ?[]const u8 = null,
            schema: ?[]const u8 = null,
            table: ?[]const u8 = null,
            snowflake_role_configuration: ?SnowflakeRoleConfiguration = null,
            data_loading_option: ?[]const u8 = null,
            meta_data_column_name: ?[]const u8 = null,
            content_column_name: ?[]const u8 = null,
            cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,
            processing_configuration: ?ProcessingConfiguration = null,
            role_arn: ?[]const u8 = null,
            retry_options: ?SnowflakeRetryOptions = null,
            s3_backup_mode: ?[]const u8 = null,
            s3_update: ?S3DestinationUpdate = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .account_url = "AccountUrl",
                    .private_key = "PrivateKey",
                    .key_passphrase = "KeyPassphrase",
                    .user = "User",
                    .database = "Database",
                    .schema = "Schema",
                    .table = "Table",
                    .snowflake_role_configuration = "SnowflakeRoleConfiguration",
                    .data_loading_option = "DataLoadingOption",
                    .meta_data_column_name = "MetaDataColumnName",
                    .content_column_name = "ContentColumnName",
                    .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                    .processing_configuration = "ProcessingConfiguration",
                    .role_arn = "RoleARN",
                    .retry_options = "RetryOptions",
                    .s3_backup_mode = "S3BackupMode",
                    .s3_update = "S3Update",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .delivery_stream_name = "DeliveryStreamName",
                .current_delivery_stream_version_id = "CurrentDeliveryStreamVersionId",
                .destination_id = "DestinationId",
                .s3_destination_update = "S3DestinationUpdate",
                .extended_s3_destination_update = "ExtendedS3DestinationUpdate",
                .redshift_destination_update = "RedshiftDestinationUpdate",
                .elasticsearch_destination_update = "ElasticsearchDestinationUpdate",
                .amazonopensearchservice_destination_update = "AmazonopensearchserviceDestinationUpdate",
                .splunk_destination_update = "SplunkDestinationUpdate",
                .http_endpoint_destination_update = "HttpEndpointDestinationUpdate",
                .amazon_open_search_serverless_destination_update = "AmazonOpenSearchServerlessDestinationUpdate",
                .snowflake_destination_update = "SnowflakeDestinationUpdate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_destination) } {
            return .{ .service_metadata = service_metadata, .action = update_destination };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};

pub const S3DestinationUpdate = struct {
    role_arn: ?[]const u8 = null,
    bucket_arn: ?[]const u8 = null,
    prefix: ?[]const u8 = null,
    error_output_prefix: ?[]const u8 = null,
    buffering_hints: ?BufferingHints = null,
    compression_format: ?[]const u8 = null,
    encryption_configuration: ?EncryptionConfiguration = null,
    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .role_arn = "RoleARN",
            .bucket_arn = "BucketARN",
            .prefix = "Prefix",
            .error_output_prefix = "ErrorOutputPrefix",
            .buffering_hints = "BufferingHints",
            .compression_format = "CompressionFormat",
            .encryption_configuration = "EncryptionConfiguration",
            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLoggingOptions = struct {
    enabled: ?bool = null,
    log_group_name: ?[]const u8 = null,
    log_stream_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
            .log_group_name = "LogGroupName",
            .log_stream_name = "LogStreamName",
        };
        return @field(mappings, field_name);
    }
};

pub const EncryptionConfiguration = struct {
    no_encryption_config: ?[]const u8 = null,
    kms_encryption_config: ?KMSEncryptionConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .no_encryption_config = "NoEncryptionConfig",
            .kms_encryption_config = "KMSEncryptionConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const KMSEncryptionConfig = struct {
    awskms_key_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .awskms_key_arn = "AWSKMSKeyARN",
        };
        return @field(mappings, field_name);
    }
};

pub const BufferingHints = struct {
    size_in_m_bs: ?i64 = null,
    interval_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .size_in_m_bs = "SizeInMBs",
            .interval_in_seconds = "IntervalInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const SnowflakeRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const ProcessingConfiguration = struct {
    enabled: ?bool = null,
    processors: ?[]Processor = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
            .processors = "Processors",
        };
        return @field(mappings, field_name);
    }
};

pub const Processor = struct {
    type: []const u8,
    parameters: ?[]ProcessorParameter = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .parameters = "Parameters",
        };
        return @field(mappings, field_name);
    }
};

pub const ProcessorParameter = struct {
    parameter_name: []const u8,
    parameter_value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .parameter_name = "ParameterName",
            .parameter_value = "ParameterValue",
        };
        return @field(mappings, field_name);
    }
};

pub const SnowflakeRoleConfiguration = struct {
    enabled: ?bool = null,
    snowflake_role: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
            .snowflake_role = "SnowflakeRole",
        };
        return @field(mappings, field_name);
    }
};

pub const AmazonOpenSearchServerlessRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const AmazonOpenSearchServerlessBufferingHints = struct {
    interval_in_seconds: ?i64 = null,
    size_in_m_bs: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .interval_in_seconds = "IntervalInSeconds",
            .size_in_m_bs = "SizeInMBs",
        };
        return @field(mappings, field_name);
    }
};

pub const HttpEndpointRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const HttpEndpointRequestConfiguration = struct {
    content_encoding: ?[]const u8 = null,
    common_attributes: ?[]HttpEndpointCommonAttribute = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .content_encoding = "ContentEncoding",
            .common_attributes = "CommonAttributes",
        };
        return @field(mappings, field_name);
    }
};

pub const HttpEndpointCommonAttribute = struct {
    attribute_name: []const u8,
    attribute_value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .attribute_name = "AttributeName",
            .attribute_value = "AttributeValue",
        };
        return @field(mappings, field_name);
    }
};

pub const HttpEndpointBufferingHints = struct {
    size_in_m_bs: ?i64 = null,
    interval_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .size_in_m_bs = "SizeInMBs",
            .interval_in_seconds = "IntervalInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const HttpEndpointConfiguration = struct {
    url: []const u8,
    name: ?[]const u8 = null,
    access_key: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .url = "Url",
            .name = "Name",
            .access_key = "AccessKey",
        };
        return @field(mappings, field_name);
    }
};

pub const SplunkBufferingHints = struct {
    interval_in_seconds: ?i64 = null,
    size_in_m_bs: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .interval_in_seconds = "IntervalInSeconds",
            .size_in_m_bs = "SizeInMBs",
        };
        return @field(mappings, field_name);
    }
};

pub const SplunkRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentIdOptions = struct {
    default_document_id_format: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_document_id_format = "DefaultDocumentIdFormat",
        };
        return @field(mappings, field_name);
    }
};

pub const AmazonopensearchserviceRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const AmazonopensearchserviceBufferingHints = struct {
    interval_in_seconds: ?i64 = null,
    size_in_m_bs: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .interval_in_seconds = "IntervalInSeconds",
            .size_in_m_bs = "SizeInMBs",
        };
        return @field(mappings, field_name);
    }
};

pub const ElasticsearchRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const ElasticsearchBufferingHints = struct {
    interval_in_seconds: ?i64 = null,
    size_in_m_bs: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .interval_in_seconds = "IntervalInSeconds",
            .size_in_m_bs = "SizeInMBs",
        };
        return @field(mappings, field_name);
    }
};

pub const RedshiftRetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const CopyCommand = struct {
    data_table_name: []const u8,
    data_table_columns: ?[]const u8 = null,
    copy_options: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_table_name = "DataTableName",
            .data_table_columns = "DataTableColumns",
            .copy_options = "CopyOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const DynamicPartitioningConfiguration = struct {
    retry_options: ?RetryOptions = null,
    enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .retry_options = "RetryOptions",
            .enabled = "Enabled",
        };
        return @field(mappings, field_name);
    }
};

pub const RetryOptions = struct {
    duration_in_seconds: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .duration_in_seconds = "DurationInSeconds",
        };
        return @field(mappings, field_name);
    }
};

pub const DataFormatConversionConfiguration = struct {
    schema_configuration: ?SchemaConfiguration = null,
    input_format_configuration: ?InputFormatConfiguration = null,
    output_format_configuration: ?OutputFormatConfiguration = null,
    enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .schema_configuration = "SchemaConfiguration",
            .input_format_configuration = "InputFormatConfiguration",
            .output_format_configuration = "OutputFormatConfiguration",
            .enabled = "Enabled",
        };
        return @field(mappings, field_name);
    }
};

pub const OutputFormatConfiguration = struct {
    serializer: ?Serializer = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .serializer = "Serializer",
        };
        return @field(mappings, field_name);
    }
};

pub const Serializer = struct {
    parquet_ser_de: ?ParquetSerDe = null,
    orc_ser_de: ?OrcSerDe = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .parquet_ser_de = "ParquetSerDe",
            .orc_ser_de = "OrcSerDe",
        };
        return @field(mappings, field_name);
    }
};

pub const OrcSerDe = struct {
    stripe_size_bytes: ?i64 = null,
    block_size_bytes: ?i64 = null,
    row_index_stride: ?i64 = null,
    enable_padding: ?bool = null,
    padding_tolerance: ?f64 = null,
    compression: ?[]const u8 = null,
    bloom_filter_columns: ?[][]const u8 = null,
    bloom_filter_false_positive_probability: ?f64 = null,
    dictionary_key_threshold: ?f64 = null,
    format_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .stripe_size_bytes = "StripeSizeBytes",
            .block_size_bytes = "BlockSizeBytes",
            .row_index_stride = "RowIndexStride",
            .enable_padding = "EnablePadding",
            .padding_tolerance = "PaddingTolerance",
            .compression = "Compression",
            .bloom_filter_columns = "BloomFilterColumns",
            .bloom_filter_false_positive_probability = "BloomFilterFalsePositiveProbability",
            .dictionary_key_threshold = "DictionaryKeyThreshold",
            .format_version = "FormatVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const ParquetSerDe = struct {
    block_size_bytes: ?i64 = null,
    page_size_bytes: ?i64 = null,
    compression: ?[]const u8 = null,
    enable_dictionary_compression: ?bool = null,
    max_padding_bytes: ?i64 = null,
    writer_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .block_size_bytes = "BlockSizeBytes",
            .page_size_bytes = "PageSizeBytes",
            .compression = "Compression",
            .enable_dictionary_compression = "EnableDictionaryCompression",
            .max_padding_bytes = "MaxPaddingBytes",
            .writer_version = "WriterVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const InputFormatConfiguration = struct {
    deserializer: ?Deserializer = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .deserializer = "Deserializer",
        };
        return @field(mappings, field_name);
    }
};

pub const Deserializer = struct {
    open_x_json_ser_de: ?OpenXJsonSerDe = null,
    hive_json_ser_de: ?HiveJsonSerDe = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .open_x_json_ser_de = "OpenXJsonSerDe",
            .hive_json_ser_de = "HiveJsonSerDe",
        };
        return @field(mappings, field_name);
    }
};

pub const HiveJsonSerDe = struct {
    timestamp_formats: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .timestamp_formats = "TimestampFormats",
        };
        return @field(mappings, field_name);
    }
};

pub const OpenXJsonSerDe = struct {
    convert_dots_in_json_keys_to_underscores: ?bool = null,
    case_insensitive: ?bool = null,
    column_to_json_key_mappings: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .convert_dots_in_json_keys_to_underscores = "ConvertDotsInJsonKeysToUnderscores",
            .case_insensitive = "CaseInsensitive",
            .column_to_json_key_mappings = "ColumnToJsonKeyMappings",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "column_to_json_key_mappings", field_name))
            return try serializeMap(self.column_to_json_key_mappings, self.fieldNameFor("column_to_json_key_mappings"), options, out_stream);
        return false;
    }
};

pub const SchemaConfiguration = struct {
    role_arn: ?[]const u8 = null,
    catalog_id: ?[]const u8 = null,
    database_name: ?[]const u8 = null,
    table_name: ?[]const u8 = null,
    region: ?[]const u8 = null,
    version_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .role_arn = "RoleARN",
            .catalog_id = "CatalogId",
            .database_name = "DatabaseName",
            .table_name = "TableName",
            .region = "Region",
            .version_id = "VersionId",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const DeliveryStreamEncryptionConfigurationInput = struct {
    key_arn: ?[]const u8 = null,
    key_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key_arn = "KeyARN",
            .key_type = "KeyType",
        };
        return @field(mappings, field_name);
    }
};

pub const Record = struct {
    data: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data = "Data",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfigurationDescription = struct {
    subnet_ids: [][]const u8,
    role_arn: []const u8,
    security_group_ids: [][]const u8,
    vpc_id: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .subnet_ids = "SubnetIds",
            .role_arn = "RoleARN",
            .security_group_ids = "SecurityGroupIds",
            .vpc_id = "VpcId",
        };
        return @field(mappings, field_name);
    }
};

pub const S3DestinationDescription = struct {
    role_arn: []const u8,
    bucket_arn: []const u8,
    prefix: ?[]const u8 = null,
    error_output_prefix: ?[]const u8 = null,
    buffering_hints: BufferingHints,
    compression_format: []const u8,
    encryption_configuration: EncryptionConfiguration,
    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .role_arn = "RoleARN",
            .bucket_arn = "BucketARN",
            .prefix = "Prefix",
            .error_output_prefix = "ErrorOutputPrefix",
            .buffering_hints = "BufferingHints",
            .compression_format = "CompressionFormat",
            .encryption_configuration = "EncryptionConfiguration",
            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const SnowflakeVpcConfiguration = struct {
    private_link_vpce_id: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .private_link_vpce_id = "PrivateLinkVpceId",
        };
        return @field(mappings, field_name);
    }
};

pub const AuthenticationConfiguration = struct {
    role_arn: []const u8,
    connectivity: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .role_arn = "RoleARN",
            .connectivity = "Connectivity",
        };
        return @field(mappings, field_name);
    }
};

pub const FailureDescription = struct {
    type: []const u8,
    details: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .details = "Details",
        };
        return @field(mappings, field_name);
    }
};

pub const S3DestinationConfiguration = struct {
    role_arn: []const u8,
    bucket_arn: []const u8,
    prefix: ?[]const u8 = null,
    error_output_prefix: ?[]const u8 = null,
    buffering_hints: ?BufferingHints = null,
    compression_format: ?[]const u8 = null,
    encryption_configuration: ?EncryptionConfiguration = null,
    cloud_watch_logging_options: ?CloudWatchLoggingOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .role_arn = "RoleARN",
            .bucket_arn = "BucketARN",
            .prefix = "Prefix",
            .error_output_prefix = "ErrorOutputPrefix",
            .buffering_hints = "BufferingHints",
            .compression_format = "CompressionFormat",
            .encryption_configuration = "EncryptionConfiguration",
            .cloud_watch_logging_options = "CloudWatchLoggingOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfiguration = struct {
    subnet_ids: [][]const u8,
    role_arn: []const u8,
    security_group_ids: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .subnet_ids = "SubnetIds",
            .role_arn = "RoleARN",
            .security_group_ids = "SecurityGroupIds",
        };
        return @field(mappings, field_name);
    }
};
