const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-01-01";
pub const sdk_id: []const u8 = "FMS";
pub const arn_namespace: ?[]const u8 = "fms";
pub const endpoint_prefix: []const u8 = "fms";
pub const sigv4_name: []const u8 = "fms";
pub const name: []const u8 = "AWSFMS_20180101";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-01-01",
    sdk_id: []const u8 = "FMS",
    arn_namespace: ?[]const u8 = "fms",
    endpoint_prefix: []const u8 = "fms",
    sigv4_name: []const u8 = "fms",
    name: []const u8 = "AWSFMS_20180101",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_admin_account: struct {
    action_name: []const u8 = "AssociateAdminAccount",
    Request: type = struct {
        admin_account: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = associate_admin_account };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const associate_third_party_firewall: struct {
    action_name: []const u8 = "AssociateThirdPartyFirewall",
    Request: type = struct {
        third_party_firewall: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall = "ThirdPartyFirewall",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_third_party_firewall) } {
            return .{ .service_metadata = service_metadata, .action = associate_third_party_firewall };
        }
    },
    Response: type = struct {
        third_party_firewall_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall_status = "ThirdPartyFirewallStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const batch_associate_resource: struct {
    action_name: []const u8 = "BatchAssociateResource",
    Request: type = struct {
        resource_set_identifier: []const u8,
        items: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set_identifier = "ResourceSetIdentifier",
                .items = "Items",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_associate_resource) } {
            return .{ .service_metadata = service_metadata, .action = batch_associate_resource };
        }
    },
    Response: type = struct {
        resource_set_identifier: []const u8,
        failed_items: []FailedItem,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set_identifier = "ResourceSetIdentifier",
                .failed_items = "FailedItems",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const batch_disassociate_resource: struct {
    action_name: []const u8 = "BatchDisassociateResource",
    Request: type = struct {
        resource_set_identifier: []const u8,
        items: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set_identifier = "ResourceSetIdentifier",
                .items = "Items",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_disassociate_resource) } {
            return .{ .service_metadata = service_metadata, .action = batch_disassociate_resource };
        }
    },
    Response: type = struct {
        resource_set_identifier: []const u8,
        failed_items: []FailedItem,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set_identifier = "ResourceSetIdentifier",
                .failed_items = "FailedItems",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_apps_list: struct {
    action_name: []const u8 = "DeleteAppsList",
    Request: type = struct {
        list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_apps_list };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_notification_channel: struct {
    action_name: []const u8 = "DeleteNotificationChannel",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = delete_notification_channel };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_policy: struct {
    action_name: []const u8 = "DeletePolicy",
    Request: type = struct {
        policy_id: []const u8,
        delete_all_policy_resources: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .delete_all_policy_resources = "DeleteAllPolicyResources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const delete_protocols_list: struct {
    action_name: []const u8 = "DeleteProtocolsList",
    Request: type = struct {
        list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_protocols_list };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_resource_set: struct {
    action_name: []const u8 = "DeleteResourceSet",
    Request: type = struct {
        identifier: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .identifier = "Identifier",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resource_set) } {
            return .{ .service_metadata = service_metadata, .action = delete_resource_set };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_admin_account: struct {
    action_name: []const u8 = "DisassociateAdminAccount",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_admin_account };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_third_party_firewall: struct {
    action_name: []const u8 = "DisassociateThirdPartyFirewall",
    Request: type = struct {
        third_party_firewall: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall = "ThirdPartyFirewall",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_third_party_firewall) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_third_party_firewall };
        }
    },
    Response: type = struct {
        third_party_firewall_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall_status = "ThirdPartyFirewallStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_admin_account: struct {
    action_name: []const u8 = "GetAdminAccount",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = get_admin_account };
        }
    },
    Response: type = struct {
        admin_account: ?[]const u8 = null,
        role_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
                .role_status = "RoleStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_admin_scope: struct {
    action_name: []const u8 = "GetAdminScope",
    Request: type = struct {
        admin_account: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_admin_scope) } {
            return .{ .service_metadata = service_metadata, .action = get_admin_scope };
        }
    },
    Response: type = struct {
        admin_scope: ?AdminScope = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_scope = "AdminScope",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const get_apps_list: struct {
    action_name: []const u8 = "GetAppsList",
    Request: type = struct {
        list_id: []const u8,
        default_list: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
                .default_list = "DefaultList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = get_apps_list };
        }
    },
    Response: type = struct {
        apps_list: ?AppsListData = null,
        apps_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .apps_list_arn = "AppsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_compliance_detail: struct {
    action_name: []const u8 = "GetComplianceDetail",
    Request: type = struct {
        policy_id: []const u8,
        member_account: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account = "MemberAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_compliance_detail) } {
            return .{ .service_metadata = service_metadata, .action = get_compliance_detail };
        }
    },
    Response: type = struct {
        policy_compliance_detail: ?struct {
            policy_owner: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            member_account: ?[]const u8 = null,
            violators: ?[]struct {
                resource_id: ?[]const u8 = null,
                violation_reason: ?[]const u8 = null,
                resource_type: ?[]const u8 = null,
                metadata: ?[]struct {
                    key: ?[]const u8 = null,
                    value: ?[]const u8 = null,
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .resource_id = "ResourceId",
                        .violation_reason = "ViolationReason",
                        .resource_type = "ResourceType",
                        .metadata = "Metadata",
                    };
                    return @field(mappings, field_name);
                }

                pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                    if (std.mem.eql(u8, "metadata", field_name))
                        return try serializeMap(self.metadata, self.fieldNameFor("metadata"), options, out_stream);
                    return false;
                }
            } = null,
            evaluation_limit_exceeded: ?bool = null,
            expired_at: ?i64 = null,
            issue_info_map: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_owner = "PolicyOwner",
                    .policy_id = "PolicyId",
                    .member_account = "MemberAccount",
                    .violators = "Violators",
                    .evaluation_limit_exceeded = "EvaluationLimitExceeded",
                    .expired_at = "ExpiredAt",
                    .issue_info_map = "IssueInfoMap",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "issue_info_map", field_name))
                    return try serializeMap(self.issue_info_map, self.fieldNameFor("issue_info_map"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_compliance_detail = "PolicyComplianceDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_notification_channel: struct {
    action_name: []const u8 = "GetNotificationChannel",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = get_notification_channel };
        }
    },
    Response: type = struct {
        sns_topic_arn: ?[]const u8 = null,
        sns_role_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sns_topic_arn = "SnsTopicArn",
                .sns_role_name = "SnsRoleName",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_policy: struct {
    action_name: []const u8 = "GetPolicy",
    Request: type = struct {
        policy_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,
        policy_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidType,
        ResourceNotFound,
    },
} = .{};
pub const get_protection_status: struct {
    action_name: []const u8 = "GetProtectionStatus",
    Request: type = struct {
        policy_id: []const u8,
        member_account_id: ?[]const u8 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account_id = "MemberAccountId",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_protection_status) } {
            return .{ .service_metadata = service_metadata, .action = get_protection_status };
        }
    },
    Response: type = struct {
        admin_account_id: ?[]const u8 = null,
        service_type: ?[]const u8 = null,
        data: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account_id = "AdminAccountId",
                .service_type = "ServiceType",
                .data = "Data",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const get_protocols_list: struct {
    action_name: []const u8 = "GetProtocolsList",
    Request: type = struct {
        list_id: []const u8,
        default_list: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
                .default_list = "DefaultList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = get_protocols_list };
        }
    },
    Response: type = struct {
        protocols_list: ?ProtocolsListData = null,
        protocols_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .protocols_list_arn = "ProtocolsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_resource_set: struct {
    action_name: []const u8 = "GetResourceSet",
    Request: type = struct {
        identifier: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .identifier = "Identifier",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resource_set) } {
            return .{ .service_metadata = service_metadata, .action = get_resource_set };
        }
    },
    Response: type = struct {
        resource_set: ResourceSet,
        resource_set_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set = "ResourceSet",
                .resource_set_arn = "ResourceSetArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_third_party_firewall_association_status: struct {
    action_name: []const u8 = "GetThirdPartyFirewallAssociationStatus",
    Request: type = struct {
        third_party_firewall: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall = "ThirdPartyFirewall",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_third_party_firewall_association_status) } {
            return .{ .service_metadata = service_metadata, .action = get_third_party_firewall_association_status };
        }
    },
    Response: type = struct {
        third_party_firewall_status: ?[]const u8 = null,
        marketplace_onboarding_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall_status = "ThirdPartyFirewallStatus",
                .marketplace_onboarding_status = "MarketplaceOnboardingStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_violation_details: struct {
    action_name: []const u8 = "GetViolationDetails",
    Request: type = struct {
        policy_id: []const u8,
        member_account: []const u8,
        resource_id: []const u8,
        resource_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account = "MemberAccount",
                .resource_id = "ResourceId",
                .resource_type = "ResourceType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_violation_details) } {
            return .{ .service_metadata = service_metadata, .action = get_violation_details };
        }
    },
    Response: type = struct {
        violation_detail: ?struct {
            policy_id: []const u8,
            member_account: []const u8,
            resource_id: []const u8,
            resource_type: []const u8,
            resource_violations: []struct {
                aws_vpc_security_group_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    partial_matches: ?[]struct {
                        reference: ?[]const u8 = null,
                        target_violation_reasons: ?[][]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .reference = "Reference",
                                .target_violation_reasons = "TargetViolationReasons",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    possible_security_group_remediation_actions: ?[]struct {
                        remediation_action_type: ?[]const u8 = null,
                        description: ?[]const u8 = null,
                        remediation_result: ?struct {
                            ipv4_range: ?[]const u8 = null,
                            ipv6_range: ?[]const u8 = null,
                            prefix_list_id: ?[]const u8 = null,
                            protocol: ?[]const u8 = null,
                            from_port: ?i64 = null,
                            to_port: ?i64 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .ipv4_range = "IPV4Range",
                                    .ipv6_range = "IPV6Range",
                                    .prefix_list_id = "PrefixListId",
                                    .protocol = "Protocol",
                                    .from_port = "FromPort",
                                    .to_port = "ToPort",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,
                        is_default_action: ?bool = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .remediation_action_type = "RemediationActionType",
                                .description = "Description",
                                .remediation_result = "RemediationResult",
                                .is_default_action = "IsDefaultAction",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .partial_matches = "PartialMatches",
                            .possible_security_group_remediation_actions = "PossibleSecurityGroupRemediationActions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                aws_ec2_network_interface_violation: ?AwsEc2NetworkInterfaceViolation = null,
                aws_ec2_instance_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    aws_ec2_network_interface_violations: ?[]AwsEc2NetworkInterfaceViolation = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .aws_ec2_network_interface_violations = "AwsEc2NetworkInterfaceViolations",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_firewall_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_subnet_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_expected_rt_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    current_route_table: ?[]const u8 = null,
                    expected_route_table: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .current_route_table = "CurrentRouteTable",
                            .expected_route_table = "ExpectedRouteTable",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_policy_modified_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    current_policy_description: ?NetworkFirewallPolicyDescription = null,
                    expected_policy_description: ?NetworkFirewallPolicyDescription = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .current_policy_description = "CurrentPolicyDescription",
                            .expected_policy_description = "ExpectedPolicyDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_internet_traffic_not_inspected_violation: ?struct {
                    subnet_id: ?[]const u8 = null,
                    subnet_availability_zone: ?[]const u8 = null,
                    route_table_id: ?[]const u8 = null,
                    violating_routes: ?[]Route = null,
                    is_route_table_used_in_different_az: ?bool = null,
                    current_firewall_subnet_route_table: ?[]const u8 = null,
                    expected_firewall_endpoint: ?[]const u8 = null,
                    firewall_subnet_id: ?[]const u8 = null,
                    expected_firewall_subnet_routes: ?[]ExpectedRoute = null,
                    actual_firewall_subnet_routes: ?[]Route = null,
                    internet_gateway_id: ?[]const u8 = null,
                    current_internet_gateway_route_table: ?[]const u8 = null,
                    expected_internet_gateway_routes: ?[]ExpectedRoute = null,
                    actual_internet_gateway_routes: ?[]Route = null,
                    vpc_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .subnet_id = "SubnetId",
                            .subnet_availability_zone = "SubnetAvailabilityZone",
                            .route_table_id = "RouteTableId",
                            .violating_routes = "ViolatingRoutes",
                            .is_route_table_used_in_different_az = "IsRouteTableUsedInDifferentAZ",
                            .current_firewall_subnet_route_table = "CurrentFirewallSubnetRouteTable",
                            .expected_firewall_endpoint = "ExpectedFirewallEndpoint",
                            .firewall_subnet_id = "FirewallSubnetId",
                            .expected_firewall_subnet_routes = "ExpectedFirewallSubnetRoutes",
                            .actual_firewall_subnet_routes = "ActualFirewallSubnetRoutes",
                            .internet_gateway_id = "InternetGatewayId",
                            .current_internet_gateway_route_table = "CurrentInternetGatewayRouteTable",
                            .expected_internet_gateway_routes = "ExpectedInternetGatewayRoutes",
                            .actual_internet_gateway_routes = "ActualInternetGatewayRoutes",
                            .vpc_id = "VpcId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_invalid_route_configuration_violation: ?struct {
                    affected_subnets: ?[][]const u8 = null,
                    route_table_id: ?[]const u8 = null,
                    is_route_table_used_in_different_az: ?bool = null,
                    violating_route: ?Route = null,
                    current_firewall_subnet_route_table: ?[]const u8 = null,
                    expected_firewall_endpoint: ?[]const u8 = null,
                    actual_firewall_endpoint: ?[]const u8 = null,
                    expected_firewall_subnet_id: ?[]const u8 = null,
                    actual_firewall_subnet_id: ?[]const u8 = null,
                    expected_firewall_subnet_routes: ?[]ExpectedRoute = null,
                    actual_firewall_subnet_routes: ?[]Route = null,
                    internet_gateway_id: ?[]const u8 = null,
                    current_internet_gateway_route_table: ?[]const u8 = null,
                    expected_internet_gateway_routes: ?[]ExpectedRoute = null,
                    actual_internet_gateway_routes: ?[]Route = null,
                    vpc_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .affected_subnets = "AffectedSubnets",
                            .route_table_id = "RouteTableId",
                            .is_route_table_used_in_different_az = "IsRouteTableUsedInDifferentAZ",
                            .violating_route = "ViolatingRoute",
                            .current_firewall_subnet_route_table = "CurrentFirewallSubnetRouteTable",
                            .expected_firewall_endpoint = "ExpectedFirewallEndpoint",
                            .actual_firewall_endpoint = "ActualFirewallEndpoint",
                            .expected_firewall_subnet_id = "ExpectedFirewallSubnetId",
                            .actual_firewall_subnet_id = "ActualFirewallSubnetId",
                            .expected_firewall_subnet_routes = "ExpectedFirewallSubnetRoutes",
                            .actual_firewall_subnet_routes = "ActualFirewallSubnetRoutes",
                            .internet_gateway_id = "InternetGatewayId",
                            .current_internet_gateway_route_table = "CurrentInternetGatewayRouteTable",
                            .expected_internet_gateway_routes = "ExpectedInternetGatewayRoutes",
                            .actual_internet_gateway_routes = "ActualInternetGatewayRoutes",
                            .vpc_id = "VpcId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_black_hole_route_detected_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    route_table_id: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,
                    violating_routes: ?[]Route = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .route_table_id = "RouteTableId",
                            .vpc_id = "VpcId",
                            .violating_routes = "ViolatingRoutes",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_unexpected_firewall_routes_violation: ?struct {
                    firewall_subnet_id: ?[]const u8 = null,
                    violating_routes: ?[]Route = null,
                    route_table_id: ?[]const u8 = null,
                    firewall_endpoint: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .firewall_subnet_id = "FirewallSubnetId",
                            .violating_routes = "ViolatingRoutes",
                            .route_table_id = "RouteTableId",
                            .firewall_endpoint = "FirewallEndpoint",
                            .vpc_id = "VpcId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_unexpected_gateway_routes_violation: ?struct {
                    gateway_id: ?[]const u8 = null,
                    violating_routes: ?[]Route = null,
                    route_table_id: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .gateway_id = "GatewayId",
                            .violating_routes = "ViolatingRoutes",
                            .route_table_id = "RouteTableId",
                            .vpc_id = "VpcId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_expected_routes_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    expected_routes: ?[]ExpectedRoute = null,
                    vpc_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .expected_routes = "ExpectedRoutes",
                            .vpc_id = "VpcId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_rule_group_priority_conflict_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    conflicting_priority: ?i64 = null,
                    conflicting_policy_id: ?[]const u8 = null,
                    unavailable_priorities: ?[]i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .conflicting_priority = "ConflictingPriority",
                            .conflicting_policy_id = "ConflictingPolicyId",
                            .unavailable_priorities = "UnavailablePriorities",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_duplicate_rule_group_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_rule_group_limit_exceeded_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    number_of_rule_groups_already_associated: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .number_of_rule_groups_already_associated = "NumberOfRuleGroupsAlreadyAssociated",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                possible_remediation_actions: ?struct {
                    description: ?[]const u8 = null,
                    actions: ?[]struct {
                        description: ?[]const u8 = null,
                        ordered_remediation_actions: []struct {
                            remediation_action: ?struct {
                                description: ?[]const u8 = null,
                                ec2_create_route_action: ?struct {
                                    description: ?[]const u8 = null,
                                    destination_cidr_block: ?[]const u8 = null,
                                    destination_prefix_list_id: ?[]const u8 = null,
                                    destination_ipv6_cidr_block: ?[]const u8 = null,
                                    vpc_endpoint_id: ?ActionTarget = null,
                                    gateway_id: ?ActionTarget = null,
                                    route_table_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .destination_cidr_block = "DestinationCidrBlock",
                                            .destination_prefix_list_id = "DestinationPrefixListId",
                                            .destination_ipv6_cidr_block = "DestinationIpv6CidrBlock",
                                            .vpc_endpoint_id = "VpcEndpointId",
                                            .gateway_id = "GatewayId",
                                            .route_table_id = "RouteTableId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_replace_route_action: ?struct {
                                    description: ?[]const u8 = null,
                                    destination_cidr_block: ?[]const u8 = null,
                                    destination_prefix_list_id: ?[]const u8 = null,
                                    destination_ipv6_cidr_block: ?[]const u8 = null,
                                    gateway_id: ?ActionTarget = null,
                                    route_table_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .destination_cidr_block = "DestinationCidrBlock",
                                            .destination_prefix_list_id = "DestinationPrefixListId",
                                            .destination_ipv6_cidr_block = "DestinationIpv6CidrBlock",
                                            .gateway_id = "GatewayId",
                                            .route_table_id = "RouteTableId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_delete_route_action: ?struct {
                                    description: ?[]const u8 = null,
                                    destination_cidr_block: ?[]const u8 = null,
                                    destination_prefix_list_id: ?[]const u8 = null,
                                    destination_ipv6_cidr_block: ?[]const u8 = null,
                                    route_table_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .destination_cidr_block = "DestinationCidrBlock",
                                            .destination_prefix_list_id = "DestinationPrefixListId",
                                            .destination_ipv6_cidr_block = "DestinationIpv6CidrBlock",
                                            .route_table_id = "RouteTableId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_copy_route_table_action: ?struct {
                                    description: ?[]const u8 = null,
                                    vpc_id: ActionTarget,
                                    route_table_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .vpc_id = "VpcId",
                                            .route_table_id = "RouteTableId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_replace_route_table_association_action: ?struct {
                                    description: ?[]const u8 = null,
                                    association_id: ActionTarget,
                                    route_table_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .association_id = "AssociationId",
                                            .route_table_id = "RouteTableId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_associate_route_table_action: ?struct {
                                    description: ?[]const u8 = null,
                                    route_table_id: ActionTarget,
                                    subnet_id: ?ActionTarget = null,
                                    gateway_id: ?ActionTarget = null,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .route_table_id = "RouteTableId",
                                            .subnet_id = "SubnetId",
                                            .gateway_id = "GatewayId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                ec2_create_route_table_action: ?struct {
                                    description: ?[]const u8 = null,
                                    vpc_id: ActionTarget,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .vpc_id = "VpcId",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,
                                fms_policy_update_firewall_creation_config_action: ?struct {
                                    description: ?[]const u8 = null,
                                    firewall_creation_config: ?[]const u8 = null,

                                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                        const mappings = .{
                                            .description = "Description",
                                            .firewall_creation_config = "FirewallCreationConfig",
                                        };
                                        return @field(mappings, field_name);
                                    }
                                } = null,

                                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                    const mappings = .{
                                        .description = "Description",
                                        .ec2_create_route_action = "EC2CreateRouteAction",
                                        .ec2_replace_route_action = "EC2ReplaceRouteAction",
                                        .ec2_delete_route_action = "EC2DeleteRouteAction",
                                        .ec2_copy_route_table_action = "EC2CopyRouteTableAction",
                                        .ec2_replace_route_table_association_action = "EC2ReplaceRouteTableAssociationAction",
                                        .ec2_associate_route_table_action = "EC2AssociateRouteTableAction",
                                        .ec2_create_route_table_action = "EC2CreateRouteTableAction",
                                        .fms_policy_update_firewall_creation_config_action = "FMSPolicyUpdateFirewallCreationConfigAction",
                                    };
                                    return @field(mappings, field_name);
                                }
                            } = null,
                            order: ?i64 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .remediation_action = "RemediationAction",
                                    .order = "Order",
                                };
                                return @field(mappings, field_name);
                            }
                        },
                        is_default_action: ?bool = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .description = "Description",
                                .ordered_remediation_actions = "OrderedRemediationActions",
                                .is_default_action = "IsDefaultAction",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .description = "Description",
                            .actions = "Actions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                firewall_subnet_is_out_of_scope_violation: ?struct {
                    firewall_subnet_id: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,
                    subnet_availability_zone: ?[]const u8 = null,
                    subnet_availability_zone_id: ?[]const u8 = null,
                    vpc_endpoint_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .firewall_subnet_id = "FirewallSubnetId",
                            .vpc_id = "VpcId",
                            .subnet_availability_zone = "SubnetAvailabilityZone",
                            .subnet_availability_zone_id = "SubnetAvailabilityZoneId",
                            .vpc_endpoint_id = "VpcEndpointId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                route_has_out_of_scope_endpoint_violation: ?struct {
                    subnet_id: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,
                    route_table_id: ?[]const u8 = null,
                    violating_routes: ?[]Route = null,
                    subnet_availability_zone: ?[]const u8 = null,
                    subnet_availability_zone_id: ?[]const u8 = null,
                    current_firewall_subnet_route_table: ?[]const u8 = null,
                    firewall_subnet_id: ?[]const u8 = null,
                    firewall_subnet_routes: ?[]Route = null,
                    internet_gateway_id: ?[]const u8 = null,
                    current_internet_gateway_route_table: ?[]const u8 = null,
                    internet_gateway_routes: ?[]Route = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .subnet_id = "SubnetId",
                            .vpc_id = "VpcId",
                            .route_table_id = "RouteTableId",
                            .violating_routes = "ViolatingRoutes",
                            .subnet_availability_zone = "SubnetAvailabilityZone",
                            .subnet_availability_zone_id = "SubnetAvailabilityZoneId",
                            .current_firewall_subnet_route_table = "CurrentFirewallSubnetRouteTable",
                            .firewall_subnet_id = "FirewallSubnetId",
                            .firewall_subnet_routes = "FirewallSubnetRoutes",
                            .internet_gateway_id = "InternetGatewayId",
                            .current_internet_gateway_route_table = "CurrentInternetGatewayRouteTable",
                            .internet_gateway_routes = "InternetGatewayRoutes",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                third_party_firewall_missing_firewall_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                third_party_firewall_missing_subnet_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                third_party_firewall_missing_expected_route_table_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    current_route_table: ?[]const u8 = null,
                    expected_route_table: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .current_route_table = "CurrentRouteTable",
                            .expected_route_table = "ExpectedRouteTable",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                firewall_subnet_missing_vpc_endpoint_violation: ?struct {
                    firewall_subnet_id: ?[]const u8 = null,
                    vpc_id: ?[]const u8 = null,
                    subnet_availability_zone: ?[]const u8 = null,
                    subnet_availability_zone_id: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .firewall_subnet_id = "FirewallSubnetId",
                            .vpc_id = "VpcId",
                            .subnet_availability_zone = "SubnetAvailabilityZone",
                            .subnet_availability_zone_id = "SubnetAvailabilityZoneId",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .aws_vpc_security_group_violation = "AwsVPCSecurityGroupViolation",
                        .aws_ec2_network_interface_violation = "AwsEc2NetworkInterfaceViolation",
                        .aws_ec2_instance_violation = "AwsEc2InstanceViolation",
                        .network_firewall_missing_firewall_violation = "NetworkFirewallMissingFirewallViolation",
                        .network_firewall_missing_subnet_violation = "NetworkFirewallMissingSubnetViolation",
                        .network_firewall_missing_expected_rt_violation = "NetworkFirewallMissingExpectedRTViolation",
                        .network_firewall_policy_modified_violation = "NetworkFirewallPolicyModifiedViolation",
                        .network_firewall_internet_traffic_not_inspected_violation = "NetworkFirewallInternetTrafficNotInspectedViolation",
                        .network_firewall_invalid_route_configuration_violation = "NetworkFirewallInvalidRouteConfigurationViolation",
                        .network_firewall_black_hole_route_detected_violation = "NetworkFirewallBlackHoleRouteDetectedViolation",
                        .network_firewall_unexpected_firewall_routes_violation = "NetworkFirewallUnexpectedFirewallRoutesViolation",
                        .network_firewall_unexpected_gateway_routes_violation = "NetworkFirewallUnexpectedGatewayRoutesViolation",
                        .network_firewall_missing_expected_routes_violation = "NetworkFirewallMissingExpectedRoutesViolation",
                        .dns_rule_group_priority_conflict_violation = "DnsRuleGroupPriorityConflictViolation",
                        .dns_duplicate_rule_group_violation = "DnsDuplicateRuleGroupViolation",
                        .dns_rule_group_limit_exceeded_violation = "DnsRuleGroupLimitExceededViolation",
                        .possible_remediation_actions = "PossibleRemediationActions",
                        .firewall_subnet_is_out_of_scope_violation = "FirewallSubnetIsOutOfScopeViolation",
                        .route_has_out_of_scope_endpoint_violation = "RouteHasOutOfScopeEndpointViolation",
                        .third_party_firewall_missing_firewall_violation = "ThirdPartyFirewallMissingFirewallViolation",
                        .third_party_firewall_missing_subnet_violation = "ThirdPartyFirewallMissingSubnetViolation",
                        .third_party_firewall_missing_expected_route_table_violation = "ThirdPartyFirewallMissingExpectedRouteTableViolation",
                        .firewall_subnet_missing_vpc_endpoint_violation = "FirewallSubnetMissingVPCEndpointViolation",
                    };
                    return @field(mappings, field_name);
                }
            },
            resource_tags: ?[]Tag = null,
            resource_description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_id = "PolicyId",
                    .member_account = "MemberAccount",
                    .resource_id = "ResourceId",
                    .resource_type = "ResourceType",
                    .resource_violations = "ResourceViolations",
                    .resource_tags = "ResourceTags",
                    .resource_description = "ResourceDescription",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .violation_detail = "ViolationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_admin_accounts_for_organization: struct {
    action_name: []const u8 = "ListAdminAccountsForOrganization",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_admin_accounts_for_organization) } {
            return .{ .service_metadata = service_metadata, .action = list_admin_accounts_for_organization };
        }
    },
    Response: type = struct {
        admin_accounts: ?[]struct {
            admin_account: ?[]const u8 = null,
            default_admin: ?bool = null,
            status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .admin_account = "AdminAccount",
                    .default_admin = "DefaultAdmin",
                    .status = "Status",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_accounts = "AdminAccounts",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const list_admins_managing_account: struct {
    action_name: []const u8 = "ListAdminsManagingAccount",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_admins_managing_account) } {
            return .{ .service_metadata = service_metadata, .action = list_admins_managing_account };
        }
    },
    Response: type = struct {
        admin_accounts: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_accounts = "AdminAccounts",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_apps_lists: struct {
    action_name: []const u8 = "ListAppsLists",
    Request: type = struct {
        default_lists: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .default_lists = "DefaultLists",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_apps_lists) } {
            return .{ .service_metadata = service_metadata, .action = list_apps_lists };
        }
    },
    Response: type = struct {
        apps_lists: ?[]struct {
            list_arn: ?[]const u8 = null,
            list_id: ?[]const u8 = null,
            list_name: ?[]const u8 = null,
            apps_list: ?[]App = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .list_arn = "ListArn",
                    .list_id = "ListId",
                    .list_name = "ListName",
                    .apps_list = "AppsList",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_lists = "AppsLists",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const list_compliance_status: struct {
    action_name: []const u8 = "ListComplianceStatus",
    Request: type = struct {
        policy_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_compliance_status) } {
            return .{ .service_metadata = service_metadata, .action = list_compliance_status };
        }
    },
    Response: type = struct {
        policy_compliance_status_list: ?[]struct {
            policy_owner: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            policy_name: ?[]const u8 = null,
            member_account: ?[]const u8 = null,
            evaluation_results: ?[]struct {
                compliance_status: ?[]const u8 = null,
                violator_count: ?i64 = null,
                evaluation_limit_exceeded: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .compliance_status = "ComplianceStatus",
                        .violator_count = "ViolatorCount",
                        .evaluation_limit_exceeded = "EvaluationLimitExceeded",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            last_updated: ?i64 = null,
            issue_info_map: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_owner = "PolicyOwner",
                    .policy_id = "PolicyId",
                    .policy_name = "PolicyName",
                    .member_account = "MemberAccount",
                    .evaluation_results = "EvaluationResults",
                    .last_updated = "LastUpdated",
                    .issue_info_map = "IssueInfoMap",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "issue_info_map", field_name))
                    return try serializeMap(self.issue_info_map, self.fieldNameFor("issue_info_map"), options, out_stream);
                return false;
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_compliance_status_list = "PolicyComplianceStatusList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const list_discovered_resources: struct {
    action_name: []const u8 = "ListDiscoveredResources",
    Request: type = struct {
        member_account_ids: [][]const u8,
        resource_type: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .member_account_ids = "MemberAccountIds",
                .resource_type = "ResourceType",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_discovered_resources) } {
            return .{ .service_metadata = service_metadata, .action = list_discovered_resources };
        }
    },
    Response: type = struct {
        items: ?[]struct {
            uri: ?[]const u8 = null,
            account_id: ?[]const u8 = null,
            type: ?[]const u8 = null,
            name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .uri = "URI",
                    .account_id = "AccountId",
                    .type = "Type",
                    .name = "Name",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .items = "Items",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
    },
} = .{};
pub const list_member_accounts: struct {
    action_name: []const u8 = "ListMemberAccounts",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_member_accounts) } {
            return .{ .service_metadata = service_metadata, .action = list_member_accounts };
        }
    },
    Response: type = struct {
        member_accounts: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .member_accounts = "MemberAccounts",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const list_policies: struct {
    action_name: []const u8 = "ListPolicies",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_policies };
        }
    },
    Response: type = struct {
        policy_list: ?[]struct {
            policy_arn: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            policy_name: ?[]const u8 = null,
            resource_type: ?[]const u8 = null,
            security_service_type: ?[]const u8 = null,
            remediation_enabled: ?bool = null,
            delete_unused_fm_managed_resources: ?bool = null,
            policy_status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_arn = "PolicyArn",
                    .policy_id = "PolicyId",
                    .policy_name = "PolicyName",
                    .resource_type = "ResourceType",
                    .security_service_type = "SecurityServiceType",
                    .remediation_enabled = "RemediationEnabled",
                    .delete_unused_fm_managed_resources = "DeleteUnusedFMManagedResources",
                    .policy_status = "PolicyStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_list = "PolicyList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const list_protocols_lists: struct {
    action_name: []const u8 = "ListProtocolsLists",
    Request: type = struct {
        default_lists: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .default_lists = "DefaultLists",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_protocols_lists) } {
            return .{ .service_metadata = service_metadata, .action = list_protocols_lists };
        }
    },
    Response: type = struct {
        protocols_lists: ?[]struct {
            list_arn: ?[]const u8 = null,
            list_id: ?[]const u8 = null,
            list_name: ?[]const u8 = null,
            protocols_list: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .list_arn = "ListArn",
                    .list_id = "ListId",
                    .list_name = "ListName",
                    .protocols_list = "ProtocolsList",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_lists = "ProtocolsLists",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const list_resource_set_resources: struct {
    action_name: []const u8 = "ListResourceSetResources",
    Request: type = struct {
        identifier: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .identifier = "Identifier",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resource_set_resources) } {
            return .{ .service_metadata = service_metadata, .action = list_resource_set_resources };
        }
    },
    Response: type = struct {
        items: []struct {
            uri: []const u8,
            account_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .uri = "URI",
                    .account_id = "AccountId",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .items = "Items",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const list_resource_sets: struct {
    action_name: []const u8 = "ListResourceSets",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resource_sets) } {
            return .{ .service_metadata = service_metadata, .action = list_resource_sets };
        }
    },
    Response: type = struct {
        resource_sets: ?[]struct {
            id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            last_update_time: ?i64 = null,
            resource_set_status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .name = "Name",
                    .description = "Description",
                    .last_update_time = "LastUpdateTime",
                    .resource_set_status = "ResourceSetStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_sets = "ResourceSets",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const list_third_party_firewall_firewall_policies: struct {
    action_name: []const u8 = "ListThirdPartyFirewallFirewallPolicies",
    Request: type = struct {
        third_party_firewall: []const u8,
        next_token: ?[]const u8 = null,
        max_results: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall = "ThirdPartyFirewall",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_third_party_firewall_firewall_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_third_party_firewall_firewall_policies };
        }
    },
    Response: type = struct {
        third_party_firewall_firewall_policies: ?[]struct {
            firewall_policy_id: ?[]const u8 = null,
            firewall_policy_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .firewall_policy_id = "FirewallPolicyId",
                    .firewall_policy_name = "FirewallPolicyName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .third_party_firewall_firewall_policies = "ThirdPartyFirewallFirewallPolicies",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const put_admin_account: struct {
    action_name: []const u8 = "PutAdminAccount",
    Request: type = struct {
        admin_account: []const u8,
        admin_scope: ?AdminScope = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
                .admin_scope = "AdminScope",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = put_admin_account };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
    },
} = .{};
pub const put_apps_list: struct {
    action_name: []const u8 = "PutAppsList",
    Request: type = struct {
        apps_list: AppsListData,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = put_apps_list };
        }
    },
    Response: type = struct {
        apps_list: ?AppsListData = null,
        apps_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .apps_list_arn = "AppsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_notification_channel: struct {
    action_name: []const u8 = "PutNotificationChannel",
    Request: type = struct {
        sns_topic_arn: []const u8,
        sns_role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sns_topic_arn = "SnsTopicArn",
                .sns_role_name = "SnsRoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = put_notification_channel };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const put_policy: struct {
    action_name: []const u8 = "PutPolicy",
    Request: type = struct {
        policy: Policy,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,
        policy_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_protocols_list: struct {
    action_name: []const u8 = "PutProtocolsList",
    Request: type = struct {
        protocols_list: ProtocolsListData,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = put_protocols_list };
        }
    },
    Response: type = struct {
        protocols_list: ?ProtocolsListData = null,
        protocols_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .protocols_list_arn = "ProtocolsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_resource_set: struct {
    action_name: []const u8 = "PutResourceSet",
    Request: type = struct {
        resource_set: ResourceSet,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set = "ResourceSet",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resource_set) } {
            return .{ .service_metadata = service_metadata, .action = put_resource_set };
        }
    },
    Response: type = struct {
        resource_set: ResourceSet,
        resource_set_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_set = "ResourceSet",
                .resource_set_arn = "ResourceSetArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_list: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const ResourceSet = struct {
    id: ?[]const u8 = null,
    name: []const u8,
    description: ?[]const u8 = null,
    update_token: ?[]const u8 = null,
    resource_type_list: [][]const u8,
    last_update_time: ?i64 = null,
    resource_set_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .name = "Name",
            .description = "Description",
            .update_token = "UpdateToken",
            .resource_type_list = "ResourceTypeList",
            .last_update_time = "LastUpdateTime",
            .resource_set_status = "ResourceSetStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const ProtocolsListData = struct {
    list_id: ?[]const u8 = null,
    list_name: []const u8,
    list_update_token: ?[]const u8 = null,
    create_time: ?i64 = null,
    last_update_time: ?i64 = null,
    protocols_list: [][]const u8,
    previous_protocols_list: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .list_id = "ListId",
            .list_name = "ListName",
            .list_update_token = "ListUpdateToken",
            .create_time = "CreateTime",
            .last_update_time = "LastUpdateTime",
            .protocols_list = "ProtocolsList",
            .previous_protocols_list = "PreviousProtocolsList",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "previous_protocols_list", field_name))
            return try serializeMap(self.previous_protocols_list, self.fieldNameFor("previous_protocols_list"), options, out_stream);
        return false;
    }
};

pub const Policy = struct {
    policy_id: ?[]const u8 = null,
    policy_name: []const u8,
    policy_update_token: ?[]const u8 = null,
    security_service_policy_data: SecurityServicePolicyData,
    resource_type: []const u8,
    resource_type_list: ?[][]const u8 = null,
    resource_tags: ?[]ResourceTag = null,
    exclude_resource_tags: bool,
    remediation_enabled: bool,
    delete_unused_fm_managed_resources: ?bool = null,
    include_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,
    exclude_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,
    resource_set_ids: ?[][]const u8 = null,
    policy_description: ?[]const u8 = null,
    policy_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_id = "PolicyId",
            .policy_name = "PolicyName",
            .policy_update_token = "PolicyUpdateToken",
            .security_service_policy_data = "SecurityServicePolicyData",
            .resource_type = "ResourceType",
            .resource_type_list = "ResourceTypeList",
            .resource_tags = "ResourceTags",
            .exclude_resource_tags = "ExcludeResourceTags",
            .remediation_enabled = "RemediationEnabled",
            .delete_unused_fm_managed_resources = "DeleteUnusedFMManagedResources",
            .include_map = "IncludeMap",
            .exclude_map = "ExcludeMap",
            .resource_set_ids = "ResourceSetIds",
            .policy_description = "PolicyDescription",
            .policy_status = "PolicyStatus",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "include_map", field_name))
            return try serializeMap(self.include_map, self.fieldNameFor("include_map"), options, out_stream);
        if (std.mem.eql(u8, "exclude_map", field_name))
            return try serializeMap(self.exclude_map, self.fieldNameFor("exclude_map"), options, out_stream);
        return false;
    }
};

pub const ResourceTag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const SecurityServicePolicyData = struct {
    type: []const u8,
    managed_service_data: ?[]const u8 = null,
    policy_option: ?PolicyOption = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .managed_service_data = "ManagedServiceData",
            .policy_option = "PolicyOption",
        };
        return @field(mappings, field_name);
    }
};

pub const PolicyOption = struct {
    network_firewall_policy: ?NetworkFirewallPolicy = null,
    third_party_firewall_policy: ?ThirdPartyFirewallPolicy = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .network_firewall_policy = "NetworkFirewallPolicy",
            .third_party_firewall_policy = "ThirdPartyFirewallPolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const ThirdPartyFirewallPolicy = struct {
    firewall_deployment_model: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .firewall_deployment_model = "FirewallDeploymentModel",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkFirewallPolicy = struct {
    firewall_deployment_model: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .firewall_deployment_model = "FirewallDeploymentModel",
        };
        return @field(mappings, field_name);
    }
};

pub const AppsListData = struct {
    list_id: ?[]const u8 = null,
    list_name: []const u8,
    list_update_token: ?[]const u8 = null,
    create_time: ?i64 = null,
    last_update_time: ?i64 = null,
    apps_list: []App,
    previous_apps_list: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]App = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .list_id = "ListId",
            .list_name = "ListName",
            .list_update_token = "ListUpdateToken",
            .create_time = "CreateTime",
            .last_update_time = "LastUpdateTime",
            .apps_list = "AppsList",
            .previous_apps_list = "PreviousAppsList",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "previous_apps_list", field_name))
            return try serializeMap(self.previous_apps_list, self.fieldNameFor("previous_apps_list"), options, out_stream);
        return false;
    }
};

pub const App = struct {
    app_name: []const u8,
    protocol: []const u8,
    port: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .app_name = "AppName",
            .protocol = "Protocol",
            .port = "Port",
        };
        return @field(mappings, field_name);
    }
};

pub const AdminScope = struct {
    account_scope: ?AccountScope = null,
    organizational_unit_scope: ?OrganizationalUnitScope = null,
    region_scope: ?RegionScope = null,
    policy_type_scope: ?PolicyTypeScope = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .account_scope = "AccountScope",
            .organizational_unit_scope = "OrganizationalUnitScope",
            .region_scope = "RegionScope",
            .policy_type_scope = "PolicyTypeScope",
        };
        return @field(mappings, field_name);
    }
};

pub const PolicyTypeScope = struct {
    policy_types: ?[][]const u8 = null,
    all_policy_types_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_types = "PolicyTypes",
            .all_policy_types_enabled = "AllPolicyTypesEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const RegionScope = struct {
    regions: ?[][]const u8 = null,
    all_regions_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .regions = "Regions",
            .all_regions_enabled = "AllRegionsEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const OrganizationalUnitScope = struct {
    organizational_units: ?[][]const u8 = null,
    all_organizational_units_enabled: ?bool = null,
    exclude_specified_organizational_units: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .organizational_units = "OrganizationalUnits",
            .all_organizational_units_enabled = "AllOrganizationalUnitsEnabled",
            .exclude_specified_organizational_units = "ExcludeSpecifiedOrganizationalUnits",
        };
        return @field(mappings, field_name);
    }
};

pub const AccountScope = struct {
    accounts: ?[][]const u8 = null,
    all_accounts_enabled: ?bool = null,
    exclude_specified_accounts: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .accounts = "Accounts",
            .all_accounts_enabled = "AllAccountsEnabled",
            .exclude_specified_accounts = "ExcludeSpecifiedAccounts",
        };
        return @field(mappings, field_name);
    }
};

pub const Route = struct {
    destination_type: ?[]const u8 = null,
    target_type: ?[]const u8 = null,
    destination: ?[]const u8 = null,
    target: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .destination_type = "DestinationType",
            .target_type = "TargetType",
            .destination = "Destination",
            .target = "Target",
        };
        return @field(mappings, field_name);
    }
};

pub const ActionTarget = struct {
    resource_id: ?[]const u8 = null,
    description: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_id = "ResourceId",
            .description = "Description",
        };
        return @field(mappings, field_name);
    }
};

pub const ExpectedRoute = struct {
    ip_v4_cidr: ?[]const u8 = null,
    prefix_list_id: ?[]const u8 = null,
    ip_v6_cidr: ?[]const u8 = null,
    contributing_subnets: ?[][]const u8 = null,
    allowed_targets: ?[][]const u8 = null,
    route_table_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ip_v4_cidr = "IpV4Cidr",
            .prefix_list_id = "PrefixListId",
            .ip_v6_cidr = "IpV6Cidr",
            .contributing_subnets = "ContributingSubnets",
            .allowed_targets = "AllowedTargets",
            .route_table_id = "RouteTableId",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkFirewallPolicyDescription = struct {
    stateless_rule_groups: ?[]StatelessRuleGroup = null,
    stateless_default_actions: ?[][]const u8 = null,
    stateless_fragment_default_actions: ?[][]const u8 = null,
    stateless_custom_actions: ?[][]const u8 = null,
    stateful_rule_groups: ?[]StatefulRuleGroup = null,
    stateful_default_actions: ?[][]const u8 = null,
    stateful_engine_options: ?StatefulEngineOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .stateless_rule_groups = "StatelessRuleGroups",
            .stateless_default_actions = "StatelessDefaultActions",
            .stateless_fragment_default_actions = "StatelessFragmentDefaultActions",
            .stateless_custom_actions = "StatelessCustomActions",
            .stateful_rule_groups = "StatefulRuleGroups",
            .stateful_default_actions = "StatefulDefaultActions",
            .stateful_engine_options = "StatefulEngineOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const StatefulEngineOptions = struct {
    rule_order: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rule_order = "RuleOrder",
        };
        return @field(mappings, field_name);
    }
};

pub const StatefulRuleGroup = struct {
    rule_group_name: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    priority: ?i64 = null,
    override: ?NetworkFirewallStatefulRuleGroupOverride = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rule_group_name = "RuleGroupName",
            .resource_id = "ResourceId",
            .priority = "Priority",
            .override = "Override",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkFirewallStatefulRuleGroupOverride = struct {
    action: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action = "Action",
        };
        return @field(mappings, field_name);
    }
};

pub const StatelessRuleGroup = struct {
    rule_group_name: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    priority: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rule_group_name = "RuleGroupName",
            .resource_id = "ResourceId",
            .priority = "Priority",
        };
        return @field(mappings, field_name);
    }
};

pub const AwsEc2NetworkInterfaceViolation = struct {
    violation_target: ?[]const u8 = null,
    violating_security_groups: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .violation_target = "ViolationTarget",
            .violating_security_groups = "ViolatingSecurityGroups",
        };
        return @field(mappings, field_name);
    }
};

pub const FailedItem = struct {
    uri: ?[]const u8 = null,
    reason: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .uri = "URI",
            .reason = "Reason",
        };
        return @field(mappings, field_name);
    }
};
