const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2019-11-15";
pub const sdk_id: []const u8 = "FraudDetector";
pub const arn_namespace: ?[]const u8 = "frauddetector";
pub const endpoint_prefix: []const u8 = "frauddetector";
pub const sigv4_name: []const u8 = "frauddetector";
pub const name: []const u8 = "AWSHawksNestServiceFacade";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2019-11-15",
    sdk_id: []const u8 = "FraudDetector",
    arn_namespace: ?[]const u8 = "frauddetector",
    endpoint_prefix: []const u8 = "frauddetector",
    sigv4_name: []const u8 = "frauddetector",
    name: []const u8 = "AWSHawksNestServiceFacade",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const batch_create_variable: struct {
    action_name: []const u8 = "BatchCreateVariable",
    Request: type = struct {
        variable_entries: []struct {
            name: ?[]const u8 = null,
            data_type: ?[]const u8 = null,
            data_source: ?[]const u8 = null,
            default_value: ?[]const u8 = null,
            description: ?[]const u8 = null,
            variable_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .data_type = "dataType",
                    .data_source = "dataSource",
                    .default_value = "defaultValue",
                    .description = "description",
                    .variable_type = "variableType",
                };
                return @field(mappings, field_name);
            }
        },
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .variable_entries = "variableEntries",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_create_variable) } {
            return .{ .service_metadata = service_metadata, .action = batch_create_variable };
        }
    },
    Response: type = struct {
        errors: ?[]struct {
            name: ?[]const u8 = null,
            code: ?i64 = null,
            message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .code = "code",
                    .message = "message",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .errors = "errors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const batch_get_variable: struct {
    action_name: []const u8 = "BatchGetVariable",
    Request: type = struct {
        names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .names = "names",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_get_variable) } {
            return .{ .service_metadata = service_metadata, .action = batch_get_variable };
        }
    },
    Response: type = struct {
        variables: ?[]Variable = null,
        errors: ?[]struct {
            name: ?[]const u8 = null,
            code: ?i64 = null,
            message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .code = "code",
                    .message = "message",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .variables = "variables",
                .errors = "errors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const cancel_batch_import_job: struct {
    action_name: []const u8 = "CancelBatchImportJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_batch_import_job) } {
            return .{ .service_metadata = service_metadata, .action = cancel_batch_import_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const cancel_batch_prediction_job: struct {
    action_name: []const u8 = "CancelBatchPredictionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_batch_prediction_job) } {
            return .{ .service_metadata = service_metadata, .action = cancel_batch_prediction_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_batch_import_job: struct {
    action_name: []const u8 = "CreateBatchImportJob",
    Request: type = struct {
        job_id: []const u8,
        input_path: []const u8,
        output_path: []const u8,
        event_type_name: []const u8,
        iam_role_arn: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
                .input_path = "inputPath",
                .output_path = "outputPath",
                .event_type_name = "eventTypeName",
                .iam_role_arn = "iamRoleArn",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_batch_import_job) } {
            return .{ .service_metadata = service_metadata, .action = create_batch_import_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_batch_prediction_job: struct {
    action_name: []const u8 = "CreateBatchPredictionJob",
    Request: type = struct {
        job_id: []const u8,
        input_path: []const u8,
        output_path: []const u8,
        event_type_name: []const u8,
        detector_name: []const u8,
        detector_version: ?[]const u8 = null,
        iam_role_arn: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
                .input_path = "inputPath",
                .output_path = "outputPath",
                .event_type_name = "eventTypeName",
                .detector_name = "detectorName",
                .detector_version = "detectorVersion",
                .iam_role_arn = "iamRoleArn",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_batch_prediction_job) } {
            return .{ .service_metadata = service_metadata, .action = create_batch_prediction_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_detector_version: struct {
    action_name: []const u8 = "CreateDetectorVersion",
    Request: type = struct {
        detector_id: []const u8,
        description: ?[]const u8 = null,
        external_model_endpoints: ?[][]const u8 = null,
        rules: []Rule,
        model_versions: ?[]ModelVersion = null,
        rule_execution_mode: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .description = "description",
                .external_model_endpoints = "externalModelEndpoints",
                .rules = "rules",
                .model_versions = "modelVersions",
                .rule_execution_mode = "ruleExecutionMode",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_detector_version) } {
            return .{ .service_metadata = service_metadata, .action = create_detector_version };
        }
    },
    Response: type = struct {
        detector_id: ?[]const u8 = null,
        detector_version_id: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .status = "status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_list: struct {
    action_name: []const u8 = "CreateList",
    Request: type = struct {
        name: []const u8,
        elements: ?[][]const u8 = null,
        variable_type: ?[]const u8 = null,
        description: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .elements = "elements",
                .variable_type = "variableType",
                .description = "description",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_list) } {
            return .{ .service_metadata = service_metadata, .action = create_list };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const create_model: struct {
    action_name: []const u8 = "CreateModel",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        description: ?[]const u8 = null,
        event_type_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .description = "description",
                .event_type_name = "eventTypeName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_model) } {
            return .{ .service_metadata = service_metadata, .action = create_model };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const create_model_version: struct {
    action_name: []const u8 = "CreateModelVersion",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        training_data_source: []const u8,
        training_data_schema: TrainingDataSchema,
        external_events_detail: ?ExternalEventsDetail = null,
        ingested_events_detail: ?IngestedEventsDetail = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .training_data_source = "trainingDataSource",
                .training_data_schema = "trainingDataSchema",
                .external_events_detail = "externalEventsDetail",
                .ingested_events_detail = "ingestedEventsDetail",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_model_version) } {
            return .{ .service_metadata = service_metadata, .action = create_model_version };
        }
    },
    Response: type = struct {
        model_id: ?[]const u8 = null,
        model_type: ?[]const u8 = null,
        model_version_number: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
                .status = "status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_rule: struct {
    action_name: []const u8 = "CreateRule",
    Request: type = struct {
        rule_id: []const u8,
        detector_id: []const u8,
        description: ?[]const u8 = null,
        expression: []const u8,
        language: []const u8,
        outcomes: [][]const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_id = "ruleId",
                .detector_id = "detectorId",
                .description = "description",
                .expression = "expression",
                .language = "language",
                .outcomes = "outcomes",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_rule) } {
            return .{ .service_metadata = service_metadata, .action = create_rule };
        }
    },
    Response: type = struct {
        rule: ?Rule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule = "rule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const create_variable: struct {
    action_name: []const u8 = "CreateVariable",
    Request: type = struct {
        name: []const u8,
        data_type: []const u8,
        data_source: []const u8,
        default_value: []const u8,
        description: ?[]const u8 = null,
        variable_type: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .data_type = "dataType",
                .data_source = "dataSource",
                .default_value = "defaultValue",
                .description = "description",
                .variable_type = "variableType",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_variable) } {
            return .{ .service_metadata = service_metadata, .action = create_variable };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_batch_import_job: struct {
    action_name: []const u8 = "DeleteBatchImportJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_batch_import_job) } {
            return .{ .service_metadata = service_metadata, .action = delete_batch_import_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_batch_prediction_job: struct {
    action_name: []const u8 = "DeleteBatchPredictionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_batch_prediction_job) } {
            return .{ .service_metadata = service_metadata, .action = delete_batch_prediction_job };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_detector: struct {
    action_name: []const u8 = "DeleteDetector",
    Request: type = struct {
        detector_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_detector) } {
            return .{ .service_metadata = service_metadata, .action = delete_detector };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_detector_version: struct {
    action_name: []const u8 = "DeleteDetectorVersion",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_detector_version) } {
            return .{ .service_metadata = service_metadata, .action = delete_detector_version };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_entity_type: struct {
    action_name: []const u8 = "DeleteEntityType",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_entity_type) } {
            return .{ .service_metadata = service_metadata, .action = delete_entity_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_event: struct {
    action_name: []const u8 = "DeleteEvent",
    Request: type = struct {
        event_id: []const u8,
        event_type_name: []const u8,
        delete_audit_history: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .delete_audit_history = "deleteAuditHistory",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_event) } {
            return .{ .service_metadata = service_metadata, .action = delete_event };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_events_by_event_type: struct {
    action_name: []const u8 = "DeleteEventsByEventType",
    Request: type = struct {
        event_type_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_type_name = "eventTypeName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_events_by_event_type) } {
            return .{ .service_metadata = service_metadata, .action = delete_events_by_event_type };
        }
    },
    Response: type = struct {
        event_type_name: ?[]const u8 = null,
        events_deletion_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_type_name = "eventTypeName",
                .events_deletion_status = "eventsDeletionStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_event_type: struct {
    action_name: []const u8 = "DeleteEventType",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_event_type) } {
            return .{ .service_metadata = service_metadata, .action = delete_event_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_external_model: struct {
    action_name: []const u8 = "DeleteExternalModel",
    Request: type = struct {
        model_endpoint: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_endpoint = "modelEndpoint",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_external_model) } {
            return .{ .service_metadata = service_metadata, .action = delete_external_model };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_label: struct {
    action_name: []const u8 = "DeleteLabel",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_label) } {
            return .{ .service_metadata = service_metadata, .action = delete_label };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_list: struct {
    action_name: []const u8 = "DeleteList",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_list };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_model: struct {
    action_name: []const u8 = "DeleteModel",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_model) } {
            return .{ .service_metadata = service_metadata, .action = delete_model };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_model_version: struct {
    action_name: []const u8 = "DeleteModelVersion",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        model_version_number: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_model_version) } {
            return .{ .service_metadata = service_metadata, .action = delete_model_version };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_outcome: struct {
    action_name: []const u8 = "DeleteOutcome",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_outcome) } {
            return .{ .service_metadata = service_metadata, .action = delete_outcome };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_rule: struct {
    action_name: []const u8 = "DeleteRule",
    Request: type = struct {
        rule: Rule,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule = "rule",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_rule) } {
            return .{ .service_metadata = service_metadata, .action = delete_rule };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_variable: struct {
    action_name: []const u8 = "DeleteVariable",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_variable) } {
            return .{ .service_metadata = service_metadata, .action = delete_variable };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const describe_detector: struct {
    action_name: []const u8 = "DescribeDetector",
    Request: type = struct {
        detector_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_detector) } {
            return .{ .service_metadata = service_metadata, .action = describe_detector };
        }
    },
    Response: type = struct {
        detector_id: ?[]const u8 = null,
        detector_version_summaries: ?[]struct {
            detector_version_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            description: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .detector_version_id = "detectorVersionId",
                    .status = "status",
                    .description = "description",
                    .last_updated_time = "lastUpdatedTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_summaries = "detectorVersionSummaries",
                .next_token = "nextToken",
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const describe_model_versions: struct {
    action_name: []const u8 = "DescribeModelVersions",
    Request: type = struct {
        model_id: ?[]const u8 = null,
        model_version_number: ?[]const u8 = null,
        model_type: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_version_number = "modelVersionNumber",
                .model_type = "modelType",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_model_versions) } {
            return .{ .service_metadata = service_metadata, .action = describe_model_versions };
        }
    },
    Response: type = struct {
        model_version_details: ?[]struct {
            model_id: ?[]const u8 = null,
            model_type: ?[]const u8 = null,
            model_version_number: ?[]const u8 = null,
            status: ?[]const u8 = null,
            training_data_source: ?[]const u8 = null,
            training_data_schema: ?TrainingDataSchema = null,
            external_events_detail: ?ExternalEventsDetail = null,
            ingested_events_detail: ?IngestedEventsDetail = null,
            training_result: ?struct {
                data_validation_metrics: ?DataValidationMetrics = null,
                training_metrics: ?struct {
                    auc: ?f32 = null,
                    metric_data_points: ?[]struct {
                        fpr: ?f32 = null,
                        precision: ?f32 = null,
                        tpr: ?f32 = null,
                        threshold: ?f32 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .fpr = "fpr",
                                .precision = "precision",
                                .tpr = "tpr",
                                .threshold = "threshold",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .auc = "auc",
                            .metric_data_points = "metricDataPoints",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                variable_importance_metrics: ?VariableImportanceMetrics = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .data_validation_metrics = "dataValidationMetrics",
                        .training_metrics = "trainingMetrics",
                        .variable_importance_metrics = "variableImportanceMetrics",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            training_result_v2: ?struct {
                data_validation_metrics: ?DataValidationMetrics = null,
                training_metrics_v2: ?struct {
                    ofi: ?struct {
                        metric_data_points: ?[]struct {
                            fpr: ?f32 = null,
                            precision: ?f32 = null,
                            tpr: ?f32 = null,
                            threshold: ?f32 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .fpr = "fpr",
                                    .precision = "precision",
                                    .tpr = "tpr",
                                    .threshold = "threshold",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,
                        model_performance: ?struct {
                            auc: ?f32 = null,
                            uncertainty_range: ?UncertaintyRange = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .auc = "auc",
                                    .uncertainty_range = "uncertaintyRange",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .metric_data_points = "metricDataPoints",
                                .model_performance = "modelPerformance",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    tfi: ?struct {
                        metric_data_points: ?[]struct {
                            fpr: ?f32 = null,
                            precision: ?f32 = null,
                            tpr: ?f32 = null,
                            threshold: ?f32 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .fpr = "fpr",
                                    .precision = "precision",
                                    .tpr = "tpr",
                                    .threshold = "threshold",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,
                        model_performance: ?struct {
                            auc: ?f32 = null,
                            uncertainty_range: ?UncertaintyRange = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .auc = "auc",
                                    .uncertainty_range = "uncertaintyRange",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .metric_data_points = "metricDataPoints",
                                .model_performance = "modelPerformance",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    ati: ?struct {
                        metric_data_points: ?[]struct {
                            cr: ?f32 = null,
                            adr: ?f32 = null,
                            threshold: ?f32 = null,
                            atodr: ?f32 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .cr = "cr",
                                    .adr = "adr",
                                    .threshold = "threshold",
                                    .atodr = "atodr",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,
                        model_performance: ?struct {
                            asi: ?f32 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .asi = "asi",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .metric_data_points = "metricDataPoints",
                                .model_performance = "modelPerformance",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .ofi = "ofi",
                            .tfi = "tfi",
                            .ati = "ati",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                variable_importance_metrics: ?VariableImportanceMetrics = null,
                aggregated_variables_importance_metrics: ?struct {
                    log_odds_metrics: ?[]struct {
                        variable_names: [][]const u8,
                        aggregated_variables_importance: f32,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .variable_names = "variableNames",
                                .aggregated_variables_importance = "aggregatedVariablesImportance",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .log_odds_metrics = "logOddsMetrics",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .data_validation_metrics = "dataValidationMetrics",
                        .training_metrics_v2 = "trainingMetricsV2",
                        .variable_importance_metrics = "variableImportanceMetrics",
                        .aggregated_variables_importance_metrics = "aggregatedVariablesImportanceMetrics",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_id = "modelId",
                    .model_type = "modelType",
                    .model_version_number = "modelVersionNumber",
                    .status = "status",
                    .training_data_source = "trainingDataSource",
                    .training_data_schema = "trainingDataSchema",
                    .external_events_detail = "externalEventsDetail",
                    .ingested_events_detail = "ingestedEventsDetail",
                    .training_result = "trainingResult",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                    .training_result_v2 = "trainingResultV2",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_version_details = "modelVersionDetails",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_batch_import_jobs: struct {
    action_name: []const u8 = "GetBatchImportJobs",
    Request: type = struct {
        job_id: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_batch_import_jobs) } {
            return .{ .service_metadata = service_metadata, .action = get_batch_import_jobs };
        }
    },
    Response: type = struct {
        batch_imports: ?[]struct {
            job_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            failure_reason: ?[]const u8 = null,
            start_time: ?[]const u8 = null,
            completion_time: ?[]const u8 = null,
            input_path: ?[]const u8 = null,
            output_path: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            iam_role_arn: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            processed_records_count: ?i64 = null,
            failed_records_count: ?i64 = null,
            total_records_count: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_id = "jobId",
                    .status = "status",
                    .failure_reason = "failureReason",
                    .start_time = "startTime",
                    .completion_time = "completionTime",
                    .input_path = "inputPath",
                    .output_path = "outputPath",
                    .event_type_name = "eventTypeName",
                    .iam_role_arn = "iamRoleArn",
                    .arn = "arn",
                    .processed_records_count = "processedRecordsCount",
                    .failed_records_count = "failedRecordsCount",
                    .total_records_count = "totalRecordsCount",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .batch_imports = "batchImports",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_batch_prediction_jobs: struct {
    action_name: []const u8 = "GetBatchPredictionJobs",
    Request: type = struct {
        job_id: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "jobId",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_batch_prediction_jobs) } {
            return .{ .service_metadata = service_metadata, .action = get_batch_prediction_jobs };
        }
    },
    Response: type = struct {
        batch_predictions: ?[]struct {
            job_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            failure_reason: ?[]const u8 = null,
            start_time: ?[]const u8 = null,
            completion_time: ?[]const u8 = null,
            last_heartbeat_time: ?[]const u8 = null,
            input_path: ?[]const u8 = null,
            output_path: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            detector_name: ?[]const u8 = null,
            detector_version: ?[]const u8 = null,
            iam_role_arn: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            processed_records_count: ?i64 = null,
            total_records_count: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_id = "jobId",
                    .status = "status",
                    .failure_reason = "failureReason",
                    .start_time = "startTime",
                    .completion_time = "completionTime",
                    .last_heartbeat_time = "lastHeartbeatTime",
                    .input_path = "inputPath",
                    .output_path = "outputPath",
                    .event_type_name = "eventTypeName",
                    .detector_name = "detectorName",
                    .detector_version = "detectorVersion",
                    .iam_role_arn = "iamRoleArn",
                    .arn = "arn",
                    .processed_records_count = "processedRecordsCount",
                    .total_records_count = "totalRecordsCount",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .batch_predictions = "batchPredictions",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_delete_events_by_event_type_status: struct {
    action_name: []const u8 = "GetDeleteEventsByEventTypeStatus",
    Request: type = struct {
        event_type_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_type_name = "eventTypeName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_delete_events_by_event_type_status) } {
            return .{ .service_metadata = service_metadata, .action = get_delete_events_by_event_type_status };
        }
    },
    Response: type = struct {
        event_type_name: ?[]const u8 = null,
        events_deletion_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_type_name = "eventTypeName",
                .events_deletion_status = "eventsDeletionStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_detectors: struct {
    action_name: []const u8 = "GetDetectors",
    Request: type = struct {
        detector_id: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_detectors) } {
            return .{ .service_metadata = service_metadata, .action = get_detectors };
        }
    },
    Response: type = struct {
        detectors: ?[]struct {
            detector_id: ?[]const u8 = null,
            description: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .detector_id = "detectorId",
                    .description = "description",
                    .event_type_name = "eventTypeName",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detectors = "detectors",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_detector_version: struct {
    action_name: []const u8 = "GetDetectorVersion",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_detector_version) } {
            return .{ .service_metadata = service_metadata, .action = get_detector_version };
        }
    },
    Response: type = struct {
        detector_id: ?[]const u8 = null,
        detector_version_id: ?[]const u8 = null,
        description: ?[]const u8 = null,
        external_model_endpoints: ?[][]const u8 = null,
        model_versions: ?[]ModelVersion = null,
        rules: ?[]Rule = null,
        status: ?[]const u8 = null,
        last_updated_time: ?[]const u8 = null,
        created_time: ?[]const u8 = null,
        rule_execution_mode: ?[]const u8 = null,
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .description = "description",
                .external_model_endpoints = "externalModelEndpoints",
                .model_versions = "modelVersions",
                .rules = "rules",
                .status = "status",
                .last_updated_time = "lastUpdatedTime",
                .created_time = "createdTime",
                .rule_execution_mode = "ruleExecutionMode",
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_entity_types: struct {
    action_name: []const u8 = "GetEntityTypes",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_entity_types) } {
            return .{ .service_metadata = service_metadata, .action = get_entity_types };
        }
    },
    Response: type = struct {
        entity_types: ?[]struct {
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .description = "description",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_types = "entityTypes",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_event: struct {
    action_name: []const u8 = "GetEvent",
    Request: type = struct {
        event_id: []const u8,
        event_type_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_event) } {
            return .{ .service_metadata = service_metadata, .action = get_event };
        }
    },
    Response: type = struct {
        event: ?struct {
            event_id: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            event_timestamp: ?[]const u8 = null,
            event_variables: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            current_label: ?[]const u8 = null,
            label_timestamp: ?[]const u8 = null,
            entities: ?[]Entity = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .event_id = "eventId",
                    .event_type_name = "eventTypeName",
                    .event_timestamp = "eventTimestamp",
                    .event_variables = "eventVariables",
                    .current_label = "currentLabel",
                    .label_timestamp = "labelTimestamp",
                    .entities = "entities",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "event_variables", field_name))
                    return try serializeMap(self.event_variables, self.fieldNameFor("event_variables"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event = "event",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_event_prediction: struct {
    action_name: []const u8 = "GetEventPrediction",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: ?[]const u8 = null,
        event_id: []const u8,
        event_type_name: []const u8,
        entities: []Entity,
        event_timestamp: []const u8,
        event_variables: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },
        external_model_endpoint_data_blobs: ?[]struct {
            key: ?[]const u8 = null,
            value: ?struct {
                byte_buffer: ?[]const u8 = null,
                content_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .byte_buffer = "byteBuffer",
                        .content_type = "contentType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .entities = "entities",
                .event_timestamp = "eventTimestamp",
                .event_variables = "eventVariables",
                .external_model_endpoint_data_blobs = "externalModelEndpointDataBlobs",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "event_variables", field_name))
                return try serializeMap(self.event_variables, self.fieldNameFor("event_variables"), options, out_stream);
            if (std.mem.eql(u8, "external_model_endpoint_data_blobs", field_name))
                return try serializeMap(self.external_model_endpoint_data_blobs, self.fieldNameFor("external_model_endpoint_data_blobs"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_event_prediction) } {
            return .{ .service_metadata = service_metadata, .action = get_event_prediction };
        }
    },
    Response: type = struct {
        model_scores: ?[]struct {
            model_version: ?ModelVersion = null,
            scores: ?[]struct {
                key: ?[]const u8 = null,
                value: ?f32 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_version = "modelVersion",
                    .scores = "scores",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "scores", field_name))
                    return try serializeMap(self.scores, self.fieldNameFor("scores"), options, out_stream);
                return false;
            }
        } = null,
        rule_results: ?[]struct {
            rule_id: ?[]const u8 = null,
            outcomes: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .rule_id = "ruleId",
                    .outcomes = "outcomes",
                };
                return @field(mappings, field_name);
            }
        } = null,
        external_model_outputs: ?[]struct {
            external_model: ?struct {
                model_endpoint: ?[]const u8 = null,
                model_source: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .model_endpoint = "modelEndpoint",
                        .model_source = "modelSource",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            outputs: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .external_model = "externalModel",
                    .outputs = "outputs",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "outputs", field_name))
                    return try serializeMap(self.outputs, self.fieldNameFor("outputs"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_scores = "modelScores",
                .rule_results = "ruleResults",
                .external_model_outputs = "externalModelOutputs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        ResourceUnavailable,
        Throttling,
        Validation,
    },
} = .{};
pub const get_event_prediction_metadata: struct {
    action_name: []const u8 = "GetEventPredictionMetadata",
    Request: type = struct {
        event_id: []const u8,
        event_type_name: []const u8,
        detector_id: []const u8,
        detector_version_id: []const u8,
        prediction_timestamp: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .prediction_timestamp = "predictionTimestamp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_event_prediction_metadata) } {
            return .{ .service_metadata = service_metadata, .action = get_event_prediction_metadata };
        }
    },
    Response: type = struct {
        event_id: ?[]const u8 = null,
        event_type_name: ?[]const u8 = null,
        entity_id: ?[]const u8 = null,
        entity_type: ?[]const u8 = null,
        event_timestamp: ?[]const u8 = null,
        detector_id: ?[]const u8 = null,
        detector_version_id: ?[]const u8 = null,
        detector_version_status: ?[]const u8 = null,
        event_variables: ?[]struct {
            name: ?[]const u8 = null,
            value: ?[]const u8 = null,
            source: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .value = "value",
                    .source = "source",
                };
                return @field(mappings, field_name);
            }
        } = null,
        rules: ?[]struct {
            rule_id: ?[]const u8 = null,
            rule_version: ?[]const u8 = null,
            expression: ?[]const u8 = null,
            expression_with_values: ?[]const u8 = null,
            outcomes: ?[][]const u8 = null,
            evaluated: ?bool = null,
            matched: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .rule_id = "ruleId",
                    .rule_version = "ruleVersion",
                    .expression = "expression",
                    .expression_with_values = "expressionWithValues",
                    .outcomes = "outcomes",
                    .evaluated = "evaluated",
                    .matched = "matched",
                };
                return @field(mappings, field_name);
            }
        } = null,
        rule_execution_mode: ?[]const u8 = null,
        outcomes: ?[][]const u8 = null,
        evaluated_model_versions: ?[]struct {
            model_id: ?[]const u8 = null,
            model_version: ?[]const u8 = null,
            model_type: ?[]const u8 = null,
            evaluations: ?[]struct {
                output_variable_name: ?[]const u8 = null,
                evaluation_score: ?[]const u8 = null,
                prediction_explanations: ?struct {
                    variable_impact_explanations: ?[]struct {
                        event_variable_name: ?[]const u8 = null,
                        relative_impact: ?[]const u8 = null,
                        log_odds_impact: ?f32 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .event_variable_name = "eventVariableName",
                                .relative_impact = "relativeImpact",
                                .log_odds_impact = "logOddsImpact",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    aggregated_variables_impact_explanations: ?[]struct {
                        event_variable_names: ?[][]const u8 = null,
                        relative_impact: ?[]const u8 = null,
                        log_odds_impact: ?f32 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .event_variable_names = "eventVariableNames",
                                .relative_impact = "relativeImpact",
                                .log_odds_impact = "logOddsImpact",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .variable_impact_explanations = "variableImpactExplanations",
                            .aggregated_variables_impact_explanations = "aggregatedVariablesImpactExplanations",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .output_variable_name = "outputVariableName",
                        .evaluation_score = "evaluationScore",
                        .prediction_explanations = "predictionExplanations",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_id = "modelId",
                    .model_version = "modelVersion",
                    .model_type = "modelType",
                    .evaluations = "evaluations",
                };
                return @field(mappings, field_name);
            }
        } = null,
        evaluated_external_models: ?[]struct {
            model_endpoint: ?[]const u8 = null,
            use_event_variables: ?bool = null,
            input_variables: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            output_variables: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_endpoint = "modelEndpoint",
                    .use_event_variables = "useEventVariables",
                    .input_variables = "inputVariables",
                    .output_variables = "outputVariables",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "input_variables", field_name))
                    return try serializeMap(self.input_variables, self.fieldNameFor("input_variables"), options, out_stream);
                if (std.mem.eql(u8, "output_variables", field_name))
                    return try serializeMap(self.output_variables, self.fieldNameFor("output_variables"), options, out_stream);
                return false;
            }
        } = null,
        prediction_timestamp: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .entity_id = "entityId",
                .entity_type = "entityType",
                .event_timestamp = "eventTimestamp",
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .detector_version_status = "detectorVersionStatus",
                .event_variables = "eventVariables",
                .rules = "rules",
                .rule_execution_mode = "ruleExecutionMode",
                .outcomes = "outcomes",
                .evaluated_model_versions = "evaluatedModelVersions",
                .evaluated_external_models = "evaluatedExternalModels",
                .prediction_timestamp = "predictionTimestamp",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_event_types: struct {
    action_name: []const u8 = "GetEventTypes",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_event_types) } {
            return .{ .service_metadata = service_metadata, .action = get_event_types };
        }
    },
    Response: type = struct {
        event_types: ?[]struct {
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            event_variables: ?[][]const u8 = null,
            labels: ?[][]const u8 = null,
            entity_types: ?[][]const u8 = null,
            event_ingestion: ?[]const u8 = null,
            ingested_event_statistics: ?struct {
                number_of_events: ?i64 = null,
                event_data_size_in_bytes: ?i64 = null,
                least_recent_event: ?[]const u8 = null,
                most_recent_event: ?[]const u8 = null,
                last_updated_time: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .number_of_events = "numberOfEvents",
                        .event_data_size_in_bytes = "eventDataSizeInBytes",
                        .least_recent_event = "leastRecentEvent",
                        .most_recent_event = "mostRecentEvent",
                        .last_updated_time = "lastUpdatedTime",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            event_orchestration: ?EventOrchestration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .description = "description",
                    .event_variables = "eventVariables",
                    .labels = "labels",
                    .entity_types = "entityTypes",
                    .event_ingestion = "eventIngestion",
                    .ingested_event_statistics = "ingestedEventStatistics",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                    .event_orchestration = "eventOrchestration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_types = "eventTypes",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_external_models: struct {
    action_name: []const u8 = "GetExternalModels",
    Request: type = struct {
        model_endpoint: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_endpoint = "modelEndpoint",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_external_models) } {
            return .{ .service_metadata = service_metadata, .action = get_external_models };
        }
    },
    Response: type = struct {
        external_models: ?[]struct {
            model_endpoint: ?[]const u8 = null,
            model_source: ?[]const u8 = null,
            invoke_model_endpoint_role_arn: ?[]const u8 = null,
            input_configuration: ?ModelInputConfiguration = null,
            output_configuration: ?ModelOutputConfiguration = null,
            model_endpoint_status: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_endpoint = "modelEndpoint",
                    .model_source = "modelSource",
                    .invoke_model_endpoint_role_arn = "invokeModelEndpointRoleArn",
                    .input_configuration = "inputConfiguration",
                    .output_configuration = "outputConfiguration",
                    .model_endpoint_status = "modelEndpointStatus",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .external_models = "externalModels",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_kms_encryption_key: struct {
    action_name: []const u8 = "GetKMSEncryptionKey",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_kms_encryption_key) } {
            return .{ .service_metadata = service_metadata, .action = get_kms_encryption_key };
        }
    },
    Response: type = struct {
        kms_key: ?struct {
            kms_encryption_key_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .kms_encryption_key_arn = "kmsEncryptionKeyArn",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .kms_key = "kmsKey",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_labels: struct {
    action_name: []const u8 = "GetLabels",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_labels) } {
            return .{ .service_metadata = service_metadata, .action = get_labels };
        }
    },
    Response: type = struct {
        labels: ?[]struct {
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .description = "description",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .labels = "labels",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_list_elements: struct {
    action_name: []const u8 = "GetListElements",
    Request: type = struct {
        name: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_list_elements) } {
            return .{ .service_metadata = service_metadata, .action = get_list_elements };
        }
    },
    Response: type = struct {
        elements: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elements = "elements",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_lists_metadata: struct {
    action_name: []const u8 = "GetListsMetadata",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_lists_metadata) } {
            return .{ .service_metadata = service_metadata, .action = get_lists_metadata };
        }
    },
    Response: type = struct {
        lists: ?[]struct {
            name: []const u8,
            description: ?[]const u8 = null,
            variable_type: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            updated_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .description = "description",
                    .variable_type = "variableType",
                    .created_time = "createdTime",
                    .updated_time = "updatedTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lists = "lists",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_models: struct {
    action_name: []const u8 = "GetModels",
    Request: type = struct {
        model_id: ?[]const u8 = null,
        model_type: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_models) } {
            return .{ .service_metadata = service_metadata, .action = get_models };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        models: ?[]struct {
            model_id: ?[]const u8 = null,
            model_type: ?[]const u8 = null,
            description: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_id = "modelId",
                    .model_type = "modelType",
                    .description = "description",
                    .event_type_name = "eventTypeName",
                    .created_time = "createdTime",
                    .last_updated_time = "lastUpdatedTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .models = "models",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_model_version: struct {
    action_name: []const u8 = "GetModelVersion",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        model_version_number: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_model_version) } {
            return .{ .service_metadata = service_metadata, .action = get_model_version };
        }
    },
    Response: type = struct {
        model_id: ?[]const u8 = null,
        model_type: ?[]const u8 = null,
        model_version_number: ?[]const u8 = null,
        training_data_source: ?[]const u8 = null,
        training_data_schema: ?TrainingDataSchema = null,
        external_events_detail: ?ExternalEventsDetail = null,
        ingested_events_detail: ?IngestedEventsDetail = null,
        status: ?[]const u8 = null,
        arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
                .training_data_source = "trainingDataSource",
                .training_data_schema = "trainingDataSchema",
                .external_events_detail = "externalEventsDetail",
                .ingested_events_detail = "ingestedEventsDetail",
                .status = "status",
                .arn = "arn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_outcomes: struct {
    action_name: []const u8 = "GetOutcomes",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_outcomes) } {
            return .{ .service_metadata = service_metadata, .action = get_outcomes };
        }
    },
    Response: type = struct {
        outcomes: ?[]struct {
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .description = "description",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outcomes = "outcomes",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_rules: struct {
    action_name: []const u8 = "GetRules",
    Request: type = struct {
        rule_id: ?[]const u8 = null,
        detector_id: []const u8,
        rule_version: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_id = "ruleId",
                .detector_id = "detectorId",
                .rule_version = "ruleVersion",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_rules) } {
            return .{ .service_metadata = service_metadata, .action = get_rules };
        }
    },
    Response: type = struct {
        rule_details: ?[]struct {
            rule_id: ?[]const u8 = null,
            description: ?[]const u8 = null,
            detector_id: ?[]const u8 = null,
            rule_version: ?[]const u8 = null,
            expression: ?[]const u8 = null,
            language: ?[]const u8 = null,
            outcomes: ?[][]const u8 = null,
            last_updated_time: ?[]const u8 = null,
            created_time: ?[]const u8 = null,
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .rule_id = "ruleId",
                    .description = "description",
                    .detector_id = "detectorId",
                    .rule_version = "ruleVersion",
                    .expression = "expression",
                    .language = "language",
                    .outcomes = "outcomes",
                    .last_updated_time = "lastUpdatedTime",
                    .created_time = "createdTime",
                    .arn = "arn",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule_details = "ruleDetails",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_variables: struct {
    action_name: []const u8 = "GetVariables",
    Request: type = struct {
        name: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_variables) } {
            return .{ .service_metadata = service_metadata, .action = get_variables };
        }
    },
    Response: type = struct {
        variables: ?[]Variable = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .variables = "variables",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const list_event_predictions: struct {
    action_name: []const u8 = "ListEventPredictions",
    Request: type = struct {
        event_id: ?FilterCondition = null,
        event_type: ?FilterCondition = null,
        detector_id: ?FilterCondition = null,
        detector_version_id: ?FilterCondition = null,
        prediction_time_range: ?struct {
            start_time: []const u8,
            end_time: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .start_time = "startTime",
                    .end_time = "endTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type = "eventType",
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .prediction_time_range = "predictionTimeRange",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_event_predictions) } {
            return .{ .service_metadata = service_metadata, .action = list_event_predictions };
        }
    },
    Response: type = struct {
        event_prediction_summaries: ?[]struct {
            event_id: ?[]const u8 = null,
            event_type_name: ?[]const u8 = null,
            event_timestamp: ?[]const u8 = null,
            prediction_timestamp: ?[]const u8 = null,
            detector_id: ?[]const u8 = null,
            detector_version_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .event_id = "eventId",
                    .event_type_name = "eventTypeName",
                    .event_timestamp = "eventTimestamp",
                    .prediction_timestamp = "predictionTimestamp",
                    .detector_id = "detectorId",
                    .detector_version_id = "detectorVersionId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_prediction_summaries = "eventPredictionSummaries",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceARN",
                .next_token = "nextToken",
                .max_results = "maxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const put_detector: struct {
    action_name: []const u8 = "PutDetector",
    Request: type = struct {
        detector_id: []const u8,
        description: ?[]const u8 = null,
        event_type_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .description = "description",
                .event_type_name = "eventTypeName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_detector) } {
            return .{ .service_metadata = service_metadata, .action = put_detector };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const put_entity_type: struct {
    action_name: []const u8 = "PutEntityType",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_entity_type) } {
            return .{ .service_metadata = service_metadata, .action = put_entity_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const put_event_type: struct {
    action_name: []const u8 = "PutEventType",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        event_variables: [][]const u8,
        labels: ?[][]const u8 = null,
        entity_types: [][]const u8,
        event_ingestion: ?[]const u8 = null,
        tags: ?[]Tag = null,
        event_orchestration: ?EventOrchestration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .event_variables = "eventVariables",
                .labels = "labels",
                .entity_types = "entityTypes",
                .event_ingestion = "eventIngestion",
                .tags = "tags",
                .event_orchestration = "eventOrchestration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_event_type) } {
            return .{ .service_metadata = service_metadata, .action = put_event_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const put_external_model: struct {
    action_name: []const u8 = "PutExternalModel",
    Request: type = struct {
        model_endpoint: []const u8,
        model_source: []const u8,
        invoke_model_endpoint_role_arn: []const u8,
        input_configuration: ModelInputConfiguration,
        output_configuration: ModelOutputConfiguration,
        model_endpoint_status: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_endpoint = "modelEndpoint",
                .model_source = "modelSource",
                .invoke_model_endpoint_role_arn = "invokeModelEndpointRoleArn",
                .input_configuration = "inputConfiguration",
                .output_configuration = "outputConfiguration",
                .model_endpoint_status = "modelEndpointStatus",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_external_model) } {
            return .{ .service_metadata = service_metadata, .action = put_external_model };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const put_kms_encryption_key: struct {
    action_name: []const u8 = "PutKMSEncryptionKey",
    Request: type = struct {
        kms_encryption_key_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .kms_encryption_key_arn = "kmsEncryptionKeyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_kms_encryption_key) } {
            return .{ .service_metadata = service_metadata, .action = put_kms_encryption_key };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const put_label: struct {
    action_name: []const u8 = "PutLabel",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_label) } {
            return .{ .service_metadata = service_metadata, .action = put_label };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const put_outcome: struct {
    action_name: []const u8 = "PutOutcome",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .description = "description",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_outcome) } {
            return .{ .service_metadata = service_metadata, .action = put_outcome };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const send_event: struct {
    action_name: []const u8 = "SendEvent",
    Request: type = struct {
        event_id: []const u8,
        event_type_name: []const u8,
        event_timestamp: []const u8,
        event_variables: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },
        assigned_label: ?[]const u8 = null,
        label_timestamp: ?[]const u8 = null,
        entities: []Entity,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .event_timestamp = "eventTimestamp",
                .event_variables = "eventVariables",
                .assigned_label = "assignedLabel",
                .label_timestamp = "labelTimestamp",
                .entities = "entities",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "event_variables", field_name))
                return try serializeMap(self.event_variables, self.fieldNameFor("event_variables"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_event) } {
            return .{ .service_metadata = service_metadata, .action = send_event };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceARN",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceARN",
                .tag_keys = "tagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_detector_version: struct {
    action_name: []const u8 = "UpdateDetectorVersion",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: []const u8,
        external_model_endpoints: [][]const u8,
        rules: []Rule,
        description: ?[]const u8 = null,
        model_versions: ?[]ModelVersion = null,
        rule_execution_mode: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .external_model_endpoints = "externalModelEndpoints",
                .rules = "rules",
                .description = "description",
                .model_versions = "modelVersions",
                .rule_execution_mode = "ruleExecutionMode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_detector_version) } {
            return .{ .service_metadata = service_metadata, .action = update_detector_version };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_detector_version_metadata: struct {
    action_name: []const u8 = "UpdateDetectorVersionMetadata",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: []const u8,
        description: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .description = "description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_detector_version_metadata) } {
            return .{ .service_metadata = service_metadata, .action = update_detector_version_metadata };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
pub const update_detector_version_status: struct {
    action_name: []const u8 = "UpdateDetectorVersionStatus",
    Request: type = struct {
        detector_id: []const u8,
        detector_version_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .detector_id = "detectorId",
                .detector_version_id = "detectorVersionId",
                .status = "status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_detector_version_status) } {
            return .{ .service_metadata = service_metadata, .action = update_detector_version_status };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_event_label: struct {
    action_name: []const u8 = "UpdateEventLabel",
    Request: type = struct {
        event_id: []const u8,
        event_type_name: []const u8,
        assigned_label: []const u8,
        label_timestamp: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .event_id = "eventId",
                .event_type_name = "eventTypeName",
                .assigned_label = "assignedLabel",
                .label_timestamp = "labelTimestamp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_event_label) } {
            return .{ .service_metadata = service_metadata, .action = update_event_label };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_list: struct {
    action_name: []const u8 = "UpdateList",
    Request: type = struct {
        name: []const u8,
        elements: ?[][]const u8 = null,
        description: ?[]const u8 = null,
        update_mode: ?[]const u8 = null,
        variable_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .elements = "elements",
                .description = "description",
                .update_mode = "updateMode",
                .variable_type = "variableType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_list) } {
            return .{ .service_metadata = service_metadata, .action = update_list };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_model: struct {
    action_name: []const u8 = "UpdateModel",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .description = "description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_model) } {
            return .{ .service_metadata = service_metadata, .action = update_model };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_model_version: struct {
    action_name: []const u8 = "UpdateModelVersion",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        major_version_number: []const u8,
        external_events_detail: ?ExternalEventsDetail = null,
        ingested_events_detail: ?IngestedEventsDetail = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .major_version_number = "majorVersionNumber",
                .external_events_detail = "externalEventsDetail",
                .ingested_events_detail = "ingestedEventsDetail",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_model_version) } {
            return .{ .service_metadata = service_metadata, .action = update_model_version };
        }
    },
    Response: type = struct {
        model_id: ?[]const u8 = null,
        model_type: ?[]const u8 = null,
        model_version_number: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
                .status = "status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_model_version_status: struct {
    action_name: []const u8 = "UpdateModelVersionStatus",
    Request: type = struct {
        model_id: []const u8,
        model_type: []const u8,
        model_version_number: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .model_id = "modelId",
                .model_type = "modelType",
                .model_version_number = "modelVersionNumber",
                .status = "status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_model_version_status) } {
            return .{ .service_metadata = service_metadata, .action = update_model_version_status };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_rule_metadata: struct {
    action_name: []const u8 = "UpdateRuleMetadata",
    Request: type = struct {
        rule: Rule,
        description: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule = "rule",
                .description = "description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_rule_metadata) } {
            return .{ .service_metadata = service_metadata, .action = update_rule_metadata };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_rule_version: struct {
    action_name: []const u8 = "UpdateRuleVersion",
    Request: type = struct {
        rule: Rule,
        description: ?[]const u8 = null,
        expression: []const u8,
        language: []const u8,
        outcomes: [][]const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule = "rule",
                .description = "description",
                .expression = "expression",
                .language = "language",
                .outcomes = "outcomes",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_rule_version) } {
            return .{ .service_metadata = service_metadata, .action = update_rule_version };
        }
    },
    Response: type = struct {
        rule: ?Rule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rule = "rule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_variable: struct {
    action_name: []const u8 = "UpdateVariable",
    Request: type = struct {
        name: []const u8,
        default_value: ?[]const u8 = null,
        description: ?[]const u8 = null,
        variable_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .default_value = "defaultValue",
                .description = "description",
                .variable_type = "variableType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_variable) } {
            return .{ .service_metadata = service_metadata, .action = update_variable };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};

pub const Rule = struct {
    detector_id: []const u8,
    rule_id: []const u8,
    rule_version: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .detector_id = "detectorId",
            .rule_id = "ruleId",
            .rule_version = "ruleVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "key",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const IngestedEventsDetail = struct {
    ingested_events_time_window: IngestedEventsTimeWindow,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ingested_events_time_window = "ingestedEventsTimeWindow",
        };
        return @field(mappings, field_name);
    }
};

pub const IngestedEventsTimeWindow = struct {
    start_time: []const u8,
    end_time: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .start_time = "startTime",
            .end_time = "endTime",
        };
        return @field(mappings, field_name);
    }
};

pub const ExternalEventsDetail = struct {
    data_location: []const u8,
    data_access_role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_location = "dataLocation",
            .data_access_role_arn = "dataAccessRoleArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ModelVersion = struct {
    model_id: []const u8,
    model_type: []const u8,
    model_version_number: []const u8,
    arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .model_id = "modelId",
            .model_type = "modelType",
            .model_version_number = "modelVersionNumber",
            .arn = "arn",
        };
        return @field(mappings, field_name);
    }
};

pub const Entity = struct {
    entity_type: []const u8,
    entity_id: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .entity_type = "entityType",
            .entity_id = "entityId",
        };
        return @field(mappings, field_name);
    }
};

pub const ModelOutputConfiguration = struct {
    format: []const u8,
    json_key_to_variable_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    csv_index_to_variable_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .format = "format",
            .json_key_to_variable_map = "jsonKeyToVariableMap",
            .csv_index_to_variable_map = "csvIndexToVariableMap",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "json_key_to_variable_map", field_name))
            return try serializeMap(self.json_key_to_variable_map, self.fieldNameFor("json_key_to_variable_map"), options, out_stream);
        if (std.mem.eql(u8, "csv_index_to_variable_map", field_name))
            return try serializeMap(self.csv_index_to_variable_map, self.fieldNameFor("csv_index_to_variable_map"), options, out_stream);
        return false;
    }
};

pub const ModelInputConfiguration = struct {
    event_type_name: ?[]const u8 = null,
    format: ?[]const u8 = null,
    use_event_variables: bool,
    json_input_template: ?[]const u8 = null,
    csv_input_template: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .event_type_name = "eventTypeName",
            .format = "format",
            .use_event_variables = "useEventVariables",
            .json_input_template = "jsonInputTemplate",
            .csv_input_template = "csvInputTemplate",
        };
        return @field(mappings, field_name);
    }
};

pub const EventOrchestration = struct {
    event_bridge_enabled: bool,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .event_bridge_enabled = "eventBridgeEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const FilterCondition = struct {
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const Variable = struct {
    name: ?[]const u8 = null,
    data_type: ?[]const u8 = null,
    data_source: ?[]const u8 = null,
    default_value: ?[]const u8 = null,
    description: ?[]const u8 = null,
    variable_type: ?[]const u8 = null,
    last_updated_time: ?[]const u8 = null,
    created_time: ?[]const u8 = null,
    arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .data_type = "dataType",
            .data_source = "dataSource",
            .default_value = "defaultValue",
            .description = "description",
            .variable_type = "variableType",
            .last_updated_time = "lastUpdatedTime",
            .created_time = "createdTime",
            .arn = "arn",
        };
        return @field(mappings, field_name);
    }
};

pub const TrainingDataSchema = struct {
    model_variables: [][]const u8,
    label_schema: ?LabelSchema = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .model_variables = "modelVariables",
            .label_schema = "labelSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const LabelSchema = struct {
    label_mapper: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,
    unlabeled_events_treatment: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .label_mapper = "labelMapper",
            .unlabeled_events_treatment = "unlabeledEventsTreatment",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "label_mapper", field_name))
            return try serializeMap(self.label_mapper, self.fieldNameFor("label_mapper"), options, out_stream);
        return false;
    }
};

pub const VariableImportanceMetrics = struct {
    log_odds_metrics: ?[]LogOddsMetric = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_odds_metrics = "logOddsMetrics",
        };
        return @field(mappings, field_name);
    }
};

pub const LogOddsMetric = struct {
    variable_name: []const u8,
    variable_type: []const u8,
    variable_importance: f32,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .variable_name = "variableName",
            .variable_type = "variableType",
            .variable_importance = "variableImportance",
        };
        return @field(mappings, field_name);
    }
};

pub const UncertaintyRange = struct {
    lower_bound_value: f32,
    upper_bound_value: f32,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .lower_bound_value = "lowerBoundValue",
            .upper_bound_value = "upperBoundValue",
        };
        return @field(mappings, field_name);
    }
};

pub const DataValidationMetrics = struct {
    file_level_messages: ?[]FileValidationMessage = null,
    field_level_messages: ?[]FieldValidationMessage = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .file_level_messages = "fileLevelMessages",
            .field_level_messages = "fieldLevelMessages",
        };
        return @field(mappings, field_name);
    }
};

pub const FieldValidationMessage = struct {
    field_name: ?[]const u8 = null,
    identifier: ?[]const u8 = null,
    title: ?[]const u8 = null,
    content: ?[]const u8 = null,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .field_name = "fieldName",
            .identifier = "identifier",
            .title = "title",
            .content = "content",
            .type = "type",
        };
        return @field(mappings, field_name);
    }
};

pub const FileValidationMessage = struct {
    title: ?[]const u8 = null,
    content: ?[]const u8 = null,
    type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .title = "title",
            .content = "content",
            .type = "type",
        };
        return @field(mappings, field_name);
    }
};
