const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2010-05-08";
pub const sdk_id: []const u8 = "IAM";
pub const arn_namespace: ?[]const u8 = "iam";
pub const endpoint_prefix: []const u8 = "iam";
pub const sigv4_name: []const u8 = "iam";
pub const name: []const u8 = "AWSIdentityManagementV20100508";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query;

pub const service_metadata: struct {
    version: []const u8 = "2010-05-08",
    sdk_id: []const u8 = "IAM",
    arn_namespace: ?[]const u8 = "iam",
    endpoint_prefix: []const u8 = "iam",
    sigv4_name: []const u8 = "iam",
    name: []const u8 = "AWSIdentityManagementV20100508",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.query,
} = .{};
pub const add_client_id_to_open_id_connect_provider: struct {
    action_name: []const u8 = "AddClientIDToOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        client_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .client_id = "ClientID",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_client_id_to_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = add_client_id_to_open_id_connect_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const add_role_to_instance_profile: struct {
    action_name: []const u8 = "AddRoleToInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_role_to_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = add_role_to_instance_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityAlreadyExists,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const add_user_to_group: struct {
    action_name: []const u8 = "AddUserToGroup",
    Request: type = struct {
        group_name: []const u8,
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_user_to_group) } {
            return .{ .service_metadata = service_metadata, .action = add_user_to_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const attach_group_policy: struct {
    action_name: []const u8 = "AttachGroupPolicy",
    Request: type = struct {
        group_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = attach_group_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        PolicyNotAttachable,
        ServiceFailure,
    },
} = .{};
pub const attach_role_policy: struct {
    action_name: []const u8 = "AttachRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = attach_role_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        PolicyNotAttachable,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const attach_user_policy: struct {
    action_name: []const u8 = "AttachUserPolicy",
    Request: type = struct {
        user_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_user_policy) } {
            return .{ .service_metadata = service_metadata, .action = attach_user_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        PolicyNotAttachable,
        ServiceFailure,
    },
} = .{};
pub const change_password: struct {
    action_name: []const u8 = "ChangePassword",
    Request: type = struct {
        old_password: []const u8,
        new_password: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .old_password = "OldPassword",
                .new_password = "NewPassword",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(change_password) } {
            return .{ .service_metadata = service_metadata, .action = change_password };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityTemporarilyUnmodifiable,
        InvalidUserType,
        LimitExceeded,
        NoSuchEntity,
        PasswordPolicyViolation,
        ServiceFailure,
    },
} = .{};
pub const create_access_key: struct {
    action_name: []const u8 = "CreateAccessKey",
    Request: type = struct {
        user_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_access_key) } {
            return .{ .service_metadata = service_metadata, .action = create_access_key };
        }
    },
    Response: type = struct {
        access_key: struct {
            user_name: []const u8,
            access_key_id: []const u8,
            status: []const u8,
            secret_access_key: []const u8,
            create_date: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .access_key_id = "AccessKeyId",
                    .status = "Status",
                    .secret_access_key = "SecretAccessKey",
                    .create_date = "CreateDate",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_key = "AccessKey",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const create_account_alias: struct {
    action_name: []const u8 = "CreateAccountAlias",
    Request: type = struct {
        account_alias: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_alias = "AccountAlias",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_account_alias) } {
            return .{ .service_metadata = service_metadata, .action = create_account_alias };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const create_group: struct {
    action_name: []const u8 = "CreateGroup",
    Request: type = struct {
        path: ?[]const u8 = null,
        group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path = "Path",
                .group_name = "GroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_group) } {
            return .{ .service_metadata = service_metadata, .action = create_group };
        }
    },
    Response: type = struct {
        group: Group,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group = "Group",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        EntityAlreadyExists,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const create_instance_profile: struct {
    action_name: []const u8 = "CreateInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,
        path: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .path = "Path",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = create_instance_profile };
        }
    },
    Response: type = struct {
        instance_profile: InstanceProfile,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile = "InstanceProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const create_login_profile: struct {
    action_name: []const u8 = "CreateLoginProfile",
    Request: type = struct {
        user_name: []const u8,
        password: []const u8,
        password_reset_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .password = "Password",
                .password_reset_required = "PasswordResetRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_login_profile) } {
            return .{ .service_metadata = service_metadata, .action = create_login_profile };
        }
    },
    Response: type = struct {
        login_profile: LoginProfile,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .login_profile = "LoginProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        EntityAlreadyExists,
        LimitExceeded,
        NoSuchEntity,
        PasswordPolicyViolation,
        ServiceFailure,
    },
} = .{};
pub const create_open_id_connect_provider: struct {
    action_name: []const u8 = "CreateOpenIDConnectProvider",
    Request: type = struct {
        url: []const u8,
        client_id_list: ?[][]const u8 = null,
        thumbprint_list: [][]const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .url = "Url",
                .client_id_list = "ClientIDList",
                .thumbprint_list = "ThumbprintList",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = create_open_id_connect_provider };
        }
    },
    Response: type = struct {
        open_id_connect_provider_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const create_policy: struct {
    action_name: []const u8 = "CreatePolicy",
    Request: type = struct {
        policy_name: []const u8,
        path: ?[]const u8 = null,
        policy_document: []const u8,
        description: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_name = "PolicyName",
                .path = "Path",
                .policy_document = "PolicyDocument",
                .description = "Description",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_policy) } {
            return .{ .service_metadata = service_metadata, .action = create_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        MalformedPolicyDocument,
        ServiceFailure,
    },
} = .{};
pub const create_policy_version: struct {
    action_name: []const u8 = "CreatePolicyVersion",
    Request: type = struct {
        policy_arn: []const u8,
        policy_document: []const u8,
        set_as_default: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .policy_document = "PolicyDocument",
                .set_as_default = "SetAsDefault",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_policy_version) } {
            return .{ .service_metadata = service_metadata, .action = create_policy_version };
        }
    },
    Response: type = struct {
        policy_version: ?PolicyVersion = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_version = "PolicyVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const create_role: struct {
    action_name: []const u8 = "CreateRole",
    Request: type = struct {
        path: ?[]const u8 = null,
        role_name: []const u8,
        assume_role_policy_document: []const u8,
        description: ?[]const u8 = null,
        max_session_duration: ?i64 = null,
        permissions_boundary: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path = "Path",
                .role_name = "RoleName",
                .assume_role_policy_document = "AssumeRolePolicyDocument",
                .description = "Description",
                .max_session_duration = "MaxSessionDuration",
                .permissions_boundary = "PermissionsBoundary",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_role) } {
            return .{ .service_metadata = service_metadata, .action = create_role };
        }
    },
    Response: type = struct {
        role: Role,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role = "Role",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        MalformedPolicyDocument,
        ServiceFailure,
    },
} = .{};
pub const create_saml_provider: struct {
    action_name: []const u8 = "CreateSAMLProvider",
    Request: type = struct {
        saml_metadata_document: []const u8,
        name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_metadata_document = "SAMLMetadataDocument",
                .name = "Name",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = create_saml_provider };
        }
    },
    Response: type = struct {
        saml_provider_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const create_service_linked_role: struct {
    action_name: []const u8 = "CreateServiceLinkedRole",
    Request: type = struct {
        aws_service_name: []const u8,
        description: ?[]const u8 = null,
        custom_suffix: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .aws_service_name = "AWSServiceName",
                .description = "Description",
                .custom_suffix = "CustomSuffix",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_service_linked_role) } {
            return .{ .service_metadata = service_metadata, .action = create_service_linked_role };
        }
    },
    Response: type = struct {
        role: ?Role = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role = "Role",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const create_service_specific_credential: struct {
    action_name: []const u8 = "CreateServiceSpecificCredential",
    Request: type = struct {
        user_name: []const u8,
        service_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .service_name = "ServiceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_service_specific_credential) } {
            return .{ .service_metadata = service_metadata, .action = create_service_specific_credential };
        }
    },
    Response: type = struct {
        service_specific_credential: ?ServiceSpecificCredential = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_specific_credential = "ServiceSpecificCredential",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceNotSupported,
    },
} = .{};
pub const create_user: struct {
    action_name: []const u8 = "CreateUser",
    Request: type = struct {
        path: ?[]const u8 = null,
        user_name: []const u8,
        permissions_boundary: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path = "Path",
                .user_name = "UserName",
                .permissions_boundary = "PermissionsBoundary",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_user) } {
            return .{ .service_metadata = service_metadata, .action = create_user };
        }
    },
    Response: type = struct {
        user: ?User = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user = "User",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const create_virtual_mfa_device: struct {
    action_name: []const u8 = "CreateVirtualMFADevice",
    Request: type = struct {
        path: ?[]const u8 = null,
        virtual_mfa_device_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path = "Path",
                .virtual_mfa_device_name = "VirtualMFADeviceName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_virtual_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = create_virtual_mfa_device };
        }
    },
    Response: type = struct {
        virtual_mfa_device: VirtualMFADevice,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .virtual_mfa_device = "VirtualMFADevice",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const deactivate_mfa_device: struct {
    action_name: []const u8 = "DeactivateMFADevice",
    Request: type = struct {
        user_name: []const u8,
        serial_number: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .serial_number = "SerialNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deactivate_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = deactivate_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        EntityTemporarilyUnmodifiable,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_access_key: struct {
    action_name: []const u8 = "DeleteAccessKey",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        access_key_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .access_key_id = "AccessKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_access_key) } {
            return .{ .service_metadata = service_metadata, .action = delete_access_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_account_alias: struct {
    action_name: []const u8 = "DeleteAccountAlias",
    Request: type = struct {
        account_alias: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_alias = "AccountAlias",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_account_alias) } {
            return .{ .service_metadata = service_metadata, .action = delete_account_alias };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_account_password_policy: struct {
    action_name: []const u8 = "DeleteAccountPasswordPolicy",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_account_password_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_account_password_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_group: struct {
    action_name: []const u8 = "DeleteGroup",
    Request: type = struct {
        group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_group_policy: struct {
    action_name: []const u8 = "DeleteGroupPolicy",
    Request: type = struct {
        group_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_group_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_instance_profile: struct {
    action_name: []const u8 = "DeleteInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = delete_instance_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_login_profile: struct {
    action_name: []const u8 = "DeleteLoginProfile",
    Request: type = struct {
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_login_profile) } {
            return .{ .service_metadata = service_metadata, .action = delete_login_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityTemporarilyUnmodifiable,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_open_id_connect_provider: struct {
    action_name: []const u8 = "DeleteOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = delete_open_id_connect_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_policy: struct {
    action_name: []const u8 = "DeletePolicy",
    Request: type = struct {
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeleteConflict,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_policy_version: struct {
    action_name: []const u8 = "DeletePolicyVersion",
    Request: type = struct {
        policy_arn: []const u8,
        version_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .version_id = "VersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_policy_version) } {
            return .{ .service_metadata = service_metadata, .action = delete_policy_version };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeleteConflict,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_role: struct {
    action_name: []const u8 = "DeleteRole",
    Request: type = struct {
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_role) } {
            return .{ .service_metadata = service_metadata, .action = delete_role };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const delete_role_permissions_boundary: struct {
    action_name: []const u8 = "DeleteRolePermissionsBoundary",
    Request: type = struct {
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_role_permissions_boundary) } {
            return .{ .service_metadata = service_metadata, .action = delete_role_permissions_boundary };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const delete_role_policy: struct {
    action_name: []const u8 = "DeleteRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_role_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const delete_saml_provider: struct {
    action_name: []const u8 = "DeleteSAMLProvider",
    Request: type = struct {
        saml_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = delete_saml_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_server_certificate: struct {
    action_name: []const u8 = "DeleteServerCertificate",
    Request: type = struct {
        server_certificate_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = delete_server_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_service_linked_role: struct {
    action_name: []const u8 = "DeleteServiceLinkedRole",
    Request: type = struct {
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_service_linked_role) } {
            return .{ .service_metadata = service_metadata, .action = delete_service_linked_role };
        }
    },
    Response: type = struct {
        deletion_task_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deletion_task_id = "DeletionTaskId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_service_specific_credential: struct {
    action_name: []const u8 = "DeleteServiceSpecificCredential",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        service_specific_credential_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .service_specific_credential_id = "ServiceSpecificCredentialId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_service_specific_credential) } {
            return .{ .service_metadata = service_metadata, .action = delete_service_specific_credential };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const delete_signing_certificate: struct {
    action_name: []const u8 = "DeleteSigningCertificate",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        certificate_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .certificate_id = "CertificateId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_signing_certificate) } {
            return .{ .service_metadata = service_metadata, .action = delete_signing_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_ssh_public_key: struct {
    action_name: []const u8 = "DeleteSSHPublicKey",
    Request: type = struct {
        user_name: []const u8,
        ssh_public_key_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .ssh_public_key_id = "SSHPublicKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_ssh_public_key) } {
            return .{ .service_metadata = service_metadata, .action = delete_ssh_public_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const delete_user: struct {
    action_name: []const u8 = "DeleteUser",
    Request: type = struct {
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_user) } {
            return .{ .service_metadata = service_metadata, .action = delete_user };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_user_permissions_boundary: struct {
    action_name: []const u8 = "DeleteUserPermissionsBoundary",
    Request: type = struct {
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_user_permissions_boundary) } {
            return .{ .service_metadata = service_metadata, .action = delete_user_permissions_boundary };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_user_policy: struct {
    action_name: []const u8 = "DeleteUserPolicy",
    Request: type = struct {
        user_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_user_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_user_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const delete_virtual_mfa_device: struct {
    action_name: []const u8 = "DeleteVirtualMFADevice",
    Request: type = struct {
        serial_number: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .serial_number = "SerialNumber",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_virtual_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = delete_virtual_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        DeleteConflict,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const detach_group_policy: struct {
    action_name: []const u8 = "DetachGroupPolicy",
    Request: type = struct {
        group_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = detach_group_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const detach_role_policy: struct {
    action_name: []const u8 = "DetachRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = detach_role_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const detach_user_policy: struct {
    action_name: []const u8 = "DetachUserPolicy",
    Request: type = struct {
        user_name: []const u8,
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_user_policy) } {
            return .{ .service_metadata = service_metadata, .action = detach_user_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const enable_mfa_device: struct {
    action_name: []const u8 = "EnableMFADevice",
    Request: type = struct {
        user_name: []const u8,
        serial_number: []const u8,
        authentication_code1: []const u8,
        authentication_code2: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .serial_number = "SerialNumber",
                .authentication_code1 = "AuthenticationCode1",
                .authentication_code2 = "AuthenticationCode2",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = enable_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        EntityTemporarilyUnmodifiable,
        InvalidAuthenticationCode,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const generate_credential_report: struct {
    action_name: []const u8 = "GenerateCredentialReport",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(generate_credential_report) } {
            return .{ .service_metadata = service_metadata, .action = generate_credential_report };
        }
    },
    Response: type = struct {
        state: ?[]const u8 = null,
        description: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .state = "State",
                .description = "Description",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        LimitExceeded,
        ServiceFailure,
    },
} = .{};
pub const generate_organizations_access_report: struct {
    action_name: []const u8 = "GenerateOrganizationsAccessReport",
    Request: type = struct {
        entity_path: []const u8,
        organizations_policy_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_path = "EntityPath",
                .organizations_policy_id = "OrganizationsPolicyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(generate_organizations_access_report) } {
            return .{ .service_metadata = service_metadata, .action = generate_organizations_access_report };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ReportGenerationLimitExceeded,
    },
} = .{};
pub const generate_service_last_accessed_details: struct {
    action_name: []const u8 = "GenerateServiceLastAccessedDetails",
    Request: type = struct {
        arn: []const u8,
        granularity: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .granularity = "Granularity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(generate_service_last_accessed_details) } {
            return .{ .service_metadata = service_metadata, .action = generate_service_last_accessed_details };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
    },
} = .{};
pub const get_access_key_last_used: struct {
    action_name: []const u8 = "GetAccessKeyLastUsed",
    Request: type = struct {
        access_key_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_key_id = "AccessKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_access_key_last_used) } {
            return .{ .service_metadata = service_metadata, .action = get_access_key_last_used };
        }
    },
    Response: type = struct {
        user_name: ?[]const u8 = null,
        access_key_last_used: ?struct {
            last_used_date: i64,
            service_name: []const u8,
            region: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .last_used_date = "LastUsedDate",
                    .service_name = "ServiceName",
                    .region = "Region",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .access_key_last_used = "AccessKeyLastUsed",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const get_account_authorization_details: struct {
    action_name: []const u8 = "GetAccountAuthorizationDetails",
    Request: type = struct {
        filter: ?[][]const u8 = null,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .max_items = "MaxItems",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_authorization_details) } {
            return .{ .service_metadata = service_metadata, .action = get_account_authorization_details };
        }
    },
    Response: type = struct {
        user_detail_list: ?[]struct {
            path: ?[]const u8 = null,
            user_name: ?[]const u8 = null,
            user_id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            create_date: ?i64 = null,
            user_policy_list: ?[]PolicyDetail = null,
            group_list: ?[][]const u8 = null,
            attached_managed_policies: ?[]AttachedPolicy = null,
            permissions_boundary: ?AttachedPermissionsBoundary = null,
            tags: ?[]Tag = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .path = "Path",
                    .user_name = "UserName",
                    .user_id = "UserId",
                    .arn = "Arn",
                    .create_date = "CreateDate",
                    .user_policy_list = "UserPolicyList",
                    .group_list = "GroupList",
                    .attached_managed_policies = "AttachedManagedPolicies",
                    .permissions_boundary = "PermissionsBoundary",
                    .tags = "Tags",
                };
                return @field(mappings, field_name);
            }
        } = null,
        group_detail_list: ?[]struct {
            path: ?[]const u8 = null,
            group_name: ?[]const u8 = null,
            group_id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            create_date: ?i64 = null,
            group_policy_list: ?[]PolicyDetail = null,
            attached_managed_policies: ?[]AttachedPolicy = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .path = "Path",
                    .group_name = "GroupName",
                    .group_id = "GroupId",
                    .arn = "Arn",
                    .create_date = "CreateDate",
                    .group_policy_list = "GroupPolicyList",
                    .attached_managed_policies = "AttachedManagedPolicies",
                };
                return @field(mappings, field_name);
            }
        } = null,
        role_detail_list: ?[]struct {
            path: ?[]const u8 = null,
            role_name: ?[]const u8 = null,
            role_id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            create_date: ?i64 = null,
            assume_role_policy_document: ?[]const u8 = null,
            instance_profile_list: ?[]InstanceProfile = null,
            role_policy_list: ?[]PolicyDetail = null,
            attached_managed_policies: ?[]AttachedPolicy = null,
            permissions_boundary: ?AttachedPermissionsBoundary = null,
            tags: ?[]Tag = null,
            role_last_used: ?RoleLastUsed = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .path = "Path",
                    .role_name = "RoleName",
                    .role_id = "RoleId",
                    .arn = "Arn",
                    .create_date = "CreateDate",
                    .assume_role_policy_document = "AssumeRolePolicyDocument",
                    .instance_profile_list = "InstanceProfileList",
                    .role_policy_list = "RolePolicyList",
                    .attached_managed_policies = "AttachedManagedPolicies",
                    .permissions_boundary = "PermissionsBoundary",
                    .tags = "Tags",
                    .role_last_used = "RoleLastUsed",
                };
                return @field(mappings, field_name);
            }
        } = null,
        policies: ?[]struct {
            policy_name: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            path: ?[]const u8 = null,
            default_version_id: ?[]const u8 = null,
            attachment_count: ?i64 = null,
            permissions_boundary_usage_count: ?i64 = null,
            is_attachable: ?bool = null,
            description: ?[]const u8 = null,
            create_date: ?i64 = null,
            update_date: ?i64 = null,
            policy_version_list: ?[]PolicyVersion = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_name = "PolicyName",
                    .policy_id = "PolicyId",
                    .arn = "Arn",
                    .path = "Path",
                    .default_version_id = "DefaultVersionId",
                    .attachment_count = "AttachmentCount",
                    .permissions_boundary_usage_count = "PermissionsBoundaryUsageCount",
                    .is_attachable = "IsAttachable",
                    .description = "Description",
                    .create_date = "CreateDate",
                    .update_date = "UpdateDate",
                    .policy_version_list = "PolicyVersionList",
                };
                return @field(mappings, field_name);
            }
        } = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_detail_list = "UserDetailList",
                .group_detail_list = "GroupDetailList",
                .role_detail_list = "RoleDetailList",
                .policies = "Policies",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const get_account_password_policy: struct {
    action_name: []const u8 = "GetAccountPasswordPolicy",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_password_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_account_password_policy };
        }
    },
    Response: type = struct {
        password_policy: struct {
            minimum_password_length: ?i64 = null,
            require_symbols: ?bool = null,
            require_numbers: ?bool = null,
            require_uppercase_characters: ?bool = null,
            require_lowercase_characters: ?bool = null,
            allow_users_to_change_password: ?bool = null,
            expire_passwords: ?bool = null,
            max_password_age: ?i64 = null,
            password_reuse_prevention: ?i64 = null,
            hard_expiry: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .minimum_password_length = "MinimumPasswordLength",
                    .require_symbols = "RequireSymbols",
                    .require_numbers = "RequireNumbers",
                    .require_uppercase_characters = "RequireUppercaseCharacters",
                    .require_lowercase_characters = "RequireLowercaseCharacters",
                    .allow_users_to_change_password = "AllowUsersToChangePassword",
                    .expire_passwords = "ExpirePasswords",
                    .max_password_age = "MaxPasswordAge",
                    .password_reuse_prevention = "PasswordReusePrevention",
                    .hard_expiry = "HardExpiry",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .password_policy = "PasswordPolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_account_summary: struct {
    action_name: []const u8 = "GetAccountSummary",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_summary) } {
            return .{ .service_metadata = service_metadata, .action = get_account_summary };
        }
    },
    Response: type = struct {
        summary_map: ?[]struct {
            key: ?[]const u8 = null,
            value: ?i64 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summary_map = "SummaryMap",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "summary_map", field_name))
                return try serializeMap(self.summary_map, self.fieldNameFor("summary_map"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const get_context_keys_for_custom_policy: struct {
    action_name: []const u8 = "GetContextKeysForCustomPolicy",
    Request: type = struct {
        policy_input_list: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_input_list = "PolicyInputList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_context_keys_for_custom_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_context_keys_for_custom_policy };
        }
    },
    Response: type = struct {
        context_key_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .context_key_names = "ContextKeyNames",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const get_context_keys_for_principal_policy: struct {
    action_name: []const u8 = "GetContextKeysForPrincipalPolicy",
    Request: type = struct {
        policy_source_arn: []const u8,
        policy_input_list: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_source_arn = "PolicySourceArn",
                .policy_input_list = "PolicyInputList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_context_keys_for_principal_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_context_keys_for_principal_policy };
        }
    },
    Response: type = struct {
        context_key_names: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .context_key_names = "ContextKeyNames",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
    },
} = .{};
pub const get_credential_report: struct {
    action_name: []const u8 = "GetCredentialReport",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_credential_report) } {
            return .{ .service_metadata = service_metadata, .action = get_credential_report };
        }
    },
    Response: type = struct {
        content: ?[]const u8 = null,
        report_format: ?[]const u8 = null,
        generated_time: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .content = "Content",
                .report_format = "ReportFormat",
                .generated_time = "GeneratedTime",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CredentialReportExpired,
        CredentialReportNotPresent,
        CredentialReportNotReady,
        ServiceFailure,
    },
} = .{};
pub const get_group: struct {
    action_name: []const u8 = "GetGroup",
    Request: type = struct {
        group_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_group) } {
            return .{ .service_metadata = service_metadata, .action = get_group };
        }
    },
    Response: type = struct {
        group: Group,
        users: []User,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group = "Group",
                .users = "Users",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_group_policy: struct {
    action_name: []const u8 = "GetGroupPolicy",
    Request: type = struct {
        group_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_group_policy };
        }
    },
    Response: type = struct {
        group_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_instance_profile: struct {
    action_name: []const u8 = "GetInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_profile };
        }
    },
    Response: type = struct {
        instance_profile: InstanceProfile,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile = "InstanceProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_login_profile: struct {
    action_name: []const u8 = "GetLoginProfile",
    Request: type = struct {
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_login_profile) } {
            return .{ .service_metadata = service_metadata, .action = get_login_profile };
        }
    },
    Response: type = struct {
        login_profile: LoginProfile,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .login_profile = "LoginProfile",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_mfa_device: struct {
    action_name: []const u8 = "GetMFADevice",
    Request: type = struct {
        serial_number: []const u8,
        user_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .serial_number = "SerialNumber",
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = get_mfa_device };
        }
    },
    Response: type = struct {
        user_name: ?[]const u8 = null,
        serial_number: []const u8,
        enable_date: ?i64 = null,
        certifications: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .serial_number = "SerialNumber",
                .enable_date = "EnableDate",
                .certifications = "Certifications",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "certifications", field_name))
                return try serializeMap(self.certifications, self.fieldNameFor("certifications"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_open_id_connect_provider: struct {
    action_name: []const u8 = "GetOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = get_open_id_connect_provider };
        }
    },
    Response: type = struct {
        url: ?[]const u8 = null,
        client_id_list: ?[][]const u8 = null,
        thumbprint_list: ?[][]const u8 = null,
        create_date: ?i64 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .url = "Url",
                .client_id_list = "ClientIDList",
                .thumbprint_list = "ThumbprintList",
                .create_date = "CreateDate",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_organizations_access_report: struct {
    action_name: []const u8 = "GetOrganizationsAccessReport",
    Request: type = struct {
        job_id: []const u8,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,
        sort_key: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .max_items = "MaxItems",
                .marker = "Marker",
                .sort_key = "SortKey",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_organizations_access_report) } {
            return .{ .service_metadata = service_metadata, .action = get_organizations_access_report };
        }
    },
    Response: type = struct {
        job_status: []const u8,
        job_creation_date: i64,
        job_completion_date: ?i64 = null,
        number_of_services_accessible: ?i64 = null,
        number_of_services_not_accessed: ?i64 = null,
        access_details: ?[]struct {
            service_name: []const u8,
            service_namespace: []const u8,
            region: ?[]const u8 = null,
            entity_path: ?[]const u8 = null,
            last_authenticated_time: ?i64 = null,
            total_authenticated_entities: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .service_name = "ServiceName",
                    .service_namespace = "ServiceNamespace",
                    .region = "Region",
                    .entity_path = "EntityPath",
                    .last_authenticated_time = "LastAuthenticatedTime",
                    .total_authenticated_entities = "TotalAuthenticatedEntities",
                };
                return @field(mappings, field_name);
            }
        } = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,
        error_details: ?ErrorDetails = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_status = "JobStatus",
                .job_creation_date = "JobCreationDate",
                .job_completion_date = "JobCompletionDate",
                .number_of_services_accessible = "NumberOfServicesAccessible",
                .number_of_services_not_accessed = "NumberOfServicesNotAccessed",
                .access_details = "AccessDetails",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
                .error_details = "ErrorDetails",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const get_policy: struct {
    action_name: []const u8 = "GetPolicy",
    Request: type = struct {
        policy_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_policy_version: struct {
    action_name: []const u8 = "GetPolicyVersion",
    Request: type = struct {
        policy_arn: []const u8,
        version_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .version_id = "VersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_policy_version) } {
            return .{ .service_metadata = service_metadata, .action = get_policy_version };
        }
    },
    Response: type = struct {
        policy_version: ?PolicyVersion = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_version = "PolicyVersion",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_role: struct {
    action_name: []const u8 = "GetRole",
    Request: type = struct {
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_role) } {
            return .{ .service_metadata = service_metadata, .action = get_role };
        }
    },
    Response: type = struct {
        role: Role,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role = "Role",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_role_policy: struct {
    action_name: []const u8 = "GetRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_role_policy };
        }
    },
    Response: type = struct {
        role_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_saml_provider: struct {
    action_name: []const u8 = "GetSAMLProvider",
    Request: type = struct {
        saml_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = get_saml_provider };
        }
    },
    Response: type = struct {
        saml_metadata_document: ?[]const u8 = null,
        create_date: ?i64 = null,
        valid_until: ?i64 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_metadata_document = "SAMLMetadataDocument",
                .create_date = "CreateDate",
                .valid_until = "ValidUntil",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_server_certificate: struct {
    action_name: []const u8 = "GetServerCertificate",
    Request: type = struct {
        server_certificate_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = get_server_certificate };
        }
    },
    Response: type = struct {
        server_certificate: struct {
            server_certificate_metadata: ServerCertificateMetadata,
            certificate_body: []const u8,
            certificate_chain: ?[]const u8 = null,
            tags: ?[]Tag = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .server_certificate_metadata = "ServerCertificateMetadata",
                    .certificate_body = "CertificateBody",
                    .certificate_chain = "CertificateChain",
                    .tags = "Tags",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate = "ServerCertificate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_service_last_accessed_details: struct {
    action_name: []const u8 = "GetServiceLastAccessedDetails",
    Request: type = struct {
        job_id: []const u8,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .max_items = "MaxItems",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_service_last_accessed_details) } {
            return .{ .service_metadata = service_metadata, .action = get_service_last_accessed_details };
        }
    },
    Response: type = struct {
        job_status: []const u8,
        job_type: ?[]const u8 = null,
        job_creation_date: i64,
        services_last_accessed: []struct {
            service_name: []const u8,
            last_authenticated: ?i64 = null,
            service_namespace: []const u8,
            last_authenticated_entity: ?[]const u8 = null,
            last_authenticated_region: ?[]const u8 = null,
            total_authenticated_entities: ?i64 = null,
            tracked_actions_last_accessed: ?[]struct {
                action_name: ?[]const u8 = null,
                last_accessed_entity: ?[]const u8 = null,
                last_accessed_time: ?i64 = null,
                last_accessed_region: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .action_name = "ActionName",
                        .last_accessed_entity = "LastAccessedEntity",
                        .last_accessed_time = "LastAccessedTime",
                        .last_accessed_region = "LastAccessedRegion",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .service_name = "ServiceName",
                    .last_authenticated = "LastAuthenticated",
                    .service_namespace = "ServiceNamespace",
                    .last_authenticated_entity = "LastAuthenticatedEntity",
                    .last_authenticated_region = "LastAuthenticatedRegion",
                    .total_authenticated_entities = "TotalAuthenticatedEntities",
                    .tracked_actions_last_accessed = "TrackedActionsLastAccessed",
                };
                return @field(mappings, field_name);
            }
        },
        job_completion_date: i64,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,
        @"error": ?ErrorDetails = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_status = "JobStatus",
                .job_type = "JobType",
                .job_creation_date = "JobCreationDate",
                .services_last_accessed = "ServicesLastAccessed",
                .job_completion_date = "JobCompletionDate",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
                .@"error" = "Error",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
    },
} = .{};
pub const get_service_last_accessed_details_with_entities: struct {
    action_name: []const u8 = "GetServiceLastAccessedDetailsWithEntities",
    Request: type = struct {
        job_id: []const u8,
        service_namespace: []const u8,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .service_namespace = "ServiceNamespace",
                .max_items = "MaxItems",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_service_last_accessed_details_with_entities) } {
            return .{ .service_metadata = service_metadata, .action = get_service_last_accessed_details_with_entities };
        }
    },
    Response: type = struct {
        job_status: []const u8,
        job_creation_date: i64,
        job_completion_date: i64,
        entity_details_list: []struct {
            entity_info: struct {
                arn: []const u8,
                name: []const u8,
                type: []const u8,
                id: []const u8,
                path: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .arn = "Arn",
                        .name = "Name",
                        .type = "Type",
                        .id = "Id",
                        .path = "Path",
                    };
                    return @field(mappings, field_name);
                }
            },
            last_authenticated: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .entity_info = "EntityInfo",
                    .last_authenticated = "LastAuthenticated",
                };
                return @field(mappings, field_name);
            }
        },
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,
        @"error": ?ErrorDetails = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_status = "JobStatus",
                .job_creation_date = "JobCreationDate",
                .job_completion_date = "JobCompletionDate",
                .entity_details_list = "EntityDetailsList",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
                .@"error" = "Error",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
    },
} = .{};
pub const get_service_linked_role_deletion_status: struct {
    action_name: []const u8 = "GetServiceLinkedRoleDeletionStatus",
    Request: type = struct {
        deletion_task_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deletion_task_id = "DeletionTaskId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_service_linked_role_deletion_status) } {
            return .{ .service_metadata = service_metadata, .action = get_service_linked_role_deletion_status };
        }
    },
    Response: type = struct {
        status: []const u8,
        reason: ?struct {
            reason: ?[]const u8 = null,
            role_usage_list: ?[]struct {
                region: ?[]const u8 = null,
                resources: ?[][]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .region = "Region",
                        .resources = "Resources",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .reason = "Reason",
                    .role_usage_list = "RoleUsageList",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "Status",
                .reason = "Reason",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_ssh_public_key: struct {
    action_name: []const u8 = "GetSSHPublicKey",
    Request: type = struct {
        user_name: []const u8,
        ssh_public_key_id: []const u8,
        encoding: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .ssh_public_key_id = "SSHPublicKeyId",
                .encoding = "Encoding",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_ssh_public_key) } {
            return .{ .service_metadata = service_metadata, .action = get_ssh_public_key };
        }
    },
    Response: type = struct {
        ssh_public_key: ?SSHPublicKey = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ssh_public_key = "SSHPublicKey",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        UnrecognizedPublicKeyEncoding,
    },
} = .{};
pub const get_user: struct {
    action_name: []const u8 = "GetUser",
    Request: type = struct {
        user_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_user) } {
            return .{ .service_metadata = service_metadata, .action = get_user };
        }
    },
    Response: type = struct {
        user: User,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user = "User",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const get_user_policy: struct {
    action_name: []const u8 = "GetUserPolicy",
    Request: type = struct {
        user_name: []const u8,
        policy_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_name = "PolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_user_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_user_policy };
        }
    },
    Response: type = struct {
        user_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_access_keys: struct {
    action_name: []const u8 = "ListAccessKeys",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_access_keys) } {
            return .{ .service_metadata = service_metadata, .action = list_access_keys };
        }
    },
    Response: type = struct {
        access_key_metadata: []struct {
            user_name: ?[]const u8 = null,
            access_key_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            create_date: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .access_key_id = "AccessKeyId",
                    .status = "Status",
                    .create_date = "CreateDate",
                };
                return @field(mappings, field_name);
            }
        },
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_key_metadata = "AccessKeyMetadata",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_account_aliases: struct {
    action_name: []const u8 = "ListAccountAliases",
    Request: type = struct {
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_account_aliases) } {
            return .{ .service_metadata = service_metadata, .action = list_account_aliases };
        }
    },
    Response: type = struct {
        account_aliases: [][]const u8,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_aliases = "AccountAliases",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_attached_group_policies: struct {
    action_name: []const u8 = "ListAttachedGroupPolicies",
    Request: type = struct {
        group_name: []const u8,
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_attached_group_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_attached_group_policies };
        }
    },
    Response: type = struct {
        attached_policies: ?[]AttachedPolicy = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attached_policies = "AttachedPolicies",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_attached_role_policies: struct {
    action_name: []const u8 = "ListAttachedRolePolicies",
    Request: type = struct {
        role_name: []const u8,
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_attached_role_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_attached_role_policies };
        }
    },
    Response: type = struct {
        attached_policies: ?[]AttachedPolicy = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attached_policies = "AttachedPolicies",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_attached_user_policies: struct {
    action_name: []const u8 = "ListAttachedUserPolicies",
    Request: type = struct {
        user_name: []const u8,
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_attached_user_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_attached_user_policies };
        }
    },
    Response: type = struct {
        attached_policies: ?[]AttachedPolicy = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attached_policies = "AttachedPolicies",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_entities_for_policy: struct {
    action_name: []const u8 = "ListEntitiesForPolicy",
    Request: type = struct {
        policy_arn: []const u8,
        entity_filter: ?[]const u8 = null,
        path_prefix: ?[]const u8 = null,
        policy_usage_filter: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .entity_filter = "EntityFilter",
                .path_prefix = "PathPrefix",
                .policy_usage_filter = "PolicyUsageFilter",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entities_for_policy) } {
            return .{ .service_metadata = service_metadata, .action = list_entities_for_policy };
        }
    },
    Response: type = struct {
        policy_groups: ?[]struct {
            group_name: ?[]const u8 = null,
            group_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .group_name = "GroupName",
                    .group_id = "GroupId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        policy_users: ?[]struct {
            user_name: ?[]const u8 = null,
            user_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .user_id = "UserId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        policy_roles: ?[]struct {
            role_name: ?[]const u8 = null,
            role_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_name = "RoleName",
                    .role_id = "RoleId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_groups = "PolicyGroups",
                .policy_users = "PolicyUsers",
                .policy_roles = "PolicyRoles",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_group_policies: struct {
    action_name: []const u8 = "ListGroupPolicies",
    Request: type = struct {
        group_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_group_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_group_policies };
        }
    },
    Response: type = struct {
        policy_names: [][]const u8,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_names = "PolicyNames",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_groups: struct {
    action_name: []const u8 = "ListGroups",
    Request: type = struct {
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_groups };
        }
    },
    Response: type = struct {
        groups: []Group,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .groups = "Groups",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_groups_for_user: struct {
    action_name: []const u8 = "ListGroupsForUser",
    Request: type = struct {
        user_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_groups_for_user) } {
            return .{ .service_metadata = service_metadata, .action = list_groups_for_user };
        }
    },
    Response: type = struct {
        groups: []Group,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .groups = "Groups",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_instance_profiles: struct {
    action_name: []const u8 = "ListInstanceProfiles",
    Request: type = struct {
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_instance_profiles) } {
            return .{ .service_metadata = service_metadata, .action = list_instance_profiles };
        }
    },
    Response: type = struct {
        instance_profiles: []InstanceProfile,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profiles = "InstanceProfiles",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_instance_profiles_for_role: struct {
    action_name: []const u8 = "ListInstanceProfilesForRole",
    Request: type = struct {
        role_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_instance_profiles_for_role) } {
            return .{ .service_metadata = service_metadata, .action = list_instance_profiles_for_role };
        }
    },
    Response: type = struct {
        instance_profiles: []InstanceProfile,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profiles = "InstanceProfiles",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_instance_profile_tags: struct {
    action_name: []const u8 = "ListInstanceProfileTags",
    Request: type = struct {
        instance_profile_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_instance_profile_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_instance_profile_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_mfa_devices: struct {
    action_name: []const u8 = "ListMFADevices",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_mfa_devices) } {
            return .{ .service_metadata = service_metadata, .action = list_mfa_devices };
        }
    },
    Response: type = struct {
        mfa_devices: []struct {
            user_name: []const u8,
            serial_number: []const u8,
            enable_date: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .serial_number = "SerialNumber",
                    .enable_date = "EnableDate",
                };
                return @field(mappings, field_name);
            }
        },
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .mfa_devices = "MFADevices",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_mfa_device_tags: struct {
    action_name: []const u8 = "ListMFADeviceTags",
    Request: type = struct {
        serial_number: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .serial_number = "SerialNumber",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_mfa_device_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_mfa_device_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_open_id_connect_providers: struct {
    action_name: []const u8 = "ListOpenIDConnectProviders",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_open_id_connect_providers) } {
            return .{ .service_metadata = service_metadata, .action = list_open_id_connect_providers };
        }
    },
    Response: type = struct {
        open_id_connect_provider_list: ?[]struct {
            arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_list = "OpenIDConnectProviderList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_open_id_connect_provider_tags: struct {
    action_name: []const u8 = "ListOpenIDConnectProviderTags",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_open_id_connect_provider_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_open_id_connect_provider_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_policies: struct {
    action_name: []const u8 = "ListPolicies",
    Request: type = struct {
        scope: ?[]const u8 = null,
        only_attached: ?bool = null,
        path_prefix: ?[]const u8 = null,
        policy_usage_filter: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .scope = "Scope",
                .only_attached = "OnlyAttached",
                .path_prefix = "PathPrefix",
                .policy_usage_filter = "PolicyUsageFilter",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_policies };
        }
    },
    Response: type = struct {
        policies: ?[]Policy = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policies = "Policies",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_policies_granting_service_access: struct {
    action_name: []const u8 = "ListPoliciesGrantingServiceAccess",
    Request: type = struct {
        marker: ?[]const u8 = null,
        arn: []const u8,
        service_namespaces: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .marker = "Marker",
                .arn = "Arn",
                .service_namespaces = "ServiceNamespaces",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policies_granting_service_access) } {
            return .{ .service_metadata = service_metadata, .action = list_policies_granting_service_access };
        }
    },
    Response: type = struct {
        policies_granting_service_access: []struct {
            service_namespace: ?[]const u8 = null,
            policies: ?[]struct {
                policy_name: []const u8,
                policy_type: []const u8,
                policy_arn: ?[]const u8 = null,
                entity_type: ?[]const u8 = null,
                entity_name: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .policy_name = "PolicyName",
                        .policy_type = "PolicyType",
                        .policy_arn = "PolicyArn",
                        .entity_type = "EntityType",
                        .entity_name = "EntityName",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .service_namespace = "ServiceNamespace",
                    .policies = "Policies",
                };
                return @field(mappings, field_name);
            }
        },
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policies_granting_service_access = "PoliciesGrantingServiceAccess",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
    },
} = .{};
pub const list_policy_tags: struct {
    action_name: []const u8 = "ListPolicyTags",
    Request: type = struct {
        policy_arn: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policy_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_policy_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_policy_versions: struct {
    action_name: []const u8 = "ListPolicyVersions",
    Request: type = struct {
        policy_arn: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policy_versions) } {
            return .{ .service_metadata = service_metadata, .action = list_policy_versions };
        }
    },
    Response: type = struct {
        versions: ?[]PolicyVersion = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .versions = "Versions",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_role_policies: struct {
    action_name: []const u8 = "ListRolePolicies",
    Request: type = struct {
        role_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_role_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_role_policies };
        }
    },
    Response: type = struct {
        policy_names: [][]const u8,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_names = "PolicyNames",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_roles: struct {
    action_name: []const u8 = "ListRoles",
    Request: type = struct {
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_roles) } {
            return .{ .service_metadata = service_metadata, .action = list_roles };
        }
    },
    Response: type = struct {
        roles: []Role,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .roles = "Roles",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_role_tags: struct {
    action_name: []const u8 = "ListRoleTags",
    Request: type = struct {
        role_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_role_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_role_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_saml_providers: struct {
    action_name: []const u8 = "ListSAMLProviders",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_saml_providers) } {
            return .{ .service_metadata = service_metadata, .action = list_saml_providers };
        }
    },
    Response: type = struct {
        saml_provider_list: ?[]struct {
            arn: ?[]const u8 = null,
            valid_until: ?i64 = null,
            create_date: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .valid_until = "ValidUntil",
                    .create_date = "CreateDate",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_list = "SAMLProviderList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_saml_provider_tags: struct {
    action_name: []const u8 = "ListSAMLProviderTags",
    Request: type = struct {
        saml_provider_arn: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_saml_provider_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_saml_provider_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_server_certificates: struct {
    action_name: []const u8 = "ListServerCertificates",
    Request: type = struct {
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_server_certificates) } {
            return .{ .service_metadata = service_metadata, .action = list_server_certificates };
        }
    },
    Response: type = struct {
        server_certificate_metadata_list: []ServerCertificateMetadata,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_metadata_list = "ServerCertificateMetadataList",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_server_certificate_tags: struct {
    action_name: []const u8 = "ListServerCertificateTags",
    Request: type = struct {
        server_certificate_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_server_certificate_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_server_certificate_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_service_specific_credentials: struct {
    action_name: []const u8 = "ListServiceSpecificCredentials",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        service_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .service_name = "ServiceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_service_specific_credentials) } {
            return .{ .service_metadata = service_metadata, .action = list_service_specific_credentials };
        }
    },
    Response: type = struct {
        service_specific_credentials: ?[]struct {
            user_name: []const u8,
            status: []const u8,
            service_user_name: []const u8,
            create_date: i64,
            service_specific_credential_id: []const u8,
            service_name: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .status = "Status",
                    .service_user_name = "ServiceUserName",
                    .create_date = "CreateDate",
                    .service_specific_credential_id = "ServiceSpecificCredentialId",
                    .service_name = "ServiceName",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_specific_credentials = "ServiceSpecificCredentials",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceNotSupported,
    },
} = .{};
pub const list_signing_certificates: struct {
    action_name: []const u8 = "ListSigningCertificates",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_signing_certificates) } {
            return .{ .service_metadata = service_metadata, .action = list_signing_certificates };
        }
    },
    Response: type = struct {
        certificates: []SigningCertificate,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificates = "Certificates",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_ssh_public_keys: struct {
    action_name: []const u8 = "ListSSHPublicKeys",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_ssh_public_keys) } {
            return .{ .service_metadata = service_metadata, .action = list_ssh_public_keys };
        }
    },
    Response: type = struct {
        ssh_public_keys: ?[]struct {
            user_name: []const u8,
            ssh_public_key_id: []const u8,
            status: []const u8,
            upload_date: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .user_name = "UserName",
                    .ssh_public_key_id = "SSHPublicKeyId",
                    .status = "Status",
                    .upload_date = "UploadDate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ssh_public_keys = "SSHPublicKeys",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const list_user_policies: struct {
    action_name: []const u8 = "ListUserPolicies",
    Request: type = struct {
        user_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_user_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_user_policies };
        }
    },
    Response: type = struct {
        policy_names: [][]const u8,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_names = "PolicyNames",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_users: struct {
    action_name: []const u8 = "ListUsers",
    Request: type = struct {
        path_prefix: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path_prefix = "PathPrefix",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_users) } {
            return .{ .service_metadata = service_metadata, .action = list_users };
        }
    },
    Response: type = struct {
        users: []User,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .users = "Users",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const list_user_tags: struct {
    action_name: []const u8 = "ListUserTags",
    Request: type = struct {
        user_name: []const u8,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_user_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_user_tags };
        }
    },
    Response: type = struct {
        tags: []Tag,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const list_virtual_mfa_devices: struct {
    action_name: []const u8 = "ListVirtualMFADevices",
    Request: type = struct {
        assignment_status: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment_status = "AssignmentStatus",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_virtual_mfa_devices) } {
            return .{ .service_metadata = service_metadata, .action = list_virtual_mfa_devices };
        }
    },
    Response: type = struct {
        virtual_mfa_devices: []VirtualMFADevice,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .virtual_mfa_devices = "VirtualMFADevices",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const put_group_policy: struct {
    action_name: []const u8 = "PutGroupPolicy",
    Request: type = struct {
        group_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_group_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const put_role_permissions_boundary: struct {
    action_name: []const u8 = "PutRolePermissionsBoundary",
    Request: type = struct {
        role_name: []const u8,
        permissions_boundary: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .permissions_boundary = "PermissionsBoundary",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_role_permissions_boundary) } {
            return .{ .service_metadata = service_metadata, .action = put_role_permissions_boundary };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        PolicyNotAttachable,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const put_role_policy: struct {
    action_name: []const u8 = "PutRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_role_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const put_user_permissions_boundary: struct {
    action_name: []const u8 = "PutUserPermissionsBoundary",
    Request: type = struct {
        user_name: []const u8,
        permissions_boundary: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .permissions_boundary = "PermissionsBoundary",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_user_permissions_boundary) } {
            return .{ .service_metadata = service_metadata, .action = put_user_permissions_boundary };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        PolicyNotAttachable,
        ServiceFailure,
    },
} = .{};
pub const put_user_policy: struct {
    action_name: []const u8 = "PutUserPolicy",
    Request: type = struct {
        user_name: []const u8,
        policy_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .policy_name = "PolicyName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_user_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_user_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const remove_client_id_from_open_id_connect_provider: struct {
    action_name: []const u8 = "RemoveClientIDFromOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        client_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .client_id = "ClientID",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(remove_client_id_from_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = remove_client_id_from_open_id_connect_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const remove_role_from_instance_profile: struct {
    action_name: []const u8 = "RemoveRoleFromInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,
        role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .role_name = "RoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(remove_role_from_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = remove_role_from_instance_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const remove_user_from_group: struct {
    action_name: []const u8 = "RemoveUserFromGroup",
    Request: type = struct {
        group_name: []const u8,
        user_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .user_name = "UserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(remove_user_from_group) } {
            return .{ .service_metadata = service_metadata, .action = remove_user_from_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const reset_service_specific_credential: struct {
    action_name: []const u8 = "ResetServiceSpecificCredential",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        service_specific_credential_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .service_specific_credential_id = "ServiceSpecificCredentialId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reset_service_specific_credential) } {
            return .{ .service_metadata = service_metadata, .action = reset_service_specific_credential };
        }
    },
    Response: type = struct {
        service_specific_credential: ?ServiceSpecificCredential = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_specific_credential = "ServiceSpecificCredential",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const resync_mfa_device: struct {
    action_name: []const u8 = "ResyncMFADevice",
    Request: type = struct {
        user_name: []const u8,
        serial_number: []const u8,
        authentication_code1: []const u8,
        authentication_code2: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .serial_number = "SerialNumber",
                .authentication_code1 = "AuthenticationCode1",
                .authentication_code2 = "AuthenticationCode2",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(resync_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = resync_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidAuthenticationCode,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const set_default_policy_version: struct {
    action_name: []const u8 = "SetDefaultPolicyVersion",
    Request: type = struct {
        policy_arn: []const u8,
        version_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .version_id = "VersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_default_policy_version) } {
            return .{ .service_metadata = service_metadata, .action = set_default_policy_version };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const set_security_token_service_preferences: struct {
    action_name: []const u8 = "SetSecurityTokenServicePreferences",
    Request: type = struct {
        global_endpoint_token_version: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .global_endpoint_token_version = "GlobalEndpointTokenVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_security_token_service_preferences) } {
            return .{ .service_metadata = service_metadata, .action = set_security_token_service_preferences };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ServiceFailure,
    },
} = .{};
pub const simulate_custom_policy: struct {
    action_name: []const u8 = "SimulateCustomPolicy",
    Request: type = struct {
        policy_input_list: [][]const u8,
        permissions_boundary_policy_input_list: ?[][]const u8 = null,
        action_names: [][]const u8,
        resource_arns: ?[][]const u8 = null,
        resource_policy: ?[]const u8 = null,
        resource_owner: ?[]const u8 = null,
        caller_arn: ?[]const u8 = null,
        context_entries: ?[]ContextEntry = null,
        resource_handling_option: ?[]const u8 = null,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_input_list = "PolicyInputList",
                .permissions_boundary_policy_input_list = "PermissionsBoundaryPolicyInputList",
                .action_names = "ActionNames",
                .resource_arns = "ResourceArns",
                .resource_policy = "ResourcePolicy",
                .resource_owner = "ResourceOwner",
                .caller_arn = "CallerArn",
                .context_entries = "ContextEntries",
                .resource_handling_option = "ResourceHandlingOption",
                .max_items = "MaxItems",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(simulate_custom_policy) } {
            return .{ .service_metadata = service_metadata, .action = simulate_custom_policy };
        }
    },
    Response: type = struct {
        evaluation_results: ?[]EvaluationResult = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .evaluation_results = "EvaluationResults",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        PolicyEvaluation,
    },
} = .{};
pub const simulate_principal_policy: struct {
    action_name: []const u8 = "SimulatePrincipalPolicy",
    Request: type = struct {
        policy_source_arn: []const u8,
        policy_input_list: ?[][]const u8 = null,
        permissions_boundary_policy_input_list: ?[][]const u8 = null,
        action_names: [][]const u8,
        resource_arns: ?[][]const u8 = null,
        resource_policy: ?[]const u8 = null,
        resource_owner: ?[]const u8 = null,
        caller_arn: ?[]const u8 = null,
        context_entries: ?[]ContextEntry = null,
        resource_handling_option: ?[]const u8 = null,
        max_items: ?i64 = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_source_arn = "PolicySourceArn",
                .policy_input_list = "PolicyInputList",
                .permissions_boundary_policy_input_list = "PermissionsBoundaryPolicyInputList",
                .action_names = "ActionNames",
                .resource_arns = "ResourceArns",
                .resource_policy = "ResourcePolicy",
                .resource_owner = "ResourceOwner",
                .caller_arn = "CallerArn",
                .context_entries = "ContextEntries",
                .resource_handling_option = "ResourceHandlingOption",
                .max_items = "MaxItems",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(simulate_principal_policy) } {
            return .{ .service_metadata = service_metadata, .action = simulate_principal_policy };
        }
    },
    Response: type = struct {
        evaluation_results: ?[]EvaluationResult = null,
        is_truncated: ?bool = null,
        marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .evaluation_results = "EvaluationResults",
                .is_truncated = "IsTruncated",
                .marker = "Marker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        PolicyEvaluation,
    },
} = .{};
pub const tag_instance_profile: struct {
    action_name: []const u8 = "TagInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = tag_instance_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_mfa_device: struct {
    action_name: []const u8 = "TagMFADevice",
    Request: type = struct {
        serial_number: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .serial_number = "SerialNumber",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = tag_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_open_id_connect_provider: struct {
    action_name: []const u8 = "TagOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = tag_open_id_connect_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_policy: struct {
    action_name: []const u8 = "TagPolicy",
    Request: type = struct {
        policy_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_policy) } {
            return .{ .service_metadata = service_metadata, .action = tag_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_role: struct {
    action_name: []const u8 = "TagRole",
    Request: type = struct {
        role_name: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_role) } {
            return .{ .service_metadata = service_metadata, .action = tag_role };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_saml_provider: struct {
    action_name: []const u8 = "TagSAMLProvider",
    Request: type = struct {
        saml_provider_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = tag_saml_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_server_certificate: struct {
    action_name: []const u8 = "TagServerCertificate",
    Request: type = struct {
        server_certificate_name: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = tag_server_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const tag_user: struct {
    action_name: []const u8 = "TagUser",
    Request: type = struct {
        user_name: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_user) } {
            return .{ .service_metadata = service_metadata, .action = tag_user };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_instance_profile: struct {
    action_name: []const u8 = "UntagInstanceProfile",
    Request: type = struct {
        instance_profile_name: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_profile_name = "InstanceProfileName",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_instance_profile) } {
            return .{ .service_metadata = service_metadata, .action = untag_instance_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_mfa_device: struct {
    action_name: []const u8 = "UntagMFADevice",
    Request: type = struct {
        serial_number: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .serial_number = "SerialNumber",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_mfa_device) } {
            return .{ .service_metadata = service_metadata, .action = untag_mfa_device };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_open_id_connect_provider: struct {
    action_name: []const u8 = "UntagOpenIDConnectProvider",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_open_id_connect_provider) } {
            return .{ .service_metadata = service_metadata, .action = untag_open_id_connect_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_policy: struct {
    action_name: []const u8 = "UntagPolicy",
    Request: type = struct {
        policy_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_arn = "PolicyArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_policy) } {
            return .{ .service_metadata = service_metadata, .action = untag_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_role: struct {
    action_name: []const u8 = "UntagRole",
    Request: type = struct {
        role_name: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_role) } {
            return .{ .service_metadata = service_metadata, .action = untag_role };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_saml_provider: struct {
    action_name: []const u8 = "UntagSAMLProvider",
    Request: type = struct {
        saml_provider_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = untag_saml_provider };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_server_certificate: struct {
    action_name: []const u8 = "UntagServerCertificate",
    Request: type = struct {
        server_certificate_name: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = untag_server_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const untag_user: struct {
    action_name: []const u8 = "UntagUser",
    Request: type = struct {
        user_name: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_user) } {
            return .{ .service_metadata = service_metadata, .action = untag_user };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_access_key: struct {
    action_name: []const u8 = "UpdateAccessKey",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        access_key_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .access_key_id = "AccessKeyId",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_access_key) } {
            return .{ .service_metadata = service_metadata, .action = update_access_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_account_password_policy: struct {
    action_name: []const u8 = "UpdateAccountPasswordPolicy",
    Request: type = struct {
        minimum_password_length: ?i64 = null,
        require_symbols: ?bool = null,
        require_numbers: ?bool = null,
        require_uppercase_characters: ?bool = null,
        require_lowercase_characters: ?bool = null,
        allow_users_to_change_password: ?bool = null,
        max_password_age: ?i64 = null,
        password_reuse_prevention: ?i64 = null,
        hard_expiry: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .minimum_password_length = "MinimumPasswordLength",
                .require_symbols = "RequireSymbols",
                .require_numbers = "RequireNumbers",
                .require_uppercase_characters = "RequireUppercaseCharacters",
                .require_lowercase_characters = "RequireLowercaseCharacters",
                .allow_users_to_change_password = "AllowUsersToChangePassword",
                .max_password_age = "MaxPasswordAge",
                .password_reuse_prevention = "PasswordReusePrevention",
                .hard_expiry = "HardExpiry",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_account_password_policy) } {
            return .{ .service_metadata = service_metadata, .action = update_account_password_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_assume_role_policy: struct {
    action_name: []const u8 = "UpdateAssumeRolePolicy",
    Request: type = struct {
        role_name: []const u8,
        policy_document: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .policy_document = "PolicyDocument",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_assume_role_policy) } {
            return .{ .service_metadata = service_metadata, .action = update_assume_role_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        MalformedPolicyDocument,
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const update_group: struct {
    action_name: []const u8 = "UpdateGroup",
    Request: type = struct {
        group_name: []const u8,
        new_path: ?[]const u8 = null,
        new_group_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .group_name = "GroupName",
                .new_path = "NewPath",
                .new_group_name = "NewGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_group) } {
            return .{ .service_metadata = service_metadata, .action = update_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityAlreadyExists,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_login_profile: struct {
    action_name: []const u8 = "UpdateLoginProfile",
    Request: type = struct {
        user_name: []const u8,
        password: ?[]const u8 = null,
        password_reset_required: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .password = "Password",
                .password_reset_required = "PasswordResetRequired",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_login_profile) } {
            return .{ .service_metadata = service_metadata, .action = update_login_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityTemporarilyUnmodifiable,
        LimitExceeded,
        NoSuchEntity,
        PasswordPolicyViolation,
        ServiceFailure,
    },
} = .{};
pub const update_open_id_connect_provider_thumbprint: struct {
    action_name: []const u8 = "UpdateOpenIDConnectProviderThumbprint",
    Request: type = struct {
        open_id_connect_provider_arn: []const u8,
        thumbprint_list: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .open_id_connect_provider_arn = "OpenIDConnectProviderArn",
                .thumbprint_list = "ThumbprintList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_open_id_connect_provider_thumbprint) } {
            return .{ .service_metadata = service_metadata, .action = update_open_id_connect_provider_thumbprint };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_role: struct {
    action_name: []const u8 = "UpdateRole",
    Request: type = struct {
        role_name: []const u8,
        description: ?[]const u8 = null,
        max_session_duration: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .description = "Description",
                .max_session_duration = "MaxSessionDuration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_role) } {
            return .{ .service_metadata = service_metadata, .action = update_role };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const update_role_description: struct {
    action_name: []const u8 = "UpdateRoleDescription",
    Request: type = struct {
        role_name: []const u8,
        description: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_name = "RoleName",
                .description = "Description",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_role_description) } {
            return .{ .service_metadata = service_metadata, .action = update_role_description };
        }
    },
    Response: type = struct {
        role: ?Role = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role = "Role",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        NoSuchEntity,
        ServiceFailure,
        UnmodifiableEntity,
    },
} = .{};
pub const update_saml_provider: struct {
    action_name: []const u8 = "UpdateSAMLProvider",
    Request: type = struct {
        saml_metadata_document: []const u8,
        saml_provider_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_metadata_document = "SAMLMetadataDocument",
                .saml_provider_arn = "SAMLProviderArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_saml_provider) } {
            return .{ .service_metadata = service_metadata, .action = update_saml_provider };
        }
    },
    Response: type = struct {
        saml_provider_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .saml_provider_arn = "SAMLProviderArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_server_certificate: struct {
    action_name: []const u8 = "UpdateServerCertificate",
    Request: type = struct {
        server_certificate_name: []const u8,
        new_path: ?[]const u8 = null,
        new_server_certificate_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_name = "ServerCertificateName",
                .new_path = "NewPath",
                .new_server_certificate_name = "NewServerCertificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = update_server_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        EntityAlreadyExists,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_service_specific_credential: struct {
    action_name: []const u8 = "UpdateServiceSpecificCredential",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        service_specific_credential_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .service_specific_credential_id = "ServiceSpecificCredentialId",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_service_specific_credential) } {
            return .{ .service_metadata = service_metadata, .action = update_service_specific_credential };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const update_signing_certificate: struct {
    action_name: []const u8 = "UpdateSigningCertificate",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        certificate_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .certificate_id = "CertificateId",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_signing_certificate) } {
            return .{ .service_metadata = service_metadata, .action = update_signing_certificate };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const update_ssh_public_key: struct {
    action_name: []const u8 = "UpdateSSHPublicKey",
    Request: type = struct {
        user_name: []const u8,
        ssh_public_key_id: []const u8,
        status: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .ssh_public_key_id = "SSHPublicKeyId",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_ssh_public_key) } {
            return .{ .service_metadata = service_metadata, .action = update_ssh_public_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        NoSuchEntity,
    },
} = .{};
pub const update_user: struct {
    action_name: []const u8 = "UpdateUser",
    Request: type = struct {
        user_name: []const u8,
        new_path: ?[]const u8 = null,
        new_user_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .new_path = "NewPath",
                .new_user_name = "NewUserName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_user) } {
            return .{ .service_metadata = service_metadata, .action = update_user };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        EntityTemporarilyUnmodifiable,
        LimitExceeded,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const upload_server_certificate: struct {
    action_name: []const u8 = "UploadServerCertificate",
    Request: type = struct {
        path: ?[]const u8 = null,
        server_certificate_name: []const u8,
        certificate_body: []const u8,
        private_key: []const u8,
        certificate_chain: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .path = "Path",
                .server_certificate_name = "ServerCertificateName",
                .certificate_body = "CertificateBody",
                .private_key = "PrivateKey",
                .certificate_chain = "CertificateChain",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(upload_server_certificate) } {
            return .{ .service_metadata = service_metadata, .action = upload_server_certificate };
        }
    },
    Response: type = struct {
        server_certificate_metadata: ?ServerCertificateMetadata = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .server_certificate_metadata = "ServerCertificateMetadata",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        EntityAlreadyExists,
        InvalidInput,
        KeyPairMismatch,
        LimitExceeded,
        MalformedCertificate,
        ServiceFailure,
    },
} = .{};
pub const upload_signing_certificate: struct {
    action_name: []const u8 = "UploadSigningCertificate",
    Request: type = struct {
        user_name: ?[]const u8 = null,
        certificate_body: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .certificate_body = "CertificateBody",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(upload_signing_certificate) } {
            return .{ .service_metadata = service_metadata, .action = upload_signing_certificate };
        }
    },
    Response: type = struct {
        certificate: SigningCertificate,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificate = "Certificate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        DuplicateCertificate,
        EntityAlreadyExists,
        InvalidCertificate,
        LimitExceeded,
        MalformedCertificate,
        NoSuchEntity,
        ServiceFailure,
    },
} = .{};
pub const upload_ssh_public_key: struct {
    action_name: []const u8 = "UploadSSHPublicKey",
    Request: type = struct {
        user_name: []const u8,
        ssh_public_key_body: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_name = "UserName",
                .ssh_public_key_body = "SSHPublicKeyBody",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(upload_ssh_public_key) } {
            return .{ .service_metadata = service_metadata, .action = upload_ssh_public_key };
        }
    },
    Response: type = struct {
        ssh_public_key: ?SSHPublicKey = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ssh_public_key = "SSHPublicKey",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateSSHPublicKey,
        InvalidPublicKey,
        LimitExceeded,
        NoSuchEntity,
        UnrecognizedPublicKeyEncoding,
    },
} = .{};

pub const SSHPublicKey = struct {
    user_name: []const u8,
    ssh_public_key_id: []const u8,
    fingerprint: []const u8,
    ssh_public_key_body: []const u8,
    status: []const u8,
    upload_date: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .user_name = "UserName",
            .ssh_public_key_id = "SSHPublicKeyId",
            .fingerprint = "Fingerprint",
            .ssh_public_key_body = "SSHPublicKeyBody",
            .status = "Status",
            .upload_date = "UploadDate",
        };
        return @field(mappings, field_name);
    }
};

pub const SigningCertificate = struct {
    user_name: []const u8,
    certificate_id: []const u8,
    certificate_body: []const u8,
    status: []const u8,
    upload_date: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .user_name = "UserName",
            .certificate_id = "CertificateId",
            .certificate_body = "CertificateBody",
            .status = "Status",
            .upload_date = "UploadDate",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const ServerCertificateMetadata = struct {
    path: []const u8,
    server_certificate_name: []const u8,
    server_certificate_id: []const u8,
    arn: []const u8,
    upload_date: ?i64 = null,
    expiration: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "Path",
            .server_certificate_name = "ServerCertificateName",
            .server_certificate_id = "ServerCertificateId",
            .arn = "Arn",
            .upload_date = "UploadDate",
            .expiration = "Expiration",
        };
        return @field(mappings, field_name);
    }
};

pub const Role = struct {
    path: []const u8,
    role_name: []const u8,
    role_id: []const u8,
    arn: []const u8,
    create_date: i64,
    assume_role_policy_document: ?[]const u8 = null,
    description: ?[]const u8 = null,
    max_session_duration: ?i64 = null,
    permissions_boundary: ?AttachedPermissionsBoundary = null,
    tags: ?[]Tag = null,
    role_last_used: ?RoleLastUsed = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "Path",
            .role_name = "RoleName",
            .role_id = "RoleId",
            .arn = "Arn",
            .create_date = "CreateDate",
            .assume_role_policy_document = "AssumeRolePolicyDocument",
            .description = "Description",
            .max_session_duration = "MaxSessionDuration",
            .permissions_boundary = "PermissionsBoundary",
            .tags = "Tags",
            .role_last_used = "RoleLastUsed",
        };
        return @field(mappings, field_name);
    }
};

pub const RoleLastUsed = struct {
    last_used_date: ?i64 = null,
    region: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .last_used_date = "LastUsedDate",
            .region = "Region",
        };
        return @field(mappings, field_name);
    }
};

pub const AttachedPermissionsBoundary = struct {
    permissions_boundary_type: ?[]const u8 = null,
    permissions_boundary_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .permissions_boundary_type = "PermissionsBoundaryType",
            .permissions_boundary_arn = "PermissionsBoundaryArn",
        };
        return @field(mappings, field_name);
    }
};

pub const EvaluationResult = struct {
    eval_action_name: []const u8,
    eval_resource_name: ?[]const u8 = null,
    eval_decision: []const u8,
    matched_statements: ?[]Statement = null,
    missing_context_values: ?[][]const u8 = null,
    organizations_decision_detail: ?OrganizationsDecisionDetail = null,
    permissions_boundary_decision_detail: ?PermissionsBoundaryDecisionDetail = null,
    eval_decision_details: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    resource_specific_results: ?[]ResourceSpecificResult = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .eval_action_name = "EvalActionName",
            .eval_resource_name = "EvalResourceName",
            .eval_decision = "EvalDecision",
            .matched_statements = "MatchedStatements",
            .missing_context_values = "MissingContextValues",
            .organizations_decision_detail = "OrganizationsDecisionDetail",
            .permissions_boundary_decision_detail = "PermissionsBoundaryDecisionDetail",
            .eval_decision_details = "EvalDecisionDetails",
            .resource_specific_results = "ResourceSpecificResults",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "eval_decision_details", field_name))
            return try serializeMap(self.eval_decision_details, self.fieldNameFor("eval_decision_details"), options, out_stream);
        return false;
    }
};

pub const ResourceSpecificResult = struct {
    eval_resource_name: []const u8,
    eval_resource_decision: []const u8,
    matched_statements: ?[]Statement = null,
    missing_context_values: ?[][]const u8 = null,
    eval_decision_details: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    permissions_boundary_decision_detail: ?PermissionsBoundaryDecisionDetail = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .eval_resource_name = "EvalResourceName",
            .eval_resource_decision = "EvalResourceDecision",
            .matched_statements = "MatchedStatements",
            .missing_context_values = "MissingContextValues",
            .eval_decision_details = "EvalDecisionDetails",
            .permissions_boundary_decision_detail = "PermissionsBoundaryDecisionDetail",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "eval_decision_details", field_name))
            return try serializeMap(self.eval_decision_details, self.fieldNameFor("eval_decision_details"), options, out_stream);
        return false;
    }
};

pub const PermissionsBoundaryDecisionDetail = struct {
    allowed_by_permissions_boundary: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .allowed_by_permissions_boundary = "AllowedByPermissionsBoundary",
        };
        return @field(mappings, field_name);
    }
};

pub const Statement = struct {
    source_policy_id: ?[]const u8 = null,
    source_policy_type: ?[]const u8 = null,
    start_position: ?Position = null,
    end_position: ?Position = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .source_policy_id = "SourcePolicyId",
            .source_policy_type = "SourcePolicyType",
            .start_position = "StartPosition",
            .end_position = "EndPosition",
        };
        return @field(mappings, field_name);
    }
};

pub const Position = struct {
    line: ?i64 = null,
    column: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .line = "Line",
            .column = "Column",
        };
        return @field(mappings, field_name);
    }
};

pub const OrganizationsDecisionDetail = struct {
    allowed_by_organizations: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .allowed_by_organizations = "AllowedByOrganizations",
        };
        return @field(mappings, field_name);
    }
};

pub const ContextEntry = struct {
    context_key_name: ?[]const u8 = null,
    context_key_values: ?[][]const u8 = null,
    context_key_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .context_key_name = "ContextKeyName",
            .context_key_values = "ContextKeyValues",
            .context_key_type = "ContextKeyType",
        };
        return @field(mappings, field_name);
    }
};

pub const ServiceSpecificCredential = struct {
    create_date: i64,
    service_name: []const u8,
    service_user_name: []const u8,
    service_password: []const u8,
    service_specific_credential_id: []const u8,
    user_name: []const u8,
    status: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .create_date = "CreateDate",
            .service_name = "ServiceName",
            .service_user_name = "ServiceUserName",
            .service_password = "ServicePassword",
            .service_specific_credential_id = "ServiceSpecificCredentialId",
            .user_name = "UserName",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const VirtualMFADevice = struct {
    serial_number: []const u8,
    base32_string_seed: ?[]const u8 = null,
    qr_code_png: ?[]const u8 = null,
    user: ?User = null,
    enable_date: ?i64 = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .serial_number = "SerialNumber",
            .base32_string_seed = "Base32StringSeed",
            .qr_code_png = "QRCodePNG",
            .user = "User",
            .enable_date = "EnableDate",
            .tags = "Tags",
        };
        return @field(mappings, field_name);
    }
};

pub const User = struct {
    path: []const u8,
    user_name: []const u8,
    user_id: []const u8,
    arn: []const u8,
    create_date: i64,
    password_last_used: ?i64 = null,
    permissions_boundary: ?AttachedPermissionsBoundary = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "Path",
            .user_name = "UserName",
            .user_id = "UserId",
            .arn = "Arn",
            .create_date = "CreateDate",
            .password_last_used = "PasswordLastUsed",
            .permissions_boundary = "PermissionsBoundary",
            .tags = "Tags",
        };
        return @field(mappings, field_name);
    }
};

pub const PolicyVersion = struct {
    document: ?[]const u8 = null,
    version_id: ?[]const u8 = null,
    is_default_version: ?bool = null,
    create_date: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .document = "Document",
            .version_id = "VersionId",
            .is_default_version = "IsDefaultVersion",
            .create_date = "CreateDate",
        };
        return @field(mappings, field_name);
    }
};

pub const Policy = struct {
    policy_name: ?[]const u8 = null,
    policy_id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    path: ?[]const u8 = null,
    default_version_id: ?[]const u8 = null,
    attachment_count: ?i64 = null,
    permissions_boundary_usage_count: ?i64 = null,
    is_attachable: ?bool = null,
    description: ?[]const u8 = null,
    create_date: ?i64 = null,
    update_date: ?i64 = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_name = "PolicyName",
            .policy_id = "PolicyId",
            .arn = "Arn",
            .path = "Path",
            .default_version_id = "DefaultVersionId",
            .attachment_count = "AttachmentCount",
            .permissions_boundary_usage_count = "PermissionsBoundaryUsageCount",
            .is_attachable = "IsAttachable",
            .description = "Description",
            .create_date = "CreateDate",
            .update_date = "UpdateDate",
            .tags = "Tags",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceProfile = struct {
    path: []const u8,
    instance_profile_name: []const u8,
    instance_profile_id: []const u8,
    arn: []const u8,
    create_date: i64,
    roles: []Role,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "Path",
            .instance_profile_name = "InstanceProfileName",
            .instance_profile_id = "InstanceProfileId",
            .arn = "Arn",
            .create_date = "CreateDate",
            .roles = "Roles",
            .tags = "Tags",
        };
        return @field(mappings, field_name);
    }
};

pub const Group = struct {
    path: []const u8,
    group_name: []const u8,
    group_id: []const u8,
    arn: []const u8,
    create_date: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "Path",
            .group_name = "GroupName",
            .group_id = "GroupId",
            .arn = "Arn",
            .create_date = "CreateDate",
        };
        return @field(mappings, field_name);
    }
};

pub const AttachedPolicy = struct {
    policy_name: ?[]const u8 = null,
    policy_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_name = "PolicyName",
            .policy_arn = "PolicyArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ErrorDetails = struct {
    message: []const u8,
    code: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .message = "Message",
            .code = "Code",
        };
        return @field(mappings, field_name);
    }
};

pub const LoginProfile = struct {
    user_name: []const u8,
    create_date: i64,
    password_reset_required: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .user_name = "UserName",
            .create_date = "CreateDate",
            .password_reset_required = "PasswordResetRequired",
        };
        return @field(mappings, field_name);
    }
};

pub const PolicyDetail = struct {
    policy_name: ?[]const u8 = null,
    policy_document: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_name = "PolicyName",
            .policy_document = "PolicyDocument",
        };
        return @field(mappings, field_name);
    }
};
