const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2023-08-08";
pub const sdk_id: []const u8 = "Inspector Scan";
pub const arn_namespace: ?[]const u8 = "inspector-scan";
pub const endpoint_prefix: []const u8 = "";
pub const sigv4_name: []const u8 = "inspector-scan";
pub const name: []const u8 = "InspectorScan";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2023-08-08",
    sdk_id: []const u8 = "Inspector Scan",
    arn_namespace: ?[]const u8 = "inspector-scan",
    endpoint_prefix: []const u8 = "",
    sigv4_name: []const u8 = "inspector-scan",
    name: []const u8 = "InspectorScan",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const scan_sbom: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/scan/sbom",
        .success_code = 200,
    };

    action_name: []const u8 = "ScanSbom",
    Request: type = struct {
        sbom: []const u8,
        output_format: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sbom = "sbom",
                .output_format = "outputFormat",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(scan_sbom) } {
            return .{ .service_metadata = service_metadata, .action = scan_sbom };
        }
    },
    Response: type = struct {
        sbom: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sbom = "sbom",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Throttling,
        Validation,
    },
} = .{};
