const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2015-08-14";
pub const sdk_id: []const u8 = "Kinesis Analytics";
pub const arn_namespace: ?[]const u8 = "kinesisanalytics";
pub const endpoint_prefix: []const u8 = "kinesisanalytics";
pub const sigv4_name: []const u8 = "kinesisanalytics";
pub const name: []const u8 = "KinesisAnalytics_20150814";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2015-08-14",
    sdk_id: []const u8 = "Kinesis Analytics",
    arn_namespace: ?[]const u8 = "kinesisanalytics",
    endpoint_prefix: []const u8 = "kinesisanalytics",
    sigv4_name: []const u8 = "kinesisanalytics",
    name: []const u8 = "KinesisAnalytics_20150814",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const add_application_cloud_watch_logging_option: struct {
    action_name: []const u8 = "AddApplicationCloudWatchLoggingOption",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        cloud_watch_logging_option: CloudWatchLoggingOption,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .cloud_watch_logging_option = "CloudWatchLoggingOption",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_cloud_watch_logging_option) } {
            return .{ .service_metadata = service_metadata, .action = add_application_cloud_watch_logging_option };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const add_application_input: struct {
    action_name: []const u8 = "AddApplicationInput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input: Input,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input = "Input",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_input) } {
            return .{ .service_metadata = service_metadata, .action = add_application_input };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const add_application_input_processing_configuration: struct {
    action_name: []const u8 = "AddApplicationInputProcessingConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input_id: []const u8,
        input_processing_configuration: InputProcessingConfiguration,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input_id = "InputId",
                .input_processing_configuration = "InputProcessingConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_input_processing_configuration) } {
            return .{ .service_metadata = service_metadata, .action = add_application_input_processing_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const add_application_output: struct {
    action_name: []const u8 = "AddApplicationOutput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        output: Output,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .output = "Output",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_output) } {
            return .{ .service_metadata = service_metadata, .action = add_application_output };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const add_application_reference_data_source: struct {
    action_name: []const u8 = "AddApplicationReferenceDataSource",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        reference_data_source: struct {
            table_name: []const u8,
            s3_reference_data_source: ?struct {
                bucket_arn: []const u8,
                file_key: []const u8,
                reference_role_arn: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .bucket_arn = "BucketARN",
                        .file_key = "FileKey",
                        .reference_role_arn = "ReferenceRoleARN",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            reference_schema: SourceSchema,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .table_name = "TableName",
                    .s3_reference_data_source = "S3ReferenceDataSource",
                    .reference_schema = "ReferenceSchema",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .reference_data_source = "ReferenceDataSource",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_reference_data_source) } {
            return .{ .service_metadata = service_metadata, .action = add_application_reference_data_source };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const create_application: struct {
    action_name: []const u8 = "CreateApplication",
    Request: type = struct {
        application_name: []const u8,
        application_description: ?[]const u8 = null,
        inputs: ?[]Input = null,
        outputs: ?[]Output = null,
        cloud_watch_logging_options: ?[]CloudWatchLoggingOption = null,
        application_code: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .application_description = "ApplicationDescription",
                .inputs = "Inputs",
                .outputs = "Outputs",
                .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                .application_code = "ApplicationCode",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application) } {
            return .{ .service_metadata = service_metadata, .action = create_application };
        }
    },
    Response: type = struct {
        application_summary: ApplicationSummary,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_summary = "ApplicationSummary",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidArgument,
        LimitExceeded,
        ResourceInUse,
        TooManyTags,
    },
} = .{};
pub const delete_application: struct {
    action_name: []const u8 = "DeleteApplication",
    Request: type = struct {
        application_name: []const u8,
        create_timestamp: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .create_timestamp = "CreateTimestamp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application) } {
            return .{ .service_metadata = service_metadata, .action = delete_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application_cloud_watch_logging_option: struct {
    action_name: []const u8 = "DeleteApplicationCloudWatchLoggingOption",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        cloud_watch_logging_option_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_cloud_watch_logging_option) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_cloud_watch_logging_option };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application_input_processing_configuration: struct {
    action_name: []const u8 = "DeleteApplicationInputProcessingConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input_id = "InputId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_input_processing_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_input_processing_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application_output: struct {
    action_name: []const u8 = "DeleteApplicationOutput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        output_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .output_id = "OutputId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_output) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_output };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application_reference_data_source: struct {
    action_name: []const u8 = "DeleteApplicationReferenceDataSource",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        reference_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .reference_id = "ReferenceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_reference_data_source) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_reference_data_source };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const describe_application: struct {
    action_name: []const u8 = "DescribeApplication",
    Request: type = struct {
        application_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_application) } {
            return .{ .service_metadata = service_metadata, .action = describe_application };
        }
    },
    Response: type = struct {
        application_detail: struct {
            application_name: []const u8,
            application_description: ?[]const u8 = null,
            application_arn: []const u8,
            application_status: []const u8,
            create_timestamp: ?i64 = null,
            last_update_timestamp: ?i64 = null,
            input_descriptions: ?[]struct {
                input_id: ?[]const u8 = null,
                name_prefix: ?[]const u8 = null,
                in_app_stream_names: ?[][]const u8 = null,
                input_processing_configuration_description: ?struct {
                    input_lambda_processor_description: ?struct {
                        resource_arn: ?[]const u8 = null,
                        role_arn: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn = "ResourceARN",
                                .role_arn = "RoleARN",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .input_lambda_processor_description = "InputLambdaProcessorDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_streams_input_description: ?struct {
                    resource_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn = "ResourceARN",
                            .role_arn = "RoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_firehose_input_description: ?struct {
                    resource_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn = "ResourceARN",
                            .role_arn = "RoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                input_schema: ?SourceSchema = null,
                input_parallelism: ?InputParallelism = null,
                input_starting_position_configuration: ?InputStartingPositionConfiguration = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .input_id = "InputId",
                        .name_prefix = "NamePrefix",
                        .in_app_stream_names = "InAppStreamNames",
                        .input_processing_configuration_description = "InputProcessingConfigurationDescription",
                        .kinesis_streams_input_description = "KinesisStreamsInputDescription",
                        .kinesis_firehose_input_description = "KinesisFirehoseInputDescription",
                        .input_schema = "InputSchema",
                        .input_parallelism = "InputParallelism",
                        .input_starting_position_configuration = "InputStartingPositionConfiguration",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            output_descriptions: ?[]struct {
                output_id: ?[]const u8 = null,
                name: ?[]const u8 = null,
                kinesis_streams_output_description: ?struct {
                    resource_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn = "ResourceARN",
                            .role_arn = "RoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_firehose_output_description: ?struct {
                    resource_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn = "ResourceARN",
                            .role_arn = "RoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                lambda_output_description: ?struct {
                    resource_arn: ?[]const u8 = null,
                    role_arn: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn = "ResourceARN",
                            .role_arn = "RoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                destination_schema: ?DestinationSchema = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .output_id = "OutputId",
                        .name = "Name",
                        .kinesis_streams_output_description = "KinesisStreamsOutputDescription",
                        .kinesis_firehose_output_description = "KinesisFirehoseOutputDescription",
                        .lambda_output_description = "LambdaOutputDescription",
                        .destination_schema = "DestinationSchema",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            reference_data_source_descriptions: ?[]struct {
                reference_id: []const u8,
                table_name: []const u8,
                s3_reference_data_source_description: struct {
                    bucket_arn: []const u8,
                    file_key: []const u8,
                    reference_role_arn: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .bucket_arn = "BucketARN",
                            .file_key = "FileKey",
                            .reference_role_arn = "ReferenceRoleARN",
                        };
                        return @field(mappings, field_name);
                    }
                },
                reference_schema: ?SourceSchema = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .reference_id = "ReferenceId",
                        .table_name = "TableName",
                        .s3_reference_data_source_description = "S3ReferenceDataSourceDescription",
                        .reference_schema = "ReferenceSchema",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            cloud_watch_logging_option_descriptions: ?[]struct {
                cloud_watch_logging_option_id: ?[]const u8 = null,
                log_stream_arn: []const u8,
                role_arn: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
                        .log_stream_arn = "LogStreamARN",
                        .role_arn = "RoleARN",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_code: ?[]const u8 = null,
            application_version_id: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .application_name = "ApplicationName",
                    .application_description = "ApplicationDescription",
                    .application_arn = "ApplicationARN",
                    .application_status = "ApplicationStatus",
                    .create_timestamp = "CreateTimestamp",
                    .last_update_timestamp = "LastUpdateTimestamp",
                    .input_descriptions = "InputDescriptions",
                    .output_descriptions = "OutputDescriptions",
                    .reference_data_source_descriptions = "ReferenceDataSourceDescriptions",
                    .cloud_watch_logging_option_descriptions = "CloudWatchLoggingOptionDescriptions",
                    .application_code = "ApplicationCode",
                    .application_version_id = "ApplicationVersionId",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_detail = "ApplicationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const discover_input_schema: struct {
    action_name: []const u8 = "DiscoverInputSchema",
    Request: type = struct {
        resource_arn: ?[]const u8 = null,
        role_arn: ?[]const u8 = null,
        input_starting_position_configuration: ?InputStartingPositionConfiguration = null,
        s3_configuration: ?struct {
            role_arn: []const u8,
            bucket_arn: []const u8,
            file_key: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .role_arn = "RoleARN",
                    .bucket_arn = "BucketARN",
                    .file_key = "FileKey",
                };
                return @field(mappings, field_name);
            }
        } = null,
        input_processing_configuration: ?InputProcessingConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .role_arn = "RoleARN",
                .input_starting_position_configuration = "InputStartingPositionConfiguration",
                .s3_configuration = "S3Configuration",
                .input_processing_configuration = "InputProcessingConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(discover_input_schema) } {
            return .{ .service_metadata = service_metadata, .action = discover_input_schema };
        }
    },
    Response: type = struct {
        input_schema: ?SourceSchema = null,
        parsed_input_records: ?[][][]const u8 = null,
        processed_input_records: ?[][]const u8 = null,
        raw_input_records: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_schema = "InputSchema",
                .parsed_input_records = "ParsedInputRecords",
                .processed_input_records = "ProcessedInputRecords",
                .raw_input_records = "RawInputRecords",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        ResourceProvisionedThroughputExceeded,
        ServiceUnavailable,
        UnableToDetectSchema,
    },
} = .{};
pub const list_applications: struct {
    action_name: []const u8 = "ListApplications",
    Request: type = struct {
        limit: ?i64 = null,
        exclusive_start_application_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .limit = "Limit",
                .exclusive_start_application_name = "ExclusiveStartApplicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_applications) } {
            return .{ .service_metadata = service_metadata, .action = list_applications };
        }
    },
    Response: type = struct {
        application_summaries: []ApplicationSummary,
        has_more_applications: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_summaries = "ApplicationSummaries",
                .has_more_applications = "HasMoreApplications",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceNotFound,
    },
} = .{};
pub const start_application: struct {
    action_name: []const u8 = "StartApplication",
    Request: type = struct {
        application_name: []const u8,
        input_configurations: []struct {
            id: []const u8,
            input_starting_position_configuration: InputStartingPositionConfiguration,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .input_starting_position_configuration = "InputStartingPositionConfiguration",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .input_configurations = "InputConfigurations",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_application) } {
            return .{ .service_metadata = service_metadata, .action = start_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidApplicationConfiguration,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const stop_application: struct {
    action_name: []const u8 = "StopApplication",
    Request: type = struct {
        application_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_application) } {
            return .{ .service_metadata = service_metadata, .action = stop_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const update_application: struct {
    action_name: []const u8 = "UpdateApplication",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        application_update: struct {
            input_updates: ?[]struct {
                input_id: []const u8,
                name_prefix_update: ?[]const u8 = null,
                input_processing_configuration_update: ?struct {
                    input_lambda_processor_update: struct {
                        resource_arn_update: ?[]const u8 = null,
                        role_arn_update: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                                .role_arn_update = "RoleARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    },

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .input_lambda_processor_update = "InputLambdaProcessorUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_streams_input_update: ?struct {
                    resource_arn_update: ?[]const u8 = null,
                    role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn_update = "ResourceARNUpdate",
                            .role_arn_update = "RoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_firehose_input_update: ?struct {
                    resource_arn_update: ?[]const u8 = null,
                    role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn_update = "ResourceARNUpdate",
                            .role_arn_update = "RoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                input_schema_update: ?struct {
                    record_format_update: ?RecordFormat = null,
                    record_encoding_update: ?[]const u8 = null,
                    record_column_updates: ?[]RecordColumn = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .record_format_update = "RecordFormatUpdate",
                            .record_encoding_update = "RecordEncodingUpdate",
                            .record_column_updates = "RecordColumnUpdates",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                input_parallelism_update: ?struct {
                    count_update: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .count_update = "CountUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .input_id = "InputId",
                        .name_prefix_update = "NamePrefixUpdate",
                        .input_processing_configuration_update = "InputProcessingConfigurationUpdate",
                        .kinesis_streams_input_update = "KinesisStreamsInputUpdate",
                        .kinesis_firehose_input_update = "KinesisFirehoseInputUpdate",
                        .input_schema_update = "InputSchemaUpdate",
                        .input_parallelism_update = "InputParallelismUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_code_update: ?[]const u8 = null,
            output_updates: ?[]struct {
                output_id: []const u8,
                name_update: ?[]const u8 = null,
                kinesis_streams_output_update: ?struct {
                    resource_arn_update: ?[]const u8 = null,
                    role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn_update = "ResourceARNUpdate",
                            .role_arn_update = "RoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                kinesis_firehose_output_update: ?struct {
                    resource_arn_update: ?[]const u8 = null,
                    role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn_update = "ResourceARNUpdate",
                            .role_arn_update = "RoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                lambda_output_update: ?struct {
                    resource_arn_update: ?[]const u8 = null,
                    role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .resource_arn_update = "ResourceARNUpdate",
                            .role_arn_update = "RoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                destination_schema_update: ?DestinationSchema = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .output_id = "OutputId",
                        .name_update = "NameUpdate",
                        .kinesis_streams_output_update = "KinesisStreamsOutputUpdate",
                        .kinesis_firehose_output_update = "KinesisFirehoseOutputUpdate",
                        .lambda_output_update = "LambdaOutputUpdate",
                        .destination_schema_update = "DestinationSchemaUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            reference_data_source_updates: ?[]struct {
                reference_id: []const u8,
                table_name_update: ?[]const u8 = null,
                s3_reference_data_source_update: ?struct {
                    bucket_arn_update: ?[]const u8 = null,
                    file_key_update: ?[]const u8 = null,
                    reference_role_arn_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .bucket_arn_update = "BucketARNUpdate",
                            .file_key_update = "FileKeyUpdate",
                            .reference_role_arn_update = "ReferenceRoleARNUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                reference_schema_update: ?SourceSchema = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .reference_id = "ReferenceId",
                        .table_name_update = "TableNameUpdate",
                        .s3_reference_data_source_update = "S3ReferenceDataSourceUpdate",
                        .reference_schema_update = "ReferenceSchemaUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            cloud_watch_logging_option_updates: ?[]struct {
                cloud_watch_logging_option_id: []const u8,
                log_stream_arn_update: ?[]const u8 = null,
                role_arn_update: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
                        .log_stream_arn_update = "LogStreamARNUpdate",
                        .role_arn_update = "RoleARNUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .input_updates = "InputUpdates",
                    .application_code_update = "ApplicationCodeUpdate",
                    .output_updates = "OutputUpdates",
                    .reference_data_source_updates = "ReferenceDataSourceUpdates",
                    .cloud_watch_logging_option_updates = "CloudWatchLoggingOptionUpdates",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .application_update = "ApplicationUpdate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application) } {
            return .{ .service_metadata = service_metadata, .action = update_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};

pub const SourceSchema = struct {
    record_format: RecordFormat,
    record_encoding: ?[]const u8 = null,
    record_columns: []RecordColumn,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format = "RecordFormat",
            .record_encoding = "RecordEncoding",
            .record_columns = "RecordColumns",
        };
        return @field(mappings, field_name);
    }
};

pub const RecordColumn = struct {
    name: []const u8,
    mapping: ?[]const u8 = null,
    sql_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .mapping = "Mapping",
            .sql_type = "SqlType",
        };
        return @field(mappings, field_name);
    }
};

pub const RecordFormat = struct {
    record_format_type: []const u8,
    mapping_parameters: ?MappingParameters = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format_type = "RecordFormatType",
            .mapping_parameters = "MappingParameters",
        };
        return @field(mappings, field_name);
    }
};

pub const MappingParameters = struct {
    json_mapping_parameters: ?JSONMappingParameters = null,
    csv_mapping_parameters: ?CSVMappingParameters = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .json_mapping_parameters = "JSONMappingParameters",
            .csv_mapping_parameters = "CSVMappingParameters",
        };
        return @field(mappings, field_name);
    }
};

pub const CSVMappingParameters = struct {
    record_row_delimiter: []const u8,
    record_column_delimiter: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_row_delimiter = "RecordRowDelimiter",
            .record_column_delimiter = "RecordColumnDelimiter",
        };
        return @field(mappings, field_name);
    }
};

pub const JSONMappingParameters = struct {
    record_row_path: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_row_path = "RecordRowPath",
        };
        return @field(mappings, field_name);
    }
};

pub const DestinationSchema = struct {
    record_format_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format_type = "RecordFormatType",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const InputStartingPositionConfiguration = struct {
    input_starting_position: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_starting_position = "InputStartingPosition",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationSummary = struct {
    application_name: []const u8,
    application_arn: []const u8,
    application_status: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_name = "ApplicationName",
            .application_arn = "ApplicationARN",
            .application_status = "ApplicationStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const InputProcessingConfiguration = struct {
    input_lambda_processor: InputLambdaProcessor,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_lambda_processor = "InputLambdaProcessor",
        };
        return @field(mappings, field_name);
    }
};

pub const InputLambdaProcessor = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const InputParallelism = struct {
    count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .count = "Count",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLoggingOption = struct {
    log_stream_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_stream_arn = "LogStreamARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const Output = struct {
    name: []const u8,
    kinesis_streams_output: ?KinesisStreamsOutput = null,
    kinesis_firehose_output: ?KinesisFirehoseOutput = null,
    lambda_output: ?LambdaOutput = null,
    destination_schema: DestinationSchema,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .kinesis_streams_output = "KinesisStreamsOutput",
            .kinesis_firehose_output = "KinesisFirehoseOutput",
            .lambda_output = "LambdaOutput",
            .destination_schema = "DestinationSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const LambdaOutput = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseOutput = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsOutput = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const Input = struct {
    name_prefix: []const u8,
    input_processing_configuration: ?InputProcessingConfiguration = null,
    kinesis_streams_input: ?KinesisStreamsInput = null,
    kinesis_firehose_input: ?KinesisFirehoseInput = null,
    input_parallelism: ?InputParallelism = null,
    input_schema: SourceSchema,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name_prefix = "NamePrefix",
            .input_processing_configuration = "InputProcessingConfiguration",
            .kinesis_streams_input = "KinesisStreamsInput",
            .kinesis_firehose_input = "KinesisFirehoseInput",
            .input_parallelism = "InputParallelism",
            .input_schema = "InputSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseInput = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsInput = struct {
    resource_arn: []const u8,
    role_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};
