const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-05-23";
pub const sdk_id: []const u8 = "Kinesis Analytics V2";
pub const arn_namespace: ?[]const u8 = "kinesisanalytics";
pub const endpoint_prefix: []const u8 = "kinesisanalytics";
pub const sigv4_name: []const u8 = "kinesisanalytics";
pub const name: []const u8 = "KinesisAnalytics_20180523";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-05-23",
    sdk_id: []const u8 = "Kinesis Analytics V2",
    arn_namespace: ?[]const u8 = "kinesisanalytics",
    endpoint_prefix: []const u8 = "kinesisanalytics",
    sigv4_name: []const u8 = "kinesisanalytics",
    name: []const u8 = "KinesisAnalytics_20180523",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const add_application_cloud_watch_logging_option: struct {
    action_name: []const u8 = "AddApplicationCloudWatchLoggingOption",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: ?i64 = null,
        cloud_watch_logging_option: CloudWatchLoggingOption,
        conditional_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .cloud_watch_logging_option = "CloudWatchLoggingOption",
                .conditional_token = "ConditionalToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_cloud_watch_logging_option) } {
            return .{ .service_metadata = service_metadata, .action = add_application_cloud_watch_logging_option };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        cloud_watch_logging_option_descriptions: ?[]CloudWatchLoggingOptionDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .cloud_watch_logging_option_descriptions = "CloudWatchLoggingOptionDescriptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const add_application_input: struct {
    action_name: []const u8 = "AddApplicationInput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input: Input,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input = "Input",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_input) } {
            return .{ .service_metadata = service_metadata, .action = add_application_input };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        input_descriptions: ?[]InputDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .input_descriptions = "InputDescriptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const add_application_input_processing_configuration: struct {
    action_name: []const u8 = "AddApplicationInputProcessingConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input_id: []const u8,
        input_processing_configuration: InputProcessingConfiguration,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input_id = "InputId",
                .input_processing_configuration = "InputProcessingConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_input_processing_configuration) } {
            return .{ .service_metadata = service_metadata, .action = add_application_input_processing_configuration };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        input_id: ?[]const u8 = null,
        input_processing_configuration_description: ?InputProcessingConfigurationDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .input_id = "InputId",
                .input_processing_configuration_description = "InputProcessingConfigurationDescription",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const add_application_output: struct {
    action_name: []const u8 = "AddApplicationOutput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        output: Output,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .output = "Output",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_output) } {
            return .{ .service_metadata = service_metadata, .action = add_application_output };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        output_descriptions: ?[]OutputDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .output_descriptions = "OutputDescriptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const add_application_reference_data_source: struct {
    action_name: []const u8 = "AddApplicationReferenceDataSource",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        reference_data_source: ReferenceDataSource,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .reference_data_source = "ReferenceDataSource",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_reference_data_source) } {
            return .{ .service_metadata = service_metadata, .action = add_application_reference_data_source };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        reference_data_source_descriptions: ?[]ReferenceDataSourceDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .reference_data_source_descriptions = "ReferenceDataSourceDescriptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const add_application_vpc_configuration: struct {
    action_name: []const u8 = "AddApplicationVpcConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: ?i64 = null,
        vpc_configuration: VpcConfiguration,
        conditional_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .vpc_configuration = "VpcConfiguration",
                .conditional_token = "ConditionalToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(add_application_vpc_configuration) } {
            return .{ .service_metadata = service_metadata, .action = add_application_vpc_configuration };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        vpc_configuration_description: ?VpcConfigurationDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .vpc_configuration_description = "VpcConfigurationDescription",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const create_application: struct {
    action_name: []const u8 = "CreateApplication",
    Request: type = struct {
        application_name: []const u8,
        application_description: ?[]const u8 = null,
        runtime_environment: []const u8,
        service_execution_role: []const u8,
        application_configuration: ?struct {
            sql_application_configuration: ?struct {
                inputs: ?[]Input = null,
                outputs: ?[]Output = null,
                reference_data_sources: ?[]ReferenceDataSource = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .inputs = "Inputs",
                        .outputs = "Outputs",
                        .reference_data_sources = "ReferenceDataSources",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            flink_application_configuration: ?struct {
                checkpoint_configuration: ?struct {
                    configuration_type: []const u8,
                    checkpointing_enabled: ?bool = null,
                    checkpoint_interval: ?i64 = null,
                    min_pause_between_checkpoints: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type = "ConfigurationType",
                            .checkpointing_enabled = "CheckpointingEnabled",
                            .checkpoint_interval = "CheckpointInterval",
                            .min_pause_between_checkpoints = "MinPauseBetweenCheckpoints",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                monitoring_configuration: ?struct {
                    configuration_type: []const u8,
                    metrics_level: ?[]const u8 = null,
                    log_level: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type = "ConfigurationType",
                            .metrics_level = "MetricsLevel",
                            .log_level = "LogLevel",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                parallelism_configuration: ?struct {
                    configuration_type: []const u8,
                    parallelism: ?i64 = null,
                    parallelism_per_kpu: ?i64 = null,
                    auto_scaling_enabled: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type = "ConfigurationType",
                            .parallelism = "Parallelism",
                            .parallelism_per_kpu = "ParallelismPerKPU",
                            .auto_scaling_enabled = "AutoScalingEnabled",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .checkpoint_configuration = "CheckpointConfiguration",
                        .monitoring_configuration = "MonitoringConfiguration",
                        .parallelism_configuration = "ParallelismConfiguration",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            environment_properties: ?struct {
                property_groups: []PropertyGroup,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .property_groups = "PropertyGroups",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_code_configuration: ?struct {
                code_content: ?struct {
                    text_content: ?[]const u8 = null,
                    zip_file_content: ?[]const u8 = null,
                    s3_content_location: ?S3ContentLocation = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .text_content = "TextContent",
                            .zip_file_content = "ZipFileContent",
                            .s3_content_location = "S3ContentLocation",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                code_content_type: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .code_content = "CodeContent",
                        .code_content_type = "CodeContentType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_snapshot_configuration: ?struct {
                snapshots_enabled: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .snapshots_enabled = "SnapshotsEnabled",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            vpc_configurations: ?[]VpcConfiguration = null,
            zeppelin_application_configuration: ?struct {
                monitoring_configuration: ?struct {
                    log_level: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .log_level = "LogLevel",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                catalog_configuration: ?struct {
                    glue_data_catalog_configuration: struct {
                        database_arn: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .database_arn = "DatabaseARN",
                            };
                            return @field(mappings, field_name);
                        }
                    },

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .glue_data_catalog_configuration = "GlueDataCatalogConfiguration",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                deploy_as_application_configuration: ?struct {
                    s3_content_location: struct {
                        bucket_arn: []const u8,
                        base_path: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .bucket_arn = "BucketARN",
                                .base_path = "BasePath",
                            };
                            return @field(mappings, field_name);
                        }
                    },

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .s3_content_location = "S3ContentLocation",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                custom_artifacts_configuration: ?[]CustomArtifactConfiguration = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .monitoring_configuration = "MonitoringConfiguration",
                        .catalog_configuration = "CatalogConfiguration",
                        .deploy_as_application_configuration = "DeployAsApplicationConfiguration",
                        .custom_artifacts_configuration = "CustomArtifactsConfiguration",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .sql_application_configuration = "SqlApplicationConfiguration",
                    .flink_application_configuration = "FlinkApplicationConfiguration",
                    .environment_properties = "EnvironmentProperties",
                    .application_code_configuration = "ApplicationCodeConfiguration",
                    .application_snapshot_configuration = "ApplicationSnapshotConfiguration",
                    .vpc_configurations = "VpcConfigurations",
                    .zeppelin_application_configuration = "ZeppelinApplicationConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        cloud_watch_logging_options: ?[]CloudWatchLoggingOption = null,
        tags: ?[]Tag = null,
        application_mode: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .application_description = "ApplicationDescription",
                .runtime_environment = "RuntimeEnvironment",
                .service_execution_role = "ServiceExecutionRole",
                .application_configuration = "ApplicationConfiguration",
                .cloud_watch_logging_options = "CloudWatchLoggingOptions",
                .tags = "Tags",
                .application_mode = "ApplicationMode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application) } {
            return .{ .service_metadata = service_metadata, .action = create_application };
        }
    },
    Response: type = struct {
        application_detail: ApplicationDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_detail = "ApplicationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        LimitExceeded,
        ResourceInUse,
        TooManyTags,
        UnsupportedOperation,
    },
} = .{};
pub const create_application_presigned_url: struct {
    action_name: []const u8 = "CreateApplicationPresignedUrl",
    Request: type = struct {
        application_name: []const u8,
        url_type: []const u8,
        session_expiration_duration_in_seconds: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .url_type = "UrlType",
                .session_expiration_duration_in_seconds = "SessionExpirationDurationInSeconds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application_presigned_url) } {
            return .{ .service_metadata = service_metadata, .action = create_application_presigned_url };
        }
    },
    Response: type = struct {
        authorized_url: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .authorized_url = "AuthorizedUrl",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const create_application_snapshot: struct {
    action_name: []const u8 = "CreateApplicationSnapshot",
    Request: type = struct {
        application_name: []const u8,
        snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .snapshot_name = "SnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_application_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_application_snapshot };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application: struct {
    action_name: []const u8 = "DeleteApplication",
    Request: type = struct {
        application_name: []const u8,
        create_timestamp: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .create_timestamp = "CreateTimestamp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application) } {
            return .{ .service_metadata = service_metadata, .action = delete_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const delete_application_cloud_watch_logging_option: struct {
    action_name: []const u8 = "DeleteApplicationCloudWatchLoggingOption",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: ?i64 = null,
        cloud_watch_logging_option_id: []const u8,
        conditional_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
                .conditional_token = "ConditionalToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_cloud_watch_logging_option) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_cloud_watch_logging_option };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,
        cloud_watch_logging_option_descriptions: ?[]CloudWatchLoggingOptionDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
                .cloud_watch_logging_option_descriptions = "CloudWatchLoggingOptionDescriptions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const delete_application_input_processing_configuration: struct {
    action_name: []const u8 = "DeleteApplicationInputProcessingConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        input_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .input_id = "InputId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_input_processing_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_input_processing_configuration };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const delete_application_output: struct {
    action_name: []const u8 = "DeleteApplicationOutput",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        output_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .output_id = "OutputId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_output) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_output };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const delete_application_reference_data_source: struct {
    action_name: []const u8 = "DeleteApplicationReferenceDataSource",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,
        reference_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .reference_id = "ReferenceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_reference_data_source) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_reference_data_source };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const delete_application_snapshot: struct {
    action_name: []const u8 = "DeleteApplicationSnapshot",
    Request: type = struct {
        application_name: []const u8,
        snapshot_name: []const u8,
        snapshot_creation_timestamp: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .snapshot_name = "SnapshotName",
                .snapshot_creation_timestamp = "SnapshotCreationTimestamp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_snapshot };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const delete_application_vpc_configuration: struct {
    action_name: []const u8 = "DeleteApplicationVpcConfiguration",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: ?i64 = null,
        vpc_configuration_id: []const u8,
        conditional_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .vpc_configuration_id = "VpcConfigurationId",
                .conditional_token = "ConditionalToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_application_vpc_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_application_vpc_configuration };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_version_id: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_version_id = "ApplicationVersionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const describe_application: struct {
    action_name: []const u8 = "DescribeApplication",
    Request: type = struct {
        application_name: []const u8,
        include_additional_details: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .include_additional_details = "IncludeAdditionalDetails",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_application) } {
            return .{ .service_metadata = service_metadata, .action = describe_application };
        }
    },
    Response: type = struct {
        application_detail: ApplicationDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_detail = "ApplicationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const describe_application_snapshot: struct {
    action_name: []const u8 = "DescribeApplicationSnapshot",
    Request: type = struct {
        application_name: []const u8,
        snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .snapshot_name = "SnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_application_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = describe_application_snapshot };
        }
    },
    Response: type = struct {
        snapshot_details: SnapshotDetails,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .snapshot_details = "SnapshotDetails",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const describe_application_version: struct {
    action_name: []const u8 = "DescribeApplicationVersion",
    Request: type = struct {
        application_name: []const u8,
        application_version_id: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .application_version_id = "ApplicationVersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_application_version) } {
            return .{ .service_metadata = service_metadata, .action = describe_application_version };
        }
    },
    Response: type = struct {
        application_version_detail: ?ApplicationDetail = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_version_detail = "ApplicationVersionDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const discover_input_schema: struct {
    action_name: []const u8 = "DiscoverInputSchema",
    Request: type = struct {
        resource_arn: ?[]const u8 = null,
        service_execution_role: []const u8,
        input_starting_position_configuration: ?InputStartingPositionConfiguration = null,
        s3_configuration: ?struct {
            bucket_arn: []const u8,
            file_key: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .bucket_arn = "BucketARN",
                    .file_key = "FileKey",
                };
                return @field(mappings, field_name);
            }
        } = null,
        input_processing_configuration: ?InputProcessingConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .service_execution_role = "ServiceExecutionRole",
                .input_starting_position_configuration = "InputStartingPositionConfiguration",
                .s3_configuration = "S3Configuration",
                .input_processing_configuration = "InputProcessingConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(discover_input_schema) } {
            return .{ .service_metadata = service_metadata, .action = discover_input_schema };
        }
    },
    Response: type = struct {
        input_schema: ?SourceSchema = null,
        parsed_input_records: ?[][][]const u8 = null,
        processed_input_records: ?[][]const u8 = null,
        raw_input_records: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_schema = "InputSchema",
                .parsed_input_records = "ParsedInputRecords",
                .processed_input_records = "ProcessedInputRecords",
                .raw_input_records = "RawInputRecords",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        InvalidRequest,
        ResourceProvisionedThroughputExceeded,
        ServiceUnavailable,
        UnableToDetectSchema,
        UnsupportedOperation,
    },
} = .{};
pub const list_applications: struct {
    action_name: []const u8 = "ListApplications",
    Request: type = struct {
        limit: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .limit = "Limit",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_applications) } {
            return .{ .service_metadata = service_metadata, .action = list_applications };
        }
    },
    Response: type = struct {
        application_summaries: []struct {
            application_name: []const u8,
            application_arn: []const u8,
            application_status: []const u8,
            application_version_id: i64,
            runtime_environment: []const u8,
            application_mode: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .application_name = "ApplicationName",
                    .application_arn = "ApplicationARN",
                    .application_status = "ApplicationStatus",
                    .application_version_id = "ApplicationVersionId",
                    .runtime_environment = "RuntimeEnvironment",
                    .application_mode = "ApplicationMode",
                };
                return @field(mappings, field_name);
            }
        },
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_summaries = "ApplicationSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidRequest,
    },
} = .{};
pub const list_application_snapshots: struct {
    action_name: []const u8 = "ListApplicationSnapshots",
    Request: type = struct {
        application_name: []const u8,
        limit: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .limit = "Limit",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_application_snapshots) } {
            return .{ .service_metadata = service_metadata, .action = list_application_snapshots };
        }
    },
    Response: type = struct {
        snapshot_summaries: ?[]SnapshotDetails = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .snapshot_summaries = "SnapshotSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        UnsupportedOperation,
    },
} = .{};
pub const list_application_versions: struct {
    action_name: []const u8 = "ListApplicationVersions",
    Request: type = struct {
        application_name: []const u8,
        limit: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .limit = "Limit",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_application_versions) } {
            return .{ .service_metadata = service_metadata, .action = list_application_versions };
        }
    },
    Response: type = struct {
        application_version_summaries: ?[]struct {
            application_version_id: i64,
            application_status: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .application_version_id = "ApplicationVersionId",
                    .application_status = "ApplicationStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_version_summaries = "ApplicationVersionSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidArgument,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceNotFound,
    },
} = .{};
pub const rollback_application: struct {
    action_name: []const u8 = "RollbackApplication",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(rollback_application) } {
            return .{ .service_metadata = service_metadata, .action = rollback_application };
        }
    },
    Response: type = struct {
        application_detail: ApplicationDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_detail = "ApplicationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};
pub const start_application: struct {
    action_name: []const u8 = "StartApplication",
    Request: type = struct {
        application_name: []const u8,
        run_configuration: ?struct {
            flink_run_configuration: ?FlinkRunConfiguration = null,
            sql_run_configurations: ?[]struct {
                input_id: []const u8,
                input_starting_position_configuration: InputStartingPositionConfiguration,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .input_id = "InputId",
                        .input_starting_position_configuration = "InputStartingPositionConfiguration",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_restore_configuration: ?ApplicationRestoreConfiguration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .flink_run_configuration = "FlinkRunConfiguration",
                    .sql_run_configurations = "SqlRunConfigurations",
                    .application_restore_configuration = "ApplicationRestoreConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .run_configuration = "RunConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_application) } {
            return .{ .service_metadata = service_metadata, .action = start_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const stop_application: struct {
    action_name: []const u8 = "StopApplication",
    Request: type = struct {
        application_name: []const u8,
        force: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .force = "Force",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_application) } {
            return .{ .service_metadata = service_metadata, .action = stop_application };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const update_application: struct {
    action_name: []const u8 = "UpdateApplication",
    Request: type = struct {
        application_name: []const u8,
        current_application_version_id: ?i64 = null,
        application_configuration_update: ?struct {
            sql_application_configuration_update: ?struct {
                input_updates: ?[]struct {
                    input_id: []const u8,
                    name_prefix_update: ?[]const u8 = null,
                    input_processing_configuration_update: ?struct {
                        input_lambda_processor_update: struct {
                            resource_arn_update: []const u8,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .resource_arn_update = "ResourceARNUpdate",
                                };
                                return @field(mappings, field_name);
                            }
                        },

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .input_lambda_processor_update = "InputLambdaProcessorUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    kinesis_streams_input_update: ?struct {
                        resource_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    kinesis_firehose_input_update: ?struct {
                        resource_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    input_schema_update: ?struct {
                        record_format_update: ?RecordFormat = null,
                        record_encoding_update: ?[]const u8 = null,
                        record_column_updates: ?[]RecordColumn = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .record_format_update = "RecordFormatUpdate",
                                .record_encoding_update = "RecordEncodingUpdate",
                                .record_column_updates = "RecordColumnUpdates",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    input_parallelism_update: ?struct {
                        count_update: i64,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .count_update = "CountUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .input_id = "InputId",
                            .name_prefix_update = "NamePrefixUpdate",
                            .input_processing_configuration_update = "InputProcessingConfigurationUpdate",
                            .kinesis_streams_input_update = "KinesisStreamsInputUpdate",
                            .kinesis_firehose_input_update = "KinesisFirehoseInputUpdate",
                            .input_schema_update = "InputSchemaUpdate",
                            .input_parallelism_update = "InputParallelismUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                output_updates: ?[]struct {
                    output_id: []const u8,
                    name_update: ?[]const u8 = null,
                    kinesis_streams_output_update: ?struct {
                        resource_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    kinesis_firehose_output_update: ?struct {
                        resource_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    lambda_output_update: ?struct {
                        resource_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .resource_arn_update = "ResourceARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    destination_schema_update: ?DestinationSchema = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .output_id = "OutputId",
                            .name_update = "NameUpdate",
                            .kinesis_streams_output_update = "KinesisStreamsOutputUpdate",
                            .kinesis_firehose_output_update = "KinesisFirehoseOutputUpdate",
                            .lambda_output_update = "LambdaOutputUpdate",
                            .destination_schema_update = "DestinationSchemaUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                reference_data_source_updates: ?[]struct {
                    reference_id: []const u8,
                    table_name_update: ?[]const u8 = null,
                    s3_reference_data_source_update: ?struct {
                        bucket_arn_update: ?[]const u8 = null,
                        file_key_update: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .bucket_arn_update = "BucketARNUpdate",
                                .file_key_update = "FileKeyUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    reference_schema_update: ?SourceSchema = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .reference_id = "ReferenceId",
                            .table_name_update = "TableNameUpdate",
                            .s3_reference_data_source_update = "S3ReferenceDataSourceUpdate",
                            .reference_schema_update = "ReferenceSchemaUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .input_updates = "InputUpdates",
                        .output_updates = "OutputUpdates",
                        .reference_data_source_updates = "ReferenceDataSourceUpdates",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_code_configuration_update: ?struct {
                code_content_type_update: ?[]const u8 = null,
                code_content_update: ?struct {
                    text_content_update: ?[]const u8 = null,
                    zip_file_content_update: ?[]const u8 = null,
                    s3_content_location_update: ?struct {
                        bucket_arn_update: ?[]const u8 = null,
                        file_key_update: ?[]const u8 = null,
                        object_version_update: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .bucket_arn_update = "BucketARNUpdate",
                                .file_key_update = "FileKeyUpdate",
                                .object_version_update = "ObjectVersionUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .text_content_update = "TextContentUpdate",
                            .zip_file_content_update = "ZipFileContentUpdate",
                            .s3_content_location_update = "S3ContentLocationUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .code_content_type_update = "CodeContentTypeUpdate",
                        .code_content_update = "CodeContentUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            flink_application_configuration_update: ?struct {
                checkpoint_configuration_update: ?struct {
                    configuration_type_update: ?[]const u8 = null,
                    checkpointing_enabled_update: ?bool = null,
                    checkpoint_interval_update: ?i64 = null,
                    min_pause_between_checkpoints_update: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type_update = "ConfigurationTypeUpdate",
                            .checkpointing_enabled_update = "CheckpointingEnabledUpdate",
                            .checkpoint_interval_update = "CheckpointIntervalUpdate",
                            .min_pause_between_checkpoints_update = "MinPauseBetweenCheckpointsUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                monitoring_configuration_update: ?struct {
                    configuration_type_update: ?[]const u8 = null,
                    metrics_level_update: ?[]const u8 = null,
                    log_level_update: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type_update = "ConfigurationTypeUpdate",
                            .metrics_level_update = "MetricsLevelUpdate",
                            .log_level_update = "LogLevelUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                parallelism_configuration_update: ?struct {
                    configuration_type_update: ?[]const u8 = null,
                    parallelism_update: ?i64 = null,
                    parallelism_per_kpu_update: ?i64 = null,
                    auto_scaling_enabled_update: ?bool = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .configuration_type_update = "ConfigurationTypeUpdate",
                            .parallelism_update = "ParallelismUpdate",
                            .parallelism_per_kpu_update = "ParallelismPerKPUUpdate",
                            .auto_scaling_enabled_update = "AutoScalingEnabledUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .checkpoint_configuration_update = "CheckpointConfigurationUpdate",
                        .monitoring_configuration_update = "MonitoringConfigurationUpdate",
                        .parallelism_configuration_update = "ParallelismConfigurationUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            environment_property_updates: ?struct {
                property_groups: []PropertyGroup,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .property_groups = "PropertyGroups",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            application_snapshot_configuration_update: ?struct {
                snapshots_enabled_update: bool,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .snapshots_enabled_update = "SnapshotsEnabledUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            vpc_configuration_updates: ?[]struct {
                vpc_configuration_id: []const u8,
                subnet_id_updates: ?[][]const u8 = null,
                security_group_id_updates: ?[][]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .vpc_configuration_id = "VpcConfigurationId",
                        .subnet_id_updates = "SubnetIdUpdates",
                        .security_group_id_updates = "SecurityGroupIdUpdates",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            zeppelin_application_configuration_update: ?struct {
                monitoring_configuration_update: ?struct {
                    log_level_update: []const u8,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .log_level_update = "LogLevelUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                catalog_configuration_update: ?struct {
                    glue_data_catalog_configuration_update: struct {
                        database_arn_update: []const u8,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .database_arn_update = "DatabaseARNUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    },

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .glue_data_catalog_configuration_update = "GlueDataCatalogConfigurationUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                deploy_as_application_configuration_update: ?struct {
                    s3_content_location_update: ?struct {
                        bucket_arn_update: ?[]const u8 = null,
                        base_path_update: ?[]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .bucket_arn_update = "BucketARNUpdate",
                                .base_path_update = "BasePathUpdate",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .s3_content_location_update = "S3ContentLocationUpdate",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                custom_artifacts_configuration_update: ?[]CustomArtifactConfiguration = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .monitoring_configuration_update = "MonitoringConfigurationUpdate",
                        .catalog_configuration_update = "CatalogConfigurationUpdate",
                        .deploy_as_application_configuration_update = "DeployAsApplicationConfigurationUpdate",
                        .custom_artifacts_configuration_update = "CustomArtifactsConfigurationUpdate",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .sql_application_configuration_update = "SqlApplicationConfigurationUpdate",
                    .application_code_configuration_update = "ApplicationCodeConfigurationUpdate",
                    .flink_application_configuration_update = "FlinkApplicationConfigurationUpdate",
                    .environment_property_updates = "EnvironmentPropertyUpdates",
                    .application_snapshot_configuration_update = "ApplicationSnapshotConfigurationUpdate",
                    .vpc_configuration_updates = "VpcConfigurationUpdates",
                    .zeppelin_application_configuration_update = "ZeppelinApplicationConfigurationUpdate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        service_execution_role_update: ?[]const u8 = null,
        run_configuration_update: ?struct {
            flink_run_configuration: ?FlinkRunConfiguration = null,
            application_restore_configuration: ?ApplicationRestoreConfiguration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .flink_run_configuration = "FlinkRunConfiguration",
                    .application_restore_configuration = "ApplicationRestoreConfiguration",
                };
                return @field(mappings, field_name);
            }
        } = null,
        cloud_watch_logging_option_updates: ?[]struct {
            cloud_watch_logging_option_id: []const u8,
            log_stream_arn_update: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
                    .log_stream_arn_update = "LogStreamARNUpdate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        conditional_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .current_application_version_id = "CurrentApplicationVersionId",
                .application_configuration_update = "ApplicationConfigurationUpdate",
                .service_execution_role_update = "ServiceExecutionRoleUpdate",
                .run_configuration_update = "RunConfigurationUpdate",
                .cloud_watch_logging_option_updates = "CloudWatchLoggingOptionUpdates",
                .conditional_token = "ConditionalToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application) } {
            return .{ .service_metadata = service_metadata, .action = update_application };
        }
    },
    Response: type = struct {
        application_detail: ApplicationDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_detail = "ApplicationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        CodeValidation,
        ConcurrentModification,
        InvalidApplicationConfiguration,
        InvalidArgument,
        InvalidRequest,
        LimitExceeded,
        ResourceInUse,
        ResourceNotFound,
    },
} = .{};
pub const update_application_maintenance_configuration: struct {
    action_name: []const u8 = "UpdateApplicationMaintenanceConfiguration",
    Request: type = struct {
        application_name: []const u8,
        application_maintenance_configuration_update: struct {
            application_maintenance_window_start_time_update: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .application_maintenance_window_start_time_update = "ApplicationMaintenanceWindowStartTimeUpdate",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_name = "ApplicationName",
                .application_maintenance_configuration_update = "ApplicationMaintenanceConfigurationUpdate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application_maintenance_configuration) } {
            return .{ .service_metadata = service_metadata, .action = update_application_maintenance_configuration };
        }
    },
    Response: type = struct {
        application_arn: ?[]const u8 = null,
        application_maintenance_configuration_description: ?ApplicationMaintenanceConfigurationDescription = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .application_arn = "ApplicationARN",
                .application_maintenance_configuration_description = "ApplicationMaintenanceConfigurationDescription",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InvalidArgument,
        ResourceInUse,
        ResourceNotFound,
        UnsupportedOperation,
    },
} = .{};

pub const ApplicationMaintenanceConfigurationDescription = struct {
    application_maintenance_window_start_time: []const u8,
    application_maintenance_window_end_time: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_maintenance_window_start_time = "ApplicationMaintenanceWindowStartTime",
            .application_maintenance_window_end_time = "ApplicationMaintenanceWindowEndTime",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationDetail = struct {
    application_arn: []const u8,
    application_description: ?[]const u8 = null,
    application_name: []const u8,
    runtime_environment: []const u8,
    service_execution_role: ?[]const u8 = null,
    application_status: []const u8,
    application_version_id: i64,
    create_timestamp: ?i64 = null,
    last_update_timestamp: ?i64 = null,
    application_configuration_description: ?ApplicationConfigurationDescription = null,
    cloud_watch_logging_option_descriptions: ?[]CloudWatchLoggingOptionDescription = null,
    application_maintenance_configuration_description: ?ApplicationMaintenanceConfigurationDescription = null,
    application_version_updated_from: ?i64 = null,
    application_version_rolled_back_from: ?i64 = null,
    conditional_token: ?[]const u8 = null,
    application_version_rolled_back_to: ?i64 = null,
    application_mode: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_arn = "ApplicationARN",
            .application_description = "ApplicationDescription",
            .application_name = "ApplicationName",
            .runtime_environment = "RuntimeEnvironment",
            .service_execution_role = "ServiceExecutionRole",
            .application_status = "ApplicationStatus",
            .application_version_id = "ApplicationVersionId",
            .create_timestamp = "CreateTimestamp",
            .last_update_timestamp = "LastUpdateTimestamp",
            .application_configuration_description = "ApplicationConfigurationDescription",
            .cloud_watch_logging_option_descriptions = "CloudWatchLoggingOptionDescriptions",
            .application_maintenance_configuration_description = "ApplicationMaintenanceConfigurationDescription",
            .application_version_updated_from = "ApplicationVersionUpdatedFrom",
            .application_version_rolled_back_from = "ApplicationVersionRolledBackFrom",
            .conditional_token = "ConditionalToken",
            .application_version_rolled_back_to = "ApplicationVersionRolledBackTo",
            .application_mode = "ApplicationMode",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLoggingOptionDescription = struct {
    cloud_watch_logging_option_id: ?[]const u8 = null,
    log_stream_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .cloud_watch_logging_option_id = "CloudWatchLoggingOptionId",
            .log_stream_arn = "LogStreamARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationConfigurationDescription = struct {
    sql_application_configuration_description: ?SqlApplicationConfigurationDescription = null,
    application_code_configuration_description: ?ApplicationCodeConfigurationDescription = null,
    run_configuration_description: ?RunConfigurationDescription = null,
    flink_application_configuration_description: ?FlinkApplicationConfigurationDescription = null,
    environment_property_descriptions: ?EnvironmentPropertyDescriptions = null,
    application_snapshot_configuration_description: ?ApplicationSnapshotConfigurationDescription = null,
    vpc_configuration_descriptions: ?[]VpcConfigurationDescription = null,
    zeppelin_application_configuration_description: ?ZeppelinApplicationConfigurationDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .sql_application_configuration_description = "SqlApplicationConfigurationDescription",
            .application_code_configuration_description = "ApplicationCodeConfigurationDescription",
            .run_configuration_description = "RunConfigurationDescription",
            .flink_application_configuration_description = "FlinkApplicationConfigurationDescription",
            .environment_property_descriptions = "EnvironmentPropertyDescriptions",
            .application_snapshot_configuration_description = "ApplicationSnapshotConfigurationDescription",
            .vpc_configuration_descriptions = "VpcConfigurationDescriptions",
            .zeppelin_application_configuration_description = "ZeppelinApplicationConfigurationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const ZeppelinApplicationConfigurationDescription = struct {
    monitoring_configuration_description: ZeppelinMonitoringConfigurationDescription,
    catalog_configuration_description: ?CatalogConfigurationDescription = null,
    deploy_as_application_configuration_description: ?DeployAsApplicationConfigurationDescription = null,
    custom_artifacts_configuration_description: ?[]CustomArtifactConfigurationDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .monitoring_configuration_description = "MonitoringConfigurationDescription",
            .catalog_configuration_description = "CatalogConfigurationDescription",
            .deploy_as_application_configuration_description = "DeployAsApplicationConfigurationDescription",
            .custom_artifacts_configuration_description = "CustomArtifactsConfigurationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const CustomArtifactConfigurationDescription = struct {
    artifact_type: ?[]const u8 = null,
    s3_content_location_description: ?S3ContentLocation = null,
    maven_reference_description: ?MavenReference = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .artifact_type = "ArtifactType",
            .s3_content_location_description = "S3ContentLocationDescription",
            .maven_reference_description = "MavenReferenceDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const MavenReference = struct {
    group_id: []const u8,
    artifact_id: []const u8,
    version: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .group_id = "GroupId",
            .artifact_id = "ArtifactId",
            .version = "Version",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ContentLocation = struct {
    bucket_arn: []const u8,
    file_key: []const u8,
    object_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket_arn = "BucketARN",
            .file_key = "FileKey",
            .object_version = "ObjectVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const DeployAsApplicationConfigurationDescription = struct {
    s3_content_location_description: S3ContentBaseLocationDescription,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_content_location_description = "S3ContentLocationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ContentBaseLocationDescription = struct {
    bucket_arn: []const u8,
    base_path: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket_arn = "BucketARN",
            .base_path = "BasePath",
        };
        return @field(mappings, field_name);
    }
};

pub const CatalogConfigurationDescription = struct {
    glue_data_catalog_configuration_description: GlueDataCatalogConfigurationDescription,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .glue_data_catalog_configuration_description = "GlueDataCatalogConfigurationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const GlueDataCatalogConfigurationDescription = struct {
    database_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .database_arn = "DatabaseARN",
        };
        return @field(mappings, field_name);
    }
};

pub const ZeppelinMonitoringConfigurationDescription = struct {
    log_level: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_level = "LogLevel",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfigurationDescription = struct {
    vpc_configuration_id: []const u8,
    vpc_id: []const u8,
    subnet_ids: [][]const u8,
    security_group_ids: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .vpc_configuration_id = "VpcConfigurationId",
            .vpc_id = "VpcId",
            .subnet_ids = "SubnetIds",
            .security_group_ids = "SecurityGroupIds",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationSnapshotConfigurationDescription = struct {
    snapshots_enabled: bool,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .snapshots_enabled = "SnapshotsEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const EnvironmentPropertyDescriptions = struct {
    property_group_descriptions: ?[]PropertyGroup = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .property_group_descriptions = "PropertyGroupDescriptions",
        };
        return @field(mappings, field_name);
    }
};

pub const PropertyGroup = struct {
    property_group_id: []const u8,
    property_map: []struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    },

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .property_group_id = "PropertyGroupId",
            .property_map = "PropertyMap",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "property_map", field_name))
            return try serializeMap(self.property_map, self.fieldNameFor("property_map"), options, out_stream);
        return false;
    }
};

pub const FlinkApplicationConfigurationDescription = struct {
    checkpoint_configuration_description: ?CheckpointConfigurationDescription = null,
    monitoring_configuration_description: ?MonitoringConfigurationDescription = null,
    parallelism_configuration_description: ?ParallelismConfigurationDescription = null,
    job_plan_description: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .checkpoint_configuration_description = "CheckpointConfigurationDescription",
            .monitoring_configuration_description = "MonitoringConfigurationDescription",
            .parallelism_configuration_description = "ParallelismConfigurationDescription",
            .job_plan_description = "JobPlanDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const ParallelismConfigurationDescription = struct {
    configuration_type: ?[]const u8 = null,
    parallelism: ?i64 = null,
    parallelism_per_kpu: ?i64 = null,
    current_parallelism: ?i64 = null,
    auto_scaling_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .configuration_type = "ConfigurationType",
            .parallelism = "Parallelism",
            .parallelism_per_kpu = "ParallelismPerKPU",
            .current_parallelism = "CurrentParallelism",
            .auto_scaling_enabled = "AutoScalingEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const MonitoringConfigurationDescription = struct {
    configuration_type: ?[]const u8 = null,
    metrics_level: ?[]const u8 = null,
    log_level: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .configuration_type = "ConfigurationType",
            .metrics_level = "MetricsLevel",
            .log_level = "LogLevel",
        };
        return @field(mappings, field_name);
    }
};

pub const CheckpointConfigurationDescription = struct {
    configuration_type: ?[]const u8 = null,
    checkpointing_enabled: ?bool = null,
    checkpoint_interval: ?i64 = null,
    min_pause_between_checkpoints: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .configuration_type = "ConfigurationType",
            .checkpointing_enabled = "CheckpointingEnabled",
            .checkpoint_interval = "CheckpointInterval",
            .min_pause_between_checkpoints = "MinPauseBetweenCheckpoints",
        };
        return @field(mappings, field_name);
    }
};

pub const RunConfigurationDescription = struct {
    application_restore_configuration_description: ?ApplicationRestoreConfiguration = null,
    flink_run_configuration_description: ?FlinkRunConfiguration = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_restore_configuration_description = "ApplicationRestoreConfigurationDescription",
            .flink_run_configuration_description = "FlinkRunConfigurationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const FlinkRunConfiguration = struct {
    allow_non_restored_state: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .allow_non_restored_state = "AllowNonRestoredState",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationRestoreConfiguration = struct {
    application_restore_type: []const u8,
    snapshot_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .application_restore_type = "ApplicationRestoreType",
            .snapshot_name = "SnapshotName",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationCodeConfigurationDescription = struct {
    code_content_type: []const u8,
    code_content_description: ?CodeContentDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code_content_type = "CodeContentType",
            .code_content_description = "CodeContentDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const CodeContentDescription = struct {
    text_content: ?[]const u8 = null,
    code_md5: ?[]const u8 = null,
    code_size: ?i64 = null,
    s3_application_code_location_description: ?S3ApplicationCodeLocationDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .text_content = "TextContent",
            .code_md5 = "CodeMD5",
            .code_size = "CodeSize",
            .s3_application_code_location_description = "S3ApplicationCodeLocationDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ApplicationCodeLocationDescription = struct {
    bucket_arn: []const u8,
    file_key: []const u8,
    object_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket_arn = "BucketARN",
            .file_key = "FileKey",
            .object_version = "ObjectVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const SqlApplicationConfigurationDescription = struct {
    input_descriptions: ?[]InputDescription = null,
    output_descriptions: ?[]OutputDescription = null,
    reference_data_source_descriptions: ?[]ReferenceDataSourceDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_descriptions = "InputDescriptions",
            .output_descriptions = "OutputDescriptions",
            .reference_data_source_descriptions = "ReferenceDataSourceDescriptions",
        };
        return @field(mappings, field_name);
    }
};

pub const ReferenceDataSourceDescription = struct {
    reference_id: []const u8,
    table_name: []const u8,
    s3_reference_data_source_description: S3ReferenceDataSourceDescription,
    reference_schema: ?SourceSchema = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .reference_id = "ReferenceId",
            .table_name = "TableName",
            .s3_reference_data_source_description = "S3ReferenceDataSourceDescription",
            .reference_schema = "ReferenceSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const SourceSchema = struct {
    record_format: RecordFormat,
    record_encoding: ?[]const u8 = null,
    record_columns: []RecordColumn,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format = "RecordFormat",
            .record_encoding = "RecordEncoding",
            .record_columns = "RecordColumns",
        };
        return @field(mappings, field_name);
    }
};

pub const RecordColumn = struct {
    name: []const u8,
    mapping: ?[]const u8 = null,
    sql_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .mapping = "Mapping",
            .sql_type = "SqlType",
        };
        return @field(mappings, field_name);
    }
};

pub const RecordFormat = struct {
    record_format_type: []const u8,
    mapping_parameters: ?MappingParameters = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format_type = "RecordFormatType",
            .mapping_parameters = "MappingParameters",
        };
        return @field(mappings, field_name);
    }
};

pub const MappingParameters = struct {
    json_mapping_parameters: ?JSONMappingParameters = null,
    csv_mapping_parameters: ?CSVMappingParameters = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .json_mapping_parameters = "JSONMappingParameters",
            .csv_mapping_parameters = "CSVMappingParameters",
        };
        return @field(mappings, field_name);
    }
};

pub const CSVMappingParameters = struct {
    record_row_delimiter: []const u8,
    record_column_delimiter: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_row_delimiter = "RecordRowDelimiter",
            .record_column_delimiter = "RecordColumnDelimiter",
        };
        return @field(mappings, field_name);
    }
};

pub const JSONMappingParameters = struct {
    record_row_path: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_row_path = "RecordRowPath",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ReferenceDataSourceDescription = struct {
    bucket_arn: []const u8,
    file_key: []const u8,
    reference_role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket_arn = "BucketARN",
            .file_key = "FileKey",
            .reference_role_arn = "ReferenceRoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const OutputDescription = struct {
    output_id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    kinesis_streams_output_description: ?KinesisStreamsOutputDescription = null,
    kinesis_firehose_output_description: ?KinesisFirehoseOutputDescription = null,
    lambda_output_description: ?LambdaOutputDescription = null,
    destination_schema: ?DestinationSchema = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .output_id = "OutputId",
            .name = "Name",
            .kinesis_streams_output_description = "KinesisStreamsOutputDescription",
            .kinesis_firehose_output_description = "KinesisFirehoseOutputDescription",
            .lambda_output_description = "LambdaOutputDescription",
            .destination_schema = "DestinationSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const DestinationSchema = struct {
    record_format_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .record_format_type = "RecordFormatType",
        };
        return @field(mappings, field_name);
    }
};

pub const LambdaOutputDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseOutputDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsOutputDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const InputDescription = struct {
    input_id: ?[]const u8 = null,
    name_prefix: ?[]const u8 = null,
    in_app_stream_names: ?[][]const u8 = null,
    input_processing_configuration_description: ?InputProcessingConfigurationDescription = null,
    kinesis_streams_input_description: ?KinesisStreamsInputDescription = null,
    kinesis_firehose_input_description: ?KinesisFirehoseInputDescription = null,
    input_schema: ?SourceSchema = null,
    input_parallelism: ?InputParallelism = null,
    input_starting_position_configuration: ?InputStartingPositionConfiguration = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_id = "InputId",
            .name_prefix = "NamePrefix",
            .in_app_stream_names = "InAppStreamNames",
            .input_processing_configuration_description = "InputProcessingConfigurationDescription",
            .kinesis_streams_input_description = "KinesisStreamsInputDescription",
            .kinesis_firehose_input_description = "KinesisFirehoseInputDescription",
            .input_schema = "InputSchema",
            .input_parallelism = "InputParallelism",
            .input_starting_position_configuration = "InputStartingPositionConfiguration",
        };
        return @field(mappings, field_name);
    }
};

pub const InputStartingPositionConfiguration = struct {
    input_starting_position: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_starting_position = "InputStartingPosition",
        };
        return @field(mappings, field_name);
    }
};

pub const InputParallelism = struct {
    count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .count = "Count",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseInputDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsInputDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const InputProcessingConfigurationDescription = struct {
    input_lambda_processor_description: ?InputLambdaProcessorDescription = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_lambda_processor_description = "InputLambdaProcessorDescription",
        };
        return @field(mappings, field_name);
    }
};

pub const InputLambdaProcessorDescription = struct {
    resource_arn: []const u8,
    role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
            .role_arn = "RoleARN",
        };
        return @field(mappings, field_name);
    }
};

pub const CustomArtifactConfiguration = struct {
    artifact_type: []const u8,
    s3_content_location: ?S3ContentLocation = null,
    maven_reference: ?MavenReference = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .artifact_type = "ArtifactType",
            .s3_content_location = "S3ContentLocation",
            .maven_reference = "MavenReference",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const SnapshotDetails = struct {
    snapshot_name: []const u8,
    snapshot_status: []const u8,
    application_version_id: i64,
    snapshot_creation_timestamp: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .snapshot_name = "SnapshotName",
            .snapshot_status = "SnapshotStatus",
            .application_version_id = "ApplicationVersionId",
            .snapshot_creation_timestamp = "SnapshotCreationTimestamp",
        };
        return @field(mappings, field_name);
    }
};

pub const InputProcessingConfiguration = struct {
    input_lambda_processor: InputLambdaProcessor,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .input_lambda_processor = "InputLambdaProcessor",
        };
        return @field(mappings, field_name);
    }
};

pub const InputLambdaProcessor = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLoggingOption = struct {
    log_stream_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_stream_arn = "LogStreamARN",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfiguration = struct {
    subnet_ids: [][]const u8,
    security_group_ids: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .subnet_ids = "SubnetIds",
            .security_group_ids = "SecurityGroupIds",
        };
        return @field(mappings, field_name);
    }
};

pub const ReferenceDataSource = struct {
    table_name: []const u8,
    s3_reference_data_source: ?S3ReferenceDataSource = null,
    reference_schema: SourceSchema,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .table_name = "TableName",
            .s3_reference_data_source = "S3ReferenceDataSource",
            .reference_schema = "ReferenceSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const S3ReferenceDataSource = struct {
    bucket_arn: ?[]const u8 = null,
    file_key: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .bucket_arn = "BucketARN",
            .file_key = "FileKey",
        };
        return @field(mappings, field_name);
    }
};

pub const Output = struct {
    name: []const u8,
    kinesis_streams_output: ?KinesisStreamsOutput = null,
    kinesis_firehose_output: ?KinesisFirehoseOutput = null,
    lambda_output: ?LambdaOutput = null,
    destination_schema: DestinationSchema,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .kinesis_streams_output = "KinesisStreamsOutput",
            .kinesis_firehose_output = "KinesisFirehoseOutput",
            .lambda_output = "LambdaOutput",
            .destination_schema = "DestinationSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const LambdaOutput = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseOutput = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsOutput = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};

pub const Input = struct {
    name_prefix: []const u8,
    input_processing_configuration: ?InputProcessingConfiguration = null,
    kinesis_streams_input: ?KinesisStreamsInput = null,
    kinesis_firehose_input: ?KinesisFirehoseInput = null,
    input_parallelism: ?InputParallelism = null,
    input_schema: SourceSchema,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name_prefix = "NamePrefix",
            .input_processing_configuration = "InputProcessingConfiguration",
            .kinesis_streams_input = "KinesisStreamsInput",
            .kinesis_firehose_input = "KinesisFirehoseInput",
            .input_parallelism = "InputParallelism",
            .input_schema = "InputSchema",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisFirehoseInput = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};

pub const KinesisStreamsInput = struct {
    resource_arn: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_arn = "ResourceARN",
        };
        return @field(mappings, field_name);
    }
};
