const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-09-30";
pub const sdk_id: []const u8 = "Kinesis Video Media";
pub const arn_namespace: ?[]const u8 = "kinesisvideo";
pub const endpoint_prefix: []const u8 = "kinesisvideo";
pub const sigv4_name: []const u8 = "kinesisvideo";
pub const name: []const u8 = "AWSAcuityInletService";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-09-30",
    sdk_id: []const u8 = "Kinesis Video Media",
    arn_namespace: ?[]const u8 = "kinesisvideo",
    endpoint_prefix: []const u8 = "kinesisvideo",
    sigv4_name: []const u8 = "kinesisvideo",
    name: []const u8 = "AWSAcuityInletService",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const get_media: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/getMedia",
        .success_code = 200,
    };

    action_name: []const u8 = "GetMedia",
    Request: type = struct {
        stream_name: ?[]const u8 = null,
        stream_arn: ?[]const u8 = null,
        start_selector: struct {
            start_selector_type: []const u8,
            after_fragment_number: ?[]const u8 = null,
            start_timestamp: ?i64 = null,
            continuation_token: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .start_selector_type = "StartSelectorType",
                    .after_fragment_number = "AfterFragmentNumber",
                    .start_timestamp = "StartTimestamp",
                    .continuation_token = "ContinuationToken",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stream_name = "StreamName",
                .stream_arn = "StreamARN",
                .start_selector = "StartSelector",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_media) } {
            return .{ .service_metadata = service_metadata, .action = get_media };
        }
    },
    Response: type = struct {
        content_type: ?[]const u8 = null,
        payload: ?[]const u8 = null,
        pub const http_header = .{
            .content_type = "Content-Type",
        };

        pub const http_payload: []const u8 = "payload";
        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .content_type = "ContentType",
                .payload = "Payload",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ClientLimitExceeded,
        ConnectionLimitExceeded,
        InvalidArgument,
        InvalidEndpoint,
        NotAuthorized,
        ResourceNotFound,
    },
} = .{};
