const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-05-10";
pub const sdk_id: []const u8 = "Kinesis Video WebRTC Storage";
pub const arn_namespace: ?[]const u8 = "kinesisvideo";
pub const endpoint_prefix: []const u8 = "kinesisvideo";
pub const sigv4_name: []const u8 = "kinesisvideo";
pub const name: []const u8 = "AWSAcuityRoutingServiceLambda";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-05-10",
    sdk_id: []const u8 = "Kinesis Video WebRTC Storage",
    arn_namespace: ?[]const u8 = "kinesisvideo",
    endpoint_prefix: []const u8 = "kinesisvideo",
    sigv4_name: []const u8 = "kinesisvideo",
    name: []const u8 = "AWSAcuityRoutingServiceLambda",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const join_storage_session: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/joinStorageSession",
        .success_code = 200,
    };

    action_name: []const u8 = "JoinStorageSession",
    Request: type = struct {
        channel_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .channel_arn = "channelArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(join_storage_session) } {
            return .{ .service_metadata = service_metadata, .action = join_storage_session };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        AccessDenied,
        ClientLimitExceeded,
        InvalidArgument,
        ResourceNotFound,
    },
} = .{};
