const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-01-17";
pub const sdk_id: []const u8 = "MTurk";
pub const arn_namespace: ?[]const u8 = "mturk-requester";
pub const endpoint_prefix: []const u8 = "mturk-requester";
pub const sigv4_name: []const u8 = "mturk-requester";
pub const name: []const u8 = "MTurkRequesterServiceV20170117";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-01-17",
    sdk_id: []const u8 = "MTurk",
    arn_namespace: ?[]const u8 = "mturk-requester",
    endpoint_prefix: []const u8 = "mturk-requester",
    sigv4_name: []const u8 = "mturk-requester",
    name: []const u8 = "MTurkRequesterServiceV20170117",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const accept_qualification_request: struct {
    action_name: []const u8 = "AcceptQualificationRequest",
    Request: type = struct {
        qualification_request_id: []const u8,
        integer_value: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_request_id = "QualificationRequestId",
                .integer_value = "IntegerValue",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(accept_qualification_request) } {
            return .{ .service_metadata = service_metadata, .action = accept_qualification_request };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const approve_assignment: struct {
    action_name: []const u8 = "ApproveAssignment",
    Request: type = struct {
        assignment_id: []const u8,
        requester_feedback: ?[]const u8 = null,
        override_rejection: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment_id = "AssignmentId",
                .requester_feedback = "RequesterFeedback",
                .override_rejection = "OverrideRejection",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(approve_assignment) } {
            return .{ .service_metadata = service_metadata, .action = approve_assignment };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const associate_qualification_with_worker: struct {
    action_name: []const u8 = "AssociateQualificationWithWorker",
    Request: type = struct {
        qualification_type_id: []const u8,
        worker_id: []const u8,
        integer_value: ?i64 = null,
        send_notification: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .worker_id = "WorkerId",
                .integer_value = "IntegerValue",
                .send_notification = "SendNotification",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_qualification_with_worker) } {
            return .{ .service_metadata = service_metadata, .action = associate_qualification_with_worker };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_additional_assignments_for_hit: struct {
    action_name: []const u8 = "CreateAdditionalAssignmentsForHIT",
    Request: type = struct {
        hit_id: []const u8,
        number_of_additional_assignments: i64,
        unique_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .number_of_additional_assignments = "NumberOfAdditionalAssignments",
                .unique_request_token = "UniqueRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_additional_assignments_for_hit) } {
            return .{ .service_metadata = service_metadata, .action = create_additional_assignments_for_hit };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_hit: struct {
    action_name: []const u8 = "CreateHIT",
    Request: type = struct {
        max_assignments: ?i64 = null,
        auto_approval_delay_in_seconds: ?i64 = null,
        lifetime_in_seconds: i64,
        assignment_duration_in_seconds: i64,
        reward: []const u8,
        title: []const u8,
        keywords: ?[]const u8 = null,
        description: []const u8,
        question: ?[]const u8 = null,
        requester_annotation: ?[]const u8 = null,
        qualification_requirements: ?[]QualificationRequirement = null,
        unique_request_token: ?[]const u8 = null,
        assignment_review_policy: ?ReviewPolicy = null,
        hit_review_policy: ?ReviewPolicy = null,
        hit_layout_id: ?[]const u8 = null,
        hit_layout_parameters: ?[]HITLayoutParameter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_assignments = "MaxAssignments",
                .auto_approval_delay_in_seconds = "AutoApprovalDelayInSeconds",
                .lifetime_in_seconds = "LifetimeInSeconds",
                .assignment_duration_in_seconds = "AssignmentDurationInSeconds",
                .reward = "Reward",
                .title = "Title",
                .keywords = "Keywords",
                .description = "Description",
                .question = "Question",
                .requester_annotation = "RequesterAnnotation",
                .qualification_requirements = "QualificationRequirements",
                .unique_request_token = "UniqueRequestToken",
                .assignment_review_policy = "AssignmentReviewPolicy",
                .hit_review_policy = "HITReviewPolicy",
                .hit_layout_id = "HITLayoutId",
                .hit_layout_parameters = "HITLayoutParameters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_hit) } {
            return .{ .service_metadata = service_metadata, .action = create_hit };
        }
    },
    Response: type = struct {
        hit: ?HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit = "HIT",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_hit_type: struct {
    action_name: []const u8 = "CreateHITType",
    Request: type = struct {
        auto_approval_delay_in_seconds: ?i64 = null,
        assignment_duration_in_seconds: i64,
        reward: []const u8,
        title: []const u8,
        keywords: ?[]const u8 = null,
        description: []const u8,
        qualification_requirements: ?[]QualificationRequirement = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_approval_delay_in_seconds = "AutoApprovalDelayInSeconds",
                .assignment_duration_in_seconds = "AssignmentDurationInSeconds",
                .reward = "Reward",
                .title = "Title",
                .keywords = "Keywords",
                .description = "Description",
                .qualification_requirements = "QualificationRequirements",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_hit_type) } {
            return .{ .service_metadata = service_metadata, .action = create_hit_type };
        }
    },
    Response: type = struct {
        hit_type_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_type_id = "HITTypeId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_hit_with_hit_type: struct {
    action_name: []const u8 = "CreateHITWithHITType",
    Request: type = struct {
        hit_type_id: []const u8,
        max_assignments: ?i64 = null,
        lifetime_in_seconds: i64,
        question: ?[]const u8 = null,
        requester_annotation: ?[]const u8 = null,
        unique_request_token: ?[]const u8 = null,
        assignment_review_policy: ?ReviewPolicy = null,
        hit_review_policy: ?ReviewPolicy = null,
        hit_layout_id: ?[]const u8 = null,
        hit_layout_parameters: ?[]HITLayoutParameter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_type_id = "HITTypeId",
                .max_assignments = "MaxAssignments",
                .lifetime_in_seconds = "LifetimeInSeconds",
                .question = "Question",
                .requester_annotation = "RequesterAnnotation",
                .unique_request_token = "UniqueRequestToken",
                .assignment_review_policy = "AssignmentReviewPolicy",
                .hit_review_policy = "HITReviewPolicy",
                .hit_layout_id = "HITLayoutId",
                .hit_layout_parameters = "HITLayoutParameters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_hit_with_hit_type) } {
            return .{ .service_metadata = service_metadata, .action = create_hit_with_hit_type };
        }
    },
    Response: type = struct {
        hit: ?HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit = "HIT",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_qualification_type: struct {
    action_name: []const u8 = "CreateQualificationType",
    Request: type = struct {
        name: []const u8,
        keywords: ?[]const u8 = null,
        description: []const u8,
        qualification_type_status: []const u8,
        retry_delay_in_seconds: ?i64 = null,
        @"test": ?[]const u8 = null,
        answer_key: ?[]const u8 = null,
        test_duration_in_seconds: ?i64 = null,
        auto_granted: ?bool = null,
        auto_granted_value: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .keywords = "Keywords",
                .description = "Description",
                .qualification_type_status = "QualificationTypeStatus",
                .retry_delay_in_seconds = "RetryDelayInSeconds",
                .@"test" = "Test",
                .answer_key = "AnswerKey",
                .test_duration_in_seconds = "TestDurationInSeconds",
                .auto_granted = "AutoGranted",
                .auto_granted_value = "AutoGrantedValue",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = create_qualification_type };
        }
    },
    Response: type = struct {
        qualification_type: ?QualificationType = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type = "QualificationType",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const create_worker_block: struct {
    action_name: []const u8 = "CreateWorkerBlock",
    Request: type = struct {
        worker_id: []const u8,
        reason: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .worker_id = "WorkerId",
                .reason = "Reason",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_worker_block) } {
            return .{ .service_metadata = service_metadata, .action = create_worker_block };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const delete_hit: struct {
    action_name: []const u8 = "DeleteHIT",
    Request: type = struct {
        hit_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_hit) } {
            return .{ .service_metadata = service_metadata, .action = delete_hit };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const delete_qualification_type: struct {
    action_name: []const u8 = "DeleteQualificationType",
    Request: type = struct {
        qualification_type_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = delete_qualification_type };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const delete_worker_block: struct {
    action_name: []const u8 = "DeleteWorkerBlock",
    Request: type = struct {
        worker_id: []const u8,
        reason: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .worker_id = "WorkerId",
                .reason = "Reason",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_worker_block) } {
            return .{ .service_metadata = service_metadata, .action = delete_worker_block };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const disassociate_qualification_from_worker: struct {
    action_name: []const u8 = "DisassociateQualificationFromWorker",
    Request: type = struct {
        worker_id: []const u8,
        qualification_type_id: []const u8,
        reason: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .worker_id = "WorkerId",
                .qualification_type_id = "QualificationTypeId",
                .reason = "Reason",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_qualification_from_worker) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_qualification_from_worker };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_account_balance: struct {
    action_name: []const u8 = "GetAccountBalance",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_balance) } {
            return .{ .service_metadata = service_metadata, .action = get_account_balance };
        }
    },
    Response: type = struct {
        available_balance: ?[]const u8 = null,
        on_hold_balance: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .available_balance = "AvailableBalance",
                .on_hold_balance = "OnHoldBalance",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_assignment: struct {
    action_name: []const u8 = "GetAssignment",
    Request: type = struct {
        assignment_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment_id = "AssignmentId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_assignment) } {
            return .{ .service_metadata = service_metadata, .action = get_assignment };
        }
    },
    Response: type = struct {
        assignment: ?Assignment = null,
        hit: ?HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment = "Assignment",
                .hit = "HIT",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_file_upload_url: struct {
    action_name: []const u8 = "GetFileUploadURL",
    Request: type = struct {
        assignment_id: []const u8,
        question_identifier: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment_id = "AssignmentId",
                .question_identifier = "QuestionIdentifier",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_file_upload_url) } {
            return .{ .service_metadata = service_metadata, .action = get_file_upload_url };
        }
    },
    Response: type = struct {
        file_upload_url: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .file_upload_url = "FileUploadURL",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_hit: struct {
    action_name: []const u8 = "GetHIT",
    Request: type = struct {
        hit_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_hit) } {
            return .{ .service_metadata = service_metadata, .action = get_hit };
        }
    },
    Response: type = struct {
        hit: ?HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit = "HIT",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_qualification_score: struct {
    action_name: []const u8 = "GetQualificationScore",
    Request: type = struct {
        qualification_type_id: []const u8,
        worker_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .worker_id = "WorkerId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_qualification_score) } {
            return .{ .service_metadata = service_metadata, .action = get_qualification_score };
        }
    },
    Response: type = struct {
        qualification: ?Qualification = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification = "Qualification",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const get_qualification_type: struct {
    action_name: []const u8 = "GetQualificationType",
    Request: type = struct {
        qualification_type_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = get_qualification_type };
        }
    },
    Response: type = struct {
        qualification_type: ?QualificationType = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type = "QualificationType",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_assignments_for_hit: struct {
    action_name: []const u8 = "ListAssignmentsForHIT",
    Request: type = struct {
        hit_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        assignment_statuses: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .assignment_statuses = "AssignmentStatuses",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_assignments_for_hit) } {
            return .{ .service_metadata = service_metadata, .action = list_assignments_for_hit };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        assignments: ?[]Assignment = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .assignments = "Assignments",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_bonus_payments: struct {
    action_name: []const u8 = "ListBonusPayments",
    Request: type = struct {
        hit_id: ?[]const u8 = null,
        assignment_id: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .assignment_id = "AssignmentId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_bonus_payments) } {
            return .{ .service_metadata = service_metadata, .action = list_bonus_payments };
        }
    },
    Response: type = struct {
        num_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        bonus_payments: ?[]struct {
            worker_id: ?[]const u8 = null,
            bonus_amount: ?[]const u8 = null,
            assignment_id: ?[]const u8 = null,
            reason: ?[]const u8 = null,
            grant_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .worker_id = "WorkerId",
                    .bonus_amount = "BonusAmount",
                    .assignment_id = "AssignmentId",
                    .reason = "Reason",
                    .grant_time = "GrantTime",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .num_results = "NumResults",
                .next_token = "NextToken",
                .bonus_payments = "BonusPayments",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_hi_ts: struct {
    action_name: []const u8 = "ListHITs",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_hi_ts) } {
            return .{ .service_metadata = service_metadata, .action = list_hi_ts };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        hi_ts: ?[]HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .hi_ts = "HITs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_hi_ts_for_qualification_type: struct {
    action_name: []const u8 = "ListHITsForQualificationType",
    Request: type = struct {
        qualification_type_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_hi_ts_for_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = list_hi_ts_for_qualification_type };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        hi_ts: ?[]HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .hi_ts = "HITs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_qualification_requests: struct {
    action_name: []const u8 = "ListQualificationRequests",
    Request: type = struct {
        qualification_type_id: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_qualification_requests) } {
            return .{ .service_metadata = service_metadata, .action = list_qualification_requests };
        }
    },
    Response: type = struct {
        num_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        qualification_requests: ?[]struct {
            qualification_request_id: ?[]const u8 = null,
            qualification_type_id: ?[]const u8 = null,
            worker_id: ?[]const u8 = null,
            @"test": ?[]const u8 = null,
            answer: ?[]const u8 = null,
            submit_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .qualification_request_id = "QualificationRequestId",
                    .qualification_type_id = "QualificationTypeId",
                    .worker_id = "WorkerId",
                    .@"test" = "Test",
                    .answer = "Answer",
                    .submit_time = "SubmitTime",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .num_results = "NumResults",
                .next_token = "NextToken",
                .qualification_requests = "QualificationRequests",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_qualification_types: struct {
    action_name: []const u8 = "ListQualificationTypes",
    Request: type = struct {
        query: ?[]const u8 = null,
        must_be_requestable: bool,
        must_be_owned_by_caller: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query = "Query",
                .must_be_requestable = "MustBeRequestable",
                .must_be_owned_by_caller = "MustBeOwnedByCaller",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_qualification_types) } {
            return .{ .service_metadata = service_metadata, .action = list_qualification_types };
        }
    },
    Response: type = struct {
        num_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        qualification_types: ?[]QualificationType = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .num_results = "NumResults",
                .next_token = "NextToken",
                .qualification_types = "QualificationTypes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_reviewable_hi_ts: struct {
    action_name: []const u8 = "ListReviewableHITs",
    Request: type = struct {
        hit_type_id: ?[]const u8 = null,
        status: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_type_id = "HITTypeId",
                .status = "Status",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_reviewable_hi_ts) } {
            return .{ .service_metadata = service_metadata, .action = list_reviewable_hi_ts };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        hi_ts: ?[]HIT = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .hi_ts = "HITs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_review_policy_results_for_hit: struct {
    action_name: []const u8 = "ListReviewPolicyResultsForHIT",
    Request: type = struct {
        hit_id: []const u8,
        policy_levels: ?[][]const u8 = null,
        retrieve_actions: ?bool = null,
        retrieve_results: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .policy_levels = "PolicyLevels",
                .retrieve_actions = "RetrieveActions",
                .retrieve_results = "RetrieveResults",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_review_policy_results_for_hit) } {
            return .{ .service_metadata = service_metadata, .action = list_review_policy_results_for_hit };
        }
    },
    Response: type = struct {
        hit_id: ?[]const u8 = null,
        assignment_review_policy: ?ReviewPolicy = null,
        hit_review_policy: ?ReviewPolicy = null,
        assignment_review_report: ?ReviewReport = null,
        hit_review_report: ?ReviewReport = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .assignment_review_policy = "AssignmentReviewPolicy",
                .hit_review_policy = "HITReviewPolicy",
                .assignment_review_report = "AssignmentReviewReport",
                .hit_review_report = "HITReviewReport",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_worker_blocks: struct {
    action_name: []const u8 = "ListWorkerBlocks",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_worker_blocks) } {
            return .{ .service_metadata = service_metadata, .action = list_worker_blocks };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        worker_blocks: ?[]struct {
            worker_id: ?[]const u8 = null,
            reason: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .worker_id = "WorkerId",
                    .reason = "Reason",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .worker_blocks = "WorkerBlocks",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const list_workers_with_qualification_type: struct {
    action_name: []const u8 = "ListWorkersWithQualificationType",
    Request: type = struct {
        qualification_type_id: []const u8,
        status: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .status = "Status",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_workers_with_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = list_workers_with_qualification_type };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        num_results: ?i64 = null,
        qualifications: ?[]Qualification = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .num_results = "NumResults",
                .qualifications = "Qualifications",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const notify_workers: struct {
    action_name: []const u8 = "NotifyWorkers",
    Request: type = struct {
        subject: []const u8,
        message_text: []const u8,
        worker_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .subject = "Subject",
                .message_text = "MessageText",
                .worker_ids = "WorkerIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(notify_workers) } {
            return .{ .service_metadata = service_metadata, .action = notify_workers };
        }
    },
    Response: type = struct {
        notify_workers_failure_statuses: ?[]struct {
            notify_workers_failure_code: ?[]const u8 = null,
            notify_workers_failure_message: ?[]const u8 = null,
            worker_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .notify_workers_failure_code = "NotifyWorkersFailureCode",
                    .notify_workers_failure_message = "NotifyWorkersFailureMessage",
                    .worker_id = "WorkerId",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .notify_workers_failure_statuses = "NotifyWorkersFailureStatuses",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const reject_assignment: struct {
    action_name: []const u8 = "RejectAssignment",
    Request: type = struct {
        assignment_id: []const u8,
        requester_feedback: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .assignment_id = "AssignmentId",
                .requester_feedback = "RequesterFeedback",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reject_assignment) } {
            return .{ .service_metadata = service_metadata, .action = reject_assignment };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const reject_qualification_request: struct {
    action_name: []const u8 = "RejectQualificationRequest",
    Request: type = struct {
        qualification_request_id: []const u8,
        reason: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_request_id = "QualificationRequestId",
                .reason = "Reason",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reject_qualification_request) } {
            return .{ .service_metadata = service_metadata, .action = reject_qualification_request };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const send_bonus: struct {
    action_name: []const u8 = "SendBonus",
    Request: type = struct {
        worker_id: []const u8,
        bonus_amount: []const u8,
        assignment_id: []const u8,
        reason: []const u8,
        unique_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .worker_id = "WorkerId",
                .bonus_amount = "BonusAmount",
                .assignment_id = "AssignmentId",
                .reason = "Reason",
                .unique_request_token = "UniqueRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_bonus) } {
            return .{ .service_metadata = service_metadata, .action = send_bonus };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const send_test_event_notification: struct {
    action_name: []const u8 = "SendTestEventNotification",
    Request: type = struct {
        notification: NotificationSpecification,
        test_event_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .notification = "Notification",
                .test_event_type = "TestEventType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_test_event_notification) } {
            return .{ .service_metadata = service_metadata, .action = send_test_event_notification };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const update_expiration_for_hit: struct {
    action_name: []const u8 = "UpdateExpirationForHIT",
    Request: type = struct {
        hit_id: []const u8,
        expire_at: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .expire_at = "ExpireAt",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_expiration_for_hit) } {
            return .{ .service_metadata = service_metadata, .action = update_expiration_for_hit };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const update_hit_review_status: struct {
    action_name: []const u8 = "UpdateHITReviewStatus",
    Request: type = struct {
        hit_id: []const u8,
        revert: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .revert = "Revert",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_hit_review_status) } {
            return .{ .service_metadata = service_metadata, .action = update_hit_review_status };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const update_hit_type_of_hit: struct {
    action_name: []const u8 = "UpdateHITTypeOfHIT",
    Request: type = struct {
        hit_id: []const u8,
        hit_type_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_id = "HITId",
                .hit_type_id = "HITTypeId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_hit_type_of_hit) } {
            return .{ .service_metadata = service_metadata, .action = update_hit_type_of_hit };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const update_notification_settings: struct {
    action_name: []const u8 = "UpdateNotificationSettings",
    Request: type = struct {
        hit_type_id: []const u8,
        notification: ?NotificationSpecification = null,
        active: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .hit_type_id = "HITTypeId",
                .notification = "Notification",
                .active = "Active",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_notification_settings) } {
            return .{ .service_metadata = service_metadata, .action = update_notification_settings };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};
pub const update_qualification_type: struct {
    action_name: []const u8 = "UpdateQualificationType",
    Request: type = struct {
        qualification_type_id: []const u8,
        description: ?[]const u8 = null,
        qualification_type_status: ?[]const u8 = null,
        @"test": ?[]const u8 = null,
        answer_key: ?[]const u8 = null,
        test_duration_in_seconds: ?i64 = null,
        retry_delay_in_seconds: ?i64 = null,
        auto_granted: ?bool = null,
        auto_granted_value: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type_id = "QualificationTypeId",
                .description = "Description",
                .qualification_type_status = "QualificationTypeStatus",
                .@"test" = "Test",
                .answer_key = "AnswerKey",
                .test_duration_in_seconds = "TestDurationInSeconds",
                .retry_delay_in_seconds = "RetryDelayInSeconds",
                .auto_granted = "AutoGranted",
                .auto_granted_value = "AutoGrantedValue",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_qualification_type) } {
            return .{ .service_metadata = service_metadata, .action = update_qualification_type };
        }
    },
    Response: type = struct {
        qualification_type: ?QualificationType = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .qualification_type = "QualificationType",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        RequestError,
        Service,
    },
} = .{};

pub const QualificationType = struct {
    qualification_type_id: ?[]const u8 = null,
    creation_time: ?i64 = null,
    name: ?[]const u8 = null,
    description: ?[]const u8 = null,
    keywords: ?[]const u8 = null,
    qualification_type_status: ?[]const u8 = null,
    @"test": ?[]const u8 = null,
    test_duration_in_seconds: ?i64 = null,
    answer_key: ?[]const u8 = null,
    retry_delay_in_seconds: ?i64 = null,
    is_requestable: ?bool = null,
    auto_granted: ?bool = null,
    auto_granted_value: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .qualification_type_id = "QualificationTypeId",
            .creation_time = "CreationTime",
            .name = "Name",
            .description = "Description",
            .keywords = "Keywords",
            .qualification_type_status = "QualificationTypeStatus",
            .@"test" = "Test",
            .test_duration_in_seconds = "TestDurationInSeconds",
            .answer_key = "AnswerKey",
            .retry_delay_in_seconds = "RetryDelayInSeconds",
            .is_requestable = "IsRequestable",
            .auto_granted = "AutoGranted",
            .auto_granted_value = "AutoGrantedValue",
        };
        return @field(mappings, field_name);
    }
};

pub const NotificationSpecification = struct {
    destination: []const u8,
    transport: []const u8,
    version: []const u8,
    event_types: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .destination = "Destination",
            .transport = "Transport",
            .version = "Version",
            .event_types = "EventTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const Qualification = struct {
    qualification_type_id: ?[]const u8 = null,
    worker_id: ?[]const u8 = null,
    grant_time: ?i64 = null,
    integer_value: ?i64 = null,
    locale_value: ?Locale = null,
    status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .qualification_type_id = "QualificationTypeId",
            .worker_id = "WorkerId",
            .grant_time = "GrantTime",
            .integer_value = "IntegerValue",
            .locale_value = "LocaleValue",
            .status = "Status",
        };
        return @field(mappings, field_name);
    }
};

pub const Locale = struct {
    country: []const u8,
    subdivision: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .country = "Country",
            .subdivision = "Subdivision",
        };
        return @field(mappings, field_name);
    }
};

pub const ReviewReport = struct {
    review_results: ?[]ReviewResultDetail = null,
    review_actions: ?[]ReviewActionDetail = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .review_results = "ReviewResults",
            .review_actions = "ReviewActions",
        };
        return @field(mappings, field_name);
    }
};

pub const ReviewActionDetail = struct {
    action_id: ?[]const u8 = null,
    action_name: ?[]const u8 = null,
    target_id: ?[]const u8 = null,
    target_type: ?[]const u8 = null,
    status: ?[]const u8 = null,
    complete_time: ?i64 = null,
    result: ?[]const u8 = null,
    error_code: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action_id = "ActionId",
            .action_name = "ActionName",
            .target_id = "TargetId",
            .target_type = "TargetType",
            .status = "Status",
            .complete_time = "CompleteTime",
            .result = "Result",
            .error_code = "ErrorCode",
        };
        return @field(mappings, field_name);
    }
};

pub const ReviewResultDetail = struct {
    action_id: ?[]const u8 = null,
    subject_id: ?[]const u8 = null,
    subject_type: ?[]const u8 = null,
    question_id: ?[]const u8 = null,
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action_id = "ActionId",
            .subject_id = "SubjectId",
            .subject_type = "SubjectType",
            .question_id = "QuestionId",
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const ReviewPolicy = struct {
    policy_name: []const u8,
    parameters: ?[]PolicyParameter = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_name = "PolicyName",
            .parameters = "Parameters",
        };
        return @field(mappings, field_name);
    }
};

pub const PolicyParameter = struct {
    key: ?[]const u8 = null,
    values: ?[][]const u8 = null,
    map_entries: ?[]ParameterMapEntry = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .values = "Values",
            .map_entries = "MapEntries",
        };
        return @field(mappings, field_name);
    }
};

pub const ParameterMapEntry = struct {
    key: ?[]const u8 = null,
    values: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .values = "Values",
        };
        return @field(mappings, field_name);
    }
};

pub const HIT = struct {
    hit_id: ?[]const u8 = null,
    hit_type_id: ?[]const u8 = null,
    hit_group_id: ?[]const u8 = null,
    hit_layout_id: ?[]const u8 = null,
    creation_time: ?i64 = null,
    title: ?[]const u8 = null,
    description: ?[]const u8 = null,
    question: ?[]const u8 = null,
    keywords: ?[]const u8 = null,
    hit_status: ?[]const u8 = null,
    max_assignments: ?i64 = null,
    reward: ?[]const u8 = null,
    auto_approval_delay_in_seconds: ?i64 = null,
    expiration: ?i64 = null,
    assignment_duration_in_seconds: ?i64 = null,
    requester_annotation: ?[]const u8 = null,
    qualification_requirements: ?[]QualificationRequirement = null,
    hit_review_status: ?[]const u8 = null,
    number_of_assignments_pending: ?i64 = null,
    number_of_assignments_available: ?i64 = null,
    number_of_assignments_completed: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .hit_id = "HITId",
            .hit_type_id = "HITTypeId",
            .hit_group_id = "HITGroupId",
            .hit_layout_id = "HITLayoutId",
            .creation_time = "CreationTime",
            .title = "Title",
            .description = "Description",
            .question = "Question",
            .keywords = "Keywords",
            .hit_status = "HITStatus",
            .max_assignments = "MaxAssignments",
            .reward = "Reward",
            .auto_approval_delay_in_seconds = "AutoApprovalDelayInSeconds",
            .expiration = "Expiration",
            .assignment_duration_in_seconds = "AssignmentDurationInSeconds",
            .requester_annotation = "RequesterAnnotation",
            .qualification_requirements = "QualificationRequirements",
            .hit_review_status = "HITReviewStatus",
            .number_of_assignments_pending = "NumberOfAssignmentsPending",
            .number_of_assignments_available = "NumberOfAssignmentsAvailable",
            .number_of_assignments_completed = "NumberOfAssignmentsCompleted",
        };
        return @field(mappings, field_name);
    }
};

pub const QualificationRequirement = struct {
    qualification_type_id: []const u8,
    comparator: []const u8,
    integer_values: ?[]i64 = null,
    locale_values: ?[]Locale = null,
    required_to_preview: ?bool = null,
    actions_guarded: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .qualification_type_id = "QualificationTypeId",
            .comparator = "Comparator",
            .integer_values = "IntegerValues",
            .locale_values = "LocaleValues",
            .required_to_preview = "RequiredToPreview",
            .actions_guarded = "ActionsGuarded",
        };
        return @field(mappings, field_name);
    }
};

pub const Assignment = struct {
    assignment_id: ?[]const u8 = null,
    worker_id: ?[]const u8 = null,
    hit_id: ?[]const u8 = null,
    assignment_status: ?[]const u8 = null,
    auto_approval_time: ?i64 = null,
    accept_time: ?i64 = null,
    submit_time: ?i64 = null,
    approval_time: ?i64 = null,
    rejection_time: ?i64 = null,
    deadline: ?i64 = null,
    answer: ?[]const u8 = null,
    requester_feedback: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .assignment_id = "AssignmentId",
            .worker_id = "WorkerId",
            .hit_id = "HITId",
            .assignment_status = "AssignmentStatus",
            .auto_approval_time = "AutoApprovalTime",
            .accept_time = "AcceptTime",
            .submit_time = "SubmitTime",
            .approval_time = "ApprovalTime",
            .rejection_time = "RejectionTime",
            .deadline = "Deadline",
            .answer = "Answer",
            .requester_feedback = "RequesterFeedback",
        };
        return @field(mappings, field_name);
    }
};

pub const HITLayoutParameter = struct {
    name: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};
