const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-09-01";
pub const sdk_id: []const u8 = "MediaStore";
pub const arn_namespace: ?[]const u8 = "mediastore";
pub const endpoint_prefix: []const u8 = "mediastore";
pub const sigv4_name: []const u8 = "mediastore";
pub const name: []const u8 = "MediaStore_20170901";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-09-01",
    sdk_id: []const u8 = "MediaStore",
    arn_namespace: ?[]const u8 = "mediastore",
    endpoint_prefix: []const u8 = "mediastore",
    sigv4_name: []const u8 = "mediastore",
    name: []const u8 = "MediaStore_20170901",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const create_container: struct {
    action_name: []const u8 = "CreateContainer",
    Request: type = struct {
        container_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_container) } {
            return .{ .service_metadata = service_metadata, .action = create_container };
        }
    },
    Response: type = struct {
        container: Container,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container = "Container",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        InternalServerError,
        LimitExceeded,
    },
} = .{};
pub const delete_container: struct {
    action_name: []const u8 = "DeleteContainer",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_container) } {
            return .{ .service_metadata = service_metadata, .action = delete_container };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const delete_container_policy: struct {
    action_name: []const u8 = "DeleteContainerPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_container_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_container_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const delete_cors_policy: struct {
    action_name: []const u8 = "DeleteCorsPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_cors_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_cors_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        CorsPolicyNotFound,
        InternalServerError,
    },
} = .{};
pub const delete_lifecycle_policy: struct {
    action_name: []const u8 = "DeleteLifecyclePolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_lifecycle_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_lifecycle_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const delete_metric_policy: struct {
    action_name: []const u8 = "DeleteMetricPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_metric_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_metric_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const describe_container: struct {
    action_name: []const u8 = "DescribeContainer",
    Request: type = struct {
        container_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_container) } {
            return .{ .service_metadata = service_metadata, .action = describe_container };
        }
    },
    Response: type = struct {
        container: ?Container = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container = "Container",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const get_container_policy: struct {
    action_name: []const u8 = "GetContainerPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_container_policy };
        }
    },
    Response: type = struct {
        policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const get_cors_policy: struct {
    action_name: []const u8 = "GetCorsPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_cors_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_cors_policy };
        }
    },
    Response: type = struct {
        cors_policy: []CorsRule,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .cors_policy = "CorsPolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        CorsPolicyNotFound,
        InternalServerError,
    },
} = .{};
pub const get_lifecycle_policy: struct {
    action_name: []const u8 = "GetLifecyclePolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_lifecycle_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_lifecycle_policy };
        }
    },
    Response: type = struct {
        lifecycle_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .lifecycle_policy = "LifecyclePolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const get_metric_policy: struct {
    action_name: []const u8 = "GetMetricPolicy",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_metric_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_metric_policy };
        }
    },
    Response: type = struct {
        metric_policy: MetricPolicy,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_policy = "MetricPolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
        PolicyNotFound,
    },
} = .{};
pub const list_containers: struct {
    action_name: []const u8 = "ListContainers",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_containers) } {
            return .{ .service_metadata = service_metadata, .action = list_containers };
        }
    },
    Response: type = struct {
        containers: []Container,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .containers = "Containers",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServerError,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource = "Resource",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const put_container_policy: struct {
    action_name: []const u8 = "PutContainerPolicy",
    Request: type = struct {
        container_name: []const u8,
        policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
                .policy = "Policy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_container_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_container_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const put_cors_policy: struct {
    action_name: []const u8 = "PutCorsPolicy",
    Request: type = struct {
        container_name: []const u8,
        cors_policy: []CorsRule,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
                .cors_policy = "CorsPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_cors_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_cors_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const put_lifecycle_policy: struct {
    action_name: []const u8 = "PutLifecyclePolicy",
    Request: type = struct {
        container_name: []const u8,
        lifecycle_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
                .lifecycle_policy = "LifecyclePolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_lifecycle_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_lifecycle_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const put_metric_policy: struct {
    action_name: []const u8 = "PutMetricPolicy",
    Request: type = struct {
        container_name: []const u8,
        metric_policy: MetricPolicy,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
                .metric_policy = "MetricPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_metric_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_metric_policy };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const start_access_logging: struct {
    action_name: []const u8 = "StartAccessLogging",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_access_logging) } {
            return .{ .service_metadata = service_metadata, .action = start_access_logging };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const stop_access_logging: struct {
    action_name: []const u8 = "StopAccessLogging",
    Request: type = struct {
        container_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_name = "ContainerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_access_logging) } {
            return .{ .service_metadata = service_metadata, .action = stop_access_logging };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource = "Resource",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource = "Resource",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ContainerInUse,
        ContainerNotFound,
        InternalServerError,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricPolicy = struct {
    container_level_metrics: []const u8,
    metric_policy_rules: ?[]MetricPolicyRule = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .container_level_metrics = "ContainerLevelMetrics",
            .metric_policy_rules = "MetricPolicyRules",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricPolicyRule = struct {
    object_group: []const u8,
    object_group_name: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .object_group = "ObjectGroup",
            .object_group_name = "ObjectGroupName",
        };
        return @field(mappings, field_name);
    }
};

pub const CorsRule = struct {
    allowed_origins: [][]const u8,
    allowed_methods: ?[][]const u8 = null,
    allowed_headers: [][]const u8,
    max_age_seconds: ?i64 = null,
    expose_headers: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .allowed_origins = "AllowedOrigins",
            .allowed_methods = "AllowedMethods",
            .allowed_headers = "AllowedHeaders",
            .max_age_seconds = "MaxAgeSeconds",
            .expose_headers = "ExposeHeaders",
        };
        return @field(mappings, field_name);
    }
};

pub const Container = struct {
    endpoint: ?[]const u8 = null,
    creation_time: ?i64 = null,
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    access_logging_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .endpoint = "Endpoint",
            .creation_time = "CreationTime",
            .arn = "ARN",
            .name = "Name",
            .status = "Status",
            .access_logging_enabled = "AccessLoggingEnabled",
        };
        return @field(mappings, field_name);
    }
};
