const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2013-02-18";
pub const sdk_id: []const u8 = "OpsWorks";
pub const arn_namespace: ?[]const u8 = "opsworks";
pub const endpoint_prefix: []const u8 = "opsworks";
pub const sigv4_name: []const u8 = "opsworks";
pub const name: []const u8 = "OpsWorks_20130218";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2013-02-18",
    sdk_id: []const u8 = "OpsWorks",
    arn_namespace: ?[]const u8 = "opsworks",
    endpoint_prefix: []const u8 = "opsworks",
    sigv4_name: []const u8 = "opsworks",
    name: []const u8 = "OpsWorks_20130218",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const assign_instance: struct {
    action_name: []const u8 = "AssignInstance",
    Request: type = struct {
        instance_id: []const u8,
        layer_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .layer_ids = "LayerIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(assign_instance) } {
            return .{ .service_metadata = service_metadata, .action = assign_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const assign_volume: struct {
    action_name: []const u8 = "AssignVolume",
    Request: type = struct {
        volume_id: []const u8,
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volume_id = "VolumeId",
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(assign_volume) } {
            return .{ .service_metadata = service_metadata, .action = assign_volume };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const associate_elastic_ip: struct {
    action_name: []const u8 = "AssociateElasticIp",
    Request: type = struct {
        elastic_ip: []const u8,
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_elastic_ip) } {
            return .{ .service_metadata = service_metadata, .action = associate_elastic_ip };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const attach_elastic_load_balancer: struct {
    action_name: []const u8 = "AttachElasticLoadBalancer",
    Request: type = struct {
        elastic_load_balancer_name: []const u8,
        layer_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_load_balancer_name = "ElasticLoadBalancerName",
                .layer_id = "LayerId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_elastic_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = attach_elastic_load_balancer };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const clone_stack: struct {
    action_name: []const u8 = "CloneStack",
    Request: type = struct {
        source_stack_id: []const u8,
        name: ?[]const u8 = null,
        region: ?[]const u8 = null,
        vpc_id: ?[]const u8 = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        service_role_arn: []const u8,
        default_instance_profile_arn: ?[]const u8 = null,
        default_os: ?[]const u8 = null,
        hostname_theme: ?[]const u8 = null,
        default_availability_zone: ?[]const u8 = null,
        default_subnet_id: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,
        configuration_manager: ?StackConfigurationManager = null,
        chef_configuration: ?ChefConfiguration = null,
        use_custom_cookbooks: ?bool = null,
        use_opsworks_security_groups: ?bool = null,
        custom_cookbooks_source: ?Source = null,
        default_ssh_key_name: ?[]const u8 = null,
        clone_permissions: ?bool = null,
        clone_app_ids: ?[][]const u8 = null,
        default_root_device_type: ?[]const u8 = null,
        agent_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .source_stack_id = "SourceStackId",
                .name = "Name",
                .region = "Region",
                .vpc_id = "VpcId",
                .attributes = "Attributes",
                .service_role_arn = "ServiceRoleArn",
                .default_instance_profile_arn = "DefaultInstanceProfileArn",
                .default_os = "DefaultOs",
                .hostname_theme = "HostnameTheme",
                .default_availability_zone = "DefaultAvailabilityZone",
                .default_subnet_id = "DefaultSubnetId",
                .custom_json = "CustomJson",
                .configuration_manager = "ConfigurationManager",
                .chef_configuration = "ChefConfiguration",
                .use_custom_cookbooks = "UseCustomCookbooks",
                .use_opsworks_security_groups = "UseOpsworksSecurityGroups",
                .custom_cookbooks_source = "CustomCookbooksSource",
                .default_ssh_key_name = "DefaultSshKeyName",
                .clone_permissions = "ClonePermissions",
                .clone_app_ids = "CloneAppIds",
                .default_root_device_type = "DefaultRootDeviceType",
                .agent_version = "AgentVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(clone_stack) } {
            return .{ .service_metadata = service_metadata, .action = clone_stack };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_app: struct {
    action_name: []const u8 = "CreateApp",
    Request: type = struct {
        stack_id: []const u8,
        shortname: ?[]const u8 = null,
        name: []const u8,
        description: ?[]const u8 = null,
        data_sources: ?[]DataSource = null,
        type: []const u8,
        app_source: ?Source = null,
        domains: ?[][]const u8 = null,
        enable_ssl: ?bool = null,
        ssl_configuration: ?SslConfiguration = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        environment: ?[]EnvironmentVariable = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .shortname = "Shortname",
                .name = "Name",
                .description = "Description",
                .data_sources = "DataSources",
                .type = "Type",
                .app_source = "AppSource",
                .domains = "Domains",
                .enable_ssl = "EnableSsl",
                .ssl_configuration = "SslConfiguration",
                .attributes = "Attributes",
                .environment = "Environment",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_app) } {
            return .{ .service_metadata = service_metadata, .action = create_app };
        }
    },
    Response: type = struct {
        app_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .app_id = "AppId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_deployment: struct {
    action_name: []const u8 = "CreateDeployment",
    Request: type = struct {
        stack_id: []const u8,
        app_id: ?[]const u8 = null,
        instance_ids: ?[][]const u8 = null,
        layer_ids: ?[][]const u8 = null,
        command: DeploymentCommand,
        comment: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .app_id = "AppId",
                .instance_ids = "InstanceIds",
                .layer_ids = "LayerIds",
                .command = "Command",
                .comment = "Comment",
                .custom_json = "CustomJson",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_deployment) } {
            return .{ .service_metadata = service_metadata, .action = create_deployment };
        }
    },
    Response: type = struct {
        deployment_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "DeploymentId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_instance: struct {
    action_name: []const u8 = "CreateInstance",
    Request: type = struct {
        stack_id: []const u8,
        layer_ids: [][]const u8,
        instance_type: []const u8,
        auto_scaling_type: ?[]const u8 = null,
        hostname: ?[]const u8 = null,
        os: ?[]const u8 = null,
        ami_id: ?[]const u8 = null,
        ssh_key_name: ?[]const u8 = null,
        availability_zone: ?[]const u8 = null,
        virtualization_type: ?[]const u8 = null,
        subnet_id: ?[]const u8 = null,
        architecture: ?[]const u8 = null,
        root_device_type: ?[]const u8 = null,
        block_device_mappings: ?[]BlockDeviceMapping = null,
        install_updates_on_boot: ?bool = null,
        ebs_optimized: ?bool = null,
        agent_version: ?[]const u8 = null,
        tenancy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .layer_ids = "LayerIds",
                .instance_type = "InstanceType",
                .auto_scaling_type = "AutoScalingType",
                .hostname = "Hostname",
                .os = "Os",
                .ami_id = "AmiId",
                .ssh_key_name = "SshKeyName",
                .availability_zone = "AvailabilityZone",
                .virtualization_type = "VirtualizationType",
                .subnet_id = "SubnetId",
                .architecture = "Architecture",
                .root_device_type = "RootDeviceType",
                .block_device_mappings = "BlockDeviceMappings",
                .install_updates_on_boot = "InstallUpdatesOnBoot",
                .ebs_optimized = "EbsOptimized",
                .agent_version = "AgentVersion",
                .tenancy = "Tenancy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_instance) } {
            return .{ .service_metadata = service_metadata, .action = create_instance };
        }
    },
    Response: type = struct {
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_layer: struct {
    action_name: []const u8 = "CreateLayer",
    Request: type = struct {
        stack_id: []const u8,
        type: []const u8,
        name: []const u8,
        shortname: []const u8,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        cloud_watch_logs_configuration: ?CloudWatchLogsConfiguration = null,
        custom_instance_profile_arn: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,
        custom_security_group_ids: ?[][]const u8 = null,
        packages: ?[][]const u8 = null,
        volume_configurations: ?[]VolumeConfiguration = null,
        enable_auto_healing: ?bool = null,
        auto_assign_elastic_ips: ?bool = null,
        auto_assign_public_ips: ?bool = null,
        custom_recipes: ?Recipes = null,
        install_updates_on_boot: ?bool = null,
        use_ebs_optimized_instances: ?bool = null,
        lifecycle_event_configuration: ?LifecycleEventConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .type = "Type",
                .name = "Name",
                .shortname = "Shortname",
                .attributes = "Attributes",
                .cloud_watch_logs_configuration = "CloudWatchLogsConfiguration",
                .custom_instance_profile_arn = "CustomInstanceProfileArn",
                .custom_json = "CustomJson",
                .custom_security_group_ids = "CustomSecurityGroupIds",
                .packages = "Packages",
                .volume_configurations = "VolumeConfigurations",
                .enable_auto_healing = "EnableAutoHealing",
                .auto_assign_elastic_ips = "AutoAssignElasticIps",
                .auto_assign_public_ips = "AutoAssignPublicIps",
                .custom_recipes = "CustomRecipes",
                .install_updates_on_boot = "InstallUpdatesOnBoot",
                .use_ebs_optimized_instances = "UseEbsOptimizedInstances",
                .lifecycle_event_configuration = "LifecycleEventConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_layer) } {
            return .{ .service_metadata = service_metadata, .action = create_layer };
        }
    },
    Response: type = struct {
        layer_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const create_stack: struct {
    action_name: []const u8 = "CreateStack",
    Request: type = struct {
        name: []const u8,
        region: []const u8,
        vpc_id: ?[]const u8 = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        service_role_arn: []const u8,
        default_instance_profile_arn: []const u8,
        default_os: ?[]const u8 = null,
        hostname_theme: ?[]const u8 = null,
        default_availability_zone: ?[]const u8 = null,
        default_subnet_id: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,
        configuration_manager: ?StackConfigurationManager = null,
        chef_configuration: ?ChefConfiguration = null,
        use_custom_cookbooks: ?bool = null,
        use_opsworks_security_groups: ?bool = null,
        custom_cookbooks_source: ?Source = null,
        default_ssh_key_name: ?[]const u8 = null,
        default_root_device_type: ?[]const u8 = null,
        agent_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .region = "Region",
                .vpc_id = "VpcId",
                .attributes = "Attributes",
                .service_role_arn = "ServiceRoleArn",
                .default_instance_profile_arn = "DefaultInstanceProfileArn",
                .default_os = "DefaultOs",
                .hostname_theme = "HostnameTheme",
                .default_availability_zone = "DefaultAvailabilityZone",
                .default_subnet_id = "DefaultSubnetId",
                .custom_json = "CustomJson",
                .configuration_manager = "ConfigurationManager",
                .chef_configuration = "ChefConfiguration",
                .use_custom_cookbooks = "UseCustomCookbooks",
                .use_opsworks_security_groups = "UseOpsworksSecurityGroups",
                .custom_cookbooks_source = "CustomCookbooksSource",
                .default_ssh_key_name = "DefaultSshKeyName",
                .default_root_device_type = "DefaultRootDeviceType",
                .agent_version = "AgentVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_stack) } {
            return .{ .service_metadata = service_metadata, .action = create_stack };
        }
    },
    Response: type = struct {
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Validation,
    },
} = .{};
pub const create_user_profile: struct {
    action_name: []const u8 = "CreateUserProfile",
    Request: type = struct {
        iam_user_arn: []const u8,
        ssh_username: ?[]const u8 = null,
        ssh_public_key: ?[]const u8 = null,
        allow_self_management: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arn = "IamUserArn",
                .ssh_username = "SshUsername",
                .ssh_public_key = "SshPublicKey",
                .allow_self_management = "AllowSelfManagement",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_user_profile) } {
            return .{ .service_metadata = service_metadata, .action = create_user_profile };
        }
    },
    Response: type = struct {
        iam_user_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arn = "IamUserArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        Validation,
    },
} = .{};
pub const delete_app: struct {
    action_name: []const u8 = "DeleteApp",
    Request: type = struct {
        app_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .app_id = "AppId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_app) } {
            return .{ .service_metadata = service_metadata, .action = delete_app };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_instance: struct {
    action_name: []const u8 = "DeleteInstance",
    Request: type = struct {
        instance_id: []const u8,
        delete_elastic_ip: ?bool = null,
        delete_volumes: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .delete_elastic_ip = "DeleteElasticIp",
                .delete_volumes = "DeleteVolumes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_instance) } {
            return .{ .service_metadata = service_metadata, .action = delete_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_layer: struct {
    action_name: []const u8 = "DeleteLayer",
    Request: type = struct {
        layer_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_layer) } {
            return .{ .service_metadata = service_metadata, .action = delete_layer };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_stack: struct {
    action_name: []const u8 = "DeleteStack",
    Request: type = struct {
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_stack) } {
            return .{ .service_metadata = service_metadata, .action = delete_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_user_profile: struct {
    action_name: []const u8 = "DeleteUserProfile",
    Request: type = struct {
        iam_user_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arn = "IamUserArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_user_profile) } {
            return .{ .service_metadata = service_metadata, .action = delete_user_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const deregister_ecs_cluster: struct {
    action_name: []const u8 = "DeregisterEcsCluster",
    Request: type = struct {
        ecs_cluster_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ecs_cluster_arn = "EcsClusterArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_ecs_cluster) } {
            return .{ .service_metadata = service_metadata, .action = deregister_ecs_cluster };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const deregister_elastic_ip: struct {
    action_name: []const u8 = "DeregisterElasticIp",
    Request: type = struct {
        elastic_ip: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_elastic_ip) } {
            return .{ .service_metadata = service_metadata, .action = deregister_elastic_ip };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const deregister_instance: struct {
    action_name: []const u8 = "DeregisterInstance",
    Request: type = struct {
        instance_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_instance) } {
            return .{ .service_metadata = service_metadata, .action = deregister_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const deregister_rds_db_instance: struct {
    action_name: []const u8 = "DeregisterRdsDbInstance",
    Request: type = struct {
        rds_db_instance_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rds_db_instance_arn = "RdsDbInstanceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_rds_db_instance) } {
            return .{ .service_metadata = service_metadata, .action = deregister_rds_db_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const deregister_volume: struct {
    action_name: []const u8 = "DeregisterVolume",
    Request: type = struct {
        volume_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volume_id = "VolumeId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(deregister_volume) } {
            return .{ .service_metadata = service_metadata, .action = deregister_volume };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_agent_versions: struct {
    action_name: []const u8 = "DescribeAgentVersions",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        configuration_manager: ?StackConfigurationManager = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .configuration_manager = "ConfigurationManager",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_agent_versions) } {
            return .{ .service_metadata = service_metadata, .action = describe_agent_versions };
        }
    },
    Response: type = struct {
        agent_versions: ?[]struct {
            version: ?[]const u8 = null,
            configuration_manager: ?StackConfigurationManager = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .version = "Version",
                    .configuration_manager = "ConfigurationManager",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agent_versions = "AgentVersions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_apps: struct {
    action_name: []const u8 = "DescribeApps",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        app_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .app_ids = "AppIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_apps) } {
            return .{ .service_metadata = service_metadata, .action = describe_apps };
        }
    },
    Response: type = struct {
        apps: ?[]struct {
            app_id: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            shortname: ?[]const u8 = null,
            name: ?[]const u8 = null,
            description: ?[]const u8 = null,
            data_sources: ?[]DataSource = null,
            type: ?[]const u8 = null,
            app_source: ?Source = null,
            domains: ?[][]const u8 = null,
            enable_ssl: ?bool = null,
            ssl_configuration: ?SslConfiguration = null,
            attributes: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            created_at: ?[]const u8 = null,
            environment: ?[]EnvironmentVariable = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .app_id = "AppId",
                    .stack_id = "StackId",
                    .shortname = "Shortname",
                    .name = "Name",
                    .description = "Description",
                    .data_sources = "DataSources",
                    .type = "Type",
                    .app_source = "AppSource",
                    .domains = "Domains",
                    .enable_ssl = "EnableSsl",
                    .ssl_configuration = "SslConfiguration",
                    .attributes = "Attributes",
                    .created_at = "CreatedAt",
                    .environment = "Environment",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "attributes", field_name))
                    return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps = "Apps",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_commands: struct {
    action_name: []const u8 = "DescribeCommands",
    Request: type = struct {
        deployment_id: ?[]const u8 = null,
        instance_id: ?[]const u8 = null,
        command_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployment_id = "DeploymentId",
                .instance_id = "InstanceId",
                .command_ids = "CommandIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_commands) } {
            return .{ .service_metadata = service_metadata, .action = describe_commands };
        }
    },
    Response: type = struct {
        commands: ?[]struct {
            command_id: ?[]const u8 = null,
            instance_id: ?[]const u8 = null,
            deployment_id: ?[]const u8 = null,
            created_at: ?[]const u8 = null,
            acknowledged_at: ?[]const u8 = null,
            completed_at: ?[]const u8 = null,
            status: ?[]const u8 = null,
            exit_code: ?i64 = null,
            log_url: ?[]const u8 = null,
            type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .command_id = "CommandId",
                    .instance_id = "InstanceId",
                    .deployment_id = "DeploymentId",
                    .created_at = "CreatedAt",
                    .acknowledged_at = "AcknowledgedAt",
                    .completed_at = "CompletedAt",
                    .status = "Status",
                    .exit_code = "ExitCode",
                    .log_url = "LogUrl",
                    .type = "Type",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .commands = "Commands",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_deployments: struct {
    action_name: []const u8 = "DescribeDeployments",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        app_id: ?[]const u8 = null,
        deployment_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .app_id = "AppId",
                .deployment_ids = "DeploymentIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_deployments) } {
            return .{ .service_metadata = service_metadata, .action = describe_deployments };
        }
    },
    Response: type = struct {
        deployments: ?[]struct {
            deployment_id: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            app_id: ?[]const u8 = null,
            created_at: ?[]const u8 = null,
            completed_at: ?[]const u8 = null,
            duration: ?i64 = null,
            iam_user_arn: ?[]const u8 = null,
            comment: ?[]const u8 = null,
            command: ?DeploymentCommand = null,
            status: ?[]const u8 = null,
            custom_json: ?[]const u8 = null,
            instance_ids: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .deployment_id = "DeploymentId",
                    .stack_id = "StackId",
                    .app_id = "AppId",
                    .created_at = "CreatedAt",
                    .completed_at = "CompletedAt",
                    .duration = "Duration",
                    .iam_user_arn = "IamUserArn",
                    .comment = "Comment",
                    .command = "Command",
                    .status = "Status",
                    .custom_json = "CustomJson",
                    .instance_ids = "InstanceIds",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployments = "Deployments",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_ecs_clusters: struct {
    action_name: []const u8 = "DescribeEcsClusters",
    Request: type = struct {
        ecs_cluster_arns: ?[][]const u8 = null,
        stack_id: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ecs_cluster_arns = "EcsClusterArns",
                .stack_id = "StackId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_ecs_clusters) } {
            return .{ .service_metadata = service_metadata, .action = describe_ecs_clusters };
        }
    },
    Response: type = struct {
        ecs_clusters: ?[]struct {
            ecs_cluster_arn: ?[]const u8 = null,
            ecs_cluster_name: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            registered_at: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .ecs_cluster_arn = "EcsClusterArn",
                    .ecs_cluster_name = "EcsClusterName",
                    .stack_id = "StackId",
                    .registered_at = "RegisteredAt",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ecs_clusters = "EcsClusters",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_elastic_ips: struct {
    action_name: []const u8 = "DescribeElasticIps",
    Request: type = struct {
        instance_id: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        ips: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .stack_id = "StackId",
                .ips = "Ips",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_elastic_ips) } {
            return .{ .service_metadata = service_metadata, .action = describe_elastic_ips };
        }
    },
    Response: type = struct {
        elastic_ips: ?[]struct {
            ip: ?[]const u8 = null,
            name: ?[]const u8 = null,
            domain: ?[]const u8 = null,
            region: ?[]const u8 = null,
            instance_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .ip = "Ip",
                    .name = "Name",
                    .domain = "Domain",
                    .region = "Region",
                    .instance_id = "InstanceId",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ips = "ElasticIps",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_elastic_load_balancers: struct {
    action_name: []const u8 = "DescribeElasticLoadBalancers",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        layer_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .layer_ids = "LayerIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_elastic_load_balancers) } {
            return .{ .service_metadata = service_metadata, .action = describe_elastic_load_balancers };
        }
    },
    Response: type = struct {
        elastic_load_balancers: ?[]struct {
            elastic_load_balancer_name: ?[]const u8 = null,
            region: ?[]const u8 = null,
            dns_name: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            layer_id: ?[]const u8 = null,
            vpc_id: ?[]const u8 = null,
            availability_zones: ?[][]const u8 = null,
            subnet_ids: ?[][]const u8 = null,
            ec2_instance_ids: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .elastic_load_balancer_name = "ElasticLoadBalancerName",
                    .region = "Region",
                    .dns_name = "DnsName",
                    .stack_id = "StackId",
                    .layer_id = "LayerId",
                    .vpc_id = "VpcId",
                    .availability_zones = "AvailabilityZones",
                    .subnet_ids = "SubnetIds",
                    .ec2_instance_ids = "Ec2InstanceIds",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_load_balancers = "ElasticLoadBalancers",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_instances: struct {
    action_name: []const u8 = "DescribeInstances",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        layer_id: ?[]const u8 = null,
        instance_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .layer_id = "LayerId",
                .instance_ids = "InstanceIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_instances) } {
            return .{ .service_metadata = service_metadata, .action = describe_instances };
        }
    },
    Response: type = struct {
        instances: ?[]struct {
            agent_version: ?[]const u8 = null,
            ami_id: ?[]const u8 = null,
            architecture: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            auto_scaling_type: ?[]const u8 = null,
            availability_zone: ?[]const u8 = null,
            block_device_mappings: ?[]BlockDeviceMapping = null,
            created_at: ?[]const u8 = null,
            ebs_optimized: ?bool = null,
            ec2_instance_id: ?[]const u8 = null,
            ecs_cluster_arn: ?[]const u8 = null,
            ecs_container_instance_arn: ?[]const u8 = null,
            elastic_ip: ?[]const u8 = null,
            hostname: ?[]const u8 = null,
            infrastructure_class: ?[]const u8 = null,
            install_updates_on_boot: ?bool = null,
            instance_id: ?[]const u8 = null,
            instance_profile_arn: ?[]const u8 = null,
            instance_type: ?[]const u8 = null,
            last_service_error_id: ?[]const u8 = null,
            layer_ids: ?[][]const u8 = null,
            os: ?[]const u8 = null,
            platform: ?[]const u8 = null,
            private_dns: ?[]const u8 = null,
            private_ip: ?[]const u8 = null,
            public_dns: ?[]const u8 = null,
            public_ip: ?[]const u8 = null,
            registered_by: ?[]const u8 = null,
            reported_agent_version: ?[]const u8 = null,
            reported_os: ?struct {
                family: ?[]const u8 = null,
                name: ?[]const u8 = null,
                version: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .family = "Family",
                        .name = "Name",
                        .version = "Version",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            root_device_type: ?[]const u8 = null,
            root_device_volume_id: ?[]const u8 = null,
            security_group_ids: ?[][]const u8 = null,
            ssh_host_dsa_key_fingerprint: ?[]const u8 = null,
            ssh_host_rsa_key_fingerprint: ?[]const u8 = null,
            ssh_key_name: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            subnet_id: ?[]const u8 = null,
            tenancy: ?[]const u8 = null,
            virtualization_type: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .agent_version = "AgentVersion",
                    .ami_id = "AmiId",
                    .architecture = "Architecture",
                    .arn = "Arn",
                    .auto_scaling_type = "AutoScalingType",
                    .availability_zone = "AvailabilityZone",
                    .block_device_mappings = "BlockDeviceMappings",
                    .created_at = "CreatedAt",
                    .ebs_optimized = "EbsOptimized",
                    .ec2_instance_id = "Ec2InstanceId",
                    .ecs_cluster_arn = "EcsClusterArn",
                    .ecs_container_instance_arn = "EcsContainerInstanceArn",
                    .elastic_ip = "ElasticIp",
                    .hostname = "Hostname",
                    .infrastructure_class = "InfrastructureClass",
                    .install_updates_on_boot = "InstallUpdatesOnBoot",
                    .instance_id = "InstanceId",
                    .instance_profile_arn = "InstanceProfileArn",
                    .instance_type = "InstanceType",
                    .last_service_error_id = "LastServiceErrorId",
                    .layer_ids = "LayerIds",
                    .os = "Os",
                    .platform = "Platform",
                    .private_dns = "PrivateDns",
                    .private_ip = "PrivateIp",
                    .public_dns = "PublicDns",
                    .public_ip = "PublicIp",
                    .registered_by = "RegisteredBy",
                    .reported_agent_version = "ReportedAgentVersion",
                    .reported_os = "ReportedOs",
                    .root_device_type = "RootDeviceType",
                    .root_device_volume_id = "RootDeviceVolumeId",
                    .security_group_ids = "SecurityGroupIds",
                    .ssh_host_dsa_key_fingerprint = "SshHostDsaKeyFingerprint",
                    .ssh_host_rsa_key_fingerprint = "SshHostRsaKeyFingerprint",
                    .ssh_key_name = "SshKeyName",
                    .stack_id = "StackId",
                    .status = "Status",
                    .subnet_id = "SubnetId",
                    .tenancy = "Tenancy",
                    .virtualization_type = "VirtualizationType",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instances = "Instances",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_layers: struct {
    action_name: []const u8 = "DescribeLayers",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        layer_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .layer_ids = "LayerIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_layers) } {
            return .{ .service_metadata = service_metadata, .action = describe_layers };
        }
    },
    Response: type = struct {
        layers: ?[]struct {
            arn: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            layer_id: ?[]const u8 = null,
            type: ?[]const u8 = null,
            name: ?[]const u8 = null,
            shortname: ?[]const u8 = null,
            attributes: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            cloud_watch_logs_configuration: ?CloudWatchLogsConfiguration = null,
            custom_instance_profile_arn: ?[]const u8 = null,
            custom_json: ?[]const u8 = null,
            custom_security_group_ids: ?[][]const u8 = null,
            default_security_group_names: ?[][]const u8 = null,
            packages: ?[][]const u8 = null,
            volume_configurations: ?[]VolumeConfiguration = null,
            enable_auto_healing: ?bool = null,
            auto_assign_elastic_ips: ?bool = null,
            auto_assign_public_ips: ?bool = null,
            default_recipes: ?Recipes = null,
            custom_recipes: ?Recipes = null,
            created_at: ?[]const u8 = null,
            install_updates_on_boot: ?bool = null,
            use_ebs_optimized_instances: ?bool = null,
            lifecycle_event_configuration: ?LifecycleEventConfiguration = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .arn = "Arn",
                    .stack_id = "StackId",
                    .layer_id = "LayerId",
                    .type = "Type",
                    .name = "Name",
                    .shortname = "Shortname",
                    .attributes = "Attributes",
                    .cloud_watch_logs_configuration = "CloudWatchLogsConfiguration",
                    .custom_instance_profile_arn = "CustomInstanceProfileArn",
                    .custom_json = "CustomJson",
                    .custom_security_group_ids = "CustomSecurityGroupIds",
                    .default_security_group_names = "DefaultSecurityGroupNames",
                    .packages = "Packages",
                    .volume_configurations = "VolumeConfigurations",
                    .enable_auto_healing = "EnableAutoHealing",
                    .auto_assign_elastic_ips = "AutoAssignElasticIps",
                    .auto_assign_public_ips = "AutoAssignPublicIps",
                    .default_recipes = "DefaultRecipes",
                    .custom_recipes = "CustomRecipes",
                    .created_at = "CreatedAt",
                    .install_updates_on_boot = "InstallUpdatesOnBoot",
                    .use_ebs_optimized_instances = "UseEbsOptimizedInstances",
                    .lifecycle_event_configuration = "LifecycleEventConfiguration",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "attributes", field_name))
                    return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layers = "Layers",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_load_based_auto_scaling: struct {
    action_name: []const u8 = "DescribeLoadBasedAutoScaling",
    Request: type = struct {
        layer_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_ids = "LayerIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_load_based_auto_scaling) } {
            return .{ .service_metadata = service_metadata, .action = describe_load_based_auto_scaling };
        }
    },
    Response: type = struct {
        load_based_auto_scaling_configurations: ?[]struct {
            layer_id: ?[]const u8 = null,
            enable: ?bool = null,
            up_scaling: ?AutoScalingThresholds = null,
            down_scaling: ?AutoScalingThresholds = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .layer_id = "LayerId",
                    .enable = "Enable",
                    .up_scaling = "UpScaling",
                    .down_scaling = "DownScaling",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_based_auto_scaling_configurations = "LoadBasedAutoScalingConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_my_user_profile: struct {
    action_name: []const u8 = "DescribeMyUserProfile",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_my_user_profile) } {
            return .{ .service_metadata = service_metadata, .action = describe_my_user_profile };
        }
    },
    Response: type = struct {
        user_profile: ?struct {
            iam_user_arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            ssh_username: ?[]const u8 = null,
            ssh_public_key: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .iam_user_arn = "IamUserArn",
                    .name = "Name",
                    .ssh_username = "SshUsername",
                    .ssh_public_key = "SshPublicKey",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_profile = "UserProfile",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_operating_systems: struct {
    action_name: []const u8 = "DescribeOperatingSystems",
    Request: type = struct {
        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_operating_systems) } {
            return .{ .service_metadata = service_metadata, .action = describe_operating_systems };
        }
    },
    Response: type = struct {
        operating_systems: ?[]struct {
            name: ?[]const u8 = null,
            id: ?[]const u8 = null,
            type: ?[]const u8 = null,
            configuration_managers: ?[]struct {
                name: ?[]const u8 = null,
                version: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .name = "Name",
                        .version = "Version",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            reported_name: ?[]const u8 = null,
            reported_version: ?[]const u8 = null,
            supported: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .id = "Id",
                    .type = "Type",
                    .configuration_managers = "ConfigurationManagers",
                    .reported_name = "ReportedName",
                    .reported_version = "ReportedVersion",
                    .supported = "Supported",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operating_systems = "OperatingSystems",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
pub const describe_permissions: struct {
    action_name: []const u8 = "DescribePermissions",
    Request: type = struct {
        iam_user_arn: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arn = "IamUserArn",
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_permissions) } {
            return .{ .service_metadata = service_metadata, .action = describe_permissions };
        }
    },
    Response: type = struct {
        permissions: ?[]struct {
            stack_id: ?[]const u8 = null,
            iam_user_arn: ?[]const u8 = null,
            allow_ssh: ?bool = null,
            allow_sudo: ?bool = null,
            level: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .iam_user_arn = "IamUserArn",
                    .allow_ssh = "AllowSsh",
                    .allow_sudo = "AllowSudo",
                    .level = "Level",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .permissions = "Permissions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_raid_arrays: struct {
    action_name: []const u8 = "DescribeRaidArrays",
    Request: type = struct {
        instance_id: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        raid_array_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .stack_id = "StackId",
                .raid_array_ids = "RaidArrayIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_raid_arrays) } {
            return .{ .service_metadata = service_metadata, .action = describe_raid_arrays };
        }
    },
    Response: type = struct {
        raid_arrays: ?[]struct {
            raid_array_id: ?[]const u8 = null,
            instance_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            raid_level: ?i64 = null,
            number_of_disks: ?i64 = null,
            size: ?i64 = null,
            device: ?[]const u8 = null,
            mount_point: ?[]const u8 = null,
            availability_zone: ?[]const u8 = null,
            created_at: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            volume_type: ?[]const u8 = null,
            iops: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .raid_array_id = "RaidArrayId",
                    .instance_id = "InstanceId",
                    .name = "Name",
                    .raid_level = "RaidLevel",
                    .number_of_disks = "NumberOfDisks",
                    .size = "Size",
                    .device = "Device",
                    .mount_point = "MountPoint",
                    .availability_zone = "AvailabilityZone",
                    .created_at = "CreatedAt",
                    .stack_id = "StackId",
                    .volume_type = "VolumeType",
                    .iops = "Iops",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .raid_arrays = "RaidArrays",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_rds_db_instances: struct {
    action_name: []const u8 = "DescribeRdsDbInstances",
    Request: type = struct {
        stack_id: []const u8,
        rds_db_instance_arns: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .rds_db_instance_arns = "RdsDbInstanceArns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_rds_db_instances) } {
            return .{ .service_metadata = service_metadata, .action = describe_rds_db_instances };
        }
    },
    Response: type = struct {
        rds_db_instances: ?[]struct {
            rds_db_instance_arn: ?[]const u8 = null,
            db_instance_identifier: ?[]const u8 = null,
            db_user: ?[]const u8 = null,
            db_password: ?[]const u8 = null,
            region: ?[]const u8 = null,
            address: ?[]const u8 = null,
            engine: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            missing_on_rds: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .rds_db_instance_arn = "RdsDbInstanceArn",
                    .db_instance_identifier = "DbInstanceIdentifier",
                    .db_user = "DbUser",
                    .db_password = "DbPassword",
                    .region = "Region",
                    .address = "Address",
                    .engine = "Engine",
                    .stack_id = "StackId",
                    .missing_on_rds = "MissingOnRds",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rds_db_instances = "RdsDbInstances",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_service_errors: struct {
    action_name: []const u8 = "DescribeServiceErrors",
    Request: type = struct {
        stack_id: ?[]const u8 = null,
        instance_id: ?[]const u8 = null,
        service_error_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .instance_id = "InstanceId",
                .service_error_ids = "ServiceErrorIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_service_errors) } {
            return .{ .service_metadata = service_metadata, .action = describe_service_errors };
        }
    },
    Response: type = struct {
        service_errors: ?[]struct {
            service_error_id: ?[]const u8 = null,
            stack_id: ?[]const u8 = null,
            instance_id: ?[]const u8 = null,
            type: ?[]const u8 = null,
            message: ?[]const u8 = null,
            created_at: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .service_error_id = "ServiceErrorId",
                    .stack_id = "StackId",
                    .instance_id = "InstanceId",
                    .type = "Type",
                    .message = "Message",
                    .created_at = "CreatedAt",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_errors = "ServiceErrors",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_stack_provisioning_parameters: struct {
    action_name: []const u8 = "DescribeStackProvisioningParameters",
    Request: type = struct {
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_provisioning_parameters) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_provisioning_parameters };
        }
    },
    Response: type = struct {
        agent_installer_url: ?[]const u8 = null,
        parameters: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .agent_installer_url = "AgentInstallerUrl",
                .parameters = "Parameters",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "parameters", field_name))
                return try serializeMap(self.parameters, self.fieldNameFor("parameters"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_stacks: struct {
    action_name: []const u8 = "DescribeStacks",
    Request: type = struct {
        stack_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_ids = "StackIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stacks) } {
            return .{ .service_metadata = service_metadata, .action = describe_stacks };
        }
    },
    Response: type = struct {
        stacks: ?[]struct {
            stack_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            region: ?[]const u8 = null,
            vpc_id: ?[]const u8 = null,
            attributes: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,
            service_role_arn: ?[]const u8 = null,
            default_instance_profile_arn: ?[]const u8 = null,
            default_os: ?[]const u8 = null,
            hostname_theme: ?[]const u8 = null,
            default_availability_zone: ?[]const u8 = null,
            default_subnet_id: ?[]const u8 = null,
            custom_json: ?[]const u8 = null,
            configuration_manager: ?StackConfigurationManager = null,
            chef_configuration: ?ChefConfiguration = null,
            use_custom_cookbooks: ?bool = null,
            use_opsworks_security_groups: ?bool = null,
            custom_cookbooks_source: ?Source = null,
            default_ssh_key_name: ?[]const u8 = null,
            created_at: ?[]const u8 = null,
            default_root_device_type: ?[]const u8 = null,
            agent_version: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .name = "Name",
                    .arn = "Arn",
                    .region = "Region",
                    .vpc_id = "VpcId",
                    .attributes = "Attributes",
                    .service_role_arn = "ServiceRoleArn",
                    .default_instance_profile_arn = "DefaultInstanceProfileArn",
                    .default_os = "DefaultOs",
                    .hostname_theme = "HostnameTheme",
                    .default_availability_zone = "DefaultAvailabilityZone",
                    .default_subnet_id = "DefaultSubnetId",
                    .custom_json = "CustomJson",
                    .configuration_manager = "ConfigurationManager",
                    .chef_configuration = "ChefConfiguration",
                    .use_custom_cookbooks = "UseCustomCookbooks",
                    .use_opsworks_security_groups = "UseOpsworksSecurityGroups",
                    .custom_cookbooks_source = "CustomCookbooksSource",
                    .default_ssh_key_name = "DefaultSshKeyName",
                    .created_at = "CreatedAt",
                    .default_root_device_type = "DefaultRootDeviceType",
                    .agent_version = "AgentVersion",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "attributes", field_name))
                    return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stacks = "Stacks",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_stack_summary: struct {
    action_name: []const u8 = "DescribeStackSummary",
    Request: type = struct {
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_stack_summary) } {
            return .{ .service_metadata = service_metadata, .action = describe_stack_summary };
        }
    },
    Response: type = struct {
        stack_summary: ?struct {
            stack_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            layers_count: ?i64 = null,
            apps_count: ?i64 = null,
            instances_count: ?struct {
                assigning: ?i64 = null,
                booting: ?i64 = null,
                connection_lost: ?i64 = null,
                deregistering: ?i64 = null,
                online: ?i64 = null,
                pending: ?i64 = null,
                rebooting: ?i64 = null,
                registered: ?i64 = null,
                registering: ?i64 = null,
                requested: ?i64 = null,
                running_setup: ?i64 = null,
                setup_failed: ?i64 = null,
                shutting_down: ?i64 = null,
                start_failed: ?i64 = null,
                stop_failed: ?i64 = null,
                stopped: ?i64 = null,
                stopping: ?i64 = null,
                terminated: ?i64 = null,
                terminating: ?i64 = null,
                unassigning: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .assigning = "Assigning",
                        .booting = "Booting",
                        .connection_lost = "ConnectionLost",
                        .deregistering = "Deregistering",
                        .online = "Online",
                        .pending = "Pending",
                        .rebooting = "Rebooting",
                        .registered = "Registered",
                        .registering = "Registering",
                        .requested = "Requested",
                        .running_setup = "RunningSetup",
                        .setup_failed = "SetupFailed",
                        .shutting_down = "ShuttingDown",
                        .start_failed = "StartFailed",
                        .stop_failed = "StopFailed",
                        .stopped = "Stopped",
                        .stopping = "Stopping",
                        .terminated = "Terminated",
                        .terminating = "Terminating",
                        .unassigning = "Unassigning",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .stack_id = "StackId",
                    .name = "Name",
                    .arn = "Arn",
                    .layers_count = "LayersCount",
                    .apps_count = "AppsCount",
                    .instances_count = "InstancesCount",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_summary = "StackSummary",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_time_based_auto_scaling: struct {
    action_name: []const u8 = "DescribeTimeBasedAutoScaling",
    Request: type = struct {
        instance_ids: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_ids = "InstanceIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_time_based_auto_scaling) } {
            return .{ .service_metadata = service_metadata, .action = describe_time_based_auto_scaling };
        }
    },
    Response: type = struct {
        time_based_auto_scaling_configurations: ?[]struct {
            instance_id: ?[]const u8 = null,
            auto_scaling_schedule: ?WeeklyAutoScalingSchedule = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .instance_id = "InstanceId",
                    .auto_scaling_schedule = "AutoScalingSchedule",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .time_based_auto_scaling_configurations = "TimeBasedAutoScalingConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_user_profiles: struct {
    action_name: []const u8 = "DescribeUserProfiles",
    Request: type = struct {
        iam_user_arns: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arns = "IamUserArns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_user_profiles) } {
            return .{ .service_metadata = service_metadata, .action = describe_user_profiles };
        }
    },
    Response: type = struct {
        user_profiles: ?[]struct {
            iam_user_arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            ssh_username: ?[]const u8 = null,
            ssh_public_key: ?[]const u8 = null,
            allow_self_management: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .iam_user_arn = "IamUserArn",
                    .name = "Name",
                    .ssh_username = "SshUsername",
                    .ssh_public_key = "SshPublicKey",
                    .allow_self_management = "AllowSelfManagement",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .user_profiles = "UserProfiles",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const describe_volumes: struct {
    action_name: []const u8 = "DescribeVolumes",
    Request: type = struct {
        instance_id: ?[]const u8 = null,
        stack_id: ?[]const u8 = null,
        raid_array_id: ?[]const u8 = null,
        volume_ids: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .stack_id = "StackId",
                .raid_array_id = "RaidArrayId",
                .volume_ids = "VolumeIds",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_volumes) } {
            return .{ .service_metadata = service_metadata, .action = describe_volumes };
        }
    },
    Response: type = struct {
        volumes: ?[]struct {
            volume_id: ?[]const u8 = null,
            ec2_volume_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            raid_array_id: ?[]const u8 = null,
            instance_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            size: ?i64 = null,
            device: ?[]const u8 = null,
            mount_point: ?[]const u8 = null,
            region: ?[]const u8 = null,
            availability_zone: ?[]const u8 = null,
            volume_type: ?[]const u8 = null,
            iops: ?i64 = null,
            encrypted: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .volume_id = "VolumeId",
                    .ec2_volume_id = "Ec2VolumeId",
                    .name = "Name",
                    .raid_array_id = "RaidArrayId",
                    .instance_id = "InstanceId",
                    .status = "Status",
                    .size = "Size",
                    .device = "Device",
                    .mount_point = "MountPoint",
                    .region = "Region",
                    .availability_zone = "AvailabilityZone",
                    .volume_type = "VolumeType",
                    .iops = "Iops",
                    .encrypted = "Encrypted",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volumes = "Volumes",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const detach_elastic_load_balancer: struct {
    action_name: []const u8 = "DetachElasticLoadBalancer",
    Request: type = struct {
        elastic_load_balancer_name: []const u8,
        layer_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_load_balancer_name = "ElasticLoadBalancerName",
                .layer_id = "LayerId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_elastic_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = detach_elastic_load_balancer };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
    },
} = .{};
pub const disassociate_elastic_ip: struct {
    action_name: []const u8 = "DisassociateElasticIp",
    Request: type = struct {
        elastic_ip: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_elastic_ip) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_elastic_ip };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const get_hostname_suggestion: struct {
    action_name: []const u8 = "GetHostnameSuggestion",
    Request: type = struct {
        layer_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_hostname_suggestion) } {
            return .{ .service_metadata = service_metadata, .action = get_hostname_suggestion };
        }
    },
    Response: type = struct {
        layer_id: ?[]const u8 = null,
        hostname: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
                .hostname = "Hostname",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const grant_access: struct {
    action_name: []const u8 = "GrantAccess",
    Request: type = struct {
        instance_id: []const u8,
        valid_for_in_minutes: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .valid_for_in_minutes = "ValidForInMinutes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(grant_access) } {
            return .{ .service_metadata = service_metadata, .action = grant_access };
        }
    },
    Response: type = struct {
        temporary_credential: ?struct {
            username: ?[]const u8 = null,
            password: ?[]const u8 = null,
            valid_for_in_minutes: ?i64 = null,
            instance_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .username = "Username",
                    .password = "Password",
                    .valid_for_in_minutes = "ValidForInMinutes",
                    .instance_id = "InstanceId",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .temporary_credential = "TemporaryCredential",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const list_tags: struct {
    action_name: []const u8 = "ListTags",
    Request: type = struct {
        resource_arn: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags) } {
            return .{ .service_metadata = service_metadata, .action = list_tags };
        }
    },
    Response: type = struct {
        tags: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const reboot_instance: struct {
    action_name: []const u8 = "RebootInstance",
    Request: type = struct {
        instance_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reboot_instance) } {
            return .{ .service_metadata = service_metadata, .action = reboot_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const register_ecs_cluster: struct {
    action_name: []const u8 = "RegisterEcsCluster",
    Request: type = struct {
        ecs_cluster_arn: []const u8,
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ecs_cluster_arn = "EcsClusterArn",
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_ecs_cluster) } {
            return .{ .service_metadata = service_metadata, .action = register_ecs_cluster };
        }
    },
    Response: type = struct {
        ecs_cluster_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ecs_cluster_arn = "EcsClusterArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const register_elastic_ip: struct {
    action_name: []const u8 = "RegisterElasticIp",
    Request: type = struct {
        elastic_ip: []const u8,
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_elastic_ip) } {
            return .{ .service_metadata = service_metadata, .action = register_elastic_ip };
        }
    },
    Response: type = struct {
        elastic_ip: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const register_instance: struct {
    action_name: []const u8 = "RegisterInstance",
    Request: type = struct {
        stack_id: []const u8,
        hostname: ?[]const u8 = null,
        public_ip: ?[]const u8 = null,
        private_ip: ?[]const u8 = null,
        rsa_public_key: ?[]const u8 = null,
        rsa_public_key_fingerprint: ?[]const u8 = null,
        instance_identity: ?struct {
            document: ?[]const u8 = null,
            signature: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .document = "Document",
                    .signature = "Signature",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .hostname = "Hostname",
                .public_ip = "PublicIp",
                .private_ip = "PrivateIp",
                .rsa_public_key = "RsaPublicKey",
                .rsa_public_key_fingerprint = "RsaPublicKeyFingerprint",
                .instance_identity = "InstanceIdentity",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_instance) } {
            return .{ .service_metadata = service_metadata, .action = register_instance };
        }
    },
    Response: type = struct {
        instance_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const register_rds_db_instance: struct {
    action_name: []const u8 = "RegisterRdsDbInstance",
    Request: type = struct {
        stack_id: []const u8,
        rds_db_instance_arn: []const u8,
        db_user: []const u8,
        db_password: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .rds_db_instance_arn = "RdsDbInstanceArn",
                .db_user = "DbUser",
                .db_password = "DbPassword",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_rds_db_instance) } {
            return .{ .service_metadata = service_metadata, .action = register_rds_db_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const register_volume: struct {
    action_name: []const u8 = "RegisterVolume",
    Request: type = struct {
        ec2_volume_id: ?[]const u8 = null,
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ec2_volume_id = "Ec2VolumeId",
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_volume) } {
            return .{ .service_metadata = service_metadata, .action = register_volume };
        }
    },
    Response: type = struct {
        volume_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volume_id = "VolumeId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const set_load_based_auto_scaling: struct {
    action_name: []const u8 = "SetLoadBasedAutoScaling",
    Request: type = struct {
        layer_id: []const u8,
        enable: ?bool = null,
        up_scaling: ?AutoScalingThresholds = null,
        down_scaling: ?AutoScalingThresholds = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
                .enable = "Enable",
                .up_scaling = "UpScaling",
                .down_scaling = "DownScaling",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_load_based_auto_scaling) } {
            return .{ .service_metadata = service_metadata, .action = set_load_based_auto_scaling };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const set_permission: struct {
    action_name: []const u8 = "SetPermission",
    Request: type = struct {
        stack_id: []const u8,
        iam_user_arn: []const u8,
        allow_ssh: ?bool = null,
        allow_sudo: ?bool = null,
        level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .iam_user_arn = "IamUserArn",
                .allow_ssh = "AllowSsh",
                .allow_sudo = "AllowSudo",
                .level = "Level",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_permission) } {
            return .{ .service_metadata = service_metadata, .action = set_permission };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const set_time_based_auto_scaling: struct {
    action_name: []const u8 = "SetTimeBasedAutoScaling",
    Request: type = struct {
        instance_id: []const u8,
        auto_scaling_schedule: ?WeeklyAutoScalingSchedule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .auto_scaling_schedule = "AutoScalingSchedule",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_time_based_auto_scaling) } {
            return .{ .service_metadata = service_metadata, .action = set_time_based_auto_scaling };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const start_instance: struct {
    action_name: []const u8 = "StartInstance",
    Request: type = struct {
        instance_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_instance) } {
            return .{ .service_metadata = service_metadata, .action = start_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const start_stack: struct {
    action_name: []const u8 = "StartStack",
    Request: type = struct {
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_stack) } {
            return .{ .service_metadata = service_metadata, .action = start_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const stop_instance: struct {
    action_name: []const u8 = "StopInstance",
    Request: type = struct {
        instance_id: []const u8,
        force: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .force = "Force",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_instance) } {
            return .{ .service_metadata = service_metadata, .action = stop_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const stop_stack: struct {
    action_name: []const u8 = "StopStack",
    Request: type = struct {
        stack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_stack) } {
            return .{ .service_metadata = service_metadata, .action = stop_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const unassign_instance: struct {
    action_name: []const u8 = "UnassignInstance",
    Request: type = struct {
        instance_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(unassign_instance) } {
            return .{ .service_metadata = service_metadata, .action = unassign_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const unassign_volume: struct {
    action_name: []const u8 = "UnassignVolume",
    Request: type = struct {
        volume_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volume_id = "VolumeId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(unassign_volume) } {
            return .{ .service_metadata = service_metadata, .action = unassign_volume };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_app: struct {
    action_name: []const u8 = "UpdateApp",
    Request: type = struct {
        app_id: []const u8,
        name: ?[]const u8 = null,
        description: ?[]const u8 = null,
        data_sources: ?[]DataSource = null,
        type: ?[]const u8 = null,
        app_source: ?Source = null,
        domains: ?[][]const u8 = null,
        enable_ssl: ?bool = null,
        ssl_configuration: ?SslConfiguration = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        environment: ?[]EnvironmentVariable = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .app_id = "AppId",
                .name = "Name",
                .description = "Description",
                .data_sources = "DataSources",
                .type = "Type",
                .app_source = "AppSource",
                .domains = "Domains",
                .enable_ssl = "EnableSsl",
                .ssl_configuration = "SslConfiguration",
                .attributes = "Attributes",
                .environment = "Environment",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_app) } {
            return .{ .service_metadata = service_metadata, .action = update_app };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_elastic_ip: struct {
    action_name: []const u8 = "UpdateElasticIp",
    Request: type = struct {
        elastic_ip: []const u8,
        name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .elastic_ip = "ElasticIp",
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_elastic_ip) } {
            return .{ .service_metadata = service_metadata, .action = update_elastic_ip };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_instance: struct {
    action_name: []const u8 = "UpdateInstance",
    Request: type = struct {
        instance_id: []const u8,
        layer_ids: ?[][]const u8 = null,
        instance_type: ?[]const u8 = null,
        auto_scaling_type: ?[]const u8 = null,
        hostname: ?[]const u8 = null,
        os: ?[]const u8 = null,
        ami_id: ?[]const u8 = null,
        ssh_key_name: ?[]const u8 = null,
        architecture: ?[]const u8 = null,
        install_updates_on_boot: ?bool = null,
        ebs_optimized: ?bool = null,
        agent_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_id = "InstanceId",
                .layer_ids = "LayerIds",
                .instance_type = "InstanceType",
                .auto_scaling_type = "AutoScalingType",
                .hostname = "Hostname",
                .os = "Os",
                .ami_id = "AmiId",
                .ssh_key_name = "SshKeyName",
                .architecture = "Architecture",
                .install_updates_on_boot = "InstallUpdatesOnBoot",
                .ebs_optimized = "EbsOptimized",
                .agent_version = "AgentVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_instance) } {
            return .{ .service_metadata = service_metadata, .action = update_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_layer: struct {
    action_name: []const u8 = "UpdateLayer",
    Request: type = struct {
        layer_id: []const u8,
        name: ?[]const u8 = null,
        shortname: ?[]const u8 = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        cloud_watch_logs_configuration: ?CloudWatchLogsConfiguration = null,
        custom_instance_profile_arn: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,
        custom_security_group_ids: ?[][]const u8 = null,
        packages: ?[][]const u8 = null,
        volume_configurations: ?[]VolumeConfiguration = null,
        enable_auto_healing: ?bool = null,
        auto_assign_elastic_ips: ?bool = null,
        auto_assign_public_ips: ?bool = null,
        custom_recipes: ?Recipes = null,
        install_updates_on_boot: ?bool = null,
        use_ebs_optimized_instances: ?bool = null,
        lifecycle_event_configuration: ?LifecycleEventConfiguration = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .layer_id = "LayerId",
                .name = "Name",
                .shortname = "Shortname",
                .attributes = "Attributes",
                .cloud_watch_logs_configuration = "CloudWatchLogsConfiguration",
                .custom_instance_profile_arn = "CustomInstanceProfileArn",
                .custom_json = "CustomJson",
                .custom_security_group_ids = "CustomSecurityGroupIds",
                .packages = "Packages",
                .volume_configurations = "VolumeConfigurations",
                .enable_auto_healing = "EnableAutoHealing",
                .auto_assign_elastic_ips = "AutoAssignElasticIps",
                .auto_assign_public_ips = "AutoAssignPublicIps",
                .custom_recipes = "CustomRecipes",
                .install_updates_on_boot = "InstallUpdatesOnBoot",
                .use_ebs_optimized_instances = "UseEbsOptimizedInstances",
                .lifecycle_event_configuration = "LifecycleEventConfiguration",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_layer) } {
            return .{ .service_metadata = service_metadata, .action = update_layer };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_my_user_profile: struct {
    action_name: []const u8 = "UpdateMyUserProfile",
    Request: type = struct {
        ssh_public_key: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .ssh_public_key = "SshPublicKey",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_my_user_profile) } {
            return .{ .service_metadata = service_metadata, .action = update_my_user_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        Validation,
    },
} = .{};
pub const update_rds_db_instance: struct {
    action_name: []const u8 = "UpdateRdsDbInstance",
    Request: type = struct {
        rds_db_instance_arn: []const u8,
        db_user: ?[]const u8 = null,
        db_password: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .rds_db_instance_arn = "RdsDbInstanceArn",
                .db_user = "DbUser",
                .db_password = "DbPassword",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_rds_db_instance) } {
            return .{ .service_metadata = service_metadata, .action = update_rds_db_instance };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_stack: struct {
    action_name: []const u8 = "UpdateStack",
    Request: type = struct {
        stack_id: []const u8,
        name: ?[]const u8 = null,
        attributes: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,
        service_role_arn: ?[]const u8 = null,
        default_instance_profile_arn: ?[]const u8 = null,
        default_os: ?[]const u8 = null,
        hostname_theme: ?[]const u8 = null,
        default_availability_zone: ?[]const u8 = null,
        default_subnet_id: ?[]const u8 = null,
        custom_json: ?[]const u8 = null,
        configuration_manager: ?StackConfigurationManager = null,
        chef_configuration: ?ChefConfiguration = null,
        use_custom_cookbooks: ?bool = null,
        custom_cookbooks_source: ?Source = null,
        default_ssh_key_name: ?[]const u8 = null,
        default_root_device_type: ?[]const u8 = null,
        use_opsworks_security_groups: ?bool = null,
        agent_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .stack_id = "StackId",
                .name = "Name",
                .attributes = "Attributes",
                .service_role_arn = "ServiceRoleArn",
                .default_instance_profile_arn = "DefaultInstanceProfileArn",
                .default_os = "DefaultOs",
                .hostname_theme = "HostnameTheme",
                .default_availability_zone = "DefaultAvailabilityZone",
                .default_subnet_id = "DefaultSubnetId",
                .custom_json = "CustomJson",
                .configuration_manager = "ConfigurationManager",
                .chef_configuration = "ChefConfiguration",
                .use_custom_cookbooks = "UseCustomCookbooks",
                .custom_cookbooks_source = "CustomCookbooksSource",
                .default_ssh_key_name = "DefaultSshKeyName",
                .default_root_device_type = "DefaultRootDeviceType",
                .use_opsworks_security_groups = "UseOpsworksSecurityGroups",
                .agent_version = "AgentVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attributes", field_name))
                return try serializeMap(self.attributes, self.fieldNameFor("attributes"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_stack) } {
            return .{ .service_metadata = service_metadata, .action = update_stack };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_user_profile: struct {
    action_name: []const u8 = "UpdateUserProfile",
    Request: type = struct {
        iam_user_arn: []const u8,
        ssh_username: ?[]const u8 = null,
        ssh_public_key: ?[]const u8 = null,
        allow_self_management: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .iam_user_arn = "IamUserArn",
                .ssh_username = "SshUsername",
                .ssh_public_key = "SshPublicKey",
                .allow_self_management = "AllowSelfManagement",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_user_profile) } {
            return .{ .service_metadata = service_metadata, .action = update_user_profile };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_volume: struct {
    action_name: []const u8 = "UpdateVolume",
    Request: type = struct {
        volume_id: []const u8,
        name: ?[]const u8 = null,
        mount_point: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .volume_id = "VolumeId",
                .name = "Name",
                .mount_point = "MountPoint",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_volume) } {
            return .{ .service_metadata = service_metadata, .action = update_volume };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
        Validation,
    },
} = .{};

pub const Source = struct {
    type: ?[]const u8 = null,
    url: ?[]const u8 = null,
    username: ?[]const u8 = null,
    password: ?[]const u8 = null,
    ssh_key: ?[]const u8 = null,
    revision: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .url = "Url",
            .username = "Username",
            .password = "Password",
            .ssh_key = "SshKey",
            .revision = "Revision",
        };
        return @field(mappings, field_name);
    }
};

pub const ChefConfiguration = struct {
    manage_berkshelf: ?bool = null,
    berkshelf_version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .manage_berkshelf = "ManageBerkshelf",
            .berkshelf_version = "BerkshelfVersion",
        };
        return @field(mappings, field_name);
    }
};

pub const StackConfigurationManager = struct {
    name: ?[]const u8 = null,
    version: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .version = "Version",
        };
        return @field(mappings, field_name);
    }
};

pub const LifecycleEventConfiguration = struct {
    shutdown: ?ShutdownEventConfiguration = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .shutdown = "Shutdown",
        };
        return @field(mappings, field_name);
    }
};

pub const ShutdownEventConfiguration = struct {
    execution_timeout: ?i64 = null,
    delay_until_elb_connections_drained: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .execution_timeout = "ExecutionTimeout",
            .delay_until_elb_connections_drained = "DelayUntilElbConnectionsDrained",
        };
        return @field(mappings, field_name);
    }
};

pub const Recipes = struct {
    setup: ?[][]const u8 = null,
    configure: ?[][]const u8 = null,
    deploy: ?[][]const u8 = null,
    undeploy: ?[][]const u8 = null,
    shutdown: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .setup = "Setup",
            .configure = "Configure",
            .deploy = "Deploy",
            .undeploy = "Undeploy",
            .shutdown = "Shutdown",
        };
        return @field(mappings, field_name);
    }
};

pub const VolumeConfiguration = struct {
    mount_point: []const u8,
    raid_level: ?i64 = null,
    number_of_disks: i64,
    size: i64,
    volume_type: ?[]const u8 = null,
    iops: ?i64 = null,
    encrypted: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .mount_point = "MountPoint",
            .raid_level = "RaidLevel",
            .number_of_disks = "NumberOfDisks",
            .size = "Size",
            .volume_type = "VolumeType",
            .iops = "Iops",
            .encrypted = "Encrypted",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLogsConfiguration = struct {
    enabled: ?bool = null,
    log_streams: ?[]CloudWatchLogsLogStream = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "Enabled",
            .log_streams = "LogStreams",
        };
        return @field(mappings, field_name);
    }
};

pub const CloudWatchLogsLogStream = struct {
    log_group_name: ?[]const u8 = null,
    datetime_format: ?[]const u8 = null,
    time_zone: ?[]const u8 = null,
    file: ?[]const u8 = null,
    file_fingerprint_lines: ?[]const u8 = null,
    multi_line_start_pattern: ?[]const u8 = null,
    initial_position: ?[]const u8 = null,
    encoding: ?[]const u8 = null,
    buffer_duration: ?i64 = null,
    batch_count: ?i64 = null,
    batch_size: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .log_group_name = "LogGroupName",
            .datetime_format = "DatetimeFormat",
            .time_zone = "TimeZone",
            .file = "File",
            .file_fingerprint_lines = "FileFingerprintLines",
            .multi_line_start_pattern = "MultiLineStartPattern",
            .initial_position = "InitialPosition",
            .encoding = "Encoding",
            .buffer_duration = "BufferDuration",
            .batch_count = "BatchCount",
            .batch_size = "BatchSize",
        };
        return @field(mappings, field_name);
    }
};

pub const EnvironmentVariable = struct {
    key: []const u8,
    value: []const u8,
    secure: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
            .secure = "Secure",
        };
        return @field(mappings, field_name);
    }
};

pub const SslConfiguration = struct {
    certificate: []const u8,
    private_key: []const u8,
    chain: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .certificate = "Certificate",
            .private_key = "PrivateKey",
            .chain = "Chain",
        };
        return @field(mappings, field_name);
    }
};

pub const DataSource = struct {
    type: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    database_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .arn = "Arn",
            .database_name = "DatabaseName",
        };
        return @field(mappings, field_name);
    }
};

pub const WeeklyAutoScalingSchedule = struct {
    monday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    tuesday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    wednesday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    thursday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    friday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    saturday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    sunday: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .monday = "Monday",
            .tuesday = "Tuesday",
            .wednesday = "Wednesday",
            .thursday = "Thursday",
            .friday = "Friday",
            .saturday = "Saturday",
            .sunday = "Sunday",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "monday", field_name))
            return try serializeMap(self.monday, self.fieldNameFor("monday"), options, out_stream);
        if (std.mem.eql(u8, "tuesday", field_name))
            return try serializeMap(self.tuesday, self.fieldNameFor("tuesday"), options, out_stream);
        if (std.mem.eql(u8, "wednesday", field_name))
            return try serializeMap(self.wednesday, self.fieldNameFor("wednesday"), options, out_stream);
        if (std.mem.eql(u8, "thursday", field_name))
            return try serializeMap(self.thursday, self.fieldNameFor("thursday"), options, out_stream);
        if (std.mem.eql(u8, "friday", field_name))
            return try serializeMap(self.friday, self.fieldNameFor("friday"), options, out_stream);
        if (std.mem.eql(u8, "saturday", field_name))
            return try serializeMap(self.saturday, self.fieldNameFor("saturday"), options, out_stream);
        if (std.mem.eql(u8, "sunday", field_name))
            return try serializeMap(self.sunday, self.fieldNameFor("sunday"), options, out_stream);
        return false;
    }
};

pub const AutoScalingThresholds = struct {
    instance_count: ?i64 = null,
    thresholds_wait_time: ?i64 = null,
    ignore_metrics_time: ?i64 = null,
    cpu_threshold: ?f64 = null,
    memory_threshold: ?f64 = null,
    load_threshold: ?f64 = null,
    alarms: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .instance_count = "InstanceCount",
            .thresholds_wait_time = "ThresholdsWaitTime",
            .ignore_metrics_time = "IgnoreMetricsTime",
            .cpu_threshold = "CpuThreshold",
            .memory_threshold = "MemoryThreshold",
            .load_threshold = "LoadThreshold",
            .alarms = "Alarms",
        };
        return @field(mappings, field_name);
    }
};

pub const BlockDeviceMapping = struct {
    device_name: ?[]const u8 = null,
    no_device: ?[]const u8 = null,
    virtual_name: ?[]const u8 = null,
    ebs: ?EbsBlockDevice = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .device_name = "DeviceName",
            .no_device = "NoDevice",
            .virtual_name = "VirtualName",
            .ebs = "Ebs",
        };
        return @field(mappings, field_name);
    }
};

pub const EbsBlockDevice = struct {
    snapshot_id: ?[]const u8 = null,
    iops: ?i64 = null,
    volume_size: ?i64 = null,
    volume_type: ?[]const u8 = null,
    delete_on_termination: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .snapshot_id = "SnapshotId",
            .iops = "Iops",
            .volume_size = "VolumeSize",
            .volume_type = "VolumeType",
            .delete_on_termination = "DeleteOnTermination",
        };
        return @field(mappings, field_name);
    }
};

pub const DeploymentCommand = struct {
    name: []const u8,
    args: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .args = "Args",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "args", field_name))
            return try serializeMap(self.args, self.fieldNameFor("args"), options, out_stream);
        return false;
    }
};
