const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-01-26";
pub const sdk_id: []const u8 = "Resource Groups Tagging API";
pub const arn_namespace: ?[]const u8 = "tagging";
pub const endpoint_prefix: []const u8 = "tagging";
pub const sigv4_name: []const u8 = "tagging";
pub const name: []const u8 = "ResourceGroupsTaggingAPI_20170126";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-01-26",
    sdk_id: []const u8 = "Resource Groups Tagging API",
    arn_namespace: ?[]const u8 = "tagging",
    endpoint_prefix: []const u8 = "tagging",
    sigv4_name: []const u8 = "tagging",
    name: []const u8 = "ResourceGroupsTaggingAPI_20170126",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const describe_report_creation: struct {
    action_name: []const u8 = "DescribeReportCreation",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_report_creation) } {
            return .{ .service_metadata = service_metadata, .action = describe_report_creation };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,
        s3_location: ?[]const u8 = null,
        start_date: ?[]const u8 = null,
        error_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "Status",
                .s3_location = "S3Location",
                .start_date = "StartDate",
                .error_message = "ErrorMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConstraintViolation,
        InternalService,
        InvalidParameter,
        Throttled,
    },
} = .{};
pub const get_compliance_summary: struct {
    action_name: []const u8 = "GetComplianceSummary",
    Request: type = struct {
        target_id_filters: ?[][]const u8 = null,
        region_filters: ?[][]const u8 = null,
        resource_type_filters: ?[][]const u8 = null,
        tag_key_filters: ?[][]const u8 = null,
        group_by: ?[][]const u8 = null,
        max_results: ?i64 = null,
        pagination_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .target_id_filters = "TargetIdFilters",
                .region_filters = "RegionFilters",
                .resource_type_filters = "ResourceTypeFilters",
                .tag_key_filters = "TagKeyFilters",
                .group_by = "GroupBy",
                .max_results = "MaxResults",
                .pagination_token = "PaginationToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_compliance_summary) } {
            return .{ .service_metadata = service_metadata, .action = get_compliance_summary };
        }
    },
    Response: type = struct {
        summary_list: ?[]struct {
            last_updated: ?[]const u8 = null,
            target_id: ?[]const u8 = null,
            target_id_type: ?[]const u8 = null,
            region: ?[]const u8 = null,
            resource_type: ?[]const u8 = null,
            non_compliant_resources: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .last_updated = "LastUpdated",
                    .target_id = "TargetId",
                    .target_id_type = "TargetIdType",
                    .region = "Region",
                    .resource_type = "ResourceType",
                    .non_compliant_resources = "NonCompliantResources",
                };
                return @field(mappings, field_name);
            }
        } = null,
        pagination_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .summary_list = "SummaryList",
                .pagination_token = "PaginationToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConstraintViolation,
        InternalService,
        InvalidParameter,
        Throttled,
    },
} = .{};
pub const get_resources: struct {
    action_name: []const u8 = "GetResources",
    Request: type = struct {
        pagination_token: ?[]const u8 = null,
        tag_filters: ?[]struct {
            key: ?[]const u8 = null,
            values: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .key = "Key",
                    .values = "Values",
                };
                return @field(mappings, field_name);
            }
        } = null,
        resources_per_page: ?i64 = null,
        tags_per_page: ?i64 = null,
        resource_type_filters: ?[][]const u8 = null,
        include_compliance_details: ?bool = null,
        exclude_compliant_resources: ?bool = null,
        resource_arn_list: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
                .tag_filters = "TagFilters",
                .resources_per_page = "ResourcesPerPage",
                .tags_per_page = "TagsPerPage",
                .resource_type_filters = "ResourceTypeFilters",
                .include_compliance_details = "IncludeComplianceDetails",
                .exclude_compliant_resources = "ExcludeCompliantResources",
                .resource_arn_list = "ResourceARNList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resources) } {
            return .{ .service_metadata = service_metadata, .action = get_resources };
        }
    },
    Response: type = struct {
        pagination_token: ?[]const u8 = null,
        resource_tag_mapping_list: ?[]struct {
            resource_arn: ?[]const u8 = null,
            tags: ?[]struct {
                key: []const u8,
                value: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .key = "Key",
                        .value = "Value",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            compliance_details: ?struct {
                noncompliant_keys: ?[][]const u8 = null,
                keys_with_noncompliant_values: ?[][]const u8 = null,
                compliance_status: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .noncompliant_keys = "NoncompliantKeys",
                        .keys_with_noncompliant_values = "KeysWithNoncompliantValues",
                        .compliance_status = "ComplianceStatus",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_arn = "ResourceARN",
                    .tags = "Tags",
                    .compliance_details = "ComplianceDetails",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
                .resource_tag_mapping_list = "ResourceTagMappingList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameter,
        PaginationTokenExpired,
        Throttled,
    },
} = .{};
pub const get_tag_keys: struct {
    action_name: []const u8 = "GetTagKeys",
    Request: type = struct {
        pagination_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_tag_keys) } {
            return .{ .service_metadata = service_metadata, .action = get_tag_keys };
        }
    },
    Response: type = struct {
        pagination_token: ?[]const u8 = null,
        tag_keys: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameter,
        PaginationTokenExpired,
        Throttled,
    },
} = .{};
pub const get_tag_values: struct {
    action_name: []const u8 = "GetTagValues",
    Request: type = struct {
        pagination_token: ?[]const u8 = null,
        key: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
                .key = "Key",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_tag_values) } {
            return .{ .service_metadata = service_metadata, .action = get_tag_values };
        }
    },
    Response: type = struct {
        pagination_token: ?[]const u8 = null,
        tag_values: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pagination_token = "PaginationToken",
                .tag_values = "TagValues",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameter,
        PaginationTokenExpired,
        Throttled,
    },
} = .{};
pub const start_report_creation: struct {
    action_name: []const u8 = "StartReportCreation",
    Request: type = struct {
        s3_bucket: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .s3_bucket = "S3Bucket",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_report_creation) } {
            return .{ .service_metadata = service_metadata, .action = start_report_creation };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        ConstraintViolation,
        InternalService,
        InvalidParameter,
        Throttled,
    },
} = .{};
pub const tag_resources: struct {
    action_name: []const u8 = "TagResources",
    Request: type = struct {
        resource_arn_list: [][]const u8,
        tags: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn_list = "ResourceARNList",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resources) } {
            return .{ .service_metadata = service_metadata, .action = tag_resources };
        }
    },
    Response: type = struct {
        failed_resources_map: ?[]struct {
            key: ?[]const u8 = null,
            value: ?FailureInfo = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failed_resources_map = "FailedResourcesMap",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "failed_resources_map", field_name))
                return try serializeMap(self.failed_resources_map, self.fieldNameFor("failed_resources_map"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameter,
        Throttled,
    },
} = .{};
pub const untag_resources: struct {
    action_name: []const u8 = "UntagResources",
    Request: type = struct {
        resource_arn_list: [][]const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn_list = "ResourceARNList",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resources) } {
            return .{ .service_metadata = service_metadata, .action = untag_resources };
        }
    },
    Response: type = struct {
        failed_resources_map: ?[]struct {
            key: ?[]const u8 = null,
            value: ?FailureInfo = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .failed_resources_map = "FailedResourcesMap",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "failed_resources_map", field_name))
                return try serializeMap(self.failed_resources_map, self.fieldNameFor("failed_resources_map"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        InternalService,
        InvalidParameter,
        Throttled,
    },
} = .{};

pub const FailureInfo = struct {
    status_code: ?i64 = null,
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status_code = "StatusCode",
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};
