const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-05-10";
pub const sdk_id: []const u8 = "RolesAnywhere";
pub const arn_namespace: ?[]const u8 = "rolesanywhere";
pub const endpoint_prefix: []const u8 = "";
pub const sigv4_name: []const u8 = "rolesanywhere";
pub const name: []const u8 = "RolesAnywhere";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-05-10",
    sdk_id: []const u8 = "RolesAnywhere",
    arn_namespace: ?[]const u8 = "rolesanywhere",
    endpoint_prefix: []const u8 = "",
    sigv4_name: []const u8 = "rolesanywhere",
    name: []const u8 = "RolesAnywhere",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const list_tags_for_resource: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ListTagsForResource",
        .success_code = 200,
    };

    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub const http_query = .{
            .resource_arn = "resourceArn",
        };

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const put_notification_settings: struct {
    pub const http_config = .{
        .method = "PATCH",
        .uri = "/put-notifications-settings",
        .success_code = 200,
    };

    action_name: []const u8 = "PutNotificationSettings",
    Request: type = struct {
        trust_anchor_id: []const u8,
        notification_settings: []struct {
            enabled: bool,
            event: []const u8,
            threshold: ?i64 = null,
            channel: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .enabled = "enabled",
                    .event = "event",
                    .threshold = "threshold",
                    .channel = "channel",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .trust_anchor_id = "trustAnchorId",
                .notification_settings = "notificationSettings",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_notification_settings) } {
            return .{ .service_metadata = service_metadata, .action = put_notification_settings };
        }
    },
    Response: type = struct {
        trust_anchor: TrustAnchorDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .trust_anchor = "trustAnchor",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const reset_notification_settings: struct {
    pub const http_config = .{
        .method = "PATCH",
        .uri = "/reset-notifications-settings",
        .success_code = 200,
    };

    action_name: []const u8 = "ResetNotificationSettings",
    Request: type = struct {
        trust_anchor_id: []const u8,
        notification_setting_keys: []struct {
            event: []const u8,
            channel: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .event = "event",
                    .channel = "channel",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .trust_anchor_id = "trustAnchorId",
                .notification_setting_keys = "notificationSettingKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reset_notification_settings) } {
            return .{ .service_metadata = service_metadata, .action = reset_notification_settings };
        }
    },
    Response: type = struct {
        trust_anchor: TrustAnchorDetail,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .trust_anchor = "trustAnchor",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const tag_resource: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/TagResource",
        .success_code = 201,
    };

    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        TooManyTags,
        Validation,
    },
} = .{};
pub const untag_resource: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/UntagResource",
        .success_code = 200,
    };

    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "resourceArn",
                .tag_keys = "tagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        ResourceNotFound,
        Validation,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "key",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const TrustAnchorDetail = struct {
    trust_anchor_id: ?[]const u8 = null,
    trust_anchor_arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    source: ?Source = null,
    enabled: ?bool = null,
    created_at: ?i64 = null,
    updated_at: ?i64 = null,
    notification_settings: ?[]NotificationSettingDetail = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .trust_anchor_id = "trustAnchorId",
            .trust_anchor_arn = "trustAnchorArn",
            .name = "name",
            .source = "source",
            .enabled = "enabled",
            .created_at = "createdAt",
            .updated_at = "updatedAt",
            .notification_settings = "notificationSettings",
        };
        return @field(mappings, field_name);
    }
};

pub const NotificationSettingDetail = struct {
    enabled: bool,
    event: []const u8,
    threshold: ?i64 = null,
    channel: ?[]const u8 = null,
    configured_by: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "enabled",
            .event = "event",
            .threshold = "threshold",
            .channel = "channel",
            .configured_by = "configuredBy",
        };
        return @field(mappings, field_name);
    }
};

pub const Source = struct {
    source_type: ?[]const u8 = null,
    source_data: ?SourceData = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .source_type = "sourceType",
            .source_data = "sourceData",
        };
        return @field(mappings, field_name);
    }
};

pub const SourceData = union {
    x509_certificate_data: ?[]const u8,
    acm_pca_arn: ?[]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .x509_certificate_data = "x509CertificateData",
            .acm_pca_arn = "acmPcaArn",
        };
        return @field(mappings, field_name);
    }
};
