const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-04-01";
pub const sdk_id: []const u8 = "Route53Resolver";
pub const arn_namespace: ?[]const u8 = "route53resolver";
pub const endpoint_prefix: []const u8 = "route53resolver";
pub const sigv4_name: []const u8 = "route53resolver";
pub const name: []const u8 = "Route53Resolver";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-04-01",
    sdk_id: []const u8 = "Route53Resolver",
    arn_namespace: ?[]const u8 = "route53resolver",
    endpoint_prefix: []const u8 = "route53resolver",
    sigv4_name: []const u8 = "route53resolver",
    name: []const u8 = "Route53Resolver",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_firewall_rule_group: struct {
    action_name: []const u8 = "AssociateFirewallRuleGroup",
    Request: type = struct {
        creator_request_id: []const u8,
        firewall_rule_group_id: []const u8,
        vpc_id: []const u8,
        priority: i64,
        name: []const u8,
        mutation_protection: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .vpc_id = "VpcId",
                .priority = "Priority",
                .name = "Name",
                .mutation_protection = "MutationProtection",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_firewall_rule_group) } {
            return .{ .service_metadata = service_metadata, .action = associate_firewall_rule_group };
        }
    },
    Response: type = struct {
        firewall_rule_group_association: ?FirewallRuleGroupAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association = "FirewallRuleGroupAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        LimitExceeded,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const associate_resolver_endpoint_ip_address: struct {
    action_name: []const u8 = "AssociateResolverEndpointIpAddress",
    Request: type = struct {
        resolver_endpoint_id: []const u8,
        ip_address: IpAddressUpdate,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
                .ip_address = "IpAddress",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_resolver_endpoint_ip_address) } {
            return .{ .service_metadata = service_metadata, .action = associate_resolver_endpoint_ip_address };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const associate_resolver_query_log_config: struct {
    action_name: []const u8 = "AssociateResolverQueryLogConfig",
    Request: type = struct {
        resolver_query_log_config_id: []const u8,
        resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_id = "ResolverQueryLogConfigId",
                .resource_id = "ResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_resolver_query_log_config) } {
            return .{ .service_metadata = service_metadata, .action = associate_resolver_query_log_config };
        }
    },
    Response: type = struct {
        resolver_query_log_config_association: ?ResolverQueryLogConfigAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_association = "ResolverQueryLogConfigAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const associate_resolver_rule: struct {
    action_name: []const u8 = "AssociateResolverRule",
    Request: type = struct {
        resolver_rule_id: []const u8,
        name: ?[]const u8 = null,
        vpc_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_id = "ResolverRuleId",
                .name = "Name",
                .vpc_id = "VPCId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = associate_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule_association: ?ResolverRuleAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_association = "ResolverRuleAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        ResourceUnavailable,
        Throttling,
    },
} = .{};
pub const create_firewall_domain_list: struct {
    action_name: []const u8 = "CreateFirewallDomainList",
    Request: type = struct {
        creator_request_id: []const u8,
        name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .name = "Name",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_firewall_domain_list) } {
            return .{ .service_metadata = service_metadata, .action = create_firewall_domain_list };
        }
    },
    Response: type = struct {
        firewall_domain_list: ?FirewallDomainList = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list = "FirewallDomainList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        LimitExceeded,
        Throttling,
        Validation,
    },
} = .{};
pub const create_firewall_rule: struct {
    action_name: []const u8 = "CreateFirewallRule",
    Request: type = struct {
        creator_request_id: []const u8,
        firewall_rule_group_id: []const u8,
        firewall_domain_list_id: []const u8,
        priority: i64,
        action: []const u8,
        block_response: ?[]const u8 = null,
        block_override_domain: ?[]const u8 = null,
        block_override_dns_type: ?[]const u8 = null,
        block_override_ttl: ?i64 = null,
        name: []const u8,
        qtype: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .firewall_domain_list_id = "FirewallDomainListId",
                .priority = "Priority",
                .action = "Action",
                .block_response = "BlockResponse",
                .block_override_domain = "BlockOverrideDomain",
                .block_override_dns_type = "BlockOverrideDnsType",
                .block_override_ttl = "BlockOverrideTtl",
                .name = "Name",
                .qtype = "Qtype",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_firewall_rule) } {
            return .{ .service_metadata = service_metadata, .action = create_firewall_rule };
        }
    },
    Response: type = struct {
        firewall_rule: ?FirewallRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule = "FirewallRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        LimitExceeded,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const create_firewall_rule_group: struct {
    action_name: []const u8 = "CreateFirewallRuleGroup",
    Request: type = struct {
        creator_request_id: []const u8,
        name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .name = "Name",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_firewall_rule_group) } {
            return .{ .service_metadata = service_metadata, .action = create_firewall_rule_group };
        }
    },
    Response: type = struct {
        firewall_rule_group: ?FirewallRuleGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group = "FirewallRuleGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        LimitExceeded,
        Throttling,
        Validation,
    },
} = .{};
pub const create_outpost_resolver: struct {
    action_name: []const u8 = "CreateOutpostResolver",
    Request: type = struct {
        creator_request_id: []const u8,
        name: []const u8,
        instance_count: ?i64 = null,
        preferred_instance_type: []const u8,
        outpost_arn: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .name = "Name",
                .instance_count = "InstanceCount",
                .preferred_instance_type = "PreferredInstanceType",
                .outpost_arn = "OutpostArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_outpost_resolver) } {
            return .{ .service_metadata = service_metadata, .action = create_outpost_resolver };
        }
    },
    Response: type = struct {
        outpost_resolver: ?OutpostResolver = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_resolver = "OutpostResolver",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        ServiceQuotaExceeded,
        Throttling,
        Validation,
    },
} = .{};
pub const create_resolver_endpoint: struct {
    action_name: []const u8 = "CreateResolverEndpoint",
    Request: type = struct {
        creator_request_id: []const u8,
        name: ?[]const u8 = null,
        security_group_ids: [][]const u8,
        direction: []const u8,
        ip_addresses: []struct {
            subnet_id: []const u8,
            ip: ?[]const u8 = null,
            ipv6: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .subnet_id = "SubnetId",
                    .ip = "Ip",
                    .ipv6 = "Ipv6",
                };
                return @field(mappings, field_name);
            }
        },
        outpost_arn: ?[]const u8 = null,
        preferred_instance_type: ?[]const u8 = null,
        tags: ?[]Tag = null,
        resolver_endpoint_type: ?[]const u8 = null,
        protocols: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .name = "Name",
                .security_group_ids = "SecurityGroupIds",
                .direction = "Direction",
                .ip_addresses = "IpAddresses",
                .outpost_arn = "OutpostArn",
                .preferred_instance_type = "PreferredInstanceType",
                .tags = "Tags",
                .resolver_endpoint_type = "ResolverEndpointType",
                .protocols = "Protocols",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_resolver_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = create_resolver_endpoint };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const create_resolver_query_log_config: struct {
    action_name: []const u8 = "CreateResolverQueryLogConfig",
    Request: type = struct {
        name: []const u8,
        destination_arn: []const u8,
        creator_request_id: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .destination_arn = "DestinationArn",
                .creator_request_id = "CreatorRequestId",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_resolver_query_log_config) } {
            return .{ .service_metadata = service_metadata, .action = create_resolver_query_log_config };
        }
    },
    Response: type = struct {
        resolver_query_log_config: ?ResolverQueryLogConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config = "ResolverQueryLogConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const create_resolver_rule: struct {
    action_name: []const u8 = "CreateResolverRule",
    Request: type = struct {
        creator_request_id: []const u8,
        name: ?[]const u8 = null,
        rule_type: []const u8,
        domain_name: ?[]const u8 = null,
        target_ips: ?[]TargetAddress = null,
        resolver_endpoint_id: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .creator_request_id = "CreatorRequestId",
                .name = "Name",
                .rule_type = "RuleType",
                .domain_name = "DomainName",
                .target_ips = "TargetIps",
                .resolver_endpoint_id = "ResolverEndpointId",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = create_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule: ?ResolverRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule = "ResolverRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceExists,
        ResourceNotFound,
        ResourceUnavailable,
        Throttling,
    },
} = .{};
pub const delete_firewall_domain_list: struct {
    action_name: []const u8 = "DeleteFirewallDomainList",
    Request: type = struct {
        firewall_domain_list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list_id = "FirewallDomainListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_firewall_domain_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_firewall_domain_list };
        }
    },
    Response: type = struct {
        firewall_domain_list: ?FirewallDomainList = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list = "FirewallDomainList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const delete_firewall_rule: struct {
    action_name: []const u8 = "DeleteFirewallRule",
    Request: type = struct {
        firewall_rule_group_id: []const u8,
        firewall_domain_list_id: []const u8,
        qtype: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .firewall_domain_list_id = "FirewallDomainListId",
                .qtype = "Qtype",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_firewall_rule) } {
            return .{ .service_metadata = service_metadata, .action = delete_firewall_rule };
        }
    },
    Response: type = struct {
        firewall_rule: ?FirewallRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule = "FirewallRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const delete_firewall_rule_group: struct {
    action_name: []const u8 = "DeleteFirewallRuleGroup",
    Request: type = struct {
        firewall_rule_group_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_firewall_rule_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_firewall_rule_group };
        }
    },
    Response: type = struct {
        firewall_rule_group: ?FirewallRuleGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group = "FirewallRuleGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_outpost_resolver: struct {
    action_name: []const u8 = "DeleteOutpostResolver",
    Request: type = struct {
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_outpost_resolver) } {
            return .{ .service_metadata = service_metadata, .action = delete_outpost_resolver };
        }
    },
    Response: type = struct {
        outpost_resolver: ?OutpostResolver = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_resolver = "OutpostResolver",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const delete_resolver_endpoint: struct {
    action_name: []const u8 = "DeleteResolverEndpoint",
    Request: type = struct {
        resolver_endpoint_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resolver_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = delete_resolver_endpoint };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const delete_resolver_query_log_config: struct {
    action_name: []const u8 = "DeleteResolverQueryLogConfig",
    Request: type = struct {
        resolver_query_log_config_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_id = "ResolverQueryLogConfigId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resolver_query_log_config) } {
            return .{ .service_metadata = service_metadata, .action = delete_resolver_query_log_config };
        }
    },
    Response: type = struct {
        resolver_query_log_config: ?ResolverQueryLogConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config = "ResolverQueryLogConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const delete_resolver_rule: struct {
    action_name: []const u8 = "DeleteResolverRule",
    Request: type = struct {
        resolver_rule_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_id = "ResolverRuleId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = delete_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule: ?ResolverRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule = "ResolverRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        ResourceInUse,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const disassociate_firewall_rule_group: struct {
    action_name: []const u8 = "DisassociateFirewallRuleGroup",
    Request: type = struct {
        firewall_rule_group_association_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association_id = "FirewallRuleGroupAssociationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_firewall_rule_group) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_firewall_rule_group };
        }
    },
    Response: type = struct {
        firewall_rule_group_association: ?FirewallRuleGroupAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association = "FirewallRuleGroupAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const disassociate_resolver_endpoint_ip_address: struct {
    action_name: []const u8 = "DisassociateResolverEndpointIpAddress",
    Request: type = struct {
        resolver_endpoint_id: []const u8,
        ip_address: IpAddressUpdate,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
                .ip_address = "IpAddress",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_resolver_endpoint_ip_address) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_resolver_endpoint_ip_address };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceExists,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const disassociate_resolver_query_log_config: struct {
    action_name: []const u8 = "DisassociateResolverQueryLogConfig",
    Request: type = struct {
        resolver_query_log_config_id: []const u8,
        resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_id = "ResolverQueryLogConfigId",
                .resource_id = "ResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_resolver_query_log_config) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_resolver_query_log_config };
        }
    },
    Response: type = struct {
        resolver_query_log_config_association: ?ResolverQueryLogConfigAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_association = "ResolverQueryLogConfigAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const disassociate_resolver_rule: struct {
    action_name: []const u8 = "DisassociateResolverRule",
    Request: type = struct {
        vpc_id: []const u8,
        resolver_rule_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .vpc_id = "VPCId",
                .resolver_rule_id = "ResolverRuleId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule_association: ?ResolverRuleAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_association = "ResolverRuleAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_firewall_config: struct {
    action_name: []const u8 = "GetFirewallConfig",
    Request: type = struct {
        resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_firewall_config) } {
            return .{ .service_metadata = service_metadata, .action = get_firewall_config };
        }
    },
    Response: type = struct {
        firewall_config: ?FirewallConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_config = "FirewallConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_firewall_domain_list: struct {
    action_name: []const u8 = "GetFirewallDomainList",
    Request: type = struct {
        firewall_domain_list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list_id = "FirewallDomainListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_firewall_domain_list) } {
            return .{ .service_metadata = service_metadata, .action = get_firewall_domain_list };
        }
    },
    Response: type = struct {
        firewall_domain_list: ?FirewallDomainList = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list = "FirewallDomainList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_firewall_rule_group: struct {
    action_name: []const u8 = "GetFirewallRuleGroup",
    Request: type = struct {
        firewall_rule_group_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_firewall_rule_group) } {
            return .{ .service_metadata = service_metadata, .action = get_firewall_rule_group };
        }
    },
    Response: type = struct {
        firewall_rule_group: ?FirewallRuleGroup = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group = "FirewallRuleGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_firewall_rule_group_association: struct {
    action_name: []const u8 = "GetFirewallRuleGroupAssociation",
    Request: type = struct {
        firewall_rule_group_association_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association_id = "FirewallRuleGroupAssociationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_firewall_rule_group_association) } {
            return .{ .service_metadata = service_metadata, .action = get_firewall_rule_group_association };
        }
    },
    Response: type = struct {
        firewall_rule_group_association: ?FirewallRuleGroupAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association = "FirewallRuleGroupAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_firewall_rule_group_policy: struct {
    action_name: []const u8 = "GetFirewallRuleGroupPolicy",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_firewall_rule_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_firewall_rule_group_policy };
        }
    },
    Response: type = struct {
        firewall_rule_group_policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_policy = "FirewallRuleGroupPolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_outpost_resolver: struct {
    action_name: []const u8 = "GetOutpostResolver",
    Request: type = struct {
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_outpost_resolver) } {
            return .{ .service_metadata = service_metadata, .action = get_outpost_resolver };
        }
    },
    Response: type = struct {
        outpost_resolver: ?OutpostResolver = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_resolver = "OutpostResolver",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_resolver_config: struct {
    action_name: []const u8 = "GetResolverConfig",
    Request: type = struct {
        resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_config) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_config };
        }
    },
    Response: type = struct {
        resolver_config: ?ResolverConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_config = "ResolverConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const get_resolver_dnssec_config: struct {
    action_name: []const u8 = "GetResolverDnssecConfig",
    Request: type = struct {
        resource_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_dnssec_config) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_dnssec_config };
        }
    },
    Response: type = struct {
        resolver_dnssec_config: ?ResolverDnssecConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_dnssec_config = "ResolverDNSSECConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_endpoint: struct {
    action_name: []const u8 = "GetResolverEndpoint",
    Request: type = struct {
        resolver_endpoint_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_endpoint };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_query_log_config: struct {
    action_name: []const u8 = "GetResolverQueryLogConfig",
    Request: type = struct {
        resolver_query_log_config_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_id = "ResolverQueryLogConfigId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_query_log_config) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_query_log_config };
        }
    },
    Response: type = struct {
        resolver_query_log_config: ?ResolverQueryLogConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config = "ResolverQueryLogConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_query_log_config_association: struct {
    action_name: []const u8 = "GetResolverQueryLogConfigAssociation",
    Request: type = struct {
        resolver_query_log_config_association_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_association_id = "ResolverQueryLogConfigAssociationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_query_log_config_association) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_query_log_config_association };
        }
    },
    Response: type = struct {
        resolver_query_log_config_association: ?ResolverQueryLogConfigAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_association = "ResolverQueryLogConfigAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_query_log_config_policy: struct {
    action_name: []const u8 = "GetResolverQueryLogConfigPolicy",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_query_log_config_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_query_log_config_policy };
        }
    },
    Response: type = struct {
        resolver_query_log_config_policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_query_log_config_policy = "ResolverQueryLogConfigPolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        UnknownResource,
    },
} = .{};
pub const get_resolver_rule: struct {
    action_name: []const u8 = "GetResolverRule",
    Request: type = struct {
        resolver_rule_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_id = "ResolverRuleId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule: ?ResolverRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule = "ResolverRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_rule_association: struct {
    action_name: []const u8 = "GetResolverRuleAssociation",
    Request: type = struct {
        resolver_rule_association_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_association_id = "ResolverRuleAssociationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_rule_association) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_rule_association };
        }
    },
    Response: type = struct {
        resolver_rule_association: ?ResolverRuleAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_association = "ResolverRuleAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const get_resolver_rule_policy: struct {
    action_name: []const u8 = "GetResolverRulePolicy",
    Request: type = struct {
        arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_resolver_rule_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_resolver_rule_policy };
        }
    },
    Response: type = struct {
        resolver_rule_policy: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_policy = "ResolverRulePolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        UnknownResource,
    },
} = .{};
pub const import_firewall_domains: struct {
    action_name: []const u8 = "ImportFirewallDomains",
    Request: type = struct {
        firewall_domain_list_id: []const u8,
        operation: []const u8,
        domain_file_url: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list_id = "FirewallDomainListId",
                .operation = "Operation",
                .domain_file_url = "DomainFileUrl",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_firewall_domains) } {
            return .{ .service_metadata = service_metadata, .action = import_firewall_domains };
        }
    },
    Response: type = struct {
        id: ?[]const u8 = null,
        name: ?[]const u8 = null,
        status: ?[]const u8 = null,
        status_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
                .name = "Name",
                .status = "Status",
                .status_message = "StatusMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        LimitExceeded,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_configs: struct {
    action_name: []const u8 = "ListFirewallConfigs",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_configs) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_configs };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        firewall_configs: ?[]FirewallConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .firewall_configs = "FirewallConfigs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_domain_lists: struct {
    action_name: []const u8 = "ListFirewallDomainLists",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_domain_lists) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_domain_lists };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        firewall_domain_lists: ?[]struct {
            id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            creator_request_id: ?[]const u8 = null,
            managed_owner_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .arn = "Arn",
                    .name = "Name",
                    .creator_request_id = "CreatorRequestId",
                    .managed_owner_name = "ManagedOwnerName",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .firewall_domain_lists = "FirewallDomainLists",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_domains: struct {
    action_name: []const u8 = "ListFirewallDomains",
    Request: type = struct {
        firewall_domain_list_id: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list_id = "FirewallDomainListId",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_domains) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_domains };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        domains: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .domains = "Domains",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_rule_group_associations: struct {
    action_name: []const u8 = "ListFirewallRuleGroupAssociations",
    Request: type = struct {
        firewall_rule_group_id: ?[]const u8 = null,
        vpc_id: ?[]const u8 = null,
        priority: ?i64 = null,
        status: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .vpc_id = "VpcId",
                .priority = "Priority",
                .status = "Status",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_rule_group_associations) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_rule_group_associations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        firewall_rule_group_associations: ?[]FirewallRuleGroupAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .firewall_rule_group_associations = "FirewallRuleGroupAssociations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_rule_groups: struct {
    action_name: []const u8 = "ListFirewallRuleGroups",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_rule_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_rule_groups };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        firewall_rule_groups: ?[]struct {
            id: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            name: ?[]const u8 = null,
            owner_id: ?[]const u8 = null,
            creator_request_id: ?[]const u8 = null,
            share_status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .id = "Id",
                    .arn = "Arn",
                    .name = "Name",
                    .owner_id = "OwnerId",
                    .creator_request_id = "CreatorRequestId",
                    .share_status = "ShareStatus",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .firewall_rule_groups = "FirewallRuleGroups",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        Throttling,
        Validation,
    },
} = .{};
pub const list_firewall_rules: struct {
    action_name: []const u8 = "ListFirewallRules",
    Request: type = struct {
        firewall_rule_group_id: []const u8,
        priority: ?i64 = null,
        action: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .priority = "Priority",
                .action = "Action",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_firewall_rules) } {
            return .{ .service_metadata = service_metadata, .action = list_firewall_rules };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        firewall_rules: ?[]FirewallRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .firewall_rules = "FirewallRules",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const list_outpost_resolvers: struct {
    action_name: []const u8 = "ListOutpostResolvers",
    Request: type = struct {
        outpost_arn: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_arn = "OutpostArn",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_outpost_resolvers) } {
            return .{ .service_metadata = service_metadata, .action = list_outpost_resolvers };
        }
    },
    Response: type = struct {
        outpost_resolvers: ?[]OutpostResolver = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_resolvers = "OutpostResolvers",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const list_resolver_configs: struct {
    action_name: []const u8 = "ListResolverConfigs",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_configs) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_configs };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        resolver_configs: ?[]ResolverConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .resolver_configs = "ResolverConfigs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
        Validation,
    },
} = .{};
pub const list_resolver_dnssec_configs: struct {
    action_name: []const u8 = "ListResolverDnssecConfigs",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_dnssec_configs) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_dnssec_configs };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        resolver_dnssec_configs: ?[]ResolverDnssecConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .resolver_dnssec_configs = "ResolverDnssecConfigs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
    },
} = .{};
pub const list_resolver_endpoint_ip_addresses: struct {
    action_name: []const u8 = "ListResolverEndpointIpAddresses",
    Request: type = struct {
        resolver_endpoint_id: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_endpoint_ip_addresses) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_endpoint_ip_addresses };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        ip_addresses: ?[]struct {
            ip_id: ?[]const u8 = null,
            subnet_id: ?[]const u8 = null,
            ip: ?[]const u8 = null,
            ipv6: ?[]const u8 = null,
            status: ?[]const u8 = null,
            status_message: ?[]const u8 = null,
            creation_time: ?[]const u8 = null,
            modification_time: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .ip_id = "IpId",
                    .subnet_id = "SubnetId",
                    .ip = "Ip",
                    .ipv6 = "Ipv6",
                    .status = "Status",
                    .status_message = "StatusMessage",
                    .creation_time = "CreationTime",
                    .modification_time = "ModificationTime",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .ip_addresses = "IpAddresses",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const list_resolver_endpoints: struct {
    action_name: []const u8 = "ListResolverEndpoints",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_endpoints) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_endpoints };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        resolver_endpoints: ?[]ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .resolver_endpoints = "ResolverEndpoints",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
    },
} = .{};
pub const list_resolver_query_log_config_associations: struct {
    action_name: []const u8 = "ListResolverQueryLogConfigAssociations",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
                .sort_by = "SortBy",
                .sort_order = "SortOrder",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_query_log_config_associations) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_query_log_config_associations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,
        total_filtered_count: ?i64 = null,
        resolver_query_log_config_associations: ?[]ResolverQueryLogConfigAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .total_count = "TotalCount",
                .total_filtered_count = "TotalFilteredCount",
                .resolver_query_log_config_associations = "ResolverQueryLogConfigAssociations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        Throttling,
    },
} = .{};
pub const list_resolver_query_log_configs: struct {
    action_name: []const u8 = "ListResolverQueryLogConfigs",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
                .sort_by = "SortBy",
                .sort_order = "SortOrder",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_query_log_configs) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_query_log_configs };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        total_count: ?i64 = null,
        total_filtered_count: ?i64 = null,
        resolver_query_log_configs: ?[]ResolverQueryLogConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .total_count = "TotalCount",
                .total_filtered_count = "TotalFilteredCount",
                .resolver_query_log_configs = "ResolverQueryLogConfigs",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
    },
} = .{};
pub const list_resolver_rule_associations: struct {
    action_name: []const u8 = "ListResolverRuleAssociations",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_rule_associations) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_rule_associations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        resolver_rule_associations: ?[]ResolverRuleAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .resolver_rule_associations = "ResolverRuleAssociations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
    },
} = .{};
pub const list_resolver_rules: struct {
    action_name: []const u8 = "ListResolverRules",
    Request: type = struct {
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,
        filters: ?[]Filter = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .max_results = "MaxResults",
                .next_token = "NextToken",
                .filters = "Filters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resolver_rules) } {
            return .{ .service_metadata = service_metadata, .action = list_resolver_rules };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        resolver_rules: ?[]ResolverRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .resolver_rules = "ResolverRules",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        Throttling,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .max_results = "MaxResults",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidNextToken,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const put_firewall_rule_group_policy: struct {
    action_name: []const u8 = "PutFirewallRuleGroupPolicy",
    Request: type = struct {
        arn: []const u8,
        firewall_rule_group_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .firewall_rule_group_policy = "FirewallRuleGroupPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_firewall_rule_group_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_firewall_rule_group_policy };
        }
    },
    Response: type = struct {
        return_value: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .return_value = "ReturnValue",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const put_resolver_query_log_config_policy: struct {
    action_name: []const u8 = "PutResolverQueryLogConfigPolicy",
    Request: type = struct {
        arn: []const u8,
        resolver_query_log_config_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .resolver_query_log_config_policy = "ResolverQueryLogConfigPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resolver_query_log_config_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_resolver_query_log_config_policy };
        }
    },
    Response: type = struct {
        return_value: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .return_value = "ReturnValue",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidPolicyDocument,
        InvalidRequest,
        UnknownResource,
    },
} = .{};
pub const put_resolver_rule_policy: struct {
    action_name: []const u8 = "PutResolverRulePolicy",
    Request: type = struct {
        arn: []const u8,
        resolver_rule_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .arn = "Arn",
                .resolver_rule_policy = "ResolverRulePolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resolver_rule_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_resolver_rule_policy };
        }
    },
    Response: type = struct {
        return_value: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .return_value = "ReturnValue",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidPolicyDocument,
        UnknownResource,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        InvalidTag,
        LimitExceeded,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const update_firewall_config: struct {
    action_name: []const u8 = "UpdateFirewallConfig",
    Request: type = struct {
        resource_id: []const u8,
        firewall_fail_open: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
                .firewall_fail_open = "FirewallFailOpen",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_firewall_config) } {
            return .{ .service_metadata = service_metadata, .action = update_firewall_config };
        }
    },
    Response: type = struct {
        firewall_config: ?FirewallConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_config = "FirewallConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_firewall_domains: struct {
    action_name: []const u8 = "UpdateFirewallDomains",
    Request: type = struct {
        firewall_domain_list_id: []const u8,
        operation: []const u8,
        domains: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_domain_list_id = "FirewallDomainListId",
                .operation = "Operation",
                .domains = "Domains",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_firewall_domains) } {
            return .{ .service_metadata = service_metadata, .action = update_firewall_domains };
        }
    },
    Response: type = struct {
        id: ?[]const u8 = null,
        name: ?[]const u8 = null,
        status: ?[]const u8 = null,
        status_message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
                .name = "Name",
                .status = "Status",
                .status_message = "StatusMessage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        LimitExceeded,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_firewall_rule: struct {
    action_name: []const u8 = "UpdateFirewallRule",
    Request: type = struct {
        firewall_rule_group_id: []const u8,
        firewall_domain_list_id: []const u8,
        priority: ?i64 = null,
        action: ?[]const u8 = null,
        block_response: ?[]const u8 = null,
        block_override_domain: ?[]const u8 = null,
        block_override_dns_type: ?[]const u8 = null,
        block_override_ttl: ?i64 = null,
        name: ?[]const u8 = null,
        qtype: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_id = "FirewallRuleGroupId",
                .firewall_domain_list_id = "FirewallDomainListId",
                .priority = "Priority",
                .action = "Action",
                .block_response = "BlockResponse",
                .block_override_domain = "BlockOverrideDomain",
                .block_override_dns_type = "BlockOverrideDnsType",
                .block_override_ttl = "BlockOverrideTtl",
                .name = "Name",
                .qtype = "Qtype",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_firewall_rule) } {
            return .{ .service_metadata = service_metadata, .action = update_firewall_rule };
        }
    },
    Response: type = struct {
        firewall_rule: ?FirewallRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule = "FirewallRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_firewall_rule_group_association: struct {
    action_name: []const u8 = "UpdateFirewallRuleGroupAssociation",
    Request: type = struct {
        firewall_rule_group_association_id: []const u8,
        priority: ?i64 = null,
        mutation_protection: ?[]const u8 = null,
        name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association_id = "FirewallRuleGroupAssociationId",
                .priority = "Priority",
                .mutation_protection = "MutationProtection",
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_firewall_rule_group_association) } {
            return .{ .service_metadata = service_metadata, .action = update_firewall_rule_group_association };
        }
    },
    Response: type = struct {
        firewall_rule_group_association: ?FirewallRuleGroupAssociation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .firewall_rule_group_association = "FirewallRuleGroupAssociation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        Throttling,
        Validation,
    },
} = .{};
pub const update_outpost_resolver: struct {
    action_name: []const u8 = "UpdateOutpostResolver",
    Request: type = struct {
        id: []const u8,
        name: ?[]const u8 = null,
        instance_count: ?i64 = null,
        preferred_instance_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .id = "Id",
                .name = "Name",
                .instance_count = "InstanceCount",
                .preferred_instance_type = "PreferredInstanceType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_outpost_resolver) } {
            return .{ .service_metadata = service_metadata, .action = update_outpost_resolver };
        }
    },
    Response: type = struct {
        outpost_resolver: ?OutpostResolver = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .outpost_resolver = "OutpostResolver",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServiceError,
        ResourceNotFound,
        ServiceQuotaExceeded,
        Throttling,
        Validation,
    },
} = .{};
pub const update_resolver_config: struct {
    action_name: []const u8 = "UpdateResolverConfig",
    Request: type = struct {
        resource_id: []const u8,
        autodefined_reverse_flag: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
                .autodefined_reverse_flag = "AutodefinedReverseFlag",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_resolver_config) } {
            return .{ .service_metadata = service_metadata, .action = update_resolver_config };
        }
    },
    Response: type = struct {
        resolver_config: ?ResolverConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_config = "ResolverConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        Throttling,
        Validation,
    },
} = .{};
pub const update_resolver_dnssec_config: struct {
    action_name: []const u8 = "UpdateResolverDnssecConfig",
    Request: type = struct {
        resource_id: []const u8,
        validation: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_id = "ResourceId",
                .validation = "Validation",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_resolver_dnssec_config) } {
            return .{ .service_metadata = service_metadata, .action = update_resolver_dnssec_config };
        }
    },
    Response: type = struct {
        resolver_dnssec_config: ?ResolverDnssecConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_dnssec_config = "ResolverDNSSECConfig",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const update_resolver_endpoint: struct {
    action_name: []const u8 = "UpdateResolverEndpoint",
    Request: type = struct {
        resolver_endpoint_id: []const u8,
        name: ?[]const u8 = null,
        resolver_endpoint_type: ?[]const u8 = null,
        update_ip_addresses: ?[]struct {
            ip_id: []const u8,
            ipv6: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .ip_id = "IpId",
                    .ipv6 = "Ipv6",
                };
                return @field(mappings, field_name);
            }
        } = null,
        protocols: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint_id = "ResolverEndpointId",
                .name = "Name",
                .resolver_endpoint_type = "ResolverEndpointType",
                .update_ip_addresses = "UpdateIpAddresses",
                .protocols = "Protocols",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_resolver_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = update_resolver_endpoint };
        }
    },
    Response: type = struct {
        resolver_endpoint: ?ResolverEndpoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_endpoint = "ResolverEndpoint",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        ResourceNotFound,
        Throttling,
    },
} = .{};
pub const update_resolver_rule: struct {
    action_name: []const u8 = "UpdateResolverRule",
    Request: type = struct {
        resolver_rule_id: []const u8,
        config: struct {
            name: ?[]const u8 = null,
            target_ips: ?[]TargetAddress = null,
            resolver_endpoint_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .target_ips = "TargetIps",
                    .resolver_endpoint_id = "ResolverEndpointId",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule_id = "ResolverRuleId",
                .config = "Config",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_resolver_rule) } {
            return .{ .service_metadata = service_metadata, .action = update_resolver_rule };
        }
    },
    Response: type = struct {
        resolver_rule: ?ResolverRule = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resolver_rule = "ResolverRule",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServiceError,
        InvalidParameter,
        InvalidRequest,
        LimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        Throttling,
    },
} = .{};

pub const ResolverRule = struct {
    id: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    domain_name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    rule_type: ?[]const u8 = null,
    name: ?[]const u8 = null,
    target_ips: ?[]TargetAddress = null,
    resolver_endpoint_id: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    share_status: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .creator_request_id = "CreatorRequestId",
            .arn = "Arn",
            .domain_name = "DomainName",
            .status = "Status",
            .status_message = "StatusMessage",
            .rule_type = "RuleType",
            .name = "Name",
            .target_ips = "TargetIps",
            .resolver_endpoint_id = "ResolverEndpointId",
            .owner_id = "OwnerId",
            .share_status = "ShareStatus",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const TargetAddress = struct {
    ip: ?[]const u8 = null,
    port: ?i64 = null,
    ipv6: ?[]const u8 = null,
    protocol: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ip = "Ip",
            .port = "Port",
            .ipv6 = "Ipv6",
            .protocol = "Protocol",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverEndpoint = struct {
    id: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    security_group_ids: ?[][]const u8 = null,
    direction: ?[]const u8 = null,
    ip_address_count: ?i64 = null,
    host_vpc_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,
    outpost_arn: ?[]const u8 = null,
    preferred_instance_type: ?[]const u8 = null,
    resolver_endpoint_type: ?[]const u8 = null,
    protocols: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .creator_request_id = "CreatorRequestId",
            .arn = "Arn",
            .name = "Name",
            .security_group_ids = "SecurityGroupIds",
            .direction = "Direction",
            .ip_address_count = "IpAddressCount",
            .host_vpc_id = "HostVPCId",
            .status = "Status",
            .status_message = "StatusMessage",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
            .outpost_arn = "OutpostArn",
            .preferred_instance_type = "PreferredInstanceType",
            .resolver_endpoint_type = "ResolverEndpointType",
            .protocols = "Protocols",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverDnssecConfig = struct {
    id: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    validation_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .owner_id = "OwnerId",
            .resource_id = "ResourceId",
            .validation_status = "ValidationStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverConfig = struct {
    id: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    autodefined_reverse: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .resource_id = "ResourceId",
            .owner_id = "OwnerId",
            .autodefined_reverse = "AutodefinedReverse",
        };
        return @field(mappings, field_name);
    }
};

pub const OutpostResolver = struct {
    arn: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    id: ?[]const u8 = null,
    instance_count: ?i64 = null,
    preferred_instance_type: ?[]const u8 = null,
    name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    outpost_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "Arn",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
            .creator_request_id = "CreatorRequestId",
            .id = "Id",
            .instance_count = "InstanceCount",
            .preferred_instance_type = "PreferredInstanceType",
            .name = "Name",
            .status = "Status",
            .status_message = "StatusMessage",
            .outpost_arn = "OutpostArn",
        };
        return @field(mappings, field_name);
    }
};

pub const FirewallRuleGroupAssociation = struct {
    id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    firewall_rule_group_id: ?[]const u8 = null,
    vpc_id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    priority: ?i64 = null,
    mutation_protection: ?[]const u8 = null,
    managed_owner_name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .arn = "Arn",
            .firewall_rule_group_id = "FirewallRuleGroupId",
            .vpc_id = "VpcId",
            .name = "Name",
            .priority = "Priority",
            .mutation_protection = "MutationProtection",
            .managed_owner_name = "ManagedOwnerName",
            .status = "Status",
            .status_message = "StatusMessage",
            .creator_request_id = "CreatorRequestId",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const FirewallRule = struct {
    firewall_rule_group_id: ?[]const u8 = null,
    firewall_domain_list_id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    priority: ?i64 = null,
    action: ?[]const u8 = null,
    block_response: ?[]const u8 = null,
    block_override_domain: ?[]const u8 = null,
    block_override_dns_type: ?[]const u8 = null,
    block_override_ttl: ?i64 = null,
    creator_request_id: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,
    qtype: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .firewall_rule_group_id = "FirewallRuleGroupId",
            .firewall_domain_list_id = "FirewallDomainListId",
            .name = "Name",
            .priority = "Priority",
            .action = "Action",
            .block_response = "BlockResponse",
            .block_override_domain = "BlockOverrideDomain",
            .block_override_dns_type = "BlockOverrideDnsType",
            .block_override_ttl = "BlockOverrideTtl",
            .creator_request_id = "CreatorRequestId",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
            .qtype = "Qtype",
        };
        return @field(mappings, field_name);
    }
};

pub const FirewallConfig = struct {
    id: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    firewall_fail_open: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .resource_id = "ResourceId",
            .owner_id = "OwnerId",
            .firewall_fail_open = "FirewallFailOpen",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const Filter = struct {
    name: ?[]const u8 = null,
    values: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .values = "Values",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverRuleAssociation = struct {
    id: ?[]const u8 = null,
    resolver_rule_id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    vpc_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .resolver_rule_id = "ResolverRuleId",
            .name = "Name",
            .vpc_id = "VPCId",
            .status = "Status",
            .status_message = "StatusMessage",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverQueryLogConfig = struct {
    id: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    share_status: ?[]const u8 = null,
    association_count: ?i64 = null,
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    destination_arn: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .owner_id = "OwnerId",
            .status = "Status",
            .share_status = "ShareStatus",
            .association_count = "AssociationCount",
            .arn = "Arn",
            .name = "Name",
            .destination_arn = "DestinationArn",
            .creator_request_id = "CreatorRequestId",
            .creation_time = "CreationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const ResolverQueryLogConfigAssociation = struct {
    id: ?[]const u8 = null,
    resolver_query_log_config_id: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    status: ?[]const u8 = null,
    @"error": ?[]const u8 = null,
    error_message: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .resolver_query_log_config_id = "ResolverQueryLogConfigId",
            .resource_id = "ResourceId",
            .status = "Status",
            .@"error" = "Error",
            .error_message = "ErrorMessage",
            .creation_time = "CreationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const FirewallRuleGroup = struct {
    id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    rule_count: ?i64 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    owner_id: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    share_status: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .arn = "Arn",
            .name = "Name",
            .rule_count = "RuleCount",
            .status = "Status",
            .status_message = "StatusMessage",
            .owner_id = "OwnerId",
            .creator_request_id = "CreatorRequestId",
            .share_status = "ShareStatus",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const FirewallDomainList = struct {
    id: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    domain_count: ?i64 = null,
    status: ?[]const u8 = null,
    status_message: ?[]const u8 = null,
    managed_owner_name: ?[]const u8 = null,
    creator_request_id: ?[]const u8 = null,
    creation_time: ?[]const u8 = null,
    modification_time: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .arn = "Arn",
            .name = "Name",
            .domain_count = "DomainCount",
            .status = "Status",
            .status_message = "StatusMessage",
            .managed_owner_name = "ManagedOwnerName",
            .creator_request_id = "CreatorRequestId",
            .creation_time = "CreationTime",
            .modification_time = "ModificationTime",
        };
        return @field(mappings, field_name);
    }
};

pub const IpAddressUpdate = struct {
    ip_id: ?[]const u8 = null,
    subnet_id: ?[]const u8 = null,
    ip: ?[]const u8 = null,
    ipv6: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ip_id = "IpId",
            .subnet_id = "SubnetId",
            .ip = "Ip",
            .ipv6 = "Ipv6",
        };
        return @field(mappings, field_name);
    }
};
