const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2014-05-15";
pub const sdk_id: []const u8 = "Route 53 Domains";
pub const arn_namespace: ?[]const u8 = "route53domains";
pub const endpoint_prefix: []const u8 = "route53domains";
pub const sigv4_name: []const u8 = "route53domains";
pub const name: []const u8 = "Route53Domains_v20140515";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2014-05-15",
    sdk_id: []const u8 = "Route 53 Domains",
    arn_namespace: ?[]const u8 = "route53domains",
    endpoint_prefix: []const u8 = "route53domains",
    sigv4_name: []const u8 = "route53domains",
    name: []const u8 = "Route53Domains_v20140515",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const accept_domain_transfer_from_another_aws_account: struct {
    action_name: []const u8 = "AcceptDomainTransferFromAnotherAwsAccount",
    Request: type = struct {
        domain_name: []const u8,
        password: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .password = "Password",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(accept_domain_transfer_from_another_aws_account) } {
            return .{ .service_metadata = service_metadata, .action = accept_domain_transfer_from_another_aws_account };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DomainLimitExceeded,
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const associate_delegation_signer_to_domain: struct {
    action_name: []const u8 = "AssociateDelegationSignerToDomain",
    Request: type = struct {
        domain_name: []const u8,
        signing_attributes: struct {
            algorithm: ?i64 = null,
            flags: ?i64 = null,
            public_key: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .algorithm = "Algorithm",
                    .flags = "Flags",
                    .public_key = "PublicKey",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .signing_attributes = "SigningAttributes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_delegation_signer_to_domain) } {
            return .{ .service_metadata = service_metadata, .action = associate_delegation_signer_to_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DnssecLimitExceeded,
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const cancel_domain_transfer_to_another_aws_account: struct {
    action_name: []const u8 = "CancelDomainTransferToAnotherAwsAccount",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_domain_transfer_to_another_aws_account) } {
            return .{ .service_metadata = service_metadata, .action = cancel_domain_transfer_to_another_aws_account };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const check_domain_availability: struct {
    action_name: []const u8 = "CheckDomainAvailability",
    Request: type = struct {
        domain_name: []const u8,
        idn_lang_code: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .idn_lang_code = "IdnLangCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(check_domain_availability) } {
            return .{ .service_metadata = service_metadata, .action = check_domain_availability };
        }
    },
    Response: type = struct {
        availability: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .availability = "Availability",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const check_domain_transferability: struct {
    action_name: []const u8 = "CheckDomainTransferability",
    Request: type = struct {
        domain_name: []const u8,
        auth_code: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .auth_code = "AuthCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(check_domain_transferability) } {
            return .{ .service_metadata = service_metadata, .action = check_domain_transferability };
        }
    },
    Response: type = struct {
        transferability: ?struct {
            transferable: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .transferable = "Transferable",
                };
                return @field(mappings, field_name);
            }
        } = null,
        message: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .transferability = "Transferability",
                .message = "Message",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const delete_domain: struct {
    action_name: []const u8 = "DeleteDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_domain) } {
            return .{ .service_metadata = service_metadata, .action = delete_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const delete_tags_for_domain: struct {
    action_name: []const u8 = "DeleteTagsForDomain",
    Request: type = struct {
        domain_name: []const u8,
        tags_to_delete: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .tags_to_delete = "TagsToDelete",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_tags_for_domain) } {
            return .{ .service_metadata = service_metadata, .action = delete_tags_for_domain };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const disable_domain_auto_renew: struct {
    action_name: []const u8 = "DisableDomainAutoRenew",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_domain_auto_renew) } {
            return .{ .service_metadata = service_metadata, .action = disable_domain_auto_renew };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const disable_domain_transfer_lock: struct {
    action_name: []const u8 = "DisableDomainTransferLock",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_domain_transfer_lock) } {
            return .{ .service_metadata = service_metadata, .action = disable_domain_transfer_lock };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const disassociate_delegation_signer_from_domain: struct {
    action_name: []const u8 = "DisassociateDelegationSignerFromDomain",
    Request: type = struct {
        domain_name: []const u8,
        id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .id = "Id",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_delegation_signer_from_domain) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_delegation_signer_from_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const enable_domain_auto_renew: struct {
    action_name: []const u8 = "EnableDomainAutoRenew",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_domain_auto_renew) } {
            return .{ .service_metadata = service_metadata, .action = enable_domain_auto_renew };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const enable_domain_transfer_lock: struct {
    action_name: []const u8 = "EnableDomainTransferLock",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_domain_transfer_lock) } {
            return .{ .service_metadata = service_metadata, .action = enable_domain_transfer_lock };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const get_contact_reachability_status: struct {
    action_name: []const u8 = "GetContactReachabilityStatus",
    Request: type = struct {
        domain_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_contact_reachability_status) } {
            return .{ .service_metadata = service_metadata, .action = get_contact_reachability_status };
        }
    },
    Response: type = struct {
        domain_name: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .status = "status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const get_domain_detail: struct {
    action_name: []const u8 = "GetDomainDetail",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_domain_detail) } {
            return .{ .service_metadata = service_metadata, .action = get_domain_detail };
        }
    },
    Response: type = struct {
        domain_name: ?[]const u8 = null,
        nameservers: ?[]Nameserver = null,
        auto_renew: ?bool = null,
        admin_contact: ?ContactDetail = null,
        registrant_contact: ?ContactDetail = null,
        tech_contact: ?ContactDetail = null,
        admin_privacy: ?bool = null,
        registrant_privacy: ?bool = null,
        tech_privacy: ?bool = null,
        registrar_name: ?[]const u8 = null,
        who_is_server: ?[]const u8 = null,
        registrar_url: ?[]const u8 = null,
        abuse_contact_email: ?[]const u8 = null,
        abuse_contact_phone: ?[]const u8 = null,
        registry_domain_id: ?[]const u8 = null,
        creation_date: ?i64 = null,
        updated_date: ?i64 = null,
        expiration_date: ?i64 = null,
        reseller: ?[]const u8 = null,
        dns_sec: ?[]const u8 = null,
        status_list: ?[][]const u8 = null,
        dnssec_keys: ?[]struct {
            algorithm: ?i64 = null,
            flags: ?i64 = null,
            public_key: ?[]const u8 = null,
            digest_type: ?i64 = null,
            digest: ?[]const u8 = null,
            key_tag: ?i64 = null,
            id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .algorithm = "Algorithm",
                    .flags = "Flags",
                    .public_key = "PublicKey",
                    .digest_type = "DigestType",
                    .digest = "Digest",
                    .key_tag = "KeyTag",
                    .id = "Id",
                };
                return @field(mappings, field_name);
            }
        } = null,
        billing_contact: ?ContactDetail = null,
        billing_privacy: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .nameservers = "Nameservers",
                .auto_renew = "AutoRenew",
                .admin_contact = "AdminContact",
                .registrant_contact = "RegistrantContact",
                .tech_contact = "TechContact",
                .admin_privacy = "AdminPrivacy",
                .registrant_privacy = "RegistrantPrivacy",
                .tech_privacy = "TechPrivacy",
                .registrar_name = "RegistrarName",
                .who_is_server = "WhoIsServer",
                .registrar_url = "RegistrarUrl",
                .abuse_contact_email = "AbuseContactEmail",
                .abuse_contact_phone = "AbuseContactPhone",
                .registry_domain_id = "RegistryDomainId",
                .creation_date = "CreationDate",
                .updated_date = "UpdatedDate",
                .expiration_date = "ExpirationDate",
                .reseller = "Reseller",
                .dns_sec = "DnsSec",
                .status_list = "StatusList",
                .dnssec_keys = "DnssecKeys",
                .billing_contact = "BillingContact",
                .billing_privacy = "BillingPrivacy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const get_domain_suggestions: struct {
    action_name: []const u8 = "GetDomainSuggestions",
    Request: type = struct {
        domain_name: []const u8,
        suggestion_count: i64,
        only_available: bool,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .suggestion_count = "SuggestionCount",
                .only_available = "OnlyAvailable",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_domain_suggestions) } {
            return .{ .service_metadata = service_metadata, .action = get_domain_suggestions };
        }
    },
    Response: type = struct {
        suggestions_list: ?[]struct {
            domain_name: ?[]const u8 = null,
            availability: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .domain_name = "DomainName",
                    .availability = "Availability",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .suggestions_list = "SuggestionsList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const get_operation_detail: struct {
    action_name: []const u8 = "GetOperationDetail",
    Request: type = struct {
        operation_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_operation_detail) } {
            return .{ .service_metadata = service_metadata, .action = get_operation_detail };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,
        status: ?[]const u8 = null,
        message: ?[]const u8 = null,
        domain_name: ?[]const u8 = null,
        type: ?[]const u8 = null,
        submitted_date: ?i64 = null,
        last_updated_date: ?i64 = null,
        status_flag: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
                .status = "Status",
                .message = "Message",
                .domain_name = "DomainName",
                .type = "Type",
                .submitted_date = "SubmittedDate",
                .last_updated_date = "LastUpdatedDate",
                .status_flag = "StatusFlag",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_domains: struct {
    action_name: []const u8 = "ListDomains",
    Request: type = struct {
        filter_conditions: ?[]struct {
            name: []const u8,
            operator: []const u8,
            values: [][]const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .operator = "Operator",
                    .values = "Values",
                };
                return @field(mappings, field_name);
            }
        } = null,
        sort_condition: ?struct {
            name: []const u8,
            sort_order: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .sort_order = "SortOrder",
                };
                return @field(mappings, field_name);
            }
        } = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter_conditions = "FilterConditions",
                .sort_condition = "SortCondition",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_domains) } {
            return .{ .service_metadata = service_metadata, .action = list_domains };
        }
    },
    Response: type = struct {
        domains: ?[]struct {
            domain_name: ?[]const u8 = null,
            auto_renew: ?bool = null,
            transfer_lock: ?bool = null,
            expiry: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .domain_name = "DomainName",
                    .auto_renew = "AutoRenew",
                    .transfer_lock = "TransferLock",
                    .expiry = "Expiry",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domains = "Domains",
                .next_page_marker = "NextPageMarker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_operations: struct {
    action_name: []const u8 = "ListOperations",
    Request: type = struct {
        submitted_since: ?i64 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,
        status: ?[][]const u8 = null,
        type: ?[][]const u8 = null,
        sort_by: ?[]const u8 = null,
        sort_order: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .submitted_since = "SubmittedSince",
                .marker = "Marker",
                .max_items = "MaxItems",
                .status = "Status",
                .type = "Type",
                .sort_by = "SortBy",
                .sort_order = "SortOrder",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_operations) } {
            return .{ .service_metadata = service_metadata, .action = list_operations };
        }
    },
    Response: type = struct {
        operations: ?[]struct {
            operation_id: ?[]const u8 = null,
            status: ?[]const u8 = null,
            type: ?[]const u8 = null,
            submitted_date: ?i64 = null,
            domain_name: ?[]const u8 = null,
            message: ?[]const u8 = null,
            status_flag: ?[]const u8 = null,
            last_updated_date: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .operation_id = "OperationId",
                    .status = "Status",
                    .type = "Type",
                    .submitted_date = "SubmittedDate",
                    .domain_name = "DomainName",
                    .message = "Message",
                    .status_flag = "StatusFlag",
                    .last_updated_date = "LastUpdatedDate",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "Operations",
                .next_page_marker = "NextPageMarker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const list_prices: struct {
    action_name: []const u8 = "ListPrices",
    Request: type = struct {
        tld: ?[]const u8 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tld = "Tld",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_prices) } {
            return .{ .service_metadata = service_metadata, .action = list_prices };
        }
    },
    Response: type = struct {
        prices: ?[]struct {
            name: ?[]const u8 = null,
            registration_price: ?PriceWithCurrency = null,
            transfer_price: ?PriceWithCurrency = null,
            renewal_price: ?PriceWithCurrency = null,
            change_ownership_price: ?PriceWithCurrency = null,
            restoration_price: ?PriceWithCurrency = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .registration_price = "RegistrationPrice",
                    .transfer_price = "TransferPrice",
                    .renewal_price = "RenewalPrice",
                    .change_ownership_price = "ChangeOwnershipPrice",
                    .restoration_price = "RestorationPrice",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_marker: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .prices = "Prices",
                .next_page_marker = "NextPageMarker",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const list_tags_for_domain: struct {
    action_name: []const u8 = "ListTagsForDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_domain) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_domain };
        }
    },
    Response: type = struct {
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const push_domain: struct {
    action_name: []const u8 = "PushDomain",
    Request: type = struct {
        domain_name: []const u8,
        target: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .target = "Target",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(push_domain) } {
            return .{ .service_metadata = service_metadata, .action = push_domain };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const register_domain: struct {
    action_name: []const u8 = "RegisterDomain",
    Request: type = struct {
        domain_name: []const u8,
        idn_lang_code: ?[]const u8 = null,
        duration_in_years: i64,
        auto_renew: ?bool = null,
        admin_contact: ContactDetail,
        registrant_contact: ContactDetail,
        tech_contact: ContactDetail,
        privacy_protect_admin_contact: ?bool = null,
        privacy_protect_registrant_contact: ?bool = null,
        privacy_protect_tech_contact: ?bool = null,
        billing_contact: ?ContactDetail = null,
        privacy_protect_billing_contact: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .idn_lang_code = "IdnLangCode",
                .duration_in_years = "DurationInYears",
                .auto_renew = "AutoRenew",
                .admin_contact = "AdminContact",
                .registrant_contact = "RegistrantContact",
                .tech_contact = "TechContact",
                .privacy_protect_admin_contact = "PrivacyProtectAdminContact",
                .privacy_protect_registrant_contact = "PrivacyProtectRegistrantContact",
                .privacy_protect_tech_contact = "PrivacyProtectTechContact",
                .billing_contact = "BillingContact",
                .privacy_protect_billing_contact = "PrivacyProtectBillingContact",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_domain) } {
            return .{ .service_metadata = service_metadata, .action = register_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DomainLimitExceeded,
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const reject_domain_transfer_from_another_aws_account: struct {
    action_name: []const u8 = "RejectDomainTransferFromAnotherAwsAccount",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reject_domain_transfer_from_another_aws_account) } {
            return .{ .service_metadata = service_metadata, .action = reject_domain_transfer_from_another_aws_account };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const renew_domain: struct {
    action_name: []const u8 = "RenewDomain",
    Request: type = struct {
        domain_name: []const u8,
        duration_in_years: ?i64 = null,
        current_expiry_year: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .duration_in_years = "DurationInYears",
                .current_expiry_year = "CurrentExpiryYear",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(renew_domain) } {
            return .{ .service_metadata = service_metadata, .action = renew_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const resend_contact_reachability_email: struct {
    action_name: []const u8 = "ResendContactReachabilityEmail",
    Request: type = struct {
        domain_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(resend_contact_reachability_email) } {
            return .{ .service_metadata = service_metadata, .action = resend_contact_reachability_email };
        }
    },
    Response: type = struct {
        domain_name: ?[]const u8 = null,
        email_address: ?[]const u8 = null,
        is_already_verified: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .email_address = "emailAddress",
                .is_already_verified = "isAlreadyVerified",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const resend_operation_authorization: struct {
    action_name: []const u8 = "ResendOperationAuthorization",
    Request: type = struct {
        operation_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(resend_operation_authorization) } {
            return .{ .service_metadata = service_metadata, .action = resend_operation_authorization };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};
pub const retrieve_domain_auth_code: struct {
    action_name: []const u8 = "RetrieveDomainAuthCode",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(retrieve_domain_auth_code) } {
            return .{ .service_metadata = service_metadata, .action = retrieve_domain_auth_code };
        }
    },
    Response: type = struct {
        auth_code: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auth_code = "AuthCode",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        UnsupportedTLD,
    },
} = .{};
pub const transfer_domain: struct {
    action_name: []const u8 = "TransferDomain",
    Request: type = struct {
        domain_name: []const u8,
        idn_lang_code: ?[]const u8 = null,
        duration_in_years: i64,
        nameservers: ?[]Nameserver = null,
        auth_code: ?[]const u8 = null,
        auto_renew: ?bool = null,
        admin_contact: ContactDetail,
        registrant_contact: ContactDetail,
        tech_contact: ContactDetail,
        privacy_protect_admin_contact: ?bool = null,
        privacy_protect_registrant_contact: ?bool = null,
        privacy_protect_tech_contact: ?bool = null,
        billing_contact: ?ContactDetail = null,
        privacy_protect_billing_contact: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .idn_lang_code = "IdnLangCode",
                .duration_in_years = "DurationInYears",
                .nameservers = "Nameservers",
                .auth_code = "AuthCode",
                .auto_renew = "AutoRenew",
                .admin_contact = "AdminContact",
                .registrant_contact = "RegistrantContact",
                .tech_contact = "TechContact",
                .privacy_protect_admin_contact = "PrivacyProtectAdminContact",
                .privacy_protect_registrant_contact = "PrivacyProtectRegistrantContact",
                .privacy_protect_tech_contact = "PrivacyProtectTechContact",
                .billing_contact = "BillingContact",
                .privacy_protect_billing_contact = "PrivacyProtectBillingContact",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(transfer_domain) } {
            return .{ .service_metadata = service_metadata, .action = transfer_domain };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DomainLimitExceeded,
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const transfer_domain_to_another_aws_account: struct {
    action_name: []const u8 = "TransferDomainToAnotherAwsAccount",
    Request: type = struct {
        domain_name: []const u8,
        account_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .account_id = "AccountId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(transfer_domain_to_another_aws_account) } {
            return .{ .service_metadata = service_metadata, .action = transfer_domain_to_another_aws_account };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,
        password: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
                .password = "Password",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const update_domain_contact: struct {
    action_name: []const u8 = "UpdateDomainContact",
    Request: type = struct {
        domain_name: []const u8,
        admin_contact: ?ContactDetail = null,
        registrant_contact: ?ContactDetail = null,
        tech_contact: ?ContactDetail = null,
        consent: ?struct {
            max_price: f64,
            currency: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .max_price = "MaxPrice",
                    .currency = "Currency",
                };
                return @field(mappings, field_name);
            }
        } = null,
        billing_contact: ?ContactDetail = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .admin_contact = "AdminContact",
                .registrant_contact = "RegistrantContact",
                .tech_contact = "TechContact",
                .consent = "Consent",
                .billing_contact = "BillingContact",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_domain_contact) } {
            return .{ .service_metadata = service_metadata, .action = update_domain_contact };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const update_domain_contact_privacy: struct {
    action_name: []const u8 = "UpdateDomainContactPrivacy",
    Request: type = struct {
        domain_name: []const u8,
        admin_privacy: ?bool = null,
        registrant_privacy: ?bool = null,
        tech_privacy: ?bool = null,
        billing_privacy: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .admin_privacy = "AdminPrivacy",
                .registrant_privacy = "RegistrantPrivacy",
                .tech_privacy = "TechPrivacy",
                .billing_privacy = "BillingPrivacy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_domain_contact_privacy) } {
            return .{ .service_metadata = service_metadata, .action = update_domain_contact_privacy };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const update_domain_nameservers: struct {
    action_name: []const u8 = "UpdateDomainNameservers",
    Request: type = struct {
        domain_name: []const u8,
        fi_auth_key: ?[]const u8 = null,
        nameservers: []Nameserver,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .fi_auth_key = "FIAuthKey",
                .nameservers = "Nameservers",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_domain_nameservers) } {
            return .{ .service_metadata = service_metadata, .action = update_domain_nameservers };
        }
    },
    Response: type = struct {
        operation_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "OperationId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DuplicateRequest,
        InvalidInput,
        OperationLimitExceeded,
        TLDRulesViolation,
        UnsupportedTLD,
    },
} = .{};
pub const update_tags_for_domain: struct {
    action_name: []const u8 = "UpdateTagsForDomain",
    Request: type = struct {
        domain_name: []const u8,
        tags_to_update: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "DomainName",
                .tags_to_update = "TagsToUpdate",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_tags_for_domain) } {
            return .{ .service_metadata = service_metadata, .action = update_tags_for_domain };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
        OperationLimitExceeded,
        UnsupportedTLD,
    },
} = .{};
pub const view_billing: struct {
    action_name: []const u8 = "ViewBilling",
    Request: type = struct {
        start: ?i64 = null,
        end: ?i64 = null,
        marker: ?[]const u8 = null,
        max_items: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .start = "Start",
                .end = "End",
                .marker = "Marker",
                .max_items = "MaxItems",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(view_billing) } {
            return .{ .service_metadata = service_metadata, .action = view_billing };
        }
    },
    Response: type = struct {
        next_page_marker: ?[]const u8 = null,
        billing_records: ?[]struct {
            domain_name: ?[]const u8 = null,
            operation: ?[]const u8 = null,
            invoice_id: ?[]const u8 = null,
            bill_date: ?i64 = null,
            price: ?f64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .domain_name = "DomainName",
                    .operation = "Operation",
                    .invoice_id = "InvoiceId",
                    .bill_date = "BillDate",
                    .price = "Price",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_page_marker = "NextPageMarker",
                .billing_records = "BillingRecords",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidInput,
    },
} = .{};

pub const Tag = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const Nameserver = struct {
    name: []const u8,
    glue_ips: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .glue_ips = "GlueIps",
        };
        return @field(mappings, field_name);
    }
};

pub const ContactDetail = struct {
    first_name: ?[]const u8 = null,
    last_name: ?[]const u8 = null,
    contact_type: ?[]const u8 = null,
    organization_name: ?[]const u8 = null,
    address_line1: ?[]const u8 = null,
    address_line2: ?[]const u8 = null,
    city: ?[]const u8 = null,
    state: ?[]const u8 = null,
    country_code: ?[]const u8 = null,
    zip_code: ?[]const u8 = null,
    phone_number: ?[]const u8 = null,
    email: ?[]const u8 = null,
    fax: ?[]const u8 = null,
    extra_params: ?[]ExtraParam = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .first_name = "FirstName",
            .last_name = "LastName",
            .contact_type = "ContactType",
            .organization_name = "OrganizationName",
            .address_line1 = "AddressLine1",
            .address_line2 = "AddressLine2",
            .city = "City",
            .state = "State",
            .country_code = "CountryCode",
            .zip_code = "ZipCode",
            .phone_number = "PhoneNumber",
            .email = "Email",
            .fax = "Fax",
            .extra_params = "ExtraParams",
        };
        return @field(mappings, field_name);
    }
};

pub const ExtraParam = struct {
    name: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const PriceWithCurrency = struct {
    price: f64,
    currency: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .price = "Price",
            .currency = "Currency",
        };
        return @field(mappings, field_name);
    }
};
