const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2022-09-30";
pub const sdk_id: []const u8 = "SageMaker Metrics";
pub const arn_namespace: ?[]const u8 = "sagemaker";
pub const endpoint_prefix: []const u8 = "metrics.sagemaker";
pub const sigv4_name: []const u8 = "sagemaker";
pub const name: []const u8 = "SageMakerMetricsService";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2022-09-30",
    sdk_id: []const u8 = "SageMaker Metrics",
    arn_namespace: ?[]const u8 = "sagemaker",
    endpoint_prefix: []const u8 = "metrics.sagemaker",
    sigv4_name: []const u8 = "sagemaker",
    name: []const u8 = "SageMakerMetricsService",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const batch_put_metrics: struct {
    pub const http_config = .{
        .method = "PUT",
        .uri = "/BatchPutMetrics",
        .success_code = 200,
    };

    action_name: []const u8 = "BatchPutMetrics",
    Request: type = struct {
        trial_component_name: []const u8,
        metric_data: []struct {
            metric_name: []const u8,
            timestamp: i64,
            step: ?i64 = null,
            value: f64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .metric_name = "MetricName",
                    .timestamp = "Timestamp",
                    .step = "Step",
                    .value = "Value",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .trial_component_name = "TrialComponentName",
                .metric_data = "MetricData",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_put_metrics) } {
            return .{ .service_metadata = service_metadata, .action = batch_put_metrics };
        }
    },
    Response: type = struct {
        errors: ?[]struct {
            code: ?[]const u8 = null,
            metric_index: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .code = "Code",
                    .metric_index = "MetricIndex",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .errors = "Errors",
            };
            return @field(mappings, field_name);
        }
    },
} = .{};
