const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2019-06-24";
pub const sdk_id: []const u8 = "Service Quotas";
pub const arn_namespace: ?[]const u8 = "servicequotas";
pub const endpoint_prefix: []const u8 = "servicequotas";
pub const sigv4_name: []const u8 = "servicequotas";
pub const name: []const u8 = "ServiceQuotasV20190624";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2019-06-24",
    sdk_id: []const u8 = "Service Quotas",
    arn_namespace: ?[]const u8 = "servicequotas",
    endpoint_prefix: []const u8 = "servicequotas",
    sigv4_name: []const u8 = "servicequotas",
    name: []const u8 = "ServiceQuotasV20190624",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_service_quota_template: struct {
    action_name: []const u8 = "AssociateServiceQuotaTemplate",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_service_quota_template) } {
            return .{ .service_metadata = service_metadata, .action = associate_service_quota_template };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        NoAvailableOrganization,
        OrganizationNotInAllFeaturesMode,
        Service,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const delete_service_quota_increase_request_from_template: struct {
    action_name: []const u8 = "DeleteServiceQuotaIncreaseRequestFromTemplate",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,
        aws_region: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
                .aws_region = "AwsRegion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_service_quota_increase_request_from_template) } {
            return .{ .service_metadata = service_metadata, .action = delete_service_quota_increase_request_from_template };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        IllegalArgument,
        NoAvailableOrganization,
        NoSuchResource,
        Service,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const disassociate_service_quota_template: struct {
    action_name: []const u8 = "DisassociateServiceQuotaTemplate",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_service_quota_template) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_service_quota_template };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        NoAvailableOrganization,
        Service,
        ServiceQuotaTemplateNotInUse,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const get_association_for_service_quota_template: struct {
    action_name: []const u8 = "GetAssociationForServiceQuotaTemplate",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_association_for_service_quota_template) } {
            return .{ .service_metadata = service_metadata, .action = get_association_for_service_quota_template };
        }
    },
    Response: type = struct {
        service_quota_template_association_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_quota_template_association_status = "ServiceQuotaTemplateAssociationStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        NoAvailableOrganization,
        Service,
        ServiceQuotaTemplateNotInUse,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const get_aws_default_service_quota: struct {
    action_name: []const u8 = "GetAWSDefaultServiceQuota",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_aws_default_service_quota) } {
            return .{ .service_metadata = service_metadata, .action = get_aws_default_service_quota };
        }
    },
    Response: type = struct {
        quota: ?ServiceQuota = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .quota = "Quota",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const get_requested_service_quota_change: struct {
    action_name: []const u8 = "GetRequestedServiceQuotaChange",
    Request: type = struct {
        request_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .request_id = "RequestId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_requested_service_quota_change) } {
            return .{ .service_metadata = service_metadata, .action = get_requested_service_quota_change };
        }
    },
    Response: type = struct {
        requested_quota: ?RequestedServiceQuotaChange = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .requested_quota = "RequestedQuota",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const get_service_quota: struct {
    action_name: []const u8 = "GetServiceQuota",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,
        context_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
                .context_id = "ContextId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_service_quota) } {
            return .{ .service_metadata = service_metadata, .action = get_service_quota };
        }
    },
    Response: type = struct {
        quota: ?ServiceQuota = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .quota = "Quota",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const get_service_quota_increase_request_from_template: struct {
    action_name: []const u8 = "GetServiceQuotaIncreaseRequestFromTemplate",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,
        aws_region: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
                .aws_region = "AwsRegion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_service_quota_increase_request_from_template) } {
            return .{ .service_metadata = service_metadata, .action = get_service_quota_increase_request_from_template };
        }
    },
    Response: type = struct {
        service_quota_increase_request_in_template: ?ServiceQuotaIncreaseRequestInTemplate = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_quota_increase_request_in_template = "ServiceQuotaIncreaseRequestInTemplate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        IllegalArgument,
        NoAvailableOrganization,
        NoSuchResource,
        Service,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const list_aws_default_service_quotas: struct {
    action_name: []const u8 = "ListAWSDefaultServiceQuotas",
    Request: type = struct {
        service_code: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_aws_default_service_quotas) } {
            return .{ .service_metadata = service_metadata, .action = list_aws_default_service_quotas };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        quotas: ?[]ServiceQuota = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .quotas = "Quotas",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        InvalidPaginationToken,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const list_requested_service_quota_change_history: struct {
    action_name: []const u8 = "ListRequestedServiceQuotaChangeHistory",
    Request: type = struct {
        service_code: ?[]const u8 = null,
        status: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        quota_requested_at_level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .status = "Status",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .quota_requested_at_level = "QuotaRequestedAtLevel",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_requested_service_quota_change_history) } {
            return .{ .service_metadata = service_metadata, .action = list_requested_service_quota_change_history };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        requested_quotas: ?[]RequestedServiceQuotaChange = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .requested_quotas = "RequestedQuotas",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        InvalidPaginationToken,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const list_requested_service_quota_change_history_by_quota: struct {
    action_name: []const u8 = "ListRequestedServiceQuotaChangeHistoryByQuota",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,
        status: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        quota_requested_at_level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
                .status = "Status",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .quota_requested_at_level = "QuotaRequestedAtLevel",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_requested_service_quota_change_history_by_quota) } {
            return .{ .service_metadata = service_metadata, .action = list_requested_service_quota_change_history_by_quota };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        requested_quotas: ?[]RequestedServiceQuotaChange = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .requested_quotas = "RequestedQuotas",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        InvalidPaginationToken,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const list_service_quota_increase_requests_in_template: struct {
    action_name: []const u8 = "ListServiceQuotaIncreaseRequestsInTemplate",
    Request: type = struct {
        service_code: ?[]const u8 = null,
        aws_region: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .aws_region = "AwsRegion",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_service_quota_increase_requests_in_template) } {
            return .{ .service_metadata = service_metadata, .action = list_service_quota_increase_requests_in_template };
        }
    },
    Response: type = struct {
        service_quota_increase_request_in_template_list: ?[]ServiceQuotaIncreaseRequestInTemplate = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_quota_increase_request_in_template_list = "ServiceQuotaIncreaseRequestInTemplateList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        IllegalArgument,
        NoAvailableOrganization,
        Service,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const list_service_quotas: struct {
    action_name: []const u8 = "ListServiceQuotas",
    Request: type = struct {
        service_code: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        quota_code: ?[]const u8 = null,
        quota_applied_at_level: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .quota_code = "QuotaCode",
                .quota_applied_at_level = "QuotaAppliedAtLevel",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_service_quotas) } {
            return .{ .service_metadata = service_metadata, .action = list_service_quotas };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        quotas: ?[]ServiceQuota = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .quotas = "Quotas",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        InvalidPaginationToken,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const list_services: struct {
    action_name: []const u8 = "ListServices",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_services) } {
            return .{ .service_metadata = service_metadata, .action = list_services };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        services: ?[]struct {
            service_code: ?[]const u8 = null,
            service_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .service_code = "ServiceCode",
                    .service_name = "ServiceName",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .services = "Services",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        InvalidPaginationToken,
        Service,
        TooManyRequests,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};
pub const put_service_quota_increase_request_into_template: struct {
    action_name: []const u8 = "PutServiceQuotaIncreaseRequestIntoTemplate",
    Request: type = struct {
        quota_code: []const u8,
        service_code: []const u8,
        aws_region: []const u8,
        desired_value: f64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .quota_code = "QuotaCode",
                .service_code = "ServiceCode",
                .aws_region = "AwsRegion",
                .desired_value = "DesiredValue",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_service_quota_increase_request_into_template) } {
            return .{ .service_metadata = service_metadata, .action = put_service_quota_increase_request_into_template };
        }
    },
    Response: type = struct {
        service_quota_increase_request_in_template: ?ServiceQuotaIncreaseRequestInTemplate = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_quota_increase_request_in_template = "ServiceQuotaIncreaseRequestInTemplate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AWSServiceAccessNotEnabled,
        DependencyAccessDenied,
        IllegalArgument,
        NoAvailableOrganization,
        NoSuchResource,
        QuotaExceeded,
        Service,
        TemplatesNotAvailableInRegion,
        TooManyRequests,
    },
} = .{};
pub const request_service_quota_increase: struct {
    action_name: []const u8 = "RequestServiceQuotaIncrease",
    Request: type = struct {
        service_code: []const u8,
        quota_code: []const u8,
        desired_value: f64,
        context_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_code = "ServiceCode",
                .quota_code = "QuotaCode",
                .desired_value = "DesiredValue",
                .context_id = "ContextId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(request_service_quota_increase) } {
            return .{ .service_metadata = service_metadata, .action = request_service_quota_increase };
        }
    },
    Response: type = struct {
        requested_quota: ?RequestedServiceQuotaChange = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .requested_quota = "RequestedQuota",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        DependencyAccessDenied,
        IllegalArgument,
        InvalidResourceState,
        NoSuchResource,
        QuotaExceeded,
        ResourceAlreadyExists,
        Service,
        TooManyRequests,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TagPolicyViolation,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        IllegalArgument,
        NoSuchResource,
        Service,
        TooManyRequests,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const RequestedServiceQuotaChange = struct {
    id: ?[]const u8 = null,
    case_id: ?[]const u8 = null,
    service_code: ?[]const u8 = null,
    service_name: ?[]const u8 = null,
    quota_code: ?[]const u8 = null,
    quota_name: ?[]const u8 = null,
    desired_value: ?f64 = null,
    status: ?[]const u8 = null,
    created: ?i64 = null,
    last_updated: ?i64 = null,
    requester: ?[]const u8 = null,
    quota_arn: ?[]const u8 = null,
    global_quota: ?bool = null,
    unit: ?[]const u8 = null,
    quota_requested_at_level: ?[]const u8 = null,
    quota_context: ?QuotaContextInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .case_id = "CaseId",
            .service_code = "ServiceCode",
            .service_name = "ServiceName",
            .quota_code = "QuotaCode",
            .quota_name = "QuotaName",
            .desired_value = "DesiredValue",
            .status = "Status",
            .created = "Created",
            .last_updated = "LastUpdated",
            .requester = "Requester",
            .quota_arn = "QuotaArn",
            .global_quota = "GlobalQuota",
            .unit = "Unit",
            .quota_requested_at_level = "QuotaRequestedAtLevel",
            .quota_context = "QuotaContext",
        };
        return @field(mappings, field_name);
    }
};

pub const QuotaContextInfo = struct {
    context_scope: ?[]const u8 = null,
    context_scope_type: ?[]const u8 = null,
    context_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .context_scope = "ContextScope",
            .context_scope_type = "ContextScopeType",
            .context_id = "ContextId",
        };
        return @field(mappings, field_name);
    }
};

pub const ServiceQuotaIncreaseRequestInTemplate = struct {
    service_code: ?[]const u8 = null,
    service_name: ?[]const u8 = null,
    quota_code: ?[]const u8 = null,
    quota_name: ?[]const u8 = null,
    desired_value: ?f64 = null,
    aws_region: ?[]const u8 = null,
    unit: ?[]const u8 = null,
    global_quota: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .service_code = "ServiceCode",
            .service_name = "ServiceName",
            .quota_code = "QuotaCode",
            .quota_name = "QuotaName",
            .desired_value = "DesiredValue",
            .aws_region = "AwsRegion",
            .unit = "Unit",
            .global_quota = "GlobalQuota",
        };
        return @field(mappings, field_name);
    }
};

pub const ServiceQuota = struct {
    service_code: ?[]const u8 = null,
    service_name: ?[]const u8 = null,
    quota_arn: ?[]const u8 = null,
    quota_code: ?[]const u8 = null,
    quota_name: ?[]const u8 = null,
    value: ?f64 = null,
    unit: ?[]const u8 = null,
    adjustable: ?bool = null,
    global_quota: ?bool = null,
    usage_metric: ?MetricInfo = null,
    period: ?QuotaPeriod = null,
    error_reason: ?ErrorReason = null,
    quota_applied_at_level: ?[]const u8 = null,
    quota_context: ?QuotaContextInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .service_code = "ServiceCode",
            .service_name = "ServiceName",
            .quota_arn = "QuotaArn",
            .quota_code = "QuotaCode",
            .quota_name = "QuotaName",
            .value = "Value",
            .unit = "Unit",
            .adjustable = "Adjustable",
            .global_quota = "GlobalQuota",
            .usage_metric = "UsageMetric",
            .period = "Period",
            .error_reason = "ErrorReason",
            .quota_applied_at_level = "QuotaAppliedAtLevel",
            .quota_context = "QuotaContext",
        };
        return @field(mappings, field_name);
    }
};

pub const ErrorReason = struct {
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};

pub const QuotaPeriod = struct {
    period_value: ?i64 = null,
    period_unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .period_value = "PeriodValue",
            .period_unit = "PeriodUnit",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricInfo = struct {
    metric_namespace: ?[]const u8 = null,
    metric_name: ?[]const u8 = null,
    metric_dimensions: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    metric_statistic_recommendation: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_namespace = "MetricNamespace",
            .metric_name = "MetricName",
            .metric_dimensions = "MetricDimensions",
            .metric_statistic_recommendation = "MetricStatisticRecommendation",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "metric_dimensions", field_name))
            return try serializeMap(self.metric_dimensions, self.fieldNameFor("metric_dimensions"), options, out_stream);
        return false;
    }
};
