const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2016-06-02";
pub const sdk_id: []const u8 = "Shield";
pub const arn_namespace: ?[]const u8 = "shield";
pub const endpoint_prefix: []const u8 = "shield";
pub const sigv4_name: []const u8 = "shield";
pub const name: []const u8 = "AWSShield_20160616";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2016-06-02",
    sdk_id: []const u8 = "Shield",
    arn_namespace: ?[]const u8 = "shield",
    endpoint_prefix: []const u8 = "shield",
    sigv4_name: []const u8 = "shield",
    name: []const u8 = "AWSShield_20160616",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_drt_log_bucket: struct {
    action_name: []const u8 = "AssociateDRTLogBucket",
    Request: type = struct {
        log_bucket: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_bucket = "LogBucket",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_drt_log_bucket) } {
            return .{ .service_metadata = service_metadata, .action = associate_drt_log_bucket };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDeniedForDependency,
        InternalError,
        InvalidOperation,
        InvalidParameter,
        LimitsExceeded,
        NoAssociatedRole,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const associate_drt_role: struct {
    action_name: []const u8 = "AssociateDRTRole",
    Request: type = struct {
        role_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_arn = "RoleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_drt_role) } {
            return .{ .service_metadata = service_metadata, .action = associate_drt_role };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDeniedForDependency,
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const associate_health_check: struct {
    action_name: []const u8 = "AssociateHealthCheck",
    Request: type = struct {
        protection_id: []const u8,
        health_check_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_id = "ProtectionId",
                .health_check_arn = "HealthCheckArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_health_check) } {
            return .{ .service_metadata = service_metadata, .action = associate_health_check };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        InvalidResource,
        LimitsExceeded,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const associate_proactive_engagement_details: struct {
    action_name: []const u8 = "AssociateProactiveEngagementDetails",
    Request: type = struct {
        emergency_contact_list: []EmergencyContact,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .emergency_contact_list = "EmergencyContactList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_proactive_engagement_details) } {
            return .{ .service_metadata = service_metadata, .action = associate_proactive_engagement_details };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const create_protection: struct {
    action_name: []const u8 = "CreateProtection",
    Request: type = struct {
        name: []const u8,
        resource_arn: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_protection) } {
            return .{ .service_metadata = service_metadata, .action = create_protection };
        }
    },
    Response: type = struct {
        protection_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_id = "ProtectionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        InvalidResource,
        LimitsExceeded,
        OptimisticLock,
        ResourceAlreadyExists,
        ResourceNotFound,
    },
} = .{};
pub const create_protection_group: struct {
    action_name: []const u8 = "CreateProtectionGroup",
    Request: type = struct {
        protection_group_id: []const u8,
        aggregation: []const u8,
        pattern: []const u8,
        resource_type: ?[]const u8 = null,
        members: ?[][]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group_id = "ProtectionGroupId",
                .aggregation = "Aggregation",
                .pattern = "Pattern",
                .resource_type = "ResourceType",
                .members = "Members",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_protection_group) } {
            return .{ .service_metadata = service_metadata, .action = create_protection_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        LimitsExceeded,
        OptimisticLock,
        ResourceAlreadyExists,
        ResourceNotFound,
    },
} = .{};
pub const create_subscription: struct {
    action_name: []const u8 = "CreateSubscription",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_subscription) } {
            return .{ .service_metadata = service_metadata, .action = create_subscription };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceAlreadyExists,
    },
} = .{};
pub const delete_protection: struct {
    action_name: []const u8 = "DeleteProtection",
    Request: type = struct {
        protection_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_id = "ProtectionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_protection) } {
            return .{ .service_metadata = service_metadata, .action = delete_protection };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const delete_protection_group: struct {
    action_name: []const u8 = "DeleteProtectionGroup",
    Request: type = struct {
        protection_group_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group_id = "ProtectionGroupId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_protection_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_protection_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const delete_subscription: struct {
    action_name: []const u8 = "DeleteSubscription",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_subscription) } {
            return .{ .service_metadata = service_metadata, .action = delete_subscription };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        LockedSubscription,
        ResourceNotFound,
    },
} = .{};
pub const describe_attack: struct {
    action_name: []const u8 = "DescribeAttack",
    Request: type = struct {
        attack_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attack_id = "AttackId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_attack) } {
            return .{ .service_metadata = service_metadata, .action = describe_attack };
        }
    },
    Response: type = struct {
        attack: ?struct {
            attack_id: ?[]const u8 = null,
            resource_arn: ?[]const u8 = null,
            sub_resources: ?[]struct {
                type: ?[]const u8 = null,
                id: ?[]const u8 = null,
                attack_vectors: ?[]struct {
                    vector_type: []const u8,
                    vector_counters: ?[]SummarizedCounter = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .vector_type = "VectorType",
                            .vector_counters = "VectorCounters",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                counters: ?[]SummarizedCounter = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .type = "Type",
                        .id = "Id",
                        .attack_vectors = "AttackVectors",
                        .counters = "Counters",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            attack_counters: ?[]SummarizedCounter = null,
            attack_properties: ?[]struct {
                attack_layer: ?[]const u8 = null,
                attack_property_identifier: ?[]const u8 = null,
                top_contributors: ?[]struct {
                    name: ?[]const u8 = null,
                    value: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .name = "Name",
                            .value = "Value",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                unit: ?[]const u8 = null,
                total: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .attack_layer = "AttackLayer",
                        .attack_property_identifier = "AttackPropertyIdentifier",
                        .top_contributors = "TopContributors",
                        .unit = "Unit",
                        .total = "Total",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            mitigations: ?[]struct {
                mitigation_name: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .mitigation_name = "MitigationName",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .attack_id = "AttackId",
                    .resource_arn = "ResourceArn",
                    .sub_resources = "SubResources",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .attack_counters = "AttackCounters",
                    .attack_properties = "AttackProperties",
                    .mitigations = "Mitigations",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attack = "Attack",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalError,
    },
} = .{};
pub const describe_attack_statistics: struct {
    action_name: []const u8 = "DescribeAttackStatistics",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_attack_statistics) } {
            return .{ .service_metadata = service_metadata, .action = describe_attack_statistics };
        }
    },
    Response: type = struct {
        time_range: TimeRange,
        data_items: []struct {
            attack_volume: ?struct {
                bits_per_second: ?AttackVolumeStatistics = null,
                packets_per_second: ?AttackVolumeStatistics = null,
                requests_per_second: ?AttackVolumeStatistics = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .bits_per_second = "BitsPerSecond",
                        .packets_per_second = "PacketsPerSecond",
                        .requests_per_second = "RequestsPerSecond",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            attack_count: i64,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .attack_volume = "AttackVolume",
                    .attack_count = "AttackCount",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .time_range = "TimeRange",
                .data_items = "DataItems",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
    },
} = .{};
pub const describe_drt_access: struct {
    action_name: []const u8 = "DescribeDRTAccess",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_drt_access) } {
            return .{ .service_metadata = service_metadata, .action = describe_drt_access };
        }
    },
    Response: type = struct {
        role_arn: ?[]const u8 = null,
        log_bucket_list: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .role_arn = "RoleArn",
                .log_bucket_list = "LogBucketList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const describe_emergency_contact_settings: struct {
    action_name: []const u8 = "DescribeEmergencyContactSettings",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_emergency_contact_settings) } {
            return .{ .service_metadata = service_metadata, .action = describe_emergency_contact_settings };
        }
    },
    Response: type = struct {
        emergency_contact_list: ?[]EmergencyContact = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .emergency_contact_list = "EmergencyContactList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const describe_protection: struct {
    action_name: []const u8 = "DescribeProtection",
    Request: type = struct {
        protection_id: ?[]const u8 = null,
        resource_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_id = "ProtectionId",
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_protection) } {
            return .{ .service_metadata = service_metadata, .action = describe_protection };
        }
    },
    Response: type = struct {
        protection: ?Protection = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection = "Protection",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        ResourceNotFound,
    },
} = .{};
pub const describe_protection_group: struct {
    action_name: []const u8 = "DescribeProtectionGroup",
    Request: type = struct {
        protection_group_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group_id = "ProtectionGroupId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_protection_group) } {
            return .{ .service_metadata = service_metadata, .action = describe_protection_group };
        }
    },
    Response: type = struct {
        protection_group: ProtectionGroup,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group = "ProtectionGroup",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const describe_subscription: struct {
    action_name: []const u8 = "DescribeSubscription",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_subscription) } {
            return .{ .service_metadata = service_metadata, .action = describe_subscription };
        }
    },
    Response: type = struct {
        subscription: ?struct {
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            time_commitment_in_seconds: ?i64 = null,
            auto_renew: ?[]const u8 = null,
            limits: ?[]Limit = null,
            proactive_engagement_status: ?[]const u8 = null,
            subscription_limits: struct {
                protection_limits: struct {
                    protected_resource_type_limits: []Limit,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .protected_resource_type_limits = "ProtectedResourceTypeLimits",
                        };
                        return @field(mappings, field_name);
                    }
                },
                protection_group_limits: struct {
                    max_protection_groups: i64,
                    pattern_type_limits: struct {
                        arbitrary_pattern_limits: struct {
                            max_members: i64,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .max_members = "MaxMembers",
                                };
                                return @field(mappings, field_name);
                            }
                        },

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .arbitrary_pattern_limits = "ArbitraryPatternLimits",
                            };
                            return @field(mappings, field_name);
                        }
                    },

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .max_protection_groups = "MaxProtectionGroups",
                            .pattern_type_limits = "PatternTypeLimits",
                        };
                        return @field(mappings, field_name);
                    }
                },

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .protection_limits = "ProtectionLimits",
                        .protection_group_limits = "ProtectionGroupLimits",
                    };
                    return @field(mappings, field_name);
                }
            },
            subscription_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .time_commitment_in_seconds = "TimeCommitmentInSeconds",
                    .auto_renew = "AutoRenew",
                    .limits = "Limits",
                    .proactive_engagement_status = "ProactiveEngagementStatus",
                    .subscription_limits = "SubscriptionLimits",
                    .subscription_arn = "SubscriptionArn",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .subscription = "Subscription",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const disable_application_layer_automatic_response: struct {
    action_name: []const u8 = "DisableApplicationLayerAutomaticResponse",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_application_layer_automatic_response) } {
            return .{ .service_metadata = service_metadata, .action = disable_application_layer_automatic_response };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const disable_proactive_engagement: struct {
    action_name: []const u8 = "DisableProactiveEngagement",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_proactive_engagement) } {
            return .{ .service_metadata = service_metadata, .action = disable_proactive_engagement };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_drt_log_bucket: struct {
    action_name: []const u8 = "DisassociateDRTLogBucket",
    Request: type = struct {
        log_bucket: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_bucket = "LogBucket",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_drt_log_bucket) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_drt_log_bucket };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDeniedForDependency,
        InternalError,
        InvalidOperation,
        NoAssociatedRole,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_drt_role: struct {
    action_name: []const u8 = "DisassociateDRTRole",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_drt_role) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_drt_role };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_health_check: struct {
    action_name: []const u8 = "DisassociateHealthCheck",
    Request: type = struct {
        protection_id: []const u8,
        health_check_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_id = "ProtectionId",
                .health_check_arn = "HealthCheckArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_health_check) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_health_check };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        InvalidResource,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const enable_application_layer_automatic_response: struct {
    action_name: []const u8 = "EnableApplicationLayerAutomaticResponse",
    Request: type = struct {
        resource_arn: []const u8,
        action: ResponseAction,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .action = "Action",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_application_layer_automatic_response) } {
            return .{ .service_metadata = service_metadata, .action = enable_application_layer_automatic_response };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        LimitsExceeded,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const enable_proactive_engagement: struct {
    action_name: []const u8 = "EnableProactiveEngagement",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_proactive_engagement) } {
            return .{ .service_metadata = service_metadata, .action = enable_proactive_engagement };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const get_subscription_state: struct {
    action_name: []const u8 = "GetSubscriptionState",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_subscription_state) } {
            return .{ .service_metadata = service_metadata, .action = get_subscription_state };
        }
    },
    Response: type = struct {
        subscription_state: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .subscription_state = "SubscriptionState",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
    },
} = .{};
pub const list_attacks: struct {
    action_name: []const u8 = "ListAttacks",
    Request: type = struct {
        resource_arns: ?[][]const u8 = null,
        start_time: ?TimeRange = null,
        end_time: ?TimeRange = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arns = "ResourceArns",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_attacks) } {
            return .{ .service_metadata = service_metadata, .action = list_attacks };
        }
    },
    Response: type = struct {
        attack_summaries: ?[]struct {
            attack_id: ?[]const u8 = null,
            resource_arn: ?[]const u8 = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,
            attack_vectors: ?[]struct {
                vector_type: []const u8,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .vector_type = "VectorType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .attack_id = "AttackId",
                    .resource_arn = "ResourceArn",
                    .start_time = "StartTime",
                    .end_time = "EndTime",
                    .attack_vectors = "AttackVectors",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .attack_summaries = "AttackSummaries",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
    },
} = .{};
pub const list_protection_groups: struct {
    action_name: []const u8 = "ListProtectionGroups",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        inclusion_filters: ?struct {
            protection_group_ids: ?[][]const u8 = null,
            patterns: ?[][]const u8 = null,
            resource_types: ?[][]const u8 = null,
            aggregations: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .protection_group_ids = "ProtectionGroupIds",
                    .patterns = "Patterns",
                    .resource_types = "ResourceTypes",
                    .aggregations = "Aggregations",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .inclusion_filters = "InclusionFilters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_protection_groups) } {
            return .{ .service_metadata = service_metadata, .action = list_protection_groups };
        }
    },
    Response: type = struct {
        protection_groups: []ProtectionGroup,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_groups = "ProtectionGroups",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidPaginationToken,
        ResourceNotFound,
    },
} = .{};
pub const list_protections: struct {
    action_name: []const u8 = "ListProtections",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,
        inclusion_filters: ?struct {
            resource_arns: ?[][]const u8 = null,
            protection_names: ?[][]const u8 = null,
            resource_types: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_arns = "ResourceArns",
                    .protection_names = "ProtectionNames",
                    .resource_types = "ResourceTypes",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
                .inclusion_filters = "InclusionFilters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_protections) } {
            return .{ .service_metadata = service_metadata, .action = list_protections };
        }
    },
    Response: type = struct {
        protections: ?[]Protection = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protections = "Protections",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidPaginationToken,
        ResourceNotFound,
    },
} = .{};
pub const list_resources_in_protection_group: struct {
    action_name: []const u8 = "ListResourcesInProtectionGroup",
    Request: type = struct {
        protection_group_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group_id = "ProtectionGroupId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_resources_in_protection_group) } {
            return .{ .service_metadata = service_metadata, .action = list_resources_in_protection_group };
        }
    },
    Response: type = struct {
        resource_arns: [][]const u8,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arns = "ResourceArns",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidPaginationToken,
        ResourceNotFound,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidResource,
        ResourceNotFound,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        InvalidResource,
        ResourceNotFound,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceARN",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        InvalidResource,
        ResourceNotFound,
    },
} = .{};
pub const update_application_layer_automatic_response: struct {
    action_name: []const u8 = "UpdateApplicationLayerAutomaticResponse",
    Request: type = struct {
        resource_arn: []const u8,
        action: ResponseAction,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .action = "Action",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_application_layer_automatic_response) } {
            return .{ .service_metadata = service_metadata, .action = update_application_layer_automatic_response };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const update_emergency_contact_settings: struct {
    action_name: []const u8 = "UpdateEmergencyContactSettings",
    Request: type = struct {
        emergency_contact_list: ?[]EmergencyContact = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .emergency_contact_list = "EmergencyContactList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_emergency_contact_settings) } {
            return .{ .service_metadata = service_metadata, .action = update_emergency_contact_settings };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const update_protection_group: struct {
    action_name: []const u8 = "UpdateProtectionGroup",
    Request: type = struct {
        protection_group_id: []const u8,
        aggregation: []const u8,
        pattern: []const u8,
        resource_type: ?[]const u8 = null,
        members: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protection_group_id = "ProtectionGroupId",
                .aggregation = "Aggregation",
                .pattern = "Pattern",
                .resource_type = "ResourceType",
                .members = "Members",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_protection_group) } {
            return .{ .service_metadata = service_metadata, .action = update_protection_group };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};
pub const update_subscription: struct {
    action_name: []const u8 = "UpdateSubscription",
    Request: type = struct {
        auto_renew: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .auto_renew = "AutoRenew",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_subscription) } {
            return .{ .service_metadata = service_metadata, .action = update_subscription };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidParameter,
        LockedSubscription,
        OptimisticLock,
        ResourceNotFound,
    },
} = .{};

pub const EmergencyContact = struct {
    email_address: []const u8,
    phone_number: ?[]const u8 = null,
    contact_notes: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .email_address = "EmailAddress",
            .phone_number = "PhoneNumber",
            .contact_notes = "ContactNotes",
        };
        return @field(mappings, field_name);
    }
};

pub const ResponseAction = struct {
    block: ?BlockAction = null,
    count: ?CountAction = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .block = "Block",
            .count = "Count",
        };
        return @field(mappings, field_name);
    }
};

pub const CountAction = struct {

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{};
        return @field(mappings, field_name);
    }
};

pub const BlockAction = struct {

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{};
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const Protection = struct {
    id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    resource_arn: ?[]const u8 = null,
    health_check_ids: ?[][]const u8 = null,
    protection_arn: ?[]const u8 = null,
    application_layer_automatic_response_configuration: ?ApplicationLayerAutomaticResponseConfiguration = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "Id",
            .name = "Name",
            .resource_arn = "ResourceArn",
            .health_check_ids = "HealthCheckIds",
            .protection_arn = "ProtectionArn",
            .application_layer_automatic_response_configuration = "ApplicationLayerAutomaticResponseConfiguration",
        };
        return @field(mappings, field_name);
    }
};

pub const ApplicationLayerAutomaticResponseConfiguration = struct {
    status: []const u8,
    action: ResponseAction,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .status = "Status",
            .action = "Action",
        };
        return @field(mappings, field_name);
    }
};

pub const ProtectionGroup = struct {
    protection_group_id: []const u8,
    aggregation: []const u8,
    pattern: []const u8,
    resource_type: ?[]const u8 = null,
    members: [][]const u8,
    protection_group_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .protection_group_id = "ProtectionGroupId",
            .aggregation = "Aggregation",
            .pattern = "Pattern",
            .resource_type = "ResourceType",
            .members = "Members",
            .protection_group_arn = "ProtectionGroupArn",
        };
        return @field(mappings, field_name);
    }
};

pub const TimeRange = struct {
    from_inclusive: ?i64 = null,
    to_exclusive: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .from_inclusive = "FromInclusive",
            .to_exclusive = "ToExclusive",
        };
        return @field(mappings, field_name);
    }
};

pub const Limit = struct {
    type: ?[]const u8 = null,
    max: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const AttackVolumeStatistics = struct {
    max: f64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .max = "Max",
        };
        return @field(mappings, field_name);
    }
};

pub const SummarizedCounter = struct {
    name: ?[]const u8 = null,
    max: ?f64 = null,
    average: ?f64 = null,
    sum: ?f64 = null,
    n: ?i64 = null,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .max = "Max",
            .average = "Average",
            .sum = "Sum",
            .n = "N",
            .unit = "Unit",
        };
        return @field(mappings, field_name);
    }
};
