const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2021-08-20";
pub const sdk_id: []const u8 = "Support App";
pub const arn_namespace: ?[]const u8 = "supportapp";
pub const endpoint_prefix: []const u8 = "";
pub const sigv4_name: []const u8 = "supportapp";
pub const name: []const u8 = "SupportApp";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1;

pub const service_metadata: struct {
    version: []const u8 = "2021-08-20",
    sdk_id: []const u8 = "Support App",
    arn_namespace: ?[]const u8 = "supportapp",
    endpoint_prefix: []const u8 = "",
    sigv4_name: []const u8 = "supportapp",
    name: []const u8 = "SupportApp",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.rest_json_1,
} = .{};
pub const create_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/create-slack-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateSlackChannelConfiguration",
    Request: type = struct {
        team_id: []const u8,
        channel_id: []const u8,
        channel_name: ?[]const u8 = null,
        notify_on_create_or_reopen_case: ?bool = null,
        notify_on_add_correspondence_to_case: ?bool = null,
        notify_on_resolve_case: ?bool = null,
        notify_on_case_severity: []const u8,
        channel_role_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
                .channel_id = "channelId",
                .channel_name = "channelName",
                .notify_on_create_or_reopen_case = "notifyOnCreateOrReopenCase",
                .notify_on_add_correspondence_to_case = "notifyOnAddCorrespondenceToCase",
                .notify_on_resolve_case = "notifyOnResolveCase",
                .notify_on_case_severity = "notifyOnCaseSeverity",
                .channel_role_arn = "channelRoleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = create_slack_channel_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ServiceQuotaExceeded,
        Validation,
    },
} = .{};
pub const delete_account_alias: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/delete-account-alias",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteAccountAlias",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_account_alias) } {
            return .{ .service_metadata = service_metadata, .action = delete_account_alias };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        ResourceNotFound,
    },
} = .{};
pub const delete_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/delete-slack-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteSlackChannelConfiguration",
    Request: type = struct {
        team_id: []const u8,
        channel_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
                .channel_id = "channelId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_slack_channel_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const delete_slack_workspace_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/delete-slack-workspace-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteSlackWorkspaceConfiguration",
    Request: type = struct {
        team_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_slack_workspace_configuration) } {
            return .{ .service_metadata = service_metadata, .action = delete_slack_workspace_configuration };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const get_account_alias: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/get-account-alias",
        .success_code = 200,
    };

    action_name: []const u8 = "GetAccountAlias",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_account_alias) } {
            return .{ .service_metadata = service_metadata, .action = get_account_alias };
        }
    },
    Response: type = struct {
        account_alias: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_alias = "accountAlias",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
    },
} = .{};
pub const list_slack_channel_configurations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/list-slack-channel-configurations",
        .success_code = 200,
    };

    action_name: []const u8 = "ListSlackChannelConfigurations",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_slack_channel_configurations) } {
            return .{ .service_metadata = service_metadata, .action = list_slack_channel_configurations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        slack_channel_configurations: []struct {
            team_id: []const u8,
            channel_id: []const u8,
            channel_name: ?[]const u8 = null,
            notify_on_create_or_reopen_case: ?bool = null,
            notify_on_add_correspondence_to_case: ?bool = null,
            notify_on_resolve_case: ?bool = null,
            notify_on_case_severity: ?[]const u8 = null,
            channel_role_arn: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .team_id = "teamId",
                    .channel_id = "channelId",
                    .channel_name = "channelName",
                    .notify_on_create_or_reopen_case = "notifyOnCreateOrReopenCase",
                    .notify_on_add_correspondence_to_case = "notifyOnAddCorrespondenceToCase",
                    .notify_on_resolve_case = "notifyOnResolveCase",
                    .notify_on_case_severity = "notifyOnCaseSeverity",
                    .channel_role_arn = "channelRoleArn",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .slack_channel_configurations = "slackChannelConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
    },
} = .{};
pub const list_slack_workspace_configurations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/list-slack-workspace-configurations",
        .success_code = 200,
    };

    action_name: []const u8 = "ListSlackWorkspaceConfigurations",
    Request: type = struct {
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_slack_workspace_configurations) } {
            return .{ .service_metadata = service_metadata, .action = list_slack_workspace_configurations };
        }
    },
    Response: type = struct {
        next_token: ?[]const u8 = null,
        slack_workspace_configurations: ?[]struct {
            team_id: []const u8,
            team_name: ?[]const u8 = null,
            allow_organization_member_account: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .team_id = "teamId",
                    .team_name = "teamName",
                    .allow_organization_member_account = "allowOrganizationMemberAccount",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .slack_workspace_configurations = "slackWorkspaceConfigurations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
    },
} = .{};
pub const put_account_alias: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/put-account-alias",
        .success_code = 200,
    };

    action_name: []const u8 = "PutAccountAlias",
    Request: type = struct {
        account_alias: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .account_alias = "accountAlias",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_account_alias) } {
            return .{ .service_metadata = service_metadata, .action = put_account_alias };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InternalServer,
        Validation,
    },
} = .{};
pub const register_slack_workspace_for_organization: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/register-slack-workspace-for-organization",
        .success_code = 200,
    };

    action_name: []const u8 = "RegisterSlackWorkspaceForOrganization",
    Request: type = struct {
        team_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_slack_workspace_for_organization) } {
            return .{ .service_metadata = service_metadata, .action = register_slack_workspace_for_organization };
        }
    },
    Response: type = struct {
        team_id: ?[]const u8 = null,
        team_name: ?[]const u8 = null,
        account_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
                .team_name = "teamName",
                .account_type = "accountType",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Validation,
    },
} = .{};
pub const update_slack_channel_configuration: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/control/update-slack-channel-configuration",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateSlackChannelConfiguration",
    Request: type = struct {
        team_id: []const u8,
        channel_id: []const u8,
        channel_name: ?[]const u8 = null,
        notify_on_create_or_reopen_case: ?bool = null,
        notify_on_add_correspondence_to_case: ?bool = null,
        notify_on_resolve_case: ?bool = null,
        notify_on_case_severity: ?[]const u8 = null,
        channel_role_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
                .channel_id = "channelId",
                .channel_name = "channelName",
                .notify_on_create_or_reopen_case = "notifyOnCreateOrReopenCase",
                .notify_on_add_correspondence_to_case = "notifyOnAddCorrespondenceToCase",
                .notify_on_resolve_case = "notifyOnResolveCase",
                .notify_on_case_severity = "notifyOnCaseSeverity",
                .channel_role_arn = "channelRoleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_slack_channel_configuration) } {
            return .{ .service_metadata = service_metadata, .action = update_slack_channel_configuration };
        }
    },
    Response: type = struct {
        team_id: ?[]const u8 = null,
        channel_id: ?[]const u8 = null,
        channel_name: ?[]const u8 = null,
        notify_on_create_or_reopen_case: ?bool = null,
        notify_on_add_correspondence_to_case: ?bool = null,
        notify_on_resolve_case: ?bool = null,
        notify_on_case_severity: ?[]const u8 = null,
        channel_role_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .team_id = "teamId",
                .channel_id = "channelId",
                .channel_name = "channelName",
                .notify_on_create_or_reopen_case = "notifyOnCreateOrReopenCase",
                .notify_on_add_correspondence_to_case = "notifyOnAddCorrespondenceToCase",
                .notify_on_resolve_case = "notifyOnResolveCase",
                .notify_on_case_severity = "notifyOnCaseSeverity",
                .channel_role_arn = "channelRoleArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Conflict,
        InternalServer,
        ResourceNotFound,
        Validation,
    },
} = .{};
