const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-07-01";
pub const sdk_id: []const u8 = "Translate";
pub const arn_namespace: ?[]const u8 = "translate";
pub const endpoint_prefix: []const u8 = "translate";
pub const sigv4_name: []const u8 = "translate";
pub const name: []const u8 = "AWSShineFrontendService_20170701";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-07-01",
    sdk_id: []const u8 = "Translate",
    arn_namespace: ?[]const u8 = "translate",
    endpoint_prefix: []const u8 = "translate",
    sigv4_name: []const u8 = "translate",
    name: []const u8 = "AWSShineFrontendService_20170701",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const create_parallel_data: struct {
    action_name: []const u8 = "CreateParallelData",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        parallel_data_config: ParallelDataConfig,
        encryption_key: ?EncryptionKey = null,
        client_token: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .description = "Description",
                .parallel_data_config = "ParallelDataConfig",
                .encryption_key = "EncryptionKey",
                .client_token = "ClientToken",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_parallel_data) } {
            return .{ .service_metadata = service_metadata, .action = create_parallel_data };
        }
    },
    Response: type = struct {
        name: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        Conflict,
        InternalServer,
        InvalidParameterValue,
        InvalidRequest,
        LimitExceeded,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const delete_parallel_data: struct {
    action_name: []const u8 = "DeleteParallelData",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_parallel_data) } {
            return .{ .service_metadata = service_metadata, .action = delete_parallel_data };
        }
    },
    Response: type = struct {
        name: ?[]const u8 = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .status = "Status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const delete_terminology: struct {
    action_name: []const u8 = "DeleteTerminology",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_terminology) } {
            return .{ .service_metadata = service_metadata, .action = delete_terminology };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_text_translation_job: struct {
    action_name: []const u8 = "DescribeTextTranslationJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_text_translation_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_text_translation_job };
        }
    },
    Response: type = struct {
        text_translation_job_properties: ?TextTranslationJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_translation_job_properties = "TextTranslationJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const get_parallel_data: struct {
    action_name: []const u8 = "GetParallelData",
    Request: type = struct {
        name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_parallel_data) } {
            return .{ .service_metadata = service_metadata, .action = get_parallel_data };
        }
    },
    Response: type = struct {
        parallel_data_properties: ?ParallelDataProperties = null,
        data_location: ?ParallelDataDataLocation = null,
        auxiliary_data_location: ?ParallelDataDataLocation = null,
        latest_update_attempt_auxiliary_data_location: ?ParallelDataDataLocation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .parallel_data_properties = "ParallelDataProperties",
                .data_location = "DataLocation",
                .auxiliary_data_location = "AuxiliaryDataLocation",
                .latest_update_attempt_auxiliary_data_location = "LatestUpdateAttemptAuxiliaryDataLocation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const get_terminology: struct {
    action_name: []const u8 = "GetTerminology",
    Request: type = struct {
        name: []const u8,
        terminology_data_format: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .terminology_data_format = "TerminologyDataFormat",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_terminology) } {
            return .{ .service_metadata = service_metadata, .action = get_terminology };
        }
    },
    Response: type = struct {
        terminology_properties: ?TerminologyProperties = null,
        terminology_data_location: ?TerminologyDataLocation = null,
        auxiliary_data_location: ?TerminologyDataLocation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .terminology_properties = "TerminologyProperties",
                .terminology_data_location = "TerminologyDataLocation",
                .auxiliary_data_location = "AuxiliaryDataLocation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const import_terminology: struct {
    action_name: []const u8 = "ImportTerminology",
    Request: type = struct {
        name: []const u8,
        merge_strategy: []const u8,
        description: ?[]const u8 = null,
        terminology_data: struct {
            file: []const u8,
            format: []const u8,
            directionality: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .file = "File",
                    .format = "Format",
                    .directionality = "Directionality",
                };
                return @field(mappings, field_name);
            }
        },
        encryption_key: ?EncryptionKey = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .merge_strategy = "MergeStrategy",
                .description = "Description",
                .terminology_data = "TerminologyData",
                .encryption_key = "EncryptionKey",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_terminology) } {
            return .{ .service_metadata = service_metadata, .action = import_terminology };
        }
    },
    Response: type = struct {
        terminology_properties: ?TerminologyProperties = null,
        auxiliary_data_location: ?TerminologyDataLocation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .terminology_properties = "TerminologyProperties",
                .auxiliary_data_location = "AuxiliaryDataLocation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidParameterValue,
        LimitExceeded,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const list_languages: struct {
    action_name: []const u8 = "ListLanguages",
    Request: type = struct {
        display_language_code: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .display_language_code = "DisplayLanguageCode",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_languages) } {
            return .{ .service_metadata = service_metadata, .action = list_languages };
        }
    },
    Response: type = struct {
        languages: ?[]struct {
            language_name: []const u8,
            language_code: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .language_name = "LanguageName",
                    .language_code = "LanguageCode",
                };
                return @field(mappings, field_name);
            }
        } = null,
        display_language_code: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .languages = "Languages",
                .display_language_code = "DisplayLanguageCode",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        TooManyRequests,
        UnsupportedDisplayLanguageCode,
    },
} = .{};
pub const list_parallel_data: struct {
    action_name: []const u8 = "ListParallelData",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_parallel_data) } {
            return .{ .service_metadata = service_metadata, .action = list_parallel_data };
        }
    },
    Response: type = struct {
        parallel_data_properties_list: ?[]ParallelDataProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .parallel_data_properties_list = "ParallelDataPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        TooManyRequests,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
    },
} = .{};
pub const list_terminologies: struct {
    action_name: []const u8 = "ListTerminologies",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_terminologies) } {
            return .{ .service_metadata = service_metadata, .action = list_terminologies };
        }
    },
    Response: type = struct {
        terminology_properties_list: ?[]TerminologyProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .terminology_properties_list = "TerminologyPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        TooManyRequests,
    },
} = .{};
pub const list_text_translation_jobs: struct {
    action_name: []const u8 = "ListTextTranslationJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submitted_before_time: ?i64 = null,
            submitted_after_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submitted_before_time = "SubmittedBeforeTime",
                    .submitted_after_time = "SubmittedAfterTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_text_translation_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_text_translation_jobs };
        }
    },
    Response: type = struct {
        text_translation_job_properties_list: ?[]TextTranslationJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_translation_job_properties_list = "TextTranslationJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const start_text_translation_job: struct {
    action_name: []const u8 = "StartTextTranslationJob",
    Request: type = struct {
        job_name: ?[]const u8 = null,
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        source_language_code: []const u8,
        target_language_codes: [][]const u8,
        terminology_names: ?[][]const u8 = null,
        parallel_data_names: ?[][]const u8 = null,
        client_token: []const u8,
        settings: ?TranslationSettings = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_name = "JobName",
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .source_language_code = "SourceLanguageCode",
                .target_language_codes = "TargetLanguageCodes",
                .terminology_names = "TerminologyNames",
                .parallel_data_names = "ParallelDataNames",
                .client_token = "ClientToken",
                .settings = "Settings",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_text_translation_job) } {
            return .{ .service_metadata = service_metadata, .action = start_text_translation_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidParameterValue,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
        UnsupportedLanguagePair,
    },
} = .{};
pub const stop_text_translation_job: struct {
    action_name: []const u8 = "StopTextTranslationJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_text_translation_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_text_translation_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const translate_document: struct {
    action_name: []const u8 = "TranslateDocument",
    Request: type = struct {
        document: struct {
            content: []const u8,
            content_type: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .content = "Content",
                    .content_type = "ContentType",
                };
                return @field(mappings, field_name);
            }
        },
        terminology_names: ?[][]const u8 = null,
        source_language_code: []const u8,
        target_language_code: []const u8,
        settings: ?TranslationSettings = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document = "Document",
                .terminology_names = "TerminologyNames",
                .source_language_code = "SourceLanguageCode",
                .target_language_code = "TargetLanguageCode",
                .settings = "Settings",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(translate_document) } {
            return .{ .service_metadata = service_metadata, .action = translate_document };
        }
    },
    Response: type = struct {
        translated_document: struct {
            content: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .content = "Content",
                };
                return @field(mappings, field_name);
            }
        },
        source_language_code: []const u8,
        target_language_code: []const u8,
        applied_terminologies: ?[]AppliedTerminology = null,
        applied_settings: ?TranslationSettings = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .translated_document = "TranslatedDocument",
                .source_language_code = "SourceLanguageCode",
                .target_language_code = "TargetLanguageCode",
                .applied_terminologies = "AppliedTerminologies",
                .applied_settings = "AppliedSettings",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        LimitExceeded,
        ResourceNotFound,
        ServiceUnavailable,
        TooManyRequests,
        UnsupportedLanguagePair,
    },
} = .{};
pub const translate_text: struct {
    action_name: []const u8 = "TranslateText",
    Request: type = struct {
        text: []const u8,
        terminology_names: ?[][]const u8 = null,
        source_language_code: []const u8,
        target_language_code: []const u8,
        settings: ?TranslationSettings = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .terminology_names = "TerminologyNames",
                .source_language_code = "SourceLanguageCode",
                .target_language_code = "TargetLanguageCode",
                .settings = "Settings",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(translate_text) } {
            return .{ .service_metadata = service_metadata, .action = translate_text };
        }
    },
    Response: type = struct {
        translated_text: []const u8,
        source_language_code: []const u8,
        target_language_code: []const u8,
        applied_terminologies: ?[]AppliedTerminology = null,
        applied_settings: ?TranslationSettings = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .translated_text = "TranslatedText",
                .source_language_code = "SourceLanguageCode",
                .target_language_code = "TargetLanguageCode",
                .applied_terminologies = "AppliedTerminologies",
                .applied_settings = "AppliedSettings",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DetectedLanguageLowConfidence,
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        ServiceUnavailable,
        TextSizeLimitExceeded,
        TooManyRequests,
        UnsupportedLanguagePair,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidParameterValue,
        ResourceNotFound,
    },
} = .{};
pub const update_parallel_data: struct {
    action_name: []const u8 = "UpdateParallelData",
    Request: type = struct {
        name: []const u8,
        description: ?[]const u8 = null,
        parallel_data_config: ParallelDataConfig,
        client_token: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .description = "Description",
                .parallel_data_config = "ParallelDataConfig",
                .client_token = "ClientToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_parallel_data) } {
            return .{ .service_metadata = service_metadata, .action = update_parallel_data };
        }
    },
    Response: type = struct {
        name: ?[]const u8 = null,
        status: ?[]const u8 = null,
        latest_update_attempt_status: ?[]const u8 = null,
        latest_update_attempt_at: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "Name",
                .status = "Status",
                .latest_update_attempt_status = "LatestUpdateAttemptStatus",
                .latest_update_attempt_at = "LatestUpdateAttemptAt",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        Conflict,
        InternalServer,
        InvalidParameterValue,
        InvalidRequest,
        LimitExceeded,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};

pub const ParallelDataConfig = struct {
    s3_uri: ?[]const u8 = null,
    format: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .format = "Format",
        };
        return @field(mappings, field_name);
    }
};

pub const TranslationSettings = struct {
    formality: ?[]const u8 = null,
    profanity: ?[]const u8 = null,
    brevity: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .formality = "Formality",
            .profanity = "Profanity",
            .brevity = "Brevity",
        };
        return @field(mappings, field_name);
    }
};

pub const AppliedTerminology = struct {
    name: ?[]const u8 = null,
    terms: ?[]Term = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .terms = "Terms",
        };
        return @field(mappings, field_name);
    }
};

pub const Term = struct {
    source_text: ?[]const u8 = null,
    target_text: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .source_text = "SourceText",
            .target_text = "TargetText",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const OutputDataConfig = struct {
    s3_uri: []const u8,
    encryption_key: ?EncryptionKey = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .encryption_key = "EncryptionKey",
        };
        return @field(mappings, field_name);
    }
};

pub const EncryptionKey = struct {
    type: []const u8,
    id: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .id = "Id",
        };
        return @field(mappings, field_name);
    }
};

pub const InputDataConfig = struct {
    s3_uri: []const u8,
    content_type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .content_type = "ContentType",
        };
        return @field(mappings, field_name);
    }
};

pub const TextTranslationJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    job_details: ?JobDetails = null,
    source_language_code: ?[]const u8 = null,
    target_language_codes: ?[][]const u8 = null,
    terminology_names: ?[][]const u8 = null,
    parallel_data_names: ?[][]const u8 = null,
    message: ?[]const u8 = null,
    submitted_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    data_access_role_arn: ?[]const u8 = null,
    settings: ?TranslationSettings = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .job_details = "JobDetails",
            .source_language_code = "SourceLanguageCode",
            .target_language_codes = "TargetLanguageCodes",
            .terminology_names = "TerminologyNames",
            .parallel_data_names = "ParallelDataNames",
            .message = "Message",
            .submitted_time = "SubmittedTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .data_access_role_arn = "DataAccessRoleArn",
            .settings = "Settings",
        };
        return @field(mappings, field_name);
    }
};

pub const JobDetails = struct {
    translated_documents_count: ?i64 = null,
    documents_with_errors_count: ?i64 = null,
    input_documents_count: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .translated_documents_count = "TranslatedDocumentsCount",
            .documents_with_errors_count = "DocumentsWithErrorsCount",
            .input_documents_count = "InputDocumentsCount",
        };
        return @field(mappings, field_name);
    }
};

pub const TerminologyProperties = struct {
    name: ?[]const u8 = null,
    description: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    source_language_code: ?[]const u8 = null,
    target_language_codes: ?[][]const u8 = null,
    encryption_key: ?EncryptionKey = null,
    size_bytes: ?i64 = null,
    term_count: ?i64 = null,
    created_at: ?i64 = null,
    last_updated_at: ?i64 = null,
    directionality: ?[]const u8 = null,
    message: ?[]const u8 = null,
    skipped_term_count: ?i64 = null,
    format: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .description = "Description",
            .arn = "Arn",
            .source_language_code = "SourceLanguageCode",
            .target_language_codes = "TargetLanguageCodes",
            .encryption_key = "EncryptionKey",
            .size_bytes = "SizeBytes",
            .term_count = "TermCount",
            .created_at = "CreatedAt",
            .last_updated_at = "LastUpdatedAt",
            .directionality = "Directionality",
            .message = "Message",
            .skipped_term_count = "SkippedTermCount",
            .format = "Format",
        };
        return @field(mappings, field_name);
    }
};

pub const ParallelDataProperties = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    description: ?[]const u8 = null,
    status: ?[]const u8 = null,
    source_language_code: ?[]const u8 = null,
    target_language_codes: ?[][]const u8 = null,
    parallel_data_config: ?ParallelDataConfig = null,
    message: ?[]const u8 = null,
    imported_data_size: ?i64 = null,
    imported_record_count: ?i64 = null,
    failed_record_count: ?i64 = null,
    skipped_record_count: ?i64 = null,
    encryption_key: ?EncryptionKey = null,
    created_at: ?i64 = null,
    last_updated_at: ?i64 = null,
    latest_update_attempt_status: ?[]const u8 = null,
    latest_update_attempt_at: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "Name",
            .arn = "Arn",
            .description = "Description",
            .status = "Status",
            .source_language_code = "SourceLanguageCode",
            .target_language_codes = "TargetLanguageCodes",
            .parallel_data_config = "ParallelDataConfig",
            .message = "Message",
            .imported_data_size = "ImportedDataSize",
            .imported_record_count = "ImportedRecordCount",
            .failed_record_count = "FailedRecordCount",
            .skipped_record_count = "SkippedRecordCount",
            .encryption_key = "EncryptionKey",
            .created_at = "CreatedAt",
            .last_updated_at = "LastUpdatedAt",
            .latest_update_attempt_status = "LatestUpdateAttemptStatus",
            .latest_update_attempt_at = "LatestUpdateAttemptAt",
        };
        return @field(mappings, field_name);
    }
};

pub const TerminologyDataLocation = struct {
    repository_type: []const u8,
    location: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .repository_type = "RepositoryType",
            .location = "Location",
        };
        return @field(mappings, field_name);
    }
};

pub const ParallelDataDataLocation = struct {
    repository_type: []const u8,
    location: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .repository_type = "RepositoryType",
            .location = "Location",
        };
        return @field(mappings, field_name);
    }
};
