const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2016-11-28";
pub const sdk_id: []const u8 = "Lightsail";
pub const arn_namespace: ?[]const u8 = "lightsail";
pub const endpoint_prefix: []const u8 = "lightsail";
pub const sigv4_name: []const u8 = "lightsail";
pub const name: []const u8 = "Lightsail_20161128";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2016-11-28",
    sdk_id: []const u8 = "Lightsail",
    arn_namespace: ?[]const u8 = "lightsail",
    endpoint_prefix: []const u8 = "lightsail",
    sigv4_name: []const u8 = "lightsail",
    name: []const u8 = "Lightsail_20161128",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const allocate_static_ip: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AllocateStaticIp",
        .success_code = 200,
    };

    action_name: []const u8 = "AllocateStaticIp",
    Request: type = struct {
        static_ip_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip_name = "staticIpName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(allocate_static_ip) } {
            return .{ .service_metadata = service_metadata, .action = allocate_static_ip };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const attach_certificate_to_distribution: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AttachCertificateToDistribution",
        .success_code = 200,
    };

    action_name: []const u8 = "AttachCertificateToDistribution",
    Request: type = struct {
        distribution_name: []const u8,
        certificate_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .certificate_name = "certificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_certificate_to_distribution) } {
            return .{ .service_metadata = service_metadata, .action = attach_certificate_to_distribution };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const attach_disk: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AttachDisk",
        .success_code = 200,
    };

    action_name: []const u8 = "AttachDisk",
    Request: type = struct {
        disk_name: []const u8,
        instance_name: []const u8,
        disk_path: []const u8,
        auto_mounting: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
                .instance_name = "instanceName",
                .disk_path = "diskPath",
                .auto_mounting = "autoMounting",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_disk) } {
            return .{ .service_metadata = service_metadata, .action = attach_disk };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const attach_instances_to_load_balancer: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AttachInstancesToLoadBalancer",
        .success_code = 200,
    };

    action_name: []const u8 = "AttachInstancesToLoadBalancer",
    Request: type = struct {
        load_balancer_name: []const u8,
        instance_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .instance_names = "instanceNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_instances_to_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = attach_instances_to_load_balancer };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const attach_load_balancer_tls_certificate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AttachLoadBalancerTlsCertificate",
        .success_code = 200,
    };

    action_name: []const u8 = "AttachLoadBalancerTlsCertificate",
    Request: type = struct {
        load_balancer_name: []const u8,
        certificate_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .certificate_name = "certificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_load_balancer_tls_certificate) } {
            return .{ .service_metadata = service_metadata, .action = attach_load_balancer_tls_certificate };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const attach_static_ip: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/AttachStaticIp",
        .success_code = 200,
    };

    action_name: []const u8 = "AttachStaticIp",
    Request: type = struct {
        static_ip_name: []const u8,
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip_name = "staticIpName",
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(attach_static_ip) } {
            return .{ .service_metadata = service_metadata, .action = attach_static_ip };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const close_instance_public_ports: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CloseInstancePublicPorts",
        .success_code = 200,
    };

    action_name: []const u8 = "CloseInstancePublicPorts",
    Request: type = struct {
        port_info: PortInfo,
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .port_info = "portInfo",
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(close_instance_public_ports) } {
            return .{ .service_metadata = service_metadata, .action = close_instance_public_ports };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const copy_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CopySnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CopySnapshot",
    Request: type = struct {
        source_snapshot_name: ?[]const u8 = null,
        source_resource_name: ?[]const u8 = null,
        restore_date: ?[]const u8 = null,
        use_latest_restorable_auto_snapshot: ?bool = null,
        target_snapshot_name: []const u8,
        source_region: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .source_snapshot_name = "sourceSnapshotName",
                .source_resource_name = "sourceResourceName",
                .restore_date = "restoreDate",
                .use_latest_restorable_auto_snapshot = "useLatestRestorableAutoSnapshot",
                .target_snapshot_name = "targetSnapshotName",
                .source_region = "sourceRegion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(copy_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = copy_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_bucket: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateBucket",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateBucket",
    Request: type = struct {
        bucket_name: []const u8,
        bundle_id: []const u8,
        tags: ?[]Tag = null,
        enable_object_versioning: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .bundle_id = "bundleId",
                .tags = "tags",
                .enable_object_versioning = "enableObjectVersioning",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_bucket) } {
            return .{ .service_metadata = service_metadata, .action = create_bucket };
        }
    },
    Response: type = struct {
        bucket: ?Bucket = null,
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket = "bucket",
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_bucket_access_key: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateBucketAccessKey",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateBucketAccessKey",
    Request: type = struct {
        bucket_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_bucket_access_key) } {
            return .{ .service_metadata = service_metadata, .action = create_bucket_access_key };
        }
    },
    Response: type = struct {
        access_key: ?AccessKey = null,
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_key = "accessKey",
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_certificate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateCertificate",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateCertificate",
    Request: type = struct {
        certificate_name: []const u8,
        domain_name: []const u8,
        subject_alternative_names: ?[][]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificate_name = "certificateName",
                .domain_name = "domainName",
                .subject_alternative_names = "subjectAlternativeNames",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_certificate) } {
            return .{ .service_metadata = service_metadata, .action = create_certificate };
        }
    },
    Response: type = struct {
        certificate: ?CertificateSummary = null,
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificate = "certificate",
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_cloud_formation_stack: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateCloudFormationStack",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateCloudFormationStack",
    Request: type = struct {
        instances: []struct {
            source_name: []const u8,
            instance_type: []const u8,
            port_info_source: []const u8,
            user_data: ?[]const u8 = null,
            availability_zone: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .source_name = "sourceName",
                    .instance_type = "instanceType",
                    .port_info_source = "portInfoSource",
                    .user_data = "userData",
                    .availability_zone = "availabilityZone",
                };
                return @field(mappings, field_name);
            }
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instances = "instances",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_cloud_formation_stack) } {
            return .{ .service_metadata = service_metadata, .action = create_cloud_formation_stack };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_contact_method: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateContactMethod",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateContactMethod",
    Request: type = struct {
        protocol: []const u8,
        contact_endpoint: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocol = "protocol",
                .contact_endpoint = "contactEndpoint",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_contact_method) } {
            return .{ .service_metadata = service_metadata, .action = create_contact_method };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_container_service: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/container-services",
        .success_code = 201,
    };

    action_name: []const u8 = "CreateContainerService",
    Request: type = struct {
        service_name: []const u8,
        power: []const u8,
        scale: i64,
        tags: ?[]Tag = null,
        public_domain_names: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[][]const u8 = null,
        } = null,
        deployment: ?struct {
            containers: ?[]struct {
                key: ?[]const u8 = null,
                value: ?Container = null,
            } = null,
            public_endpoint: ?EndpointRequest = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .containers = "containers",
                    .public_endpoint = "publicEndpoint",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "containers", field_name))
                    return try serializeMap(self.containers, self.fieldNameFor("containers"), options, out_stream);
                return false;
            }
        } = null,
        private_registry_access: ?PrivateRegistryAccessRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .power = "power",
                .scale = "scale",
                .tags = "tags",
                .public_domain_names = "publicDomainNames",
                .deployment = "deployment",
                .private_registry_access = "privateRegistryAccess",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "public_domain_names", field_name))
                return try serializeMap(self.public_domain_names, self.fieldNameFor("public_domain_names"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_container_service) } {
            return .{ .service_metadata = service_metadata, .action = create_container_service };
        }
    },
    Response: type = struct {
        container_service: ?ContainerService = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_service = "containerService",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_container_service_deployment: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/deployments",
        .success_code = 201,
    };

    action_name: []const u8 = "CreateContainerServiceDeployment",
    Request: type = struct {
        service_name: []const u8,
        containers: ?[]struct {
            key: ?[]const u8 = null,
            value: ?Container = null,
        } = null,
        public_endpoint: ?EndpointRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .containers = "containers",
                .public_endpoint = "publicEndpoint",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "containers", field_name))
                return try serializeMap(self.containers, self.fieldNameFor("containers"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_container_service_deployment) } {
            return .{ .service_metadata = service_metadata, .action = create_container_service_deployment };
        }
    },
    Response: type = struct {
        container_service: ?ContainerService = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_service = "containerService",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_container_service_registry_login: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/container-registry-login",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateContainerServiceRegistryLogin",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_container_service_registry_login) } {
            return .{ .service_metadata = service_metadata, .action = create_container_service_registry_login };
        }
    },
    Response: type = struct {
        registry_login: ?struct {
            username: ?[]const u8 = null,
            password: ?[]const u8 = null,
            expires_at: ?i64 = null,
            registry: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .username = "username",
                    .password = "password",
                    .expires_at = "expiresAt",
                    .registry = "registry",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .registry_login = "registryLogin",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_disk: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDisk",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDisk",
    Request: type = struct {
        disk_name: []const u8,
        availability_zone: []const u8,
        size_in_gb: i64,
        tags: ?[]Tag = null,
        add_ons: ?[]AddOnRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
                .availability_zone = "availabilityZone",
                .size_in_gb = "sizeInGb",
                .tags = "tags",
                .add_ons = "addOns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_disk) } {
            return .{ .service_metadata = service_metadata, .action = create_disk };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_disk_from_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDiskFromSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDiskFromSnapshot",
    Request: type = struct {
        disk_name: []const u8,
        disk_snapshot_name: ?[]const u8 = null,
        availability_zone: []const u8,
        size_in_gb: i64,
        tags: ?[]Tag = null,
        add_ons: ?[]AddOnRequest = null,
        source_disk_name: ?[]const u8 = null,
        restore_date: ?[]const u8 = null,
        use_latest_restorable_auto_snapshot: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
                .disk_snapshot_name = "diskSnapshotName",
                .availability_zone = "availabilityZone",
                .size_in_gb = "sizeInGb",
                .tags = "tags",
                .add_ons = "addOns",
                .source_disk_name = "sourceDiskName",
                .restore_date = "restoreDate",
                .use_latest_restorable_auto_snapshot = "useLatestRestorableAutoSnapshot",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_disk_from_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_disk_from_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_disk_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDiskSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDiskSnapshot",
    Request: type = struct {
        disk_name: ?[]const u8 = null,
        disk_snapshot_name: []const u8,
        instance_name: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
                .disk_snapshot_name = "diskSnapshotName",
                .instance_name = "instanceName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_disk_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_disk_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_distribution: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDistribution",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDistribution",
    Request: type = struct {
        distribution_name: []const u8,
        origin: InputOrigin,
        default_cache_behavior: CacheBehavior,
        cache_behavior_settings: ?CacheSettings = null,
        cache_behaviors: ?[]CacheBehaviorPerPath = null,
        bundle_id: []const u8,
        ip_address_type: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .origin = "origin",
                .default_cache_behavior = "defaultCacheBehavior",
                .cache_behavior_settings = "cacheBehaviorSettings",
                .cache_behaviors = "cacheBehaviors",
                .bundle_id = "bundleId",
                .ip_address_type = "ipAddressType",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_distribution) } {
            return .{ .service_metadata = service_metadata, .action = create_distribution };
        }
    },
    Response: type = struct {
        distribution: ?LightsailDistribution = null,
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution = "distribution",
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_domain: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDomain",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDomain",
    Request: type = struct {
        domain_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_domain) } {
            return .{ .service_metadata = service_metadata, .action = create_domain };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_domain_entry: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateDomainEntry",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateDomainEntry",
    Request: type = struct {
        domain_name: []const u8,
        domain_entry: DomainEntry,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .domain_entry = "domainEntry",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_domain_entry) } {
            return .{ .service_metadata = service_metadata, .action = create_domain_entry };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_gui_session_access_details: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/create-gui-session-access-details",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateGUISessionAccessDetails",
    Request: type = struct {
        resource_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_gui_session_access_details) } {
            return .{ .service_metadata = service_metadata, .action = create_gui_session_access_details };
        }
    },
    Response: type = struct {
        resource_name: ?[]const u8 = null,
        status: ?[]const u8 = null,
        percentage_complete: ?i64 = null,
        failure_reason: ?[]const u8 = null,
        sessions: ?[]struct {
            name: ?[]const u8 = null,
            url: ?[]const u8 = null,
            is_primary: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .url = "url",
                    .is_primary = "isPrimary",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .status = "status",
                .percentage_complete = "percentageComplete",
                .failure_reason = "failureReason",
                .sessions = "sessions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_instances: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateInstances",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateInstances",
    Request: type = struct {
        instance_names: [][]const u8,
        availability_zone: []const u8,
        custom_image_name: ?[]const u8 = null,
        blueprint_id: []const u8,
        bundle_id: []const u8,
        user_data: ?[]const u8 = null,
        key_pair_name: ?[]const u8 = null,
        tags: ?[]Tag = null,
        add_ons: ?[]AddOnRequest = null,
        ip_address_type: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_names = "instanceNames",
                .availability_zone = "availabilityZone",
                .custom_image_name = "customImageName",
                .blueprint_id = "blueprintId",
                .bundle_id = "bundleId",
                .user_data = "userData",
                .key_pair_name = "keyPairName",
                .tags = "tags",
                .add_ons = "addOns",
                .ip_address_type = "ipAddressType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_instances) } {
            return .{ .service_metadata = service_metadata, .action = create_instances };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_instances_from_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateInstancesFromSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateInstancesFromSnapshot",
    Request: type = struct {
        instance_names: [][]const u8,
        attached_disk_mapping: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]struct {
                original_disk_path: ?[]const u8 = null,
                new_disk_name: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .original_disk_path = "originalDiskPath",
                        .new_disk_name = "newDiskName",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
        } = null,
        availability_zone: []const u8,
        instance_snapshot_name: ?[]const u8 = null,
        bundle_id: []const u8,
        user_data: ?[]const u8 = null,
        key_pair_name: ?[]const u8 = null,
        tags: ?[]Tag = null,
        add_ons: ?[]AddOnRequest = null,
        ip_address_type: ?[]const u8 = null,
        source_instance_name: ?[]const u8 = null,
        restore_date: ?[]const u8 = null,
        use_latest_restorable_auto_snapshot: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_names = "instanceNames",
                .attached_disk_mapping = "attachedDiskMapping",
                .availability_zone = "availabilityZone",
                .instance_snapshot_name = "instanceSnapshotName",
                .bundle_id = "bundleId",
                .user_data = "userData",
                .key_pair_name = "keyPairName",
                .tags = "tags",
                .add_ons = "addOns",
                .ip_address_type = "ipAddressType",
                .source_instance_name = "sourceInstanceName",
                .restore_date = "restoreDate",
                .use_latest_restorable_auto_snapshot = "useLatestRestorableAutoSnapshot",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "attached_disk_mapping", field_name))
                return try serializeMap(self.attached_disk_mapping, self.fieldNameFor("attached_disk_mapping"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_instances_from_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_instances_from_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_instance_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateInstanceSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateInstanceSnapshot",
    Request: type = struct {
        instance_snapshot_name: []const u8,
        instance_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_snapshot_name = "instanceSnapshotName",
                .instance_name = "instanceName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_instance_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_instance_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_key_pair: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateKeyPair",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateKeyPair",
    Request: type = struct {
        key_pair_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair_name = "keyPairName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_key_pair) } {
            return .{ .service_metadata = service_metadata, .action = create_key_pair };
        }
    },
    Response: type = struct {
        key_pair: ?KeyPair = null,
        public_key_base64: ?[]const u8 = null,
        private_key_base64: ?[]const u8 = null,
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair = "keyPair",
                .public_key_base64 = "publicKeyBase64",
                .private_key_base64 = "privateKeyBase64",
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_load_balancer: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateLoadBalancer",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateLoadBalancer",
    Request: type = struct {
        load_balancer_name: []const u8,
        instance_port: i64,
        health_check_path: ?[]const u8 = null,
        certificate_name: ?[]const u8 = null,
        certificate_domain_name: ?[]const u8 = null,
        certificate_alternative_names: ?[][]const u8 = null,
        tags: ?[]Tag = null,
        ip_address_type: ?[]const u8 = null,
        tls_policy_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .instance_port = "instancePort",
                .health_check_path = "healthCheckPath",
                .certificate_name = "certificateName",
                .certificate_domain_name = "certificateDomainName",
                .certificate_alternative_names = "certificateAlternativeNames",
                .tags = "tags",
                .ip_address_type = "ipAddressType",
                .tls_policy_name = "tlsPolicyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = create_load_balancer };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_load_balancer_tls_certificate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateLoadBalancerTlsCertificate",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateLoadBalancerTlsCertificate",
    Request: type = struct {
        load_balancer_name: []const u8,
        certificate_name: []const u8,
        certificate_domain_name: []const u8,
        certificate_alternative_names: ?[][]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .certificate_name = "certificateName",
                .certificate_domain_name = "certificateDomainName",
                .certificate_alternative_names = "certificateAlternativeNames",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_load_balancer_tls_certificate) } {
            return .{ .service_metadata = service_metadata, .action = create_load_balancer_tls_certificate };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,
        availability_zone: ?[]const u8 = null,
        relational_database_blueprint_id: []const u8,
        relational_database_bundle_id: []const u8,
        master_database_name: []const u8,
        master_username: []const u8,
        master_user_password: ?[]const u8 = null,
        preferred_backup_window: ?[]const u8 = null,
        preferred_maintenance_window: ?[]const u8 = null,
        publicly_accessible: ?bool = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .availability_zone = "availabilityZone",
                .relational_database_blueprint_id = "relationalDatabaseBlueprintId",
                .relational_database_bundle_id = "relationalDatabaseBundleId",
                .master_database_name = "masterDatabaseName",
                .master_username = "masterUsername",
                .master_user_password = "masterUserPassword",
                .preferred_backup_window = "preferredBackupWindow",
                .preferred_maintenance_window = "preferredMaintenanceWindow",
                .publicly_accessible = "publiclyAccessible",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = create_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_relational_database_from_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateRelationalDatabaseFromSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateRelationalDatabaseFromSnapshot",
    Request: type = struct {
        relational_database_name: []const u8,
        availability_zone: ?[]const u8 = null,
        publicly_accessible: ?bool = null,
        relational_database_snapshot_name: ?[]const u8 = null,
        relational_database_bundle_id: ?[]const u8 = null,
        source_relational_database_name: ?[]const u8 = null,
        restore_time: ?i64 = null,
        use_latest_restorable_time: ?bool = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .availability_zone = "availabilityZone",
                .publicly_accessible = "publiclyAccessible",
                .relational_database_snapshot_name = "relationalDatabaseSnapshotName",
                .relational_database_bundle_id = "relationalDatabaseBundleId",
                .source_relational_database_name = "sourceRelationalDatabaseName",
                .restore_time = "restoreTime",
                .use_latest_restorable_time = "useLatestRestorableTime",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_relational_database_from_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_relational_database_from_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const create_relational_database_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/CreateRelationalDatabaseSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "CreateRelationalDatabaseSnapshot",
    Request: type = struct {
        relational_database_name: []const u8,
        relational_database_snapshot_name: []const u8,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .relational_database_snapshot_name = "relationalDatabaseSnapshotName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_relational_database_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = create_relational_database_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_alarm: struct {
    pub const http_config = .{
        .method = "DELETE",
        .uri = "/ls/api/2016-11-28/DeleteAlarm",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteAlarm",
    Request: type = struct {
        alarm_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "alarmName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_alarm) } {
            return .{ .service_metadata = service_metadata, .action = delete_alarm };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_auto_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteAutoSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteAutoSnapshot",
    Request: type = struct {
        resource_name: []const u8,
        date: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .date = "date",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_auto_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = delete_auto_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_bucket: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteBucket",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteBucket",
    Request: type = struct {
        bucket_name: []const u8,
        force_delete: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .force_delete = "forceDelete",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_bucket) } {
            return .{ .service_metadata = service_metadata, .action = delete_bucket };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_bucket_access_key: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteBucketAccessKey",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteBucketAccessKey",
    Request: type = struct {
        bucket_name: []const u8,
        access_key_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .access_key_id = "accessKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_bucket_access_key) } {
            return .{ .service_metadata = service_metadata, .action = delete_bucket_access_key };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_certificate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteCertificate",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteCertificate",
    Request: type = struct {
        certificate_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificate_name = "certificateName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_certificate) } {
            return .{ .service_metadata = service_metadata, .action = delete_certificate };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_contact_method: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteContactMethod",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteContactMethod",
    Request: type = struct {
        protocol: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocol = "protocol",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_contact_method) } {
            return .{ .service_metadata = service_metadata, .action = delete_contact_method };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_container_image: struct {
    pub const http_config = .{
        .method = "DELETE",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/images/{image}",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteContainerImage",
    Request: type = struct {
        service_name: []const u8,
        image: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .image = "image",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_container_image) } {
            return .{ .service_metadata = service_metadata, .action = delete_container_image };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_container_service: struct {
    pub const http_config = .{
        .method = "DELETE",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}",
        .success_code = 204,
    };

    action_name: []const u8 = "DeleteContainerService",
    Request: type = struct {
        service_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_container_service) } {
            return .{ .service_metadata = service_metadata, .action = delete_container_service };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_disk: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteDisk",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteDisk",
    Request: type = struct {
        disk_name: []const u8,
        force_delete_add_ons: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
                .force_delete_add_ons = "forceDeleteAddOns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_disk) } {
            return .{ .service_metadata = service_metadata, .action = delete_disk };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_disk_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteDiskSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteDiskSnapshot",
    Request: type = struct {
        disk_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_snapshot_name = "diskSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_disk_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = delete_disk_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_distribution: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteDistribution",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteDistribution",
    Request: type = struct {
        distribution_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_distribution) } {
            return .{ .service_metadata = service_metadata, .action = delete_distribution };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_domain: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteDomain",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_domain) } {
            return .{ .service_metadata = service_metadata, .action = delete_domain };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_domain_entry: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteDomainEntry",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteDomainEntry",
    Request: type = struct {
        domain_name: []const u8,
        domain_entry: DomainEntry,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .domain_entry = "domainEntry",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_domain_entry) } {
            return .{ .service_metadata = service_metadata, .action = delete_domain_entry };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_instance: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteInstance",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteInstance",
    Request: type = struct {
        instance_name: []const u8,
        force_delete_add_ons: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .force_delete_add_ons = "forceDeleteAddOns",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_instance) } {
            return .{ .service_metadata = service_metadata, .action = delete_instance };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_instance_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteInstanceSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteInstanceSnapshot",
    Request: type = struct {
        instance_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_snapshot_name = "instanceSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_instance_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = delete_instance_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_key_pair: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteKeyPair",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteKeyPair",
    Request: type = struct {
        key_pair_name: []const u8,
        expected_fingerprint: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair_name = "keyPairName",
                .expected_fingerprint = "expectedFingerprint",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_key_pair) } {
            return .{ .service_metadata = service_metadata, .action = delete_key_pair };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_known_host_keys: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteKnownHostKeys",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteKnownHostKeys",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_known_host_keys) } {
            return .{ .service_metadata = service_metadata, .action = delete_known_host_keys };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_load_balancer: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteLoadBalancer",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteLoadBalancer",
    Request: type = struct {
        load_balancer_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = delete_load_balancer };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_load_balancer_tls_certificate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteLoadBalancerTlsCertificate",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteLoadBalancerTlsCertificate",
    Request: type = struct {
        load_balancer_name: []const u8,
        certificate_name: []const u8,
        force: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .certificate_name = "certificateName",
                .force = "force",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_load_balancer_tls_certificate) } {
            return .{ .service_metadata = service_metadata, .action = delete_load_balancer_tls_certificate };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,
        skip_final_snapshot: ?bool = null,
        final_relational_database_snapshot_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .skip_final_snapshot = "skipFinalSnapshot",
                .final_relational_database_snapshot_name = "finalRelationalDatabaseSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = delete_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const delete_relational_database_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DeleteRelationalDatabaseSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "DeleteRelationalDatabaseSnapshot",
    Request: type = struct {
        relational_database_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_snapshot_name = "relationalDatabaseSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_relational_database_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = delete_relational_database_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const detach_certificate_from_distribution: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DetachCertificateFromDistribution",
        .success_code = 200,
    };

    action_name: []const u8 = "DetachCertificateFromDistribution",
    Request: type = struct {
        distribution_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_certificate_from_distribution) } {
            return .{ .service_metadata = service_metadata, .action = detach_certificate_from_distribution };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const detach_disk: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DetachDisk",
        .success_code = 200,
    };

    action_name: []const u8 = "DetachDisk",
    Request: type = struct {
        disk_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_disk) } {
            return .{ .service_metadata = service_metadata, .action = detach_disk };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const detach_instances_from_load_balancer: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DetachInstancesFromLoadBalancer",
        .success_code = 200,
    };

    action_name: []const u8 = "DetachInstancesFromLoadBalancer",
    Request: type = struct {
        load_balancer_name: []const u8,
        instance_names: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .instance_names = "instanceNames",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_instances_from_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = detach_instances_from_load_balancer };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const detach_static_ip: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DetachStaticIp",
        .success_code = 200,
    };

    action_name: []const u8 = "DetachStaticIp",
    Request: type = struct {
        static_ip_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip_name = "staticIpName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detach_static_ip) } {
            return .{ .service_metadata = service_metadata, .action = detach_static_ip };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const disable_add_on: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DisableAddOn",
        .success_code = 200,
    };

    action_name: []const u8 = "DisableAddOn",
    Request: type = struct {
        add_on_type: []const u8,
        resource_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .add_on_type = "addOnType",
                .resource_name = "resourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disable_add_on) } {
            return .{ .service_metadata = service_metadata, .action = disable_add_on };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const download_default_key_pair: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/DownloadDefaultKeyPair",
        .success_code = 200,
    };

    action_name: []const u8 = "DownloadDefaultKeyPair",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(download_default_key_pair) } {
            return .{ .service_metadata = service_metadata, .action = download_default_key_pair };
        }
    },
    Response: type = struct {
        public_key_base64: ?[]const u8 = null,
        private_key_base64: ?[]const u8 = null,
        created_at: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .public_key_base64 = "publicKeyBase64",
                .private_key_base64 = "privateKeyBase64",
                .created_at = "createdAt",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const enable_add_on: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/EnableAddOn",
        .success_code = 200,
    };

    action_name: []const u8 = "EnableAddOn",
    Request: type = struct {
        resource_name: []const u8,
        add_on_request: AddOnRequest,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .add_on_request = "addOnRequest",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(enable_add_on) } {
            return .{ .service_metadata = service_metadata, .action = enable_add_on };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const export_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/ExportSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "ExportSnapshot",
    Request: type = struct {
        source_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .source_snapshot_name = "sourceSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(export_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = export_snapshot };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_active_names: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetActiveNames",
        .success_code = 200,
    };

    action_name: []const u8 = "GetActiveNames",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_active_names) } {
            return .{ .service_metadata = service_metadata, .action = get_active_names };
        }
    },
    Response: type = struct {
        active_names: ?[][]const u8 = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .active_names = "activeNames",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_alarms: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/GetAlarms",
        .success_code = 200,
    };

    action_name: []const u8 = "GetAlarms",
    Request: type = struct {
        alarm_name: ?[]const u8 = null,
        page_token: ?[]const u8 = null,
        monitored_resource_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "alarmName",
                .page_token = "pageToken",
                .monitored_resource_name = "monitoredResourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_alarms) } {
            return .{ .service_metadata = service_metadata, .action = get_alarms };
        }
    },
    Response: type = struct {
        alarms: ?[]struct {
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            created_at: ?i64 = null,
            location: ?ResourceLocation = null,
            resource_type: ?[]const u8 = null,
            support_code: ?[]const u8 = null,
            monitored_resource_info: ?struct {
                arn: ?[]const u8 = null,
                name: ?[]const u8 = null,
                resource_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .arn = "arn",
                        .name = "name",
                        .resource_type = "resourceType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            comparison_operator: ?[]const u8 = null,
            evaluation_periods: ?i64 = null,
            period: ?i64 = null,
            threshold: ?f64 = null,
            datapoints_to_alarm: ?i64 = null,
            treat_missing_data: ?[]const u8 = null,
            statistic: ?[]const u8 = null,
            metric_name: ?[]const u8 = null,
            state: ?[]const u8 = null,
            unit: ?[]const u8 = null,
            contact_protocols: ?[][]const u8 = null,
            notification_triggers: ?[][]const u8 = null,
            notification_enabled: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .arn = "arn",
                    .created_at = "createdAt",
                    .location = "location",
                    .resource_type = "resourceType",
                    .support_code = "supportCode",
                    .monitored_resource_info = "monitoredResourceInfo",
                    .comparison_operator = "comparisonOperator",
                    .evaluation_periods = "evaluationPeriods",
                    .period = "period",
                    .threshold = "threshold",
                    .datapoints_to_alarm = "datapointsToAlarm",
                    .treat_missing_data = "treatMissingData",
                    .statistic = "statistic",
                    .metric_name = "metricName",
                    .state = "state",
                    .unit = "unit",
                    .contact_protocols = "contactProtocols",
                    .notification_triggers = "notificationTriggers",
                    .notification_enabled = "notificationEnabled",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarms = "alarms",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_auto_snapshots: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetAutoSnapshots",
        .success_code = 200,
    };

    action_name: []const u8 = "GetAutoSnapshots",
    Request: type = struct {
        resource_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_auto_snapshots) } {
            return .{ .service_metadata = service_metadata, .action = get_auto_snapshots };
        }
    },
    Response: type = struct {
        resource_name: ?[]const u8 = null,
        resource_type: ?[]const u8 = null,
        auto_snapshots: ?[]struct {
            date: ?[]const u8 = null,
            created_at: ?i64 = null,
            status: ?[]const u8 = null,
            from_attached_disks: ?[]struct {
                path: ?[]const u8 = null,
                size_in_gb: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .path = "path",
                        .size_in_gb = "sizeInGb",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .date = "date",
                    .created_at = "createdAt",
                    .status = "status",
                    .from_attached_disks = "fromAttachedDisks",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .resource_type = "resourceType",
                .auto_snapshots = "autoSnapshots",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_blueprints: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBlueprints",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBlueprints",
    Request: type = struct {
        include_inactive: ?bool = null,
        page_token: ?[]const u8 = null,
        app_category: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .include_inactive = "includeInactive",
                .page_token = "pageToken",
                .app_category = "appCategory",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_blueprints) } {
            return .{ .service_metadata = service_metadata, .action = get_blueprints };
        }
    },
    Response: type = struct {
        blueprints: ?[]struct {
            blueprint_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            group: ?[]const u8 = null,
            type: ?[]const u8 = null,
            description: ?[]const u8 = null,
            is_active: ?bool = null,
            min_power: ?i64 = null,
            version: ?[]const u8 = null,
            version_code: ?[]const u8 = null,
            product_url: ?[]const u8 = null,
            license_url: ?[]const u8 = null,
            platform: ?[]const u8 = null,
            app_category: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .blueprint_id = "blueprintId",
                    .name = "name",
                    .group = "group",
                    .type = "type",
                    .description = "description",
                    .is_active = "isActive",
                    .min_power = "minPower",
                    .version = "version",
                    .version_code = "versionCode",
                    .product_url = "productUrl",
                    .license_url = "licenseUrl",
                    .platform = "platform",
                    .app_category = "appCategory",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .blueprints = "blueprints",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_bucket_access_keys: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBucketAccessKeys",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBucketAccessKeys",
    Request: type = struct {
        bucket_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_bucket_access_keys) } {
            return .{ .service_metadata = service_metadata, .action = get_bucket_access_keys };
        }
    },
    Response: type = struct {
        access_keys: ?[]AccessKey = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_keys = "accessKeys",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_bucket_bundles: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBucketBundles",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBucketBundles",
    Request: type = struct {
        include_inactive: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .include_inactive = "includeInactive",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_bucket_bundles) } {
            return .{ .service_metadata = service_metadata, .action = get_bucket_bundles };
        }
    },
    Response: type = struct {
        bundles: ?[]struct {
            bundle_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            price: ?f32 = null,
            storage_per_month_in_gb: ?i64 = null,
            transfer_per_month_in_gb: ?i64 = null,
            is_active: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .bundle_id = "bundleId",
                    .name = "name",
                    .price = "price",
                    .storage_per_month_in_gb = "storagePerMonthInGb",
                    .transfer_per_month_in_gb = "transferPerMonthInGb",
                    .is_active = "isActive",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bundles = "bundles",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_bucket_metric_data: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBucketMetricData",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBucketMetricData",
    Request: type = struct {
        bucket_name: []const u8,
        metric_name: []const u8,
        start_time: i64,
        end_time: i64,
        period: i64,
        statistics: [][]const u8,
        unit: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .metric_name = "metricName",
                .start_time = "startTime",
                .end_time = "endTime",
                .period = "period",
                .statistics = "statistics",
                .unit = "unit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_bucket_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_bucket_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_buckets: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBuckets",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBuckets",
    Request: type = struct {
        bucket_name: ?[]const u8 = null,
        page_token: ?[]const u8 = null,
        include_connected_resources: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .page_token = "pageToken",
                .include_connected_resources = "includeConnectedResources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_buckets) } {
            return .{ .service_metadata = service_metadata, .action = get_buckets };
        }
    },
    Response: type = struct {
        buckets: ?[]Bucket = null,
        next_page_token: ?[]const u8 = null,
        account_level_bpa_sync: ?struct {
            status: ?[]const u8 = null,
            last_synced_at: ?i64 = null,
            message: ?[]const u8 = null,
            bpa_impacts_lightsail: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "status",
                    .last_synced_at = "lastSyncedAt",
                    .message = "message",
                    .bpa_impacts_lightsail = "bpaImpactsLightsail",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .buckets = "buckets",
                .next_page_token = "nextPageToken",
                .account_level_bpa_sync = "accountLevelBpaSync",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_bundles: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetBundles",
        .success_code = 200,
    };

    action_name: []const u8 = "GetBundles",
    Request: type = struct {
        include_inactive: ?bool = null,
        page_token: ?[]const u8 = null,
        app_category: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .include_inactive = "includeInactive",
                .page_token = "pageToken",
                .app_category = "appCategory",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_bundles) } {
            return .{ .service_metadata = service_metadata, .action = get_bundles };
        }
    },
    Response: type = struct {
        bundles: ?[]struct {
            price: ?f32 = null,
            cpu_count: ?i64 = null,
            disk_size_in_gb: ?i64 = null,
            bundle_id: ?[]const u8 = null,
            instance_type: ?[]const u8 = null,
            is_active: ?bool = null,
            name: ?[]const u8 = null,
            power: ?i64 = null,
            ram_size_in_gb: ?f32 = null,
            transfer_per_month_in_gb: ?i64 = null,
            supported_platforms: ?[][]const u8 = null,
            supported_app_categories: ?[][]const u8 = null,
            public_ipv4_address_count: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .price = "price",
                    .cpu_count = "cpuCount",
                    .disk_size_in_gb = "diskSizeInGb",
                    .bundle_id = "bundleId",
                    .instance_type = "instanceType",
                    .is_active = "isActive",
                    .name = "name",
                    .power = "power",
                    .ram_size_in_gb = "ramSizeInGb",
                    .transfer_per_month_in_gb = "transferPerMonthInGb",
                    .supported_platforms = "supportedPlatforms",
                    .supported_app_categories = "supportedAppCategories",
                    .public_ipv4_address_count = "publicIpv4AddressCount",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bundles = "bundles",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_certificates: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetCertificates",
        .success_code = 200,
    };

    action_name: []const u8 = "GetCertificates",
    Request: type = struct {
        certificate_statuses: ?[][]const u8 = null,
        include_certificate_details: ?bool = null,
        certificate_name: ?[]const u8 = null,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificate_statuses = "certificateStatuses",
                .include_certificate_details = "includeCertificateDetails",
                .certificate_name = "certificateName",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_certificates) } {
            return .{ .service_metadata = service_metadata, .action = get_certificates };
        }
    },
    Response: type = struct {
        certificates: ?[]CertificateSummary = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .certificates = "certificates",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_cloud_formation_stack_records: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetCloudFormationStackRecords",
        .success_code = 200,
    };

    action_name: []const u8 = "GetCloudFormationStackRecords",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_cloud_formation_stack_records) } {
            return .{ .service_metadata = service_metadata, .action = get_cloud_formation_stack_records };
        }
    },
    Response: type = struct {
        cloud_formation_stack_records: ?[]struct {
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            created_at: ?i64 = null,
            location: ?ResourceLocation = null,
            resource_type: ?[]const u8 = null,
            state: ?[]const u8 = null,
            source_info: ?[]struct {
                resource_type: ?[]const u8 = null,
                name: ?[]const u8 = null,
                arn: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .resource_type = "resourceType",
                        .name = "name",
                        .arn = "arn",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            destination_info: ?DestinationInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .arn = "arn",
                    .created_at = "createdAt",
                    .location = "location",
                    .resource_type = "resourceType",
                    .state = "state",
                    .source_info = "sourceInfo",
                    .destination_info = "destinationInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .cloud_formation_stack_records = "cloudFormationStackRecords",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_contact_methods: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/GetContactMethods",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContactMethods",
    Request: type = struct {
        protocols: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols = "protocols",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_contact_methods) } {
            return .{ .service_metadata = service_metadata, .action = get_contact_methods };
        }
    },
    Response: type = struct {
        contact_methods: ?[]struct {
            contact_endpoint: ?[]const u8 = null,
            status: ?[]const u8 = null,
            protocol: ?[]const u8 = null,
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            created_at: ?i64 = null,
            location: ?ResourceLocation = null,
            resource_type: ?[]const u8 = null,
            support_code: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .contact_endpoint = "contactEndpoint",
                    .status = "status",
                    .protocol = "protocol",
                    .name = "name",
                    .arn = "arn",
                    .created_at = "createdAt",
                    .location = "location",
                    .resource_type = "resourceType",
                    .support_code = "supportCode",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .contact_methods = "contactMethods",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_api_metadata: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-api-metadata",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerAPIMetadata",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_api_metadata) } {
            return .{ .service_metadata = service_metadata, .action = get_container_api_metadata };
        }
    },
    Response: type = struct {
        metadata: ?[][]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metadata = "metadata",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "metadata", field_name))
                return try serializeMap(self.metadata, self.fieldNameFor("metadata"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        AccessDenied,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_images: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/images",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerImages",
    Request: type = struct {
        service_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_images) } {
            return .{ .service_metadata = service_metadata, .action = get_container_images };
        }
    },
    Response: type = struct {
        container_images: ?[]ContainerImage = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_images = "containerImages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_log: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/containers/{containerName}/log",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerLog",
    Request: type = struct {
        service_name: []const u8,
        container_name: []const u8,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        filter_pattern: ?[]const u8 = null,
        page_token: ?[]const u8 = null,

        pub const http_query = .{
            .start_time = "startTime",
            .end_time = "endTime",
            .filter_pattern = "filterPattern",
            .page_token = "pageToken",
        };

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .container_name = "containerName",
                .start_time = "startTime",
                .end_time = "endTime",
                .filter_pattern = "filterPattern",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_log) } {
            return .{ .service_metadata = service_metadata, .action = get_container_log };
        }
    },
    Response: type = struct {
        log_events: ?[]struct {
            created_at: ?i64 = null,
            message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .created_at = "createdAt",
                    .message = "message",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_events = "logEvents",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_service_deployments: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/deployments",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerServiceDeployments",
    Request: type = struct {
        service_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_service_deployments) } {
            return .{ .service_metadata = service_metadata, .action = get_container_service_deployments };
        }
    },
    Response: type = struct {
        deployments: ?[]ContainerServiceDeployment = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .deployments = "deployments",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_service_metric_data: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/metrics",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerServiceMetricData",
    Request: type = struct {
        service_name: []const u8,
        metric_name: []const u8,
        start_time: i64,
        end_time: i64,
        period: i64,
        statistics: [][]const u8,

        pub const http_query = .{
            .metric_name = "metricName",
            .start_time = "startTime",
            .end_time = "endTime",
            .period = "period",
            .statistics = "statistics",
        };

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .metric_name = "metricName",
                .start_time = "startTime",
                .end_time = "endTime",
                .period = "period",
                .statistics = "statistics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_service_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_container_service_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_service_powers: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-service-powers",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerServicePowers",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_service_powers) } {
            return .{ .service_metadata = service_metadata, .action = get_container_service_powers };
        }
    },
    Response: type = struct {
        powers: ?[]struct {
            power_id: ?[]const u8 = null,
            price: ?f32 = null,
            cpu_count: ?f32 = null,
            ram_size_in_gb: ?f32 = null,
            name: ?[]const u8 = null,
            is_active: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .power_id = "powerId",
                    .price = "price",
                    .cpu_count = "cpuCount",
                    .ram_size_in_gb = "ramSizeInGb",
                    .name = "name",
                    .is_active = "isActive",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .powers = "powers",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_container_services: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/container-services",
        .success_code = 200,
    };

    action_name: []const u8 = "GetContainerServices",
    Request: type = struct {
        service_name: ?[]const u8 = null,

        pub const http_query = .{
            .service_name = "serviceName",
        };

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_container_services) } {
            return .{ .service_metadata = service_metadata, .action = get_container_services };
        }
    },
    Response: type = struct {
        container_services: ?[]ContainerService = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_services = "containerServices",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_cost_estimate: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/budgettracker/getCostEstimate",
        .success_code = 200,
    };

    action_name: []const u8 = "GetCostEstimate",
    Request: type = struct {
        resource_name: []const u8,
        start_time: i64,
        end_time: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .start_time = "startTime",
                .end_time = "endTime",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_cost_estimate) } {
            return .{ .service_metadata = service_metadata, .action = get_cost_estimate };
        }
    },
    Response: type = struct {
        resources_budget_estimate: ?[]struct {
            resource_name: ?[]const u8 = null,
            resource_type: ?[]const u8 = null,
            cost_estimates: ?[]struct {
                usage_type: ?[]const u8 = null,
                results_by_time: ?[]struct {
                    usage_cost: ?f64 = null,
                    pricing_unit: ?[]const u8 = null,
                    unit: ?f64 = null,
                    currency: ?[]const u8 = null,
                    time_period: ?struct {
                        start: ?i64 = null,
                        end: ?i64 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .start = "start",
                                .end = "end",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .usage_cost = "usageCost",
                            .pricing_unit = "pricingUnit",
                            .unit = "unit",
                            .currency = "currency",
                            .time_period = "timePeriod",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .usage_type = "usageType",
                        .results_by_time = "resultsByTime",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            start_time: ?i64 = null,
            end_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource_name = "resourceName",
                    .resource_type = "resourceType",
                    .cost_estimates = "costEstimates",
                    .start_time = "startTime",
                    .end_time = "endTime",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resources_budget_estimate = "resourcesBudgetEstimate",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_disk: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDisk",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDisk",
    Request: type = struct {
        disk_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_name = "diskName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_disk) } {
            return .{ .service_metadata = service_metadata, .action = get_disk };
        }
    },
    Response: type = struct {
        disk: ?Disk = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk = "disk",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_disks: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDisks",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDisks",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_disks) } {
            return .{ .service_metadata = service_metadata, .action = get_disks };
        }
    },
    Response: type = struct {
        disks: ?[]Disk = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disks = "disks",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_disk_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDiskSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDiskSnapshot",
    Request: type = struct {
        disk_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_snapshot_name = "diskSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_disk_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = get_disk_snapshot };
        }
    },
    Response: type = struct {
        disk_snapshot: ?DiskSnapshot = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_snapshot = "diskSnapshot",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_disk_snapshots: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDiskSnapshots",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDiskSnapshots",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_disk_snapshots) } {
            return .{ .service_metadata = service_metadata, .action = get_disk_snapshots };
        }
    },
    Response: type = struct {
        disk_snapshots: ?[]DiskSnapshot = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .disk_snapshots = "diskSnapshots",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_distribution_bundles: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDistributionBundles",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDistributionBundles",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_distribution_bundles) } {
            return .{ .service_metadata = service_metadata, .action = get_distribution_bundles };
        }
    },
    Response: type = struct {
        bundles: ?[]struct {
            bundle_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            price: ?f32 = null,
            transfer_per_month_in_gb: ?i64 = null,
            is_active: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .bundle_id = "bundleId",
                    .name = "name",
                    .price = "price",
                    .transfer_per_month_in_gb = "transferPerMonthInGb",
                    .is_active = "isActive",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bundles = "bundles",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_distribution_latest_cache_reset: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDistributionLatestCacheReset",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDistributionLatestCacheReset",
    Request: type = struct {
        distribution_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_distribution_latest_cache_reset) } {
            return .{ .service_metadata = service_metadata, .action = get_distribution_latest_cache_reset };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,
        create_time: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "status",
                .create_time = "createTime",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_distribution_metric_data: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDistributionMetricData",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDistributionMetricData",
    Request: type = struct {
        distribution_name: []const u8,
        metric_name: []const u8,
        start_time: i64,
        end_time: i64,
        period: i64,
        unit: []const u8,
        statistics: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .metric_name = "metricName",
                .start_time = "startTime",
                .end_time = "endTime",
                .period = "period",
                .unit = "unit",
                .statistics = "statistics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_distribution_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_distribution_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_distributions: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDistributions",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDistributions",
    Request: type = struct {
        distribution_name: ?[]const u8 = null,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_distributions) } {
            return .{ .service_metadata = service_metadata, .action = get_distributions };
        }
    },
    Response: type = struct {
        distributions: ?[]LightsailDistribution = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distributions = "distributions",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_domain: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDomain",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDomain",
    Request: type = struct {
        domain_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_domain) } {
            return .{ .service_metadata = service_metadata, .action = get_domain };
        }
    },
    Response: type = struct {
        domain: ?Domain = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain = "domain",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_domains: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetDomains",
        .success_code = 200,
    };

    action_name: []const u8 = "GetDomains",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_domains) } {
            return .{ .service_metadata = service_metadata, .action = get_domains };
        }
    },
    Response: type = struct {
        domains: ?[]Domain = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domains = "domains",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_export_snapshot_records: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetExportSnapshotRecords",
        .success_code = 200,
    };

    action_name: []const u8 = "GetExportSnapshotRecords",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_export_snapshot_records) } {
            return .{ .service_metadata = service_metadata, .action = get_export_snapshot_records };
        }
    },
    Response: type = struct {
        export_snapshot_records: ?[]struct {
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            created_at: ?i64 = null,
            location: ?ResourceLocation = null,
            resource_type: ?[]const u8 = null,
            state: ?[]const u8 = null,
            source_info: ?struct {
                resource_type: ?[]const u8 = null,
                created_at: ?i64 = null,
                name: ?[]const u8 = null,
                arn: ?[]const u8 = null,
                from_resource_name: ?[]const u8 = null,
                from_resource_arn: ?[]const u8 = null,
                instance_snapshot_info: ?struct {
                    from_bundle_id: ?[]const u8 = null,
                    from_blueprint_id: ?[]const u8 = null,
                    from_disk_info: ?[]struct {
                        name: ?[]const u8 = null,
                        path: ?[]const u8 = null,
                        size_in_gb: ?i64 = null,
                        is_system_disk: ?bool = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .name = "name",
                                .path = "path",
                                .size_in_gb = "sizeInGb",
                                .is_system_disk = "isSystemDisk",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .from_bundle_id = "fromBundleId",
                            .from_blueprint_id = "fromBlueprintId",
                            .from_disk_info = "fromDiskInfo",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                disk_snapshot_info: ?struct {
                    size_in_gb: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .size_in_gb = "sizeInGb",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .resource_type = "resourceType",
                        .created_at = "createdAt",
                        .name = "name",
                        .arn = "arn",
                        .from_resource_name = "fromResourceName",
                        .from_resource_arn = "fromResourceArn",
                        .instance_snapshot_info = "instanceSnapshotInfo",
                        .disk_snapshot_info = "diskSnapshotInfo",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            destination_info: ?DestinationInfo = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .arn = "arn",
                    .created_at = "createdAt",
                    .location = "location",
                    .resource_type = "resourceType",
                    .state = "state",
                    .source_info = "sourceInfo",
                    .destination_info = "destinationInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_snapshot_records = "exportSnapshotRecords",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstance",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstance",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance) } {
            return .{ .service_metadata = service_metadata, .action = get_instance };
        }
    },
    Response: type = struct {
        instance: ?Instance = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance = "instance",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_access_details: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstanceAccessDetails",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstanceAccessDetails",
    Request: type = struct {
        instance_name: []const u8,
        protocol: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .protocol = "protocol",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_access_details) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_access_details };
        }
    },
    Response: type = struct {
        access_details: ?struct {
            cert_key: ?[]const u8 = null,
            expires_at: ?i64 = null,
            ip_address: ?[]const u8 = null,
            ipv6_addresses: ?[][]const u8 = null,
            password: ?[]const u8 = null,
            password_data: ?struct {
                ciphertext: ?[]const u8 = null,
                key_pair_name: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .ciphertext = "ciphertext",
                        .key_pair_name = "keyPairName",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            private_key: ?[]const u8 = null,
            protocol: ?[]const u8 = null,
            instance_name: ?[]const u8 = null,
            username: ?[]const u8 = null,
            host_keys: ?[]struct {
                algorithm: ?[]const u8 = null,
                public_key: ?[]const u8 = null,
                witnessed_at: ?i64 = null,
                fingerprint_sha1: ?[]const u8 = null,
                fingerprint_sha256: ?[]const u8 = null,
                not_valid_before: ?i64 = null,
                not_valid_after: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .algorithm = "algorithm",
                        .public_key = "publicKey",
                        .witnessed_at = "witnessedAt",
                        .fingerprint_sha1 = "fingerprintSHA1",
                        .fingerprint_sha256 = "fingerprintSHA256",
                        .not_valid_before = "notValidBefore",
                        .not_valid_after = "notValidAfter",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .cert_key = "certKey",
                    .expires_at = "expiresAt",
                    .ip_address = "ipAddress",
                    .ipv6_addresses = "ipv6Addresses",
                    .password = "password",
                    .password_data = "passwordData",
                    .private_key = "privateKey",
                    .protocol = "protocol",
                    .instance_name = "instanceName",
                    .username = "username",
                    .host_keys = "hostKeys",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .access_details = "accessDetails",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_metric_data: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstanceMetricData",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstanceMetricData",
    Request: type = struct {
        instance_name: []const u8,
        metric_name: []const u8,
        period: i64,
        start_time: i64,
        end_time: i64,
        unit: []const u8,
        statistics: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .metric_name = "metricName",
                .period = "period",
                .start_time = "startTime",
                .end_time = "endTime",
                .unit = "unit",
                .statistics = "statistics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_port_states: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstancePortStates",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstancePortStates",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_port_states) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_port_states };
        }
    },
    Response: type = struct {
        port_states: ?[]struct {
            from_port: ?i64 = null,
            to_port: ?i64 = null,
            protocol: ?[]const u8 = null,
            state: ?[]const u8 = null,
            cidrs: ?[][]const u8 = null,
            ipv6_cidrs: ?[][]const u8 = null,
            cidr_list_aliases: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .from_port = "fromPort",
                    .to_port = "toPort",
                    .protocol = "protocol",
                    .state = "state",
                    .cidrs = "cidrs",
                    .ipv6_cidrs = "ipv6Cidrs",
                    .cidr_list_aliases = "cidrListAliases",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .port_states = "portStates",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instances: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstances",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstances",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instances) } {
            return .{ .service_metadata = service_metadata, .action = get_instances };
        }
    },
    Response: type = struct {
        instances: ?[]Instance = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instances = "instances",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstanceSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstanceSnapshot",
    Request: type = struct {
        instance_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_snapshot_name = "instanceSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_snapshot };
        }
    },
    Response: type = struct {
        instance_snapshot: ?InstanceSnapshot = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_snapshot = "instanceSnapshot",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_snapshots: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstanceSnapshots",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstanceSnapshots",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_snapshots) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_snapshots };
        }
    },
    Response: type = struct {
        instance_snapshots: ?[]InstanceSnapshot = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_snapshots = "instanceSnapshots",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_instance_state: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetInstanceState",
        .success_code = 200,
    };

    action_name: []const u8 = "GetInstanceState",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_instance_state) } {
            return .{ .service_metadata = service_metadata, .action = get_instance_state };
        }
    },
    Response: type = struct {
        state: ?InstanceState = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .state = "state",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_key_pair: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetKeyPair",
        .success_code = 200,
    };

    action_name: []const u8 = "GetKeyPair",
    Request: type = struct {
        key_pair_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair_name = "keyPairName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_key_pair) } {
            return .{ .service_metadata = service_metadata, .action = get_key_pair };
        }
    },
    Response: type = struct {
        key_pair: ?KeyPair = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair = "keyPair",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_key_pairs: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetKeyPairs",
        .success_code = 200,
    };

    action_name: []const u8 = "GetKeyPairs",
    Request: type = struct {
        page_token: ?[]const u8 = null,
        include_default_key_pair: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
                .include_default_key_pair = "includeDefaultKeyPair",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_key_pairs) } {
            return .{ .service_metadata = service_metadata, .action = get_key_pairs };
        }
    },
    Response: type = struct {
        key_pairs: ?[]KeyPair = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pairs = "keyPairs",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_load_balancer: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetLoadBalancer",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLoadBalancer",
    Request: type = struct {
        load_balancer_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_load_balancer) } {
            return .{ .service_metadata = service_metadata, .action = get_load_balancer };
        }
    },
    Response: type = struct {
        load_balancer: ?LoadBalancer = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer = "loadBalancer",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_load_balancer_metric_data: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetLoadBalancerMetricData",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLoadBalancerMetricData",
    Request: type = struct {
        load_balancer_name: []const u8,
        metric_name: []const u8,
        period: i64,
        start_time: i64,
        end_time: i64,
        unit: []const u8,
        statistics: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .metric_name = "metricName",
                .period = "period",
                .start_time = "startTime",
                .end_time = "endTime",
                .unit = "unit",
                .statistics = "statistics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_load_balancer_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_load_balancer_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_load_balancers: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetLoadBalancers",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLoadBalancers",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_load_balancers) } {
            return .{ .service_metadata = service_metadata, .action = get_load_balancers };
        }
    },
    Response: type = struct {
        load_balancers: ?[]LoadBalancer = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancers = "loadBalancers",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_load_balancer_tls_certificates: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetLoadBalancerTlsCertificates",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLoadBalancerTlsCertificates",
    Request: type = struct {
        load_balancer_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_load_balancer_tls_certificates) } {
            return .{ .service_metadata = service_metadata, .action = get_load_balancer_tls_certificates };
        }
    },
    Response: type = struct {
        tls_certificates: ?[]struct {
            name: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            support_code: ?[]const u8 = null,
            created_at: ?i64 = null,
            location: ?ResourceLocation = null,
            resource_type: ?[]const u8 = null,
            tags: ?[]Tag = null,
            load_balancer_name: ?[]const u8 = null,
            is_attached: ?bool = null,
            status: ?[]const u8 = null,
            domain_name: ?[]const u8 = null,
            domain_validation_records: ?[]struct {
                name: ?[]const u8 = null,
                type: ?[]const u8 = null,
                value: ?[]const u8 = null,
                validation_status: ?[]const u8 = null,
                domain_name: ?[]const u8 = null,
                dns_record_creation_state: ?struct {
                    code: ?[]const u8 = null,
                    message: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .code = "code",
                            .message = "message",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .name = "name",
                        .type = "type",
                        .value = "value",
                        .validation_status = "validationStatus",
                        .domain_name = "domainName",
                        .dns_record_creation_state = "dnsRecordCreationState",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            failure_reason: ?[]const u8 = null,
            issued_at: ?i64 = null,
            issuer: ?[]const u8 = null,
            key_algorithm: ?[]const u8 = null,
            not_after: ?i64 = null,
            not_before: ?i64 = null,
            renewal_summary: ?struct {
                renewal_status: ?[]const u8 = null,
                domain_validation_options: ?[]struct {
                    domain_name: ?[]const u8 = null,
                    validation_status: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .domain_name = "domainName",
                            .validation_status = "validationStatus",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .renewal_status = "renewalStatus",
                        .domain_validation_options = "domainValidationOptions",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            revocation_reason: ?[]const u8 = null,
            revoked_at: ?i64 = null,
            serial: ?[]const u8 = null,
            signature_algorithm: ?[]const u8 = null,
            subject: ?[]const u8 = null,
            subject_alternative_names: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .arn = "arn",
                    .support_code = "supportCode",
                    .created_at = "createdAt",
                    .location = "location",
                    .resource_type = "resourceType",
                    .tags = "tags",
                    .load_balancer_name = "loadBalancerName",
                    .is_attached = "isAttached",
                    .status = "status",
                    .domain_name = "domainName",
                    .domain_validation_records = "domainValidationRecords",
                    .failure_reason = "failureReason",
                    .issued_at = "issuedAt",
                    .issuer = "issuer",
                    .key_algorithm = "keyAlgorithm",
                    .not_after = "notAfter",
                    .not_before = "notBefore",
                    .renewal_summary = "renewalSummary",
                    .revocation_reason = "revocationReason",
                    .revoked_at = "revokedAt",
                    .serial = "serial",
                    .signature_algorithm = "signatureAlgorithm",
                    .subject = "subject",
                    .subject_alternative_names = "subjectAlternativeNames",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tls_certificates = "tlsCertificates",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_load_balancer_tls_policies: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetLoadBalancerTlsPolicies",
        .success_code = 200,
    };

    action_name: []const u8 = "GetLoadBalancerTlsPolicies",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_load_balancer_tls_policies) } {
            return .{ .service_metadata = service_metadata, .action = get_load_balancer_tls_policies };
        }
    },
    Response: type = struct {
        tls_policies: ?[]struct {
            name: ?[]const u8 = null,
            is_default: ?bool = null,
            description: ?[]const u8 = null,
            protocols: ?[][]const u8 = null,
            ciphers: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .is_default = "isDefault",
                    .description = "description",
                    .protocols = "protocols",
                    .ciphers = "ciphers",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tls_policies = "tlsPolicies",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_operation: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetOperation",
        .success_code = 200,
    };

    action_name: []const u8 = "GetOperation",
    Request: type = struct {
        operation_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation_id = "operationId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_operation) } {
            return .{ .service_metadata = service_metadata, .action = get_operation };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_operations: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetOperations",
        .success_code = 200,
    };

    action_name: []const u8 = "GetOperations",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_operations) } {
            return .{ .service_metadata = service_metadata, .action = get_operations };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_operations_for_resource: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetOperationsForResource",
        .success_code = 200,
    };

    action_name: []const u8 = "GetOperationsForResource",
    Request: type = struct {
        resource_name: []const u8,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_operations_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = get_operations_for_resource };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,
        next_page_count: ?[]const u8 = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
                .next_page_count = "nextPageCount",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_regions: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRegions",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRegions",
    Request: type = struct {
        include_availability_zones: ?bool = null,
        include_relational_database_availability_zones: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .include_availability_zones = "includeAvailabilityZones",
                .include_relational_database_availability_zones = "includeRelationalDatabaseAvailabilityZones",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_regions) } {
            return .{ .service_metadata = service_metadata, .action = get_regions };
        }
    },
    Response: type = struct {
        regions: ?[]struct {
            continent_code: ?[]const u8 = null,
            description: ?[]const u8 = null,
            display_name: ?[]const u8 = null,
            name: ?[]const u8 = null,
            availability_zones: ?[]AvailabilityZone = null,
            relational_database_availability_zones: ?[]AvailabilityZone = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .continent_code = "continentCode",
                    .description = "description",
                    .display_name = "displayName",
                    .name = "name",
                    .availability_zones = "availabilityZones",
                    .relational_database_availability_zones = "relationalDatabaseAvailabilityZones",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .regions = "regions",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database };
        }
    },
    Response: type = struct {
        relational_database: ?RelationalDatabase = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database = "relationalDatabase",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_blueprints: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseBlueprints",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseBlueprints",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_blueprints) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_blueprints };
        }
    },
    Response: type = struct {
        blueprints: ?[]struct {
            blueprint_id: ?[]const u8 = null,
            engine: ?[]const u8 = null,
            engine_version: ?[]const u8 = null,
            engine_description: ?[]const u8 = null,
            engine_version_description: ?[]const u8 = null,
            is_engine_default: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .blueprint_id = "blueprintId",
                    .engine = "engine",
                    .engine_version = "engineVersion",
                    .engine_description = "engineDescription",
                    .engine_version_description = "engineVersionDescription",
                    .is_engine_default = "isEngineDefault",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .blueprints = "blueprints",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_bundles: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseBundles",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseBundles",
    Request: type = struct {
        page_token: ?[]const u8 = null,
        include_inactive: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
                .include_inactive = "includeInactive",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_bundles) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_bundles };
        }
    },
    Response: type = struct {
        bundles: ?[]struct {
            bundle_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            price: ?f32 = null,
            ram_size_in_gb: ?f32 = null,
            disk_size_in_gb: ?i64 = null,
            transfer_per_month_in_gb: ?i64 = null,
            cpu_count: ?i64 = null,
            is_encrypted: ?bool = null,
            is_active: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .bundle_id = "bundleId",
                    .name = "name",
                    .price = "price",
                    .ram_size_in_gb = "ramSizeInGb",
                    .disk_size_in_gb = "diskSizeInGb",
                    .transfer_per_month_in_gb = "transferPerMonthInGb",
                    .cpu_count = "cpuCount",
                    .is_encrypted = "isEncrypted",
                    .is_active = "isActive",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bundles = "bundles",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_events: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseEvents",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseEvents",
    Request: type = struct {
        relational_database_name: []const u8,
        duration_in_minutes: ?i64 = null,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .duration_in_minutes = "durationInMinutes",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_events) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_events };
        }
    },
    Response: type = struct {
        relational_database_events: ?[]struct {
            resource: ?[]const u8 = null,
            created_at: ?i64 = null,
            message: ?[]const u8 = null,
            event_categories: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .resource = "resource",
                    .created_at = "createdAt",
                    .message = "message",
                    .event_categories = "eventCategories",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_events = "relationalDatabaseEvents",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_log_events: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseLogEvents",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseLogEvents",
    Request: type = struct {
        relational_database_name: []const u8,
        log_stream_name: []const u8,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        start_from_head: ?bool = null,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .log_stream_name = "logStreamName",
                .start_time = "startTime",
                .end_time = "endTime",
                .start_from_head = "startFromHead",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_log_events) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_log_events };
        }
    },
    Response: type = struct {
        resource_log_events: ?[]struct {
            created_at: ?i64 = null,
            message: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .created_at = "createdAt",
                    .message = "message",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_backward_token: ?[]const u8 = null,
        next_forward_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_log_events = "resourceLogEvents",
                .next_backward_token = "nextBackwardToken",
                .next_forward_token = "nextForwardToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_log_streams: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseLogStreams",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseLogStreams",
    Request: type = struct {
        relational_database_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_log_streams) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_log_streams };
        }
    },
    Response: type = struct {
        log_streams: ?[][]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_streams = "logStreams",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_master_user_password: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseMasterUserPassword",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseMasterUserPassword",
    Request: type = struct {
        relational_database_name: []const u8,
        password_version: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .password_version = "passwordVersion",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_master_user_password) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_master_user_password };
        }
    },
    Response: type = struct {
        master_user_password: ?[]const u8 = null,
        created_at: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .master_user_password = "masterUserPassword",
                .created_at = "createdAt",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_metric_data: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseMetricData",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseMetricData",
    Request: type = struct {
        relational_database_name: []const u8,
        metric_name: []const u8,
        period: i64,
        start_time: i64,
        end_time: i64,
        unit: []const u8,
        statistics: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .metric_name = "metricName",
                .period = "period",
                .start_time = "startTime",
                .end_time = "endTime",
                .unit = "unit",
                .statistics = "statistics",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_metric_data) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_metric_data };
        }
    },
    Response: type = struct {
        metric_name: ?[]const u8 = null,
        metric_data: ?[]MetricDatapoint = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_name = "metricName",
                .metric_data = "metricData",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_parameters: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseParameters",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseParameters",
    Request: type = struct {
        relational_database_name: []const u8,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_parameters) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_parameters };
        }
    },
    Response: type = struct {
        parameters: ?[]RelationalDatabaseParameter = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .parameters = "parameters",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_databases: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabases",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabases",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_databases) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_databases };
        }
    },
    Response: type = struct {
        relational_databases: ?[]RelationalDatabase = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_databases = "relationalDatabases",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_snapshot: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseSnapshot",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseSnapshot",
    Request: type = struct {
        relational_database_snapshot_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_snapshot_name = "relationalDatabaseSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_snapshot) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_snapshot };
        }
    },
    Response: type = struct {
        relational_database_snapshot: ?RelationalDatabaseSnapshot = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_snapshot = "relationalDatabaseSnapshot",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_relational_database_snapshots: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetRelationalDatabaseSnapshots",
        .success_code = 200,
    };

    action_name: []const u8 = "GetRelationalDatabaseSnapshots",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_relational_database_snapshots) } {
            return .{ .service_metadata = service_metadata, .action = get_relational_database_snapshots };
        }
    },
    Response: type = struct {
        relational_database_snapshots: ?[]RelationalDatabaseSnapshot = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_snapshots = "relationalDatabaseSnapshots",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_setup_history: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/get-setup-history",
        .success_code = 200,
    };

    action_name: []const u8 = "GetSetupHistory",
    Request: type = struct {
        resource_name: []const u8,
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_setup_history) } {
            return .{ .service_metadata = service_metadata, .action = get_setup_history };
        }
    },
    Response: type = struct {
        setup_history: ?[]struct {
            operation_id: ?[]const u8 = null,
            request: ?struct {
                instance_name: ?[]const u8 = null,
                domain_names: ?[][]const u8 = null,
                certificate_provider: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .instance_name = "instanceName",
                        .domain_names = "domainNames",
                        .certificate_provider = "certificateProvider",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            resource: ?struct {
                name: ?[]const u8 = null,
                arn: ?[]const u8 = null,
                created_at: ?i64 = null,
                location: ?ResourceLocation = null,
                resource_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .name = "name",
                        .arn = "arn",
                        .created_at = "createdAt",
                        .location = "location",
                        .resource_type = "resourceType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            execution_details: ?[]struct {
                command: ?[]const u8 = null,
                date_time: ?i64 = null,
                name: ?[]const u8 = null,
                status: ?[]const u8 = null,
                standard_error: ?[]const u8 = null,
                standard_output: ?[]const u8 = null,
                version: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .command = "command",
                        .date_time = "dateTime",
                        .name = "name",
                        .status = "status",
                        .standard_error = "standardError",
                        .standard_output = "standardOutput",
                        .version = "version",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            status: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .operation_id = "operationId",
                    .request = "request",
                    .resource = "resource",
                    .execution_details = "executionDetails",
                    .status = "status",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .setup_history = "setupHistory",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_static_ip: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetStaticIp",
        .success_code = 200,
    };

    action_name: []const u8 = "GetStaticIp",
    Request: type = struct {
        static_ip_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip_name = "staticIpName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_static_ip) } {
            return .{ .service_metadata = service_metadata, .action = get_static_ip };
        }
    },
    Response: type = struct {
        static_ip: ?StaticIp = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip = "staticIp",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const get_static_ips: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/GetStaticIps",
        .success_code = 200,
    };

    action_name: []const u8 = "GetStaticIps",
    Request: type = struct {
        page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .page_token = "pageToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_static_ips) } {
            return .{ .service_metadata = service_metadata, .action = get_static_ips };
        }
    },
    Response: type = struct {
        static_ips: ?[]StaticIp = null,
        next_page_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ips = "staticIps",
                .next_page_token = "nextPageToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const import_key_pair: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/ImportKeyPair",
        .success_code = 200,
    };

    action_name: []const u8 = "ImportKeyPair",
    Request: type = struct {
        key_pair_name: []const u8,
        public_key_base64: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_pair_name = "keyPairName",
                .public_key_base64 = "publicKeyBase64",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(import_key_pair) } {
            return .{ .service_metadata = service_metadata, .action = import_key_pair };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const is_vpc_peered: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/IsVpcPeered",
        .success_code = 200,
    };

    action_name: []const u8 = "IsVpcPeered",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(is_vpc_peered) } {
            return .{ .service_metadata = service_metadata, .action = is_vpc_peered };
        }
    },
    Response: type = struct {
        is_peered: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .is_peered = "isPeered",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const open_instance_public_ports: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/OpenInstancePublicPorts",
        .success_code = 200,
    };

    action_name: []const u8 = "OpenInstancePublicPorts",
    Request: type = struct {
        port_info: PortInfo,
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .port_info = "portInfo",
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(open_instance_public_ports) } {
            return .{ .service_metadata = service_metadata, .action = open_instance_public_ports };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const peer_vpc: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/PeerVpc",
        .success_code = 200,
    };

    action_name: []const u8 = "PeerVpc",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(peer_vpc) } {
            return .{ .service_metadata = service_metadata, .action = peer_vpc };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const put_alarm: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/PutAlarm",
        .success_code = 200,
    };

    action_name: []const u8 = "PutAlarm",
    Request: type = struct {
        alarm_name: []const u8,
        metric_name: []const u8,
        monitored_resource_name: []const u8,
        comparison_operator: []const u8,
        threshold: f64,
        evaluation_periods: i64,
        datapoints_to_alarm: ?i64 = null,
        treat_missing_data: ?[]const u8 = null,
        contact_protocols: ?[][]const u8 = null,
        notification_triggers: ?[][]const u8 = null,
        notification_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "alarmName",
                .metric_name = "metricName",
                .monitored_resource_name = "monitoredResourceName",
                .comparison_operator = "comparisonOperator",
                .threshold = "threshold",
                .evaluation_periods = "evaluationPeriods",
                .datapoints_to_alarm = "datapointsToAlarm",
                .treat_missing_data = "treatMissingData",
                .contact_protocols = "contactProtocols",
                .notification_triggers = "notificationTriggers",
                .notification_enabled = "notificationEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_alarm) } {
            return .{ .service_metadata = service_metadata, .action = put_alarm };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const put_instance_public_ports: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/PutInstancePublicPorts",
        .success_code = 200,
    };

    action_name: []const u8 = "PutInstancePublicPorts",
    Request: type = struct {
        port_infos: []PortInfo,
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .port_infos = "portInfos",
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_instance_public_ports) } {
            return .{ .service_metadata = service_metadata, .action = put_instance_public_ports };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const reboot_instance: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/RebootInstance",
        .success_code = 200,
    };

    action_name: []const u8 = "RebootInstance",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reboot_instance) } {
            return .{ .service_metadata = service_metadata, .action = reboot_instance };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const reboot_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/RebootRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "RebootRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reboot_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = reboot_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const register_container_image: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}/images",
        .success_code = 200,
    };

    action_name: []const u8 = "RegisterContainerImage",
    Request: type = struct {
        service_name: []const u8,
        label: []const u8,
        digest: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .label = "label",
                .digest = "digest",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(register_container_image) } {
            return .{ .service_metadata = service_metadata, .action = register_container_image };
        }
    },
    Response: type = struct {
        container_image: ?ContainerImage = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_image = "containerImage",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const release_static_ip: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/ReleaseStaticIp",
        .success_code = 200,
    };

    action_name: []const u8 = "ReleaseStaticIp",
    Request: type = struct {
        static_ip_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .static_ip_name = "staticIpName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(release_static_ip) } {
            return .{ .service_metadata = service_metadata, .action = release_static_ip };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const reset_distribution_cache: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/ResetDistributionCache",
        .success_code = 200,
    };

    action_name: []const u8 = "ResetDistributionCache",
    Request: type = struct {
        distribution_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(reset_distribution_cache) } {
            return .{ .service_metadata = service_metadata, .action = reset_distribution_cache };
        }
    },
    Response: type = struct {
        status: ?[]const u8 = null,
        create_time: ?i64 = null,
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .status = "status",
                .create_time = "createTime",
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const send_contact_method_verification: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/SendContactMethodVerification",
        .success_code = 200,
    };

    action_name: []const u8 = "SendContactMethodVerification",
    Request: type = struct {
        protocol: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocol = "protocol",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(send_contact_method_verification) } {
            return .{ .service_metadata = service_metadata, .action = send_contact_method_verification };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const set_ip_address_type: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/SetIpAddressType",
        .success_code = 200,
    };

    action_name: []const u8 = "SetIpAddressType",
    Request: type = struct {
        resource_type: []const u8,
        resource_name: []const u8,
        ip_address_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_type = "resourceType",
                .resource_name = "resourceName",
                .ip_address_type = "ipAddressType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_ip_address_type) } {
            return .{ .service_metadata = service_metadata, .action = set_ip_address_type };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const set_resource_access_for_bucket: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/SetResourceAccessForBucket",
        .success_code = 200,
    };

    action_name: []const u8 = "SetResourceAccessForBucket",
    Request: type = struct {
        resource_name: []const u8,
        bucket_name: []const u8,
        access: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .bucket_name = "bucketName",
                .access = "access",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(set_resource_access_for_bucket) } {
            return .{ .service_metadata = service_metadata, .action = set_resource_access_for_bucket };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const setup_instance_https: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/setup-instance-https",
        .success_code = 200,
    };

    action_name: []const u8 = "SetupInstanceHttps",
    Request: type = struct {
        instance_name: []const u8,
        email_address: []const u8,
        domain_names: [][]const u8,
        certificate_provider: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .email_address = "emailAddress",
                .domain_names = "domainNames",
                .certificate_provider = "certificateProvider",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(setup_instance_https) } {
            return .{ .service_metadata = service_metadata, .action = setup_instance_https };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const start_gui_session: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/start-gui-session",
        .success_code = 200,
    };

    action_name: []const u8 = "StartGUISession",
    Request: type = struct {
        resource_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_gui_session) } {
            return .{ .service_metadata = service_metadata, .action = start_gui_session };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const start_instance: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/StartInstance",
        .success_code = 200,
    };

    action_name: []const u8 = "StartInstance",
    Request: type = struct {
        instance_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_instance) } {
            return .{ .service_metadata = service_metadata, .action = start_instance };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const start_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/StartRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "StartRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = start_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const stop_gui_session: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/stop-gui-session",
        .success_code = 200,
    };

    action_name: []const u8 = "StopGUISession",
    Request: type = struct {
        resource_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_gui_session) } {
            return .{ .service_metadata = service_metadata, .action = stop_gui_session };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const stop_instance: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/StopInstance",
        .success_code = 200,
    };

    action_name: []const u8 = "StopInstance",
    Request: type = struct {
        instance_name: []const u8,
        force: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .force = "force",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_instance) } {
            return .{ .service_metadata = service_metadata, .action = stop_instance };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const stop_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/StopRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "StopRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,
        relational_database_snapshot_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .relational_database_snapshot_name = "relationalDatabaseSnapshotName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = stop_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const tag_resource: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/TagResource",
        .success_code = 200,
    };

    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_name: []const u8,
        resource_arn: ?[]const u8 = null,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .resource_arn = "resourceArn",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const test_alarm: struct {
    pub const http_config = .{
        .method = "GET",
        .uri = "/ls/api/2016-11-28/TestAlarm",
        .success_code = 200,
    };

    action_name: []const u8 = "TestAlarm",
    Request: type = struct {
        alarm_name: []const u8,
        state: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .alarm_name = "alarmName",
                .state = "state",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(test_alarm) } {
            return .{ .service_metadata = service_metadata, .action = test_alarm };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const unpeer_vpc: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UnpeerVpc",
        .success_code = 200,
    };

    action_name: []const u8 = "UnpeerVpc",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(unpeer_vpc) } {
            return .{ .service_metadata = service_metadata, .action = unpeer_vpc };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const untag_resource: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UntagResource",
        .success_code = 200,
    };

    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_name: []const u8,
        resource_arn: ?[]const u8 = null,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_name = "resourceName",
                .resource_arn = "resourceArn",
                .tag_keys = "tagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_bucket: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateBucket",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateBucket",
    Request: type = struct {
        bucket_name: []const u8,
        access_rules: ?AccessRules = null,
        versioning: ?[]const u8 = null,
        readonly_access_accounts: ?[][]const u8 = null,
        access_log_config: ?BucketAccessLogConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .access_rules = "accessRules",
                .versioning = "versioning",
                .readonly_access_accounts = "readonlyAccessAccounts",
                .access_log_config = "accessLogConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_bucket) } {
            return .{ .service_metadata = service_metadata, .action = update_bucket };
        }
    },
    Response: type = struct {
        bucket: ?Bucket = null,
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket = "bucket",
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_bucket_bundle: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateBucketBundle",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateBucketBundle",
    Request: type = struct {
        bucket_name: []const u8,
        bundle_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .bucket_name = "bucketName",
                .bundle_id = "bundleId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_bucket_bundle) } {
            return .{ .service_metadata = service_metadata, .action = update_bucket_bundle };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_container_service: struct {
    pub const http_config = .{
        .method = "PATCH",
        .uri = "/ls/api/2016-11-28/container-services/{serviceName}",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateContainerService",
    Request: type = struct {
        service_name: []const u8,
        power: ?[]const u8 = null,
        scale: ?i64 = null,
        is_disabled: ?bool = null,
        public_domain_names: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[][]const u8 = null,
        } = null,
        private_registry_access: ?PrivateRegistryAccessRequest = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .service_name = "serviceName",
                .power = "power",
                .scale = "scale",
                .is_disabled = "isDisabled",
                .public_domain_names = "publicDomainNames",
                .private_registry_access = "privateRegistryAccess",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "public_domain_names", field_name))
                return try serializeMap(self.public_domain_names, self.fieldNameFor("public_domain_names"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_container_service) } {
            return .{ .service_metadata = service_metadata, .action = update_container_service };
        }
    },
    Response: type = struct {
        container_service: ?ContainerService = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .container_service = "containerService",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_distribution: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateDistribution",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateDistribution",
    Request: type = struct {
        distribution_name: []const u8,
        origin: ?InputOrigin = null,
        default_cache_behavior: ?CacheBehavior = null,
        cache_behavior_settings: ?CacheSettings = null,
        cache_behaviors: ?[]CacheBehaviorPerPath = null,
        is_enabled: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .origin = "origin",
                .default_cache_behavior = "defaultCacheBehavior",
                .cache_behavior_settings = "cacheBehaviorSettings",
                .cache_behaviors = "cacheBehaviors",
                .is_enabled = "isEnabled",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_distribution) } {
            return .{ .service_metadata = service_metadata, .action = update_distribution };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_distribution_bundle: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateDistributionBundle",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateDistributionBundle",
    Request: type = struct {
        distribution_name: ?[]const u8 = null,
        bundle_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .distribution_name = "distributionName",
                .bundle_id = "bundleId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_distribution_bundle) } {
            return .{ .service_metadata = service_metadata, .action = update_distribution_bundle };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_domain_entry: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateDomainEntry",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateDomainEntry",
    Request: type = struct {
        domain_name: []const u8,
        domain_entry: DomainEntry,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .domain_name = "domainName",
                .domain_entry = "domainEntry",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_domain_entry) } {
            return .{ .service_metadata = service_metadata, .action = update_domain_entry };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_instance_metadata_options: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateInstanceMetadataOptions",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateInstanceMetadataOptions",
    Request: type = struct {
        instance_name: []const u8,
        http_tokens: ?[]const u8 = null,
        http_endpoint: ?[]const u8 = null,
        http_put_response_hop_limit: ?i64 = null,
        http_protocol_ipv6: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .instance_name = "instanceName",
                .http_tokens = "httpTokens",
                .http_endpoint = "httpEndpoint",
                .http_put_response_hop_limit = "httpPutResponseHopLimit",
                .http_protocol_ipv6 = "httpProtocolIpv6",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_instance_metadata_options) } {
            return .{ .service_metadata = service_metadata, .action = update_instance_metadata_options };
        }
    },
    Response: type = struct {
        operation: ?Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operation = "operation",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_load_balancer_attribute: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateLoadBalancerAttribute",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateLoadBalancerAttribute",
    Request: type = struct {
        load_balancer_name: []const u8,
        attribute_name: []const u8,
        attribute_value: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .load_balancer_name = "loadBalancerName",
                .attribute_name = "attributeName",
                .attribute_value = "attributeValue",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_load_balancer_attribute) } {
            return .{ .service_metadata = service_metadata, .action = update_load_balancer_attribute };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_relational_database: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateRelationalDatabase",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateRelationalDatabase",
    Request: type = struct {
        relational_database_name: []const u8,
        master_user_password: ?[]const u8 = null,
        rotate_master_user_password: ?bool = null,
        preferred_backup_window: ?[]const u8 = null,
        preferred_maintenance_window: ?[]const u8 = null,
        enable_backup_retention: ?bool = null,
        disable_backup_retention: ?bool = null,
        publicly_accessible: ?bool = null,
        apply_immediately: ?bool = null,
        ca_certificate_identifier: ?[]const u8 = null,
        relational_database_blueprint_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .master_user_password = "masterUserPassword",
                .rotate_master_user_password = "rotateMasterUserPassword",
                .preferred_backup_window = "preferredBackupWindow",
                .preferred_maintenance_window = "preferredMaintenanceWindow",
                .enable_backup_retention = "enableBackupRetention",
                .disable_backup_retention = "disableBackupRetention",
                .publicly_accessible = "publiclyAccessible",
                .apply_immediately = "applyImmediately",
                .ca_certificate_identifier = "caCertificateIdentifier",
                .relational_database_blueprint_id = "relationalDatabaseBlueprintId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_relational_database) } {
            return .{ .service_metadata = service_metadata, .action = update_relational_database };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};
pub const update_relational_database_parameters: struct {
    pub const http_config = .{
        .method = "POST",
        .uri = "/ls/api/2016-11-28/UpdateRelationalDatabaseParameters",
        .success_code = 200,
    };

    action_name: []const u8 = "UpdateRelationalDatabaseParameters",
    Request: type = struct {
        relational_database_name: []const u8,
        parameters: []RelationalDatabaseParameter,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .relational_database_name = "relationalDatabaseName",
                .parameters = "parameters",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_relational_database_parameters) } {
            return .{ .service_metadata = service_metadata, .action = update_relational_database_parameters };
        }
    },
    Response: type = struct {
        operations: ?[]Operation = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .operations = "operations",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        AccessDenied,
        AccountSetupInProgress,
        InvalidInput,
        NotFound,
        OperationFailure,
        Service,
        Unauthenticated,
    },
} = .{};

pub const Operation = struct {
    id: ?[]const u8 = null,
    resource_name: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    is_terminal: ?bool = null,
    operation_details: ?[]const u8 = null,
    operation_type: ?[]const u8 = null,
    status: ?[]const u8 = null,
    status_changed_at: ?i64 = null,
    error_code: ?[]const u8 = null,
    error_details: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .resource_name = "resourceName",
            .resource_type = "resourceType",
            .created_at = "createdAt",
            .location = "location",
            .is_terminal = "isTerminal",
            .operation_details = "operationDetails",
            .operation_type = "operationType",
            .status = "status",
            .status_changed_at = "statusChangedAt",
            .error_code = "errorCode",
            .error_details = "errorDetails",
        };
        return @field(mappings, field_name);
    }
};

pub const ResourceLocation = struct {
    availability_zone: ?[]const u8 = null,
    region_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .availability_zone = "availabilityZone",
            .region_name = "regionName",
        };
        return @field(mappings, field_name);
    }
};

pub const RelationalDatabaseParameter = struct {
    allowed_values: ?[]const u8 = null,
    apply_method: ?[]const u8 = null,
    apply_type: ?[]const u8 = null,
    data_type: ?[]const u8 = null,
    description: ?[]const u8 = null,
    is_modifiable: ?bool = null,
    parameter_name: ?[]const u8 = null,
    parameter_value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .allowed_values = "allowedValues",
            .apply_method = "applyMethod",
            .apply_type = "applyType",
            .data_type = "dataType",
            .description = "description",
            .is_modifiable = "isModifiable",
            .parameter_name = "parameterName",
            .parameter_value = "parameterValue",
        };
        return @field(mappings, field_name);
    }
};

pub const DomainEntry = struct {
    id: ?[]const u8 = null,
    name: ?[]const u8 = null,
    target: ?[]const u8 = null,
    is_alias: ?bool = null,
    type: ?[]const u8 = null,
    options: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .name = "name",
            .target = "target",
            .is_alias = "isAlias",
            .type = "type",
            .options = "options",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "options", field_name))
            return try serializeMap(self.options, self.fieldNameFor("options"), options, out_stream);
        return false;
    }
};

pub const CacheBehaviorPerPath = struct {
    path: ?[]const u8 = null,
    behavior: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .path = "path",
            .behavior = "behavior",
        };
        return @field(mappings, field_name);
    }
};

pub const CacheSettings = struct {
    default_ttl: ?i64 = null,
    minimum_ttl: ?i64 = null,
    maximum_ttl: ?i64 = null,
    allowed_http_methods: ?[]const u8 = null,
    cached_http_methods: ?[]const u8 = null,
    forwarded_cookies: ?CookieObject = null,
    forwarded_headers: ?HeaderObject = null,
    forwarded_query_strings: ?QueryStringObject = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .default_ttl = "defaultTTL",
            .minimum_ttl = "minimumTTL",
            .maximum_ttl = "maximumTTL",
            .allowed_http_methods = "allowedHTTPMethods",
            .cached_http_methods = "cachedHTTPMethods",
            .forwarded_cookies = "forwardedCookies",
            .forwarded_headers = "forwardedHeaders",
            .forwarded_query_strings = "forwardedQueryStrings",
        };
        return @field(mappings, field_name);
    }
};

pub const QueryStringObject = struct {
    option: ?bool = null,
    query_strings_allow_list: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .option = "option",
            .query_strings_allow_list = "queryStringsAllowList",
        };
        return @field(mappings, field_name);
    }
};

pub const HeaderObject = struct {
    option: ?[]const u8 = null,
    headers_allow_list: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .option = "option",
            .headers_allow_list = "headersAllowList",
        };
        return @field(mappings, field_name);
    }
};

pub const CookieObject = struct {
    option: ?[]const u8 = null,
    cookies_allow_list: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .option = "option",
            .cookies_allow_list = "cookiesAllowList",
        };
        return @field(mappings, field_name);
    }
};

pub const CacheBehavior = struct {
    behavior: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .behavior = "behavior",
        };
        return @field(mappings, field_name);
    }
};

pub const InputOrigin = struct {
    name: ?[]const u8 = null,
    region_name: ?[]const u8 = null,
    protocol_policy: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .region_name = "regionName",
            .protocol_policy = "protocolPolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerService = struct {
    container_service_name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    power: ?[]const u8 = null,
    power_id: ?[]const u8 = null,
    state: ?[]const u8 = null,
    state_detail: ?ContainerServiceStateDetail = null,
    scale: ?i64 = null,
    current_deployment: ?ContainerServiceDeployment = null,
    next_deployment: ?ContainerServiceDeployment = null,
    is_disabled: ?bool = null,
    principal_arn: ?[]const u8 = null,
    private_domain_name: ?[]const u8 = null,
    public_domain_names: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,
    url: ?[]const u8 = null,
    private_registry_access: ?PrivateRegistryAccess = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .container_service_name = "containerServiceName",
            .arn = "arn",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .power = "power",
            .power_id = "powerId",
            .state = "state",
            .state_detail = "stateDetail",
            .scale = "scale",
            .current_deployment = "currentDeployment",
            .next_deployment = "nextDeployment",
            .is_disabled = "isDisabled",
            .principal_arn = "principalArn",
            .private_domain_name = "privateDomainName",
            .public_domain_names = "publicDomainNames",
            .url = "url",
            .private_registry_access = "privateRegistryAccess",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "public_domain_names", field_name))
            return try serializeMap(self.public_domain_names, self.fieldNameFor("public_domain_names"), options, out_stream);
        return false;
    }
};

pub const PrivateRegistryAccess = struct {
    ecr_image_puller_role: ?ContainerServiceECRImagePullerRole = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ecr_image_puller_role = "ecrImagePullerRole",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerServiceECRImagePullerRole = struct {
    is_active: ?bool = null,
    principal_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .is_active = "isActive",
            .principal_arn = "principalArn",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerServiceDeployment = struct {
    version: ?i64 = null,
    state: ?[]const u8 = null,
    containers: ?[]struct {
        key: ?[]const u8 = null,
        value: ?Container = null,
    } = null,
    public_endpoint: ?ContainerServiceEndpoint = null,
    created_at: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .version = "version",
            .state = "state",
            .containers = "containers",
            .public_endpoint = "publicEndpoint",
            .created_at = "createdAt",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "containers", field_name))
            return try serializeMap(self.containers, self.fieldNameFor("containers"), options, out_stream);
        return false;
    }
};

pub const ContainerServiceEndpoint = struct {
    container_name: ?[]const u8 = null,
    container_port: ?i64 = null,
    health_check: ?ContainerServiceHealthCheckConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .container_name = "containerName",
            .container_port = "containerPort",
            .health_check = "healthCheck",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerServiceHealthCheckConfig = struct {
    healthy_threshold: ?i64 = null,
    unhealthy_threshold: ?i64 = null,
    timeout_seconds: ?i64 = null,
    interval_seconds: ?i64 = null,
    path: ?[]const u8 = null,
    success_codes: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .healthy_threshold = "healthyThreshold",
            .unhealthy_threshold = "unhealthyThreshold",
            .timeout_seconds = "timeoutSeconds",
            .interval_seconds = "intervalSeconds",
            .path = "path",
            .success_codes = "successCodes",
        };
        return @field(mappings, field_name);
    }
};

pub const Container = struct {
    image: ?[]const u8 = null,
    command: ?[][]const u8 = null,
    environment: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    ports: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .image = "image",
            .command = "command",
            .environment = "environment",
            .ports = "ports",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "environment", field_name))
            return try serializeMap(self.environment, self.fieldNameFor("environment"), options, out_stream);
        if (std.mem.eql(u8, "ports", field_name))
            return try serializeMap(self.ports, self.fieldNameFor("ports"), options, out_stream);
        return false;
    }
};

pub const ContainerServiceStateDetail = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const Tag = struct {
    key: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "key",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const PrivateRegistryAccessRequest = struct {
    ecr_image_puller_role: ?ContainerServiceECRImagePullerRoleRequest = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .ecr_image_puller_role = "ecrImagePullerRole",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerServiceECRImagePullerRoleRequest = struct {
    is_active: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .is_active = "isActive",
        };
        return @field(mappings, field_name);
    }
};

pub const Bucket = struct {
    resource_type: ?[]const u8 = null,
    access_rules: ?AccessRules = null,
    arn: ?[]const u8 = null,
    bundle_id: ?[]const u8 = null,
    created_at: ?i64 = null,
    url: ?[]const u8 = null,
    location: ?ResourceLocation = null,
    name: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    tags: ?[]Tag = null,
    object_versioning: ?[]const u8 = null,
    able_to_update_bundle: ?bool = null,
    readonly_access_accounts: ?[][]const u8 = null,
    resources_receiving_access: ?[]ResourceReceivingAccess = null,
    state: ?BucketState = null,
    access_log_config: ?BucketAccessLogConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .resource_type = "resourceType",
            .access_rules = "accessRules",
            .arn = "arn",
            .bundle_id = "bundleId",
            .created_at = "createdAt",
            .url = "url",
            .location = "location",
            .name = "name",
            .support_code = "supportCode",
            .tags = "tags",
            .object_versioning = "objectVersioning",
            .able_to_update_bundle = "ableToUpdateBundle",
            .readonly_access_accounts = "readonlyAccessAccounts",
            .resources_receiving_access = "resourcesReceivingAccess",
            .state = "state",
            .access_log_config = "accessLogConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const BucketAccessLogConfig = struct {
    enabled: bool,
    destination: ?[]const u8 = null,
    prefix: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .enabled = "enabled",
            .destination = "destination",
            .prefix = "prefix",
        };
        return @field(mappings, field_name);
    }
};

pub const BucketState = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const ResourceReceivingAccess = struct {
    name: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .resource_type = "resourceType",
        };
        return @field(mappings, field_name);
    }
};

pub const AccessRules = struct {
    get_object: ?[]const u8 = null,
    allow_public_overrides: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .get_object = "getObject",
            .allow_public_overrides = "allowPublicOverrides",
        };
        return @field(mappings, field_name);
    }
};

pub const ContainerImage = struct {
    image: ?[]const u8 = null,
    digest: ?[]const u8 = null,
    created_at: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .image = "image",
            .digest = "digest",
            .created_at = "createdAt",
        };
        return @field(mappings, field_name);
    }
};

pub const PortInfo = struct {
    from_port: ?i64 = null,
    to_port: ?i64 = null,
    protocol: ?[]const u8 = null,
    cidrs: ?[][]const u8 = null,
    ipv6_cidrs: ?[][]const u8 = null,
    cidr_list_aliases: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .from_port = "fromPort",
            .to_port = "toPort",
            .protocol = "protocol",
            .cidrs = "cidrs",
            .ipv6_cidrs = "ipv6Cidrs",
            .cidr_list_aliases = "cidrListAliases",
        };
        return @field(mappings, field_name);
    }
};

pub const StaticIp = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    ip_address: ?[]const u8 = null,
    attached_to: ?[]const u8 = null,
    is_attached: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .ip_address = "ipAddress",
            .attached_to = "attachedTo",
            .is_attached = "isAttached",
        };
        return @field(mappings, field_name);
    }
};

pub const RelationalDatabaseSnapshot = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    engine: ?[]const u8 = null,
    engine_version: ?[]const u8 = null,
    size_in_gb: ?i64 = null,
    state: ?[]const u8 = null,
    from_relational_database_name: ?[]const u8 = null,
    from_relational_database_arn: ?[]const u8 = null,
    from_relational_database_bundle_id: ?[]const u8 = null,
    from_relational_database_blueprint_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .engine = "engine",
            .engine_version = "engineVersion",
            .size_in_gb = "sizeInGb",
            .state = "state",
            .from_relational_database_name = "fromRelationalDatabaseName",
            .from_relational_database_arn = "fromRelationalDatabaseArn",
            .from_relational_database_bundle_id = "fromRelationalDatabaseBundleId",
            .from_relational_database_blueprint_id = "fromRelationalDatabaseBlueprintId",
        };
        return @field(mappings, field_name);
    }
};

pub const RelationalDatabase = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    relational_database_blueprint_id: ?[]const u8 = null,
    relational_database_bundle_id: ?[]const u8 = null,
    master_database_name: ?[]const u8 = null,
    hardware: ?RelationalDatabaseHardware = null,
    state: ?[]const u8 = null,
    secondary_availability_zone: ?[]const u8 = null,
    backup_retention_enabled: ?bool = null,
    pending_modified_values: ?PendingModifiedRelationalDatabaseValues = null,
    engine: ?[]const u8 = null,
    engine_version: ?[]const u8 = null,
    latest_restorable_time: ?i64 = null,
    master_username: ?[]const u8 = null,
    parameter_apply_status: ?[]const u8 = null,
    preferred_backup_window: ?[]const u8 = null,
    preferred_maintenance_window: ?[]const u8 = null,
    publicly_accessible: ?bool = null,
    master_endpoint: ?RelationalDatabaseEndpoint = null,
    pending_maintenance_actions: ?[]PendingMaintenanceAction = null,
    ca_certificate_identifier: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .relational_database_blueprint_id = "relationalDatabaseBlueprintId",
            .relational_database_bundle_id = "relationalDatabaseBundleId",
            .master_database_name = "masterDatabaseName",
            .hardware = "hardware",
            .state = "state",
            .secondary_availability_zone = "secondaryAvailabilityZone",
            .backup_retention_enabled = "backupRetentionEnabled",
            .pending_modified_values = "pendingModifiedValues",
            .engine = "engine",
            .engine_version = "engineVersion",
            .latest_restorable_time = "latestRestorableTime",
            .master_username = "masterUsername",
            .parameter_apply_status = "parameterApplyStatus",
            .preferred_backup_window = "preferredBackupWindow",
            .preferred_maintenance_window = "preferredMaintenanceWindow",
            .publicly_accessible = "publiclyAccessible",
            .master_endpoint = "masterEndpoint",
            .pending_maintenance_actions = "pendingMaintenanceActions",
            .ca_certificate_identifier = "caCertificateIdentifier",
        };
        return @field(mappings, field_name);
    }
};

pub const PendingMaintenanceAction = struct {
    action: ?[]const u8 = null,
    description: ?[]const u8 = null,
    current_apply_date: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .action = "action",
            .description = "description",
            .current_apply_date = "currentApplyDate",
        };
        return @field(mappings, field_name);
    }
};

pub const RelationalDatabaseEndpoint = struct {
    port: ?i64 = null,
    address: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .port = "port",
            .address = "address",
        };
        return @field(mappings, field_name);
    }
};

pub const PendingModifiedRelationalDatabaseValues = struct {
    master_user_password: ?[]const u8 = null,
    engine_version: ?[]const u8 = null,
    backup_retention_enabled: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .master_user_password = "masterUserPassword",
            .engine_version = "engineVersion",
            .backup_retention_enabled = "backupRetentionEnabled",
        };
        return @field(mappings, field_name);
    }
};

pub const RelationalDatabaseHardware = struct {
    cpu_count: ?i64 = null,
    disk_size_in_gb: ?i64 = null,
    ram_size_in_gb: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .cpu_count = "cpuCount",
            .disk_size_in_gb = "diskSizeInGb",
            .ram_size_in_gb = "ramSizeInGb",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricDatapoint = struct {
    average: ?f64 = null,
    maximum: ?f64 = null,
    minimum: ?f64 = null,
    sample_count: ?f64 = null,
    sum: ?f64 = null,
    timestamp: ?i64 = null,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .average = "average",
            .maximum = "maximum",
            .minimum = "minimum",
            .sample_count = "sampleCount",
            .sum = "sum",
            .timestamp = "timestamp",
            .unit = "unit",
        };
        return @field(mappings, field_name);
    }
};

pub const AvailabilityZone = struct {
    zone_name: ?[]const u8 = null,
    state: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .zone_name = "zoneName",
            .state = "state",
        };
        return @field(mappings, field_name);
    }
};

pub const LoadBalancer = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    dns_name: ?[]const u8 = null,
    state: ?[]const u8 = null,
    protocol: ?[]const u8 = null,
    public_ports: ?[]i64 = null,
    health_check_path: ?[]const u8 = null,
    instance_port: ?i64 = null,
    instance_health_summary: ?[]InstanceHealthSummary = null,
    tls_certificate_summaries: ?[]LoadBalancerTlsCertificateSummary = null,
    configuration_options: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    ip_address_type: ?[]const u8 = null,
    https_redirection_enabled: ?bool = null,
    tls_policy_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .dns_name = "dnsName",
            .state = "state",
            .protocol = "protocol",
            .public_ports = "publicPorts",
            .health_check_path = "healthCheckPath",
            .instance_port = "instancePort",
            .instance_health_summary = "instanceHealthSummary",
            .tls_certificate_summaries = "tlsCertificateSummaries",
            .configuration_options = "configurationOptions",
            .ip_address_type = "ipAddressType",
            .https_redirection_enabled = "httpsRedirectionEnabled",
            .tls_policy_name = "tlsPolicyName",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "configuration_options", field_name))
            return try serializeMap(self.configuration_options, self.fieldNameFor("configuration_options"), options, out_stream);
        return false;
    }
};

pub const LoadBalancerTlsCertificateSummary = struct {
    name: ?[]const u8 = null,
    is_attached: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .is_attached = "isAttached",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceHealthSummary = struct {
    instance_name: ?[]const u8 = null,
    instance_health: ?[]const u8 = null,
    instance_health_reason: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .instance_name = "instanceName",
            .instance_health = "instanceHealth",
            .instance_health_reason = "instanceHealthReason",
        };
        return @field(mappings, field_name);
    }
};

pub const KeyPair = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    fingerprint: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .fingerprint = "fingerprint",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceState = struct {
    code: ?i64 = null,
    name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .name = "name",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceSnapshot = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    state: ?[]const u8 = null,
    progress: ?[]const u8 = null,
    from_attached_disks: ?[]Disk = null,
    from_instance_name: ?[]const u8 = null,
    from_instance_arn: ?[]const u8 = null,
    from_blueprint_id: ?[]const u8 = null,
    from_bundle_id: ?[]const u8 = null,
    is_from_auto_snapshot: ?bool = null,
    size_in_gb: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .state = "state",
            .progress = "progress",
            .from_attached_disks = "fromAttachedDisks",
            .from_instance_name = "fromInstanceName",
            .from_instance_arn = "fromInstanceArn",
            .from_blueprint_id = "fromBlueprintId",
            .from_bundle_id = "fromBundleId",
            .is_from_auto_snapshot = "isFromAutoSnapshot",
            .size_in_gb = "sizeInGb",
        };
        return @field(mappings, field_name);
    }
};

pub const Disk = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    add_ons: ?[]AddOn = null,
    size_in_gb: ?i64 = null,
    is_system_disk: ?bool = null,
    iops: ?i64 = null,
    path: ?[]const u8 = null,
    state: ?[]const u8 = null,
    attached_to: ?[]const u8 = null,
    is_attached: ?bool = null,
    attachment_state: ?[]const u8 = null,
    gb_in_use: ?i64 = null,
    auto_mount_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .add_ons = "addOns",
            .size_in_gb = "sizeInGb",
            .is_system_disk = "isSystemDisk",
            .iops = "iops",
            .path = "path",
            .state = "state",
            .attached_to = "attachedTo",
            .is_attached = "isAttached",
            .attachment_state = "attachmentState",
            .gb_in_use = "gbInUse",
            .auto_mount_status = "autoMountStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const AddOn = struct {
    name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    snapshot_time_of_day: ?[]const u8 = null,
    next_snapshot_time_of_day: ?[]const u8 = null,
    threshold: ?[]const u8 = null,
    duration: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .status = "status",
            .snapshot_time_of_day = "snapshotTimeOfDay",
            .next_snapshot_time_of_day = "nextSnapshotTimeOfDay",
            .threshold = "threshold",
            .duration = "duration",
        };
        return @field(mappings, field_name);
    }
};

pub const Instance = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    blueprint_id: ?[]const u8 = null,
    blueprint_name: ?[]const u8 = null,
    bundle_id: ?[]const u8 = null,
    add_ons: ?[]AddOn = null,
    is_static_ip: ?bool = null,
    private_ip_address: ?[]const u8 = null,
    public_ip_address: ?[]const u8 = null,
    ipv6_addresses: ?[][]const u8 = null,
    ip_address_type: ?[]const u8 = null,
    hardware: ?InstanceHardware = null,
    networking: ?InstanceNetworking = null,
    state: ?InstanceState = null,
    username: ?[]const u8 = null,
    ssh_key_name: ?[]const u8 = null,
    metadata_options: ?InstanceMetadataOptions = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .blueprint_id = "blueprintId",
            .blueprint_name = "blueprintName",
            .bundle_id = "bundleId",
            .add_ons = "addOns",
            .is_static_ip = "isStaticIp",
            .private_ip_address = "privateIpAddress",
            .public_ip_address = "publicIpAddress",
            .ipv6_addresses = "ipv6Addresses",
            .ip_address_type = "ipAddressType",
            .hardware = "hardware",
            .networking = "networking",
            .state = "state",
            .username = "username",
            .ssh_key_name = "sshKeyName",
            .metadata_options = "metadataOptions",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceMetadataOptions = struct {
    state: ?[]const u8 = null,
    http_tokens: ?[]const u8 = null,
    http_endpoint: ?[]const u8 = null,
    http_put_response_hop_limit: ?i64 = null,
    http_protocol_ipv6: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .state = "state",
            .http_tokens = "httpTokens",
            .http_endpoint = "httpEndpoint",
            .http_put_response_hop_limit = "httpPutResponseHopLimit",
            .http_protocol_ipv6 = "httpProtocolIpv6",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceNetworking = struct {
    monthly_transfer: ?MonthlyTransfer = null,
    ports: ?[]InstancePortInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .monthly_transfer = "monthlyTransfer",
            .ports = "ports",
        };
        return @field(mappings, field_name);
    }
};

pub const InstancePortInfo = struct {
    from_port: ?i64 = null,
    to_port: ?i64 = null,
    protocol: ?[]const u8 = null,
    access_from: ?[]const u8 = null,
    access_type: ?[]const u8 = null,
    common_name: ?[]const u8 = null,
    access_direction: ?[]const u8 = null,
    cidrs: ?[][]const u8 = null,
    ipv6_cidrs: ?[][]const u8 = null,
    cidr_list_aliases: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .from_port = "fromPort",
            .to_port = "toPort",
            .protocol = "protocol",
            .access_from = "accessFrom",
            .access_type = "accessType",
            .common_name = "commonName",
            .access_direction = "accessDirection",
            .cidrs = "cidrs",
            .ipv6_cidrs = "ipv6Cidrs",
            .cidr_list_aliases = "cidrListAliases",
        };
        return @field(mappings, field_name);
    }
};

pub const MonthlyTransfer = struct {
    gb_per_month_allocated: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .gb_per_month_allocated = "gbPerMonthAllocated",
        };
        return @field(mappings, field_name);
    }
};

pub const InstanceHardware = struct {
    cpu_count: ?i64 = null,
    disks: ?[]Disk = null,
    ram_size_in_gb: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .cpu_count = "cpuCount",
            .disks = "disks",
            .ram_size_in_gb = "ramSizeInGb",
        };
        return @field(mappings, field_name);
    }
};

pub const DestinationInfo = struct {
    id: ?[]const u8 = null,
    service: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .id = "id",
            .service = "service",
        };
        return @field(mappings, field_name);
    }
};

pub const Domain = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    domain_entries: ?[]DomainEntry = null,
    registered_domain_delegation_info: ?RegisteredDomainDelegationInfo = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .domain_entries = "domainEntries",
            .registered_domain_delegation_info = "registeredDomainDelegationInfo",
        };
        return @field(mappings, field_name);
    }
};

pub const RegisteredDomainDelegationInfo = struct {
    name_servers_update_state: ?NameServersUpdateState = null,
    r53_hosted_zone_deletion_state: ?R53HostedZoneDeletionState = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name_servers_update_state = "nameServersUpdateState",
            .r53_hosted_zone_deletion_state = "r53HostedZoneDeletionState",
        };
        return @field(mappings, field_name);
    }
};

pub const R53HostedZoneDeletionState = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const NameServersUpdateState = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const LightsailDistribution = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    alternative_domain_names: ?[][]const u8 = null,
    status: ?[]const u8 = null,
    is_enabled: ?bool = null,
    domain_name: ?[]const u8 = null,
    bundle_id: ?[]const u8 = null,
    certificate_name: ?[]const u8 = null,
    origin: ?Origin = null,
    origin_public_dns: ?[]const u8 = null,
    default_cache_behavior: ?CacheBehavior = null,
    cache_behavior_settings: ?CacheSettings = null,
    cache_behaviors: ?[]CacheBehaviorPerPath = null,
    able_to_update_bundle: ?bool = null,
    ip_address_type: ?[]const u8 = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .alternative_domain_names = "alternativeDomainNames",
            .status = "status",
            .is_enabled = "isEnabled",
            .domain_name = "domainName",
            .bundle_id = "bundleId",
            .certificate_name = "certificateName",
            .origin = "origin",
            .origin_public_dns = "originPublicDNS",
            .default_cache_behavior = "defaultCacheBehavior",
            .cache_behavior_settings = "cacheBehaviorSettings",
            .cache_behaviors = "cacheBehaviors",
            .able_to_update_bundle = "ableToUpdateBundle",
            .ip_address_type = "ipAddressType",
            .tags = "tags",
        };
        return @field(mappings, field_name);
    }
};

pub const Origin = struct {
    name: ?[]const u8 = null,
    resource_type: ?[]const u8 = null,
    region_name: ?[]const u8 = null,
    protocol_policy: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .resource_type = "resourceType",
            .region_name = "regionName",
            .protocol_policy = "protocolPolicy",
        };
        return @field(mappings, field_name);
    }
};

pub const DiskSnapshot = struct {
    name: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    support_code: ?[]const u8 = null,
    created_at: ?i64 = null,
    location: ?ResourceLocation = null,
    resource_type: ?[]const u8 = null,
    tags: ?[]Tag = null,
    size_in_gb: ?i64 = null,
    state: ?[]const u8 = null,
    progress: ?[]const u8 = null,
    from_disk_name: ?[]const u8 = null,
    from_disk_arn: ?[]const u8 = null,
    from_instance_name: ?[]const u8 = null,
    from_instance_arn: ?[]const u8 = null,
    is_from_auto_snapshot: ?bool = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .arn = "arn",
            .support_code = "supportCode",
            .created_at = "createdAt",
            .location = "location",
            .resource_type = "resourceType",
            .tags = "tags",
            .size_in_gb = "sizeInGb",
            .state = "state",
            .progress = "progress",
            .from_disk_name = "fromDiskName",
            .from_disk_arn = "fromDiskArn",
            .from_instance_name = "fromInstanceName",
            .from_instance_arn = "fromInstanceArn",
            .is_from_auto_snapshot = "isFromAutoSnapshot",
        };
        return @field(mappings, field_name);
    }
};

pub const CertificateSummary = struct {
    certificate_arn: ?[]const u8 = null,
    certificate_name: ?[]const u8 = null,
    domain_name: ?[]const u8 = null,
    certificate_detail: ?Certificate = null,
    tags: ?[]Tag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .certificate_arn = "certificateArn",
            .certificate_name = "certificateName",
            .domain_name = "domainName",
            .certificate_detail = "certificateDetail",
            .tags = "tags",
        };
        return @field(mappings, field_name);
    }
};

pub const Certificate = struct {
    arn: ?[]const u8 = null,
    name: ?[]const u8 = null,
    domain_name: ?[]const u8 = null,
    status: ?[]const u8 = null,
    serial_number: ?[]const u8 = null,
    subject_alternative_names: ?[][]const u8 = null,
    domain_validation_records: ?[]DomainValidationRecord = null,
    request_failure_reason: ?[]const u8 = null,
    in_use_resource_count: ?i64 = null,
    key_algorithm: ?[]const u8 = null,
    created_at: ?i64 = null,
    issued_at: ?i64 = null,
    issuer_ca: ?[]const u8 = null,
    not_before: ?i64 = null,
    not_after: ?i64 = null,
    eligible_to_renew: ?[]const u8 = null,
    renewal_summary: ?RenewalSummary = null,
    revoked_at: ?i64 = null,
    revocation_reason: ?[]const u8 = null,
    tags: ?[]Tag = null,
    support_code: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .arn = "arn",
            .name = "name",
            .domain_name = "domainName",
            .status = "status",
            .serial_number = "serialNumber",
            .subject_alternative_names = "subjectAlternativeNames",
            .domain_validation_records = "domainValidationRecords",
            .request_failure_reason = "requestFailureReason",
            .in_use_resource_count = "inUseResourceCount",
            .key_algorithm = "keyAlgorithm",
            .created_at = "createdAt",
            .issued_at = "issuedAt",
            .issuer_ca = "issuerCA",
            .not_before = "notBefore",
            .not_after = "notAfter",
            .eligible_to_renew = "eligibleToRenew",
            .renewal_summary = "renewalSummary",
            .revoked_at = "revokedAt",
            .revocation_reason = "revocationReason",
            .tags = "tags",
            .support_code = "supportCode",
        };
        return @field(mappings, field_name);
    }
};

pub const RenewalSummary = struct {
    domain_validation_records: ?[]DomainValidationRecord = null,
    renewal_status: ?[]const u8 = null,
    renewal_status_reason: ?[]const u8 = null,
    updated_at: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .domain_validation_records = "domainValidationRecords",
            .renewal_status = "renewalStatus",
            .renewal_status_reason = "renewalStatusReason",
            .updated_at = "updatedAt",
        };
        return @field(mappings, field_name);
    }
};

pub const DomainValidationRecord = struct {
    domain_name: ?[]const u8 = null,
    resource_record: ?ResourceRecord = null,
    dns_record_creation_state: ?DnsRecordCreationState = null,
    validation_status: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .domain_name = "domainName",
            .resource_record = "resourceRecord",
            .dns_record_creation_state = "dnsRecordCreationState",
            .validation_status = "validationStatus",
        };
        return @field(mappings, field_name);
    }
};

pub const DnsRecordCreationState = struct {
    code: ?[]const u8 = null,
    message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .code = "code",
            .message = "message",
        };
        return @field(mappings, field_name);
    }
};

pub const ResourceRecord = struct {
    name: ?[]const u8 = null,
    type: ?[]const u8 = null,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .name = "name",
            .type = "type",
            .value = "value",
        };
        return @field(mappings, field_name);
    }
};

pub const AccessKey = struct {
    access_key_id: ?[]const u8 = null,
    secret_access_key: ?[]const u8 = null,
    status: ?[]const u8 = null,
    created_at: ?i64 = null,
    last_used: ?AccessKeyLastUsed = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .access_key_id = "accessKeyId",
            .secret_access_key = "secretAccessKey",
            .status = "status",
            .created_at = "createdAt",
            .last_used = "lastUsed",
        };
        return @field(mappings, field_name);
    }
};

pub const AccessKeyLastUsed = struct {
    last_used_date: ?i64 = null,
    region: ?[]const u8 = null,
    service_name: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .last_used_date = "lastUsedDate",
            .region = "region",
            .service_name = "serviceName",
        };
        return @field(mappings, field_name);
    }
};

pub const AddOnRequest = struct {
    add_on_type: []const u8,
    auto_snapshot_add_on_request: ?AutoSnapshotAddOnRequest = null,
    stop_instance_on_idle_request: ?StopInstanceOnIdleRequest = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .add_on_type = "addOnType",
            .auto_snapshot_add_on_request = "autoSnapshotAddOnRequest",
            .stop_instance_on_idle_request = "stopInstanceOnIdleRequest",
        };
        return @field(mappings, field_name);
    }
};

pub const StopInstanceOnIdleRequest = struct {
    threshold: ?[]const u8 = null,
    duration: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .threshold = "threshold",
            .duration = "duration",
        };
        return @field(mappings, field_name);
    }
};

pub const AutoSnapshotAddOnRequest = struct {
    snapshot_time_of_day: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .snapshot_time_of_day = "snapshotTimeOfDay",
        };
        return @field(mappings, field_name);
    }
};

pub const EndpointRequest = struct {
    container_name: []const u8,
    container_port: i64,
    health_check: ?ContainerServiceHealthCheckConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .container_name = "containerName",
            .container_port = "containerPort",
            .health_check = "healthCheck",
        };
        return @field(mappings, field_name);
    }
};
